/* A Bison parser, made by GNU Bison 2.7.1.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yylval          base_yylval
#define yychar          base_yychar
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs
#define yylloc          base_yylloc

/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 1 "gram.y"


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 1996-2012, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *	  SQL92-specific syntax is separated from plain SQL/Postgres syntax
 *	  to help isolate the non-extensible portions of the parser.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET SQL_inheritance TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.  The handling of SQL_inheritance is
 *	  a good example.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */
#include "postgres.h"

#include <ctype.h>
#include <limits.h>

#include "catalog/index.h"
#include "catalog/namespace.h"
#include "catalog/pg_trigger.h"
#include "commands/defrem.h"
#include "nodes/makefuncs.h"
#include "nodes/nodeFuncs.h"
#include "parser/gramparse.h"
#include "parser/parser.h"
#include "storage/lmgr.h"
#include "utils/date.h"
#include "utils/datetime.h"
#include "utils/numeric.h"
#include "utils/xml.h"


/* Location tracking support --- simpler than bison's default */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if (N) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (Rhs)[0]; \
	} while (0)

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	GrantObjectType objtype;
	List	   *objs;
} PrivTarget;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
static Node *makeStringConst(char *str, int location);
static Node *makeStringConstCast(char *str, int location, TypeName *typename);
static Node *makeIntConst(int val, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Value *v, int location);
static Node *makeBoolAConst(bool state, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								Node *limitOffset, Node *limitCount,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Value *v);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner);


/* Line 371 of yacc.c  */
#line 224 "gram.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "gram.h".  */
#ifndef YY_BASE_YY_GRAM_H_INCLUDED
# define YY_BASE_YY_GRAM_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int base_yydebug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     IDENT = 258,
     FCONST = 259,
     SCONST = 260,
     BCONST = 261,
     XCONST = 262,
     Op = 263,
     ICONST = 264,
     PARAM = 265,
     TYPECAST = 266,
     DOT_DOT = 267,
     COLON_EQUALS = 268,
     ABORT_P = 269,
     ABSOLUTE_P = 270,
     ACCESS = 271,
     ACTION = 272,
     ADD_P = 273,
     ADMIN = 274,
     AFTER = 275,
     AGGREGATE = 276,
     ALL = 277,
     ALSO = 278,
     ALTER = 279,
     ALWAYS = 280,
     ANALYSE = 281,
     ANALYZE = 282,
     AND = 283,
     ANY = 284,
     APPLICATION = 285,
     ARRAY = 286,
     AS = 287,
     ASC = 288,
     ASSERTION = 289,
     ASSIGNMENT = 290,
     ASYMMETRIC = 291,
     AT = 292,
     ATTRIBUTE = 293,
     AUTHORIZATION = 294,
     BACKWARD = 295,
     BEFORE = 296,
     BEGIN_P = 297,
     BETWEEN = 298,
     BIGINT = 299,
     BINARY = 300,
     BIT = 301,
     BOOLEAN_P = 302,
     BOTH = 303,
     BY = 304,
     CACHE = 305,
     CALLED = 306,
     CASCADE = 307,
     CASCADED = 308,
     CASE = 309,
     CAST = 310,
     CATALOG_P = 311,
     CHAIN = 312,
     CHAR_P = 313,
     CHARACTER = 314,
     CHARACTERISTICS = 315,
     CHECK = 316,
     CHECKPOINT = 317,
     CLASS = 318,
     CLOSE = 319,
     CLUSTER = 320,
     COALESCE = 321,
     COLLATE = 322,
     COLLATION = 323,
     COLUMN = 324,
     COMMENT = 325,
     COMMENTS = 326,
     COMMIT = 327,
     COMMITTED = 328,
     CONCURRENTLY = 329,
     CONFIGURATION = 330,
     CONNECTION = 331,
     CONSTRAINT = 332,
     CONSTRAINTS = 333,
     CONTENT_P = 334,
     CONTINUE_P = 335,
     CONVERSION_P = 336,
     COPY = 337,
     COST = 338,
     CREATE = 339,
     CROSS = 340,
     CSV = 341,
     CURRENT_P = 342,
     CURRENT_CATALOG = 343,
     CURRENT_DATE = 344,
     CURRENT_ROLE = 345,
     CURRENT_SCHEMA = 346,
     CURRENT_TIME = 347,
     CURRENT_TIMESTAMP = 348,
     CURRENT_USER = 349,
     CURSOR = 350,
     CYCLE = 351,
     DATA_P = 352,
     DATABASE = 353,
     DAY_P = 354,
     DEALLOCATE = 355,
     DEC = 356,
     DECIMAL_P = 357,
     DECLARE = 358,
     DEFAULT = 359,
     DEFAULTS = 360,
     DEFERRABLE = 361,
     DEFERRED = 362,
     DEFINER = 363,
     DELETE_P = 364,
     DELIMITER = 365,
     DELIMITERS = 366,
     DESC = 367,
     DICTIONARY = 368,
     DISABLE_P = 369,
     DISCARD = 370,
     DISTINCT = 371,
     DO = 372,
     DOCUMENT_P = 373,
     DOMAIN_P = 374,
     DOUBLE_P = 375,
     DROP = 376,
     EACH = 377,
     ELSE = 378,
     ENABLE_P = 379,
     ENCODING = 380,
     ENCRYPTED = 381,
     END_P = 382,
     ENUM_P = 383,
     ESCAPE = 384,
     EXCEPT = 385,
     EXCLUDE = 386,
     EXCLUDING = 387,
     EXCLUSIVE = 388,
     EXECUTE = 389,
     EXISTS = 390,
     EXPLAIN = 391,
     EXTENSION = 392,
     EXTERNAL = 393,
     EXTRACT = 394,
     FALSE_P = 395,
     FAMILY = 396,
     FETCH = 397,
     FIRST_P = 398,
     FLOAT_P = 399,
     FOLLOWING = 400,
     FOR = 401,
     FORCE = 402,
     FOREIGN = 403,
     FORWARD = 404,
     FREEZE = 405,
     FROM = 406,
     FULL = 407,
     FUNCTION = 408,
     FUNCTIONS = 409,
     GLOBAL = 410,
     GRANT = 411,
     GRANTED = 412,
     GREATEST = 413,
     GROUP_P = 414,
     HANDLER = 415,
     HAVING = 416,
     HEADER_P = 417,
     HOLD = 418,
     HOUR_P = 419,
     IDENTITY_P = 420,
     IF_P = 421,
     ILIKE = 422,
     IMMEDIATE = 423,
     IMMUTABLE = 424,
     IMPLICIT_P = 425,
     IN_P = 426,
     INCLUDING = 427,
     INCREMENT = 428,
     INDEX = 429,
     INDEXES = 430,
     INHERIT = 431,
     INHERITS = 432,
     INITIALLY = 433,
     INLINE_P = 434,
     INNER_P = 435,
     INOUT = 436,
     INPUT_P = 437,
     INSENSITIVE = 438,
     INSERT = 439,
     INSTEAD = 440,
     INT_P = 441,
     INTEGER = 442,
     INTERSECT = 443,
     INTERVAL = 444,
     INTO = 445,
     INVOKER = 446,
     IS = 447,
     ISNULL = 448,
     ISOLATION = 449,
     JOIN = 450,
     KEY = 451,
     LABEL = 452,
     LANGUAGE = 453,
     LARGE_P = 454,
     LAST_P = 455,
     LC_COLLATE_P = 456,
     LC_CTYPE_P = 457,
     LEADING = 458,
     LEAKPROOF = 459,
     LEAST = 460,
     LEFT = 461,
     LEVEL = 462,
     LIKE = 463,
     LIMIT = 464,
     LISTEN = 465,
     LOAD = 466,
     LOCAL = 467,
     LOCALTIME = 468,
     LOCALTIMESTAMP = 469,
     LOCATION = 470,
     LOCK_P = 471,
     MAPPING = 472,
     MATCH = 473,
     MAXVALUE = 474,
     MINUTE_P = 475,
     MINVALUE = 476,
     MODE = 477,
     MONTH_P = 478,
     MOVE = 479,
     NAME_P = 480,
     NAMES = 481,
     NATIONAL = 482,
     NATURAL = 483,
     NCHAR = 484,
     NEXT = 485,
     NO = 486,
     NONE = 487,
     NOT = 488,
     NOTHING = 489,
     NOTIFY = 490,
     NOTNULL = 491,
     NOWAIT = 492,
     NULL_P = 493,
     NULLIF = 494,
     NULLS_P = 495,
     NUMERIC = 496,
     OBJECT_P = 497,
     OF = 498,
     OFF = 499,
     OFFSET = 500,
     OIDS = 501,
     ON = 502,
     ONLY = 503,
     OPERATOR = 504,
     OPTION = 505,
     OPTIONS = 506,
     OR = 507,
     ORDER = 508,
     OUT_P = 509,
     OUTER_P = 510,
     OVER = 511,
     OVERLAPS = 512,
     OVERLAY = 513,
     OWNED = 514,
     OWNER = 515,
     PARSER = 516,
     PARTIAL = 517,
     PARTITION = 518,
     PASSING = 519,
     PASSWORD = 520,
     PLACING = 521,
     PLANS = 522,
     POSITION = 523,
     PRECEDING = 524,
     PRECISION = 525,
     PRESERVE = 526,
     PREPARE = 527,
     PREPARED = 528,
     PRIMARY = 529,
     PRIOR = 530,
     PRIVILEGES = 531,
     PROCEDURAL = 532,
     PROCEDURE = 533,
     QUOTE = 534,
     RANGE = 535,
     READ = 536,
     REAL = 537,
     REASSIGN = 538,
     RECHECK = 539,
     RECURSIVE = 540,
     REF = 541,
     REFERENCES = 542,
     REINDEX = 543,
     RELATIVE_P = 544,
     RELEASE = 545,
     RENAME = 546,
     REPEATABLE = 547,
     REPLACE = 548,
     REPLICA = 549,
     RESET = 550,
     RESTART = 551,
     RESTRICT = 552,
     RETURNING = 553,
     RETURNS = 554,
     REVOKE = 555,
     RIGHT = 556,
     ROLE = 557,
     ROLLBACK = 558,
     ROW = 559,
     ROWS = 560,
     RULE = 561,
     SAVEPOINT = 562,
     SCHEMA = 563,
     SCROLL = 564,
     SEARCH = 565,
     SECOND_P = 566,
     SECURITY = 567,
     SELECT = 568,
     SEQUENCE = 569,
     SEQUENCES = 570,
     SERIALIZABLE = 571,
     SERVER = 572,
     SESSION = 573,
     SESSION_USER = 574,
     SET = 575,
     SETOF = 576,
     SHARE = 577,
     SHOW = 578,
     SIMILAR = 579,
     SIMPLE = 580,
     SMALLINT = 581,
     SNAPSHOT = 582,
     SOME = 583,
     STABLE = 584,
     STANDALONE_P = 585,
     START = 586,
     STATEMENT = 587,
     STATISTICS = 588,
     STDIN = 589,
     STDOUT = 590,
     STORAGE = 591,
     STRICT_P = 592,
     STRIP_P = 593,
     SUBSTRING = 594,
     SYMMETRIC = 595,
     SYSID = 596,
     SYSTEM_P = 597,
     TABLE = 598,
     TABLES = 599,
     TABLESPACE = 600,
     TEMP = 601,
     TEMPLATE = 602,
     TEMPORARY = 603,
     TEXT_P = 604,
     THEN = 605,
     TIME = 606,
     TIMESTAMP = 607,
     TO = 608,
     TRAILING = 609,
     TRANSACTION = 610,
     TREAT = 611,
     TRIGGER = 612,
     TRIM = 613,
     TRUE_P = 614,
     TRUNCATE = 615,
     TRUSTED = 616,
     TYPE_P = 617,
     TYPES_P = 618,
     UNBOUNDED = 619,
     UNCOMMITTED = 620,
     UNENCRYPTED = 621,
     UNION = 622,
     UNIQUE = 623,
     UNKNOWN = 624,
     UNLISTEN = 625,
     UNLOGGED = 626,
     UNTIL = 627,
     UPDATE = 628,
     USER = 629,
     USING = 630,
     VACUUM = 631,
     VALID = 632,
     VALIDATE = 633,
     VALIDATOR = 634,
     VALUE_P = 635,
     VALUES = 636,
     VARCHAR = 637,
     VARIADIC = 638,
     VARYING = 639,
     VERBOSE = 640,
     VERSION_P = 641,
     VIEW = 642,
     VOLATILE = 643,
     WHEN = 644,
     WHERE = 645,
     WHITESPACE_P = 646,
     WINDOW = 647,
     WITH = 648,
     WITHOUT = 649,
     WORK = 650,
     WRAPPER = 651,
     WRITE = 652,
     XML_P = 653,
     XMLATTRIBUTES = 654,
     XMLCONCAT = 655,
     XMLELEMENT = 656,
     XMLEXISTS = 657,
     XMLFOREST = 658,
     XMLPARSE = 659,
     XMLPI = 660,
     XMLROOT = 661,
     XMLSERIALIZE = 662,
     YEAR_P = 663,
     YES_P = 664,
     ZONE = 665,
     NULLS_FIRST = 666,
     NULLS_LAST = 667,
     WITH_TIME = 668,
     POSTFIXOP = 669,
     UMINUS = 670
   };
#endif


#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 158 "gram.y"

	core_YYSTYPE		core_yystype;
	/* these fields must match core_YYSTYPE: */
	int					ival;
	char				*str;
	const char			*keyword;

	char				chr;
	bool				boolean;
	JoinType			jtype;
	DropBehavior		dbehavior;
	OnCommitAction		oncommit;
	List				*list;
	Node				*node;
	Value				*value;
	ObjectType			objtype;
	TypeName			*typnam;
	FunctionParameter   *fun_param;
	FunctionParameterMode fun_param_mode;
	FuncWithArgs		*funwithargs;
	DefElem				*defelt;
	SortBy				*sortby;
	WindowDef			*windef;
	JoinExpr			*jexpr;
	IndexElem			*ielem;
	Alias				*alias;
	RangeVar			*range;
	IntoClause			*into;
	WithClause			*with;
	A_Indices			*aind;
	ResTarget			*target;
	struct PrivTarget	*privtarget;
	AccessPriv			*accesspriv;
	InsertStmt			*istmt;
	VariableSetStmt		*vsetstmt;


/* Line 387 of yacc.c  */
#line 720 "gram.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int base_yyparse (void *YYPARSE_PARAM);
#else
int base_yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int base_yyparse (core_yyscan_t yyscanner);
#else
int base_yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_BASE_YY_GRAM_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 760 "gram.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef __attribute__
/* This feature is available in gcc versions 2.5 and later.  */
# if (! defined __GNUC__ || __GNUC__ < 2 \
      || (__GNUC__ == 2 && __GNUC_MINOR__ < 5))
#  define __attribute__(Spec) /* empty */
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif


/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  697
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   75155

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  433
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  546
/* YYNRULES -- Number of rules.  */
#define YYNRULES  2263
/* YYNRULES -- Number of states.  */
#define YYNSTATES  4302

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   670

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   422,     2,     2,
     427,   428,   420,   418,   431,   419,   429,   421,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   432,   430,
     415,   414,   416,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   425,     2,   426,   423,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   417,
     424
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     9,    11,    13,    15,    17,    19,
      21,    23,    25,    27,    29,    31,    33,    35,    37,    39,
      41,    43,    45,    47,    49,    51,    53,    55,    57,    59,
      61,    63,    65,    67,    69,    71,    73,    75,    77,    79,
      81,    83,    85,    87,    89,    91,    93,    95,    97,    99,
     101,   103,   105,   107,   109,   111,   113,   115,   117,   119,
     121,   123,   125,   127,   129,   131,   133,   135,   137,   139,
     141,   143,   145,   147,   149,   151,   153,   155,   157,   159,
     161,   163,   165,   167,   169,   171,   173,   175,   177,   179,
     181,   183,   185,   187,   189,   191,   193,   195,   197,   199,
     201,   203,   205,   207,   209,   211,   213,   215,   217,   219,
     221,   223,   225,   227,   229,   231,   232,   238,   240,   241,
     244,   245,   248,   249,   252,   255,   259,   263,   265,   269,
     273,   276,   278,   280,   283,   286,   289,   293,   297,   303,
     309,   310,   314,   320,   326,   331,   335,   341,   345,   351,
     357,   364,   366,   368,   372,   378,   385,   390,   392,   393,
     396,   397,   399,   401,   403,   405,   407,   409,   412,   416,
     420,   423,   429,   431,   435,   439,   443,   447,   451,   455,
     458,   461,   464,   467,   471,   475,   479,   483,   485,   489,
     491,   495,   497,   499,   502,   505,   508,   510,   512,   514,
     516,   518,   520,   522,   526,   533,   535,   537,   539,   541,
     543,   544,   546,   548,   551,   555,   560,   564,   567,   570,
     572,   575,   577,   580,   584,   589,   593,   596,   601,   603,
     605,   607,   609,   611,   614,   617,   620,   623,   628,   635,
     640,   647,   652,   659,   664,   671,   673,   677,   680,   684,
     689,   696,   703,   710,   716,   722,   729,   736,   741,   750,
     755,   758,   762,   769,   774,   778,   782,   786,   790,   794,
     799,   804,   808,   812,   816,   820,   824,   828,   833,   838,
     842,   845,   849,   852,   855,   859,   863,   866,   869,   871,
     875,   878,   880,   882,   883,   886,   887,   890,   891,   895,
     898,   899,   901,   905,   909,   911,   917,   921,   926,   928,
     932,   937,   944,   949,   958,   961,   964,   975,   982,   984,
     986,   988,   990,   992,   994,   998,  1001,  1002,  1004,  1006,
    1010,  1014,  1016,  1018,  1022,  1026,  1030,  1034,  1039,  1042,
    1044,  1045,  1048,  1049,  1053,  1054,  1056,  1057,  1059,  1063,
    1066,  1068,  1070,  1072,  1076,  1077,  1079,  1083,  1085,  1097,
    1112,  1123,  1137,  1139,  1141,  1144,  1147,  1150,  1153,  1155,
    1156,  1158,  1159,  1163,  1164,  1166,  1170,  1172,  1176,  1178,
    1180,  1182,  1184,  1186,  1191,  1196,  1199,  1200,  1204,  1206,
    1208,  1211,  1214,  1216,  1220,  1225,  1231,  1234,  1240,  1242,
    1245,  1248,  1251,  1255,  1259,  1263,  1264,  1266,  1268,  1270,
    1272,  1274,  1276,  1280,  1282,  1288,  1296,  1300,  1309,  1314,
    1324,  1336,  1339,  1340,  1344,  1345,  1347,  1351,  1353,  1356,
    1359,  1362,  1363,  1365,  1369,  1373,  1380,  1385,  1386,  1388,
    1390,  1393,  1396,  1397,  1401,  1405,  1408,  1410,  1412,  1415,
    1418,  1423,  1424,  1427,  1430,  1433,  1434,  1438,  1443,  1448,
    1449,  1452,  1453,  1458,  1459,  1463,  1471,  1477,  1480,  1484,
    1485,  1491,  1496,  1503,  1505,  1506,  1508,  1511,  1514,  1516,
    1519,  1523,  1526,  1529,  1532,  1535,  1539,  1543,  1545,  1549,
    1551,  1552,  1554,  1557,  1559,  1561,  1565,  1572,  1583,  1585,
    1586,  1588,  1591,  1594,  1595,  1598,  1601,  1603,  1604,  1610,
    1618,  1620,  1621,  1628,  1631,  1632,  1636,  1642,  1648,  1657,
    1660,  1661,  1664,  1667,  1670,  1676,  1679,  1680,  1683,  1691,
    1702,  1709,  1716,  1723,  1730,  1738,  1746,  1756,  1766,  1773,
    1780,  1789,  1798,  1807,  1816,  1823,  1830,  1838,  1847,  1854,
    1861,  1869,  1872,  1875,  1878,  1881,  1883,  1886,  1888,  1889,
    1896,  1905,  1913,  1920,  1925,  1926,  1928,  1932,  1937,  1939,
    1943,  1945,  1948,  1951,  1954,  1957,  1959,  1961,  1972,  1975,
    1976,  1979,  1982,  1984,  1985,  1990,  1997,  2003,  2008,  2013,
    2022,  2034,  2038,  2041,  2043,  2047,  2049,  2055,  2063,  2072,
    2074,  2076,  2078,  2086,  2096,  2105,  2121,  2142,  2144,  2146,
    2149,  2151,  2155,  2157,  2159,  2161,  2165,  2167,  2171,  2172,
    2174,  2175,  2177,  2179,  2184,  2185,  2187,  2191,  2192,  2194,
    2196,  2198,  2200,  2203,  2204,  2205,  2208,  2211,  2213,  2216,
    2219,  2222,  2225,  2232,  2241,  2250,  2255,  2261,  2266,  2271,
    2276,  2280,  2288,  2297,  2304,  2311,  2318,  2325,  2332,  2337,
    2343,  2347,  2349,  2353,  2357,  2359,  2361,  2363,  2365,  2367,
    2369,  2373,  2377,  2381,  2383,  2387,  2391,  2393,  2394,  2396,
    2400,  2407,  2416,  2425,  2439,  2441,  2445,  2451,  2458,  2463,
    2471,  2474,  2476,  2477,  2480,  2481,  2484,  2489,  2490,  2492,
    2493,  2500,  2509,  2518,  2520,  2524,  2530,  2536,  2544,  2554,
    2562,  2572,  2578,  2585,  2592,  2597,  2603,  2611,  2613,  2615,
    2617,  2619,  2622,  2624,  2626,  2628,  2630,  2632,  2634,  2638,
    2642,  2646,  2650,  2652,  2656,  2658,  2661,  2664,  2668,  2674,
    2677,  2680,  2681,  2688,  2696,  2704,  2712,  2721,  2730,  2737,
    2746,  2756,  2766,  2774,  2785,  2793,  2802,  2811,  2820,  2829,
    2831,  2833,  2835,  2837,  2839,  2841,  2843,  2845,  2847,  2849,
    2851,  2853,  2855,  2857,  2860,  2862,  2866,  2868,  2870,  2879,
    2889,  2899,  2909,  2919,  2922,  2923,  2925,  2927,  2930,  2932,
    2934,  2936,  2938,  2940,  2942,  2944,  2946,  2948,  2950,  2953,
    2956,  2958,  2961,  2965,  2969,  2973,  2977,  2982,  2987,  2991,
    2995,  2999,  3004,  3009,  3013,  3018,  3023,  3025,  3027,  3029,
    3030,  3038,  3046,  3057,  3059,  3061,  3064,  3069,  3075,  3077,
    3081,  3084,  3087,  3090,  3093,  3095,  3098,  3101,  3106,  3110,
    3113,  3116,  3119,  3122,  3126,  3129,  3132,  3135,  3141,  3147,
    3153,  3155,  3159,  3161,  3164,  3168,  3169,  3171,  3175,  3178,
    3185,  3192,  3202,  3206,  3207,  3211,  3212,  3218,  3221,  3222,
    3226,  3230,  3234,  3242,  3250,  3261,  3263,  3265,  3267,  3269,
    3284,  3286,  3287,  3289,  3290,  3292,  3293,  3296,  3297,  3299,
    3303,  3309,  3315,  3323,  3326,  3327,  3329,  3332,  3333,  3335,
    3337,  3338,  3340,  3342,  3343,  3353,  3366,  3374,  3377,  3378,
    3382,  3385,  3387,  3391,  3395,  3398,  3400,  3404,  3408,  3412,
    3415,  3418,  3420,  3422,  3424,  3426,  3429,  3431,  3433,  3435,
    3437,  3442,  3448,  3450,  3454,  3458,  3460,  3463,  3468,  3474,
    3476,  3478,  3480,  3482,  3486,  3490,  3493,  3496,  3498,  3501,
    3504,  3507,  3509,  3512,  3515,  3517,  3519,  3521,  3525,  3528,
    3529,  3532,  3534,  3538,  3544,  3546,  3549,  3551,  3552,  3558,
    3566,  3572,  3580,  3586,  3594,  3598,  3604,  3610,  3616,  3618,
    3622,  3625,  3627,  3630,  3632,  3635,  3647,  3658,  3669,  3672,
    3675,  3676,  3686,  3689,  3690,  3695,  3700,  3705,  3707,  3709,
    3711,  3712,  3720,  3727,  3734,  3741,  3748,  3757,  3766,  3773,
    3780,  3788,  3798,  3808,  3815,  3822,  3829,  3838,  3845,  3854,
    3861,  3870,  3877,  3886,  3894,  3904,  3913,  3924,  3933,  3943,
    3955,  3964,  3971,  3978,  3985,  3991,  3997,  4006,  4015,  4024,
    4033,  4040,  4050,  4052,  4053,  4056,  4057,  4065,  4072,  4079,
    4086,  4093,  4100,  4108,  4118,  4128,  4135,  4144,  4153,  4162,
    4171,  4180,  4187,  4196,  4203,  4212,  4220,  4230,  4237,  4245,
    4252,  4259,  4266,  4273,  4280,  4288,  4296,  4304,  4314,  4324,
    4331,  4338,  4345,  4354,  4363,  4372,  4379,  4393,  4395,  4397,
    4401,  4405,  4407,  4409,  4411,  4413,  4415,  4417,  4419,  4420,
    4422,  4424,  4426,  4428,  4430,  4432,  4433,  4440,  4449,  4453,
    4456,  4457,  4460,  4463,  4466,  4469,  4473,  4477,  4480,  4483,
    4486,  4489,  4493,  4496,  4502,  4507,  4511,  4515,  4519,  4521,
    4523,  4524,  4528,  4531,  4534,  4536,  4539,  4541,  4545,  4548,
    4550,  4551,  4561,  4573,  4577,  4582,  4587,  4588,  4591,  4597,
    4600,  4601,  4605,  4609,  4613,  4617,  4621,  4625,  4629,  4633,
    4637,  4641,  4645,  4649,  4653,  4658,  4662,  4666,  4668,  4669,
    4675,  4682,  4687,  4690,  4691,  4696,  4700,  4706,  4713,  4718,
    4725,  4732,  4738,  4746,  4756,  4763,  4765,  4766,  4773,  4785,
    4797,  4809,  4823,  4833,  4845,  4856,  4861,  4864,  4870,  4873,
    4874,  4879,  4885,  4891,  4896,  4903,  4905,  4909,  4911,  4913,
    4915,  4917,  4920,  4925,  4927,  4929,  4931,  4932,  4934,  4935,
    4937,  4938,  4942,  4943,  4946,  4951,  4955,  4961,  4963,  4965,
    4967,  4969,  4971,  4973,  4975,  4977,  4981,  4984,  4986,  4988,
    4990,  4992,  4993,  4999,  5003,  5004,  5006,  5008,  5010,  5012,
    5016,  5026,  5030,  5031,  5034,  5038,  5041,  5045,  5052,  5054,
    5059,  5062,  5064,  5068,  5071,  5074,  5075,  5083,  5086,  5087,
    5093,  5097,  5098,  5101,  5104,  5107,  5110,  5113,  5117,  5119,
    5123,  5125,  5128,  5130,  5131,  5140,  5142,  5146,  5148,  5150,
    5154,  5160,  5163,  5165,  5169,  5177,  5179,  5180,  5184,  5187,
    5190,  5193,  5194,  5197,  5200,  5202,  5204,  5208,  5212,  5214,
    5217,  5222,  5227,  5230,  5234,  5240,  5246,  5248,  5250,  5260,
    5262,  5265,  5270,  5275,  5280,  5283,  5287,  5289,  5293,  5300,
    5302,  5303,  5306,  5307,  5311,  5315,  5320,  5325,  5330,  5335,
    5339,  5342,  5344,  5346,  5347,  5349,  5351,  5352,  5354,  5360,
    5362,  5363,  5365,  5366,  5370,  5372,  5376,  5381,  5385,  5388,
    5391,  5393,  5395,  5397,  5398,  5401,  5406,  5412,  5415,  5419,
    5421,  5423,  5425,  5427,  5431,  5432,  5434,  5436,  5438,  5440,
    5442,  5446,  5447,  5450,  5451,  5453,  5457,  5459,  5460,  5462,
    5465,  5470,  5475,  5478,  5479,  5482,  5486,  5489,  5490,  5492,
    5496,  5498,  5501,  5503,  5506,  5512,  5519,  5525,  5527,  5530,
    5532,  5537,  5541,  5546,  5552,  5557,  5563,  5568,  5574,  5577,
    5582,  5584,  5587,  5590,  5593,  5595,  5597,  5598,  5603,  5606,
    5608,  5611,  5614,  5619,  5621,  5625,  5627,  5630,  5634,  5636,
    5639,  5640,  5643,  5648,  5649,  5651,  5652,  5654,  5658,  5662,
    5665,  5669,  5675,  5682,  5685,  5689,  5693,  5698,  5699,  5701,
    5703,  5705,  5707,  5709,  5712,  5718,  5720,  5722,  5724,  5726,
    5729,  5733,  5737,  5738,  5740,  5742,  5744,  5746,  5748,  5751,
    5754,  5757,  5760,  5763,  5765,  5769,  5770,  5772,  5774,  5776,
    5778,  5784,  5787,  5789,  5791,  5793,  5795,  5801,  5804,  5807,
    5810,  5812,  5816,  5820,  5823,  5825,  5826,  5830,  5831,  5837,
    5840,  5846,  5849,  5851,  5854,  5858,  5859,  5861,  5863,  5865,
    5867,  5869,  5871,  5875,  5879,  5883,  5887,  5891,  5895,  5899,
    5900,  5902,  5907,  5909,  5913,  5917,  5923,  5926,  5929,  5933,
    5937,  5941,  5945,  5949,  5953,  5957,  5961,  5965,  5969,  5972,
    5975,  5979,  5983,  5986,  5990,  5996,  6001,  6008,  6012,  6018,
    6023,  6030,  6035,  6042,  6048,  6056,  6060,  6063,  6068,  6071,
    6075,  6079,  6084,  6088,  6093,  6097,  6102,  6108,  6115,  6122,
    6130,  6137,  6145,  6152,  6160,  6164,  6169,  6174,  6181,  6184,
    6188,  6193,  6195,  6199,  6202,  6205,  6209,  6213,  6217,  6221,
    6225,  6229,  6233,  6237,  6241,  6245,  6248,  6251,  6257,  6264,
    6271,  6279,  6283,  6288,  6290,  6292,  6295,  6300,  6302,  6304,
    6306,  6309,  6312,  6315,  6318,  6320,  6325,  6331,  6338,  6347,
    6354,  6362,  6370,  6376,  6382,  6384,  6386,  6391,  6393,  6398,
    6400,  6405,  6407,  6412,  6414,  6416,  6418,  6420,  6422,  6424,
    6431,  6436,  6441,  6446,  6451,  6458,  6464,  6470,  6476,  6481,
    6488,  6493,  6498,  6503,  6508,  6514,  6522,  6530,  6540,  6546,
    6551,  6558,  6564,  6572,  6580,  6588,  6591,  6595,  6599,  6603,
    6608,  6609,  6614,  6616,  6620,  6624,  6626,  6628,  6630,  6633,
    6636,  6637,  6640,  6645,  6650,  6657,  6660,  6661,  6663,  6667,
    6671,  6674,  6677,  6678,  6685,  6687,  6688,  6692,  6693,  6696,
    6699,  6700,  6702,  6707,  6710,  6713,  6716,  6719,  6722,  6727,
    6731,  6737,  6739,  6741,  6743,  6745,  6747,  6749,  6751,  6753,
    6755,  6757,  6759,  6761,  6763,  6765,  6767,  6772,  6774,  6779,
    6781,  6786,  6788,  6791,  6793,  6796,  6798,  6802,  6804,  6808,
    6810,  6814,  6816,  6820,  6824,  6828,  6831,  6833,  6837,  6841,
    6842,  6844,  6846,  6848,  6850,  6852,  6854,  6856,  6858,  6863,
    6867,  6870,  6874,  6875,  6879,  6883,  6886,  6889,  6891,  6892,
    6895,  6898,  6902,  6905,  6907,  6909,  6913,  6919,  6921,  6924,
    6929,  6932,  6933,  6935,  6936,  6938,  6941,  6944,  6947,  6951,
    6957,  6959,  6962,  6963,  6966,  6968,  6969,  6971,  6973,  6975,
    6979,  6983,  6985,  6989,  6993,  6996,  6998,  7000,  7002,  7006,
    7008,  7011,  7013,  7017,  7019,  7021,  7023,  7025,  7027,  7029,
    7031,  7034,  7036,  7038,  7040,  7042,  7044,  7047,  7053,  7056,
    7060,  7067,  7069,  7071,  7073,  7075,  7077,  7079,  7081,  7085,
    7087,  7090,  7093,  7095,  7097,  7099,  7101,  7103,  7105,  7107,
    7109,  7111,  7113,  7115,  7117,  7119,  7121,  7123,  7125,  7127,
    7129,  7131,  7133,  7135,  7137,  7139,  7141,  7143,  7145,  7147,
    7149,  7151,  7153,  7155,  7157,  7159,  7161,  7163,  7165,  7167,
    7169,  7171,  7173,  7175,  7177,  7179,  7181,  7183,  7185,  7187,
    7189,  7191,  7193,  7195,  7197,  7199,  7201,  7203,  7205,  7207,
    7209,  7211,  7213,  7215,  7217,  7219,  7221,  7223,  7225,  7227,
    7229,  7231,  7233,  7235,  7237,  7239,  7241,  7243,  7245,  7247,
    7249,  7251,  7253,  7255,  7257,  7259,  7261,  7263,  7265,  7267,
    7269,  7271,  7273,  7275,  7277,  7279,  7281,  7283,  7285,  7287,
    7289,  7291,  7293,  7295,  7297,  7299,  7301,  7303,  7305,  7307,
    7309,  7311,  7313,  7315,  7317,  7319,  7321,  7323,  7325,  7327,
    7329,  7331,  7333,  7335,  7337,  7339,  7341,  7343,  7345,  7347,
    7349,  7351,  7353,  7355,  7357,  7359,  7361,  7363,  7365,  7367,
    7369,  7371,  7373,  7375,  7377,  7379,  7381,  7383,  7385,  7387,
    7389,  7391,  7393,  7395,  7397,  7399,  7401,  7403,  7405,  7407,
    7409,  7411,  7413,  7415,  7417,  7419,  7421,  7423,  7425,  7427,
    7429,  7431,  7433,  7435,  7437,  7439,  7441,  7443,  7445,  7447,
    7449,  7451,  7453,  7455,  7457,  7459,  7461,  7463,  7465,  7467,
    7469,  7471,  7473,  7475,  7477,  7479,  7481,  7483,  7485,  7487,
    7489,  7491,  7493,  7495,  7497,  7499,  7501,  7503,  7505,  7507,
    7509,  7511,  7513,  7515,  7517,  7519,  7521,  7523,  7525,  7527,
    7529,  7531,  7533,  7535,  7537,  7539,  7541,  7543,  7545,  7547,
    7549,  7551,  7553,  7555,  7557,  7559,  7561,  7563,  7565,  7567,
    7569,  7571,  7573,  7575,  7577,  7579,  7581,  7583,  7585,  7587,
    7589,  7591,  7593,  7595,  7597,  7599,  7601,  7603,  7605,  7607,
    7609,  7611,  7613,  7615,  7617,  7619,  7621,  7623,  7625,  7627,
    7629,  7631,  7633,  7635,  7637,  7639,  7641,  7643,  7645,  7647,
    7649,  7651,  7653,  7655,  7657,  7659,  7661,  7663,  7665,  7667,
    7669,  7671,  7673,  7675,  7677,  7679,  7681,  7683,  7685,  7687,
    7689,  7691,  7693,  7695,  7697,  7699,  7701,  7703,  7705,  7707,
    7709,  7711,  7713,  7715,  7717,  7719,  7721,  7723,  7725,  7727,
    7729,  7731,  7733,  7735,  7737,  7739,  7741,  7743,  7745,  7747,
    7749,  7751,  7753,  7755,  7757,  7759,  7761,  7763,  7765,  7767,
    7769,  7771,  7773,  7775,  7777,  7779,  7781,  7783,  7785,  7787,
    7789,  7791,  7793,  7795,  7797,  7799,  7801,  7803,  7805,  7807,
    7809,  7811,  7813,  7815,  7817,  7819,  7821,  7823,  7825,  7827,
    7829,  7831,  7833,  7835,  7837,  7839,  7841,  7843,  7845,  7847,
    7849,  7851,  7853,  7855,  7857,  7859,  7861,  7863,  7865,  7867,
    7869,  7871,  7873,  7875,  7877,  7879,  7881,  7883,  7885,  7887,
    7889,  7891,  7893,  7895,  7897,  7899,  7901,  7903,  7905,  7907,
    7909,  7911,  7913,  7915
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     434,     0,    -1,   435,    -1,   435,   430,   436,    -1,   436,
      -1,   762,    -1,   763,    -1,   680,    -1,   768,    -1,   631,
      -1,   571,    -1,   574,    -1,   580,    -1,   594,    -1,   599,
      -1,   715,    -1,   452,    -1,   736,    -1,   737,    -1,   550,
      -1,   479,    -1,   490,    -1,   446,    -1,   444,    -1,   771,
      -1,   770,    -1,   603,    -1,   448,    -1,   447,    -1,   778,
      -1,   477,    -1,   493,    -1,   773,    -1,   654,    -1,   474,
      -1,   494,    -1,   546,    -1,   618,    -1,   726,    -1,   772,
      -1,   767,    -1,   568,    -1,   575,    -1,   589,    -1,   595,
      -1,   696,    -1,   451,    -1,   632,    -1,   639,    -1,   640,
      -1,   557,    -1,   455,    -1,   549,    -1,   509,    -1,   565,
      -1,   604,    -1,   437,    -1,   443,    -1,   600,    -1,   758,
      -1,   795,    -1,   814,    -1,   620,    -1,   801,    -1,   478,
      -1,   723,    -1,   619,    -1,   728,    -1,   579,    -1,   593,
      -1,   454,    -1,   643,    -1,   644,    -1,   645,    -1,   563,
      -1,   745,    -1,   647,    -1,   567,    -1,   617,    -1,   449,
      -1,   450,    -1,   602,    -1,   766,    -1,   793,    -1,   784,
      -1,   661,    -1,   665,    -1,   676,    -1,   685,    -1,   796,
      -1,   748,    -1,   757,    -1,   803,    -1,   746,    -1,   790,
      -1,   646,    -1,   730,    -1,   719,    -1,   718,    -1,   720,
      -1,   733,    -1,   666,    -1,   677,    -1,   738,    -1,   657,
      -1,   818,    -1,   750,    -1,   652,    -1,   749,    -1,   807,
      -1,   775,    -1,   470,    -1,   459,    -1,   473,    -1,   755,
      -1,    -1,    84,   302,   968,   438,   439,    -1,   393,    -1,
      -1,   439,   442,    -1,    -1,   440,   441,    -1,    -1,   265,
     967,    -1,   265,   238,    -1,   126,   265,   967,    -1,   366,
     265,   967,    -1,   176,    -1,    76,   209,   970,    -1,   377,
     372,   967,    -1,   374,   969,    -1,     3,    -1,   441,    -1,
     341,   966,    -1,    19,   969,    -1,   302,   969,    -1,   171,
     302,   969,    -1,   171,   159,   969,    -1,    84,   374,   968,
     438,   439,    -1,    24,   302,   968,   438,   440,    -1,    -1,
     171,    98,   959,    -1,    24,   302,   968,   445,   471,    -1,
      24,   374,   968,   438,   440,    -1,    24,   374,   968,   471,
      -1,   121,   302,   969,    -1,   121,   302,   166,   135,   969,
      -1,   121,   374,   969,    -1,   121,   374,   166,   135,   969,
      -1,    84,   159,   968,   438,   439,    -1,    24,   159,   968,
     453,   374,   969,    -1,    18,    -1,   121,    -1,   121,   159,
     969,    -1,   121,   159,   166,   135,   969,    -1,    84,   308,
     456,    39,   968,   457,    -1,    84,   308,   971,   457,    -1,
     971,    -1,    -1,   457,   458,    -1,    -1,   509,    -1,   685,
      -1,   549,    -1,   604,    -1,   665,    -1,   755,    -1,   320,
     460,    -1,   320,   212,   460,    -1,   320,   318,   460,    -1,
     355,   753,    -1,   318,    60,    32,   355,   753,    -1,   461,
      -1,   462,   353,   463,    -1,   462,   414,   463,    -1,   462,
     353,   104,    -1,   462,   414,   104,    -1,   462,   151,    87,
      -1,   351,   410,   467,    -1,    56,   967,    -1,   308,   967,
      -1,   226,   468,    -1,   302,   469,    -1,   318,    39,   469,
      -1,   318,    39,   104,    -1,   398,   250,   904,    -1,   355,
     327,   967,    -1,   971,    -1,   462,   429,   971,    -1,   464,
      -1,   463,   431,   464,    -1,   466,    -1,   555,    -1,   281,
     365,    -1,   281,    73,    -1,   292,   281,    -1,   316,    -1,
     359,    -1,   140,    -1,   247,    -1,   469,    -1,   967,    -1,
       3,    -1,   891,   967,   893,    -1,   891,   427,   966,   428,
     967,   893,    -1,   555,    -1,   104,    -1,   212,    -1,   967,
      -1,   104,    -1,    -1,   973,    -1,   967,    -1,   295,   462,
      -1,   295,   351,   410,    -1,   295,   355,   194,   207,    -1,
     295,   318,    39,    -1,   295,    22,    -1,   320,   460,    -1,
     470,    -1,   320,   461,    -1,   470,    -1,   323,   462,    -1,
     323,   351,   410,    -1,   323,   355,   194,   207,    -1,   323,
     318,    39,    -1,   323,    22,    -1,   320,    78,   475,   476,
      -1,    22,    -1,   955,    -1,   107,    -1,   168,    -1,    62,
      -1,   115,    22,    -1,   115,   346,    -1,   115,   348,    -1,
     115,   267,    -1,    24,   343,   862,   480,    -1,    24,   343,
     166,   135,   862,   480,    -1,    24,   174,   956,   480,    -1,
      24,   174,   166,   135,   956,   480,    -1,    24,   314,   956,
     480,    -1,    24,   314,   166,   135,   956,   480,    -1,    24,
     387,   956,   480,    -1,    24,   387,   166,   135,   956,   480,
      -1,   481,    -1,   480,   431,   481,    -1,    18,   517,    -1,
      18,    69,   517,    -1,    24,   734,   971,   482,    -1,    24,
     734,   971,   121,   233,   238,    -1,    24,   734,   971,   320,
     233,   238,    -1,    24,   734,   971,   320,   333,   970,    -1,
      24,   734,   971,   320,   486,    -1,    24,   734,   971,   295,
     486,    -1,    24,   734,   971,   320,   336,   971,    -1,   121,
     734,   166,   135,   971,   483,    -1,   121,   734,   971,   483,
      -1,    24,   734,   971,   735,   362,   871,   484,   485,    -1,
      24,   734,   971,   583,    -1,    18,   526,    -1,   378,    77,
     958,    -1,   121,    77,   166,   135,   958,   483,    -1,   121,
      77,   958,   483,    -1,   320,   393,   246,    -1,   320,   394,
     246,    -1,    65,   247,   958,    -1,   320,   394,    65,    -1,
     124,   357,   958,    -1,   124,    25,   357,   958,    -1,   124,
     294,   357,   958,    -1,   124,   357,    22,    -1,   124,   357,
     374,    -1,   114,   357,   958,    -1,   114,   357,    22,    -1,
     114,   357,   374,    -1,   124,   306,   958,    -1,   124,    25,
     306,   958,    -1,   124,   294,   306,   958,    -1,   114,   306,
     958,    -1,   176,   956,    -1,   231,   176,   956,    -1,   243,
     650,    -1,   233,   243,    -1,   260,   353,   968,    -1,   320,
     345,   958,    -1,   320,   486,    -1,   295,   486,    -1,   583,
      -1,   320,   104,   895,    -1,   121,   104,    -1,    52,    -1,
     297,    -1,    -1,    67,   650,    -1,    -1,   375,   895,    -1,
      -1,   427,   488,   428,    -1,   393,   486,    -1,    -1,   489,
      -1,   488,   431,   489,    -1,   974,   414,   624,    -1,   974,
      -1,   974,   429,   974,   414,   624,    -1,   974,   429,   974,
      -1,    24,   362,   650,   491,    -1,   492,    -1,   491,   431,
     492,    -1,    18,    38,   870,   483,    -1,   121,    38,   166,
     135,   971,   483,    -1,   121,    38,   971,   483,    -1,    24,
      38,   971,   735,   362,   871,   484,   483,    -1,    64,   815,
      -1,    64,    22,    -1,    82,   500,   956,   529,   501,   495,
     496,   502,   438,   497,    -1,    82,   819,   353,   496,   438,
     497,    -1,   151,    -1,   353,    -1,   967,    -1,   334,    -1,
     335,    -1,   498,    -1,   427,   504,   428,    -1,   498,   499,
      -1,    -1,    45,    -1,   246,    -1,   110,   769,   967,    -1,
     238,   769,   967,    -1,    86,    -1,   162,    -1,   279,   769,
     967,    -1,   129,   769,   967,    -1,   147,   279,   530,    -1,
     147,   279,   420,    -1,   147,   233,   238,   530,    -1,   125,
     967,    -1,    45,    -1,    -1,   393,   246,    -1,    -1,   503,
     111,   967,    -1,    -1,   375,    -1,    -1,   505,    -1,   504,
     431,   505,    -1,   974,   506,    -1,   466,    -1,   555,    -1,
     420,    -1,   427,   507,   428,    -1,    -1,   508,    -1,   507,
     431,   508,    -1,   466,    -1,    84,   510,   343,   956,   427,
     511,   428,   540,   541,   542,   543,    -1,    84,   510,   343,
     166,   233,   135,   956,   427,   511,   428,   540,   541,   542,
     543,    -1,    84,   510,   343,   956,   243,   650,   512,   541,
     542,   543,    -1,    84,   510,   343,   166,   233,   135,   956,
     243,   650,   512,   541,   542,   543,    -1,   348,    -1,   346,
      -1,   212,   348,    -1,   212,   346,    -1,   155,   348,    -1,
     155,   346,    -1,   371,    -1,    -1,   513,    -1,    -1,   427,
     514,   428,    -1,    -1,   515,    -1,   513,   431,   515,    -1,
     516,    -1,   514,   431,   516,    -1,   517,    -1,   523,    -1,
     526,    -1,   518,    -1,   526,    -1,   971,   871,   581,   519,
      -1,   971,   393,   251,   519,    -1,   519,   520,    -1,    -1,
      77,   958,   521,    -1,   521,    -1,   522,    -1,    67,   650,
      -1,   233,   238,    -1,   238,    -1,   368,   712,   544,    -1,
     274,   196,   712,   544,    -1,    61,   427,   895,   428,   528,
      -1,   104,   896,    -1,   287,   956,   529,   532,   536,    -1,
     106,    -1,   233,   106,    -1,   178,   107,    -1,   178,   168,
      -1,   208,   956,   524,    -1,   524,   172,   525,    -1,   524,
     132,   525,    -1,    -1,   105,    -1,    78,    -1,   175,    -1,
     336,    -1,    71,    -1,    22,    -1,    77,   958,   527,    -1,
     527,    -1,    61,   427,   895,   428,   615,    -1,   368,   427,
     530,   428,   712,   544,   615,    -1,   368,   545,   615,    -1,
     274,   196,   427,   530,   428,   712,   544,   615,    -1,   274,
     196,   545,   615,    -1,   131,   689,   427,   533,   428,   712,
     544,   535,   615,    -1,   148,   196,   427,   530,   428,   287,
     956,   529,   532,   536,   615,    -1,   231,   176,    -1,    -1,
     427,   530,   428,    -1,    -1,   531,    -1,   530,   431,   531,
      -1,   971,    -1,   218,   152,    -1,   218,   262,    -1,   218,
     325,    -1,    -1,   534,    -1,   533,   431,   534,    -1,   691,
     393,   722,    -1,   691,   393,   249,   427,   722,   428,    -1,
     390,   427,   895,   428,    -1,    -1,   537,    -1,   538,    -1,
     537,   538,    -1,   538,   537,    -1,    -1,   247,   373,   539,
      -1,   247,   109,   539,    -1,   231,    17,    -1,   297,    -1,
      52,    -1,   320,   238,    -1,   320,   104,    -1,   177,   427,
     955,   428,    -1,    -1,   393,   486,    -1,   393,   246,    -1,
     394,   246,    -1,    -1,   247,    72,   121,    -1,   247,    72,
     109,   305,    -1,   247,    72,   271,   305,    -1,    -1,   345,
     958,    -1,    -1,   375,   174,   345,   958,    -1,    -1,   375,
     174,   962,    -1,    84,   510,   343,   547,    32,   818,   548,
      -1,   956,   529,   541,   542,   543,    -1,   393,    97,    -1,
     393,   231,    97,    -1,    -1,    84,   510,   314,   956,   551,
      -1,    24,   314,   956,   552,    -1,    24,   314,   166,   135,
     956,   552,    -1,   552,    -1,    -1,   553,    -1,   552,   553,
      -1,    50,   555,    -1,    96,    -1,   231,    96,    -1,   173,
     554,   555,    -1,   219,   555,    -1,   221,   555,    -1,   231,
     219,    -1,   231,   221,    -1,   259,    49,   650,    -1,   331,
     438,   555,    -1,   296,    -1,   296,   438,   555,    -1,    49,
      -1,    -1,     4,    -1,   419,     4,    -1,   970,    -1,   555,
      -1,   556,   431,   555,    -1,    84,   697,   558,   564,   198,
     469,    -1,    84,   697,   558,   564,   198,   469,   160,   559,
     560,   562,    -1,   361,    -1,    -1,   958,    -1,   958,   651,
      -1,   179,   559,    -1,    -1,   379,   559,    -1,   231,   379,
      -1,   561,    -1,    -1,   121,   564,   198,   469,   483,    -1,
     121,   564,   198,   166,   135,   469,   483,    -1,   277,    -1,
      -1,    84,   345,   958,   566,   215,   967,    -1,   260,   958,
      -1,    -1,   121,   345,   958,    -1,   121,   345,   166,   135,
     958,    -1,    84,   137,   958,   438,   569,    -1,    84,   137,
     166,   233,   135,   958,   438,   569,    -1,   569,   570,    -1,
      -1,   308,   958,    -1,   386,   469,    -1,   151,   469,    -1,
      24,   137,   958,   373,   572,    -1,   572,   573,    -1,    -1,
     353,   469,    -1,    24,   137,   958,   453,    21,   964,   625,
      -1,    24,   137,   958,   453,    55,   427,   871,    32,   871,
     428,    -1,    24,   137,   958,   453,    68,   650,    -1,    24,
     137,   958,   453,    81,   650,    -1,    24,   137,   958,   453,
     119,   650,    -1,    24,   137,   958,   453,   153,   675,    -1,
      24,   137,   958,   453,   564,   198,   958,    -1,    24,   137,
     958,   453,   249,   722,   721,    -1,    24,   137,   958,   453,
     249,    63,   650,   375,   960,    -1,    24,   137,   958,   453,
     249,   141,   650,   375,   960,    -1,    24,   137,   958,   453,
     308,   958,    -1,    24,   137,   958,   453,   343,   650,    -1,
      24,   137,   958,   453,   349,   310,   261,   650,    -1,    24,
     137,   958,   453,   349,   310,   113,   650,    -1,    24,   137,
     958,   453,   349,   310,   347,   650,    -1,    24,   137,   958,
     453,   349,   310,    75,   650,    -1,    24,   137,   958,   453,
     314,   650,    -1,    24,   137,   958,   453,   387,   650,    -1,
      24,   137,   958,   453,   148,   343,   650,    -1,    24,   137,
     958,   453,   148,    97,   396,   958,    -1,    24,   137,   958,
     453,   317,   958,    -1,    24,   137,   958,   453,   362,   650,
      -1,    84,   148,    97,   396,   958,   578,   581,    -1,   160,
     559,    -1,   231,   160,    -1,   379,   559,    -1,   231,   379,
      -1,   576,    -1,   577,   576,    -1,   577,    -1,    -1,   121,
     148,    97,   396,   958,   483,    -1,   121,   148,    97,   396,
     166,   135,   958,   483,    -1,    24,   148,    97,   396,   958,
     578,   583,    -1,    24,   148,    97,   396,   958,   577,    -1,
     251,   427,   582,   428,    -1,    -1,   586,    -1,   582,   431,
     586,    -1,   251,   427,   584,   428,    -1,   585,    -1,   584,
     431,   585,    -1,   586,    -1,   320,   586,    -1,    18,   586,
      -1,   121,   587,    -1,   587,   588,    -1,   974,    -1,   967,
      -1,    84,   317,   958,   590,   592,   148,    97,   396,   958,
     581,    -1,   362,   967,    -1,    -1,   386,   967,    -1,   386,
     238,    -1,   591,    -1,    -1,   121,   317,   958,   483,    -1,
     121,   317,   166,   135,   958,   483,    -1,    24,   317,   958,
     591,   583,    -1,    24,   317,   958,   591,    -1,    24,   317,
     958,   583,    -1,    84,   148,   343,   956,   596,   317,   958,
     581,    -1,    84,   148,   343,   166,   233,   135,   956,   596,
     317,   958,   581,    -1,   427,   597,   428,    -1,   427,   428,
      -1,   598,    -1,   597,   431,   598,    -1,   517,    -1,    24,
     148,   343,   862,   480,    -1,    24,   148,   343,   166,   135,
     862,   480,    -1,    84,   374,   217,   146,   601,   317,   958,
     581,    -1,    94,    -1,   374,    -1,   968,    -1,   121,   374,
     217,   146,   601,   317,   958,    -1,   121,   374,   217,   166,
     135,   146,   601,   317,   958,    -1,    24,   374,   217,   146,
     601,   317,   958,   583,    -1,    84,   357,   958,   605,   606,
     247,   956,   608,   611,   134,   278,   964,   427,   612,   428,
      -1,    84,    77,   357,   958,    20,   606,   247,   956,   614,
     615,   146,   122,   304,   611,   134,   278,   964,   427,   612,
     428,    -1,    41,    -1,    20,    -1,   185,   243,    -1,   607,
      -1,   606,   252,   607,    -1,   184,    -1,   109,    -1,   373,
      -1,   373,   243,   530,    -1,   360,    -1,   146,   609,   610,
      -1,    -1,   122,    -1,    -1,   304,    -1,   332,    -1,   389,
     427,   895,   428,    -1,    -1,   613,    -1,   612,   431,   613,
      -1,    -1,   966,    -1,     4,    -1,   967,    -1,   974,    -1,
     151,   956,    -1,    -1,    -1,   615,   616,    -1,   233,   106,
      -1,   106,    -1,   178,   168,    -1,   178,   107,    -1,   233,
     377,    -1,   231,   176,    -1,   121,   357,   958,   247,   650,
     483,    -1,   121,   357,   166,   135,   958,   247,   650,   483,
      -1,    84,    34,   958,    61,   427,   895,   428,   615,    -1,
     121,    34,   958,   483,    -1,    84,    21,   964,   625,   621,
      -1,    84,    21,   964,   626,    -1,    84,   249,   722,   621,
      -1,    84,   362,   650,   621,    -1,    84,   362,   650,    -1,
      84,   362,   650,    32,   427,   868,   428,    -1,    84,   362,
     650,    32,   128,   427,   629,   428,    -1,    84,   362,   650,
      32,   280,   621,    -1,    84,   349,   310,   261,   650,   621,
      -1,    84,   349,   310,   113,   650,   621,    -1,    84,   349,
     310,   347,   650,   621,    -1,    84,   349,   310,    75,   650,
     621,    -1,    84,    68,   650,   621,    -1,    84,    68,   650,
     151,   650,    -1,   427,   622,   428,    -1,   623,    -1,   622,
     431,   623,    -1,   974,   414,   624,    -1,   974,    -1,   706,
      -1,   978,    -1,   922,    -1,   555,    -1,   967,    -1,   427,
     927,   428,    -1,   427,   420,   428,    -1,   427,   627,   428,
      -1,   628,    -1,   627,   431,   628,    -1,     3,   414,   624,
      -1,   630,    -1,    -1,   967,    -1,   630,   431,   967,    -1,
      24,   362,   650,    18,   380,   967,    -1,    24,   362,   650,
      18,   380,   967,    41,   967,    -1,    24,   362,   650,    18,
     380,   967,    20,   967,    -1,    84,   249,    63,   650,   635,
     146,   362,   871,   375,   960,   636,    32,   633,    -1,   634,
      -1,   633,   431,   634,    -1,   249,   966,   722,   637,   638,
      -1,   249,   966,   722,   721,   637,   638,    -1,   153,   966,
     964,   698,    -1,   153,   966,   427,   927,   428,   964,   698,
      -1,   336,   871,    -1,   104,    -1,    -1,   141,   650,    -1,
      -1,   146,   310,    -1,   146,   253,    49,   650,    -1,    -1,
     284,    -1,    -1,    84,   249,   141,   650,   375,   960,    -1,
      24,   249,   141,   650,   375,   960,    18,   633,    -1,    24,
     249,   141,   650,   375,   960,   121,   641,    -1,   642,    -1,
     641,   431,   642,    -1,   249,   966,   427,   927,   428,    -1,
     153,   966,   427,   927,   428,    -1,   121,   249,    63,   650,
     375,   960,   483,    -1,   121,   249,    63,   166,   135,   650,
     375,   960,   483,    -1,   121,   249,   141,   650,   375,   960,
     483,    -1,   121,   249,   141,   166,   135,   650,   375,   960,
     483,    -1,   121,   259,    49,   969,   483,    -1,   283,   259,
      49,   969,   353,   958,    -1,   121,   648,   166,   135,   649,
     483,    -1,   121,   648,   649,   483,    -1,   121,   174,    74,
     649,   483,    -1,   121,   174,    74,   166,   135,   649,   483,
      -1,   343,    -1,   314,    -1,   387,    -1,   174,    -1,   148,
     343,    -1,   362,    -1,   119,    -1,    68,    -1,    81,    -1,
     308,    -1,   137,    -1,   349,   310,   261,    -1,   349,   310,
     113,    -1,   349,   310,   347,    -1,   349,   310,    75,    -1,
     650,    -1,   649,   431,   650,    -1,   971,    -1,   971,   651,
      -1,   429,   961,    -1,   651,   429,   961,    -1,   360,   829,
     863,   653,   483,    -1,    80,   165,    -1,   296,   165,    -1,
      -1,    70,   247,   655,   650,   192,   656,    -1,    70,   247,
      21,   964,   625,   192,   656,    -1,    70,   247,   153,   964,
     698,   192,   656,    -1,    70,   247,   249,   722,   721,   192,
     656,    -1,    70,   247,    77,   958,   247,   650,   192,   656,
      -1,    70,   247,   306,   958,   247,   650,   192,   656,    -1,
      70,   247,   306,   958,   192,   656,    -1,    70,   247,   357,
     958,   247,   650,   192,   656,    -1,    70,   247,   249,    63,
     650,   375,   960,   192,   656,    -1,    70,   247,   249,   141,
     650,   375,   960,   192,   656,    -1,    70,   247,   199,   242,
     555,   192,   656,    -1,    70,   247,    55,   427,   871,    32,
     871,   428,   192,   656,    -1,    70,   247,   564,   198,   650,
     192,   656,    -1,    70,   247,   349,   310,   261,   650,   192,
     656,    -1,    70,   247,   349,   310,   113,   650,   192,   656,
      -1,    70,   247,   349,   310,   347,   650,   192,   656,    -1,
      70,   247,   349,   310,    75,   650,   192,   656,    -1,    69,
      -1,    98,    -1,   308,    -1,   174,    -1,   314,    -1,   343,
      -1,   119,    -1,   362,    -1,   387,    -1,    68,    -1,    81,
      -1,   345,    -1,   137,    -1,   302,    -1,   148,   343,    -1,
     317,    -1,   148,    97,   396,    -1,   967,    -1,   238,    -1,
     312,   197,   658,   247,   659,   650,   192,   660,    -1,   312,
     197,   658,   247,    21,   964,   625,   192,   660,    -1,   312,
     197,   658,   247,   153,   964,   698,   192,   660,    -1,   312,
     197,   658,   247,   199,   242,   555,   192,   660,    -1,   312,
     197,   658,   247,   564,   198,   650,   192,   660,    -1,   146,
     469,    -1,    -1,    69,    -1,    98,    -1,   148,   343,    -1,
     308,    -1,   314,    -1,   343,    -1,   119,    -1,   302,    -1,
     345,    -1,   362,    -1,   387,    -1,   967,    -1,   238,    -1,
     142,   662,    -1,   224,   662,    -1,   815,    -1,   663,   815,
      -1,   230,   664,   815,    -1,   275,   664,   815,    -1,   143,
     664,   815,    -1,   200,   664,   815,    -1,    15,   970,   664,
     815,    -1,   289,   970,   664,   815,    -1,   970,   664,   815,
      -1,    22,   664,   815,    -1,   149,   664,   815,    -1,   149,
     970,   664,   815,    -1,   149,    22,   664,   815,    -1,    40,
     664,   815,    -1,    40,   970,   664,   815,    -1,    40,    22,
     664,   815,    -1,   151,    -1,   171,    -1,   663,    -1,    -1,
     156,   667,   247,   670,   353,   671,   673,    -1,   300,   667,
     247,   670,   151,   671,   483,    -1,   300,   156,   250,   146,
     667,   247,   670,   151,   671,   483,    -1,   668,    -1,    22,
      -1,    22,   276,    -1,    22,   427,   530,   428,    -1,    22,
     276,   427,   530,   428,    -1,   669,    -1,   668,   431,   669,
      -1,   313,   529,    -1,   287,   529,    -1,    84,   529,    -1,
     971,   529,    -1,   955,    -1,   343,   955,    -1,   314,   955,
      -1,   148,    97,   396,   957,    -1,   148,   317,   957,    -1,
     153,   674,    -1,    98,   957,    -1,   119,   649,    -1,   198,
     957,    -1,   199,   242,   556,    -1,   308,   957,    -1,   345,
     957,    -1,   362,   649,    -1,    22,   344,   171,   308,   957,
      -1,    22,   315,   171,   308,   957,    -1,    22,   154,   171,
     308,   957,    -1,   672,    -1,   671,   431,   672,    -1,   968,
      -1,   159,   968,    -1,   393,   156,   250,    -1,    -1,   675,
      -1,   674,   431,   675,    -1,   964,   698,    -1,   156,   668,
     353,   969,   678,   679,    -1,   300,   668,   151,   969,   679,
     483,    -1,   300,    19,   250,   146,   668,   151,   969,   679,
     483,    -1,   393,    19,   250,    -1,    -1,   157,    49,   968,
      -1,    -1,    24,   104,   276,   681,   683,    -1,   681,   682,
      -1,    -1,   171,   308,   957,    -1,   146,   302,   969,    -1,
     146,   374,   969,    -1,   156,   667,   247,   684,   353,   671,
     673,    -1,   300,   667,   247,   684,   151,   671,   483,    -1,
     300,   156,   250,   146,   667,   247,   684,   151,   671,   483,
      -1,   344,    -1,   154,    -1,   315,    -1,   363,    -1,    84,
     686,   174,   687,   688,   247,   956,   689,   427,   690,   428,
     487,   543,   866,    -1,   368,    -1,    -1,    74,    -1,    -1,
     962,    -1,    -1,   375,   960,    -1,    -1,   691,    -1,   690,
     431,   691,    -1,   971,   692,   693,   694,   695,    -1,   898,
     692,   693,   694,   695,    -1,   427,   895,   428,   692,   693,
     694,   695,    -1,    67,   650,    -1,    -1,   650,    -1,   375,
     650,    -1,    -1,    33,    -1,   112,    -1,    -1,   411,    -1,
     412,    -1,    -1,    84,   697,   153,   964,   700,   299,   705,
     708,   712,    -1,    84,   697,   153,   964,   700,   299,   343,
     427,   714,   428,   708,   712,    -1,    84,   697,   153,   964,
     700,   708,   712,    -1,   252,   293,    -1,    -1,   427,   699,
     428,    -1,   427,   428,    -1,   702,    -1,   699,   431,   702,
      -1,   427,   701,   428,    -1,   427,   428,    -1,   707,    -1,
     701,   431,   707,    -1,   703,   704,   706,    -1,   704,   703,
     706,    -1,   704,   706,    -1,   703,   706,    -1,   706,    -1,
     171,    -1,   254,    -1,   181,    -1,   171,   254,    -1,   383,
      -1,   972,    -1,   706,    -1,   871,    -1,   972,   651,   422,
     362,    -1,   321,   972,   651,   422,   362,    -1,   702,    -1,
     702,   104,   895,    -1,   702,   414,   895,    -1,   710,    -1,
     708,   710,    -1,    51,   247,   238,   182,    -1,   299,   238,
     247,   238,   182,    -1,   337,    -1,   169,    -1,   329,    -1,
     388,    -1,   138,   312,   108,    -1,   138,   312,   191,    -1,
     312,   108,    -1,   312,   191,    -1,   204,    -1,   233,   204,
      -1,    83,   555,    -1,   305,   555,    -1,   472,    -1,    32,
     711,    -1,   198,   469,    -1,   392,    -1,   709,    -1,   967,
      -1,   967,   431,   967,    -1,   393,   621,    -1,    -1,   704,
     706,    -1,   713,    -1,   714,   431,   713,    -1,    24,   153,
     675,   716,   717,    -1,   709,    -1,   716,   709,    -1,   297,
      -1,    -1,   121,   153,   964,   698,   483,    -1,   121,   153,
     166,   135,   964,   698,   483,    -1,   121,    21,   964,   625,
     483,    -1,   121,    21,   166,   135,   964,   625,   483,    -1,
     121,   249,   722,   721,   483,    -1,   121,   249,   166,   135,
     722,   721,   483,    -1,   427,   871,   428,    -1,   427,   871,
     431,   871,   428,    -1,   427,   232,   431,   871,   428,    -1,
     427,   871,   431,   232,   428,    -1,   919,    -1,   971,   429,
     722,    -1,   117,   724,    -1,   725,    -1,   724,   725,    -1,
     967,    -1,   198,   469,    -1,    84,    55,   427,   871,    32,
     871,   428,   393,   153,   675,   727,    -1,    84,    55,   427,
     871,    32,   871,   428,   394,   153,   727,    -1,    84,    55,
     427,   871,    32,   871,   428,   393,   181,   727,    -1,    32,
     170,    -1,    32,    35,    -1,    -1,   121,    55,   729,   427,
     871,    32,   871,   428,   483,    -1,   166,   135,    -1,    -1,
     288,   731,   956,   732,    -1,   288,   342,   958,   732,    -1,
     288,    98,   958,   732,    -1,   174,    -1,   343,    -1,   147,
      -1,    -1,    24,    21,   964,   625,   291,   353,   958,    -1,
      24,    68,   650,   291,   353,   958,    -1,    24,    81,   650,
     291,   353,   958,    -1,    24,    98,   959,   291,   353,   959,
      -1,    24,   119,   650,   291,   353,   958,    -1,    24,   119,
     650,   291,    77,   958,   353,   958,    -1,    24,   148,    97,
     396,   958,   291,   353,   958,    -1,    24,   153,   675,   291,
     353,   958,    -1,    24,   159,   968,   291,   353,   968,    -1,
      24,   564,   198,   958,   291,   353,   958,    -1,    24,   249,
      63,   650,   375,   960,   291,   353,   958,    -1,    24,   249,
     141,   650,   375,   960,   291,   353,   958,    -1,    24,   308,
     958,   291,   353,   958,    -1,    24,   317,   958,   291,   353,
     958,    -1,    24,   343,   862,   291,   353,   958,    -1,    24,
     343,   166,   135,   862,   291,   353,   958,    -1,    24,   314,
     956,   291,   353,   958,    -1,    24,   314,   166,   135,   956,
     291,   353,   958,    -1,    24,   387,   956,   291,   353,   958,
      -1,    24,   387,   166,   135,   956,   291,   353,   958,    -1,
      24,   174,   956,   291,   353,   958,    -1,    24,   174,   166,
     135,   956,   291,   353,   958,    -1,    24,   148,   343,   862,
     291,   353,   958,    -1,    24,   148,   343,   166,   135,   862,
     291,   353,   958,    -1,    24,   343,   862,   291,   734,   958,
     353,   958,    -1,    24,   343,   166,   135,   862,   291,   734,
     958,   353,   958,    -1,    24,   343,   862,   291,    77,   958,
     353,   958,    -1,    24,   148,   343,   862,   291,   734,   958,
     353,   958,    -1,    24,   148,   343,   166,   135,   862,   291,
     734,   958,   353,   958,    -1,    24,   357,   958,   247,   956,
     291,   353,   958,    -1,    24,   302,   968,   291,   353,   968,
      -1,    24,   374,   968,   291,   353,   968,    -1,    24,   345,
     958,   291,   353,   958,    -1,    24,   345,   958,   320,   486,
      -1,    24,   345,   958,   295,   486,    -1,    24,   349,   310,
     261,   650,   291,   353,   958,    -1,    24,   349,   310,   113,
     650,   291,   353,   958,    -1,    24,   349,   310,   347,   650,
     291,   353,   958,    -1,    24,   349,   310,    75,   650,   291,
     353,   958,    -1,    24,   362,   650,   291,   353,   958,    -1,
      24,   362,   650,   291,    38,   958,   353,   958,   483,    -1,
      69,    -1,    -1,   320,    97,    -1,    -1,    24,    21,   964,
     625,   320,   308,   958,    -1,    24,    68,   650,   320,   308,
     958,    -1,    24,    81,   650,   320,   308,   958,    -1,    24,
     119,   650,   320,   308,   958,    -1,    24,   137,   650,   320,
     308,   958,    -1,    24,   153,   675,   320,   308,   958,    -1,
      24,   249,   722,   721,   320,   308,   958,    -1,    24,   249,
      63,   650,   375,   960,   320,   308,   958,    -1,    24,   249,
     141,   650,   375,   960,   320,   308,   958,    -1,    24,   343,
     862,   320,   308,   958,    -1,    24,   343,   166,   135,   862,
     320,   308,   958,    -1,    24,   349,   310,   261,   650,   320,
     308,   958,    -1,    24,   349,   310,   113,   650,   320,   308,
     958,    -1,    24,   349,   310,   347,   650,   320,   308,   958,
      -1,    24,   349,   310,    75,   650,   320,   308,   958,    -1,
      24,   314,   956,   320,   308,   958,    -1,    24,   314,   166,
     135,   956,   320,   308,   958,    -1,    24,   387,   956,   320,
     308,   958,    -1,    24,   387,   166,   135,   956,   320,   308,
     958,    -1,    24,   148,   343,   862,   320,   308,   958,    -1,
      24,   148,   343,   166,   135,   862,   320,   308,   958,    -1,
      24,   362,   650,   320,   308,   958,    -1,    24,    21,   964,
     625,   260,   353,   968,    -1,    24,    68,   650,   260,   353,
     968,    -1,    24,    81,   650,   260,   353,   968,    -1,    24,
      98,   959,   260,   353,   968,    -1,    24,   119,   650,   260,
     353,   968,    -1,    24,   153,   675,   260,   353,   968,    -1,
      24,   564,   198,   958,   260,   353,   968,    -1,    24,   199,
     242,   555,   260,   353,   968,    -1,    24,   249,   722,   721,
     260,   353,   968,    -1,    24,   249,    63,   650,   375,   960,
     260,   353,   968,    -1,    24,   249,   141,   650,   375,   960,
     260,   353,   968,    -1,    24,   308,   958,   260,   353,   968,
      -1,    24,   362,   650,   260,   353,   968,    -1,    24,   345,
     958,   260,   353,   968,    -1,    24,   349,   310,   113,   650,
     260,   353,   968,    -1,    24,   349,   310,    75,   650,   260,
     353,   968,    -1,    24,   148,    97,   396,   958,   260,   353,
     968,    -1,    24,   317,   958,   260,   353,   968,    -1,    84,
     697,   306,   958,    32,   247,   743,   353,   956,   866,   117,
     744,   739,    -1,   234,    -1,   741,    -1,   427,   740,   428,
      -1,   740,   430,   742,    -1,   742,    -1,   818,    -1,   796,
      -1,   807,    -1,   801,    -1,   746,    -1,   741,    -1,    -1,
     313,    -1,   373,    -1,   109,    -1,   184,    -1,   185,    -1,
      23,    -1,    -1,   121,   306,   958,   247,   650,   483,    -1,
     121,   306,   166,   135,   958,   247,   650,   483,    -1,   235,
     971,   747,    -1,   431,   967,    -1,    -1,   210,   971,    -1,
     370,   971,    -1,   370,   420,    -1,    14,   751,    -1,    42,
     751,   754,    -1,   331,   355,   754,    -1,    72,   751,    -1,
     127,   751,    -1,   303,   751,    -1,   307,   971,    -1,   290,
     307,   971,    -1,   290,   971,    -1,   303,   751,   353,   307,
     971,    -1,   303,   751,   353,   971,    -1,   272,   355,   967,
      -1,    72,   273,   967,    -1,   303,   273,   967,    -1,   395,
      -1,   355,    -1,    -1,   194,   207,   465,    -1,   281,   248,
      -1,   281,   397,    -1,   106,    -1,   233,   106,    -1,   752,
      -1,   753,   431,   752,    -1,   753,   752,    -1,   753,    -1,
      -1,    84,   510,   387,   956,   529,   487,    32,   818,   756,
      -1,    84,   252,   293,   510,   387,   956,   529,   487,    32,
     818,   756,    -1,   393,    61,   250,    -1,   393,    53,    61,
     250,    -1,   393,   212,    61,   250,    -1,    -1,   211,   963,
      -1,    84,    98,   959,   438,   759,    -1,   759,   760,    -1,
      -1,   345,   761,   958,    -1,   345,   761,   104,    -1,   215,
     761,   967,    -1,   215,   761,   104,    -1,   347,   761,   958,
      -1,   347,   761,   104,    -1,   125,   761,   967,    -1,   125,
     761,   966,    -1,   125,   761,   104,    -1,   201,   761,   967,
      -1,   201,   761,   104,    -1,   202,   761,   967,    -1,   202,
     761,   104,    -1,    76,   209,   761,   970,    -1,   260,   761,
     958,    -1,   260,   761,   104,    -1,   414,    -1,    -1,    24,
      98,   959,   438,   764,    -1,    24,    98,   959,   320,   345,
     958,    -1,    24,    98,   959,   471,    -1,   764,   765,    -1,
      -1,    76,   209,   761,   970,    -1,   121,    98,   959,    -1,
     121,    98,   166,   135,   959,    -1,    84,   119,   650,   769,
     871,   519,    -1,    24,   119,   650,   482,    -1,    24,   119,
     650,   121,   233,   238,    -1,    24,   119,   650,   320,   233,
     238,    -1,    24,   119,   650,    18,   526,    -1,    24,   119,
     650,   121,    77,   958,   483,    -1,    24,   119,   650,   121,
      77,   166,   135,   958,   483,    -1,    24,   119,   650,   378,
      77,   958,    -1,    32,    -1,    -1,    24,   349,   310,   113,
     650,   621,    -1,    24,   349,   310,    75,   650,    18,   217,
     146,   957,   393,   649,    -1,    24,   349,   310,    75,   650,
      24,   217,   146,   957,   393,   649,    -1,    24,   349,   310,
      75,   650,    24,   217,   293,   650,   393,   650,    -1,    24,
     349,   310,    75,   650,    24,   217,   146,   957,   293,   650,
     393,   650,    -1,    24,   349,   310,    75,   650,   121,   217,
     146,   957,    -1,    24,   349,   310,    75,   650,   121,   217,
     166,   135,   146,   957,    -1,    84,   635,    81,   650,   146,
     967,   353,   967,   151,   650,    -1,    65,   780,   956,   774,
      -1,    65,   780,    -1,    65,   780,   962,   247,   956,    -1,
     375,   962,    -1,    -1,   376,   781,   782,   780,    -1,   376,
     781,   782,   780,   956,    -1,   376,   781,   782,   780,   778,
      -1,   376,   427,   776,   428,    -1,   376,   427,   776,   428,
     956,   783,    -1,   777,    -1,   776,   431,   777,    -1,   779,
      -1,   385,    -1,   150,    -1,   152,    -1,   779,   780,    -1,
     779,   780,   956,   783,    -1,    27,    -1,    26,    -1,   385,
      -1,    -1,   152,    -1,    -1,   150,    -1,    -1,   427,   957,
     428,    -1,    -1,   136,   785,    -1,   136,   779,   780,   785,
      -1,   136,   385,   785,    -1,   136,   427,   786,   428,   785,
      -1,   818,    -1,   796,    -1,   807,    -1,   801,    -1,   814,
      -1,   546,    -1,   793,    -1,   787,    -1,   786,   431,   787,
      -1,   788,   789,    -1,   973,    -1,   779,    -1,   466,    -1,
     555,    -1,    -1,   272,   958,   791,    32,   792,    -1,   427,
     927,   428,    -1,    -1,   818,    -1,   796,    -1,   807,    -1,
     801,    -1,   134,   958,   794,    -1,    84,   510,   343,   547,
      32,   134,   958,   794,   548,    -1,   427,   924,   428,    -1,
      -1,   100,   958,    -1,   100,   272,   958,    -1,   100,    22,
      -1,   100,   272,    22,    -1,   826,   184,   190,   956,   797,
     800,    -1,   818,    -1,   427,   798,   428,   818,    -1,   104,
     381,    -1,   799,    -1,   798,   431,   799,    -1,   971,   948,
      -1,   298,   953,    -1,    -1,   826,   109,   151,   864,   802,
     867,   800,    -1,   375,   855,    -1,    -1,   216,   829,   863,
     804,   806,    -1,   171,   805,   222,    -1,    -1,    16,   322,
      -1,   304,   322,    -1,   304,   133,    -1,    30,   322,    -1,
      30,   133,    -1,   322,   373,   133,    -1,   322,    -1,   322,
     304,   133,    -1,   133,    -1,    16,   133,    -1,   237,    -1,
      -1,   826,   373,   864,   320,   808,   854,   867,   800,    -1,
     809,    -1,   808,   431,   809,    -1,   810,    -1,   811,    -1,
     812,   414,   950,    -1,   427,   813,   428,   414,   952,    -1,
     971,   948,    -1,   812,    -1,   813,   431,   812,    -1,   103,
     815,   816,    95,   817,   146,   818,    -1,   958,    -1,    -1,
     816,   231,   309,    -1,   816,   309,    -1,   816,    45,    -1,
     816,   183,    -1,    -1,   393,   163,    -1,   394,   163,    -1,
     820,    -1,   819,    -1,   427,   820,   428,    -1,   427,   819,
     428,    -1,   822,    -1,   821,   833,    -1,   821,   832,   848,
     837,    -1,   821,   832,   836,   849,    -1,   823,   821,    -1,
     823,   821,   833,    -1,   823,   821,   832,   848,   837,    -1,
     823,   821,   832,   836,   849,    -1,   822,    -1,   819,    -1,
     313,   831,   953,   827,   854,   866,   846,   847,   907,    -1,
     853,    -1,   343,   862,    -1,   821,   367,   830,   821,    -1,
     821,   188,   830,   821,    -1,   821,   130,   830,   821,    -1,
     393,   824,    -1,   393,   285,   824,    -1,   825,    -1,   824,
     431,   825,    -1,   958,   783,    32,   427,   792,   428,    -1,
     823,    -1,    -1,   190,   828,    -1,    -1,   348,   829,   956,
      -1,   346,   829,   956,    -1,   212,   348,   829,   956,    -1,
     212,   346,   829,   956,    -1,   155,   348,   829,   956,    -1,
     155,   346,   829,   956,    -1,   371,   829,   956,    -1,   343,
     956,    -1,   956,    -1,   343,    -1,    -1,    22,    -1,   116,
      -1,    -1,   116,    -1,   116,   247,   427,   924,   428,    -1,
      22,    -1,    -1,   833,    -1,    -1,   253,    49,   834,    -1,
     835,    -1,   834,   431,   835,    -1,   895,   375,   922,   695,
      -1,   895,   694,   695,    -1,   838,   839,    -1,   839,   838,
      -1,   838,    -1,   839,    -1,   836,    -1,    -1,   209,   840,
      -1,   209,   840,   431,   841,    -1,   142,   845,   842,   844,
     248,    -1,   245,   841,    -1,   245,   843,   844,    -1,   895,
      -1,    22,    -1,   895,    -1,   970,    -1,   427,   895,   428,
      -1,    -1,   897,    -1,   304,    -1,   305,    -1,   143,    -1,
     230,    -1,   159,    49,   924,    -1,    -1,   161,   895,    -1,
      -1,   850,    -1,   146,   281,   248,    -1,   848,    -1,    -1,
     851,    -1,   850,   851,    -1,   146,   373,   852,   806,    -1,
     146,   322,   852,   806,    -1,   243,   955,    -1,    -1,   381,
     952,    -1,   853,   431,   952,    -1,   151,   855,    -1,    -1,
     856,    -1,   855,   431,   856,    -1,   862,    -1,   862,   858,
      -1,   865,    -1,   865,   858,    -1,   865,    32,   427,   869,
     428,    -1,   865,    32,   971,   427,   869,   428,    -1,   865,
     971,   427,   869,   428,    -1,   819,    -1,   819,   858,    -1,
     857,    -1,   427,   857,   428,   858,    -1,   427,   857,   428,
      -1,   856,    85,   195,   856,    -1,   856,   859,   195,   856,
     861,    -1,   856,   195,   856,   861,    -1,   856,   228,   859,
     195,   856,    -1,   856,   228,   195,   856,    -1,    32,   971,
     427,   957,   428,    -1,    32,   971,    -1,   971,   427,   957,
     428,    -1,   971,    -1,   152,   860,    -1,   206,   860,    -1,
     301,   860,    -1,   180,    -1,   255,    -1,    -1,   375,   427,
     957,   428,    -1,   247,   895,    -1,   956,    -1,   956,   420,
      -1,   248,   956,    -1,   248,   427,   956,   428,    -1,   862,
      -1,   863,   431,   862,    -1,   862,    -1,   862,   971,    -1,
     862,    32,   971,    -1,   898,    -1,   390,   895,    -1,    -1,
     390,   895,    -1,   390,    87,   243,   815,    -1,    -1,   869,
      -1,    -1,   870,    -1,   869,   431,   870,    -1,   971,   871,
     484,    -1,   873,   872,    -1,   321,   873,   872,    -1,   873,
      31,   425,   966,   426,    -1,   321,   873,    31,   425,   966,
     426,    -1,   873,    31,    -1,   321,   873,    31,    -1,   872,
     425,   426,    -1,   872,   425,   966,   426,    -1,    -1,   875,
      -1,   877,    -1,   879,    -1,   883,    -1,   890,    -1,   891,
     893,    -1,   891,   427,   966,   428,   893,    -1,   877,    -1,
     880,    -1,   884,    -1,   890,    -1,   972,   876,    -1,   972,
     651,   876,    -1,   427,   924,   428,    -1,    -1,   186,    -1,
     187,    -1,   326,    -1,    44,    -1,   282,    -1,   144,   878,
      -1,   120,   270,    -1,   102,   876,    -1,   101,   876,    -1,
     241,   876,    -1,    47,    -1,   427,   966,   428,    -1,    -1,
     881,    -1,   882,    -1,   881,    -1,   882,    -1,    46,   888,
     427,   924,   428,    -1,    46,   888,    -1,   885,    -1,   886,
      -1,   885,    -1,   886,    -1,   887,   427,   966,   428,   889,
      -1,   887,   889,    -1,    59,   888,    -1,    58,   888,    -1,
     382,    -1,   227,    59,   888,    -1,   227,    58,   888,    -1,
     229,   888,    -1,   384,    -1,    -1,    59,   320,   971,    -1,
      -1,   352,   427,   966,   428,   892,    -1,   352,   892,    -1,
     351,   427,   966,   428,   892,    -1,   351,   892,    -1,   189,
      -1,   413,   410,    -1,   394,   351,   410,    -1,    -1,   408,
      -1,   223,    -1,    99,    -1,   164,    -1,   220,    -1,   894,
      -1,   408,   353,   223,    -1,    99,   353,   164,    -1,    99,
     353,   220,    -1,    99,   353,   894,    -1,   164,   353,   220,
      -1,   164,   353,   894,    -1,   220,   353,   894,    -1,    -1,
     311,    -1,   311,   427,   966,   428,    -1,   897,    -1,   895,
      11,   871,    -1,   895,    67,   650,    -1,   895,    37,   351,
     410,   895,    -1,   418,   895,    -1,   419,   895,    -1,   895,
     418,   895,    -1,   895,   419,   895,    -1,   895,   420,   895,
      -1,   895,   421,   895,    -1,   895,   422,   895,    -1,   895,
     423,   895,    -1,   895,   415,   895,    -1,   895,   416,   895,
      -1,   895,   414,   895,    -1,   895,   921,   895,    -1,   921,
     895,    -1,   895,   921,    -1,   895,    28,   895,    -1,   895,
     252,   895,    -1,   233,   895,    -1,   895,   208,   895,    -1,
     895,   208,   895,   129,   895,    -1,   895,   233,   208,   895,
      -1,   895,   233,   208,   895,   129,   895,    -1,   895,   167,
     895,    -1,   895,   167,   895,   129,   895,    -1,   895,   233,
     167,   895,    -1,   895,   233,   167,   895,   129,   895,    -1,
     895,   324,   353,   895,    -1,   895,   324,   353,   895,   129,
     895,    -1,   895,   233,   324,   353,   895,    -1,   895,   233,
     324,   353,   895,   129,   895,    -1,   895,   192,   238,    -1,
     895,   193,    -1,   895,   192,   233,   238,    -1,   895,   236,
      -1,   917,   257,   917,    -1,   895,   192,   359,    -1,   895,
     192,   233,   359,    -1,   895,   192,   140,    -1,   895,   192,
     233,   140,    -1,   895,   192,   369,    -1,   895,   192,   233,
     369,    -1,   895,   192,   116,   151,   895,    -1,   895,   192,
     233,   116,   151,   895,    -1,   895,   192,   243,   427,   927,
     428,    -1,   895,   192,   233,   243,   427,   927,   428,    -1,
     895,    43,   949,   896,    28,   896,    -1,   895,   233,    43,
     949,   896,    28,   896,    -1,   895,    43,   340,   896,    28,
     896,    -1,   895,   233,    43,   340,   896,    28,   896,    -1,
     895,   171,   939,    -1,   895,   233,   171,   939,    -1,   895,
     923,   918,   819,    -1,   895,   923,   918,   427,   895,   428,
      -1,   368,   819,    -1,   895,   192,   118,    -1,   895,   192,
     233,   118,    -1,   897,    -1,   896,    11,   871,    -1,   418,
     896,    -1,   419,   896,    -1,   896,   418,   896,    -1,   896,
     419,   896,    -1,   896,   420,   896,    -1,   896,   421,   896,
      -1,   896,   422,   896,    -1,   896,   423,   896,    -1,   896,
     415,   896,    -1,   896,   416,   896,    -1,   896,   414,   896,
      -1,   896,   921,   896,    -1,   921,   896,    -1,   896,   921,
      -1,   896,   192,   116,   151,   896,    -1,   896,   192,   233,
     116,   151,   896,    -1,   896,   192,   243,   427,   927,   428,
      -1,   896,   192,   233,   243,   427,   927,   428,    -1,   896,
     192,   118,    -1,   896,   192,   233,   118,    -1,   945,    -1,
     965,    -1,    10,   948,    -1,   427,   895,   428,   948,    -1,
     940,    -1,   898,    -1,   819,    -1,   819,   947,    -1,   135,
     819,    -1,    31,   819,    -1,    31,   928,    -1,   917,    -1,
     964,   427,   428,   910,    -1,   964,   427,   925,   428,   910,
      -1,   964,   427,   383,   926,   428,   910,    -1,   964,   427,
     925,   431,   383,   926,   428,   910,    -1,   964,   427,   925,
     833,   428,   910,    -1,   964,   427,    22,   925,   832,   428,
     910,    -1,   964,   427,   116,   925,   832,   428,   910,    -1,
     964,   427,   420,   428,   910,    -1,    68,   146,   427,   895,
     428,    -1,    89,    -1,    92,    -1,    92,   427,   966,   428,
      -1,    93,    -1,    93,   427,   966,   428,    -1,   213,    -1,
     213,   427,   966,   428,    -1,   214,    -1,   214,   427,   966,
     428,    -1,    90,    -1,    94,    -1,   319,    -1,   374,    -1,
      88,    -1,    91,    -1,    55,   427,   895,    32,   871,   428,
      -1,   139,   427,   930,   428,    -1,   258,   427,   932,   428,
      -1,   268,   427,   934,   428,    -1,   339,   427,   935,   428,
      -1,   356,   427,   895,    32,   871,   428,    -1,   358,   427,
      48,   938,   428,    -1,   358,   427,   203,   938,   428,    -1,
     358,   427,   354,   938,   428,    -1,   358,   427,   938,   428,
      -1,   239,   427,   895,   431,   895,   428,    -1,    66,   427,
     924,   428,    -1,   158,   427,   924,   428,    -1,   205,   427,
     924,   428,    -1,   400,   427,   924,   428,    -1,   401,   427,
     225,   974,   428,    -1,   401,   427,   225,   974,   431,   901,
     428,    -1,   401,   427,   225,   974,   431,   924,   428,    -1,
     401,   427,   225,   974,   431,   901,   431,   924,   428,    -1,
     402,   427,   897,   906,   428,    -1,   403,   427,   902,   428,
      -1,   404,   427,   904,   895,   905,   428,    -1,   405,   427,
     225,   974,   428,    -1,   405,   427,   225,   974,   431,   895,
     428,    -1,   406,   427,   895,   431,   899,   900,   428,    -1,
     407,   427,   904,   895,    32,   873,   428,    -1,   386,   895,
      -1,   386,   231,   380,    -1,   431,   330,   409,    -1,   431,
     330,   231,    -1,   431,   330,   231,   380,    -1,    -1,   399,
     427,   902,   428,    -1,   903,    -1,   902,   431,   903,    -1,
     895,    32,   974,    -1,   895,    -1,   118,    -1,    79,    -1,
     271,   391,    -1,   338,   391,    -1,    -1,   264,   897,    -1,
     264,   897,    49,   286,    -1,   264,    49,   286,   897,    -1,
     264,    49,   286,   897,    49,   286,    -1,   392,   908,    -1,
      -1,   909,    -1,   908,   431,   909,    -1,   971,    32,   911,
      -1,   256,   911,    -1,   256,   971,    -1,    -1,   427,   912,
     913,   832,   914,   428,    -1,   971,    -1,    -1,   263,    49,
     924,    -1,    -1,   280,   915,    -1,   305,   915,    -1,    -1,
     916,    -1,    43,   916,    28,   916,    -1,   364,   269,    -1,
     364,   145,    -1,    87,   304,    -1,   895,   269,    -1,   895,
     145,    -1,   304,   427,   924,   428,    -1,   304,   427,   428,
      -1,   427,   924,   431,   895,   428,    -1,    29,    -1,   328,
      -1,    22,    -1,     8,    -1,   920,    -1,   418,    -1,   419,
      -1,   420,    -1,   421,    -1,   422,    -1,   423,    -1,   415,
      -1,   416,    -1,   414,    -1,     8,    -1,   249,   427,   722,
     428,    -1,   919,    -1,   249,   427,   722,   428,    -1,   919,
      -1,   249,   427,   722,   428,    -1,   208,    -1,   233,   208,
      -1,   167,    -1,   233,   167,    -1,   895,    -1,   924,   431,
     895,    -1,   926,    -1,   925,   431,   926,    -1,   895,    -1,
     704,    13,   895,    -1,   871,    -1,   927,   431,   871,    -1,
     425,   924,   426,    -1,   425,   929,   426,    -1,   425,   426,
      -1,   928,    -1,   929,   431,   928,    -1,   931,   151,   895,
      -1,    -1,     3,    -1,   408,    -1,   223,    -1,    99,    -1,
     164,    -1,   220,    -1,   311,    -1,   967,    -1,   895,   933,
     936,   937,    -1,   895,   933,   936,    -1,   266,   895,    -1,
     896,   171,   896,    -1,    -1,   895,   936,   937,    -1,   895,
     937,   936,    -1,   895,   936,    -1,   895,   937,    -1,   924,
      -1,    -1,   151,   895,    -1,   146,   895,    -1,   895,   151,
     924,    -1,   151,   924,    -1,   924,    -1,   819,    -1,   427,
     924,   428,    -1,    54,   944,   941,   943,   127,    -1,   942,
      -1,   941,   942,    -1,   389,   895,   350,   895,    -1,   123,
     895,    -1,    -1,   895,    -1,    -1,   971,    -1,   971,   947,
      -1,   429,   961,    -1,   429,   420,    -1,   425,   895,   426,
      -1,   425,   895,   432,   895,   426,    -1,   946,    -1,   947,
     946,    -1,    -1,   948,   946,    -1,    36,    -1,    -1,   895,
      -1,   104,    -1,   950,    -1,   951,   431,   950,    -1,   427,
     951,   428,    -1,   954,    -1,   953,   431,   954,    -1,   895,
      32,   974,    -1,   895,     3,    -1,   895,    -1,   420,    -1,
     956,    -1,   955,   431,   956,    -1,   971,    -1,   971,   947,
      -1,   958,    -1,   957,   431,   958,    -1,   971,    -1,   971,
      -1,   971,    -1,   974,    -1,   971,    -1,   967,    -1,   972,
      -1,   971,   947,    -1,   966,    -1,     4,    -1,   967,    -1,
       6,    -1,     7,    -1,   964,   967,    -1,   964,   427,   925,
     428,   967,    -1,   874,   967,    -1,   891,   967,   893,    -1,
     891,   427,   966,   428,   967,   893,    -1,   359,    -1,   140,
      -1,   238,    -1,     9,    -1,     5,    -1,   973,    -1,   968,
      -1,   969,   431,   968,    -1,   966,    -1,   418,   966,    -1,
     419,   966,    -1,     3,    -1,   975,    -1,   976,    -1,     3,
      -1,   975,    -1,   977,    -1,     3,    -1,   975,    -1,   976,
      -1,   977,    -1,     3,    -1,   975,    -1,   976,    -1,   977,
      -1,   978,    -1,    14,    -1,    15,    -1,    16,    -1,    17,
      -1,    18,    -1,    19,    -1,    20,    -1,    21,    -1,    23,
      -1,    24,    -1,    25,    -1,    30,    -1,    34,    -1,    35,
      -1,    37,    -1,    38,    -1,    40,    -1,    41,    -1,    42,
      -1,    49,    -1,    50,    -1,    51,    -1,    52,    -1,    53,
      -1,    56,    -1,    57,    -1,    60,    -1,    62,    -1,    63,
      -1,    64,    -1,    65,    -1,    70,    -1,    71,    -1,    72,
      -1,    73,    -1,    75,    -1,    76,    -1,    78,    -1,    79,
      -1,    80,    -1,    81,    -1,    82,    -1,    83,    -1,    86,
      -1,    87,    -1,    95,    -1,    96,    -1,    97,    -1,    98,
      -1,    99,    -1,   100,    -1,   103,    -1,   105,    -1,   107,
      -1,   108,    -1,   109,    -1,   110,    -1,   111,    -1,   113,
      -1,   114,    -1,   115,    -1,   118,    -1,   119,    -1,   120,
      -1,   121,    -1,   122,    -1,   124,    -1,   125,    -1,   126,
      -1,   128,    -1,   129,    -1,   131,    -1,   132,    -1,   133,
      -1,   134,    -1,   136,    -1,   137,    -1,   138,    -1,   141,
      -1,   143,    -1,   145,    -1,   147,    -1,   149,    -1,   153,
      -1,   154,    -1,   155,    -1,   157,    -1,   160,    -1,   162,
      -1,   163,    -1,   164,    -1,   165,    -1,   166,    -1,   168,
      -1,   169,    -1,   170,    -1,   172,    -1,   173,    -1,   174,
      -1,   175,    -1,   176,    -1,   177,    -1,   179,    -1,   182,
      -1,   183,    -1,   184,    -1,   185,    -1,   191,    -1,   194,
      -1,   196,    -1,   197,    -1,   198,    -1,   199,    -1,   200,
      -1,   201,    -1,   202,    -1,   204,    -1,   207,    -1,   210,
      -1,   211,    -1,   212,    -1,   215,    -1,   216,    -1,   217,
      -1,   218,    -1,   219,    -1,   220,    -1,   221,    -1,   222,
      -1,   223,    -1,   224,    -1,   225,    -1,   226,    -1,   230,
      -1,   231,    -1,   234,    -1,   235,    -1,   237,    -1,   240,
      -1,   242,    -1,   243,    -1,   244,    -1,   246,    -1,   249,
      -1,   250,    -1,   251,    -1,   259,    -1,   260,    -1,   261,
      -1,   262,    -1,   263,    -1,   264,    -1,   265,    -1,   267,
      -1,   269,    -1,   272,    -1,   273,    -1,   271,    -1,   275,
      -1,   276,    -1,   277,    -1,   278,    -1,   279,    -1,   280,
      -1,   281,    -1,   283,    -1,   284,    -1,   285,    -1,   286,
      -1,   288,    -1,   289,    -1,   290,    -1,   291,    -1,   292,
      -1,   293,    -1,   294,    -1,   295,    -1,   296,    -1,   297,
      -1,   299,    -1,   300,    -1,   302,    -1,   303,    -1,   305,
      -1,   306,    -1,   307,    -1,   308,    -1,   309,    -1,   310,
      -1,   311,    -1,   312,    -1,   314,    -1,   315,    -1,   316,
      -1,   317,    -1,   318,    -1,   320,    -1,   322,    -1,   323,
      -1,   325,    -1,   327,    -1,   329,    -1,   330,    -1,   331,
      -1,   332,    -1,   333,    -1,   334,    -1,   335,    -1,   336,
      -1,   337,    -1,   338,    -1,   341,    -1,   342,    -1,   344,
      -1,   345,    -1,   346,    -1,   347,    -1,   348,    -1,   349,
      -1,   355,    -1,   357,    -1,   360,    -1,   361,    -1,   362,
      -1,   363,    -1,   364,    -1,   365,    -1,   366,    -1,   369,
      -1,   370,    -1,   371,    -1,   372,    -1,   373,    -1,   376,
      -1,   377,    -1,   378,    -1,   379,    -1,   380,    -1,   384,
      -1,   386,    -1,   387,    -1,   388,    -1,   391,    -1,   394,
      -1,   395,    -1,   396,    -1,   397,    -1,   398,    -1,   408,
      -1,   409,    -1,   410,    -1,    43,    -1,    44,    -1,    46,
      -1,    47,    -1,    58,    -1,    59,    -1,    66,    -1,   101,
      -1,   102,    -1,   135,    -1,   139,    -1,   144,    -1,   158,
      -1,   181,    -1,   186,    -1,   187,    -1,   189,    -1,   205,
      -1,   227,    -1,   229,    -1,   232,    -1,   239,    -1,   241,
      -1,   254,    -1,   258,    -1,   268,    -1,   270,    -1,   282,
      -1,   304,    -1,   321,    -1,   326,    -1,   339,    -1,   351,
      -1,   352,    -1,   356,    -1,   358,    -1,   381,    -1,   382,
      -1,   399,    -1,   400,    -1,   401,    -1,   402,    -1,   403,
      -1,   404,    -1,   405,    -1,   406,    -1,   407,    -1,    39,
      -1,    45,    -1,    68,    -1,    74,    -1,    85,    -1,    91,
      -1,   150,    -1,   152,    -1,   167,    -1,   180,    -1,   192,
      -1,   193,    -1,   195,    -1,   206,    -1,   208,    -1,   228,
      -1,   236,    -1,   255,    -1,   256,    -1,   257,    -1,   301,
      -1,   324,    -1,   385,    -1,    22,    -1,    26,    -1,    27,
      -1,    28,    -1,    29,    -1,    31,    -1,    32,    -1,    33,
      -1,    36,    -1,    48,    -1,    54,    -1,    55,    -1,    61,
      -1,    67,    -1,    69,    -1,    77,    -1,    84,    -1,    88,
      -1,    89,    -1,    90,    -1,    92,    -1,    93,    -1,    94,
      -1,   104,    -1,   106,    -1,   112,    -1,   116,    -1,   117,
      -1,   123,    -1,   127,    -1,   130,    -1,   140,    -1,   142,
      -1,   146,    -1,   148,    -1,   151,    -1,   156,    -1,   159,
      -1,   161,    -1,   171,    -1,   178,    -1,   188,    -1,   190,
      -1,   203,    -1,   209,    -1,   213,    -1,   214,    -1,   233,
      -1,   238,    -1,   245,    -1,   247,    -1,   248,    -1,   252,
      -1,   253,    -1,   266,    -1,   274,    -1,   287,    -1,   298,
      -1,   313,    -1,   319,    -1,   328,    -1,   340,    -1,   343,
      -1,   350,    -1,   353,    -1,   354,    -1,   359,    -1,   367,
      -1,   368,    -1,   374,    -1,   375,    -1,   383,    -1,   389,
      -1,   390,    -1,   392,    -1,   393,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   653,   653,   660,   667,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,   747,   748,   749,   750,   751,
     752,   753,   754,   755,   756,   757,   758,   759,   760,   761,
     762,   763,   764,   765,   766,   767,   768,   769,   770,   771,
     772,   773,   774,   775,   776,   777,   778,   779,   780,   781,
     782,   783,   784,   785,   786,   788,   798,   809,   810,   819,
     820,   824,   825,   829,   834,   838,   843,   848,   852,   856,
     861,   865,   919,   921,   925,   929,   933,   937,   951,   969,
     980,   981,   985,  1003,  1015,  1036,  1043,  1062,  1069,  1086,
    1104,  1115,  1116,  1128,  1135,  1152,  1164,  1176,  1177,  1181,
    1182,  1190,  1191,  1192,  1193,  1194,  1195,  1209,  1215,  1221,
    1230,  1238,  1246,  1250,  1258,  1266,  1273,  1280,  1288,  1299,
    1307,  1315,  1326,  1334,  1342,  1349,  1358,  1368,  1369,  1376,
    1377,  1380,  1382,  1386,  1387,  1388,  1389,  1393,  1394,  1395,
    1401,  1413,  1417,  1421,  1436,  1459,  1460,  1461,  1465,  1466,
    1467,  1471,  1472,  1476,  1483,  1490,  1497,  1504,  1514,  1515,
    1520,  1521,  1526,  1532,  1538,  1544,  1550,  1560,  1570,  1571,
    1575,  1576,  1584,  1599,  1605,  1611,  1617,  1635,  1644,  1653,
    1662,  1671,  1680,  1689,  1698,  1710,  1711,  1716,  1724,  1732,
    1741,  1749,  1757,  1766,  1775,  1784,  1793,  1803,  1816,  1830,
    1839,  1847,  1855,  1865,  1875,  1882,  1889,  1897,  1905,  1913,
    1921,  1929,  1936,  1943,  1951,  1958,  1965,  1973,  1981,  1989,
    1997,  2005,  2013,  2023,  2030,  2038,  2046,  2054,  2061,  2071,
    2072,  2076,  2077,  2078,  2082,  2090,  2094,  2095,  2099,  2102,
    2103,  2107,  2108,  2113,  2117,  2121,  2126,  2141,  2154,  2155,
    2160,  2169,  2179,  2189,  2214,  2220,  2247,  2269,  2283,  2284,
    2293,  2294,  2295,  2298,  2299,  2304,  2305,  2309,  2313,  2317,
    2321,  2325,  2329,  2333,  2337,  2341,  2345,  2349,  2353,  2362,
    2366,  2370,  2374,  2378,  2382,  2386,  2387,  2392,  2396,  2403,
    2410,  2411,  2412,  2413,  2414,  2418,  2422,  2430,  2441,  2456,
    2472,  2488,  2517,  2518,  2519,  2520,  2521,  2528,  2535,  2536,
    2540,  2541,  2545,  2546,  2550,  2554,  2561,  2565,  2572,  2573,
    2574,  2578,  2579,  2582,  2602,  2622,  2623,  2627,  2635,  2636,
    2637,  2668,  2675,  2682,  2693,  2704,  2714,  2723,  2756,  2763,
    2770,  2777,  2788,  2798,  2799,  2800,  2804,  2805,  2806,  2807,
    2808,  2809,  2818,  2826,  2830,  2843,  2858,  2872,  2887,  2901,
    2919,  2940,  2941,  2945,  2946,  2950,  2951,  2954,  2960,  2964,
    2972,  2977,  2983,  2984,  2988,  2993,  3000,  3001,  3011,  3013,
    3015,  3017,  3020,  3023,  3026,  3030,  3031,  3032,  3033,  3034,
    3037,  3038,  3043,  3044,  3045,  3046,  3049,  3050,  3051,  3052,
    3055,  3056,  3059,  3060,  3063,  3078,  3092,  3105,  3106,  3107,
    3120,  3132,  3140,  3151,  3152,  3155,  3156,  3159,  3163,  3167,
    3171,  3175,  3179,  3183,  3187,  3191,  3195,  3199,  3203,  3209,
    3210,  3214,  3215,  3220,  3223,  3224,  3236,  3248,  3263,  3264,
    3272,  3273,  3277,  3278,  3282,  3283,  3287,  3288,  3292,  3303,
    3316,  3317,  3327,  3337,  3338,  3351,  3358,  3375,  3383,  3394,
    3397,  3401,  3405,  3409,  3421,  3431,  3434,  3438,  3451,  3461,
    3471,  3480,  3489,  3498,  3508,  3517,  3527,  3537,  3547,  3556,
    3565,  3574,  3583,  3592,  3601,  3610,  3619,  3628,  3637,  3646,
    3664,  3675,  3676,  3677,  3678,  3682,  3683,  3687,  3688,  3698,
    3709,  3729,  3737,  3749,  3750,  3754,  3758,  3766,  3770,  3774,
    3781,  3785,  3790,  3795,  3802,  3809,  3814,  3824,  3838,  3839,
    3844,  3845,  3849,  3850,  3860,  3871,  3891,  3900,  3908,  3925,
    3940,  3958,  3959,  3963,  3967,  3974,  3985,  3994,  4012,  4024,
    4025,  4026,  4036,  4044,  4061,  4080,  4100,  4125,  4126,  4127,
    4131,  4133,  4155,  4157,  4159,  4161,  4163,  4168,  4173,  4183,
    4184,  4188,  4189,  4193,  4194,  4198,  4199,  4200,  4204,  4210,
    4211,  4212,  4216,  4217,  4222,  4223,  4250,  4251,  4252,  4253,
    4254,  4255,  4260,  4271,  4294,  4314,  4337,  4347,  4358,  4368,
    4378,  4389,  4398,  4405,  4412,  4421,  4430,  4439,  4448,  4457,
    4468,  4471,  4472,  4475,  4479,  4486,  4487,  4488,  4489,  4490,
    4493,  4494,  4497,  4500,  4501,  4509,  4516,  4517,  4520,  4522,
    4533,  4542,  4551,  4575,  4590,  4591,  4595,  4605,  4616,  4625,
    4635,  4644,  4645,  4648,  4649,  4652,  4653,  4654,  4657,  4671,
    4676,  4686,  4695,  4707,  4708,  4712,  4720,  4732,  4743,  4757,
    4768,  4791,  4801,  4819,  4830,  4841,  4852,  4866,  4867,  4868,
    4869,  4870,  4871,  4872,  4873,  4874,  4875,  4876,  4877,  4878,
    4879,  4880,  4884,  4885,  4888,  4889,  4892,  4894,  4907,  4918,
    4919,  4920,  4946,  4955,  4964,  4973,  4982,  4991,  5000,  5010,
    5019,  5028,  5037,  5046,  5055,  5064,  5072,  5080,  5088,  5099,
    5100,  5101,  5102,  5103,  5104,  5105,  5106,  5107,  5108,  5109,
    5110,  5111,  5112,  5113,  5114,  5115,  5119,  5120,  5134,  5145,
    5156,  5167,  5178,  5191,  5192,  5196,  5197,  5198,  5199,  5200,
    5201,  5202,  5203,  5204,  5205,  5206,  5209,  5210,  5220,  5226,
    5234,  5242,  5250,  5258,  5266,  5274,  5282,  5290,  5298,  5306,
    5314,  5322,  5330,  5338,  5346,  5354,  5364,  5365,  5368,  5369,
    5379,  5395,  5409,  5435,  5437,  5439,  5441,  5448,  5457,  5458,
    5461,  5468,  5475,  5482,  5496,  5504,  5512,  5520,  5528,  5536,
    5544,  5552,  5560,  5568,  5576,  5584,  5592,  5600,  5608,  5616,
    5628,  5629,  5632,  5642,  5656,  5657,  5661,  5662,  5667,  5683,
    5696,  5706,  5718,  5719,  5722,  5723,  5733,  5743,  5744,  5748,
    5752,  5756,  5767,  5780,  5794,  5811,  5812,  5813,  5814,  5826,
    5853,  5854,  5858,  5859,  5863,  5864,  5868,  5869,  5872,  5873,
    5881,  5892,  5903,  5916,  5917,  5920,  5921,  5922,  5925,  5926,
    5927,  5930,  5931,  5932,  5948,  5960,  5973,  5988,  5989,  5992,
    5993,  5997,  5998,  6006,  6007,  6011,  6012,  6027,  6036,  6045,
    6054,  6063,  6075,  6076,  6077,  6078,  6079,  6085,  6089,  6104,
    6105,  6111,  6121,  6125,  6130,  6140,  6141,  6148,  6152,  6156,
    6160,  6164,  6168,  6172,  6176,  6180,  6184,  6188,  6192,  6196,
    6200,  6204,  6212,  6216,  6220,  6224,  6230,  6231,  6238,  6239,
    6242,  6254,  6258,  6273,  6284,  6285,  6290,  6291,  6306,  6317,
    6331,  6342,  6356,  6367,  6381,  6389,  6391,  6393,  6398,  6400,
    6413,  6422,  6423,  6427,  6431,  6443,  6454,  6465,  6478,  6479,
    6480,  6484,  6497,  6498,  6512,  6520,  6530,  6543,  6544,  6547,
    6548,  6558,  6568,  6577,  6586,  6595,  6604,  6614,  6623,  6633,
    6642,  6651,  6661,  6671,  6680,  6689,  6699,  6709,  6719,  6729,
    6739,  6749,  6759,  6769,  6779,  6789,  6800,  6811,  6821,  6832,
    6843,  6853,  6862,  6871,  6880,  6889,  6898,  6907,  6916,  6925,
    6934,  6943,  6957,  6958,  6961,  6962,  6972,  6982,  6991,  7000,
    7009,  7018,  7028,  7038,  7048,  7058,  7067,  7076,  7085,  7094,
    7103,  7112,  7121,  7130,  7139,  7148,  7157,  7166,  7183,  7192,
    7200,  7208,  7216,  7224,  7233,  7241,  7249,  7258,  7267,  7276,
    7284,  7292,  7300,  7308,  7316,  7324,  7341,  7358,  7359,  7360,
    7365,  7371,  7380,  7381,  7382,  7383,  7384,  7388,  7389,  7392,
    7393,  7394,  7395,  7399,  7400,  7401,  7406,  7417,  7439,  7449,
    7450,  7453,  7462,  7468,  7487,  7494,  7501,  7508,  7515,  7522,
    7529,  7537,  7545,  7553,  7561,  7569,  7576,  7583,  7592,  7593,
    7594,  7598,  7601,  7604,  7607,  7610,  7617,  7619,  7621,  7626,
    7628,  7640,  7652,  7667,  7673,  7679,  7685,  7695,  7711,  7721,
    7722,  7726,  7730,  7734,  7738,  7742,  7746,  7750,  7754,  7758,
    7762,  7766,  7770,  7774,  7778,  7782,  7786,  7796,  7797,  7808,
    7815,  7826,  7837,  7838,  7842,  7856,  7863,  7880,  7893,  7902,
    7910,  7918,  7927,  7938,  7949,  7959,  7960,  7971,  7981,  7991,
    8001,  8011,  8021,  8029,  8050,  8073,  8081,  8090,  8101,  8102,
    8114,  8128,  8142,  8154,  8166,  8183,  8184,  8188,  8189,  8190,
    8191,  8195,  8207,  8222,  8223,  8227,  8228,  8231,  8232,  8235,
    8236,  8240,  8241,  8254,  8261,  8271,  8278,  8288,  8289,  8290,
    8291,  8292,  8293,  8294,  8298,  8302,  8309,  8316,  8317,  8321,
    8322,  8323,  8333,  8343,  8344,  8348,  8349,  8350,  8351,  8361,
    8368,  8385,  8386,  8396,  8402,  8408,  8414,  8430,  8440,  8446,
    8452,  8461,  8463,  8468,  8479,  8480,  8491,  8505,  8506,  8517,
    8528,  8529,  8532,  8533,  8534,  8535,  8536,  8537,  8538,  8539,
    8540,  8541,  8544,  8545,  8556,  8574,  8575,  8579,  8580,  8584,
    8592,  8620,  8631,  8632,  8642,  8653,  8656,  8657,  8658,  8659,
    8660,  8663,  8664,  8665,  8713,  8714,  8718,  8719,  8733,  8734,
    8741,  8749,  8757,  8765,  8773,  8781,  8792,  8793,  8820,  8835,
    8836,  8855,  8859,  8863,  8878,  8885,  8895,  8896,  8899,  8911,
    8912,  8916,  8927,  8935,  8940,  8945,  8950,  8955,  8963,  8971,
    8976,  8981,  8988,  8989,  8992,  8993,  8994,  9001,  9002,  9003,
    9004,  9008,  9009,  9013,  9017,  9018,  9021,  9030,  9043,  9044,
    9045,  9046,  9050,  9051,  9055,  9057,  9067,  9072,  9075,  9080,
    9081,  9089,  9099,  9100,  9101,  9109,  9113,  9114,  9117,  9118,
    9123,  9124,  9128,  9129,  9133,  9134,  9138,  9139,  9143,  9144,
    9148,  9156,  9167,  9168,  9173,  9179,  9197,  9198,  9202,  9203,
    9213,  9217,  9222,  9229,  9237,  9244,  9254,  9264,  9292,  9299,
    9303,  9329,  9333,  9345,  9358,  9372,  9383,  9398,  9404,  9409,
    9415,  9422,  9423,  9424,  9425,  9429,  9430,  9442,  9443,  9448,
    9455,  9462,  9469,  9480,  9481,  9494,  9498,  9505,  9515,  9520,
    9521,  9526,  9527,  9535,  9540,  9541,  9545,  9549,  9555,  9584,
    9589,  9596,  9601,  9607,  9612,  9621,  9623,  9626,  9630,  9631,
    9632,  9633,  9634,  9635,  9640,  9670,  9671,  9672,  9673,  9684,
    9690,  9698,  9699,  9705,  9710,  9715,  9720,  9725,  9730,  9735,
    9740,  9746,  9752,  9758,  9765,  9787,  9796,  9800,  9808,  9812,
    9820,  9832,  9853,  9857,  9863,  9867,  9880,  9899,  9922,  9924,
    9926,  9928,  9930,  9932,  9937,  9938,  9942,  9943,  9950,  9959,
    9967,  9976,  9987,  9995,  9996,  9997, 10001, 10003, 10005, 10007,
   10009, 10011, 10013, 10018, 10023, 10029, 10037, 10042, 10049, 10056,
   10060, 10064, 10094, 10095, 10097, 10105, 10127, 10129, 10131, 10133,
   10135, 10137, 10139, 10141, 10143, 10145, 10147, 10150, 10152, 10154,
   10157, 10159, 10161, 10164, 10166, 10179, 10181, 10194, 10196, 10209,
   10211, 10225, 10238, 10251, 10264, 10287, 10294, 10301, 10308, 10315,
   10338, 10345, 10352, 10359, 10366, 10373, 10380, 10384, 10392, 10396,
   10406, 10413, 10420, 10433, 10446, 10465, 10486, 10496, 10503, 10519,
   10524, 10542, 10544, 10546, 10548, 10550, 10552, 10554, 10556, 10558,
   10560, 10562, 10564, 10566, 10568, 10570, 10572, 10574, 10578, 10583,
   10587, 10591, 10596, 10613, 10614, 10615, 10630, 10642, 10644, 10646,
   10656, 10679, 10689, 10699, 10707, 10726, 10739, 10752, 10765, 10778,
   10791, 10808, 10821, 10844, 10857, 10883, 10893, 10906, 10923, 10936,
   10946, 10959, 10969, 10982, 10995, 11008, 11021, 11034, 11047, 11060,
   11062, 11075, 11093, 11107, 11123, 11145, 11161, 11174, 11187, 11200,
   11204, 11211, 11219, 11227, 11231, 11235, 11239, 11243, 11247, 11262,
   11266, 11275, 11279, 11283, 11288, 11302, 11304, 11308, 11310, 11312,
   11315, 11318, 11321, 11322, 11325, 11333, 11343, 11344, 11347, 11348,
   11349, 11354, 11358, 11362, 11366, 11377, 11378, 11382, 11383, 11388,
   11396, 11398, 11412, 11415, 11442, 11443, 11446, 11447, 11458, 11476,
   11483, 11492, 11509, 11554, 11562, 11570, 11578, 11586, 11607, 11608,
   11609, 11612, 11613, 11614, 11617, 11618, 11621, 11622, 11623, 11624,
   11625, 11626, 11627, 11628, 11629, 11632, 11634, 11639, 11641, 11646,
   11648, 11650, 11652, 11654, 11656, 11668, 11672, 11679, 11683, 11689,
   11693, 11704, 11705, 11708, 11712, 11716, 11722, 11723, 11728, 11732,
   11739, 11740, 11741, 11742, 11743, 11744, 11745, 11746, 11756, 11760,
   11767, 11774, 11775, 11791, 11795, 11800, 11804, 11819, 11824, 11828,
   11831, 11834, 11835, 11836, 11839, 11846, 11856, 11870, 11871, 11875,
   11886, 11887, 11890, 11891, 11894, 11898, 11905, 11909, 11913, 11920,
   11930, 11931, 11935, 11936, 11939, 11940, 11951, 11952, 11961, 11962,
   11970, 11981, 11982, 11985, 12001, 12009, 12017, 12039, 12040, 12051,
   12055, 12082, 12084, 12089, 12092, 12095, 12097, 12099, 12101, 12111,
   12113, 12124, 12128, 12132, 12136, 12140, 12149, 12156, 12181, 12185,
   12191, 12208, 12212, 12216, 12222, 12223, 12224, 12226, 12228, 12232,
   12233, 12234, 12250, 12251, 12252, 12257, 12258, 12259, 12264, 12265,
   12266, 12267, 12273, 12274, 12275, 12276, 12277, 12297, 12298, 12299,
   12300, 12301, 12302, 12303, 12304, 12305, 12306, 12307, 12308, 12309,
   12310, 12311, 12312, 12313, 12314, 12315, 12316, 12317, 12318, 12319,
   12320, 12321, 12322, 12323, 12324, 12325, 12326, 12327, 12328, 12329,
   12330, 12331, 12332, 12333, 12334, 12335, 12336, 12337, 12338, 12339,
   12340, 12341, 12342, 12343, 12344, 12345, 12346, 12347, 12348, 12349,
   12350, 12351, 12352, 12353, 12354, 12355, 12356, 12357, 12358, 12359,
   12360, 12361, 12362, 12363, 12364, 12365, 12366, 12367, 12368, 12369,
   12370, 12371, 12372, 12373, 12374, 12375, 12376, 12377, 12378, 12379,
   12380, 12381, 12382, 12383, 12384, 12385, 12386, 12387, 12388, 12389,
   12390, 12391, 12392, 12393, 12394, 12395, 12396, 12397, 12398, 12399,
   12400, 12401, 12402, 12403, 12404, 12405, 12406, 12407, 12408, 12409,
   12410, 12411, 12412, 12413, 12414, 12415, 12416, 12417, 12418, 12419,
   12420, 12421, 12422, 12423, 12424, 12425, 12426, 12427, 12428, 12429,
   12430, 12431, 12432, 12433, 12434, 12435, 12436, 12437, 12438, 12439,
   12440, 12441, 12442, 12443, 12444, 12445, 12446, 12447, 12448, 12449,
   12450, 12451, 12452, 12453, 12454, 12455, 12456, 12457, 12458, 12459,
   12460, 12461, 12462, 12463, 12464, 12465, 12466, 12467, 12468, 12469,
   12470, 12471, 12472, 12473, 12474, 12475, 12476, 12477, 12478, 12479,
   12480, 12481, 12482, 12483, 12484, 12485, 12486, 12487, 12488, 12489,
   12490, 12491, 12492, 12493, 12494, 12495, 12496, 12497, 12498, 12499,
   12500, 12501, 12502, 12503, 12504, 12505, 12506, 12507, 12508, 12509,
   12510, 12511, 12512, 12513, 12514, 12515, 12516, 12517, 12518, 12519,
   12520, 12521, 12522, 12523, 12524, 12525, 12526, 12527, 12528, 12529,
   12530, 12531, 12532, 12533, 12534, 12535, 12536, 12537, 12538, 12539,
   12540, 12541, 12542, 12543, 12544, 12545, 12546, 12547, 12561, 12562,
   12563, 12564, 12565, 12566, 12567, 12568, 12569, 12570, 12571, 12572,
   12573, 12574, 12575, 12576, 12577, 12578, 12579, 12580, 12581, 12582,
   12583, 12584, 12585, 12586, 12587, 12588, 12589, 12590, 12591, 12592,
   12593, 12594, 12595, 12596, 12597, 12598, 12599, 12600, 12601, 12602,
   12603, 12604, 12605, 12606, 12607, 12621, 12622, 12623, 12624, 12625,
   12626, 12627, 12628, 12629, 12630, 12631, 12632, 12633, 12634, 12635,
   12636, 12637, 12638, 12639, 12640, 12641, 12642, 12643, 12653, 12654,
   12655, 12656, 12657, 12658, 12659, 12660, 12661, 12662, 12663, 12664,
   12665, 12666, 12667, 12668, 12669, 12670, 12671, 12672, 12673, 12674,
   12675, 12676, 12677, 12678, 12679, 12680, 12681, 12682, 12683, 12684,
   12685, 12686, 12687, 12688, 12689, 12690, 12691, 12692, 12693, 12694,
   12695, 12696, 12697, 12698, 12699, 12700, 12701, 12702, 12703, 12704,
   12705, 12706, 12707, 12708, 12709, 12710, 12711, 12712, 12713, 12714,
   12715, 12716, 12717, 12718, 12719, 12720, 12721, 12722, 12723, 12724,
   12725, 12726, 12727, 12728
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "FCONST", "SCONST", "BCONST",
  "XCONST", "Op", "ICONST", "PARAM", "TYPECAST", "DOT_DOT", "COLON_EQUALS",
  "ABORT_P", "ABSOLUTE_P", "ACCESS", "ACTION", "ADD_P", "ADMIN", "AFTER",
  "AGGREGATE", "ALL", "ALSO", "ALTER", "ALWAYS", "ANALYSE", "ANALYZE",
  "AND", "ANY", "APPLICATION", "ARRAY", "AS", "ASC", "ASSERTION",
  "ASSIGNMENT", "ASYMMETRIC", "AT", "ATTRIBUTE", "AUTHORIZATION",
  "BACKWARD", "BEFORE", "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT",
  "BOOLEAN_P", "BOTH", "BY", "CACHE", "CALLED", "CASCADE", "CASCADED",
  "CASE", "CAST", "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER",
  "CHARACTERISTICS", "CHECK", "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER",
  "COALESCE", "COLLATE", "COLLATION", "COLUMN", "COMMENT", "COMMENTS",
  "COMMIT", "COMMITTED", "CONCURRENTLY", "CONFIGURATION", "CONNECTION",
  "CONSTRAINT", "CONSTRAINTS", "CONTENT_P", "CONTINUE_P", "CONVERSION_P",
  "COPY", "COST", "CREATE", "CROSS", "CSV", "CURRENT_P", "CURRENT_CATALOG",
  "CURRENT_DATE", "CURRENT_ROLE", "CURRENT_SCHEMA", "CURRENT_TIME",
  "CURRENT_TIMESTAMP", "CURRENT_USER", "CURSOR", "CYCLE", "DATA_P",
  "DATABASE", "DAY_P", "DEALLOCATE", "DEC", "DECIMAL_P", "DECLARE",
  "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED", "DEFINER", "DELETE_P",
  "DELIMITER", "DELIMITERS", "DESC", "DICTIONARY", "DISABLE_P", "DISCARD",
  "DISTINCT", "DO", "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P", "DROP", "EACH",
  "ELSE", "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P", "ENUM_P", "ESCAPE",
  "EXCEPT", "EXCLUDE", "EXCLUDING", "EXCLUSIVE", "EXECUTE", "EXISTS",
  "EXPLAIN", "EXTENSION", "EXTERNAL", "EXTRACT", "FALSE_P", "FAMILY",
  "FETCH", "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR", "FORCE", "FOREIGN",
  "FORWARD", "FREEZE", "FROM", "FULL", "FUNCTION", "FUNCTIONS", "GLOBAL",
  "GRANT", "GRANTED", "GREATEST", "GROUP_P", "HANDLER", "HAVING",
  "HEADER_P", "HOLD", "HOUR_P", "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE",
  "IMMUTABLE", "IMPLICIT_P", "IN_P", "INCLUDING", "INCREMENT", "INDEX",
  "INDEXES", "INHERIT", "INHERITS", "INITIALLY", "INLINE_P", "INNER_P",
  "INOUT", "INPUT_P", "INSENSITIVE", "INSERT", "INSTEAD", "INT_P",
  "INTEGER", "INTERSECT", "INTERVAL", "INTO", "INVOKER", "IS", "ISNULL",
  "ISOLATION", "JOIN", "KEY", "LABEL", "LANGUAGE", "LARGE_P", "LAST_P",
  "LC_COLLATE_P", "LC_CTYPE_P", "LEADING", "LEAKPROOF", "LEAST", "LEFT",
  "LEVEL", "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME",
  "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "MAPPING", "MATCH", "MAXVALUE",
  "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE", "NAME_P", "NAMES",
  "NATIONAL", "NATURAL", "NCHAR", "NEXT", "NO", "NONE", "NOT", "NOTHING",
  "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P", "NULLIF", "NULLS_P", "NUMERIC",
  "OBJECT_P", "OF", "OFF", "OFFSET", "OIDS", "ON", "ONLY", "OPERATOR",
  "OPTION", "OPTIONS", "OR", "ORDER", "OUT_P", "OUTER_P", "OVER",
  "OVERLAPS", "OVERLAY", "OWNED", "OWNER", "PARSER", "PARTIAL",
  "PARTITION", "PASSING", "PASSWORD", "PLACING", "PLANS", "POSITION",
  "PRECEDING", "PRECISION", "PRESERVE", "PREPARE", "PREPARED", "PRIMARY",
  "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "QUOTE", "RANGE",
  "READ", "REAL", "REASSIGN", "RECHECK", "RECURSIVE", "REF", "REFERENCES",
  "REINDEX", "RELATIVE_P", "RELEASE", "RENAME", "REPEATABLE", "REPLACE",
  "REPLICA", "RESET", "RESTART", "RESTRICT", "RETURNING", "RETURNS",
  "REVOKE", "RIGHT", "ROLE", "ROLLBACK", "ROW", "ROWS", "RULE",
  "SAVEPOINT", "SCHEMA", "SCROLL", "SEARCH", "SECOND_P", "SECURITY",
  "SELECT", "SEQUENCE", "SEQUENCES", "SERIALIZABLE", "SERVER", "SESSION",
  "SESSION_USER", "SET", "SETOF", "SHARE", "SHOW", "SIMILAR", "SIMPLE",
  "SMALLINT", "SNAPSHOT", "SOME", "STABLE", "STANDALONE_P", "START",
  "STATEMENT", "STATISTICS", "STDIN", "STDOUT", "STORAGE", "STRICT_P",
  "STRIP_P", "SUBSTRING", "SYMMETRIC", "SYSID", "SYSTEM_P", "TABLE",
  "TABLES", "TABLESPACE", "TEMP", "TEMPLATE", "TEMPORARY", "TEXT_P",
  "THEN", "TIME", "TIMESTAMP", "TO", "TRAILING", "TRANSACTION", "TREAT",
  "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE", "TRUSTED", "TYPE_P", "TYPES_P",
  "UNBOUNDED", "UNCOMMITTED", "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN",
  "UNLISTEN", "UNLOGGED", "UNTIL", "UPDATE", "USER", "USING", "VACUUM",
  "VALID", "VALIDATE", "VALIDATOR", "VALUE_P", "VALUES", "VARCHAR",
  "VARIADIC", "VARYING", "VERBOSE", "VERSION_P", "VIEW", "VOLATILE",
  "WHEN", "WHERE", "WHITESPACE_P", "WINDOW", "WITH", "WITHOUT", "WORK",
  "WRAPPER", "WRITE", "XML_P", "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT",
  "XMLEXISTS", "XMLFOREST", "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE",
  "YEAR_P", "YES_P", "ZONE", "NULLS_FIRST", "NULLS_LAST", "WITH_TIME",
  "'='", "'<'", "'>'", "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'",
  "'^'", "UMINUS", "'['", "']'", "'('", "')'", "'.'", "';'", "','", "':'",
  "$accept", "stmtblock", "stmtmulti", "stmt", "CreateRoleStmt",
  "opt_with", "OptRoleList", "AlterOptRoleList", "AlterOptRoleElem",
  "CreateOptRoleElem", "CreateUserStmt", "AlterRoleStmt",
  "opt_in_database", "AlterRoleSetStmt", "AlterUserStmt",
  "AlterUserSetStmt", "DropRoleStmt", "DropUserStmt", "CreateGroupStmt",
  "AlterGroupStmt", "add_drop", "DropGroupStmt", "CreateSchemaStmt",
  "OptSchemaName", "OptSchemaEltList", "schema_stmt", "VariableSetStmt",
  "set_rest", "set_rest_more", "var_name", "var_list", "var_value",
  "iso_level", "opt_boolean_or_string", "zone_value", "opt_encoding",
  "NonReservedWord_or_Sconst", "VariableResetStmt", "SetResetClause",
  "FunctionSetResetClause", "VariableShowStmt", "ConstraintsSetStmt",
  "constraints_set_list", "constraints_set_mode", "CheckPointStmt",
  "DiscardStmt", "AlterTableStmt", "alter_table_cmds", "alter_table_cmd",
  "alter_column_default", "opt_drop_behavior", "opt_collate_clause",
  "alter_using", "reloptions", "opt_reloptions", "reloption_list",
  "reloption_elem", "AlterCompositeTypeStmt", "alter_type_cmds",
  "alter_type_cmd", "ClosePortalStmt", "CopyStmt", "copy_from",
  "copy_file_name", "copy_options", "copy_opt_list", "copy_opt_item",
  "opt_binary", "opt_oids", "copy_delimiter", "opt_using",
  "copy_generic_opt_list", "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement", "columnDef", "columnOptions",
  "ColQualList", "ColConstraint", "ColConstraintElem", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_no_inherit", "opt_column_list",
  "columnList", "columnElem", "key_match", "ExclusionConstraintList",
  "ExclusionConstraintElem", "ExclusionWhereClause", "key_actions",
  "key_update", "key_delete", "key_action", "OptInherit", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace", "ExistingIndex",
  "CreateAsStmt", "create_as_target", "opt_with_data", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "SeqOptList", "SeqOptElem", "opt_by",
  "NumericOnly", "NumericOnly_list", "CreatePLangStmt", "opt_trusted",
  "handler_name", "opt_inline_handler", "validator_clause",
  "opt_validator", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "DropFdwStmt", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "DropForeignServerStmt",
  "AlterForeignServerStmt", "CreateForeignTableStmt",
  "OptForeignTableElementList", "ForeignTableElementList",
  "ForeignTableElement", "AlterForeignTableStmt", "CreateUserMappingStmt",
  "auth_ident", "DropUserMappingStmt", "AlterUserMappingStmt",
  "CreateTrigStmt", "TriggerActionTime", "TriggerEvents",
  "TriggerOneEvent", "TriggerForSpec", "TriggerForOptEach",
  "TriggerForType", "TriggerWhen", "TriggerFuncArgs", "TriggerFuncArg",
  "OptConstrFromTable", "ConstraintAttributeSpec",
  "ConstraintAttributeElem", "DropTrigStmt", "CreateAssertStmt",
  "DropAssertStmt", "DefineStmt", "definition", "def_list", "def_elem",
  "def_arg", "aggr_args", "old_aggr_definition", "old_aggr_list",
  "old_aggr_elem", "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "CreateOpClassStmt", "opclass_item_list", "opclass_item", "opt_default",
  "opt_opfamily", "opclass_purpose", "opt_recheck", "CreateOpFamilyStmt",
  "AlterOpFamilyStmt", "opclass_drop_list", "opclass_drop",
  "DropOpClassStmt", "DropOpFamilyStmt", "DropOwnedStmt",
  "ReassignOwnedStmt", "DropStmt", "drop_type", "any_name_list",
  "any_name", "attrs", "TruncateStmt", "opt_restart_seqs", "CommentStmt",
  "comment_type", "comment_text", "SecLabelStmt", "opt_provider",
  "security_label_type", "security_label", "FetchStmt", "fetch_args",
  "from_in", "opt_from_in", "GrantStmt", "RevokeStmt", "privileges",
  "privilege_list", "privilege", "privilege_target", "grantee_list",
  "grantee", "opt_grant_grant_option", "function_with_argtypes_list",
  "function_with_argtypes", "GrantRoleStmt", "RevokeRoleStmt",
  "opt_grant_admin_option", "opt_granted_by", "AlterDefaultPrivilegesStmt",
  "DefACLOptionList", "DefACLOption", "DefACLAction",
  "defacl_privilege_target", "IndexStmt", "opt_unique", "opt_concurrently",
  "opt_index_name", "access_method_clause", "index_params", "index_elem",
  "opt_collate", "opt_class", "opt_asc_desc", "opt_nulls_order",
  "CreateFunctionStmt", "opt_or_replace", "func_args", "func_args_list",
  "func_args_with_defaults", "func_args_with_defaults_list", "func_arg",
  "arg_class", "param_name", "func_return", "func_type",
  "func_arg_with_default", "createfunc_opt_list", "common_func_opt_item",
  "createfunc_opt_item", "func_as", "opt_definition", "table_func_column",
  "table_func_column_list", "AlterFunctionStmt", "alterfunc_opt_list",
  "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt",
  "oper_argtypes", "any_operator", "DoStmt", "dostmt_opt_list",
  "dostmt_opt_item", "CreateCastStmt", "cast_context", "DropCastStmt",
  "opt_if_exists", "ReindexStmt", "reindex_type", "opt_force",
  "RenameStmt", "opt_column", "opt_set_data", "AlterObjectSchemaStmt",
  "AlterOwnerStmt", "RuleStmt", "RuleActionList", "RuleActionMulti",
  "RuleActionStmt", "RuleActionStmtOrEmpty", "event", "opt_instead",
  "DropRuleStmt", "NotifyStmt", "notify_payload", "ListenStmt",
  "UnlistenStmt", "TransactionStmt", "opt_transaction",
  "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "ViewStmt", "opt_check_option",
  "LoadStmt", "CreatedbStmt", "createdb_opt_list", "createdb_opt_item",
  "opt_equal", "AlterDatabaseStmt", "AlterDatabaseSetStmt",
  "alterdb_opt_list", "alterdb_opt_item", "DropdbStmt", "CreateDomainStmt",
  "AlterDomainStmt", "opt_as", "AlterTSDictionaryStmt",
  "AlterTSConfigurationStmt", "CreateConversionStmt", "ClusterStmt",
  "cluster_index_specification", "VacuumStmt", "vacuum_option_list",
  "vacuum_option_elem", "AnalyzeStmt", "analyze_keyword", "opt_verbose",
  "opt_full", "opt_freeze", "opt_name_list", "ExplainStmt",
  "ExplainableStmt", "explain_option_list", "explain_option_elem",
  "explain_option_name", "explain_option_arg", "PrepareStmt",
  "prep_type_clause", "PreparableStmt", "ExecuteStmt",
  "execute_param_clause", "DeallocateStmt", "InsertStmt", "insert_rest",
  "insert_column_list", "insert_column_item", "returning_clause",
  "DeleteStmt", "using_clause", "LockStmt", "opt_lock", "lock_type",
  "opt_nowait", "UpdateStmt", "set_clause_list", "set_clause",
  "single_set_clause", "multiple_set_clause", "set_target",
  "set_target_list", "DeclareCursorStmt", "cursor_name", "cursor_options",
  "opt_hold", "SelectStmt", "select_with_parens", "select_no_parens",
  "select_clause", "simple_select", "with_clause", "cte_list",
  "common_table_expr", "opt_with_clause", "into_clause",
  "OptTempTableName", "opt_table", "opt_all", "opt_distinct",
  "opt_sort_clause", "sort_clause", "sortby_list", "sortby",
  "select_limit", "opt_select_limit", "limit_clause", "offset_clause",
  "select_limit_value", "select_offset_value",
  "opt_select_fetch_first_value", "select_offset_value2", "row_or_rows",
  "first_or_next", "group_clause", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "locked_rels_list", "values_clause", "from_clause", "from_list",
  "table_ref", "joined_table", "alias_clause", "join_type", "join_outer",
  "join_qual", "relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "func_table", "where_clause",
  "where_or_current_clause", "OptTableFuncElementList",
  "TableFuncElementList", "TableFuncElement", "Typename",
  "opt_array_bounds", "SimpleTypename", "ConstTypename", "GenericType",
  "opt_type_modifiers", "Numeric", "opt_float", "Bit", "ConstBit",
  "BitWithLength", "BitWithoutLength", "Character", "ConstCharacter",
  "CharacterWithLength", "CharacterWithoutLength", "character",
  "opt_varying", "opt_charset", "ConstDatetime", "ConstInterval",
  "opt_timezone", "opt_interval", "interval_second", "a_expr", "b_expr",
  "c_expr", "func_expr", "xml_root_version", "opt_xml_root_standalone",
  "xml_attributes", "xml_attribute_list", "xml_attribute_el",
  "document_or_content", "xml_whitespace_option", "xmlexists_argument",
  "window_clause", "window_definition_list", "window_definition",
  "over_clause", "window_specification", "opt_existing_window_name",
  "opt_partition_clause", "opt_frame_clause", "frame_extent",
  "frame_bound", "row", "sub_type", "all_Op", "MathOp", "qual_Op",
  "qual_all_Op", "subquery_Op", "expr_list", "func_arg_list",
  "func_arg_expr", "type_list", "array_expr", "array_expr_list",
  "extract_list", "extract_arg", "overlay_list", "overlay_placing",
  "position_list", "substr_list", "substr_from", "substr_for", "trim_list",
  "in_expr", "case_expr", "when_clause_list", "when_clause",
  "case_default", "case_arg", "columnref", "indirection_el", "indirection",
  "opt_indirection", "opt_asymmetric", "ctext_expr", "ctext_expr_list",
  "ctext_row", "target_list", "target_el", "qualified_name_list",
  "qualified_name", "name_list", "name", "database_name", "access_method",
  "attr_name", "index_name", "file_name", "func_name", "AexprConst",
  "Iconst", "Sconst", "RoleId", "role_list", "SignedIconst", "ColId",
  "type_function_name", "NonReservedWord", "ColLabel",
  "unreserved_keyword", "col_name_keyword", "type_func_name_keyword",
  "reserved_keyword", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,    61,    60,    62,   669,    43,    45,
      42,    47,    37,    94,   670,    91,    93,    40,    41,    46,
      59,    44,    58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   433,   434,   435,   435,   436,   436,   436,   436,   436,
     436,   436,   436,   436,   436,   436,   436,   436,   436,   436,
     436,   436,   436,   436,   436,   436,   436,   436,   436,   436,
     436,   436,   436,   436,   436,   436,   436,   436,   436,   436,
     436,   436,   436,   436,   436,   436,   436,   436,   436,   436,
     436,   436,   436,   436,   436,   436,   436,   436,   436,   436,
     436,   436,   436,   436,   436,   436,   436,   436,   436,   436,
     436,   436,   436,   436,   436,   436,   436,   436,   436,   436,
     436,   436,   436,   436,   436,   436,   436,   436,   436,   436,
     436,   436,   436,   436,   436,   436,   436,   436,   436,   436,
     436,   436,   436,   436,   436,   436,   436,   436,   436,   436,
     436,   436,   436,   436,   436,   436,   437,   438,   438,   439,
     439,   440,   440,   441,   441,   441,   441,   441,   441,   441,
     441,   441,   442,   442,   442,   442,   442,   442,   443,   444,
     445,   445,   446,   447,   448,   449,   449,   450,   450,   451,
     452,   453,   453,   454,   454,   455,   455,   456,   456,   457,
     457,   458,   458,   458,   458,   458,   458,   459,   459,   459,
     460,   460,   460,   461,   461,   461,   461,   461,   461,   461,
     461,   461,   461,   461,   461,   461,   461,   462,   462,   463,
     463,   464,   464,   465,   465,   465,   465,   466,   466,   466,
     466,   467,   467,   467,   467,   467,   467,   467,   468,   468,
     468,   469,   469,   470,   470,   470,   470,   470,   471,   471,
     472,   472,   473,   473,   473,   473,   473,   474,   475,   475,
     476,   476,   477,   478,   478,   478,   478,   479,   479,   479,
     479,   479,   479,   479,   479,   480,   480,   481,   481,   481,
     481,   481,   481,   481,   481,   481,   481,   481,   481,   481,
     481,   481,   481,   481,   481,   481,   481,   481,   481,   481,
     481,   481,   481,   481,   481,   481,   481,   481,   481,   481,
     481,   481,   481,   481,   481,   481,   481,   481,   481,   482,
     482,   483,   483,   483,   484,   484,   485,   485,   486,   487,
     487,   488,   488,   489,   489,   489,   489,   490,   491,   491,
     492,   492,   492,   492,   493,   493,   494,   494,   495,   495,
     496,   496,   496,   497,   497,   498,   498,   499,   499,   499,
     499,   499,   499,   499,   499,   499,   499,   499,   499,   500,
     500,   501,   501,   502,   502,   503,   503,   504,   504,   505,
     506,   506,   506,   506,   506,   507,   507,   508,   509,   509,
     509,   509,   510,   510,   510,   510,   510,   510,   510,   510,
     511,   511,   512,   512,   513,   513,   514,   514,   515,   515,
     515,   516,   516,   517,   518,   519,   519,   520,   520,   520,
     520,   521,   521,   521,   521,   521,   521,   521,   522,   522,
     522,   522,   523,   524,   524,   524,   525,   525,   525,   525,
     525,   525,   526,   526,   527,   527,   527,   527,   527,   527,
     527,   528,   528,   529,   529,   530,   530,   531,   532,   532,
     532,   532,   533,   533,   534,   534,   535,   535,   536,   536,
     536,   536,   536,   537,   538,   539,   539,   539,   539,   539,
     540,   540,   541,   541,   541,   541,   542,   542,   542,   542,
     543,   543,   544,   544,   545,   546,   547,   548,   548,   548,
     549,   550,   550,   551,   551,   552,   552,   553,   553,   553,
     553,   553,   553,   553,   553,   553,   553,   553,   553,   554,
     554,   555,   555,   555,   556,   556,   557,   557,   558,   558,
     559,   559,   560,   560,   561,   561,   562,   562,   563,   563,
     564,   564,   565,   566,   566,   567,   567,   568,   568,   569,
     569,   570,   570,   570,   571,   572,   572,   573,   574,   574,
     574,   574,   574,   574,   574,   574,   574,   574,   574,   574,
     574,   574,   574,   574,   574,   574,   574,   574,   574,   574,
     575,   576,   576,   576,   576,   577,   577,   578,   578,   579,
     579,   580,   580,   581,   581,   582,   582,   583,   584,   584,
     585,   585,   585,   585,   586,   587,   588,   589,   590,   590,
     591,   591,   592,   592,   593,   593,   594,   594,   594,   595,
     595,   596,   596,   597,   597,   598,   599,   599,   600,   601,
     601,   601,   602,   602,   603,   604,   604,   605,   605,   605,
     606,   606,   607,   607,   607,   607,   607,   608,   608,   609,
     609,   610,   610,   611,   611,   612,   612,   612,   613,   613,
     613,   613,   614,   614,   615,   615,   616,   616,   616,   616,
     616,   616,   617,   617,   618,   619,   620,   620,   620,   620,
     620,   620,   620,   620,   620,   620,   620,   620,   620,   620,
     621,   622,   622,   623,   623,   624,   624,   624,   624,   624,
     625,   625,   626,   627,   627,   628,   629,   629,   630,   630,
     631,   631,   631,   632,   633,   633,   634,   634,   634,   634,
     634,   635,   635,   636,   636,   637,   637,   637,   638,   638,
     639,   640,   640,   641,   641,   642,   642,   643,   643,   644,
     644,   645,   646,   647,   647,   647,   647,   648,   648,   648,
     648,   648,   648,   648,   648,   648,   648,   648,   648,   648,
     648,   648,   649,   649,   650,   650,   651,   651,   652,   653,
     653,   653,   654,   654,   654,   654,   654,   654,   654,   654,
     654,   654,   654,   654,   654,   654,   654,   654,   654,   655,
     655,   655,   655,   655,   655,   655,   655,   655,   655,   655,
     655,   655,   655,   655,   655,   655,   656,   656,   657,   657,
     657,   657,   657,   658,   658,   659,   659,   659,   659,   659,
     659,   659,   659,   659,   659,   659,   660,   660,   661,   661,
     662,   662,   662,   662,   662,   662,   662,   662,   662,   662,
     662,   662,   662,   662,   662,   662,   663,   663,   664,   664,
     665,   666,   666,   667,   667,   667,   667,   667,   668,   668,
     669,   669,   669,   669,   670,   670,   670,   670,   670,   670,
     670,   670,   670,   670,   670,   670,   670,   670,   670,   670,
     671,   671,   672,   672,   673,   673,   674,   674,   675,   676,
     677,   677,   678,   678,   679,   679,   680,   681,   681,   682,
     682,   682,   683,   683,   683,   684,   684,   684,   684,   685,
     686,   686,   687,   687,   688,   688,   689,   689,   690,   690,
     691,   691,   691,   692,   692,   693,   693,   693,   694,   694,
     694,   695,   695,   695,   696,   696,   696,   697,   697,   698,
     698,   699,   699,   700,   700,   701,   701,   702,   702,   702,
     702,   702,   703,   703,   703,   703,   703,   704,   705,   706,
     706,   706,   707,   707,   707,   708,   708,   709,   709,   709,
     709,   709,   709,   709,   709,   709,   709,   709,   709,   709,
     709,   709,   710,   710,   710,   710,   711,   711,   712,   712,
     713,   714,   714,   715,   716,   716,   717,   717,   718,   718,
     719,   719,   720,   720,   721,   721,   721,   721,   722,   722,
     723,   724,   724,   725,   725,   726,   726,   726,   727,   727,
     727,   728,   729,   729,   730,   730,   730,   731,   731,   732,
     732,   733,   733,   733,   733,   733,   733,   733,   733,   733,
     733,   733,   733,   733,   733,   733,   733,   733,   733,   733,
     733,   733,   733,   733,   733,   733,   733,   733,   733,   733,
     733,   733,   733,   733,   733,   733,   733,   733,   733,   733,
     733,   733,   734,   734,   735,   735,   736,   736,   736,   736,
     736,   736,   736,   736,   736,   736,   736,   736,   736,   736,
     736,   736,   736,   736,   736,   736,   736,   736,   737,   737,
     737,   737,   737,   737,   737,   737,   737,   737,   737,   737,
     737,   737,   737,   737,   737,   737,   738,   739,   739,   739,
     740,   740,   741,   741,   741,   741,   741,   742,   742,   743,
     743,   743,   743,   744,   744,   744,   745,   745,   746,   747,
     747,   748,   749,   749,   750,   750,   750,   750,   750,   750,
     750,   750,   750,   750,   750,   750,   750,   750,   751,   751,
     751,   752,   752,   752,   752,   752,   753,   753,   753,   754,
     754,   755,   755,   756,   756,   756,   756,   757,   758,   759,
     759,   760,   760,   760,   760,   760,   760,   760,   760,   760,
     760,   760,   760,   760,   760,   760,   760,   761,   761,   762,
     762,   763,   764,   764,   765,   766,   766,   767,   768,   768,
     768,   768,   768,   768,   768,   769,   769,   770,   771,   771,
     771,   771,   771,   771,   772,   773,   773,   773,   774,   774,
     775,   775,   775,   775,   775,   776,   776,   777,   777,   777,
     777,   778,   778,   779,   779,   780,   780,   781,   781,   782,
     782,   783,   783,   784,   784,   784,   784,   785,   785,   785,
     785,   785,   785,   785,   786,   786,   787,   788,   788,   789,
     789,   789,   790,   791,   791,   792,   792,   792,   792,   793,
     793,   794,   794,   795,   795,   795,   795,   796,   797,   797,
     797,   798,   798,   799,   800,   800,   801,   802,   802,   803,
     804,   804,   805,   805,   805,   805,   805,   805,   805,   805,
     805,   805,   806,   806,   807,   808,   808,   809,   809,   810,
     811,   812,   813,   813,   814,   815,   816,   816,   816,   816,
     816,   817,   817,   817,   818,   818,   819,   819,   820,   820,
     820,   820,   820,   820,   820,   820,   821,   821,   822,   822,
     822,   822,   822,   822,   823,   823,   824,   824,   825,   826,
     826,   827,   827,   828,   828,   828,   828,   828,   828,   828,
     828,   828,   829,   829,   830,   830,   830,   831,   831,   831,
     831,   832,   832,   833,   834,   834,   835,   835,   836,   836,
     836,   836,   837,   837,   838,   838,   838,   839,   839,   840,
     840,   841,   842,   842,   842,   843,   844,   844,   845,   845,
     846,   846,   847,   847,   848,   848,   849,   849,   850,   850,
     851,   851,   852,   852,   853,   853,   854,   854,   855,   855,
     856,   856,   856,   856,   856,   856,   856,   856,   856,   856,
     856,   857,   857,   857,   857,   857,   857,   858,   858,   858,
     858,   859,   859,   859,   859,   860,   860,   861,   861,   862,
     862,   862,   862,   863,   863,   864,   864,   864,   865,   866,
     866,   867,   867,   867,   868,   868,   869,   869,   870,   871,
     871,   871,   871,   871,   871,   872,   872,   872,   873,   873,
     873,   873,   873,   873,   873,   874,   874,   874,   874,   875,
     875,   876,   876,   877,   877,   877,   877,   877,   877,   877,
     877,   877,   877,   877,   878,   878,   879,   879,   880,   880,
     881,   882,   883,   883,   884,   884,   885,   886,   887,   887,
     887,   887,   887,   887,   888,   888,   889,   889,   890,   890,
     890,   890,   891,   892,   892,   892,   893,   893,   893,   893,
     893,   893,   893,   893,   893,   893,   893,   893,   893,   893,
     894,   894,   895,   895,   895,   895,   895,   895,   895,   895,
     895,   895,   895,   895,   895,   895,   895,   895,   895,   895,
     895,   895,   895,   895,   895,   895,   895,   895,   895,   895,
     895,   895,   895,   895,   895,   895,   895,   895,   895,   895,
     895,   895,   895,   895,   895,   895,   895,   895,   895,   895,
     895,   895,   895,   895,   895,   895,   895,   895,   895,   895,
     895,   896,   896,   896,   896,   896,   896,   896,   896,   896,
     896,   896,   896,   896,   896,   896,   896,   896,   896,   896,
     896,   896,   896,   897,   897,   897,   897,   897,   897,   897,
     897,   897,   897,   897,   897,   898,   898,   898,   898,   898,
     898,   898,   898,   898,   898,   898,   898,   898,   898,   898,
     898,   898,   898,   898,   898,   898,   898,   898,   898,   898,
     898,   898,   898,   898,   898,   898,   898,   898,   898,   898,
     898,   898,   898,   898,   898,   898,   898,   898,   898,   898,
     898,   898,   898,   898,   898,   899,   899,   900,   900,   900,
     900,   901,   902,   902,   903,   903,   904,   904,   905,   905,
     905,   906,   906,   906,   906,   907,   907,   908,   908,   909,
     910,   910,   910,   911,   912,   912,   913,   913,   914,   914,
     914,   915,   915,   916,   916,   916,   916,   916,   917,   917,
     917,   918,   918,   918,   919,   919,   920,   920,   920,   920,
     920,   920,   920,   920,   920,   921,   921,   922,   922,   923,
     923,   923,   923,   923,   923,   924,   924,   925,   925,   926,
     926,   927,   927,   928,   928,   928,   929,   929,   930,   930,
     931,   931,   931,   931,   931,   931,   931,   931,   932,   932,
     933,   934,   934,   935,   935,   935,   935,   935,   935,   936,
     937,   938,   938,   938,   939,   939,   940,   941,   941,   942,
     943,   943,   944,   944,   945,   945,   946,   946,   946,   946,
     947,   947,   948,   948,   949,   949,   950,   950,   951,   951,
     952,   953,   953,   954,   954,   954,   954,   955,   955,   956,
     956,   957,   957,   958,   959,   960,   961,   962,   963,   964,
     964,   965,   965,   965,   965,   965,   965,   965,   965,   965,
     965,   965,   965,   965,   966,   967,   968,   969,   969,   970,
     970,   970,   971,   971,   971,   972,   972,   972,   973,   973,
     973,   973,   974,   974,   974,   974,   974,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   975,   975,
     975,   975,   975,   975,   975,   975,   975,   975,   976,   976,
     976,   976,   976,   976,   976,   976,   976,   976,   976,   976,
     976,   976,   976,   976,   976,   976,   976,   976,   976,   976,
     976,   976,   976,   976,   976,   976,   976,   976,   976,   976,
     976,   976,   976,   976,   976,   976,   976,   976,   976,   976,
     976,   976,   976,   976,   976,   977,   977,   977,   977,   977,
     977,   977,   977,   977,   977,   977,   977,   977,   977,   977,
     977,   977,   977,   977,   977,   977,   977,   977,   978,   978,
     978,   978,   978,   978,   978,   978,   978,   978,   978,   978,
     978,   978,   978,   978,   978,   978,   978,   978,   978,   978,
     978,   978,   978,   978,   978,   978,   978,   978,   978,   978,
     978,   978,   978,   978,   978,   978,   978,   978,   978,   978,
     978,   978,   978,   978,   978,   978,   978,   978,   978,   978,
     978,   978,   978,   978,   978,   978,   978,   978,   978,   978,
     978,   978,   978,   978,   978,   978,   978,   978,   978,   978,
     978,   978,   978,   978
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     5,     1,     0,     2,
       0,     2,     0,     2,     2,     3,     3,     1,     3,     3,
       2,     1,     1,     2,     2,     2,     3,     3,     5,     5,
       0,     3,     5,     5,     4,     3,     5,     3,     5,     5,
       6,     1,     1,     3,     5,     6,     4,     1,     0,     2,
       0,     1,     1,     1,     1,     1,     1,     2,     3,     3,
       2,     5,     1,     3,     3,     3,     3,     3,     3,     2,
       2,     2,     2,     3,     3,     3,     3,     1,     3,     1,
       3,     1,     1,     2,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     3,     6,     1,     1,     1,     1,     1,
       0,     1,     1,     2,     3,     4,     3,     2,     2,     1,
       2,     1,     2,     3,     4,     3,     2,     4,     1,     1,
       1,     1,     1,     2,     2,     2,     2,     4,     6,     4,
       6,     4,     6,     4,     6,     1,     3,     2,     3,     4,
       6,     6,     6,     5,     5,     6,     6,     4,     8,     4,
       2,     3,     6,     4,     3,     3,     3,     3,     3,     4,
       4,     3,     3,     3,     3,     3,     3,     4,     4,     3,
       2,     3,     2,     2,     3,     3,     2,     2,     1,     3,
       2,     1,     1,     0,     2,     0,     2,     0,     3,     2,
       0,     1,     3,     3,     1,     5,     3,     4,     1,     3,
       4,     6,     4,     8,     2,     2,    10,     6,     1,     1,
       1,     1,     1,     1,     3,     2,     0,     1,     1,     3,
       3,     1,     1,     3,     3,     3,     3,     4,     2,     1,
       0,     2,     0,     3,     0,     1,     0,     1,     3,     2,
       1,     1,     1,     3,     0,     1,     3,     1,    11,    14,
      10,    13,     1,     1,     2,     2,     2,     2,     1,     0,
       1,     0,     3,     0,     1,     3,     1,     3,     1,     1,
       1,     1,     1,     4,     4,     2,     0,     3,     1,     1,
       2,     2,     1,     3,     4,     5,     2,     5,     1,     2,
       2,     2,     3,     3,     3,     0,     1,     1,     1,     1,
       1,     1,     3,     1,     5,     7,     3,     8,     4,     9,
      11,     2,     0,     3,     0,     1,     3,     1,     2,     2,
       2,     0,     1,     3,     3,     6,     4,     0,     1,     1,
       2,     2,     0,     3,     3,     2,     1,     1,     2,     2,
       4,     0,     2,     2,     2,     0,     3,     4,     4,     0,
       2,     0,     4,     0,     3,     7,     5,     2,     3,     0,
       5,     4,     6,     1,     0,     1,     2,     2,     1,     2,
       3,     2,     2,     2,     2,     3,     3,     1,     3,     1,
       0,     1,     2,     1,     1,     3,     6,    10,     1,     0,
       1,     2,     2,     0,     2,     2,     1,     0,     5,     7,
       1,     0,     6,     2,     0,     3,     5,     5,     8,     2,
       0,     2,     2,     2,     5,     2,     0,     2,     7,    10,
       6,     6,     6,     6,     7,     7,     9,     9,     6,     6,
       8,     8,     8,     8,     6,     6,     7,     8,     6,     6,
       7,     2,     2,     2,     2,     1,     2,     1,     0,     6,
       8,     7,     6,     4,     0,     1,     3,     4,     1,     3,
       1,     2,     2,     2,     2,     1,     1,    10,     2,     0,
       2,     2,     1,     0,     4,     6,     5,     4,     4,     8,
      11,     3,     2,     1,     3,     1,     5,     7,     8,     1,
       1,     1,     7,     9,     8,    15,    20,     1,     1,     2,
       1,     3,     1,     1,     1,     3,     1,     3,     0,     1,
       0,     1,     1,     4,     0,     1,     3,     0,     1,     1,
       1,     1,     2,     0,     0,     2,     2,     1,     2,     2,
       2,     2,     6,     8,     8,     4,     5,     4,     4,     4,
       3,     7,     8,     6,     6,     6,     6,     6,     4,     5,
       3,     1,     3,     3,     1,     1,     1,     1,     1,     1,
       3,     3,     3,     1,     3,     3,     1,     0,     1,     3,
       6,     8,     8,    13,     1,     3,     5,     6,     4,     7,
       2,     1,     0,     2,     0,     2,     4,     0,     1,     0,
       6,     8,     8,     1,     3,     5,     5,     7,     9,     7,
       9,     5,     6,     6,     4,     5,     7,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     1,     1,     3,     3,
       3,     3,     1,     3,     1,     2,     2,     3,     5,     2,
       2,     0,     6,     7,     7,     7,     8,     8,     6,     8,
       9,     9,     7,    10,     7,     8,     8,     8,     8,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     3,     1,     1,     8,     9,
       9,     9,     9,     2,     0,     1,     1,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       1,     2,     3,     3,     3,     3,     4,     4,     3,     3,
       3,     4,     4,     3,     4,     4,     1,     1,     1,     0,
       7,     7,    10,     1,     1,     2,     4,     5,     1,     3,
       2,     2,     2,     2,     1,     2,     2,     4,     3,     2,
       2,     2,     2,     3,     2,     2,     2,     5,     5,     5,
       1,     3,     1,     2,     3,     0,     1,     3,     2,     6,
       6,     9,     3,     0,     3,     0,     5,     2,     0,     3,
       3,     3,     7,     7,    10,     1,     1,     1,     1,    14,
       1,     0,     1,     0,     1,     0,     2,     0,     1,     3,
       5,     5,     7,     2,     0,     1,     2,     0,     1,     1,
       0,     1,     1,     0,     9,    12,     7,     2,     0,     3,
       2,     1,     3,     3,     2,     1,     3,     3,     3,     2,
       2,     1,     1,     1,     1,     2,     1,     1,     1,     1,
       4,     5,     1,     3,     3,     1,     2,     4,     5,     1,
       1,     1,     1,     3,     3,     2,     2,     1,     2,     2,
       2,     1,     2,     2,     1,     1,     1,     3,     2,     0,
       2,     1,     3,     5,     1,     2,     1,     0,     5,     7,
       5,     7,     5,     7,     3,     5,     5,     5,     1,     3,
       2,     1,     2,     1,     2,    11,    10,    10,     2,     2,
       0,     9,     2,     0,     4,     4,     4,     1,     1,     1,
       0,     7,     6,     6,     6,     6,     8,     8,     6,     6,
       7,     9,     9,     6,     6,     6,     8,     6,     8,     6,
       8,     6,     8,     7,     9,     8,    10,     8,     9,    11,
       8,     6,     6,     6,     5,     5,     8,     8,     8,     8,
       6,     9,     1,     0,     2,     0,     7,     6,     6,     6,
       6,     6,     7,     9,     9,     6,     8,     8,     8,     8,
       8,     6,     8,     6,     8,     7,     9,     6,     7,     6,
       6,     6,     6,     6,     7,     7,     7,     9,     9,     6,
       6,     6,     8,     8,     8,     6,    13,     1,     1,     3,
       3,     1,     1,     1,     1,     1,     1,     1,     0,     1,
       1,     1,     1,     1,     1,     0,     6,     8,     3,     2,
       0,     2,     2,     2,     2,     3,     3,     2,     2,     2,
       2,     3,     2,     5,     4,     3,     3,     3,     1,     1,
       0,     3,     2,     2,     1,     2,     1,     3,     2,     1,
       0,     9,    11,     3,     4,     4,     0,     2,     5,     2,
       0,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     4,     3,     3,     1,     0,     5,
       6,     4,     2,     0,     4,     3,     5,     6,     4,     6,
       6,     5,     7,     9,     6,     1,     0,     6,    11,    11,
      11,    13,     9,    11,    10,     4,     2,     5,     2,     0,
       4,     5,     5,     4,     6,     1,     3,     1,     1,     1,
       1,     2,     4,     1,     1,     1,     0,     1,     0,     1,
       0,     3,     0,     2,     4,     3,     5,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     2,     1,     1,     1,
       1,     0,     5,     3,     0,     1,     1,     1,     1,     3,
       9,     3,     0,     2,     3,     2,     3,     6,     1,     4,
       2,     1,     3,     2,     2,     0,     7,     2,     0,     5,
       3,     0,     2,     2,     2,     2,     2,     3,     1,     3,
       1,     2,     1,     0,     8,     1,     3,     1,     1,     3,
       5,     2,     1,     3,     7,     1,     0,     3,     2,     2,
       2,     0,     2,     2,     1,     1,     3,     3,     1,     2,
       4,     4,     2,     3,     5,     5,     1,     1,     9,     1,
       2,     4,     4,     4,     2,     3,     1,     3,     6,     1,
       0,     2,     0,     3,     3,     4,     4,     4,     4,     3,
       2,     1,     1,     0,     1,     1,     0,     1,     5,     1,
       0,     1,     0,     3,     1,     3,     4,     3,     2,     2,
       1,     1,     1,     0,     2,     4,     5,     2,     3,     1,
       1,     1,     1,     3,     0,     1,     1,     1,     1,     1,
       3,     0,     2,     0,     1,     3,     1,     0,     1,     2,
       4,     4,     2,     0,     2,     3,     2,     0,     1,     3,
       1,     2,     1,     2,     5,     6,     5,     1,     2,     1,
       4,     3,     4,     5,     4,     5,     4,     5,     2,     4,
       1,     2,     2,     2,     1,     1,     0,     4,     2,     1,
       2,     2,     4,     1,     3,     1,     2,     3,     1,     2,
       0,     2,     4,     0,     1,     0,     1,     3,     3,     2,
       3,     5,     6,     2,     3,     3,     4,     0,     1,     1,
       1,     1,     1,     2,     5,     1,     1,     1,     1,     2,
       3,     3,     0,     1,     1,     1,     1,     1,     2,     2,
       2,     2,     2,     1,     3,     0,     1,     1,     1,     1,
       5,     2,     1,     1,     1,     1,     5,     2,     2,     2,
       1,     3,     3,     2,     1,     0,     3,     0,     5,     2,
       5,     2,     1,     2,     3,     0,     1,     1,     1,     1,
       1,     1,     3,     3,     3,     3,     3,     3,     3,     0,
       1,     4,     1,     3,     3,     5,     2,     2,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     2,
       3,     3,     2,     3,     5,     4,     6,     3,     5,     4,
       6,     4,     6,     5,     7,     3,     2,     4,     2,     3,
       3,     4,     3,     4,     3,     4,     5,     6,     6,     7,
       6,     7,     6,     7,     3,     4,     4,     6,     2,     3,
       4,     1,     3,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     2,     5,     6,     6,
       7,     3,     4,     1,     1,     2,     4,     1,     1,     1,
       2,     2,     2,     2,     1,     4,     5,     6,     8,     6,
       7,     7,     5,     5,     1,     1,     4,     1,     4,     1,
       4,     1,     4,     1,     1,     1,     1,     1,     1,     6,
       4,     4,     4,     4,     6,     5,     5,     5,     4,     6,
       4,     4,     4,     4,     5,     7,     7,     9,     5,     4,
       6,     5,     7,     7,     7,     2,     3,     3,     3,     4,
       0,     4,     1,     3,     3,     1,     1,     1,     2,     2,
       0,     2,     4,     4,     6,     2,     0,     1,     3,     3,
       2,     2,     0,     6,     1,     0,     3,     0,     2,     2,
       0,     1,     4,     2,     2,     2,     2,     2,     4,     3,
       5,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     4,     1,     4,     1,
       4,     1,     2,     1,     2,     1,     3,     1,     3,     1,
       3,     1,     3,     3,     3,     2,     1,     3,     3,     0,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     3,
       2,     3,     0,     3,     3,     2,     2,     1,     0,     2,
       2,     3,     2,     1,     1,     3,     5,     1,     2,     4,
       2,     0,     1,     0,     1,     2,     2,     2,     3,     5,
       1,     2,     0,     2,     1,     0,     1,     1,     1,     3,
       3,     1,     3,     3,     2,     1,     1,     1,     3,     1,
       2,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     1,     2,     5,     2,     3,
       6,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       2,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    1330,  1130,   511,  1214,  1213,  1130,   232,     0,  1216,     0,
    1130,   340,   908,     0,     0,     0,     0,   511,  1130,     0,
    1330,     0,     0,     0,     0,  1343,     0,     0,     0,     0,
       0,     0,     0,     0,  1130,     0,     0,  1350,     0,     0,
       0,     0,  1343,     0,  1218,     0,     0,     0,     0,     2,
       4,    56,    57,    23,    22,    28,    27,    79,    80,    46,
      16,    70,    51,   112,   111,   113,    34,    30,    64,    20,
      21,    31,    35,    53,    36,    52,    19,    50,    74,    54,
      77,    41,    10,    11,    42,    68,    12,    43,    69,    13,
      44,    14,    58,    81,    26,    55,    78,    37,    66,    62,
       9,    47,    48,    49,    71,    72,    73,    95,    76,   107,
      33,   104,    85,    86,   101,    87,   102,     7,    88,    45,
      15,    98,    97,    99,    65,    38,    67,    96,   100,    17,
      18,   103,    75,    93,    90,   108,   106,   114,    91,    59,
       5,     6,    82,    40,     8,    25,    24,    39,    32,   110,
      29,  1216,    84,    94,    83,    60,    89,    63,    92,   109,
      61,   105,  1317,  1304,  1352,  1316,  1329,     0,  1319,  1129,
    1128,  1114,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   510,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1140,  1852,
    1867,  1868,  1869,  1870,  1871,  1872,  1873,  1874,   315,  1875,
    1876,  1877,  1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,
    2118,  2119,  2120,  2121,  1886,  1887,  1888,  1889,  1890,  1891,
    1892,  2122,  2123,  1893,  1894,  1895,  1896,  1897,  2124,  1898,
    1899,  1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,
    1909,  1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,  2125,
    2126,  1918,  1919,  1920,  1921,  1922,  1923,  1924,  1925,  1926,
    1927,  1928,  1929,  1930,  1931,  1932,  1933,  1934,  1935,  1936,
    1937,  1938,  1939,  1940,  1941,  2127,  1942,  1943,  1944,  2128,
    1945,  1946,  2129,  1947,  1948,  1949,  1950,  1951,  1952,  1953,
    2130,  1954,  1955,  1956,  1957,  1958,  1959,  1960,  1961,  1962,
    1963,  1964,  1965,  1966,  1967,  1968,  1969,  2131,  1970,  1971,
    1972,  1973,  2132,  2133,  2134,  1974,  1975,  1976,  1977,  1978,
    1979,  1980,  1981,  1982,  1983,  2135,  1984,  1985,  1986,  1987,
    1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,
    1998,  1999,  2136,  2137,  2000,  2001,  2138,  2002,  2003,  2004,
    2139,  2005,  2140,  2006,  2007,  2008,  2009,  2010,  2011,  2012,
    2141,  2142,  2013,  2014,  2015,  2016,  2017,  2018,  2019,  2020,
    2143,  2021,  2144,  2024,  2022,  2023,  2025,  2026,  2027,  2028,
    2029,  2030,  2031,  2145,  2032,  2033,  2034,  2035,  2036,  2037,
    2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,
    2048,  2049,  2146,  2050,  2051,  2052,  2053,  2054,  2055,  2056,
    2057,  2058,  2059,  2060,  2061,  2062,  2063,  2147,  2064,  2065,
    2066,  2148,  2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,
    2075,  2076,  2077,  2149,  2078,  2079,  2080,  2081,  2082,  2083,
    2084,  2085,  2150,  2151,  2086,  2152,  2087,  2153,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2154,  2155,  2105,  2106,  2107,
    2108,  2109,  2110,  2111,  2112,  2113,  2114,  2156,  2157,  2158,
    2159,  2160,  2161,  2162,  2163,  2164,  2115,  2116,  2117,   314,
    1295,  1823,  1853,  1854,  1215,  1196,   511,     0,  1117,   339,
       0,     0,     0,     0,     0,     0,     0,     0,   691,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   158,     0,
       0,   363,   362,     0,     0,     0,   880,   368,     0,     0,
       0,     0,   499,  1255,  2022,  1253,  1296,   233,   236,   234,
     235,  1845,     0,   980,   981,   983,     0,     0,   993,   724,
     725,     0,   723,   727,     0,     0,     0,   720,     0,     0,
       0,     0,   726,   718,     0,   717,     0,     0,     0,   722,
       0,   719,     0,     0,  1118,  1252,   369,  1330,     0,  1232,
    1216,  1223,  1233,  1228,  1230,  1229,  1231,  1227,  1844,  1868,
     819,   819,   819,   819,   816,   817,   819,   819,   819,  2037,
       0,     0,   798,     0,   800,  1849,   819,   824,   424,   424,
     424,     0,   823,   828,   424,  1111,  1147,  1828,  1342,     0,
     799,  1110,  2086,  1244,     0,     0,   997,     0,   998,     0,
    2052,  1122,   217,  2062,  2150,  2086,   213,   187,  1872,     0,
       0,   823,     0,  1119,  1120,   784,  1349,  1347,     0,  1891,
    1904,  1987,   210,  2048,  2053,  2062,  2150,  2086,  2114,   167,
     172,     0,   226,  2062,  2150,  2086,   222,  1140,     0,  1320,
    1429,  1819,     0,  1113,  1112,  1217,     0,  1220,     0,  1394,
    2034,  1324,  1326,  1222,  1317,     0,     0,     1,  1330,  1211,
    1346,  1346,     0,  1346,     0,  1309,  1317,  1312,  1316,     0,
       0,     0,     0,  1852,  2165,  2166,  2167,  2168,  2169,  2170,
    2171,  2172,  2173,  2174,  2175,  2176,  2177,  2178,  2179,  2180,
    2181,  2182,  2183,  2184,  2185,  2186,  2187,     0,     0,  1829,
    1853,  1857,     0,   734,     0,   118,  1824,   868,     0,     0,
       0,  1823,     0,     0,     0,     0,  1858,     0,  1846,  1859,
    1860,  1861,  1959,     0,     0,  1724,  1895,  1945,  1734,  1732,
    1733,  1726,  1727,  1728,  1729,  1730,  1731,     0,   978,  1725,
       0,   118,     0,  1959,     0,     0,  1959,     0,     0,     0,
       0,     0,  1990,   118,  1959,     0,     0,  1134,     0,     0,
       0,  1136,  1139,  1115,  1199,     0,  1819,     0,     0,   768,
     759,     0,   769,   760,   765,   771,     0,     0,   762,     0,
       0,   772,     0,   761,   763,   774,   764,   770,     0,     0,
     766,   767,     0,     0,  1126,   424,     0,     0,     0,     0,
       0,     0,   118,  1186,  1959,   118,     0,     0,   367,   366,
     118,   365,   364,  1895,  1945,     0,   907,   118,     0,   160,
     579,   514,     0,     0,   650,  1990,   118,     0,     0,     0,
       0,   883,     0,     0,   498,   511,  1256,  1254,     0,   984,
     212,   211,   982,  1959,     0,   293,     0,     0,  1959,  1175,
       0,   721,  1959,     0,  1959,  1847,   153,     0,  1895,  1945,
    1959,     0,     0,  1959,   145,  1959,     0,  1959,   293,  1959,
     515,     0,  1959,     0,  1959,  1990,   147,     0,  1959,   293,
     732,     0,  1249,     0,  1225,  2154,  1238,     0,  1234,  1241,
    1237,  1330,   819,   818,     0,   819,     0,   819,     0,   819,
       0,   819,     0,     0,     0,   819,  1850,  1851,   801,     0,
     825,     0,     0,   832,   831,   830,     0,     0,     0,   833,
    1433,  1271,     0,  1108,  1125,     0,     0,     0,  1000,  1000,
    1000,  1121,   216,   214,     0,     0,     0,     0,     0,     0,
    1127,     0,     0,     0,     0,  1832,  1834,  1835,  1735,  1802,
       0,  2119,  2120,  2121,  1793,     0,  2122,  2123,  2124,  2167,
    1647,  1634,  1643,  1648,  1635,  1637,  1644,  2125,  2126,  1930,
    2127,  2128,  1842,  2129,  2130,  2132,  2133,  2134,  2135,  1639,
    1641,  2136,  2137,     0,  1843,  2139,  2140,  2010,  2142,  2143,
    2145,  2146,  1645,  2148,  2149,  2150,  2151,  2152,  2153,  1841,
       0,  1646,  2155,  2157,  2158,  2159,  2160,  2161,  2162,  2163,
    2164,     0,     0,  1816,     0,  1619,     0,  1465,  1466,  1488,
    1489,  1467,  1494,  1495,  1507,  1468,     0,  1815,  1532,  1618,
    1624,     0,  1617,  1613,  1332,  1811,     0,  1614,  1831,  1833,
    1794,   179,   228,     0,   229,  1817,  2062,   168,   209,   181,
     208,   182,   180,     0,  1893,   169,     0,     0,   170,     0,
       0,     0,     0,   225,   223,     0,  1116,     0,  1431,  1430,
       0,     0,  1800,  1820,   741,  1209,  1210,  1208,     0,  1205,
    1207,  1219,  1216,  1807,  1806,  1808,     0,  1325,     0,     0,
       0,  1307,  1306,     3,  1222,  1344,  1345,     0,     0,     0,
       0,     0,     0,     0,     0,  1387,  1360,  1361,  1363,  1384,
    1388,     0,  1313,     0,     0,  1435,     0,  1395,     0,     0,
    1830,     0,     0,     0,     0,   735,     0,     0,     0,     0,
       0,     0,   117,  1173,   219,  1171,     0,     0,     0,     0,
       0,     0,     0,  1178,     0,   151,   152,   526,   511,     0,
    1959,     0,     0,     0,     0,   940,   947,     0,     0,     0,
       0,     0,     0,     0,   941,   939,   942,   221,   951,   964,
     967,     0,   858,     0,     0,     0,     0,  1043,     0,     0,
    1043,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   239,   245,   288,   491,     0,     0,   493,     0,
       0,     0,     0,     0,     0,     0,   122,     0,     0,     0,
       0,     0,   478,   490,     0,     0,     0,     0,     0,   487,
       0,   118,   241,   471,   475,     0,     0,     0,   588,   587,
       0,  1043,     0,   237,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   307,
     308,     0,     0,     0,   122,   144,     0,     0,     0,   243,
       0,     0,  1135,  1132,  1133,     0,  1138,     0,  1195,     0,
       0,     0,     0,     0,   773,     0,     0,  1895,  1945,     0,
       0,     0,     0,     0,     0,   342,   321,   322,   118,   320,
       0,     0,   647,     0,  1855,  1476,  1505,  1483,  1505,  1505,
    1472,  1472,  1485,  1473,  1474,  1512,     0,  1505,  1472,  1477,
       0,  1475,  1515,  1515,  1500,     0,  1457,  1458,  1459,  1460,
    1486,  1487,  1461,  1492,  1493,  1462,  1529,  1472,  1856,     0,
       0,   658,     0,  1150,  1185,     0,     0,   520,     0,  1959,
       0,   120,   692,     0,   648,     0,   120,     0,   156,     0,
     583,     0,     0,     0,     0,     0,     0,   608,   607,     0,
       0,     0,   649,     0,   120,   474,  1959,     0,   424,   424,
       0,   882,   885,     0,     0,     0,  1299,  1301,  1300,     0,
    1298,     0,   293,   291,   292,   645,   992,     0,     0,     0,
       0,   293,     0,     0,  1959,   293,  1959,     0,  1959,     0,
       0,   293,   293,     0,     0,     0,     0,   584,     0,   731,
     729,   728,   730,     0,     0,     0,     0,     0,  1959,   293,
       0,     0,   714,  1745,     0,     0,  1330,     0,   198,   199,
     197,  1239,   200,  1240,  1236,  1224,     0,   809,     0,   813,
       0,   804,     0,   810,     0,   805,   802,   803,     0,   808,
       0,     0,   425,   427,     0,     0,  1915,  1929,     0,  1950,
    1978,  1979,  2053,  2058,     0,  2081,  2090,     0,   834,   863,
     829,     0,     0,  1283,  1109,  1751,     0,  1330,     0,   999,
     996,   995,   994,   215,   188,     0,     0,     0,   865,  2052,
    1124,   783,   511,     0,  1615,     0,  1622,  1623,  1504,  1491,
    1792,     0,     0,  1499,  1498,     0,     0,     0,     0,     0,
    1481,  1480,  1479,  1621,  1759,     0,  1478,     0,     0,     0,
       0,  1505,  1505,  1503,  1552,     0,  1482,     0,     0,  1772,
       0,  1778,     0,     0,     0,  1511,     0,  1509,     0,     0,
    1588,     0,     0,     0,     0,     0,     0,     0,     0,  1536,
    1537,  1619,  1745,     0,  1620,  1838,     0,     0,  1497,     0,
    1529,  1814,  1735,     0,     0,     0,     0,  1805,     0,  1743,
       0,     0,  1566,  1741,     0,  1568,     0,     0,     0,  1734,
    1732,  1733,  1726,  1727,  1728,  1729,  1730,  1731,  1739,  1549,
       0,     0,  1548,     0,     0,  1397,     0,  1836,  1795,   230,
     231,   227,     0,     0,   184,   183,     0,   202,   206,   207,
     178,   205,     0,   201,   186,  1687,  1686,   185,   177,   175,
     173,   189,   191,   192,   176,   174,   224,     0,     0,  1862,
    2188,  2189,  2190,  2191,  2192,  2193,  2194,  2195,  2196,  2197,
    2198,  2199,  2200,  2201,  2202,  2203,  2204,  2205,  2206,  2207,
    2208,  2209,  2210,  2211,  2212,  2213,  2214,  2215,  2216,  2217,
    2218,  2219,  2220,  2221,  2222,  2223,  2224,  2225,  2226,  2227,
    2228,  2229,  2230,  2231,  2232,  2233,  2234,  2235,  2236,  2237,
    2238,  2239,  2240,  2241,  2242,  2243,  2244,  2245,  2246,  2247,
    2248,  2249,  2250,  2251,  2252,  2253,  2254,  2255,  2256,  2257,
    2258,  2259,  2260,  2261,  2262,  2263,  1797,  1796,  1826,  1863,
    1864,  1865,  1866,  1801,     0,     0,   293,  1203,     0,  1200,
    1810,     0,  1327,     0,  1821,     0,  1212,  1323,  1322,  1353,
    1354,   900,  1321,  1378,  1379,  1374,     0,  1393,  1393,  1370,
    1364,  1369,  1367,     0,  1371,  1532,  1386,  1311,  1358,  1359,
    1362,  1310,     0,  1389,  1387,  1363,  1268,     0,     0,  1436,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   736,
       0,     0,     0,     0,     0,     0,  2081,   218,  1169,     0,
       0,     0,     0,   867,   866,     0,     0,   887,     0,     0,
       0,  1181,   413,     0,   290,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   524,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   558,     0,  1043,     0,   596,     0,   949,     0,   948,
       0,     0,     0,   950,   945,   946,  2053,  2062,  2086,   220,
     966,     0,   965,   963,   922,   924,   923,     0,   926,   910,
       0,   911,     0,     0,   921,   929,   927,     0,     0,     0,
       0,  1938,   247,   260,     0,  1042,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   280,     0,   283,   282,
       0,     0,     0,     0,   287,     0,     0,     0,   286,     0,
       0,   492,     0,     0,     0,     0,     0,     0,     0,   979,
       0,     0,   139,   142,     0,     0,     0,   477,   489,     0,
     481,   482,   479,   483,   484,     0,     0,     0,     0,     0,
       0,   476,     0,     0,   581,   580,   586,     0,     0,     0,
       0,     0,     0,     0,  1035,  1034,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     599,   600,     0,   601,     0,   143,     0,     0,     0,     0,
       0,     0,     0,   196,  1131,  1137,  1198,  1827,  1197,     0,
       0,     0,   775,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   326,
    1855,     0,   673,   646,     0,  1457,     0,  1453,  1449,  1518,
    1519,  1520,  1517,  1530,  1516,     0,  1463,  1521,  1472,  1469,
     659,     0,   661,   664,     0,  1148,   386,     0,   517,   558,
       0,     0,     0,   149,     0,     0,     0,   116,   160,   369,
       0,   159,   161,   163,   164,   165,   162,   166,   578,   582,
       0,   513,     0,     0,     0,     0,     0,   609,   613,   612,
     616,   614,     0,   610,     0,     0,  1445,     0,   138,   470,
     473,     0,     0,     0,   371,   455,   300,     0,     0,   884,
       0,     0,     0,     0,     0,     0,     0,  1297,     0,   970,
       0,  1176,  1959,   293,     0,   968,   154,  1848,     0,   715,
       0,     0,     0,     0,     0,   972,   711,   146,     0,   293,
     293,   516,     0,   293,   148,     0,     0,     0,   508,   293,
     733,  1251,     0,   424,  1226,  1235,   806,   815,   814,   812,
     811,   807,     0,   826,     0,   423,     0,     0,     0,   840,
     841,     0,     0,   839,   856,   842,     0,   844,   836,   835,
     845,   846,     0,     0,   865,     0,     0,  1280,     0,  1278,
       0,  1434,  1282,  1269,  1243,     0,  1242,  1246,  1248,  1247,
    1245,     0,     0,     0,   823,     0,     0,   293,  1123,     0,
     785,   786,   791,     0,     0,     0,   792,   788,   789,   790,
     793,   794,   795,     0,     0,     0,  1803,  1755,     0,  1756,
       0,     0,     0,  1791,  1787,     0,     0,     0,     0,     0,
       0,  1760,  1763,  1764,  1765,  1762,  1766,  1761,     0,     0,
    1767,     0,     0,     0,     0,     0,  1502,  1501,     0,     0,
       0,     0,     0,     0,     0,  1591,  1624,     0,     0,  1719,
       0,  1745,  1777,     0,     0,  1513,     0,     0,     0,     0,
       0,     0,     0,  1745,  1783,     0,     0,     0,     0,  1685,
       0,  1682,     0,     0,     0,     0,  1802,     0,     0,     0,
       0,  1839,  1533,  1550,  1813,     0,  1804,     0,     0,  1534,
    1557,     0,  1784,  1584,     0,  1589,  1572,     0,  1565,     0,
    1570,  1574,  1553,  1805,  1744,     0,  1742,     0,     0,  1551,
       0,  1546,  1544,  1545,  1538,  1539,  1540,  1541,  1542,  1543,
    1547,  1723,  1721,  1722,     0,     0,     0,  1569,  1952,  1987,
       0,  1343,  1343,  1343,  1331,  1341,  1812,     0,  1440,     0,
       0,     0,     0,  1702,     0,  1749,     0,  1747,  1829,  1818,
       0,     0,  1529,     0,  1432,  1798,     0,   739,   740,   738,
    1222,  1206,  1202,  1201,  1809,  1221,     0,  1330,     0,   898,
     899,     0,   903,     0,     0,  1372,  1385,     0,  1283,  1283,
       0,  1376,  1377,  1368,  1315,  1314,     0,  1443,     0,     0,
    1265,  1258,  1437,     0,  1397,  1285,  1287,  1288,     0,  1802,
     671,   670,     0,     0,     0,  1069,  1002,  1047,   737,  1070,
    1003,  1048,  1071,  1004,  1170,     0,  1172,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   634,  1959,   293,  1179,  1072,     0,  1005,   289,  1180,
    1049,  1184,  1050,     0,   525,     0,     0,   530,   531,   532,
       0,     0,   533,  1895,  1945,     0,   538,   544,   548,   539,
       0,   549,   545,     0,     0,     0,     0,     0,     0,   555,
     562,     0,     0,     0,     0,     0,     0,   943,   944,  1073,
    1008,     0,  1051,   925,  1472,   909,     0,     0,   920,     0,
     919,  1472,  1472,  1009,   150,     0,   240,   248,   564,  1045,
     266,   279,   274,   275,   273,  1959,   293,  1959,   293,     0,
       0,     0,     0,   276,   271,   272,   268,   281,  1871,  1931,
    2063,     0,   568,   570,     0,   575,   284,  1021,     0,   301,
     304,   285,   264,   267,   265,   261,   246,     0,     0,  1825,
       0,     0,   974,     0,     0,     0,   141,  1031,   131,     0,
       0,   127,     0,     0,     0,     0,   121,  1079,  1013,     0,
       0,   242,   472,   480,   485,  1017,   488,  1061,   486,  1085,
    1014,  1043,     0,   238,     0,  1015,     0,  1055,  1081,  1033,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1187,
       0,     0,     0,     0,     0,   293,     0,   680,  1045,  1959,
     293,  1080,     0,  1040,  1067,     0,   309,     0,  1032,     0,
       0,   244,  1019,  1063,     0,     0,   194,   193,   195,     0,
       0,     0,     0,     0,     0,     0,     0,   777,   748,   776,
       0,     0,     0,     0,     0,     0,     0,   742,   341,   318,
     319,     0,     0,   317,   323,     0,   672,     0,     0,  1454,
    1450,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1470,   660,     0,     0,     0,     0,  1168,  1168,  1168,  1168,
    1168,  1168,  1168,  1149,  1177,   118,     0,     0,     0,   519,
     557,   564,     0,   592,   595,     0,   593,     0,     0,     0,
       0,     0,   132,   119,     0,   700,   424,   155,     0,     0,
       0,   512,   657,   655,   654,   656,     0,     0,     0,   677,
     653,     0,  1444,  1446,     0,     0,     0,   469,   373,     0,
       0,   370,   374,   378,   379,   380,   427,     0,     0,   459,
       0,     0,     0,     0,   914,     0,   932,   915,     0,     0,
       0,   954,   959,   955,   935,     0,   496,  1302,  1303,     0,
     293,     0,     0,   559,   293,   293,     0,   293,     0,   293,
     293,     0,  1106,   585,     0,   642,     0,     0,   293,   713,
    1746,   827,   426,     0,     0,     0,     0,   838,     0,   494,
     843,     0,   855,   850,   852,     0,   859,  1281,  1272,  1276,
    1275,  1274,  1273,     0,     0,  1270,  1752,   712,     0,     0,
     293,     0,   860,     0,   787,     0,     0,     0,     0,  1348,
    1753,  1754,     0,     0,     0,     0,  1788,     0,     0,  1660,
       0,  1636,  1638,  1471,  1650,     0,  1484,  1661,  1662,  1640,
    1642,     0,  1736,     0,     0,  1651,  1593,  1594,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1606,  1605,  1652,  1718,     0,     0,  1775,  1776,  1653,
    1514,  1515,  1515,     0,     0,  1782,     0,     0,     0,  1658,
    1663,     0,     0,     0,     0,  1669,     0,  1690,     0,     0,
       0,  1616,  1746,  1506,  1507,     0,     0,     0,     0,     0,
       0,     0,     0,  1590,  1573,  1567,     0,  1571,  1575,     0,
       0,     0,     0,  1559,  1585,  1555,     0,     0,  1561,     0,
    1586,  1343,  1343,  1343,  1343,  1340,     0,     0,     0,     0,
    1407,  1396,  1398,  1409,  1400,  1402,  1438,     0,  1819,     0,
    1381,  1352,  1352,     0,  1702,     0,  1625,     0,  1702,     0,
       0,   171,     0,   203,   190,     0,  1204,  1822,     0,  1355,
       0,  1737,   903,   901,   902,  1357,     0,     0,  1392,  1391,
    1390,  1365,  1267,     0,  1265,  1260,     0,  1261,  1802,     0,
    1257,  1292,     0,     0,  1443,     0,  1291,  1068,  1001,  1046,
    1168,   870,   871,     0,   869,     0,     0,     0,   412,   886,
       0,     0,     0,   634,     0,     0,   416,     0,  1182,     0,
     527,   528,     0,     0,   546,     0,     0,   535,     0,     0,
       0,     0,   534,   551,   500,   552,   554,     0,     0,   553,
     556,   561,  1043,     0,   597,  1023,     0,  1065,   937,     0,
    1472,   912,   917,   918,     0,     0,     0,   386,     0,     0,
       0,   249,   259,     0,     0,   263,     0,   257,   277,   269,
     278,   270,   572,   573,   571,   567,     0,   574,   576,   298,
       0,     0,     0,  1075,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1076,  1052,     0,     0,   124,
     123,     0,   130,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   310,   295,     0,     0,     0,
       0,     0,   312,     0,     0,     0,     0,  1074,  1010,   743,
       0,     0,   744,   752,     0,     0,   745,     0,     0,     0,
       0,     0,     0,   754,   344,     0,   347,   354,   327,   331,
    1186,     0,  1186,     0,   332,  1186,   328,  1186,   325,  2010,
    1726,  1727,   668,   675,   665,   667,   669,   666,     0,   674,
     634,     0,     0,     0,  1455,     0,  1523,  1524,  1525,  1526,
    1527,  1528,     0,  1522,  1529,   662,   663,     0,  1168,  1167,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   398,     0,     0,   392,     0,     0,   959,   385,   388,
     389,   520,   523,   521,   522,   550,     0,   591,     0,   564,
     134,     0,     0,   135,   133,     0,   300,   369,     0,     0,
     615,   618,   611,     0,   676,   678,   651,     0,   564,     0,
    1252,     0,   465,     0,   455,   405,   451,     0,   453,   452,
     454,     0,   461,   299,     0,     0,   887,   913,     0,     0,
       0,   952,   956,   953,     0,     0,   928,     0,   936,   906,
    1101,  1102,  1099,  1100,     0,     0,  1294,   971,     0,   293,
     969,   716,     0,   707,     0,   709,   973,   293,   293,   602,
       0,   509,     0,     0,     0,   837,   857,     0,   853,     0,
       0,   820,   862,  1279,  1277,   865,     0,   821,   864,     0,
       0,     0,     0,     0,  1757,  1490,     0,  1790,  1786,     0,
    1633,  1758,     0,  1770,  1769,  1592,  1771,     0,  1611,     0,
       0,  1603,  1601,  1602,  1595,  1596,  1597,  1598,  1599,  1600,
    1604,  1780,  1779,  1773,  1774,  1510,  1508,     0,  1655,  1656,
    1657,  1781,  1664,     0,  1886,  1691,  1668,  1684,  1683,     0,
       0,     0,  1671,     0,     0,  1680,     0,  1720,  1496,  1529,
    1535,     0,     0,  1558,  1785,  1576,     0,     0,     0,  1554,
       0,     0,     0,     0,  1563,  1736,     0,     0,     0,     0,
       0,     0,  1334,  1333,  1339,  1317,     0,  1409,     0,  1408,
    1420,     0,     0,  1426,  1424,     0,  1426,     0,  1426,     0,
    1401,     0,  1403,  1420,     0,  1820,  1439,     0,  1383,     0,
       0,  1351,     0,  1702,  1632,  1705,  1700,  1701,  1750,  1626,
    1837,     0,  1748,  1702,     0,  1799,  1328,     0,  1356,  1373,
    1366,  1911,  1441,  1266,     0,     0,  1263,  1264,     0,     0,
    1286,  1265,  1289,     0,   876,   877,   875,   878,     0,     0,
       0,   634,     0,     0,   432,     0,   894,   894,     0,     0,
     418,   464,   959,   637,     0,     0,     0,   635,   293,  1006,
       0,   547,     0,     0,   543,   541,   540,   542,   501,  1084,
    1007,     0,     0,     0,     0,   938,     0,   930,  1022,     0,
     383,     0,   254,  1044,     0,     0,     0,   253,     0,   293,
     293,   569,   302,   303,   306,     0,     0,     0,     0,     0,
       0,   701,   684,     0,     0,   702,   703,     0,     0,     0,
     976,   977,   975,   128,   125,   126,   129,  1018,  1062,  1016,
       0,  1056,  1027,  1025,     0,     0,     0,     0,     0,  1083,
    1039,  1060,  1082,  1037,  1058,  1036,  1057,  1038,  1059,  1030,
       0,  1448,   682,   681,     0,   293,   293,   604,  1020,  1064,
       0,   746,     0,     0,   747,   758,   756,   755,   757,   749,
     345,   118,     0,   324,     0,   352,     0,   350,   349,   351,
       0,   338,     0,     0,     0,     0,     0,   644,     0,     0,
       0,  1451,  1456,  1531,  1464,   633,     0,  1159,  1158,  1157,
    1161,  1160,  1163,  1162,  1154,  1153,  1166,  1165,  1152,  1151,
    1156,  1155,     0,   390,     0,   396,   400,   401,   399,   391,
     959,   424,   463,   518,     0,   594,   589,   137,   136,     0,
       0,     0,     0,   620,   624,   652,     0,  1447,   598,     0,
     371,   469,   467,     0,     0,   376,   381,   382,     0,   459,
     402,     0,   455,   375,     0,     0,   466,  1146,     0,     0,
     916,   933,   934,     0,     0,   959,   958,     0,   503,   293,
     560,   293,   293,  1107,   643,     0,   849,   848,   847,   495,
       0,   851,   293,     0,     0,     0,     0,     0,   797,   778,
     796,  1789,  1649,  1659,  1768,     0,     0,  1612,     0,     0,
    1654,  2156,     0,     0,     0,     0,  1688,  1689,  1670,     0,
    2001,  1675,     0,     0,     0,  1840,  1582,  1580,  1577,     0,
    1578,     0,     0,  1560,  1556,     0,  1562,  1587,  1338,  1337,
    1336,  1335,  1411,  1418,     0,  1399,     0,  1425,  1421,     0,
    1422,     0,     0,  1423,     0,     0,  1418,     0,     0,     0,
       0,  1696,  1702,  1702,  1627,  1707,  1704,     0,  1629,  1529,
       0,     0,  1259,  1262,     0,  1293,  1284,  1174,     0,     0,
       0,   414,     0,   959,     0,     0,     0,   897,   897,     0,
     959,   463,   639,   638,   641,   636,   640,  1183,     0,   536,
     537,  1024,     0,  1066,  1028,   931,     0,   565,   250,   251,
     252,   255,   295,   262,   256,     0,  1077,  1011,  1053,     0,
       0,   690,     0,     0,     0,     0,  1078,  1012,  1054,     0,
       0,     0,     0,  1192,     0,   294,   295,   311,  1041,     0,
     750,   751,   326,     0,   348,   357,     0,   355,   329,   334,
       0,   336,   335,   330,   333,  1452,     0,   990,   990,     0,
     634,  1164,     0,     0,   387,   463,   431,     0,   393,     0,
       0,     0,   371,   564,   619,     0,     0,     0,   679,   373,
       0,  1250,   468,   372,     0,     0,   461,     0,     0,     0,
     459,     0,   456,     0,   460,     0,  1141,     0,     0,   957,
       0,   961,     0,   927,   904,  1440,     0,   507,   991,   708,
     710,   603,   854,   861,   293,   779,   780,   781,   782,  1607,
       0,     0,     0,     0,  1665,     0,  1666,  1693,  1692,  1672,
    1676,     0,  1673,  1674,  1579,  1583,  1581,  1564,  1410,     0,
       0,  1412,     0,     0,  1414,  1416,     0,     0,     0,     0,
       0,  1823,  1702,  1380,  1382,     0,  1318,  1630,  1631,     0,
    1352,  1702,   204,  1738,  1442,  1290,   855,     0,   293,   894,
     463,   433,  2010,   434,   893,     0,   895,   900,   900,     0,
     463,   634,   529,     0,   563,     0,   297,   305,     0,     0,
     697,   685,     0,     0,   704,  1026,     0,     0,     0,     0,
       0,   293,   753,   316,   343,   353,     0,   337,   990,     0,
     987,   986,   632,     0,   422,   394,     0,   442,     0,   564,
     694,  1146,   577,   621,   622,   617,     0,     0,   455,   451,
     377,   386,   360,   411,   410,   407,   406,   408,   409,   404,
     403,     0,   461,   457,   458,     0,     0,     0,  1194,     0,
     888,   960,     0,     0,     0,   502,     0,     0,   506,   497,
     822,  1608,     0,  1609,     0,     0,     0,  1678,  1677,     0,
    1419,  1428,     0,  1415,  1413,  1404,     0,  1406,  1695,  1697,
       0,     0,  1710,  1628,   872,     0,   873,   897,   437,     0,
     896,   903,   903,   424,   634,   415,  1029,   566,     0,   258,
       0,   688,     0,   699,   697,     0,     0,  1188,     0,  1189,
    1190,  1193,   313,   356,   985,   989,   988,     0,     0,   395,
     428,   429,   430,     0,   397,   438,   439,     0,   590,     0,
       0,  1142,     0,     0,   459,   455,   384,   450,   358,     0,
    1143,     0,   300,     0,   959,   962,  1105,   505,   504,  1610,
    1681,  1667,  1694,  1679,  1417,     0,  1405,     0,     0,  1706,
       0,     0,     0,     0,   900,     0,   634,     0,   891,   890,
     431,   417,   296,     0,     0,   695,   698,   686,   699,   706,
     705,     0,     0,   421,     0,     0,     0,   440,     0,   441,
     462,   693,     0,   623,     0,   461,   459,  1144,  1145,   461,
     889,   905,  1104,  1103,  1330,  1427,  1698,  1699,  2118,  1911,
    2092,     0,  1708,  1711,  1709,  1703,   293,   903,     0,   419,
     435,   442,     0,     0,   687,  1191,   624,   447,     0,   446,
       0,   444,   443,   683,   627,   361,   461,  1440,  1087,  1330,
    1086,  1088,  1096,  1093,  1095,  1094,  1092,     0,  1715,  1714,
    1713,  1717,  1716,   874,   892,     0,   634,   689,   696,     0,
     445,   449,   448,   629,     0,   625,   628,   630,   631,   359,
     879,     0,  1097,  1091,  1317,  1304,     0,   436,   420,     0,
     605,     0,  1089,  1330,  1712,     0,   626,  1090,     0,   627,
       0,   606
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    48,    49,    50,    51,  1173,  2063,  1942,  2712,  2713,
      52,    53,  1247,    54,    55,    56,    57,    58,    59,    60,
    1188,    61,    62,   858,  1388,  2071,    63,  1817,   670,   671,
    1660,  1661,  2004,  1662,  1650,  1089,  1472,  1207,  1175,  1208,
      65,    66,  1083,  1641,    67,    68,    69,  1232,  1233,  1183,
    1425,  3571,  4109,  1928,  2751,  2548,  2549,    70,  1289,  1290,
      71,    72,  2661,  1328,  2663,  2664,  3168,   510,  2028,  3591,
    3592,  3155,  3156,  3598,  3856,  3857,    73,  1385,  2740,  3254,
    2741,  3664,  2742,  3665,  2743,  3666,  2694,  3218,  3219,  3220,
    2744,  3670,  4049,  2745,  1832,  4129,  2105,  1494,  1492,  4027,
    3473,  3474,  4176,  4134,  4135,  4136,  4241,  3672,  2749,  3262,
    3676,  3878,  2451,   589,  1407,  3252,    75,    76,  2099,  1263,
    1264,  1949,  3172,  2800,    77,   875,  3033,  3917,  4068,  4069,
      78,   197,    79,  1392,    80,    81,  2058,  2699,    82,  1844,
    2464,    83,    84,  2489,  2490,  2491,    85,    86,  3057,  3816,
    1234,  2541,  2542,  2543,  2544,  3077,    87,  1390,  1269,  2080,
      88,    89,    90,  2062,  2705,  2706,    91,    92,  1992,    93,
      94,    95,  1400,  2092,  2093,  3654,  3885,  4035,  3887,  4274,
    4275,  3870,  3016,  3487,    96,    97,    98,    99,  1371,  2051,
    2052,  3173,  1159,  1332,  2031,  2032,  3243,  3244,   100,   101,
    3531,  3532,   540,  4140,  4113,  4187,   102,   103,  3535,  3536,
     104,   105,   106,   107,   108,   583,   919,   920,  1165,   109,
    1756,   110,   833,  2648,   111,   983,  2224,  3709,   112,   612,
     933,   934,   113,   114,   621,  2204,   623,  1507,  2802,  2803,
    3311,  2173,   754,   115,   116,  2184,  2207,   117,  1176,  1823,
    1824,  3468,   118,   541,  1412,  2108,  2446,  4059,  3475,  3797,
    3987,  2392,  2975,   119,   542,  1212,  1890,  2111,  2755,  2756,
    1892,  2364,  3275,  1894,  2757,  2762,  2763,  2764,  3271,  3279,
    3911,  3912,   120,  1210,  1883,   121,   122,   123,  1242,   777,
     124,   553,   554,   125,  4020,   126,   887,   127,   639,  1520,
     128,  1906,  3063,   129,   130,   131,  4250,  4281,  4282,  4283,
    3284,  4214,   132,  4252,   963,   134,   135,   136,   171,   801,
     802,   803,   137,  3906,   138,   139,  2055,  2693,  3200,   140,
     141,  1818,  2436,   142,   143,   144,  1375,   145,   146,   147,
     148,  1308,   149,  1118,  1119,   150,   151,   505,   687,  1122,
    1130,   152,   591,   927,   928,   929,  1474,   153,   966,  2196,
     592,   922,   155,   593,  2410,  2986,  2987,  2990,   594,  2407,
     158,  1513,  2190,  2193,   595,  2414,  2415,  2416,  2417,  2418,
    2992,   596,   614,   878,  2116,   597,  1055,   163,   164,   165,
     696,   691,   692,   167,  1635,  2354,   629,  1137,   658,   704,
    3431,  1769,  1770,  1790,  1791,  1146,  1147,  1780,  1782,  2394,
    1783,  2403,  1775,  3428,  3771,  1786,  1787,  1149,  1150,  2398,
     168,  2358,  2941,  2942,  2943,  3409,  3419,  3758,  3954,  2944,
     961,  1156,  2945,  2950,  2984,  2731,  2732,  2733,  1895,  2038,
    1356,  1056,  1357,  2049,  1057,  1556,  1359,  1058,  1059,  1060,
    1362,  1061,  1062,  1063,  1064,  1539,  1598,  1065,  1066,  1575,
    2046,  2047,  1463,  2264,  1068,  1069,  3375,  3733,  3722,  2290,
    2291,  1657,  3371,  2893,  3966,  4088,  4089,  3439,  3436,  3775,
    3970,  4172,  4222,  4223,  1070,  2344,  1628,   779,  1071,  3175,
    1630,  2284,  2366,  2367,  1802,  1537,  2230,  2248,  2249,  2261,
    2854,  2268,  2273,  2877,  2878,  2285,  2313,  1072,  2233,  2234,
    2837,  1541,  1073,  1112,  1113,  1534,  2308,  1125,  1126,   689,
    1074,  1075,  1508,   680,  3950,   500,   745,  2558,  1747,   805,
     626,  1076,  1077,  1078,  1079,   895,   896,  1238,   501,   739,
     758,  2545,   502,   503,   741,  1752
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -3845
static const int yypact[] =
{
    5178,  1175,  2711, -3845, -3845,  1175, -3845, 51566,   754,   647,
     984,   150, 12033, 51974, 58910,   509,   257,  7751,  1175, 58910,
    2100, 38918, 49118, 58910,  1150,   845, 38918, 58910, 59318,  1005,
     736, 59726, 52382, 47894,  1168, 58910,  1136,   335, 60134, 52790,
    1041, 53198,   845, 36082,   105,  1037, 60542,  1635,  1476,  1085,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845,   754, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845,   267, -3845,   129,   277,  1686,   739,  1051, -3845,
   -3845, -3845, 43406, 58910, 58910, 58910,  1397, 58910, 58910,   676,
   43406, 43814, 60950,  1462, 32738, -3845, 43814, 58910, 61358, 58910,
   53606, 58910,  1385, 58910, 58910, 44222, 61766,  1521,   194, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, 58910,  5474,  1150, -3845, -3845,
   58910,  1400, 43406, 58910,  1351, 58910,  1463, 58910, -3845, 58910,
   62174,   678,  1398, 43814,  1414, 33159,  1537, 43814, 58910, 58910,
   58910, -3845, -3845,  1573, 58910, 58910, -3845, -3845, 44630,    13,
    1817,  1751,   793, -3845, 54014, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, 42182,   257, -3845, -3845, 45038, 58910,  1736, -3845,
   -3845, 62582, -3845, -3845,   723, 45446, 45854,  1861, 33580,  1902,
   46262, 62990, -3845, -3845, 63398, -3845, 63806,  1647, 64214, -3845,
   46670, -3845,  1763, 64622, -3845,  1566,  1443,   696, 29419, -3845,
     754, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,   345,
    1479,   191,   228,   197, -3845, -3845,   238,   254,   255,   345,
    1995,  1995, -3845, 58910, -3845, -3845,  1479,   569,  1598,  1598,
    1598,  1785,   958, -3845,  1598, -3845, -3845, -3845, -3845, 53198,
   -3845,  1613,  1150,  1628,  2011, 58910, -3845, 58910, -3845, 58910,
   58910, -3845, -3845,  2025,  1659,  1889,  1678, -3845,  1871,  1886,
    1893,   137,  1150,  1788, -3845,  2004, -3845,  1959, 20577,  1150,
   54422, 65030,   162, 42182,  1150, 54830,  1752,  1161,  1916, -3845,
   -3845,   722, -3845,  2161,  1809,  2013,  1678,   194, 30661, -3845,
    1792,  1417, 53198, -3845, -3845, -3845,   184,  2073, 21002, -3845,
   58910,  1801, -3845,  1822,  1831,  1835,  1686, -3845,  5178, 58910,
    1230,  1230,  2224,  1230,  1345,  1676, -3845,  2062, -3845,  2133,
    2114, 53198,  1037,   179, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845,  1881,  1417, -3845,
     180, -3845,  1389,  1897,  1574,  1629, -3845, -3845,   790,  2007,
     153,   802,  1914, 55238,  2678,  1904, -3845,   294, -3845, -3845,
   -3845, -3845,  2200,  4124,   319, -3845, 58910, 58910, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845,  1909, -3845, -3845,
    1908,  1189,   683,  2213,  8520,  1328,  2218,  4943,  1534,   764,
    2108,  1174,  2221,  1269,  2258,  5789, 58910, -3845,  2190,  2301,
      51, -3845,   628, -3845,  2026,  2164,   563, 43406,  1985, -3845,
   -3845, 58910, -3845, -3845, -3845, -3845,   726, 43406, -3845,  2183,
   34001, -3845, 58910, -3845, -3845, -3845, -3845, -3845,  2124, 58910,
   -3845, -3845,  2238, 58910, -3845,  1598,   247,  2020,  2379, 73554,
      75, 58910,  2068,  2431,  2232,  2068,  2071, 65438, -3845, -3845,
    2068, -3845, -3845, 58910, 58910,  2057,  1319,  2068,  2439,  2451,
    2129,  2239,   874,   299,   157,  2354,  2068, 58910, 65846, 58910,
   58910,  2436, 43406, 58910, -3845,  2228, -3845, -3845,   797, -3845,
   -3845, -3845, -3845,  2376,  1881,   182,  2389,  2099,  2395, -3845,
    2136, -3845,  2398,  1904,  2399, -3845,  2106, 66254, 66662, 67070,
    2403,  1909, 43814,  2404,  2106,  2405,  2294,  2407,   182,  2408,
   -3845,   886,  2410,  2299,  2413,  1491,  2106, 42590,  2414,   164,
   -3845, 22702, -3845,  2207, -3845,  1037, -3845,   -56, -3845, 38510,
   -3845,   696,  1479, -3845, 58910,  1479, 58910,  1479, 58910,  1479,
   58910,  1479, 58910, 58910, 58910,  1479, -3845, -3845, -3845, 58910,
    2125, 58910, 58910, -3845, -3845, -3845, 49526, 43814, 49934, -3845,
   -3845,   189,  1150, -3845, -3845, 73554,  2519, 43814,  2409,  2409,
    2409, -3845, -3845, -3845,  2348, 58910,  2411,  2412, 49526, 43814,
   -3845, 67478, 42182,  2312,  2134, -3845, -3845, -3845, -3845, -3845,
    1361,  2555,   302,  2557, 22702,  2140,   219,   219,  2148,  2432,
   -3845, -3845, -3845,   217,  2152,  2156, -3845,   218,   218,  2307,
    2163,  2168, -3845,   264,  2175,  2586,  2599,   266,  2180,  2181,
    2182,   899,   219, 22702, -3845,  2184,   218,  2185,  2186,  2187,
    2605,  2188, -3845,  2611,  2191,   293,   296,  2193,  2195, -3845,
    2163, -3845,   235,  2196,  2197,  2198,  2199,  2202,  2204,  2208,
    2209, 22702, 22702, -3845, 19727,  1417,  1150, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845,   140, -3845,   284,  4302, -3845, -3845,
    2360, 22702, -3845, -3845,   575, -3845,   287, -3845, -3845, -3845,
    1417, -3845, -3845,   223,  2210, -3845,  1133, -3845, -3845, -3845,
   -3845, -3845, -3845, 40958,  2595, -3845,   341,  1150,   628,   279,
    2551, 37694, 38102, -3845, -3845,  2433, -3845, 58910, -3845, -3845,
   22702, 35674, -3845,  1417,   141, -3845, -3845, -3845,   974, -3845,
   -3845, -3845,   754, -3845, 10669, -3845,  1137,  1801, 58910, 58910,
    2607, -3845, -3845, -3845,  1822, -3845, -3845,  1686,  1686, 22702,
    1686,  1007,   926, 21427, 22702,  2496,  2400,   773,  1333,  2497,
   -3845,  1345,  1676, 53198, 58910, 67886,  2324, -3845, 36898,  1597,
    1417,  2296,  2298,  2347, 39734,  2230,  2308,  2311,  2352,  2313,
    2314, 68294, -3845, -3845, -3845, -3845,  1125,  1088,  1224,  2316,
     404,   697,  2588, -3845,  2363, -3845, -3845, -3845,  2016, 58910,
    2538,  6232,  2428,   319,  2365, -3845, -3845,  2477,  2329,  2330,
    2446,   319,   759, 68702, -3845, -3845, -3845, -3845, -3845, -3845,
    3500, 18075, -3845,  2332,  2317, 58910, 47078,  2617,  2441,   937,
     300,   200, 58910,  2516,  2450, 58910,  2268,  2346,  2350,  2273,
     989,  2624,  2276, -3845, -3845, -3845,  1547,  2444, -3845,  2331,
    2337, 72352,   669, 34422,  2623,  2370, -3845,  1083,  2371,  2372,
   58910,   319, -3845,  2679,   319,   319,  1447,  2681,  2378,   343,
    1258,  2068,  2276,  1453, -3845,  2380,  2381,   244, -3845,  2488,
   53198,   377,  1363,  2276,  2384,  2387,  2273,  2273, 58910, 58910,
   58910, 58910, 58910,   158,  2703,  2704,  2390,   170,  2437,  2315,
   -3845, 41366,  2391, 65030, -3845, -3845, 58910,  2406,  1388,  2276,
     999,  1378, -3845, -3845, -3845,   194, -3845, 58910, -3845, 58910,
    1881, 73554,  2505,  2357, -3845,  1904,   319, 58910, 58910,  1909,
     679,   936,  2509, 58910,  2568,  2369, -3845, -3845,  2068, -3845,
   37296,  2057, -3845,  2336, -3845, -3845,  2383, -3845,  2383,  2383,
    2338,  2338,  2341, -3845, -3845, -3845,   899,  2383,  2338, -3845,
   74348, -3845,  1607,  1669, -3845,  2739,  2741, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845,   147,  1517, -3845, 58910,
   39734, -3845,  2753, -3845, -3845, 73554,  2640, -3845, 58910,  2543,
    2351, -3845,  2676,  2415, -3845,  2394, -3845, 43814,  1018,  1150,
    2396, 58910,  2570, 58910, 58910, 58910, 58910, -3845, -3845,  2545,
     712,   159, -3845, 41366, -3845,  1453,  2553,  2757,    20,  1598,
    2647, -3845, 58910,  2367,  2763,  2600, -3845,  1247, -3845,  2490,
   -3845, 43406,   182, -3845, -3845, -3845, -3845, 73554, 58910, 69110,
   43406,   182, 43814, 43814,  2662,   164,  2669,  2438,  2671,  2442,
   34422,   182,   168, 43814, 58910, 58910, 58910, -3845, 58910, -3845,
   -3845, -3845, -3845, 58910, 58910, 43814, 41366,  2672,  2673,   182,
   58910, 58910, -3845, 10669,  1404, 58910,   696, 41774, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, 58910, -3845, 58910, -3845,
   58910, -3845, 58910, -3845, 58910, -3845, -3845, -3845, 58910, -3845,
   58910,  1424, -3845, -3845,  1446,   746, 58910, 58910,   176, 43406,
   58910,  2569, 58910, 58910, 58910, 58910, 58910,  2459,  2210,  1042,
   -3845,   188, 53198,  2577, -3845, -3845,  1451,  1635,   990, -3845,
   -3845, -3845, -3845, -3845, -3845, 49934, 49118,  2668,    70, 58910,
   -3845, -3845,  2733, 22702,  1417, 20152, -3845, -3845, -3845,  2393,
   10669,  2435, 22702, -3845, -3845, 22702,  2402,  1995,  1995, 22702,
   -3845, -3845, -3845, -3845,   833,  1995, -3845, 22702, 22702,  1995,
    1995,  2383,  2383, -3845,  5536, 22702, -3845, 34422, 22702, 25252,
   17243, 22702,  2470,  2416,  1995, -3845,  1995, -3845, 22702, 19302,
   -3845, 22702,  2608, 26096, 22702,   279,  2609, 22702,   279,  2821,
    2821,  1416,  4381,  2418,  1417, -3845,  2515,  1995, -3845,  1995,
     636, -3845,   207, 73554, 22702, 39734,  2487,   173, 58910, 22702,
    2426,  1722, -3845, 22702,   992, -3845,  2427, 22702,  2484, 22702,
   22702, 22702, 22702, 22702, 22702, 22702, 22702, 22702, -3845, 26924,
     221,   566,  1193, 55646, 20577,  2688, 16817, -3845,   290, -3845,
   -3845, -3845, 58910,  2595, -3845, -3845,  2485, -3845, -3845, -3845,
   -3845, -3845,   291, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
    2429, -3845, -3845, -3845, -3845,  2429, -3845,  2417,  3478, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845,  2677,  2693,   182, 58910,   184, 50342,
   -3845, 21002, -3845,  1502, -3845,  2434, -3845,  2653, -3845,  2440,
   -3845,  8179,  2653, -3845, -3845,   313,  2618,  2622,  2622, -3845,
    2443, 10669, -3845,  1665, 10669,  1672, -3845, -3845, -3845, -3845,
   -3845, -3845,  1034, -3845,  2496,  1333,  2468,   127, 58910, -3845,
   31075,  2449,  1528,  2514,  2525,  2561, 43814, 58910, 58910, -3845,
   39734, 43814, 58910, 58910, 43814, 58910, 58910, -3845,  2796,   933,
   49118,  2571, 48302, -3845, -3845,  2453, 58910,  2508,  2694,  2696,
     875, -3845, -3845, 69518, -3845,  2646, 43814, 58910, 58910, 22702,
    2651, 58910, 58910, 58910,  2540, 43406,  2472, 58910, 58910, 58910,
     728, 43406, 34843, 58910, 58910, 58910, 58910,  2585, 58910, 58910,
    2699,  1309, 53198,   380,  1465,  2276,  2665, -3845,  1012, -3845,
   43814, 58910,  2667, -3845, -3845, -3845, 56054,  2876,  2590, -3845,
   -3845, 69926, -3845, -3845,  2664, -3845, -3845, 74348, -3845, -3845,
    1580, -3845, 73951, 70334, -3845, -3845,   476, 43814, 43814,  6637,
   58910,  1040, -3845, -3845, 73554, -3845, 58910, 58910, 58910, 50750,
   70731, 71139,  1052,  1095, 58910, 51158, -3845, 58910, -3845, -3845,
   40142, 43814, 58910, 39734, -3845, 58910,  2682,   220, -3845, 58910,
    2826, -3845,  2572, 58910, 58910,  2492,  1596,  2574,  2625, -3845,
   58910, 43814,   787, -3845, 43814, 58910,  8553, -3845, -3845,   319,
   -3845, -3845, -3845, -3845, -3845, 58910, 58910,   319, 58910,   319,
    1106, -3845, 43814, 58910, -3845, -3845, -3845,  7224, 58910, 58910,
   58910, 58910, 43814, 58910, -3845, -3845,  1221,   934,    72,  1373,
    2645, 58910,  1150, 58910, 71547, 43814, 58910, 58910, 58910,   998,
   -3845, -3845,  2620, -3845, 43814,   787,  7344, 58910, 58910,  2589,
    2591,   144,  2660, -3845, -3845, -3845, -3845, -3845, -3845,  2754,
    2913, 58910, -3845,  2756,  2759,  2578,  2579,  2760,   804, 58910,
   58910, 58910, 58910, 58910, 58910,  2764,   804,  2709,   114,  2530,
    2544,  1611, -3845, -3845, 22702,  2930, 73554,  2537,  2539,  2610,
    2612,  2613, -3845,  2541,  2614,  1995, -3845, -3845,  1560, -3845,
   -3845,  1637, -3845,  2560,   712,  1419, -3845, 58910,   766,   110,
    2840, 18472,  2659,  2629,  2832, 58910, 58910,  2629, -3845,  1771,
   49118, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
    2831, -3845,  1150,  2057,  2057,  2057,  2057, -3845, -3845, -3845,
   -3845,  2737,  1483, -3845,  2554,  2057, 58910,  2670,  2629, -3845,
    1453,  2847,   119, 58910, 47486,  1604,  2592,  1150,  2744, -3845,
   18887,  3132,  2746, 42182,  2823,  2834,  2848, -3845,  1881, -3845,
    2967, -3845,  2865,   182,  1904, -3845,  2106, -3845, 58910, -3845,
   58910, 58910, 58910, 58910,  1909, -3845, -3845,  2106,  2758,   182,
     182, -3845,  2762,   182,  2106,  2684,  2858, 42182, -3845,   164,
   -3845, -3845, 22702,  1598, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845,  1681, -3845, 58910, -3845,  2841,  2843,  2845,  2580,
    2587,  2621, 58910,  2593, -3845,  2580,   319,  2580,  2210,  2210,
    2580,  2587, 42998,  3001,  2864,   175,   686, -3845,   693,    34,
    2800, -3845, -3845, -3845, -3845, 73554, -3845, -3845, -3845, -3845,
   -3845, 58910,   167,  2776,  2596, 42998,  2977,   182, -3845, 43406,
   -3845, -3845, -3845,  2686, 43406,  2788, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845,  2833, 58910,  1687, -3845, -3845,  1305, -3845,
    1312, 22702, 22702,   365, -3845,  9582,  1729, 22702,  2604,  2606,
    1744, -3845, -3845, -3845, -3845, -3845, -3845, -3845,  2615,  2882,
   -3845,  2616,  1745,  1762,  2627,  2633, -3845, -3845,  2295,  2634,
    9901,  2635, 25252, 25252,  1306, -3845, -3845, 25252,  2636, -3845,
    1768,  9025,  2619,  2639,  2626, -3845,  2642,  2643,  9757, 21852,
   22702, 21852, 21852, 10302,  2619,  2654,  1774, 39734,  2773, 10567,
    1783, -3845, 22702, 39734,  3776, 22702, -3845, 22702, 58910,  2655,
    2656, -3845, -3845,  5536, -3845,  2628, -3845, 25252, 25252, -3845,
    5810, 19727, -3845, -3845,  2888, -3845, -3845,  1583, -3845,  2661,
   -3845, -3845,  6251,   201, 22702,  2426, 22702,  2687, 34422,  2486,
   22702,  4908,  2178,  2178,   383,   383,   253,   253,   253,  1728,
    1193, -3845, -3845, -3845,  2666,  2188, 22702, -3845,  1784,  1837,
   58910,  1884,  3151,  3835, -3845, -3845, -3845, 28177,  2663, 22702,
   22702, 22702,  2674,  2789,  3033, 10669,   792, -3845,  3036, -3845,
     194,  1995,   636, 38510, -3845, -3845, 22702, -3845, -3845, -3845,
    1822, -3845, -3845, -3845, -3845, -3845, 58910,  1635, 22702, -3845,
   -3845,   329,  1601, 22702,  1665, -3845, -3845, 58910,  2577,  2577,
   22702, -3845, -3845, -3845, -3845, -3845, 28177,  2691,  2706, 30247,
    2793, -3845, -3845, 58910,   181, -3845, -3845, -3845,  2637, -3845,
   -3845, -3845, 43814, 58910, 58910, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845,  2887, -3845, 43814, 43814,  2805,
   58910,  2824,  2850, 22702,   917, 58910,  2680,  2683,  1097,  2925,
   58910, -3845,  2968,   182, -3845, -3845,  2751, -3845, 10669, -3845,
   -3845, -3845, -3845, 42182, -3845,  1881, 73554, -3845, -3845, -3845,
    2712, 58910, -3845, 58910, 58910,  1909, -3845, -3845, -3845, -3845,
     985, -3845, -3845, 58910, 58910,    85,  2752,  2761, 58910, -3845,
     691,  2488,  7663, 58910, 58910, 58910,  2927, -3845, -3845, -3845,
   -3845,  2873, -3845, -3845,  1517, -3845, 70334, 73951, -3845, 73951,
   -3845,  1517,  1358, -3845,  2106,  2770,  2276, -3845,  2861,   139,
   -3845, -3845, -3845, -3845, -3845,  2978,   182,  2989,   182, 58910,
   58910, 58910, 58910, -3845, -3845, -3845, -3845, -3845, 39734, 39734,
   39734,  1797, -3845, -3845,  1150, -3845, -3845, -3845,  1802, -3845,
    1263, -3845, -3845, -3845, -3845, -3845, -3845, 43814,  1680, -3845,
     823, 73554, -3845, 72749, 43814, 58910, -3845, -3845, -3845,  2916,
    2862, -3845,   853,  2863, 43814,  2765, -3845, -3845, -3845,  2777,
    1545,  2276,  1453, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845,   403,  1740,  2276,  2778, -3845,  2780, -3845, -3845, -3845,
    2909,  2912,  2917,  2783,  2791,  2837,  2794,  2797,  2846, -3845,
    2806,  2857,  2814,  2860,  2816,   182, 73554,  1271,  2829,  3023,
     182, -3845,  2817, -3845, -3845,  3133, -3845, 58910, -3845,  2819,
    1786,  2276, -3845, -3845, 43814, 58910, -3845, -3845, -3845,   804,
   73554,  2981,   804,   804, 58910, 58910,   804, -3845, -3845, -3845,
    2982,  2984,  2986,  2987,  2988,  2992,   804, -3845, -3845, -3845,
   -3845,   247, 39734, -3845,  2275, 32317, -3845,  3178,  4671,  2772,
    2539,  2771,  1995,   178,   757,   133,  2875,  1995,  2964,  2774,
   -3845, -3845, 39734, 32317,  1523,  2979,  2775,  2775,  2775,  2775,
    2775,  2775,  2775, -3845,  2697,  2068, 42182, 58910, 42182, -3845,
     110,  2861, 58910, -3845, -3845,  1811, -3845, 58910, 43814,   701,
   43814,  1995, -3845, -3845,  2828, -3845,  1598,  1018,  2907,  1049,
    3104, -3845, -3845, -3845, -3845, -3845, 58910, 58910,   712,  1150,
   -3845,  2779,  2781, -3845, 58910, 58910, 58910,  2812,  2782, 58910,
    2785,  2786, -3845, -3845, -3845, -3845, 73554,   571,  2970,  2963,
    2273,  3182,  2866, 58910, -3845,  1812,   111, -3845,  1150, 42182,
   71955, -3845,  1544, -3845, -3845,   843,  3058, -3845, -3845,  1635,
     182, 73554, 58910, -3845,   182,   164,  2849,   182,  2851,   182,
     182, 58910, -3845, -3845, 58910, -3845, 58910, 41366,   182, -3845,
   10669, -3845, -3845,  2914,  2915,  2919, 58910,  2580, 43406, -3845,
    2790, 43814,  1065, -3845, -3845,  2983, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845,  3087,  3095, -3845, -3845, -3845, 43814, 49526,
     251, 43814, -3845,  1881, -3845,  1904,   319, 58910,  3039, -3845,
   -3845, -3845,  2811,  1825, 10522, 22702, -3845,  3110, 73554, -3845,
    4935, -3845, -3845, -3845, -3845, 22702, -3845, -3845, -3845, -3845,
   -3845, 22702, -3845, 22702,  3090, -3845,  3232,  3232, 73554, 25252,
    1395,  2185, 25252, 25252, 25252, 25252, 25252, 25252, 25252, 25252,
   25252, 27349,   710, -3845, -3845, 22702, 22702,  3098,  3090, -3845,
   -3845,  1084,  1084, 73554,  2825,  2619,  2827,  2830, 22702, -3845,
   -3845,  1826, 26510,  2838, 39734, -3845, 22702,  9111,  1844,  2868,
   10631,  1417,  5469, -3845,  3188,  1150, 22702,   763,  1867, 22702,
    1864, 22702,  3100, -3845, -3845, -3845,  2835, -3845, -3845, 73554,
   22702, 25252, 25252,  6323, -3845,  6384, 22702,  2844,  7115, 19727,
   -3845,   845,   845,   845,   845, -3845, 58910, 58910, 58910, 27763,
   56462,  2842,  1622, -3845, 56462, 56870, -3845,  2853,  1417, 22702,
    3093,    22,    22,  2854,  2789, 31489, -3845, 22702,   234, 22277,
    2855,   628,  2856, -3845, -3845,  5671, -3845, -3845,  2859, -3845,
    2867, -3845,  1601, -3845, -3845, -3845,  5578,  3009,  2210, -3845,
   -3845, -3845,  2842, 23127,  2793, -3845,  1870, -3845, -3845, 20577,
   -3845, -3845,  1890, 31075,  2691, 21002,  1417, -3845, -3845, -3845,
    2775,  2106,  2106,   827,  2580,  3113,   827,  6311, -3845, -3845,
   28591, 58910, 58910, -3845, 58910,  1891,  1157, 58910, -3845, 58910,
   -3845, -3845,  3228, 58910, -3845,  2886,  2893, -3845, 58910, 58910,
   58910, 58910, -3845, -3845,  1897, -3845, -3845, 43814, 58910, -3845,
   -3845, -3845,   405,  1983,  2276, -3845,  2918, -3845, -3845,  3092,
    1679, -3845, -3845, -3845,  2923, 58910,  2869, -3845,   774,  2273,
     768, -3845, -3845,  2924, 58910, -3845, 58910, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, 40142, -3845, -3845, -3845,
   39734, 32317, 39734, -3845,  2922,  2935,  2961,   831,   742,  2936,
    2937,  2969,  2870,  2871,  2877, -3845, -3845,   345,  1150, -3845,
   -3845,  1150,  2106,  1150, 58910, 58910, 58910, 58910, 58910, 58910,
   58910,  3130,   183,  1595, 43814, 58910, 58910, 43814, 58910, 58910,
   58910, 58910, 58910, 58910, 58910, -3845,  3211,  1150,  1150,  3195,
    2933, 58910, -3845, 58910,  2488, 58910, 58910, -3845, -3845, -3845,
    2878,   804, -3845, -3845,  3111,  3112, -3845,   804,   804,   804,
     804,   804,   804, -3845,   130,  1915, -3845, 29005, -3845, -3845,
    2431,  1150,  2431,  1412, -3845,  2431, -3845,  2431, -3845,  2867,
    1995,  1547, -3845, -3845, -3845, -3845, -3845, -3845,  2544, -3845,
   -3845,  1995,  1682,  2883, -3845,  2885, -3845, -3845, -3845, -3845,
   -3845, -3845,  2880, -3845,   636, -3845, -3845, 58910,  2775, -3845,
     919,   334,  1053,  1071, 57278, 57686, 58094,  2889, 58910, 58910,
   25252, -3845,   811,   813, -3845,  3117, 58910,  2928, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845,  2351, -3845, 58910,  2861,
    2106, 43814, 43814,  2106, -3845, 73554,  2592,  1443, 65846,  2926,
    2884,  3177, -3845,  2896,  2894, -3845, -3845, 58910,  2861,    29,
    1566,   246, -3845, 48710,  1604, -3845,  3150, 47486, -3845, -3845,
   -3845,  3256,  2990, -3845,  1635,  1150,  2508, -3845, 70334, 22702,
   22702, -3845,  2898, -3845,  2904,  3315, -3845,  2057, -3845, -3845,
   -3845, -3845, -3845, -3845,  2980, 58910, -3845, -3845,  2906,   182,
   -3845, -3845, 58910, -3845, 58910, -3845, -3845,   182,   182, -3845,
    3024, -3845, 58910, 58910, 58910,  2580, -3845,   319, -3845,  3186,
   42998, -3845, -3845, -3845, -3845,    70,  3192, -3845, -3845,  3152,
    3157,  3158,  3159,   859, -3845, -3845, 22702, 10669, -3845,  2929,
   -3845, 10669,  6789, 10669,  3098, -3845,  2030,  3201, -3845,   819,
    2931,  2030,  1631,  1631,   362,   362,   177,   177,   177,  3232,
     710, 10669, 10669, -3845, -3845, -3845, -3845,  2934, -3845, -3845,
   -3845,  2619, -3845, 23552,  3067,  3305, -3845, -3845, -3845,  2965,
    2973,  2939, -3845, 22702, 23977,  2938, 74348, -3845, -3845,   636,
    1259, 25252, 25252,  1726, -3845,   374, 22702, 73554,  1919,  1726,
    2150,  2166, 22702, 22702,  7955,   222, 22702,  7031, 58910, 58910,
   58910, 58910, -3845, -3845, -3845, 17660,  1622,  2940, 58910, -3845,
    2932, 28177,  3160,  3106, -3845, 28177,  3106,  1123,  3106,  3175,
   -3845, 31903, -3845,  2944, 16817,  1380, 10669,  3323,  3212, 22702,
    2946, -3845,  2947,  2789, -3845, 73146, -3845, -3845, 10669, -3845,
   -3845, 22702, -3845,  2789,  1150, -3845, -3845, 34422, -3845, -3845,
   -3845,  3134, 10669, -3845,  1635, 58910,  1417,  2945,  2972, 58910,
   -3845,  2793, -3845,   345, -3845, -3845, -3845, -3845,  3025, 49118,
    3237, -3845, 22702,  1932, -3845,  2997,  3316,   134,  1938,  1951,
    1157, -3845,  2928, -3845,  1238,  3216,   126, -3845,   182, -3845,
   73554, -3845, 58910, 58910, -3845, -3845, -3845, -3845,  2230, -3845,
   -3845, 58910, 58910, 58910, 58910, -3845,  3031, -3845, -3845, 39734,
    2697,  3156, -3845, -3845,  3161,   345, 58910, -3845, 73554,   182,
     182, -3845, -3845, -3845,  2991, 43814, 58910, 58910,  1995,  1995,
   73554,  2971, -3845,  1995,  1995,  2975, -3845, 43814, 58910, 58910,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
    3054, -3845, -3845, -3845, 58910, 58910, 58910, 58910,  3273, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   58910, -3845, -3845, -3845, 73554,   182,   182, -3845, -3845, -3845,
    3217, -3845,   804,   804, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845,  2068,  3299, -3845, 39734, -3845, 40550, -3845, -3845, -3845,
    1150, -3845,  1150,  3176, 36490,  1150,  1150,  1157,  2993,  1406,
    3260, -3845, -3845, -3845, -3845,  3265,   345, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845, 22702, -3845,   808,  2030, -3845, -3845, -3845, -3845,
    2928,  1598,  3042,   766,  3101, -3845, -3845,  2106,  2106,  3045,
    3389,    33, 58910,  3300,  3034, -3845,  1150, -3845, -3845, 58910,
   47486,  2812, -3845,  3327,  1952, -3845, -3845, -3845,  3032,  2963,
    1403,  2999,  1604, -3845,   172, 58910, -3845,  3035,  3278,  3005,
   -3845, 10669, 10669,  1150, 74745,  1544, -3845, 58910,  3254,   182,
   -3845,   182,   182, -3845, -3845, 58910,  2580,  2580,  2580, -3845,
    3184, -3845,   182, 42998,   859,   859,   859,   859, -3845, -3845,
   -3845, 10669, -3845, -3845, -3845, 25252,  3285, -3845,  3011, 73554,
   -3845,  3012,  1953,  1974, 26096,  3154, -3845, -3845, -3845,  7067,
    3061, 10669,  3115,  3014,  3015, -3845,  1025,  1025,   374,  1988,
   -3845, 25252, 25252,  1726,  1726, 22702,  1726, -3845, -3845, -3845,
   -3845, -3845, 56462,  3019, 58910,  1622, 28177, -3845, -3845,  1401,
   -3845, 28177,  3252, -3845, 28177, 58910,  3030, 58910,   841, 22702,
   22702,  3059,  2789,  2789, -3845,  3196, -3845,  3037, -3845,   636,
    3038, 58910, -3845, -3845,  1037, -3845, -3845, -3845, 42998,  3213,
   42998,  1157,  7375,  2928, 28591, 35264, 58910, 58502, 58502,  3171,
    2928,  3042, -3845, -3845, -3845, -3845, -3845, -3845,  3040, -3845,
   -3845, -3845,  3109, -3845, -3845, -3845,  1989, -3845, -3845, -3845,
   -3845, -3845,  3211, -3845, -3845, 32317, -3845, -3845, -3845, 29833,
   34422, -3845,   831,  3043,  3044,   742, -3845, -3845, -3845, 58910,
    1178,   913,  3070,  2580,  3318, -3845,  3211, -3845, -3845,   804,
   -3845, -3845,  2530,  1150, -3845, -3845,  1990, -3845, -3845, -3845,
   58910, -3845,  2884, -3845, -3845, -3845, 43406,  3435,  3435, 58910,
   -3845, -3845,  7393,  3234, -3845,  3042,  3255,  3302, -3845, 58910,
   58910,  1635, 47486,  2861, -3845,  1343,  3047,  3343, -3845,  2782,
    3050, -3845, -3845, -3845, 48710,  3229,  2990,   226,   226, 58910,
    2963,  3174, -3845,  3180, -3845,  1239, -3845, 58910, 28591, -3845,
   73951, -3845,  2000, -3845, -3845,  2663, 58910,    84, -3845, -3845,
   -3845, -3845, -3845, -3845,   251, -3845, -3845, -3845, -3845,   791,
   25252, 73554,  2002, 22702, -3845, 22702, -3845,  3432, -3845, -3845,
   -3845,    60, -3845, -3845, -3845,  1025,  1025,  1726, -3845, 58910,
    2010, -3845, 22702,  3055, -3845, -3845, 28177,  1401,  2027, 58910,
    2028, 73554,  2789,  2619, 10669, 58910, -3845, -3845, -3845,  3434,
    3238,  2789, -3845, -3845, -3845, -3845,  1065,   827,   251,  3316,
    3042, -3845,  3060, -3845, -3845, 58910, -3845,   316,   316, 58910,
    3042, -3845, -3845, 58910, -3845, 39734,  3118, -3845, 73554,  1904,
     101, -3845, 73554, 73554, -3845, -3845, 58910, 58910, 58910, 58910,
   58910,   182, -3845, -3845, -3845, -3845, 40550,  2884,  3435,   298,
   -3845, -3845, -3845,  1485,  3259, -3845,   862,  3245,  3153,  2861,
    3354,  3035, -3845, -3845, -3845, -3845, 22702,  3218,  1604,  3150,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
   -3845,  2029,  2990, -3845, -3845,  3436,  3249,  3439, -3845,  2044,
   -3845, -3845,  3315, 74745,  3384, -3845,  3123, 58910, -3845, -3845,
   -3845,   791,  2045, -3845,  2046,  2051,  3219,  3124, -3845,  2055,
   -3845, 10669, 58910, -3845, -3845, -3845,  2061, -3845,  3072, -3845,
    3475, 22702,  1180, -3845, -3845,  3358, -3845, 58502,  3122, 34422,
   -3845,  1601,  1601,  1598, -3845,  1157, -3845, -3845, 22702, -3845,
    2067, -3845,   112,  3230,  3370,  2076,  2084,  2587,  3129,  2587,
   -3845,  2580, -3845, -3845, -3845, -3845, -3845,  3395,  3347, -3845,
   -3845, -3845, -3845,   670, -3845,  3279,  3280, 58910, -3845, 58910,
    3493, -3845,  7809, 43406,  2963,  1604,  2697, -3845, -3845,  3281,
   -3845,  3282,  2592, 28591,  1544, -3845,   245, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845,  2088, -3845, 58910,  3102,  2619,
   24402, 24402,  3105, 42998,   316,  3103, -3845,  3107, -3845, -3845,
    3255,  1157, 10669, 43406,  3479, -3845, -3845, -3845,  3230, -3845,
   -3845, 58910,  3233, -3845,   675,   675,  3425, -3845,  3165, -3845,
   -3845, -3845,   831, -3845,  3119,  2990,  2963, -3845, -3845,  2990,
   -3845, -3845, -3845, -3845,  1693, -3845, -3845, -3845, 25677,  3235,
     893,  9287, -3845, -3845, -3845, -3845,   251,  1601, 22702,  1157,
   -3845,  3245,  1904, 58910, -3845, -3845,  3034, -3845,  3525, -3845,
     762, -3845, -3845,  2971, 39326, -3845,  2990,  2663, -3845,  1924,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845,  3519, -3845, -3845,
   -3845, -3845, -3845, -3845, -3845,  7840, -3845, -3845, -3845,  3415,
   -3845, -3845, -3845, -3845,  2089, -3845, -3845, -3845, -3845, -3845,
   -3845,  1501, -3845, -3845,  1850,  1835, 24827, -3845,  1157,  3272,
   -3845, 39326, -3845,  1924, -3845, 43406, -3845, -3845,  3125, 39326,
    2094, -3845
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -3845, -3845, -3845,  2872, -3845,  -745, -1020,  2261, -1583, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845, -3845,
    2799, -3845, -3845, -3845,  1489, -3845, -3845,   116, -1052,   344,
    2458,  1188, -3845,  -916, -3845, -3845,  -460,   148,  -630, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845, -3845,  -631,  1632,  1044,
      48, -2190, -3845, -1145, -3097, -3845,   484, -3845, -3845,  1576,
   -3845, -3845, -3845,   905,  -283, -3845, -3845, -3845, -3845, -3845,
   -3845, -3845,   -23, -3845, -3845,  -444, -1309,    45,   -85,  -312,
   -3845, -3845,   325,  -310, -1172, -3845, -2924, -3845,   -49, -3845,
   -3845, -3845,  -309, -1143,  1144, -3845,  -593,  -934,  1426,  -588,
   -3845,  -200, -3845,  -633,  -537,  -535,  -594,  -437, -3111, -3496,
   -3372, -2643,  1155,   142, -3845,   -57, -1289, -3845, -3845, -1233,
   -1149, -3845,  -715, -3845, -3845, -3845, -2423, -3845, -3845, -3845,
   -3845,    65, -3845, -3845, -3845, -3845,   384, -3845, -3845, -3845,
   -3845, -3845, -3845, -2229,  1548,  1552, -3845, -3845, -2599, -3845,
    -740, -3845,   539, -2445,  1078, -3845, -3845, -3845,  2229, -3845,
   -3845, -3845, -3845,   392, -3845,   393, -3845, -3845, -1316, -3845,
   -3845, -1285, -3845,  1568,   897, -3845, -3845, -3845,  -610,  -671,
    -662, -3845, -2866, -3845, -3845, -3845, -3845, -3845,  -797, -3845,
     948, -2560,  -765, -3845, -3845,   964, -3845, -3845, -3845, -3845,
    -570,  -199,  2252, -3845,  -478,  -551, -3845, -3845, -3845,  -196,
   -3845, -3845, -3845, -3845, -3845, -3845,  -831,   132, -1282, -3845,
   -3845, -3845, -3845, -1828, -3845, -3845, -3845, -1332, -3845,  3614,
    1782,   931, -1280, -3845,   -21,    58,  2685,  -903, -2155,   332,
    -326, -3845, -1458, -3845, -3845, -3845, -2068, -3845, -3845, -3845,
   -3845, -2877, -1279, -3845, -3845, -3845,   385, -3845, -3673, -3318,
   -3586, -3156, -2846, -3845, -3845,  -884, -3845, -3845, -3845, -1113,
    1760, -1176, -3845, -1815,   386, -3137,  -597, -2691, -3845, -3047,
    -408, -3845, -3845, -3845, -3845, -3845, -3845, -3845,  -883,  -504,
   -3845, -3845,  3108, -3845, -3566, -3845, -3845, -3845, -3845,  1119,
   -3845, -1151,  1038, -3845, -3845, -3845, -3845, -3845,  -557,  -635,
   -3845, -3845, -3845,   145, -3845, -3845, -3845, -3845,  1997,  -763,
    -599,  2985, -1278,  -372, -3845, -3845, -3845, -3845, -2509, -3845,
   -3845, -3845, -3845, -3845, -3845, -3845,  -997, -3845, -3845, -3845,
   -3845, -3845, -3845, -3845,  1906,  1901,    69,   -17, -3845, -3845,
   -1021, -3845,  -446, -3845,  2201, -3845, -3845, -3845, -3845,  1279,
     146,   417, -3845,     3, -3845, -3845,   224, -2829,     4, -3845,
   -3845, -3845, -3845,  -299,     5, -3845,   680, -3845, -3845, -2286,
   -3845,   149,    26, -3845, -3845,     1,     0,   -41,   -22,     8,
       2,  2994,  2547, -3845, -3845, -3845,   -12,  1593, -3845,  -691,
    -156, -3845,  1284,  -529,  1882,  2529,  2534, -3845,  1282, -3845,
   -3845,  1291, -3845, -3845, -3845,  -510,  1895, -3845,  2542,  1912,
   -3845,  1273,  1286, -2732,   755, -2776,   276, -1116,  -258,    96,
    3018,  2548, -3845, -3710,   711, -3845, -2851, -1870,   592,  1671,
   -1297, -3845, -3845,  -945,  7277, -3845, -3845, -3845, 10849, 11110,
   -3845, -3845, 12098, 12584, -3845,  -820,   805, 12847,  4383,  -982,
   -1548,  -863, 10304, -1983,  -958, -2302, -3845, -3845, -3845,  -225,
     814,   308, -3845, -3845, -3845, -3845,  -454, -2273,  -453, -3845,
   -3845, -3845,  -455, -3844, -1495, -3845,  -147, -3845, 11054,  1329,
   -3845,  -893, -2235, -2233,  -923, -1441, -3845, -3845, -3845, -3845,
   -3845, -3845, -3845, -1218, -2715,  -157,  1396, -3845, -3845,  1490,
   -3845, -3845, -3845, -1030,  -700, -2136,  1402, -1643, -3845,  -683,
     740,  2097,  -650,   -81, -1086,  8530,  -411, -1875, -1012, -1247,
   -3845,  -148, -3845,    25,    -9,  -125,  -484,    -7,  3207, 10110,
    -430, -1088,  6126,  8671, 10050, -2548
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -2171
static const yytype_int16 yytable[] =
{
     162,   161,   166,   156,   157,   159,   695,   555,   705,  1431,
    1084,   511,   650,  1471,   616,   627,  1151,  1491,  1441,   616,
     162,   855,   166,  1748,   737,   953,   954,   955,  1464,  1157,
     682,   959,   755,   499,  1831,  1893,  1246,   778,  1160,  1306,
     546,  2174,  1516,  1763,  1902,  1268,   615,   694,  1294,  1237,
    2820,   615,  2301,  2035,  1577,  2946,   757,   539,  1384,  2560,
    2006,   781,  1550,  1551,   901,  3039,  1435,  1402,  1098,  1911,
     793,  3278,  1331,  1903,  2266,  1527,  1748,  2508,  2510,  2072,
     622,  1566,   582,  1753,  1924,  2048,   904,  2097,  2266,   590,
    2956,   651,   879,  3072,  2229,  3074,   916,  1373,  1891,  2073,
    1377,   763,  3225,  2074,  2946,  1381,   842,   784,  2075,  2076,
    2077,  2615,  1386,  1766,  1961,   795,  2806,  3177,  2384,  1422,
    1970,  1404,   881,  3196,  2951,  2952,  3448,  2991,  2953,  3470,
    1753,  1974,  1975,  3510,   699,  3177,  2347,   679,  3685,  3650,
    2145,   924,    74,  3669,   707,   133,   154,  3480,    64,   160,
     889,  1879,  1809,  1262,   669,  3453,  1273,  1209,   930,  3798,
    2901,  1593,  3353,  1295,  1299,  2109,   706,   551,  3420,  3422,
    3642,  1185,  2100,  3896,   708,  1145,  1543,  1544,  3201,  3202,
    3203,  3204,  3205,  3206, -1855, -1856,  1785,   598,  2858,  1401,
    2715, -1883, -1855, -1856,  1148,   509,  1981, -1949,  2657,  1596,
     598,  3796,  1563,  1091,  2185,  4064,   598,  3406,  1986,  2306,
       3,     4,  3988,   935,  1473,  3269,  1423,  2636,  2186,   939,
    1423,  1754, -2170, -1472, -1505,  1912,  1369,  2206, -1946, -1724,
   -2170,  2408,  3805,   881,  1423,  4060, -1724,  2306, -1980,   551,
   -1500,  -346,  1325,  2341, -1740,  3035,  2039,  4112,  4043,   551,
    2342, -1740,   551,  2736, -2000, -2025,  2777,   685,  2779,   700,
    3058,  3040,   551,  2103,  1603,  2659,  1088, -1305,  4212, -1485,
    2484, -1512,  3659,  2171,  1186,   702,  2103, -1308, -1505,  2856,
    2857,  3901,  2053,  2996,  2872,  2553,   787,  2094,   979,   551,
    1606,  4077,   551,  3902, -1500, -1830,   551,  4044, -1515,  1303,
     797, -1515,  4021,  1423,  4045,   742,   744, -1505,  2807,   748,
     749,  2040,  1185, -1999,  3607,  4066,  1319,   701,  2818,  1397,
    1608,  2187,   598,  1235,  2907,  2908,   791,   867,   598,  3555,
    1639,  4046,  2357,  4125,  1115,  1306,  1116,   765,  2813,   551,
    1398,  2485,   604,  3662,  1647,  1235,   551,  -118,   604,  2389,
     598, -1305,  -118,  3189,   598,  1594,   868,   656,  1655,  2576,
    1511, -1308,   605,  2610,   837,  4184,  2067,  2041,   605,  1905,
    2042,  1577,  1466,  2858,  4257,  1467,   646,  1910,   778,   604,
    1638,  1651,   702,   676,  2098,  1603,  1663,  1663,   798,   604,
    1226,  1640,  2611,  2472,  1603,  1550,  1551,  1656,   850,   605,
     869,  4047,   857,  1566,  4052,   604,   604,  2814,   884,   605,
    2169,  1606,  2576,   866,  2175,  1186,  2177,   893,  1442,  2180,
    1606,   778,  4185, -1305,   804,   605,   605,   799,  2390,   835,
    4213,  2013,    37, -1308,  3059,  3801,  2017,  1755,  3620,  2095,
      37,  1608,  4294,  3903,  2043,  1648,  1905,  2104,  1304,  1905,
    1608,   657,  4124,  3429,  1968,   552,  3660,  1459,  2043,  3060,
    3882,  1424,    41,  4067,  3036,  1424,  2554,  2660,  4126,  4078,
      41,  3040,  1905,  1509,  1905,   800,  3556,  3663,  1867,  1424,
    4210,  1837,  1964,  1518,  1399,  1475,  1873,   881,  2835,  2488,
    2955,  3463,  2188,  2172,  1913,  1528,   703,  2808,   834,   881,
      45,  1433,  1370,  3806,  2226,  3590,  1914, -1472,    45,  2637,
    2189,  4174,    46,  2307,  1957, -1999,  1959,  2304,  1543,  1544,
      46,  3523,  1531,  1987,  4042,  3270,  1187,  1563,  1241,  1966,
    1345,   547,   686,  3177,  2033, -1724,  1947,  4280,  1982,  1950,
    1951,  2921,  2005,   880,   555,  2009,    47,   695,  1424,  2343,
   -1740,  1152,   881,  1649,  2409,  2044,  2162,  1915,   970,  1110,
    1865,  3900,  4048,  1111,  1753, -1305, -2171,  1597,   958,  1117,
    3009,   832,  1512,   931,  2045, -1308, -1999,    47,  2970,  1085,
   -1472,  1326,  1327,  2029,  1370,  1213,  2096,   162,   694,   166,
    2035, -1999,   932,  3875,   937,  1461,   941,  1108,   958,  1433,
    2870,  2014,   945,  1538,  3184,  3791, -1855, -1856,  1753,   610,
     611,  2265,  2993,  1882,  2512,   610,   611,  1943,  1134,  3714,
    1512, -1883,  1794,   964,   615,  2288,   615, -1949,   615,  2149,
    3646,   923,  3786,  1645,   615,   946,   947,  2946,  3914,   948,
    2225,  1795,  2228,   980, -2170,  1549, -1505,   840,  4205,  3658,
    1081,   843,  2236,  1090,   880,  1092,  2240,   926, -1946,  1310,
   -1305,  4097, -1500,   881,  2252,  2253,  2170,   864, -1980,  1315,
   -1308,   881,   881,   778,   707,  2181,  1627,  2270,  2272,  3755,
    4148,  3434,  3310,  3759, -2000, -2025,  1538,  1572,  2286,  3616,
    1572,  1555,  3052, -1512,  3053, -1305,   706, -1305,   162,   161,
     166,   156,   157,   159,   708, -1308,  1573, -1308,  3476,  1573,
    4246,  1599,  2494,  2582,  1636,  1110,  2507, -1830,  2371,  1111,
    1574,  2858,  1748,  1576,  1413,   960,  3442,  4237,  2517, -1505,
    1969,   610,   611,  2493,   797,  2039,  1172,   610,  1236,  1939,
    2393,  2256,  2257,   768,   769,   770,  3980,   771,   772,   773,
     774,   775,   776,  3990,  2232,  1120,  3106,  1838,  3501,   610,
    1236,  -118,  -118,   610,   611,  1633,  1380,  2266,  2266,  3144,
    3145,   988,  2266,   752,  2858,   846,   548,  1087,   960,  4194,
     586,  1095,  2867,  2868,  2869,  2870,  1405,  1408,  1409,   615,
    2568,  3381,  1622,  1623,  1624,  1625,  1626,  1627,  2428,    14,
    2040,  1839,  2858,  1624,  1625,  1626,  1627,  1155,  1177,   551,
   -1827,  3139,  2266,  2266,  3142,  3143,  2106,  3258,  3146,  2809,
     890,  2088,   798,  1313,  2963,  2470,  2811,  1329,  3153,  1879,
      19,  4101,  4102,  4245,   635,  2550,  2241,  4247,   551,  1278,
      74,  3087,  1416,   133,   154,   950,    64,   160,   709,  1191,
    3174,  2484,  3456,  2178,  2179,   549,  2041,   550,   551,  2042,
    3231,   799,  3688,  2569,   551,  3513,  4271,  1874,  3174,  3207,
    2345,  2018,  1839,  1100,  4279,  1085,  3336,  1279,  1834,  3341,
    3342,  3343,  3344,  3345,  3346,  3347,  3348,  3349,  3350,  2704,
   -1472,  1594,  1417,  1174,   506,  3533,  2089,  1085,  1239,  1240,
    2166, -1472,  2860,  1549, -1472,  1164,  4238, -1472,   880,   800,
     636,  1178,  3210,  2570,  3958,  1141,  3960,  2696,  3636,  3638,
     880,  3186,  2485,   710,   551,  4154,  2019,  4144,   598,  1937,
    1840,   162,  2242,   166,  1893,  3716,  2134,  3717,  3390,  3391,
    1415,  1174,  -557,  1248,  3088,  3276,   872,  2043,  2126,  1393,
    1875,  1961,  3280,  1514,   615,  2860,  1447,  1561,  1562,  2137,
    1477,  1449,  1479,  2571,  1481,  1324,  1483,  1462,  1485,  1486,
    1487,  2144,  4239,   880,  1249,  1489,  3948,  3187,  1825,  3637,
    1418,  3464,  1143, -2171,  3528,  1382,  1383,  1394,  1110,  1938,
    1536,  3534,  1111,  2346,  3278,  4240,   951,  2243,  1923,  1450,
    4272,  3514,  1410,  3232,  4023,  1841,  1634,  3511,  2810,    37,
    1553,  2020,  2861,   695,  4130,  2812,  2625,  2121,  4227,   753,
    2154,   847,  1284,  3617,  3951,  1280,  1667,  3281,  1419,  3955,
    1437,  1439,  3957,   988,  4206,  2323,  2858,   930,  4259,    41,
    1580,  3873,  2647,  4195,  2044,   702,  3214,  1595,  1827,  2021,
    1179,  3639,  2572,  2244,  1591,  4209,  2245,  1600,   551,  1305,
    3028,  2167,  3718,  2259,  3817,  1828,   891,  1637,  2043,  1314,
    2488,  2471,  2090,  1797,  2697,  1101,   551,    45,   637,   638,
    3529,  1180,  3215,  3089,   880,  2091,  2797,  1653,  1654,    46,
    2168,  3099,   880,   880,   702,  3216,   778,  3708,  3029,   873,
    4095,  3515,  2069,  2680,  3516,  1759,  1420,  4211,  4086,  2946,
    1181,  1281,   711,  2946,  3090,  1767,  1768,  4146,  1772,  1285,
    2497,   615,  -734,    47,  4131,  4105,   615,   615,  2865,  2866,
    2867,  2868,  2869,  2870,  1899,  1395,  1102,   706,   706,   504,
     706,  1916,  3465,  3091,  2246,   708,   708,  1451,   708,  1825,
    1773,   975,  2698,  2573,   874,   551,  3282,  3622,  3991,  2324,
    3774,  2574,  4260,  2325,  2575,  1826,  1993,  3530,  1182,  1946,
    3778,  3466,  1093,  3785,  2070,  3624,  3217,  2862,  2863,  2864,
    2609,  2865,  2866,  2867,  2868,  2869,  2870,  4132,   628,  3768,
    3467,  1829,  1283,  1643,  2606,  1923,  3442,  2022,  1284,  2891,
    2326,  1980,  1952,  2498,  1603,  2898,  4007,  1776,  3777,  2865,
    2866,  2867,  2868,  2869,  2870,  1996,  3283,  2860,   615,  1827,
    2958,  1396,  3050,  2959,  4083,  2607,   615,  3635,  2008,  2512,
    1606,  1164,  4025,  1452,  2583,  2437,  1828,  1774,  4181,  2600,
    2774,  2247,  2586,  1908,  2588,  2601,  3030,  3702,  1777,  1155,
    2449,  2780,  1135,  1860,  2608,  4178,  4179,   507,  1965,  1999,
    1608,   947,  2068,  3483,   634,  3997,  3174,   797,  2516,  3962,
    1603,  1819,  2959,  2118,  2861,  3413,   615,  3177,  1993,   615,
     615,  1820,  2124,  2023,  4032,  1830,  2722,  2723,  2724,  2725,
    2000,  3127,  4055,   778,  1909,  1285,  1821,  2775,  2730,  1778,
    4056,  1833,  2450,  3414,  2265,  2265,  4008,  2438,  2127,  2265,
    4229,   957,  3128,  3581,   988,  2581,  2327,  2858,  3761,  3584,
    3585,  3586,  3587,  3588,  3589,  1953,  1608,  1954,  1834,  3416,
    1893,  1993,  3031,   655,  1925,  3484,  2593,  4098,  2833,   169,
    3306,   615,  2602,  2201,  2386,  3802,  1136,  4104,  2475,  2265,
    2265,   755,  3462,  2770,  3004,   798,  1777,  1919,  2529,  2966,
    1244,  1370,  1829,   867,  2266,  2631,  1967,  2266,  2266,  2266,
    2266,  2266,  2266,  2266,  2266,  2266,  2266,  3657,    32,   170,
    2078,  4264,  1926,  1927,  2153,  1611,  1612,  2885,  3485,   958,
    3486,  3324,  3238,  3051,   799,  1174,   677,  2266,  3736,  3737,
    4288,  2531,  1757,  1293,  2433,  1758,  3803,  1778,  2072,  2530,
    1976,  1977,  1978,  1979,  2514,  2445,  1923,  3691,  2910,  3692,
     778,  1433,  1085,  1085,  3418,  1822,  2266,  2266,  2073,  1615,
    4138,  1355,  2074,  1961,  1286,  2183,   869,  2075,  2076,  2077,
    3107,   652,   800,  2865,  2866,  2867,  2868,  2869,  2870,  2015,
    2016,  4057,  2532,  1593,  2946,  2025,  1830,  1835,  3309,  2946,
    4170,  2799,  2946,  3278,   688,  1287,   162,  -887,   166,  2484,
    2119,  3300,  2449,  1433,   522,  1141,   697,  2859,  1572,  2125,
    1245,  2603,   712,  2129,  -140,  4171,  3412,  1141,  1097,  2135,
    2136,  1142,  3476,  4065,  1288,  2685,  3310,  1573,  2860,  3967,
    3968,  2050,  2156,  1251,  2157,  2203,  2158,  2148,  2159,  -140,
    2160,  3337,  2604,  3338,  2161,   698,  3015,   162,  2200,   166,
    2197,  2198,  2199,   169,  3012,  2083,  2084,  2085,  2086,  2566,
     169,   524,   936,   938,   940,  3897,   926,   942,   943,   944,
    2485,  2605,  1143,  1952,  2686,  2250, -1317,   949,  3924,  1252,
    4107,  1931,  2355,  3413,  1143,  2861,   598,  1515, -1317,  3866,
    1292,  2369, -1317,   170,    32,  1760,  1958,  2680,  1761,  2486,
     170,  4006,  2238,  2239,  3157,  3898,  2758,  2139,  1144,  1226,
    2251,  3414,  1172,  2202,  2254,  2255,  2143,  3867,  1265,  1293,
    1144,  3483,  3027,  2150,  2053,  1192,  3415,  2223,   522,  2276,
    2487,  2277,  3259,  1925, -1317,  3263,  3476,  3416,  2191,  2386,
    2312,  1622,  1623,  1624,  1625,  1626,  1627,  3809,  3810,  1266,
    2687,  2688,  2299,  1917,  2300, -1317,  1253,  1193,  3339,  3417,
     604,  4127,  3996,  3976,  2689,  3978,  3334,  1456,  3340,   988,
    2114,  2115,  2858,  2372,  4158,  3603,  3614,  4033,  3952,  1161,
     605,  1926,  1927,  2766,  2946,   524,  4011,  1457,  1663,  2001,
    3354, -1317,  1172,  3484,  2612,   531,  1953,   532,  1954, -1317,
    2002,  1971,  1254,   747,  1255,  4034,  2380,  3081,  2383,  2690,
    1162,  2425,  1194,   881,  1960,  1923,  2429,  2788,  2488,  2432,
     537,  3604,  3082,  2613,  2003,   789,  1998,  2465,  4093,  2912,
    3021,  2913,  3418,   755,   764,   778,  -369,  3412,  1925,  1163,
    3305,  2455,  1257,  1195,  1267,  2266,  3485,   881,  3486,   796,
    2862,  2863,  2864,  2914,  2865,  2866,  2867,  2868,  2869,  2870,
    2727,  2830,  3929,  1925,  1602,  2728,  2152,  1603,  2831,  1603,
    2309,  3557,  2759,  2832,   848,  2499,   849,  2978,  1196,  1259,
    1515,  3041,  3498,   836,  3850,  3851,  1926,  1927,  3945,  3946,
     851,  3558,   852,  1606,  2691,  1606,  2692,  3481,  2395,  1607,
    3197,  2961,  2513,  2495,  3413,  2728,  3953,  1197,   839,  3062,
    3054,  1926,  1927, -1317,  1261,  1549,  1535,  1810,    47,   531,
    1923,   532,  3240,  1608,  1274,  1608,  2546,   162,  2411,  2439,
     615,  2442,  3414,   613,  2379,  1110,  3367, -1830,   613,  1111,
    1925,  3188,  3190,  3191,   537,  1923,  2567,  3415, -1351,  2577,
     841,  2915, -1351,  2860,  2927,  1275,  2916,  1120,  3416,  1276,
     856,  3735,  2151,  1936,  1166,  2152,  2537,  2589,  2314,    32,
    2315,  1110,  1110,  1200,  1131,  1111,  1111,  2598,   516,  1201,
    3417,  3476,  2163,  3105,  1277,  2164,  1202,  1803,  1926,  1927,
    2621,  3044,  2316,  1476,  1881,  1167,  1478,  1092,  1480,  2628,
    1482,  2226,  1484,  1204,  2165,   988,  1488,  2164,  2858,  2194,
    2861,  1205,  2195,   862, -2082, -1351,  2266,  2266,  1804,  1169,
    1925,  3502,  1923,  2292,  1168,  3382,  2295,  1610,   870,  3355,
    3356,  2265,   886,  2010,  2265,  2265,  2265,  2265,  2265,  2265,
    2265,  2265,  2265,  2265,  3512,  3517,  3316,  1805,  1611,  1612,
    1170, -1351,  1515,  3418,    32,   871,   522,  4248,    27,  4292,
    2385,  4293,  1206,  2386,  3365,   897,  2761,  3277,  1926,  1927,
    3084,  3320,  2917,   881,  1549,  -881,  1164,  4071,    37,  1171,
    3221,   902,  2918,  3001,  3002,  2317,  2421,   911,  2492,  2195,
    2318,   917,  1615,  2265,  2265,  2319,  2226,  2056, -2082,  2401,
    2402,  3085,  1923,  2617,   615,  1616, -1375, -1375,    41,  2467,
    2468,  2469,   615,   524,   615,  2716,  2477,  1549,  2479,  1810,
    2481,  2482,  2550,   921,  3524,  3361,  3388,  2747,  2748,    37,
    3086,  1572,   198,  3020,   598,  4030,    37,   508,  2505,  2649,
    3174,  2506,  2973,  2974, -2082,   584,    45,  2649,  4226,  2120,
    1573,  4012,  1172,  2718,  2562,   952, -2082,  2563,    46,    41,
   -2082,   653,   956,   881,  1574, -2082,    41,  1845,   988,  2666,
   -2082,  2858,  2667, -2082,   962, -2082, -2171, -2171,  3108,  2865,
    2866,  2867,  2868,  2869,  2870,   965,  2704,  2804,  3319,  2860,
     967,  2823,    47,  1572,   972,  2681,  2825,    45,  2682,   973,
    2679,  1846, -2082,  2721,    45,  3609,  3610,  3478,  3479,  3734,
    2804,  2320,  1573,   974,  1847,  1925,    46,  2584,  1521,  1522,
    3102,  2321,  1893, -2082,  3136,  4061,  1576,  1848,  2752,  2979,
    2980,  3506,   162,  2737,   880,  2680,  1549,   975,  1810,  2791,
    3667,  3321,  2164,    47,  2719,  2829,  2861,   531,  2152,   532,
    4249,   976,  2884,  3236,  2886,  2887,     3,     4,   534, -2082,
    2931,  1925,  2932,  1926,  1927,  1849,   977, -2082,   880,   536,
     978,   981,   537,  2641,  1622,  1623,  1624,  1625,  1626,  1627,
     982,  2650,  2651,  2652,  2653,  2654,  2655,  2839,   988,    27,
    2152,  2858,  1096,  3600,  1850,  3602,  1099,  1923,  3605,  1851,
    3606,  2773,  2843,  2847,   988,  2152,  2152,  2858,  3741,  1926,
    1927,   778, -2082,  2933,   586,  2934,  1602,  2782,  2783,  1603,
    2848,  2785,   700,  2152,  3742,  2302,  2874,  2789,  1306,  2152,
    1103,   615,  2890,    14, -1352,  2152,   984,  1105, -1352,  2947,
    2960,  2895,  1109,  1923,  2896,  1606,  3696,  3697,  3698,  1104,
    2266,  1607,  2860,  1121,  3230,  3075,  3233,   628,  3076,  2266,
    3079,  3972,  1128,  3080,    19,  2738,  3222,    37,  3224,  3227,
    3267,  3597,  3228,  3268,  2971,  1608,  2266,  2266,  3425,  1129,
     701, -2082,  2265,  3325,  3362,  2822,  2152,  3363,  2947,  1131,
    3430,  3432,  2776,  1132,  2778,  1852,   881,    41,   881,  2935,
     695, -1352,  3372,  1139, -2082,  3373, -2082, -2082,  1131,  2861,
   -1305,  2862,  2863,  2864,  1153,  2865,  2866,  2867,  2868,  2869,
    2870,  3503,  3384,   185,  1138,  2152,  1140,  2997,  3454,  3273,
    3760,  3455,  3763,  1602,  1154,    45,  1603, -1352,  1158, -2082,
    1189,  1591, -2082, -2082, -2082,   702,  1085,    46,  3458,  3482,
    3158,  3459,  2164,  1604,  1853,  2312,  1164,  1184,  1925,   881,
    1854,  1211,  1606,  1855,  3315,  1215,  1241,  1243,  1607,  2936,
    2937,  2938,  2860,  3593,  2930,  1609,  3594,  3740,  1250,  1610,
    2195,    47, -1098,  1270, -1098,  1282,  2828,  2940,  2860,  1856,
    3793,  3159,  1608,  3794,   880,  1857,  3799,  1291,   695,  2164,
    1611,  1612,  3925,  3926,  3927,  3928,  1926,  1927,  1858,  3800,
    3893,  3934,  2164,  3894,  3935,  3160,  1613,   162,  2200,   166,
    2197,  2198,  2199,  1296,  3577,  1753,  2962,  1301,   615,  2861,
    3161,  1307,  3936,  1859,  3162,  2152,  2940,  1302,  4018,   694,
    1923,  1309,  1311,    37,  1615,  2861,  3944,  3994,  4015,  2195,
    3995,  4016,  3163,  2265,  2265,  1316,  2226,  1616,  4062,   703,
    4073,  4063,  3083,  2195,  1321,  2266,  1323,  3164,  4080,  3095,
    1333,  2386,  3599,    41,  2862,  2863,  2864,  1330,  2865,  2866,
    2867,  2868,  2869,  2870,   880,  4085,  4087,  4147,  3247,  3247,
    1642,  1172,  1609,  1374,  3739,  1376,  1610,  1378,  3840,  3841,
    3723,  3843,  4152,  4159,  4160,  4153,  2195,  2896,  1387,  4161,
    3686,    45,  2152,  4164,  1370,   587,  2386,  1611,  1612,  4166,
    -157,  1389,  3247,    46,  1602,  4183,  2518,  1603,  2195,  1391,
    1403,  3018,  1618,  1613,  4189,   185,  3157,  2195,  3910,  3137,
    1411,  1421,  4190,  3165,  1604,  2195,  4215,  4290,  2971,  2386,
    4291,  3166,  4301,  1606,  1426,  4291,  1427,   588,  1614,  1607,
    1428,  1615,  1429,  1430,  1432,  3078,  2971,  1433,  1440,  1443,
    1444,  1445,  1446,  1448,  1616,  1453,  1454,  1617,  1455,  1460,
    1465,  1517,  1490,  1608,  3167,  1523,  1519,  1525,  1526,  1532,
   -1476,  1533, -1483,  3100,  2862,  2863,  2864,  1542,  2865,  2866,
    2867,  2868,  2869,  2870,  3065,  1545,  3067,  1552,  1546,  1547,
    2862,  2863,  2864,  1548,  2865,  2866,  2867,  2868,  2869,  2870,
      47, -1473,  3699, -2171, -2171,  1554,  1622,  1623,  1624,  1625,
    1626,  1627,  1557,  3024, -1474,  3025,  3026,  1558,  1559,  1560,
   -1477,  1565,  1567,  1568,  1569,  1570, -1475,  1631,  1571,  1618,
    1578,  3226,  1579,  1581,  1582,  1583,  1584,  1646,  2671,  1585,
    2649,  1586,  2568,  2649,  2649,  1587,  1588,  2649,  1658,  1765,
    1666,  1642,  1142,  1792,  1800,  1144,  3241,  2649,  2708,  1806,
     755,  1807,  1329,  1609,  3249,  1808,  3176,  1610,  3255,  1810,
    1813,  1811,  1993,  3125,  1812,  1842,  1814,  1815,  3132,  1836,
    3862,  1843,  3266,  1862,  3176,  1866,  3308,  1868,  1611,  1612,
    3855,  1869,  1870,  1871,  1872,  1897,  1905,   880,  1907,   880,
     615,  1898,  1917,  1918,  1613,  1920,  3318,  3183,  3185,  1921,
    1923,  1929,  3192,  1922,  1932,  2569,  1933,  1930,   615,  1619,
    1620,  1621,  1934,  1622,  1623,  1624,  1625,  1626,  1627,  1614,
    3245,  1940,  1615,  1941,  1944,  1945,  2851,   881,  1948,  1192,
    1955,  1956,   172,  1962,  1963,  1616,  3234,  1972,  1085,  1226,
    1973,  1983,  1984,  1985,  1994,  1988,  1989,  3647,  3648,  3272,
     880,  3667,  2011,  2012,  2209,  2570,  2024,  2265,  3207,  1997,
    2026,  1193,  2027,  2034,  3208,  1549,  3937,  1538,  1555,   162,
    3286,  2036,  2037,  2054,  3209,  2057,  2060,  1160,  2061,   173,
     518,  2066,  1267,  2265,  2265,  2082,  2101,  2816,  2087,  2102,
    2065,  2947,   174,  2107,  2110,  2112,  3932,  2128,  2113,  2117,
    2709,  3210,  2210,  3211,  2130,  2571,  2132,  2146,  2147,   175,
    1618,  2176,  2182,  2131,  2192,   176,  1194,  2133,  3287,  2205,
    2231,  2274,  3290,  3291,  2232,  3293,  2275,  3295,  3296,  2237,
     177,  2211,  1603,  2287,  2293,  2298,  3301,  2330,  2305,  2357,
    2370,   701,  2377,  2406,  1216,  2374,  3852,  1195,   178,  2297,
    1217,   615,  2212,  2311,  2328,  3402,  3403,  3404,  2378,   179,
    2373,  2387,  2947,  4079,   180,  2397,  2396,  2422,  3317,  2424,
     181,  2388,  2435,  4079,  2400,  3212,  3963,  2420,  2423,  2440,
    2443,  2213,  1196,  2445,  2454,   182,  2214,  3910,   695,  2459,
    2447,  1218,  2448,  2463,  2572,  2480,  3379,  2483,   695,  2466,
    1619,  1620,  1621,  2496,  1622,  1623,  1624,  1625,  1626,  1627,
     183,  1197,  3499,  3297,  2501,  1093,  3298,  1097,  2503,  3398,
    3399,  3400,  3401,  2561,  4121,  2557,  4017,  2564,  2552,  1591,
    3213,  2710,  2215,  2565,  2971,  3214,  2614,  2627,  1198,  3405,
    1219,  2638,  2634,  3780,  2635,  2640,  2639,  1220,  2642,  3440,
    1221,  2643,  2646,  2644,  2645,  2658,  2656,  2662,  2665,  3322,
     184,  2669,  2672,  2674,  2673,  2675,  2676,  2678,  2677,  1199,
    2711,  3215,  2265,    32,  2683,  2702,  2707,  1200,  2714,  2720,
    2726,  2729,  2735,  1201,  3216,  2750,  2767,  2734,   185,  3559,
    1202,  2753,  3562,  2765,  2769,  2573,  4165,  2768,  1203,  2771,
    2772,  2786,  1222,  2574,  2787,  2781,  2575,  1204,  4072,  2784,
     185,  2386,  2793,   186,  2794,  1205,  2795,  2796,  1461,   187,
    2805,  2206,  2815,  2819,  2798,   188,  2821,   958,   189,  2824,
    2826,  2827,  2841,  2845,  2842,  2216,  2880,  2892,  2906,  2911,
    2926,  2217,  4075,  2844,  2846,  2955,  2957,  2218,  3876,  -927,
    2152,  2995,  3003,  2949,   190,  2849,   191,  1223,  3022,  1224,
     192,  2850,  2852,  2855,  2873,  3217,  1206,  2879,   193,  1225,
    2881,  2882,  3176,   194,  3005,  4110,  2219,  1226,  2220,  4115,
    4116,  2983,  2889,  2904,  2905,   195,  1227,  2985,  2919,  3544,
    3543,  2989,  3545,  2929,  3546,  2221,  3000,  3006,   196,  3014,
    3855,  3975,  2954,  3017,  3019,  3037,   615,  3010,  3023,  3048,
    3011,  3049,  3056,  3064,  3038,  4111,  3615,  4114,  3572,  3573,
    2222,  1229,   615,  3055,  3066,  3097,  3111,  3098,  3101,  3112,
    3104,  3109,  2649,  3110,  3113,  3641,  3114,  3103,  2649,  2649,
    2649,  2649,  2649,  2649,  3115,  3116,  1230,  3117,   880,  3129,
    3118, -2084,  3601,  3092,  3119,  3094,  4278,  3651,  3131,  3120,
    3494,  3495,  3496,  3497,  2758,  3121,   881,  3122,  3123,  3124,
    3133,  1981,  3135,  3141,  3147,  4117,  3148,  4119,  3149,  3150,
    3151,  3178,   615,  1192,  3152,  2804,  2043,  3193,  3198,  3199,
    3235,  3619,  3621,  3623,  3625,   946,   947,  3181,  4169,  3182,
    3237,  3239,  3194,  4278,  1231,  3251,  3608,  3246,  3126,  3253,
    3261,  4278,  3247,  3256,  3264,  1193,  3260,  3257,  3285,  3265,
    3313,  3307,  3302,  3303,  3292,  3618,  3294,  3304,  3314,   624,
     625,  3323,  3140,  3312,   631, -2084,  1535,  3328,   641,   647,
     624,  2876,   654,  2858,  2875,   647,   647,  1596,   681,  4051,
     684,  3386,  3427,  3358,  3374,  3359,  3678,  3450,  3360,  3469,
    3490,  3492,  3387,  2947,   162,  3677,  3366,  2947,  3493,  3527,
    1194,  3504,  3395,  3411,  3505,  3525,  3554,  3539,  3570,  4092,
    3424, -2084,  3433,  3443,  3444,  3507,  3518,  3446,  3526,  3537,
    3538,  3983,  3513, -2084,  3447,  3574,  3509, -2084,  3540,  3541,
     778,  1195, -2084,  3582,  3583,  3542,  3580, -2084,  3613,  3611,
   -2084,  3612, -2084,  3640,  3710,  2164,  3632,  3748,  3749,  3750,
    3751,  3277,  3652,  3653,  3655,  3656,  4000,  3671,  3674,  3683,
    2759,  3684,   615,  3687,  3689,  3675,  1196,  3690,  2518, -2084,
    3633,  3695,  3700,  3703,  3704,  3693,  3694,  2758,  4267,  3705,
    3706,  3707,  3715,  3724,  3725,  3756,  3726,  3712,  3719,  3754,
   -2084,  3757,  3720,  3288,  3727,  1197,  1192,  3728,  3752,  3732,
    3764,  3767,  3769,  3770,  3772,  3773,  1634,  3781,  3788,   738,
     743,   743,   746,  3796,   743,   751,  3784,   738,  3790,   681,
    3795,   780,  3804,  3815,  3818,   681, -2084,   681,  1193,  3819,
    3826,   743,  3832,   681, -2084,  3825,  3835,  3839,  3844,  3849,
    3853,  2940,  3836,  3868,  3860,  2940,  3869,  3877,  3879,  3865,
    3880,  3881,  3884,  3886,  3892,  3895,  3899,    32,  3905,  3907,
    3329,  2760,  3908,  3916,  3922,  3779,  3930,  1201,  3931,  3933,
    3938,  3940,  3942,  3943,  1202,  3941,  3949,  3956,  3789, -2084,
    3335,  3965,  1881,  1194,   162,  3782,  3787,  3959,  3989,  3969,
    3977,  1204,  3993,  4009,  4010,  3971,  3973,  4019,  3992,  1205,
    4002,  4003,  3639,  4026,  4036,  3357,  4028,  4037,  4039,  4053,
    4041,  4076,  4082,  4091,  1195,  4054,  1602,  4099,   615,  1603,
    4128,   702,  4133,  4108,   628,  4139,  4143,  4149,  4137,  4150,
    4151,  4156,  4157,  4167,  4163,  4162,  1604,  4168,  3820,  4173,
    4180,  1515,  4175,  2759,  4186,  1606,  4112,  4192, -2084,  1196,
    1206,  1607,  4191,  4193,  2761,  4202,  4196,  4198,  4233,  3435,
    4228,  4207,  4208,  4225,  4194,  4230,  3807,  4236,  4195,  4258,
     615, -2084,  4270, -2084, -2084,  1608,  4244,  4286,  1197,  4289,
    4295,  1192,  4299,  3829,  3830,  1995,  1214,  2717,  3833,  3834,
    1665,  2964,  2556,  3061,  3522,  2626,  3154,  3823,  3824,  4013,
    1133,  3854,  4123,  2649,  2649,  3890, -2084,  4038,  2804, -2084,
   -2084, -2084,  3673,  1193,  4040,  3874,   881,   880,  3008,  4050,
    2792,  3858,  4231,  3859,  3981,  4177,  3863,  3864,  4266,  4199,
    4197,  4242,  4145,  3013,  3891,  3643,  3915,  2700,  2947,  3871,
      32,  2701,  2960,  2947,  1200,  3521,  2947,  3073,  3644,  2079,
    1201,  3645,  2684,  3847,  3848,  3242,  4269,  1202,  4300,  4296,
    3195,  3179,  4243,  4001,  2064,  1881,  4188,  4234,  1194,  4004,
     630,   615,  3701,  1510,  1204,  1609,  2947,  3888,   778,  1610,
    4094,  3679,  1205,  2509,  3680,  4155,  3130,  4251,  4297,  4141,
    2382,   882,  1106,  2804,  2381,  2804,  2968,  3661,  2155,  1195,
    1611,  1612,  2969,  3460,  3909,  1762,  1789,  2405,  2971,  3783,
    1788,  3999,  2981,   778,  1127,  2977,  1613,  2994,  3842,  2404,
    2399,  1793,  2982,  3762,  3407,  3710,  3710,  3710,  3710,  4084,
    1114,  1796,  3845,  1206,  1196,  3461,  2670,  2761,  4074,  3378,
    3368,  1614,   806,  4216,  1615,  4217,  4224,   681,   755,   738,
    2972,  2924,   743,  2836,   746,  2922,   743,  1616,     0,  3457,
    1617,  2356,   780,  1197,     0,   859,     0,  3918,     0,  3919,
    3920,     0,   743,     0,     0,     0,     0,     0,     0,     0,
    3923,     0,     0,     0,     0,     0,  2940,     0,     0,     0,
    2947,  2940,     0,   738,  2940,     0,     0,     0,   746,     0,
       0,     0,   738,     0,     0,   780,     0,     0,     0,     0,
       0,     0,     0,     0,  1602,     0,     0,  1603,  4022,     0,
     743,  3889,     0,     0,     0,    32,     0,  1880,     0,  1200,
       0,     0,  1618,     0,  1604,  1201,     0,  3974,  2947,     0,
       0,     0,  1202,  1606,     0,     0,  3176,     0,  1085,  1607,
    1881,     0,     0,     0,     0,     0,     0,  3649,     0,  1204,
       0,     0,     0,     0,     0, -2097,   681,  1205,     0,     0,
    2649,     0,     0,  1608,  4014,     0,   681,   971,     0,     0,
     615,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1080,     0,   681,   647,     0,
       0,     0,   647,     0,     0,     0,     0,     0,     0,     0,
       0,   162,  4031,     0,     0,   681,     0,     0,  1206,   681,
       0,     0,  1619,  1620,  1621,  1080,  1622,  1623,  1624,  1625,
    1626,  1627,     0,     0,  2375,     0,   681,     0,  4103,     0,
    2376,     0,     0,     0,     0,     0,     0,     0,   681, -2097,
       0,     0,     0,     0,     0,     0,     0,     0,  3984,  3986,
    3986,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1609,     0,     0,     0,  1610,     0,     0,
       0,     0,   778,     0,     0,     0,  2940,     0,     0,     0,
     681,     0,     0,     0,     0, -2097,     0,     0,  1611,  1612,
       0,     0,  4070,   743,   743,     0,     0, -2097,     0,  1515,
       0, -2097,     0,     0,  1613,     0, -2097,     0,     0,     0,
       0, -2097,     0,     0, -2097,  4204, -2097,     0,     0,     0,
       0,     0,     0,     0,     0,  2947,     0,   880,     0,  1614,
       0,     0,  1615,     0,   738,     0,     0,     0,     0,     0,
       0,     0,     0, -2097,   738,  1616,  4096,   780,  1617,     0,
       0,     0,     0,     0,     0,  4232,     0,     0,     0,  4058,
     743,     0,     0,     0, -2097,     0,     0,     0,  2804,     0,
       0,     0,     0,     0,   681,     0,     0,     0,     0,  4122,
     743,   743,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   681,   681,   681,   743,     0,   738,
   -2097,     0,  3808,     0,     0,     0,     0,     0, -2097,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1618,     0,     0,     0,   743,   743,   743,     0,     0,     0,
    3822,     0,     0,     0,     0,     0,     0,  4100,     0,     0,
       0,     0,  3831,     0,     0,     0,     0,     0,  1080,     0,
       0,     0,     0, -2097,     0,     0,     0,     0,     0,  4118,
       0,  4120,  1216,     0,     0,     0,     0,  4298,  1217,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1493,  1493,
       0,     0,     0,   681,     0,   624,  3846,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   628,     0,
       0,     0,  1524,     0,     0,   681,     0,     0,  1530,  1218,
    1619,  1620,  1621,     0,  1622,  1623,  1624,  1625,  1626,  1627,
       0,  1080, -2097,     0,     0,     0,     0,  2899,  4285,     0,
       0,     0,     0,     0,   162,  4256,   166,  4253,  4254,  4255,
       0,     0,     0,     0,     0, -2097,     0, -2097, -2097,  3986,
    1080,     0,     0,     0,     0,  4277,     0,     0,  1219,     0,
       0,     0,     0,     0,     0,  1220,     0,     0,  1221,  4284,
    4256,   166,  4253,  4254,  4255,     0,     0,     0,  1080,  1080,
   -2097,  1080,     0, -2097, -2097, -2097,     0,     0,     0,  4276,
       0,  4201,     0,     0,  4263,     0,     0,     0,  1080,     0,
       0,     0,  4277,     0,     0,     0,     0,     0,     0,     0,
    4277,     0,     0,   162,  4256,   166,  4253,  4254,  4255,     0,
    1222,     0,     0,     0,     0,  1601,     0,     0,     0,     0,
    1602,  1515,     0,  1603,   681,     0,  4276,  1080,     0,     0,
       0,     0,     0,  4235,  4276,     0,     0,     0,     0,     0,
    1604,     0,     0,     0,  1605,     0,     0,     0,     0,  1606,
       0,     0,     0,     0,     0,  1607,  1080,     0,     0,     0,
    1080,  1080,     0,     0,     0,  1223,     0,  1224,     0,     0,
     681,   681,  1799,     0,     0,  4268,     0,  1225,     0,  1608,
       0,     0,     0,     0,     0,  1226,     0,     0,   647,     0,
       0,     0,     0,     0,  1227,     0,     0,     0,     0,  1602,
       0,     0,  1603,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1604,
     647,     0,     0,     0,     0,  1228,     0,     0,  1606,  1229,
       0,     0,   681,  1904,  1607,     0,     0,     0,     0,   681,
       0,     0,   743,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1230,     0,     0,     0,  1608,     0,
     780,     0,     0,     0,     0,     0,     0,   681,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1609,
       0,     0,     0,  1610,     0,     0,     0,   681,     0,     0,
       0,     0,     0,     0,     0,   743,   743,   743,   743,   681,
       0,     0,     0,     0,  1611,  1612,     0,     0,     0,     0,
     647,     0,  1231,   681,     0,     0,     0,     0,     0,     0,
    1613,     0,     0,     0,  2007,     0,   681,     0,     0,     0,
       0,     0,     0,  1515,   743,   743,     0,     0,     0,     0,
     743,     0,     0,     0,     0,  1614,     0,     0,  1615,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1609,     0,
       0,  1616,  1610,  3126,  1617,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1611,  1612,     0,   743,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1613,
    1515,     0,     0,     0,  1515,  1515,     0,     0,     0,     0,
     743,   743,   743,   743,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1614,     0,     0,  1615,     0,  2007,
       0,     0,     0,     0,     0,     0,  1618,     0,   738,     0,
    1616,     0,     0,  1617,     0,   746,     0,   738,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   780,     0,     0,
       0,     0,   743,     0,     0,     0,     0,     0,     0,     0,
       0,   743,     0,     0,     0,     0,     0,   743,   743,     0,
       0,     0,   681,     0,     0,     0,     0,     0,     0,  1602,
       0,     0,  1603,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1493,     0,  1604,
       0,     0,     0,     0,   743,  1618,   738,     0,  1606,     0,
     681,   681,     0,   743,  1607,     0,  1619,  1620,  1621,   681,
    1622,  1623,  1624,  1625,  1626,  1627,     0,     0,     0,     0,
       0,     0,   624,   624,     0,     0,  2208,     0,  1608,     0,
    1080,     0,  1080,     0,     0,     0,     0,     0,     0,  1080,
       0,     0,  1080,     0,     0,     0,  1080,     0,     0,     0,
       0,     0,     0,     0,  1080,  1080,     0,     0,     0,     0,
       0,     0,  1080,     0,   780,  1080,  1080,  1080,  1080,     0,
       0,     0,     0,     0,     0,  1080,  1080,     0,  1080,     0,
    1080,  1080,     0,     0,  1080,  1619,  1620,  1621,     0,  1622,
    1623,  1624,  1625,  1626,  1627,     0,     0,     0,     0,  2296,
       0,  1080,     0,     0,     0,   743,  1080,     0,     0,     0,
    1080,     0,     0,     0,  1080,     0,  1080,  1080,  1080,  1080,
    1080,  1080,  1080,  1080,  1080,     0,  1080,     0,  1609,     0,
     681,  1080,  1610,  1080,     0,     0,     0,     0,     0,   681,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1611,  1612,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1613,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1614,     0,     0,  1615,     0,     0,
       0,     0,     0,     0,     0,     0,  1602,     0,     0,  1603,
    1616,     0,     0,  1617,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1602,     0,  1606,  1603,     0,     0,     0,
       0,  1607,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1216,     0,  1604,   681,     0,   681,  1217,  1080,     0,
       0,     0,  1606,     0,     0,  1608,     0,     0,  1607,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1618,     0,     0,     0,     0,
       0,     0,  1608,     0,     0,  2412,     0,  2419,  1218,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   746,     0,     0,     0,     0,   624,     0,   624,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1080,     0,     0,     0,
       0,     0,   738,     0,   743,   743,   743,  1219,   738,   780,
       0,   743,     0,   743,  1220,   743,   743,  1221,     0,   681,
       0,     0,     0,     0,     0,  1609,     0,     0,     0,  1610,
       0,     0,     0,     0,     0,  1619,  1620,  1621,   647,  1622,
    1623,  1624,  1625,  1626,  1627,     0,     0,     0,     0,  3180,
    1611,  1612,  1609,     0,     0,     0,  1610,  1904,     0,     0,
       0,     0,     0,  2519,     0,     0,  1613,     0,  2528,  1222,
       0,     0,     0,     0,   681,     0,     0,  1611,  1612,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2559,  2559,     0,  1613,  1615,     0,     0,   746,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1616,     0,     0,
       0,     0,   743,     0,     0,     0,     0,     0,  1614,     0,
       0,  1615,     0,     0,  1223,     0,  1224,     0,  -115,     0,
       0,     0,     0,     0,  1616,     0,  1225,  1617,  2616,     0,
    2618,  2620,     1,     0,  1226,     0,     0,     0,     0,     0,
       0,     0,     2,  1227,     3,     4,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   743,     0,
       5,     0,  1366,     0,     0,     0,   743,   743,   743,   743,
     743,   743,  1618,     0,  1271,     0,     0,     0,  1229,     0,
       6,  1080,     7,     8,     0,     0,     0,     0,     9,     0,
      10,     0,     0,     0,     0,     0,     0,     0,     0,  1618,
      11,     0,    12,  1272,     0,     0,     0,     0,  1904,     0,
       0,     0,  2559,   681,     0,     0,     0,   624,    13,     0,
       0,    14,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    15,     0,    16,     0,     0,     0,    17,
       0,     0,     0,  2616,     0,    18,     0,     0,     0,     0,
     743,  2746,    19,     0,    20,     0,     0,     0,     0,     0,
      21,  1231,  1619,  1620,  1621,     0,  1622,  1623,  1624,  1625,
    1626,  1627,     0,     0,    22,   743,     0,   743,  2559,   743,
    2559,     0,     0,     0,     0,     0,     0,     0,  1366,  1619,
    1620,  1621,     0,  1622,  1623,  1624,  1625,  1626,  1627,  1080,
       0,     0,     0,  3330,     0,     0,     0,     0,     0,     0,
       0,  1493,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    23,    24,
       0,     0,     0,     0,    25,     0,     0,     0,     0,     0,
       0,     0,    26,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    27,     0,     0,   738,     0,     0,     0,
       0,   738,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   743,     0,     0,     0,     0,     0,     0,  1080,  1080,
       0,     0,     0,     0,  1080,     0,     0,     0,     0,     0,
      28,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    29,     0,     0,     0,     0,    30,     0,    31,  1080,
    1080,     0,     0,    32,  1080,     0,     0,  1602,    33,  1652,
    1603,    34,     0,     0,     0,    35,  1080,  1080,  1080,  1080,
      36,    37,     0,     0,     0,   807,     0,  1604,    38,  1080,
       0,    39,  1080,     0,  1080,  2903,  1606,     0,     0,    40,
       0,     0,  1607,     0,  1080,  1080,     0,     0,  1080,     0,
       0,    41,     0,     0,     0,     0,     0,     0,     0,   808,
       0,  1080,     0,  1080,     0,   780,  1608,  1080,    42,     0,
       0,  1366,   809,   810,  1602,     0,     0,  1603,    43,     0,
       0,   811,     0,  1080,    44,   812,     0,   681,     0,    45,
       0,     0,     0,     0,  2948,     0,  1080,  1080,  1080,     0,
       0,    46,   813,  1606,     0,     0,     0,     0,     0,  1607,
       0,     0,     0,  1080,     0,     0,  1602,     0,     0,  1603,
       0,     0,     0,   814,  1366,  1080,     0,     0,     0,     0,
    1080,     0,     0,  1608,   681,    47,  1604,  1080,  -115,     0,
       0,   815,     0,  2948,     0,  1606,  2988,     0,     0,     0,
    2419,  1607,   816,     0,  1366,     0,     0,   817,     0,     0,
       0,     0,     0,     0,     0,     0,  1609,     0,     0,     0,
    1610,     0,     0,     0,     0,  1608,     0,     0,   818,     0,
    1080,     0,  2559,     0,     0,     0,     0,  1493,     0,     0,
       0,  1611,  1612,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   819,     0,     0,     0,  1613,   743,  1602,
     743,   743,  1603,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1366,     0,     0,     0,     0,  1604,
       0,     0,  1614,  1609,     0,  1615,     0,  1610,  1606,     0,
       0,     0,     0,  1366,  1607,     0,     0,     0,  1616,     0,
       0,  1617,     0,   820,     0,     0,     0,     0,  1611,  1612,
       0,     0,     0,  1366,     0,     0,     0,     0,  1608,     0,
       0,     0,     0,     0,  1613,  1609,     0,     0,     0,  1610,
       0,   185,     0,     0,     0,     0,     0,     0,  1366,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1614,
    1611,  1612,  1615,     0,     0,     0,   821,     0,     0,     0,
     822,     0,   823,     0,     0,  1616,  1613,     0,   824,     0,
       0,   825,     0,  1618,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1216,     0,     0,
    1366,  1614,     0,  1217,  1615,     0,     0,   826,  1602,   827,
       0,  1603,     0,   828,     0,     0,     0,  1616,     0,     0,
    1617,   829,     0,     0,     0,     0,   830,     0,  1609,     0,
       0,     0,  1610,     0,     0,     0,     0,  1606,     0,     0,
       0,  2559,  2559,  1607,  1218,     0,     0,     0,     0,     0,
    1618,   831,     0,  1611,  1612,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1608,     0,  1613,
       0,     0,     0,  1619,  1620,  1621,     0,  1622,  1623,  1624,
    1625,  1626,  1627,     0,     0,     0,     0,  3377,     0,     0,
       0,     0,  1618,  1219,  1614,     0,     0,  1615,     0,   681,
    1220,     0,     0,  1221,     0,     0,     0,     0,     0,     0,
    1616,     0,     0,  1617,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1493,   681,     0,     0,     0,     0,  2909,
       0,     0,   681,     0,     0,     0,   681,     0,     0,     0,
    1619,  1620,  1621,     0,  1622,  1623,  1624,  1625,  1626,  1627,
     681,     0,     0,     0,     0,  1222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0, -2171,     0,     0,
       0,  1610,     0,     0,     0,     0,  1366,     0,   743,     0,
       0,   743,  1619,  1620,  1621,  1618,  1622,  1623,  1624,  1625,
    1626,  1627,  1611,  1612,     0,   738,  3449,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0, -2171,     0,
    1223,     0,  1224,     0,     0,     0,   681,     0,     0,     0,
       0,     0,  1225,     0,   743,     0,     0,     0,     0,     0,
    1226,     0,  1080,     0,     0,     0,  1615,     0,     0,  1227,
       0,     0,  1080,     0,     0,     0,     0,     0,  1080,  1616,
    1080,     0,     0,     0,     0,     0,  1080,     0,     0,  1080,
    1080,  1080,  1080,  1080,  1080,  1080,  1080,  1080,  1080,     0,
    1297,     0,  1080,  1080,  1229,  1619,  1620,  1621,     0,  1622,
    1623,  1624,  1625,  1626,  1627,  1080,     0,  3445,     0,  1080,
       0,     0,     0,  1080,     0,     0,     0,     0,     0,  1298,
       0,     0,     0,  1080,     0,     0,  1080,     0,  1080,     0,
       0,     0,     0,     0,     0,     0,     0,  1080,  1080,  1080,
       0,     0,     0,  1080, -2171,     0,  1080,     0,     0,     0,
       0,     0,     0,   681,   681,   681,  2948,  3410,     0,     0,
       0,  3410,  3423,     0,     0,     0,  1080,     0,     0,     0,
       0,     0,  3437,     0,  1080,     0,  1080,  1231,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1080,     0,     0,     0,     0,     0,  1080,     0,     0,     0,
    2419,     0,  1080,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3477,  1493,  1493,
       0,  2007,     0,     0,     0,     0,     0,     0,  1622,  1623,
    1624,  1625,  1626,  1627,     0,   743,   743,   743,   743,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1216,     0,     0,     0,     0,     0,  1217,     0,     0,  1602,
       0,     0,  1603,     0,     0,     0,     0,     0,     0,     0,
    1366,     0,     0,  3520,     0,  1366,  1366,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1366,  1606,     0,
       0,     0,     0,     0,  1607,     0,     0,  1218,   740,     0,
       0,     0,     0,     0,     0,     0,   740,   759,     0,     0,
       0,     0,   759,     0,     0,     0,     0,     0,  1608,  1602,
       0,   759,  1603,     0,     0,     0,     0,     0,     0,     0,
       0,  1602,     0,     0,  1603,     0,     0,     0,  3575,  1604,
       0,     0,     0,     0,     0,     0,  1219,     0,  1606,     0,
       0,     0,     0,  1220,  1607,     0,  1221,     0,     0,     0,
    1606,     0,     0,     0,     0,     0,  1607,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1608,     0,
    2920,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1608,     0,  1602,     0,     0,  1603,     0,     0,     0,     0,
       0,     0,     0,     0,   681,     0,     0,     0,  1222,     0,
       0,     0,     0,     0,     0,   743,     0,  1080, -2171,  1366,
       0,  1606,  1610,   681,     0,     0,     0,  1607,     0,     0,
       0,     0,     0,     0,     0,  1904,     0,     0,     0,     0,
       0,     0,     0,  1611,  1612,   681,     0,     0,     0,     0,
       0,  1608,  3392,     0,  2616,     0,     0,     0,     0, -2171,
    3668,     0,     0,  1223,  1904,  1224,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1225,  1080,  1080,  1609,     0,
       0,     0,  1610,  1226,     0,     0,     0,  1615,     0,     0,
   -2171,     0,  1227,  1366,  1610,     0,     0,     0,     0,  2559,
    1616,  2559,     0,  1611,  1612,     0,     0,     0,     0,     0,
       0,     0,     0,  3393,     0,  1611,  1612,     0,     0,  1613,
       0,     0,     0,  1863,     0,     0,     0,  1229,     0,     0,
       0, -2171,     0,  1080,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1614,     0,     0,  1615,     0,     0,
       0, -2171,  1864,     0,     0,  1610,     0,     0,     0,  1615,
    1616,     0,     0,  1617,     0,     0,     0,     0,     0,     0,
    1080,     0,  1616,     0,     0, -2171,  1611,  1612,  1366,     0,
    1080,  1080,     0,     0,     0,     0,     0,     0,  1080,  1080,
       0,     0, -2171,  1080,     0,     0,     0,     0,     0,  1080,
    1080,     0,     0,  1080,     0,   681,   681,   681,   681,     0,
    1231,     0,  3410,     0,     0,  3753,     0,     0,  2948,     0,
    1615,     0,  2948,     0,     0,     0,     0,     0,  3766,     0,
       0,  1080,     0,  1616,     0,  1618,  1080,     0,   740,     0,
       0,     0,  3776,     0,     0,     0,     0, -2171,  1080,   759,
       0,     0,     0,   759,   780,  1216,     0,     0,     0,     0,
       0,  1217,  2988,     0,   759,     0,  2419,     0,     0,  1622,
    1623,  1624,  1625,  1626,  1627,     0,   624,     0,   759,  1080,
       0,     0,   740,     0,     0,     0,     0,     0,     0,     0,
       0,   740,   759,     0,     0,     0,   759,     0,     0,  2559,
    2559,     0,  1218,     0,     0,     0,   759,     0, -2171,     0,
       0,     0,     0,     0,   759,     0,     0,     0,     0,     0,
       0,     0,     0,  3821,     0,  1619,  1620,  1621,     0,  1622,
    1623,  1624,  1625,  1626,  1627,     0,     0,     0,     0,  3471,
       0,  1622,  1623,  1624,  1625,  1626,  1627,     0,     0,     0,
       0,  1219,     0,     0,     0,     0,     0,     0,  1220,     0,
       0,  1221,     0,   743,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   743,     0,     0,
       0,     0,     0,     0,   740,     0,     0,     0,     0,   759,
       0,     0,     0,     0,     0,     0,     0,  1602,     0,     0,
    1603,     0,  1622,  1623,  1624,  1625,  1626,  1627,     0,     0,
       0,  1493,     0,  1222,   740,     0,     0,  1604,     0,     0,
       0,     0,     0,     0,     0,     0,  1606,     0,     0,     0,
       0,     0,  1607,     0,     0,     0,     0,     0,     0,  1080,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1366,
       0,     0,     0,     0,     0,     0,  1608,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   743,  1904,  1223,     0,
    1224,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1225,     0,     0,     0,     0,     0,     0,     0,  1226,  1366,
    1366,     0,  1366,     0,   681,     0,     0,  1227,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1080,     0,     0,     0,     0,     0,  2515,     0,
       0,  1080,  1229,   740,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   740,  1366,     0,  1366,     0,  1080,  1080,
       0,     0,  1080,     0,     0,     0,  1609,  1230,     0,  3410,
    1610,     0,     0,  2948,     0,  1368,     0,     0,  2948,     0,
       0,  2948,  2616,     0,  3961,     0,  1080,  1080,     0,     0,
       0,  1611,  1612,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1613,   740,  1366,
       0,  3477,   780,   743,   743,   743,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1231,     0,     0,     0,     0,
       0,     0,  1614,  1366,     0,  1615,     0,     0,   759,     0,
       0,     0,     0,     0,     0,     0,   738,   780,  1616,  1602,
       0,  1617,  1603,   759,     0,     0,     0,   740,  1366,     0,
       0,     0,     0,     0,     0,   759,     0,     0,     0,  1604,
       0,     0,     0,     0,     0,     0,  1366,  1493,  1606,     0,
       0,     0,     0,   738,  1607,  1602,   681,     0,  1603,     0,
       0,     0,     0,   759,     0,     0,     0,  2559,     0,  1904,
       0,  1368,     0,   759,     0,  1604,     0,     0,  1608,     0,
       0,  3668,     0,     0,  1606,   759,   681,     0,   759,     0,
    1607,     0,     0,  1618,   743,  3477,     0,     0,     0,     0,
     740,     0,     0,  1602,     0,     0,  1603,     0,     0,  1366,
       0,     0,     0,     0,  1608,     0,     0,  1080,     0,     0,
    1080,     0,  1080,  1366,     0,     0,     0,     0,     0,   740,
       0,     0,  1606,     0,  1366,     0,     0,     0,  1607,  1080,
       0,     0,     0,  2948,     0,     0,  3961,     0,     0,     0,
       0,     0,  4090,     0,     0,     0,     0,   740,   740,     0,
     740,     0,  1608,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   743,     0,     0,     0,   681,   740,  1609,     0,
       0,     0,  1610,  1619,  1620,  1621,     0,  1622,  1623,  1624,
    1625,  1626,  1627,   743,   743,   743,   743,  3713,     0,   759,
       0,  1366,     0,  1611,  1612,     0,     0,   759,   759,     0,
       0,     0,     0,     0,  1609,     0,   740,  1749,  1610,  1613,
       0,  1366,  1216,  1080,  3396,     0,     0,     0,  1217,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1611,
    1612,     0,     0,     0,  1614,   740,  1366,  1615,     0,   740,
     740,     0,     0,     0,     0,  1613,     0,     0,     0,     0,
    1616,     0, -2171,  1617,  1368,     0,  1610,     0,     0,  1218,
    1749,     0,     0,     0,     0,     0,     0,     0,  1080,     0,
    1614,     0,  1366,  1615,   743,     0,   780,  1611,  1612,     0,
       0,     0,     0,     0,     0,  1080,  1616,     0,     0,  1617,
       0,     0,     0, -2171,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1368,  1219,     0,
       0,     0,     0,     0,     0,  1220,   743,     0,  1221,     0,
     738,  1615,     0,     0,     0,  1618,     0,     0,     0,     0,
    3477,     0,  1216,     0,  1616,     0,     0,  1368,  1217,     0,
       0,     0,     0,     0,  4090,     0,     0,  1080,  1080,     0,
       0,     0,     0,  1602,     0,     0,  1603,     0,     0,     0,
     738,  1618,     0,     0,     0,     0,     0,     0,   743,     0,
    1222,  1602,     0,  1604,  1603,     0,     0,     0,     0,  1218,
       0,     0,  1606,     0,     0,     0,     0,   759,  1607,     0,
       0,  1604,     0,     0,     0,  1080,     0,     0,     0,     0,
    1606,     0,     0,     0,     0,  1080,  1607,  1368,     0, -2171,
     743,     0,  1608,     0,     0,  1619,  1620,  1621,     0,  1622,
    1623,  1624,  1625,  1626,  1627,  1223,  1368,  1224,  1219,  3747,
    1608,     0,     0,     0,  1366,  1220,     0,  1225,  1221,     0,
       0,     0,     0,     0,     0,  1226,  1368,     0,     0,     0,
       0,  1619,  1620,  1621,  1227,  1622,  1623,  1624,  1625,  1626,
    1627,     0,     0,  1080,     0,  3939,  1749,     0,     0,     0,
       0,  1368,   738,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   759,     0,  2591,     0,     0,     0,  1229,
    1222,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,     0,     0,  1622,  1623,  1624,  1625,  1626,  1627,     0,
       0,     0,  1609,     0,  2592,     0,  1610,   740,     0,     0,
       0,     0,     0,  1368,     0,     0,   740,     0,   759,   759,
    1609,     0,     0,     0,  1610,     0,     0,  1611,  1612,   759,
       0,     0,     0,     0,     0,  1223,     0,  1224,     0,     0,
       0,   759,   759,  1613,     0,  1611,  1612,  1225,     0,     0,
       0,     0,     0,   759,     0,  1226,     0,     0,     0,     0,
       0,  1613,  1231,     0,  1227,     0,     0,     0,  1614,     0,
       0,  1615,     0,     0,     0,     0,     0,     0,  1366,     0,
       0,     0,     0,     0,  1616,   740,  1614,  1617,     0,  1615,
       0,     0,     0,     0,     0,  2629,     0,     0,     0,  1229,
       0,     0,  1616,     0,     0,  1617,     0,     0,     0,     0,
       0,  1366,     0,     0,     0,     0,     0,     0,     0,   740,
       0,   740,     0,     0,  2630,     0,     0,     0,   740,     0,
       0,   740,     0,     0,     0,   740,     0,     0,     0,     0,
       0,  1216,     0,   740,   740,     0,     0,  1217,     0,     0,
       0,   740,     0,     0,   740,   740,   740,   740,     0,  1618,
       0,     0,     0,     0,   740,   740,     0,   740,     0,   740,
     740,     0,     0,   740,     0,     0,     0,  1618,     0,     0,
       0,     0,  1231,     0,     0,     0,     0,     0,  1218,  1368,
     740,  1749,     0,     0,     0,   740,     0,     0,     0,   740,
       0,     0,     0,   740,     0,   740,   740,   740,   740,   740,
     740,   740,   740,   740,     0,   740,     0,     0,     0,  1366,
     740,     0,   740,     0,     0,     0,     0,     0,     0,     0,
    1366,     0,   556,     0,     0,     0,     0,  1219,     0,     0,
       0,     0,     0,     0,  1220,   557,     0,  1221,     0,  1619,
    1620,  1621,     0,  1622,  1623,  1624,  1625,  1626,  1627,     0,
       0,     0,     0,  3979,     0,     0,   558,  1619,  1620,  1621,
       0,  1622,  1623,  1624,  1625,  1626,  1627,  1602,     0,   559,
    1603,  4024,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   560,     0,     0,     0,     0,  1604,     0,  1222,
       0,     0,     0,     0,     0,     0,  1606,     0,  1602,   561,
       0,  1603,  1607,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1604,     0,
     562,     0,     0,  1366,     0,     0,  1608,  1606,     0,     0,
       0,     0,     0,  1607,     0,     0,     0,   740,   563,     0,
       0,     0,     0,     0,  1223,     0,  1224,     0,     0,   564,
       0,  1366,     0,     0,   565,     0,  1225,  1608,     0,     0,
     566,     0,     0,  1366,  1226,     0,     0,     0,     0,     0,
       0,     0,     0,  1227,     0,   567,     0,     0,     0,     0,
       0,     0,   759,     0,     0,     0,  1749,   759,     0,     0,
     759,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3042,     0,     0,  1366,  1229,     0,
       0,     0,   759,  1602,     0,   740,  1603,     0,     0,     0,
       0,   740,     0,     0,     0,     0,  1609,   740,     0,     0,
    1610,     0,     0,  3043,     0,     0,     0,     0,     0,     0,
       0,     0,  1606,     0,     0,     0,   759,     0,  1607,     0,
     568,  1611,  1612,     0,     0,     0,     0,  1609,     0,     0,
     569,  1610,     0,  1368,     0,     0,     0,  1613,  1368,  1368,
       0,     0,  1608,   759,   759,     0,     0,     0,   185,     0,
    1368,     0,  1611,  1612,     0,     0,     0,     0,     0,     0,
       0,  1231,  1614,     0,     0,  1615,  1749,   759,  1613,  1749,
       0,     0,     0,   570,     0,     0,     0,   571,  1616,   572,
       0,  1617,     0,     0,     0,   573,     0,   759,   574,     0,
     759,     0,     0,  1614,     0,     0,  1615,     0,     0,     0,
       0,     0,     0,     0,  3745,     0,     0,     0,   759,  1616,
       0,     0,  1617,     0,   575,     0,   576,     0,   759,     0,
     577,     0,  1366,     0,     0,     0,     0,     0,   578,     0,
       0,   759,     0,   579,     0,     0,  1358,     0,     0,     0,
     759,     0, -2171,     0,     0,   580,  1610,     0,     0,     0,
       0,     0,     0,  1618,     0,     0,     0,     0,   581,     0,
       0,     0,     0,     0,     0,     0,     0,  1611,  1612,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     740,     0,  1368, -2171,  1618,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1602,     0,     0,
    1603,  1615,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1616,     0,     0,  1604,  1366,     0,
       0,     0,  2389,     0,     0,     0,  1606,     0,     0,     0,
       0,     0,  1607,  1619,  1620,  1621,     0,  1622,  1623,  1624,
    1625,  1626,  1627,     0,     0,     0,  1368,  4203,     0,   759,
       0,     0,  1358,     0,     0,     0,  1608,     0,     0,     0,
       0,     0,     0,     0,  1619,  1620,  1621,     0,  1622,  1623,
    1624,  1625,  1626,  1627,     0,     0,     0,     0,  4287,     0,
       0,     0,     0,   759,     0,     0,     0,     0,   740, -2171,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2390,     0,  1366,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   759,     0,
       0,     0,     0,     0,  1366,     0,     0,     0,     0,     0,
       0,  1368,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,     0,     0,   740,     0,     0,     0,     0,
     740,     0,     0,     0,  1366,     0,  1609,     0,     0,     0,
    1610,     0,     0,     0,     0,     0,     0,   740,   740,     0,
       0,     0,     0,   740,     0,     0,     0,     0,     0,     0,
       0,  1611,  1612,  1622,  1623,  1624,  1625,  1626,  1627,     0,
       0,  1366,     0,     0,     0,  1366,  1366,  1613,   740,   740,
       0,     0,     0,   740,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   740,   740,   740,   740,     0,
       0,     0,  1614,  1749,     0,  1615,     0,     0,   740,  1749,
       0,   740,     0,   740,     0,     0,     0,     0,  1616,     0,
       0,  1617,     0,   740,   740,  1358,     0,   740,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     740,     0,   740,     0,     0,     0,   740,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   740,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   740,     0,   740,   740,   740,  1358,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   759,
       0,     0,   740,  1618,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   740,     0,     0,     0,  1358,   740,
       0,     0,     0,     0,     0,     0,   740,     0,     0,     0,
       0,     0,   740,     0,     0,     0,     0,     0,  1216,     0,
       0,     0,     0,   545,  1217,     0,     0,     0,   759,   585,
       0,     0,     0,     0,  2391,     0,     0,     0,   633,     0,
       0,     0,     0,   759,   759,     0,     0,     0,     0,   740,
    1251,  1216,     0,     0,     0,     0,   693,  1217,     0,     0,
       0,     0,     0,     0,     0,  1218,     0,     0,  1358,   759,
       0,     0,  1368,  1619,  1620,  1621,     0,  1622,  1623,  1624,
    1625,  1626,  1627,  1251,     0,     0,     0,  1358,     0,     0,
       0,     0,     0,     0,     0,     0,  1252,     0,  1218,     0,
       0,     0,     0,     0,     0,     0,     0,  1358,     0,     0,
       0,     0,  1368,  1368,  1219,  1368,     0,     0,     0,     0,
       0,  1220,     0,     0,  1221,     0,     0,     0,     0,  1252,
       0,     0,  1358,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1749,  1749,  1749,  1219,     0,     0,
       0,     0,     0,     0,  1220,     0,     0,  1221,     0,     0,
       0,     0,     0,   759,     0,     0,     0,  1368,     0,  1368,
     759,     0,     0,  1253,     0,     0,  1222,     0,     0,     0,
     759,     0,     0,     0,  1358,     0,     0,     0,   750,     0,
       0,     0,     0,     0,     0,     0,     0,   782,     0,   785,
       0,   788,     0,   790,     0,     0,  1253,     0,     0,  1222,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1254,
       0,  1255,  1368,     0,     0,     0,     0,     0,     0,     0,
       0,  1256,     0,  1224,     0,     0,     0,     0,     0,     0,
     759,     0,     0,  1225,     0,     0,  1368,     0,     0,     0,
       0,  1226,  1254,     0,  1255,     0,     0,     0,     0,  1257,
    1227,     0,     0,     0,  1256,     0,  1224,     0,  1749,     0,
       0,  1368,     0,     0,     0,     0,  1225,     0,     0,     0,
       0,     0,     0,     0,  1226,     0,     0,     0,  1749,  1368,
       0,  1258,  1257,  1227,     0,  1229,  1259,     0,     0,     0,
       0,     0,   759,     0,   759,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   759,     0,   759,     0,     0,     0,
    1260,     0,     0,     0,  2579,     0,     0,     0,  1229,  1259,
       0,  1261,   760,     0,     0,     0,     0,   760,     0,     0,
       0,     0,     0,     0,     0,     0,   760,     0,     0,     0,
       0,     0,  1368,  2580,     0,     0,     0,     0,     0,     0,
    1358,     0,     0,     0,  1261,   759,  1368,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1368,  1231,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   759,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   740,     0,     0,   759,     0,     0,
       0,  1231,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   759,     0,     0,   759,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   740,     0,     0,  1368,     0,     0,     0,     0,     0,
       0,   740,     0,     0,     0,     0,     0,   740,     0,   740,
       0,     0,     0,     0,  1368,   740,     0,     0,   740,   740,
     740,   740,   740,   740,   740,   740,   740,   740,     0,     0,
       0,   740,   740,     0,     0,     0,     0,     0,     0,  1368,
       0,     0,     0,     0,   740,     0,     0,     0,   740,     0,
    1749,     0,   740,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   740,  1602,     0,   740,  1603,   740,     0,     0,
       0,     0,     0,   838,     0,  1368,   740,   740,   740,     0,
     845,     0,   740,  1604,     0,   740,     0,     0,     0,   860,
     861,     0,  1606,     0,   863,   740,     0,     0,  1607,     0,
       0,     0,     0,     0,   877,   740,     0,     0,     0,     0,
       0,     0,     0,   740,     0,   740,     0,   885,     0,     0,
       0,     0,  1608,     0,     0,     0,     0,     0,     0,     0,
       0,   906,     0,     0,   908,     0,   910,     0,   913,   740,
       0,     0,     0,     0,     0,   740,     0,     0,     0,  1602,
       0,   740,  1603,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   740,     0,     0,  1604,
       0,     0,     0,     0,     0,     0,     0,     0,  1606,     0,
       0,     0,     0,     0,  1607,     0,     0,     0,     0,     0,
       0,     0,     0,   759,  1358,   968,     0,   969,     0,  1358,
    1358,  2875,     0,     0,     0,     0,  2876,     0,  1608,     0,
       0,  1358,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1609,     0,   760,     0,  1610,     0,   760,     0,
       0,     0,  1749,     0,     0,     0,  1749,  1368,  1749,   760,
       0,     0,     0,     0,     0,     0,     0,  1611,  1612,     0,
     693,     0,     0,   760,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1613,     0,     0,     0,   760,     0,     0,
     759,   760,     0,   759,     0,     0,     0,     0,     0,     0,
       0,   760,     0,     0,     0,     0,     0,     0,  1614,   760,
       0,  1615,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1616,     0,     0,  1617,  1609,     0,
       0,     0,  1610,   759,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1602,     0,     0,  1603,     0,
       0,     0,     0,  1611,  1612,     0,     0,     0,     0,     0,
       0,     0,     0,  1358,     0,  1604,     0,     0,     0,  1613,
       0,     0,     0,     0,  1606,     0,  1300,     0,     0,     0,
    1607,     0,     0,     0,   760,     0,   740,     0,     0,     0,
       0,  1312,     0,     0,  1614,     0,     0,  1615,     0,  1618,
       0,     0,  1320,     0,  1608,     0,     0,   759,   759,  1322,
    1616,  1368,     0,  1617,     0,     0,     0,     0,     0,     0,
       0,  1372,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3369,     0,     0,     0,     0,  1358,     0,     0,
       0,     0,     0,     0,  1368,   740,   740,     0,     0,     0,
       0,     0,     0,  1414,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4261,     0,     0,  1618,   759,     0,     0,  1619,
    1620,  1621,     0,  1622,  1623,  1624,  1625,  1626,  1627,  3370,
       0,     0,   740,     0,  1609,     0,     0,     0,  1610,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1358,     0,     0,     0,     0,     0,     0,  1611,
    1612,     0,     0,     0,     0,     0,     0,     0,     0,   740,
       0,     0,     0,     0,     0,  1613,     0,     0,     0,   740,
     740,     0,  1368,     0,     0,     0,     0,   740,   740,     0,
       0,     0,   740,  1368,     0,     0,     0,     0,   740,   740,
    1614,     0,   740,  1615,     0,  1619,  1620,  1621,     0,  1622,
    1623,  1624,  1625,  1626,  1627,     0,  1616,   740,     0,  1617,
       0,   740,     0,     0,     0,     0,     0,     0,     0,     0,
     740,     0,     0,     0,     0,   740,  4262,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   740,     0,     0,
       0,     0,     0,   760,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   760,     0,
    1602,     0,     0,  1603,     0,     0,     0,     0,   740,     0,
     760,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1604,  1618,     0,     0,  2838,     0,  1368,     0,     0,  1606,
       0,     0,     0,     0,     0,  1607,     0,     0,   760,     0,
       0,     0,     0,     0,     0,  1749,     0,     0,   760,     0,
       0,     0,     0,     0,  1368,     0,     0,     0,     0,  1608,
     760,   759,     0,   760,     0,     0,  1368,     0,   693,  1764,
       0,     0,     0,   759,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1368,  1619,  1620,  1621,     0,  1622,  1623,  1624,  1625,  1626,
    1627,     0,     0,     0,     0,     0,     0,     0,     0,  1861,
    1749,     0,   759,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1358,     0,     0,     0,     0,     0,  1609,
       0,     0,     0,  1610,     0,     0,     0,     0,   740,     0,
       0,     0,     0,     0,   760,  1602,     0,     0,  1603,     0,
       0,     0,   760,   760,  1611,  1612,     0,     0,     0,     0,
       0,     0,  1750,  1358,  1358,  1604,  1358,     0,     0,  2883,
    1613,     0,     0,     0,  1606,     0,     0,     0,     0,     0,
    1607,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1368,     0,     0,     0,     0,  1614,     0,     0,  1615,     0,
       0,     0,     0,     0,  1608,     0,     0,     0,     0,   759,
       0,  1616,     0,     0,  1617,  1750,     0,     0,  1358,     0,
    1358,   740,     0,     0,     0,  1368,     0,     0,     0,     0,
     740,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   740,   740,     0,
       0,   740,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   740,     0,     0,     0,     0,   740,     0,     0,
     740,     0,     0,  1358,     0,   740,   740,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1618,     0,  2059,  1602,
       0,     0,  1603,     0,   759,     0,   759,  1358,     0,     0,
     740,  2081,     0,     0,  1609,     0,     0,     0,  1610,  1604,
       0,     0,     0,     0,     0,     0,     0,     0,  1606,     0,
       0,     0,  1358,     0,  1607,     0,     0,     0,     0,  1611,
    1612,  1368,     0,     0,     0,   740,     0,     0,     0,  2123,
    1358,     0,   760,     0,     0,  1613,     0,     0,  1608,     0,
       0,     0,     0,     0,  2138,     0,  2140,     0,  2141,     0,
       0,     0,     0,  2142,     0,     0,     0,     0,     0,     0,
    1614,     0,   740,  1615,     0,     0,  1619,  1620,  1621,     0,
    1622,  1623,  1624,  1625,  1626,  1627,  1616,     0,     0,  1617,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1358,     0,     0,  1764,     0,     0,     0,
    1764,     0,  1764,     0,   740,  1764,  1368,  1358,     0,     0,
       0,  1750,     0,     0,     0,     0,     0,     0,  1358,     0,
       0,     0,     0,     0,     0,     0,   740,  1368,   760,   740,
       0,   740,     0,     0,     0,     0,     0,     0,  1609,     0,
       0,     0,  1610,     0,   760,     0,     0,     0,   740,     0,
       0,  1618,   740,     0,     0,     0,     0,  1368,     0,     0,
       0,     0,     0,  1611,  1612,     0,     0,     0,     0,     0,
       0,     0,     0,   760,   760,     0,     0,     0,     0,  1613,
       0,     0,     0,     0,   760,  1358,     0,     0,     0,     0,
       0,  1749,     0,     0,  1368,     0,   760,   760,  1368,  1368,
       0,     0,     0,     0,  1614,  1358,     0,  1615,   760,     0,
       0,     0,   759,     0,     0,     0,     0,     0,     0,     0,
    1616,     0,     0,  1617,     0,     0,     0,     0,     0,     0,
    1358,     0,   740,     0,     0,     0,     0,  2853,     0,     0,
       0,  1619,  1620,  1621,     0,  1622,  1623,  1624,  1625,  1626,
    1627,     0,     0,     0,     0,     0,     0,     0,     0,  1368,
       0,     0,     0,     0,     0,     0,  1358,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   740,     0,     0,
       0,     0,     0,     0,     0,  1618,     0,     0,     0,     0,
       0,   761,     0,     0,   740,     0,   761,     0,     0,     0,
       0,     0,     0,     0,     0,   761,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   740,
       0,     0,     0,     0,     0,     0,  1750,     0,     0,   740,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   740,   740,     0,   759,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   740,
    1602,     0,     0,  1603,     0,  1619,  1620,  1621,     0,  1622,
    1623,  1624,  1625,  1626,  1627,     0,     0,     0,     0,     0,
    1604,     0,     0,     0,     0,     0,     0,  2426,  2427,  1606,
       0,     0,  2430,  2431,   740,  1607,  2434,     0,     0,     0,
       0,     0,     0,     0,   740,     0,  2444,     0,  1358,     0,
       0,     0,     0,  2453,     0,     0,     0,  2456,  2457,  1608,
    1749,  2460,  2461,  2462,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2476,     0,  2478,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2500,     0,     0,     0,     0,  2502,     0,     0,     0,
       0,     0,   740,     0,     0,     0,     0,  1749,     0,     0,
       0,   740,     0,     0,     0,  1749,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2520,  2521,  2524,
    2526,     0,     0,     0,  2533,  2536,     0,     0,     0,     0,
       0,     0,  2547,  2888,     0,  2551,     0,     0,     0,  2555,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1609,
       0,     0,     0,  1610,     0,  2578,     0,   760,     0,     0,
       0,  1750,   760,     0,     0,   760,  2585,     0,  2587,     0,
       0,     0,     0,  2590,  1611,  1612,     0,     0,  2594,  2595,
    2596,  2597,     0,  2599,     0,     0,     0,   760,     0,     0,
    1613,     0,  1358,     0,     0,     0,  2622,  2623,  2624,     0,
       0,     0,     0,     0,     0,     0,     0,  2632,  2633,     0,
    1602,     0,     0,  1603,     0,  1614,     0,     0,  1615,     0,
       0,   760,     0,     0,     0,  1358,     0,     0,     0,     0,
    1604,  1616,     0,     0,  1617,     0,     0,     0,     0,  1606,
       0,     0,     0,     0,     0,  1607,     0,     0,   760,   760,
       0,     0,     0,   761,     0,  1602,     0,   761,  1603,     0,
       0,     0,     0,     0,     0,     0,     0,  2695,   761,  1608,
       0,  1750,   760,     0,  1750,  1604,     0,     0,     0,  2894,
       0,     0,   761,     0,  1606,     0,     0,     0,     0,     0,
    1607,     0,   760,     0,     0,   760,   761,     0,     0,     0,
     761,     0,     0,     0,     0,     0,  1618,     0,     0,     0,
     761,     0,     0,   760,  1608,     0,     0,     0,   761,  1602,
       0,     0,  1603,   760,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1358,     0,     0,   760,     0,     0,  1604,
       0,     0,     0,  3376,  1358,   760,     0,     0,  1606,     0,
       0,     0,     0,     0,  1607,     0,     0,  1602,     0,     0,
    1603,     0,     0,     0,     0,     0,     0,     0,     0,  1609,
       0,     0,     0,  1610,     0,     0,     0,  1604,  1608,     0,
       0,     0,  1764,     0,     0,     0,  1606,     0,     0,     0,
       0,     0,  1607,   761,  1611,  1612,  1619,  1620,  1621,     0,
    1622,  1623,  1624,  1625,  1626,  1627,     0,     0,     0,     0,
    1613,  2817,     0,     0,  1609,     0,  1608,     0,  1610,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1614,     0,     0,  1615,  1611,
    1612,     0,     0,     0,     0,     0,     0,  1358,     0,     0,
       0,  1616,     0,     0,  1617,  1613,     0,     0,     0,     0,
       0,     0,     0,     0,   760,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1358,     0,     0,  1609,     0,
    1614,     0,  1610,  1615,     0,     0,     0,  1358,     0,     0,
       0,     0,     0,     0,     0,     0,  1616,     0,   760,  1617,
       0,     0,     0,  1611,  1612,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1609,     0,     0,  1613,
    1610,     0,     0,     0,     0,     0,  1618,     0,     0,     0,
       0,  1358,     0,   760,     0,     0,     0,     0,     0,     0,
       0,  1611,  1612,     0,  1614,     0,     0,  1615,     0,     0,
       0,     0,  3326,     0,     0,     0,   760,  1613,     0,     0,
    1616,     0,     0,  1617,     0,     0,     0,     0,     0,     0,
       0,  1618,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1614,     0,     0,  1615,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2967,     0,  1616,     0,
       0,  1617,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1619,  1620,  1621,     0,
    1622,  1623,  1624,  1625,  1626,  1627,     0,     0,     0,  1367,
       0,     0,   761,  2998,  2999,  1618,     0,     0,  1750,     0,
       0,     0,  1067,     0,  1750,     0,     0,   761,     0,     0,
    1764,     0,     0,     0,     0,     0,     0,     0,     0,   761,
       0,  1619,  1620,  1621,     0,  1622,  1623,  1624,  1625,  1626,
    1627,     0,  1124,  1618,     0,     0,  1358,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   761,     0,     0,
       0,     0,     0,  3032,  3034,     0,     0,   761,  3034,     0,
       0,     0,     0,  3045,  3046,  3047,     0,     0,     0,   761,
       0,     0,   761,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   760,  1619,  1620,  1621,     0,  1622,
    1623,  1624,  1625,  1626,  1627,     0,     0,     0,     0,  3068,
    3069,  3070,  3071,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1367,     0,     0,     0,     0,
       0,     0,     0,  1619,  1620,  1621,     0,  1622,  1623,  1624,
    1625,  1626,  1627,   760,     0,  3096,     0,     0,     0,     0,
       0,     0,  1358,     0,     0,     0,     0,     0,   760,   760,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   760,     0,     0,     0,     0,     0,
       0,     0,     0,   761,     0,     0,     0,     0,     0,     0,
       0,   761,   761,     0,     0,     0,     0,  3134,     0,     0,
       0,  1751,     0,     0,     0,  3138,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1358,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1358,  1750,
    1750,  1750,     0,     0,  1751,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3223,   760,     0,
       0,     0,     0,     0,     0,   760,     0,  3229,  1358,     0,
       0,     0,     0,     0,     0,   760,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3248,     0,  3250,     0,  1367,     0,
       0,     0,     0,     0,     0,  1358,     0,     0,     0,  1358,
    1358,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1540,     0,
       0,     0,  3289,     0,     0,   760,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3299,     0,     0,     0,
       0,  1896,     0,     0,     0,     0,  1764,  1564,     0,     0,
       0,     0,     0,  1750,     0,     0,     0,     0,     0,     0,
       0,   761,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1367,     0,  1750,     0,  1589,  1590,     0,  1592,     0,
       0,     0,     0,     0,     0,     0,     0,   760,     0,   760,
       0,     0,     0,     0,     0,  1632,     0,     0,     0,   760,
       0,   760,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1668,     0,     0,     0,     0,     0,
    1751,  1367,     0,     0,     0,     0,     0,     0,     0,     0,
     760,     0,     0,     0,     0,     0,     0,   761,     0,     0,
    1367,     0,     0,  1771,     0,     0,     0,  1781,  1784,     0,
       0,     0,     0,   761,     0,     0,     0,     0,   760,     0,
    1367,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   760,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   761,   761,     0,  1367,     0,     0,     0,   760,
       0,     0,   760,   761,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   761,   761,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   761,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1367,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3488,     0,  3489,
       0,     0,     0,  3491,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1750,     0,     0,  3500,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3508,     0,     0,     0,     0,
       0,     0,     0,     0,  3519,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3547,  3548,  3549,  3550,  3551,  3552,
    3553,     0,     0,     0,     0,  3560,  3561,     0,  3563,  3564,
    3565,  3566,  3567,  3568,  3569,  1751,     0,     0,     0,     0,
       0,     0,     0,  3576,     0,  3578,  3579,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1360,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   760,     0,
       0,     0,     0,  1367,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3627,  3629,  3631,     0,     0,  3634,
       0,     0,     0,     0,     0,     0,  2368,  1750,     0,     0,
       0,  1750,     0,  1750,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   760,     0,     0,   760,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1360,  3034,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   760,     0,
       0,     0,  1764,  1764,  1764,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2235,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   761,     0,     0,     0,
    1751,   761,     0,     0,   761,     0,     0,     0,     0,  2258,
       0,     0,  2260,     0,     0,  2271,     0,     0,     0,     0,
       0,     0,  2278,  2283,     0,     0,   761,     0,  2289,     0,
       0,  2294,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   760,   760,     0,     0,     0,     0,  2303,     0,
       0,     0,     0,  2310,     0,     0,     0,  2322,     0,     0,
     761,  2329,     0,  2331,  2332,  2333,  2334,  2335,  2336,  2337,
    2338,  2339,     0,  2340,     0,     0,     0,     0,  1067,     0,
    2365,     0,     0,     0,     0,     0,     0,   761,   761,  1361,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1751,   761,     0,  1751,     0,     0,     0,     0,     0,     0,
       0,   760,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   761,     0,     0,   761,     0,     0,  2504,     0,     0,
       0,     0,  1896,  2511,     0,     0,     0,  1360,     0,     0,
       0,     0,   761,     0,  1367,     0,     0,     0,     0,     0,
       0,     0,   761,     0,     0,     0,     0,     0,     0,     0,
       0,  3811,  3812,  3813,  3814,   761,     0,     0,     0,     0,
       0,     0,     0,     0,   761,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   512,     0,  3827,  3828,     0,     0,
    1360,     0,     0,     0,     0,  1124,     0,   513,  3837,  3838,
       0,     0,     0,     0,     0,  1361,     0,     0,     0,     0,
       0,     0,     0,     0,  1764,  1764,     0,  1764,   514,     0,
    1360,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   515,     0,     0,     0,     0,     0,     0,     0,     0,
     516,     0,     0,     0,  -692,     0,     0,     0,     0,     0,
       0,  1629,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   517,     0,     0,     0,     0,     0,   518,     0,     0,
       0,     0,     0,  2458,     0,     0,  1367,     0,     0,     0,
       0,     0,   519,     0,     0,     0,     0,     0,     0,     0,
    1360,     0,     0,   761,     0,     0,     0,     0,     0,     0,
     520,     0,     0,     0,     0,     0,     0,     0,  1629,  1360,
    1750,   521,  3883,     0,     0,     0,     0,     0,   522,     0,
       0,     0,   523,     0,     0,     0,   760,   761,     0,  1360,
       0,     0,     0,     0,     0,  3904,     0,  -881,   760,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1896,     0,     0,     0,  1360,  3921,     0,     0,     0,     0,
       0,     0,   761,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   524,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   761,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1750,     0,   760,  1361,     0,
       0,     0,     0,     0,     0,     0,  1360,     0,     0,     0,
       0,     0,   525,     0,  1764,   526,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1764,     0,     0,
       0,     0,     0,     0,     0,  1367,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1361,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   527,     0,  1751,  2668,     0,
       0,   528,     0,  1751,     0,     0,     0,  -369,     0,     0,
     529,  1361,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4005,
       0,     0,     0,     0,   760,     0,  -369,     0,   530,   531,
       0,   532,   533,     0,     0,     0,     0,     0,     0,     0,
     534,     0,     0,     0,     0,   535,     0,     0,     0,     0,
       0,   536,     0,     0,   537,     0,     0,   538,     0,  4029,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    -369,  1361,     0,   761,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1361,     0,     0,     0,     0,     0,  3034,     0,     0,     0,
       0,     0,  1360,     0,     0,     0,  2790,     0,     0,   760,
    1361,   760,     0,     0,     0,     0,     0,     0,     0,  2368,
    2368,  2368,   761,     0,     0,     0,     0,     0,     0,  1764,
       0,     0,     0,     0,     0,  1361,     0,   761,   761,  1764,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   761,     0,     0,     0,  1629,     0,     0,
       0,     0,     0,  4106,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2834,  1361,     0,     0,
    1764,  2840,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1367,     0,     0,     0,
       0,     0,     0,  2283,     0,  2283,  2283,     0,  1751,  1751,
    1751,     0,     0,     0,  1629,     0,  2897,  3034,     0,  2900,
       0,  2902,     0,     0,     0,     0,     0,   761,     0,     0,
       0,     0,  1764,     0,   761,     0,  1896,  2511,  1629,  2511,
       0,     0,     0,  2267,   761,     0,     0,     0,  2923,     0,
    2925,     0,     0,     0,  2928,     0,     0,     0,     0,     0,
       0,     0,     0,  1629,  1629,     0,  1629,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2365,  2365,  2365,  1750,  4200,     0,     0,
       0,  1367,     0,  1367,     0,     0,     0,     0,     0,     0,
    2965,     0,     0,     0,   761,     0,  1629,   760,     0,     0,
       0,     0,  1771,     0,     0,     0,     0,  2976,     0,     0,
       0,     0,     0,     0,  1784,     0,     0,     0,     0,     0,
       0,     0,  1751,  1361,     0,     0,     0,     0,     0,     0,
       0,     0,  1629,     0,     0,     0,  1367,     0,     0,     0,
       0,     0,  1751,     0,     0,     0,  1360,     0,     0,     0,
       0,  1360,  1360,     0,     0,     0,   761,  3007,   761,     0,
    1367,     0,     0,  1360,     0,     0,     0,     0,   761,     0,
     761,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2511,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2511,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   761,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1629,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1629,     0,   761,  1629,     0,
       0,     0,     0,     0,   760,     0,     0,     0,     0,     0,
       0,   761,     0,     0,     0,     0,  1367,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   761,     0,
    2511,   761,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1367,     0,     0,     0,  1360,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1750,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1363,     0,     0,
       0,     0,     0,     0,  1751,     0,     0,     0,  1367,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1360,
       0,     0,  1750,     0,     0,     0,     0,     0,  1367,     0,
    1750,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1367,     0,     0,     0,  1361,     0,     0,
       0,     0,  1361,  1361,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1361,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1367,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1360,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1363,     0,     0,     0,     0,     0,  2368,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   761,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1751,     0,     0,     0,
    1751,     0,  1751,     0,     0,     0,     0,     0,     0,  3327,
       0,     0,     0,     0,     0,     0,  1361,     0,     0,  3331,
       0,     0,     0,     0,     0,  3332,     0,  3333,     0,     0,
       0,     0,     0,     0,   761,     0,     0,   761,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3351,
    3352,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2511,     0,     0,     0,     0,     0,     0,     0,     0,
    2289,     0,     0,     0,     0,     0,     0,   761,     0,     0,
    3380,     0,     0,  3383,     0,  3385,     0,     0,     0,     0,
    1361,     0,     0,     0,  3389,     0,     0,     0,     0,     0,
    3394,     0,     0,  3397,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3426,     0,     0,  1363,     0,     0,     0,
       0,  3438,     0,  2365,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   761,   761,     0,     0,     0,     0,  3452,     0,  1629,
       0,     0,     0,  1067,     0,     0,     0,     0,     0,  1124,
       0,     0,     0,     0,     0,  1361,     0,     0,     0,  1363,
       0,     0,  1629,     0,  1629,  1360,  2267,  2267,  2871,     0,
       0,  2267,     0,     0,     0,  1629,     0,     0,     0,     0,
       0,     0,  1629,     0,     0,     0,     0,  1629,     0,  1363,
       0,     0,     0,  1629,     0,  1367,     0,     0,  1629,     0,
       0,     0,     0,     0,     0,  1360,  1360,  1629,  1360,     0,
     761,  2267,  2267,     0,  1629,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1629,     0,  1896,     0,
       0,     0,     0,  1629,     0,  1629,  1629,  1629,  1629,  1629,
    1629,  1629,  1629,  1629,  1629,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1363,
    1360,     0,  1360,     0,     0,     0,     0,     0,     0,  1629,
       0,     0,     0,  1364,     0,     0,     0,     0,  1363,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1363,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1360,     0,     0,     0,     0,
       0,     0,     0,  1363,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1367,     0,     0,  1360,
       0,     0,     0,     0,     0,     0,     0,  1367,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1629,     0,  1360,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1363,     0,     0,     0,     0,
       0,     0,  1360,     0,  2368,     0,     0,     0,     0,  2368,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1364,
       0,  2368,     0,     0,     0,     0,     0,     0,     0,  1751,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3681,  3682,   761,  1361,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   761,     0,     0,
       0,     0,     0,     0,     0,  1360,     0,     0,     0,     0,
    1367,     0,     0,     0,     0,     0,     0,     0,     0,  1360,
       0,     0,     0,     0,     0,     0,  1361,  1361,     0,  1361,
    1360,     0,     0,     0,     0,     0,     0,     0,  1367,     0,
    3711,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1367,     0,     0,     0,  1751,     0,   761,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1361,     0,  1361,     0,     0,     0,  3729,  3731,     0,
       0,     0,     0,     0,  1367,     0,  1365,  1360,     0,     0,
    3738,     0,     0,     0,     0,     0,  3743,  3744,     0,     0,
    3746,  1363,     0,     0,     0,     0,     0,  1360,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1629,     0,     0,     0,  1361,     0,  2365,     0,
       0,     0,  1360,  2365,     0,     0,     0,     0,     0,     0,
       0,     0,  1364,     0,     0,  2365,     0,     0,     0,     0,
    1361,     0,     0,   761,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1360,     0,
       0,     0,     0,     0,     0,  1361,  3792,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1361,  3913,  1364,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1365,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1364,     0,     0,     0,  1367,
       0,     0,     0,     0,     0,     0,     0,     0,   761,     0,
     761,     0,     0,     0,  1629,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1361,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1361,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1361,     0,     0,     0,     0,     0,     0,  1629,     0,
       0,     0,     0,     0,  1629,  1364,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2871,  2871,     0,  2267,  1364,     0,  2267,  2267,  2267,  2267,
    2267,  2267,  2267,  2267,  2267,  2267,  2871,     0,     0,     0,
    1360,     0,     0,     0,  1364,  2511,  3872,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1361,     0,
       0,  1629,     0,     0,  1629,     0,  1629,     0,     0,  1364,
       0,  2871,  2871,     0,     0,     0,     0,     0,  1361,     0,
       0,     0,     0,     0,     0,  2267,  2267,  1629,     0,  1629,
       0,     0,  1629,     0,     0,  1363,     0,     0,     0,     0,
    1363,  1363,     0,  1361,     0,     0,     0,     0,     0,     0,
       0,     0,  1363,     0,     0,  1365,     0,     0,     0,     0,
       0,  1364,     0,     0,     0,     0,     0,     0,     0,  1629,
    2511,     0,     0,     0,     0,     0,     0,     0,     0,  1361,
    1629,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1367,     0,     0,     0,  1751,     0,     0,     0,  3947,
       0,     0,     0,     0,     0,     0,     0,     0,  1365,     0,
       0,  1629,     0,     0,     0,     0,   761,     0,     0,     0,
       0,  1367,     0,     0,  3964,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1360,     0,     0,     0,  1365,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1367,     0,
       0,     0,  1367,  1367,     0,     0,     0,  1360,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1363,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1365,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3913,     0,     0,     0,  1365,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1364,     0,     0,
       0,  1361,     0,     0,     0,     0,     0,  1365,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1363,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1365,   761,     0,  1360,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1360,  2289,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4081,     0,     0,     0,
       0,     0,     0,     0,  2267,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1365,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1363,  1751,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1360,
    4142,  1751,     0,     0,     0,  1361,     0,     0,     0,  1751,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1360,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1361,  1360,
       0,  1629,     0,     0,     0,  1629,  1629,  1629,     0,     0,
    2871,     0,     0,     0,     0,  2871,  2871,  2871,  2871,  2871,
    2871,  2871,  2871,  2871,  2871,  1629,  1629,     0,     0,     0,
       0,     0,  4182,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1360,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1629,  2267,  2267,  1629,     0,  1629,
       0,     0,     0,  1629,  2871,  2871,     0,     0,  1629,     0,
    1365,  1629,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1364,     0,     0,  4221,  4221,  1364,  1364,     0,     0,
    1629,     0,     0,     0,     0,     0,  1361,     0,  1364,     0,
       0,     0,  1629,     0,     0,     0,     0,  1361,     0,     0,
       0,     0,     0,     0,     0,     0,  1629,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4221,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4265,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1363,     0,     0,     0,  1360,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4221,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1361,     0,     0,     0,  1363,  1363,     0,  1363,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1364,     0,     0,     0,     0,     0,     0,     0,  1361,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1361,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1363,
       0,  1363,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1360,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1361,     0,     0,     0,     0,  2871,
       0,     0,     0,     0,  1364,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1363,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1365,  1629,  1629,     0,  1363,  1365,
    1365,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1365,     0,     0,     0,     0,     0,     0,     0,  1360,
       0,     0,     0,  1363,     0,  1629,     0,     0,     0,  2267,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1364,
    1360,  1363,     0,  1629,     0,  1629,     0,     0,     0,     0,
    2871,  2871,  1629,     0,     0,  2267,  2267,  1629,  1629,     0,
    1629,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1360,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1361,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1363,     0,  1629,  1360,     0,     0,
       0,  1360,  1360,     0,     0,     0,     0,     0,  1363,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1363,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1365,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1629,     0,     0,     0,
       0,     0,     0,     0,     0,  1361,  1363,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1363,  1365,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1363,     0,  2871,  2267,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2871,
    2871,  1629,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1363,  1629,     0,
    1361,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1361,  1365,     0,     0,     0,     0,     0,     0,     0,
    1364,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1361,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1364,  1364,     0,  1364,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1361,     0,
       0,     0,  1361,  1361,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2871,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1629,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1364,     0,  1364,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1363,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1629,     0,     0,     0,
    1364,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1364,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1629,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1364,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1364,     0,     0,
       0,     0,     0,     0,     0,  1629,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1365,     0,     0,     0,     0,     0,  1629,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1364,     0,     0,  1363,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1364,     0,     0,     0,     0,     0,
       0,     0,     0,  1365,  1365,  1364,  1365,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1363,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1365,     0,
    1365,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1364,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1364,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1365,     0,     0,     0,  1364,     0,     0,
       0,     0,     0,     0,  1363,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1363,     0,  1365,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1364,     0,     0,     0,     0,     0,     0,
       0,     0,  1365,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1365,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1363,     0,
       0,     0,     0,  1365,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1365,     0,     0,
       0,     0,     0,     0,     0,     0,  1363,     0,  1365,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1363,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1364,     0,     0,     0,     0,
       0,     0,  1363,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1365,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1365,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1365,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1365,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1363,     0,  1364,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1364,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1363,     0,     0,     0,     0,  1365,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1364,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1364,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1363,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1363,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1363,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1364,     0,     0,     0,     0,     0,
       0,     0,  1365,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1363,     0,     0,     0,
    1363,  1363,  1364,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1364,  1365,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1364,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1365,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1365,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1364,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1365,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1365,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1365,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1364,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1365,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1364,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1364,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1364,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1365,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1364,     0,     0,     0,  1364,  1364,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1365,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1365,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1365,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1365,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     713,   985,   551,   986,   987,   988,   598,   989,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,  2359,
     209,   210,   211,     0,     0,  1365,     0,   212,   990,  1365,
    1365,   213,   214,     0,   215,   216,   714,   217,   218,   219,
     220,   991,   715,   992,   993,     0,   224,   225,   226,   227,
     228,   994,   995,   229,   230,   996,   997,   233,     0,   234,
     235,   236,   237,   998,     0,   999,     0,   239,   240,   241,
     242,   717,   243,   244,     0,   245,   246,   247,   248,   249,
     250,     0,   718,   251,   252,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,   253,   254,   255,   256,   257,   258,  1007,  1008,
     261,     0,   262,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,  2360,     0,   271,   272,  1009,   274,   275,
       0,   276,   277,   278,     0,   279,   280,     0,   281,   282,
     283,   284,  1010,   286,   287,   288,  1011,  1012,   290,     0,
     291,  1013,   293,     0,   294,     0,   295,   720,     0,   721,
     296,   297,   298,     0,   299,  1014,     0,   301,     0,   302,
     303,   304,   305,   306,   722,   307,   308,   309,     0,   310,
     311,   312,   313,   314,   315,     0,   316,   723,   317,   318,
     319,   320,   321,  1015,  1016,     0,  1017,     0,   325,   724,
     725,   326,   726,   327,   328,   329,   330,   331,   332,   333,
       0,   334,  1018,   727,   336,   728,     0,   337,   338,   339,
    1019,  1020,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,  1021,   729,  1022,   354,   355,   356,
    1023,   357,   358,   730,   359,  1024,  1025,   361,  1026,   363,
     364,   365,     0,   366,     0,     0,  1027,   368,   369,     0,
       0,   370,   731,   732,   733,  1028,   372,   373,   374,   375,
     376,   377,   378,     0,   379,  1029,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,  1030,
     394,   395,   396,   397,     0,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   734,   410,
     411,  1031,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,  1032,   426,   427,   428,
     429,   735,   430,  1033,   432,     0,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,  1034,     0,   444,   445,
       0,   446,   447,   448,   449,   450,   451,     0,  1035,  1036,
       0,     0,   454,  1037,   456,  1038,  1039,   458,   459,   460,
     461,   462,   463,   464,     0,  1040,   465,   466,   467,   468,
     469,  1041,     0,   470,   471,   472,   473,   474,   475,  1042,
    2361,   477,   736,   478,   479,   480,     0,     0,   481,     0,
       0,   482,   483,   484,   485,   486,   487,  1043,  1044,  1045,
    1046,  1047,  1048,  1049,  1050,   496,   497,   498,     0,     0,
       0,     0,     0,     0,     0,  1051,  1052,  2362,     0,     0,
       0,     0,     0,     0,  1054,  2363,   713,   985,   551,   986,
     987,   988,   598,   989,     0,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,   212,   990,     0,     0,   213,   214,     0,
     215,   216,   714,   217,   218,   219,   220,   991,   715,   992,
     993,     0,   224,   225,   226,   227,   228,   994,   995,   229,
     230,   996,   997,   233,     0,   234,   235,   236,   237,   998,
       0,   999,     0,   239,   240,   241,   242,   717,   243,   244,
       0,   245,   246,   247,   248,   249,   250,     0,   718,   251,
     252,  1000,  1001,  1002,  1003,  1004,  1005,  1006,   253,   254,
     255,   256,   257,   258,  1007,  1008,   261,     0,   262,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
       0,   271,   272,  1009,   274,   275,     0,   276,   277,   278,
       0,   279,   280,     0,   281,   282,   283,   284,  1010,   286,
     287,   288,  1011,  1012,   290,     0,   291,  1013,   293,     0,
     294,     0,   295,   720,     0,   721,   296,   297,   298,     0,
     299,  1014,     0,   301,     0,   302,   303,   304,   305,   306,
     722,   307,   308,   309,     0,   310,   311,   312,   313,   314,
     315,     0,   316,   723,   317,   318,   319,   320,   321,  1015,
    1016,     0,  1017,     0,   325,   724,   725,   326,   726,   327,
     328,   329,   330,   331,   332,   333,     0,   334,  1018,   727,
     336,   728,     0,   337,   338,   339,  1019,  1020,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
    1021,   729,  1022,   354,   355,   356,  1023,   357,   358,   730,
     359,  1024,  1025,   361,  1026,   363,   364,   365,     0,   366,
       0,     0,  1027,   368,   369,     0,     0,   370,   731,   732,
     733,  1028,   372,   373,   374,   375,   376,   377,   378,     0,
     379,  1029,   381,   382,   383,   384,   385,     0,   386,   387,
     388,   389,   390,   391,   392,  1030,   394,   395,   396,   397,
       0,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   734,   410,   411,  1031,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,  1032,   426,   427,   428,   429,   735,   430,  1033,
     432,     0,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,  1034,     0,   444,   445,     0,   446,   447,   448,
     449,   450,   451,     0,  1035,  1036,     0,     0,   454,  1037,
     456,  1038,  1039,   458,   459,   460,   461,   462,   463,   464,
       0,  1040,   465,   466,   467,   468,   469,  1041,     0,   470,
     471,   472,   473,   474,   475,  1042,     0,   477,   736,   478,
     479,   480,     0,     0,   481,     0,     0,   482,   483,   484,
     485,   486,   487,  1043,  1044,  1045,  1046,  1047,  1048,  1049,
    1050,   496,   497,   498,     0,     0,     0,     0,     0,     0,
       0,  1051,  1052,   199,     0,     0,     0,     0,     0,     0,
    1054,  2269,     0,     0,   200,   201,   202,   203,   204,   205,
     206,   207,     0,   209,   210,   211,     0,     0,     0,     0,
     212,     0,  3408,     0,   213,   214,     0,   215,   216,     0,
     217,   218,   219,   220,   221,     0,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
     233,     0,   234,   235,   236,   237,   238,     0,     0,     0,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0, -1407,   251,   252,     0,     0,
       0,     0,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,     0,   295,
       0,     0, -1407,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,     0,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
   -1407,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,     0,     0,   326, -1407,   327,   328,   329,   330,
     331,   332,   333,     0,   334,   335, -1407,   336,     0,     0,
     337,   338,   339,     0,     0,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352, -1407,   353,
     354,   355,   356,     0,   357,   358,     0,   359,     0,   360,
     361,   362,   363,   364,   365,     0,   366,     0,     0,   367,
     368,   369,     0,     0,   370,     0,     0,     0,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409, -1407,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,     0,
     426,   427,   428,   429,     0,   430,   431,   432,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   444,   445,     0,   446,   447,   448,   449,   450,   451,
       0,   452,   453,     0,     0,   454,   455,   456,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,     0,   465,
     466,   467,   468,   469,     0,     0,   470,   471,   472,   473,
     474,   475,   476,     0,   477,     0,   478,   479,   480,     0,
       0,   481,     0,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,     0,     0,     0,     0,     0,     0,     0,  1334,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1131,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,   212,     0,     0,     0,   213,
     214,     0,   215,   216,   714,   217,   218,   219,     0,  1335,
     715,  1336,  1337,     0,   224,   225,   226,   227,   228,     0,
       0,   229,   230,  1338,  1339,   233,     0,   234,   235,   236,
     237,     0,     0,   716,     0,   239,   240,   241,   242,   717,
     243,   244,     0,   245,   246,   247,   248,   249,   250,     0,
     718,   251,   252,     0,     0,     0,   719,     0,     0,     0,
     253,   254,   255,   256,   257,   258,  1340,  1341,   261,     0,
     262,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,     0,   271,   272,  1009,   274,   275,     0,   276,
     277,   278,     0,   279,   280,     0,   281,   282,   283,   284,
       0,   286,   287,   288,     0,     0,   290,     0,   291,  1342,
     293,     0,   294,     0,   295,   720,     0,   721,   296,   297,
     298,     0,   299,     0,     0,   301,     0,   302,   303,   304,
     305,   306,   722,   307,   308,   309,  1884,   310,   311,   312,
     313,   314,   315,     0,   316,   723,  1885,   318,   319,   320,
     321,  1343,  1344,     0,  1345,     0,   325,   724,   725,   326,
     726,   327,   328,   329,   330,   331,   332,   333,     0,   334,
       0,   727,   336,   728,     0,   337,   338,   339,     0,     0,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,  1346,   729,  1347,   354,   355,     0,     0,   357,
     358,   730,   359,     0,     0,   361,  1348,   363,   364,   365,
       0,   366,     0,     0,   367,   368,   369,     0,     0,  1886,
     731,   732,   733,     0,   372,   373,   374,   375,   376,   377,
     378,     0,   379,     0,   381,     0,   383,   384,   385,     0,
     386,   387,   388,   389,   390,   391,   392,  1349,   394,   395,
     396,   397,     0,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   734,   410,   411,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,     0,   426,  1887,   428,   429,   735,
     430,  1351,   432,     0,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,     0,     0,   444,   445,     0,   446,
     447,   448,   449,   450,   451,     0,  1352,  1353,     0,     0,
     454,     0,   456,     0,     0,   458,   459,   460,   461,   462,
     463,   464,     0,     0,   465,   466,   467,   468,   469,     0,
       0,   470,   471,   472,   473,   474,     0,  1354,  1888,   477,
     736,   478,   479,   480,     0,     0,   481,     0,     0,   482,
     483,   484,   485,   486,     0,   199,     0,     0,     0,     0,
       0,     0,     0,   496,   497,   498,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,   212,  1889,     0,     0,   213,   214,     0,   215,
     216,     0,   217,   218,   219,   220,   221,     0,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,     0,
       0,     0,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,     0,   251,   252,
       0,     0,     0,     0,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,     0,     0,     0,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,     0,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,     0,     0,   326,     0,   327,   328,
     329,   330,   331,   332,   333,     0,   334,   335,     0,   336,
       0,     0,   337,   338,   339,     0,     0,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
       0,   353,   354,   355,   356,     0,   357,   358,     0,   359,
       0,   360,   361,   362,   363,   364,   365,     0,   366,     0,
       0,   367,   368,   369,     0,     0,   370,     0,     0,     0,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,     0,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,     0,   426,   427,   428,   429,     0,   430,   431,   432,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   449,
     450,   451,     0,   452,   453,     0,     0,   454,   455,   456,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
       0,   465,   466,   467,   468,   469,     0,     0,   470,   471,
     472,   473,   474,   475,   476,     0,   477,     0,   478,   479,
     480,     0,     0,   481,     0,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,     0,     0,     0,     0,     0,     0,     0,
    1334,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2703,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,   212,     0,     0,
       0,   213,   214,     0,   215,   216,   714,   217,   218,   219,
       0,  1335,   715,  1336,  1337,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,  1338,  1339,   233,     0,   234,
     235,   236,   237,     0,     0,   716,     0,   239,   240,   241,
     242,   717,   243,   244,     0,   245,   246,   247,   248,   249,
     250,     0,   718,   251,   252,     0,     0,     0,   719,     0,
       0,     0,   253,   254,   255,   256,   257,   258,  1340,  1341,
     261,     0,   262,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,     0,   271,   272,  1009,   274,   275,
       0,   276,   277,   278,     0,   279,   280,     0,   281,   282,
     283,   284,     0,   286,   287,   288,     0,     0,   290,     0,
     291,  1342,   293,     0,   294,     0,   295,   720,     0,   721,
     296,   297,   298,     0,   299,     0,     0,   301,     0,   302,
     303,   304,   305,   306,   722,   307,   308,   309,  1884,   310,
     311,   312,   313,   314,   315,     0,   316,   723,  1885,   318,
     319,   320,   321,  1343,  1344,     0,  1345,     0,   325,   724,
     725,   326,   726,   327,   328,   329,   330,   331,   332,   333,
       0,   334,     0,   727,   336,   728,     0,   337,   338,   339,
       0,     0,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,  1346,   729,  1347,   354,   355,     0,
       0,   357,   358,   730,   359,     0,     0,   361,  1348,   363,
     364,   365,     0,   366,     0,     0,   367,   368,   369,     0,
       0,  1886,   731,   732,   733,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,     0,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,  1349,
     394,   395,   396,   397,     0,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   734,   410,
     411,     0,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,     0,   426,  1887,   428,
     429,   735,   430,  1351,   432,     0,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,     0,     0,   444,   445,
       0,   446,   447,   448,   449,   450,   451,     0,  1352,  1353,
       0,     0,   454,     0,   456,     0,     0,   458,   459,   460,
     461,   462,   463,   464,     0,     0,   465,   466,   467,   468,
     469,     0,     0,   470,   471,   472,   473,   474,     0,  1354,
    1888,   477,   736,   478,   479,   480,     0,     0,   481,     0,
       0,   482,   483,   484,   485,   486,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   496,   497,   498,     0,     0,
       0,     0,     0,     0,     0,   713,   985,   551,   986,   987,
     988,   598,   989,     0,     0,  2754,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,   212,   990,     0,     0,   213,   214,     0,   215,
     216,   714,   217,   218,   219,   220,   991,   715,   992,   993,
    2279,   224,   225,   226,   227,   228,   994,   995,   229,   230,
     996,   997,   233,     0,   234,   235,   236,   237,   998,     0,
     999,     0,   239,   240,   241,   242,   717,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,   718,   251,   252,
    1000,  1001,  1002,  1003,  1004,  1005,  1006,   253,   254,   255,
     256,   257,   258,  1007,  1008,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,  1009,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,  1010,   286,   287,
     288,  1011,  1012,   290,     0,   291,  1013,   293,     0,   294,
       0,   295,   720,  2280,   721,   296,   297,   298,     0,   299,
    1014,     0,   301,     0,   302,   303,   304,   305,   306,   722,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,   723,   317,   318,   319,   320,   321,  1015,  1016,
       0,  1017,     0,   325,   724,   725,   326,   726,   327,   328,
     329,   330,   331,   332,   333,  2281,   334,  1018,   727,   336,
     728,     0,   337,   338,   339,  1019,  1020,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,  1021,
     729,  1022,   354,   355,   356,  1023,   357,   358,   730,   359,
    1024,  1025,   361,  1026,   363,   364,   365,     0,   366,     0,
       0,  1027,   368,   369,     0,     0,   370,   731,   732,   733,
    1028,   372,   373,   374,   375,   376,   377,   378,     0,   379,
    1029,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,  1030,   394,   395,   396,   397,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   734,   410,   411,  1031,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,  1032,   426,   427,   428,   429,   735,   430,  1033,   432,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,  1034,     0,   444,   445,     0,   446,   447,   448,   449,
     450,   451,     0,  1035,  1036,     0,  2282,   454,  1037,   456,
    1038,  1039,   458,   459,   460,   461,   462,   463,   464,     0,
    1040,   465,   466,   467,   468,   469,  1041,     0,   470,   471,
     472,   473,   474,   475,  1042,     0,   477,   736,   478,   479,
     480,     0,     0,   481,     0,     0,   482,   483,   484,   485,
     486,   487,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,
     496,   497,   498,     0,     0,     0,     0,     0,     0,     0,
    1051,  1052,     0,     0,     0,     0,     0,     0,     0,  1054,
     713,   985,   551,   986,   987,   988,   598,   989,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,   212,   990,     0,
       0,   213,   214,     0,   215,   216,   714,   217,   218,   219,
     220,   991,   715,   992,   993,     0,   224,   225,   226,   227,
     228,   994,   995,   229,   230,   996,   997,   233,     0,   234,
     235,   236,   237,   998,     0,   999,     0,   239,   240,   241,
     242,   717,   243,   244,     0,   245,   246,   247,   248,   249,
     250,     0,   718,   251,   252,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,   253,   254,   255,   256,   257,   258,  1007,  1008,
     261,     0,   262,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,     0,   271,   272,  1009,   274,   275,
       0,   276,   277,   278,     0,   279,   280,     0,   281,   282,
     283,   284,  1010,   286,   287,   288,  1011,  1012,   290,     0,
     291,  1013,   293,     0,   294,     0,   295,   720,     0,   721,
     296,   297,   298,     0,   299,  1014,     0,   301,     0,   302,
     303,   304,   305,   306,   722,   307,   308,   309,     0,   310,
     311,   312,   313,   314,   315,     0,   316,   723,   317,   318,
     319,   320,   321,  1015,  1016,     0,  1017,     0,   325,   724,
     725,   326,   726,   327,   328,   329,   330,   331,   332,   333,
       0,   334,  1018,   727,   336,   728,     0,   337,   338,   339,
    1019,  1020,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,  1021,   729,  1022,   354,   355,   356,
    1023,   357,   358,   730,   359,  1024,  1025,   361,  1026,   363,
     364,   365,     0,   366,     0,     0,  1027,   368,   369,     0,
       0,   370,   731,   732,   733,  1028,   372,   373,   374,   375,
     376,   377,   378,     0,   379,  1029,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,  1030,
     394,   395,   396,   397,     0,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   734,   410,
     411,  1031,   413,   414,   415,   416,   417,   418,   419,   420,
      37,   421,   422,   423,   424,   425,  1032,   426,   427,   428,
     429,   735,   430,  1033,   432,     0,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,  1034,     0,   444,   445,
      41,   446,   447,   448,   449,   450,   451,     0,  1035,  1036,
       0,     0,   454,  1037,   456,  1038,  1039,   458,   459,   460,
     461,   462,   463,   464,     0,  1040,   465,   466,   467,   468,
     469,  1041,     0,   470,   471,   472,   473,   474,   925,  1042,
       0,   477,   736,   478,   479,   480,     0,     0,   481,     0,
      46,   482,   483,   484,   485,   486,   487,  1043,  1044,  1045,
    1046,  1047,  1048,  1049,  1050,   496,   497,   498,     0,     0,
       0,     0,     0,     0,     0,  1051,  1052,     0,     0,     0,
       0,     0,     0,     0,  1054,   713,   985,   551,   986,   987,
     988,   598,   989,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,   212,   990,     0,     0,   213,   214,     0,   215,
     216,   714,   217,   218,   219,   220,   991,   715,   992,   993,
       0,   224,   225,   226,   227,   228,   994,   995,   229,   230,
     996,   997,   233,     0,   234,   235,   236,   237,   998,     0,
     999,     0,   239,   240,   241,   242,   717,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,   718,   251,   252,
    1000,  1001,  1002,  1003,  1004,  1005,  1006,   253,   254,   255,
     256,   257,   258,  1007,  1008,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,  1009,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,  1010,   286,   287,
     288,  1011,  1012,   290,     0,   291,  1013,   293,     0,   294,
       0,   295,   720,     0,   721,   296,   297,   298,     0,   299,
    1014,     0,   301,     0,   302,   303,   304,   305,   306,   722,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,   723,   317,   318,   319,   320,   321,  1015,  1016,
       0,  1017,     0,   325,   724,   725,   326,   726,   327,   328,
     329,   330,   331,   332,   333,     0,   334,  1018,   727,   336,
     728,     0,   337,   338,   339,  1019,  1020,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,  1021,
     729,  1022,   354,   355,   356,  1023,   357,   358,   730,   359,
    1024,  1025,   361,  1026,   363,   364,   365,     0,   366,     0,
       0,  1027,   368,   369,     0,     0,   370,   731,   732,   733,
    1028,   372,   373,   374,   375,   376,   377,   378,     0,   379,
    1029,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,  1030,   394,   395,   396,   397,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   734,   410,   411,  1031,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,  1032,   426,   427,   428,   429,   735,   430,  1033,   432,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,  1034,     0,   444,   445,     0,   446,   447,   448,   449,
     450,   451,     0,  1035,  1036,     0,     0,   454,  1037,   456,
    1038,  1039,   458,   459,   460,   461,   462,   463,   464,     0,
    1040,   465,   466,   467,   468,   469,  1041,     0,   470,   471,
     472,   473,   474,   475,  1042,     0,   477,   736,   478,   479,
     480,     0,     0,   481,     0,     0,   482,   483,   484,   485,
     486,   487,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,
     496,   497,   498,     0,     0,     0,     0,     0,     0,     0,
    1051,  1052,     0,     0,     0,     0,     0,  1535,  2227,  1054,
     713,   985,   551,   986,   987,   988,   598,   989,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,   212,   990,     0,
       0,   213,   214,     0,   215,   216,   714,   217,   218,   219,
     220,   991,   715,   992,   993,     0,   224,   225,   226,   227,
     228,   994,   995,   229,   230,   996,   997,   233,     0,   234,
     235,   236,   237,   998,     0,   999,     0,   239,   240,   241,
     242,   717,   243,   244,     0,   245,   246,   247,   248,   249,
     250,     0,   718,   251,   252,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,   253,   254,   255,   256,   257,   258,  1007,  1008,
     261,     0,   262,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,     0,   271,   272,  1009,   274,   275,
       0,   276,   277,   278,     0,   279,   280,     0,   281,   282,
     283,   284,  1010,   286,   287,   288,  1011,  1012,   290,     0,
     291,  1013,   293,     0,   294,     0,   295,   720,     0,   721,
     296,   297,   298,     0,   299,  1014,     0,   301,     0,   302,
     303,   304,   305,   306,   722,   307,   308,   309,     0,   310,
     311,   312,   313,   314,   315,     0,   316,   723,   317,   318,
     319,   320,   321,  1015,  1016,     0,  1017,     0,   325,   724,
     725,   326,   726,   327,   328,   329,   330,   331,   332,   333,
       0,   334,  1018,   727,   336,   728,     0,   337,   338,   339,
    1019,  1020,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,  1021,   729,  1022,   354,   355,   356,
    1023,   357,   358,   730,   359,  1024,  1025,   361,  1026,   363,
     364,   365,     0,   366,     0,     0,  1027,   368,   369,     0,
       0,   370,   731,   732,   733,  1028,   372,   373,   374,   375,
     376,   377,   378,     0,   379,  1029,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,  1030,
     394,   395,   396,   397,     0,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   734,   410,
     411,  1031,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,  1032,   426,   427,   428,
     429,   735,   430,  1033,   432,     0,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,  1034,     0,   444,   445,
       0,   446,   447,   448,   449,   450,   451,     0,  1035,  1036,
       0,     0,   454,  1037,   456,  1038,  1039,   458,   459,   460,
     461,   462,   463,   464,     0,  1040,   465,   466,   467,   468,
     469,  1041,     0,   470,   471,   472,   473,   474,   475,  1042,
       0,   477,   736,   478,   479,   480,     0,     0,   481,     0,
       0,   482,   483,   484,   485,   486,   487,  1043,  1044,  1045,
    1046,  1047,  1048,  1049,  1050,   496,   497,   498,     0,     0,
       0,     0,     0,     0,     0,  1051,  1052,  1053,     0,     0,
       0,     0,     0,     0,  1054,   713,   985,   551,   986,   987,
     988,   598,   989,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,   212,   990,     0,     0,   213,   214,     0,   215,
     216,   714,   217,   218,   219,   220,   991,   715,   992,   993,
       0,   224,   225,   226,   227,   228,   994,   995,   229,   230,
     996,   997,   233,     0,   234,   235,   236,   237,   998,     0,
     999,     0,   239,   240,   241,   242,   717,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,   718,   251,   252,
    1000,  1001,  1002,  1003,  1004,  1005,  1006,   253,   254,   255,
     256,   257,   258,  1007,  1008,   261,  1123,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,  1009,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,  1010,   286,   287,
     288,  1011,  1012,   290,     0,   291,  1013,   293,     0,   294,
       0,   295,   720,     0,   721,   296,   297,   298,     0,   299,
    1014,     0,   301,     0,   302,   303,   304,   305,   306,   722,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,   723,   317,   318,   319,   320,   321,  1015,  1016,
       0,  1017,     0,   325,   724,   725,   326,   726,   327,   328,
     329,   330,   331,   332,   333,     0,   334,  1018,   727,   336,
     728,     0,   337,   338,   339,  1019,  1020,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,  1021,
     729,  1022,   354,   355,   356,  1023,   357,   358,   730,   359,
    1024,  1025,   361,  1026,   363,   364,   365,     0,   366,     0,
       0,  1027,   368,   369,     0,     0,   370,   731,   732,   733,
    1028,   372,   373,   374,   375,   376,   377,   378,     0,   379,
    1029,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,  1030,   394,   395,   396,   397,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   734,   410,   411,  1031,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,  1032,   426,   427,   428,   429,   735,   430,  1033,   432,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,  1034,     0,   444,   445,     0,   446,   447,   448,   449,
     450,   451,     0,  1035,  1036,     0,     0,   454,  1037,   456,
    1038,  1039,   458,   459,   460,   461,   462,   463,   464,     0,
    1040,   465,   466,   467,   468,   469,  1041,     0,   470,   471,
     472,   473,   474,   475,  1042,     0,   477,   736,   478,   479,
     480,     0,     0,   481,     0,     0,   482,   483,   484,   485,
     486,   487,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,
     496,   497,   498,     0,     0,     0,     0,     0,     0,     0,
    1051,  1052,     0,     0,     0,     0,     0,     0,     0,  1054,
     713,   985,   551,   986,   987,   988,   598,   989,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,  1779,
     209,   210,   211,     0,     0,     0,     0,   212,   990,     0,
       0,   213,   214,     0,   215,   216,   714,   217,   218,   219,
     220,   991,   715,   992,   993,     0,   224,   225,   226,   227,
     228,   994,   995,   229,   230,   996,   997,   233,     0,   234,
     235,   236,   237,   998,     0,   999,     0,   239,   240,   241,
     242,   717,   243,   244,     0,   245,   246,   247,   248,   249,
     250,     0,   718,   251,   252,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,   253,   254,   255,   256,   257,   258,  1007,  1008,
     261,     0,   262,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,     0,   271,   272,  1009,   274,   275,
       0,   276,   277,   278,     0,   279,   280,     0,   281,   282,
     283,   284,  1010,   286,   287,   288,  1011,  1012,   290,     0,
     291,  1013,   293,     0,   294,     0,   295,   720,     0,   721,
     296,   297,   298,     0,   299,  1014,     0,   301,     0,   302,
     303,   304,   305,   306,   722,   307,   308,   309,     0,   310,
     311,   312,   313,   314,   315,     0,   316,   723,   317,   318,
     319,   320,   321,  1015,  1016,     0,  1017,     0,   325,   724,
     725,   326,   726,   327,   328,   329,   330,   331,   332,   333,
       0,   334,  1018,   727,   336,   728,     0,   337,   338,   339,
    1019,  1020,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,  1021,   729,  1022,   354,   355,   356,
    1023,   357,   358,   730,   359,  1024,  1025,   361,  1026,   363,
     364,   365,     0,   366,     0,     0,  1027,   368,   369,     0,
       0,   370,   731,   732,   733,  1028,   372,   373,   374,   375,
     376,   377,   378,     0,   379,  1029,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,  1030,
     394,   395,   396,   397,     0,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   734,   410,
     411,  1031,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,  1032,   426,   427,   428,
     429,   735,   430,  1033,   432,     0,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,  1034,     0,   444,   445,
       0,   446,   447,   448,   449,   450,   451,     0,  1035,  1036,
       0,     0,   454,  1037,   456,  1038,  1039,   458,   459,   460,
     461,   462,   463,   464,     0,  1040,   465,   466,   467,   468,
     469,  1041,     0,   470,   471,   472,   473,   474,   475,  1042,
       0,   477,   736,   478,   479,   480,     0,     0,   481,     0,
       0,   482,   483,   484,   485,   486,   487,  1043,  1044,  1045,
    1046,  1047,  1048,  1049,  1050,   496,   497,   498,     0,     0,
       0,     0,     0,     0,     0,  1051,  1052,     0,     0,     0,
       0,     0,     0,     0,  1054,   713,   985,   551,   986,   987,
     988,   598,   989,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,   212,   990,     0,     0,   213,   214,     0,   215,
     216,   714,   217,   218,   219,   220,   991,   715,   992,   993,
       0,   224,   225,   226,   227,   228,   994,   995,   229,   230,
     996,   997,   233,     0,   234,   235,   236,   237,   998,     0,
     999,     0,   239,   240,   241,   242,   717,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,   718,   251,   252,
    1000,  1001,  1002,  1003,  1004,  1005,  1006,   253,   254,   255,
     256,   257,   258,  1007,  1008,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,  1009,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,  1010,   286,   287,
     288,  1011,  1012,   290,     0,   291,  1013,   293,     0,   294,
       0,   295,   720,  2280,   721,   296,   297,   298,     0,   299,
    1014,     0,   301,     0,   302,   303,   304,   305,   306,   722,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,   723,   317,   318,   319,   320,   321,  1015,  1016,
       0,  1017,     0,   325,   724,   725,   326,   726,   327,   328,
     329,   330,   331,   332,   333,     0,   334,  1018,   727,   336,
     728,     0,   337,   338,   339,  1019,  1020,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,  1021,
     729,  1022,   354,   355,   356,  1023,   357,   358,   730,   359,
    1024,  1025,   361,  1026,   363,   364,   365,     0,   366,     0,
       0,  1027,   368,   369,     0,     0,   370,   731,   732,   733,
    1028,   372,   373,   374,   375,   376,   377,   378,     0,   379,
    1029,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,  1030,   394,   395,   396,   397,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   734,   410,   411,  1031,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,  1032,   426,   427,   428,   429,   735,   430,  1033,   432,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,  1034,     0,   444,   445,     0,   446,   447,   448,   449,
     450,   451,     0,  1035,  1036,     0,     0,   454,  1037,   456,
    1038,  1039,   458,   459,   460,   461,   462,   463,   464,     0,
    1040,   465,   466,   467,   468,   469,  1041,     0,   470,   471,
     472,   473,   474,   475,  1042,     0,   477,   736,   478,   479,
     480,     0,     0,   481,     0,     0,   482,   483,   484,   485,
     486,   487,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,
     496,   497,   498,     0,     0,     0,     0,     0,     0,     0,
    1051,  1052,     0,     0,     0,     0,     0,     0,     0,  1054,
     713,   985,   551,   986,   987,   988,   598,   989,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,   212,   990,     0,
       0,   213,   214,     0,   215,   216,   714,   217,   218,   219,
     220,   991,   715,   992,   993,     0,   224,   225,   226,   227,
     228,   994,   995,   229,   230,   996,   997,   233,     0,   234,
     235,   236,   237,   998,     0,   999,     0,   239,   240,   241,
     242,   717,   243,   244,     0,   245,   246,   247,   248,   249,
     250,     0,   718,   251,   252,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,   253,   254,   255,   256,   257,   258,  1007,  1008,
     261,     0,   262,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,     0,   271,   272,  1009,   274,   275,
       0,   276,   277,   278,     0,   279,   280,     0,   281,   282,
     283,   284,  1010,   286,   287,   288,  1011,  1012,   290,     0,
     291,  1013,   293,     0,   294,     0,   295,   720,     0,   721,
     296,   297,   298,     0,   299,  1014,     0,   301,     0,   302,
     303,   304,   305,   306,   722,   307,   308,   309,     0,   310,
     311,   312,   313,   314,   315,     0,   316,   723,   317,   318,
     319,   320,   321,  1015,  1016,     0,  1017,     0,   325,   724,
     725,   326,   726,   327,   328,   329,   330,   331,   332,   333,
       0,   334,  1018,   727,   336,   728,     0,   337,   338,   339,
    1019,  1020,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,  1021,   729,  1022,   354,   355,   356,
    1023,   357,   358,   730,   359,  1024,  1025,   361,  1026,   363,
     364,   365,     0,   366,     0,     0,  1027,   368,   369,     0,
       0,   370,   731,   732,   733,  1028,   372,   373,   374,   375,
     376,   377,   378,     0,   379,  1029,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,  1030,
     394,   395,   396,   397,     0,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   734,   410,
     411,  1031,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,  1032,   426,   427,   428,
     429,   735,   430,  1033,   432,     0,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,  1034,     0,   444,   445,
       0,   446,   447,   448,   449,   450,   451,     0,  1035,  1036,
       0,     0,   454,  1037,   456,  1038,  1039,   458,   459,   460,
     461,   462,   463,   464,     0,  1040,   465,   466,   467,   468,
     469,  1041,     0,   470,   471,   472,   473,   474,   475,  1042,
    3441,   477,   736,   478,   479,   480,     0,     0,   481,     0,
       0,   482,   483,   484,   485,   486,   487,  1043,  1044,  1045,
    1046,  1047,  1048,  1049,  1050,   496,   497,   498,     0,     0,
       0,     0,     0,     0,     0,  1051,  1052,     0,     0,     0,
       0,     0,     0,     0,  1054,   713,   985,   551,   986,   987,
     988,   598,   989,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,   212,   990,     0,     0,   213,   214,     0,   215,
     216,   714,   217,   218,   219,   220,   991,   715,   992,   993,
       0,   224,   225,   226,   227,   228,   994,   995,   229,   230,
     996,   997,   233,     0,   234,   235,   236,   237,   998,     0,
     999,     0,   239,   240,   241,   242,   717,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,   718,   251,   252,
    1000,  1001,  1002,  1003,  1004,  1005,  1006,   253,   254,   255,
     256,   257,   258,  1007,  1008,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,  1009,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,  1010,   286,   287,
     288,  1011,  1012,   290,     0,   291,  1013,   293,     0,   294,
       0,   295,   720,     0,   721,   296,   297,   298,     0,   299,
    1014,     0,   301,     0,   302,   303,   304,   305,   306,   722,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,   723,   317,   318,   319,   320,   321,  1015,  1016,
       0,  1017,     0,   325,   724,   725,   326,   726,   327,   328,
     329,   330,   331,   332,   333,     0,   334,  1018,   727,   336,
     728,     0,   337,   338,   339,  1019,  1020,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,  1021,
     729,  1022,   354,   355,   356,  1023,   357,   358,   730,   359,
    1024,  1025,   361,  1026,   363,   364,   365,     0,   366,     0,
       0,  1027,   368,   369,     0,     0,   370,   731,   732,   733,
    1028,   372,   373,   374,   375,   376,   377,   378,     0,   379,
    1029,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,  1030,   394,   395,   396,   397,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   734,   410,   411,  1031,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,  1032,   426,   427,   428,   429,   735,   430,  1033,   432,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,  1034,     0,   444,   445,     0,   446,   447,   448,   449,
     450,   451,     0,  1035,  1036,     0,     0,   454,  1037,   456,
    1038,  1039,   458,   459,   460,   461,   462,   463,   464,     0,
    1040,   465,   466,   467,   468,   469,  1041,     0,   470,   471,
     472,   473,   474,   475,  1042,     0,   477,   736,   478,   479,
     480,     0,     0,   481,     0,     0,   482,   483,   484,   485,
     486,   487,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,
     496,   497,   498,     0,     0,     0,     0,     0,     0,     0,
    1051,  1052,     0,     0,     0,     0,     0,     0,     0,  1054,
     713,   985,   551,   986,   987,   988,   598,   989,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,   212,   990,     0,
       0,   213,   214,     0,   215,   216,   714,   217,   218,   219,
     220,   991,   715,   992,   993,     0,   224,   225,   226,   227,
     228,   994,   995,   229,   230,   996,   997,   233,     0,   234,
     235,   236,   237,   998,     0,   999,     0,   239,   240,   241,
     242,   717,   243,   244,     0,   245,   246,   247,   248,   249,
     250,     0,   718,   251,  3451,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,   253,   254,   255,   256,   257,   258,  1007,  1008,
     261,     0,   262,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,     0,   271,   272,  1009,   274,   275,
       0,   276,   277,   278,     0,   279,   280,     0,   281,   282,
     283,   284,  1010,   286,   287,   288,  1011,  1012,   290,     0,
     291,  1013,   293,     0,   294,     0,   295,   720,     0,   721,
     296,   297,   298,     0,   299,  1014,     0,   301,     0,   302,
     303,   304,   305,   306,   722,   307,   308,   309,     0,   310,
     311,   312,   313,   314,   315,     0,   316,   723,   317,   318,
     319,   320,   321,  1015,  1016,     0,  1017,     0,   325,   724,
     725,   326,   726,   327,   328,   329,   330,   331,   332,   333,
       0,   334,  1018,   727,   336,   728,     0,   337,   338,   339,
    1019,  1020,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,  1021,   729,  1022,   354,   355,   356,
    1023,   357,   358,   730,   359,  1024,  1025,   361,  1026,   363,
     364,   365,     0,   366,     0,     0,  1027,   368,   369,     0,
       0,   370,   731,   732,   733,  1028,   372,   373,   374,   375,
     376,   377,   378,     0,   379,  1029,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,  1030,
     394,   395,   396,   397,     0,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   734,   410,
     411,  1031,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,  1032,   426,   427,   428,
     429,   735,   430,  1033,   432,     0,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,  1034,     0,   444,   445,
       0,   446,   447,   448,   449,   450,   451,     0,  1035,  1036,
       0,     0,   454,  1037,   456,  1038,  1039,   458,   459,   460,
     461,   462,   463,   464,     0,  1040,   465,   466,   467,   468,
     469,  1041,     0,   470,   471,   472,   473,   474,   475,  1042,
       0,   477,   736,   478,   479,   480,     0,     0,   481,     0,
       0,   482,   483,   484,   485,   486,   487,  1043,  1044,  1045,
    1046,  1047,  1048,  1049,  1050,   496,   497,   498,     0,     0,
       0,     0,     0,     0,     0,  1051,  1052,     0,     0,     0,
       0,     0,     0,     0,  1054,   713,   985,   551,   986,   987,
     988,   598,   989,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,   212,   990,     0,     0,   213,   214,     0,   215,
     216,   714,   217,   218,   219,   220,   991,   715,   992,   993,
       0,   224,   225,   226,   227,   228,   994,   995,   229,   230,
     996,   997,   233,     0,   234,   235,   236,   237,   998,     0,
     999,     0,   239,   240,   241,   242,   717,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,   718,   251,   252,
    1000,  1001,  1002,  1003,  1004,  1005,  1006,   253,   254,   255,
     256,   257,   258,  1007,  1008,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,  1009,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,  1010,   286,   287,
     288,  1011,  1012,   290,     0,   291,  1013,   293,     0,   294,
       0,   295,   720,     0,   721,   296,   297,   298,     0,   299,
    1014,     0,   301,     0,   302,   303,   304,   305,   306,   722,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,   723,   317,   318,   319,   320,   321,  1015,  1016,
       0,  1017,     0,   325,   724,   725,   326,   726,   327,   328,
     329,   330,   331,   332,   333,     0,   334,  1018,   727,   336,
     728,     0,   337,   338,   339,  1019,  1020,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,  1021,
     729,  1022,   354,   355,   356,  1023,   357,   358,   730,   359,
    1024,  1025,   361,  1026,   363,   364,   365,     0,   366,     0,
       0,  1027,   368,   369,     0,     0,   370,   731,   732,   733,
    1028,   372,   373,   374,   375,   376,   377,   378,     0,   379,
    1029,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,  1030,   394,   395,   396,   397,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   734,   410,   411,  1031,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,  1032,   426,   427,   428,   429,   735,   430,  1033,   432,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,  1034,     0,   444,   445,     0,   446,   447,   448,   449,
     450,   451,     0,  1035,  1036,     0,     0,   454,  1037,   456,
    1038,  1039,   458,   459,   460,   461,   462,   463,   464,     0,
    1040,   465,   466,   467,   468,   469,  1041,     0,   470,   471,
     472,   473,   474,   475,  1042,     0,   477,   736,   478,   479,
     480,     0,     0,   481,     0,     0,   482,   483,   484,   485,
     486,  3721,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,
     496,   497,   498,     0,     0,     0,     0,     0,     0,     0,
    1051,  1052,     0,     0,     0,     0,     0,     0,     0,  1054,
     713,   985,   551,   986,   987,   988,   598,   989,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,   212,   990,     0,
       0,   213,   214,     0,   215,   216,   714,   217,   218,   219,
     220,   991,   715,   992,   993,     0,   224,   225,   226,   227,
     228,   994,   995,   229,   230,   996,   997,   233,     0,   234,
     235,   236,   237,   998,     0,   999,     0,   239,   240,   241,
     242,   717,   243,   244,     0,   245,   246,   247,   248,   249,
     250,     0,   718,   251,   252,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,   253,   254,   255,   256,   257,   258,  1007,  1008,
     261,     0,   262,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,     0,   271,   272,  1009,   274,   275,
       0,   276,   277,   278,     0,   279,   280,     0,   281,   282,
     283,   284,  1010,   286,   287,   288,  1011,  1012,   290,     0,
     291,  1013,   293,     0,   294,     0,   295,   720,     0,   721,
     296,   297,   298,     0,   299,  1014,     0,   301,     0,   302,
     303,   304,   305,   306,   722,   307,   308,   309,     0,   310,
     311,   312,   313,   314,   315,     0,   316,   723,   317,   318,
     319,   320,   321,  1015,  1016,     0,  1017,     0,   325,   724,
     725,   326,   726,   327,   328,   329,   330,   331,   332,   333,
       0,   334,  1018,   727,   336,   728,     0,   337,   338,   339,
    1019,  1020,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,  1021,   729,  1022,   354,  3730,   356,
    1023,   357,   358,   730,   359,  1024,  1025,   361,  1026,   363,
     364,   365,     0,   366,     0,     0,  1027,   368,   369,     0,
       0,   370,   731,   732,   733,  1028,   372,   373,   374,   375,
     376,   377,   378,     0,   379,  1029,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,  1030,
     394,   395,   396,   397,     0,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   734,   410,
     411,  1031,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,  1032,   426,   427,   428,
     429,   735,   430,  1033,   432,     0,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,  1034,     0,   444,   445,
       0,   446,   447,   448,   449,   450,   451,     0,  1035,  1036,
       0,     0,   454,  1037,   456,  1038,  1039,   458,   459,   460,
     461,   462,   463,   464,     0,  1040,   465,   466,   467,   468,
     469,  1041,     0,   470,   471,   472,   473,   474,   475,  1042,
       0,   477,   736,   478,   479,   480,     0,     0,   481,     0,
       0,   482,   483,   484,   485,   486,   487,  1043,  1044,  1045,
    1046,  1047,  1048,  1049,  1050,   496,   497,   498,     0,     0,
       0,     0,     0,     0,     0,  1051,  1052,     0,     0,     0,
       0,     0,     0,     0,  1054,   713,   985,   551,   986,   987,
     988,   598,   989,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,   212,   990,     0,     0,   213,   214,     0,   215,
     216,   714,   217,   218,   219,  4218,   991,   715,   992,   993,
       0,   224,   225,   226,   227,   228,   994,   995,   229,   230,
     996,   997,   233,     0,   234,   235,   236,   237,   998,     0,
     999,     0,   239,   240,   241,   242,   717,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,   718,   251,  4219,
    1000,  1001,  1002,  1003,  1004,  1005,  1006,   253,   254,   255,
     256,   257,   258,  1007,  1008,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,  1009,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,  1010,   286,   287,
     288,  1011,  1012,   290,     0,   291,  1013,   293,     0,   294,
       0,   295,   720,     0,   721,   296,   297,   298,     0,   299,
    1014,     0,   301,     0,   302,   303,   304,   305,   306,   722,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,   723,   317,   318,   319,   320,   321,  1015,  1016,
       0,  1017,     0,   325,   724,   725,   326,   726,   327,   328,
     329,   330,   331,   332,   333,     0,   334,  1018,   727,   336,
     728,     0,   337,   338,   339,  1019,  1020,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,  1021,
     729,  1022,   354,   355,   356,  1023,   357,   358,   730,   359,
    1024,  1025,   361,  1026,   363,   364,   365,     0,   366,     0,
       0,  1027,   368,   369,     0,     0,   370,   731,   732,   733,
    1028,   372,   373,   374,   375,   376,   377,   378,     0,   379,
    1029,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,  1030,   394,   395,   396,   397,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   734,   410,   411,  1031,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,  1032,   426,   427,   428,   429,   735,   430,  1033,   432,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,  1034,     0,   444,   445,     0,   446,   447,   448,   449,
     450,   451,     0,  1035,  1036,     0,     0,   454,  1037,   456,
    1038,  1039,   458,   459,   460,   461,  4220,   463,   464,     0,
    1040,   465,   466,   467,   468,   469,  1041,     0,   470,   471,
     472,   473,   474,   475,  1042,     0,   477,   736,   478,   479,
     480,     0,     0,   481,     0,     0,   482,   483,   484,   485,
     486,   487,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,
     496,   497,   498,     0,     0,     0,     0,     0,     0,     0,
    1051,  1052,     0,     0,     0,     0,     0,     0,     0,  1054,
     713,   985,   551,   986,   987,   988,   598,   989,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,   212,   990,     0,
       0,   213,   214,     0,   215,   216,   714,   217,   218,   219,
     220,   991,   715,   992,   993,     0,   224,   225,   226,   227,
     228,   994,   995,   229,   230,   996,   997,   233,     0,   234,
     235,   236,   237,   998,     0,   999,     0,   239,   240,   241,
     242,   717,   243,   244,     0,   245,   246,   247,   248,   249,
     250,     0,   718,   251,  4219,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,   253,   254,   255,   256,   257,   258,  1007,  1008,
     261,     0,   262,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,     0,   271,   272,  1009,   274,   275,
       0,   276,   277,   278,     0,   279,   280,     0,   281,   282,
     283,   284,  1010,   286,   287,   288,  1011,  1012,   290,     0,
     291,  1013,   293,     0,   294,     0,   295,   720,     0,   721,
     296,   297,   298,     0,   299,  1014,     0,   301,     0,   302,
     303,   304,   305,   306,   722,   307,   308,   309,     0,   310,
     311,   312,   313,   314,   315,     0,   316,   723,   317,   318,
     319,   320,   321,  1015,  1016,     0,  1017,     0,   325,   724,
     725,   326,   726,   327,   328,   329,   330,   331,   332,   333,
       0,   334,  1018,   727,   336,   728,     0,   337,   338,   339,
    1019,  1020,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,  1021,   729,  1022,   354,   355,   356,
    1023,   357,   358,   730,   359,  1024,  1025,   361,  1026,   363,
     364,   365,     0,   366,     0,     0,  1027,   368,   369,     0,
       0,   370,   731,   732,   733,  1028,   372,   373,   374,   375,
     376,   377,   378,     0,   379,  1029,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,  1030,
     394,   395,   396,   397,     0,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   734,   410,
     411,  1031,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,  1032,   426,   427,   428,
     429,   735,   430,  1033,   432,     0,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,  1034,     0,   444,   445,
       0,   446,   447,   448,   449,   450,   451,     0,  1035,  1036,
       0,     0,   454,  1037,   456,  1038,  1039,   458,   459,   460,
     461,  4220,   463,   464,     0,  1040,   465,   466,   467,   468,
     469,  1041,     0,   470,   471,   472,   473,   474,   475,  1042,
       0,   477,   736,   478,   479,   480,     0,     0,   481,     0,
       0,   482,   483,   484,   485,   486,   487,  1043,  1044,  1045,
    1046,  1047,  1048,  1049,  1050,   496,   497,   498,     0,     0,
       0,     0,     0,     0,     0,  1051,  1052,     0,     0,     0,
       0,     0,     0,     0,  1054,   713,   985,   551,   986,   987,
     988,   598,   989,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,   212,   990,     0,     0,   213,   214,     0,   215,
     216,   714,   217,   218,   219,   220,   991,   715,   992,   993,
       0,   224,   225,   226,   227,   228,   994,   995,   229,   230,
     996,   997,   233,     0,   234,   235,   236,   237,   998,     0,
     999,     0,   239,   240,   241,   242,   717,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,   718,   251,   252,
    1000,  1001,  1002,  1003,  1004,  1005,  1006,   253,   254,   255,
     256,   257,   258,  1007,  1008,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,  1009,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,  1010,   286,   287,
     288,  1011,  1012,   290,     0,   291,  1013,   293,     0,   294,
       0,   295,   720,     0,   721,   296,   297,   298,     0,   299,
    1014,     0,   301,     0,   302,   303,   304,   305,   306,   722,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,   723,   317,   318,   319,   320,   321,  1015,  1016,
       0,  1017,     0,   325,   724,   725,   326,   726,   327,   328,
     329,   330,   331,   332,   333,     0,   334,  1018,   727,   336,
     728,     0,   337,   338,   339,  1019,  1020,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,  1021,
     729,  1022,   354,   355,   356,     0,   357,   358,   730,   359,
    1024,  1025,   361,  1026,   363,   364,   365,     0,   366,     0,
       0,  1027,   368,   369,     0,     0,   370,   731,   732,   733,
    1028,   372,   373,   374,   375,   376,   377,   378,     0,   379,
    1029,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,  1030,   394,   395,   396,   397,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   734,   410,   411,  1031,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,  1032,   426,   427,   428,   429,   735,   430,  1033,   432,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,  1034,     0,   444,   445,     0,   446,   447,   448,   449,
     450,   451,     0,  1035,  1036,     0,     0,   454,  1037,   456,
    1038,  1039,   458,   459,   460,   461,   462,   463,   464,     0,
       0,   465,   466,   467,   468,   469,  1041,     0,   470,   471,
     472,   473,   474,   475,  1042,     0,   477,   736,   478,   479,
     480,     0,     0,   481,     0,     0,   482,   483,   484,   485,
     486,   487,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,
     496,   497,   498,     0,     0,     0,     0,     0,     0,     0,
    2262,  2263,     0,     0,     0,     0,     0,     0,     0,  1054,
     713,   985,   551,   986,   987,   988,   598,   989,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,   212,   990,     0,
       0,   213,   214,     0,   215,   216,   714,   217,   218,   219,
   -2171,   991,   715,   992,   993,     0,   224,   225,   226,   227,
     228,   994,   995,   229,   230,   996,   997,   233,     0,   234,
     235,   236,   237,   998,     0,   999,     0,   239,   240,   241,
     242,   717,   243,   244,     0,   245,   246,   247,   248,   249,
     250,     0,   718,   251,  4219,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,   253,   254,   255,   256,   257,   258,  1007,  1008,
     261,     0,   262,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,     0,   271,   272,  1009,   274,   275,
       0,   276,   277,   278,     0,   279,   280,     0,   281,   282,
     283,   284,  1010,   286,   287,   288,  1011,  1012,   290,     0,
     291,  1013,   293,     0,   294,     0,   295,   720,     0,   721,
     296,   297,   298,     0,   299,  1014,     0,   301,     0,   302,
     303,   304,   305,   306,     0,   307,   308,   309,     0,   310,
     311,   312,   313,   314,   315,     0,   316,   723,   317,   318,
     319,   320,   321,  1015,  1016,     0,  1017,     0,   325,   724,
     725,   326,   726,   327,   328,   329,   330,   331,   332,   333,
       0,   334,  1018,   727,   336,     0,     0,   337,   338,   339,
    1019,  1020,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,  1021,   729,  1022,   354,   355,   356,
       0,   357,   358,   730,   359,  1024,  1025,   361,  1026,   363,
     364,   365,     0,   366,     0,     0,  1027,   368,   369,     0,
       0,   370,   731,   732,   733,  1028,   372,   373,   374,   375,
     376,   377,   378,     0,   379,  1029,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,  1030,
     394,   395,   396,   397,     0,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   734,   410,
     411,  1031,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,  1032,   426,   427,   428,
     429,     0,   430,  1033,   432,     0,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,  1034,     0,   444,   445,
       0,   446,   447,   448,   449,   450,   451,     0,  1035,  1036,
       0,     0,   454,  1037,   456,  1038,  1039,   458,   459,   460,
     461,  4220,   463,   464,     0,  1040,   465,   466,   467,   468,
     469,  1041,     0,   470,   471,   472,   473,   474,   475,  1042,
       0,   477,   736,   478,   479,   480,     0,     0,   481,     0,
       0,   482,   483,   484,   485,   486,   487,  1043,  1044,  1045,
    1046,  1047,  1048,  1049,  1050,   496,   497,   498,     0,     0,
       0,     0,     0,     0,     0,  1051,  1052,     0,     0,   713,
     985,   551,   986,   987,  1054,   598,   989,     0,     0,     0,
     200,   201,   202,   203,   204,   205,   206,   207,     0,   209,
     210,   211,     0,     0,     0,     0,   212,   990,     0,     0,
     213,   214,     0,   215,   216,   714,   217,   218,   219,   220,
     991,   715,   992,   993,     0,   224,   225,   226,   227,   228,
     994,   995,   229,   230,   996,   997,   233,     0,   234,   235,
     236,   237,   998,     0,   999,     0,   239,   240,   241,   242,
     717,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,   718,   251,   252,  1000,  1001,  1002,  1003,  1004,  1005,
    1006,   253,   254,   255,   256,   257,   258,  1007,  1008,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,  1009,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,  1010,   286,   287,   288,  1011,  1012,   290,     0,   291,
    1013,   293,     0,   294,     0,   295,   720,     0,   721,   296,
     297,   298,     0,   299,  1014,     0,   301,     0,   302,   303,
     304,   305,   306,   722,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,   723,   317,   318,   319,
     320,   321,  1015,  1016,     0,  1017,     0,   325,   724,   725,
     326,   726,   327,   328,   329,   330,   331,   332,   333,     0,
     334,  1018,   727,   336,   728,     0,   337,   338,   339,  1019,
    1020,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,  1021,   729,  1022,   354,   355,   356,     0,
     357,   358,   730,   359,  1024,  1025,   361,  1026,   363,   364,
     365,     0,   366,     0,     0,   367,   368,   369,     0,     0,
     370,   731,   732,   733,  1028,   372,   373,   374,   375,   376,
     377,   378,     0,   379,  1029,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,  1030,   394,
     395,   396,   397,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,   734,   410,   411,
    1031,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,  1032,   426,   427,   428,   429,
     735,   430,  1033,   432,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,  1034,     0,   444,   445,     0,
     446,   447,   448,   449,   450,   451,     0,  1035,  1036,     0,
       0,   454,  1037,   456,  1038,  1039,   458,   459,   460,   461,
     462,   463,   464,     0,     0,   465,   466,   467,   468,   469,
    1041,     0,   470,   471,   472,   473,   474,   475,  1042,     0,
     477,   736,   478,   479,   480,     0,     0,   481,     0,     0,
     482,   483,   484,   485,   486,   487,  1043,  1044,  1045,  1046,
    1047,  1048,  1049,  1050,   496,   497,   498,     0,     0,     0,
       0,     0,     0,   713,   985,   551,   986,   987,     0,   598,
     989,     0,     0,  1054,   200,   201,   202,   203,   204,   205,
     206,   207,     0,   209,   210,   211,     0,     0,     0,     0,
     212,   990,     0,     0,   213,   214,     0,   215,   216,   714,
     217,   218,   219,   220,   991,   715,   992,   993,     0,  3364,
     225,   226,   227,   228,   994,   995,   229,   230,   996,   997,
     233,     0,   234,   235,   236,   237,   998,     0,   999,     0,
     239,   240,   241,   242,   717,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,   718,   251,   252,  1000,  1001,
    1002,  1003,  1004,  1005,  1006,   253,   254,   255,   256,   257,
     258,  1007,  1008,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
    1009,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,  1010,   286,   287,   288,  1011,
    1012,   290,     0,   291,  1013,   293,     0,   294,     0,   295,
     720,     0,   721,   296,   297,   298,     0,   299,  1014,     0,
     301,     0,   302,   303,   304,   305,   306,   722,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
     723,   317,   318,   319,   320,   321,  1015,  1016,     0,  1017,
       0,   325,   724,   725,   326,   726,   327,   328,   329,   330,
     331,   332,   333,     0,   334,  1018,   727,   336,   728,     0,
     337,   338,   339,  1019,  1020,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,  1021,   729,  1022,
     354,   355,   356,     0,   357,   358,   730,   359,  1024,  1025,
     361,  1026,   363,   364,   365,     0,   366,     0,     0,   367,
     368,   369,     0,     0,   370,   731,   732,   733,  1028,   372,
     373,   374,   375,   376,   377,   378,     0,   379,  1029,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,  1030,   394,   395,   396,   397,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,   734,   410,   411,  1031,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,  1032,
     426,   427,   428,   429,   735,   430,  1033,   432,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,  1034,
       0,   444,   445,     0,   446,   447,   448,   449,   450,   451,
       0,  1035,  1036,     0,     0,   454,  1037,   456,  1038,  1039,
     458,   459,   460,   461,   462,   463,   464,     0,     0,   465,
     466,   467,   468,   469,  1041,     0,   470,   471,   472,   473,
     474,   475,  1042,     0,   477,   736,   478,   479,   480,     0,
       0,   481,     0,     0,   482,   483,   484,   485,   486,   487,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,   496,   497,
     498,     0,     0,     0,     0,     0,     0,   713,   985,   551,
     986,   987,   988,   598,   989,     0,     0,  1054,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,   212,   990,     0,     0,   213,   214,
       0,   215,   216,   714,   217,   218,   219,     0,   991,   715,
     992,   993,     0,   224,   225,   226,   227,   228,   994,   995,
     229,   230,   996,   997,   233,     0,   234,   235,   236,   237,
     998,     0,   999,     0,   239,   240,   241,   242,   717,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,   718,
     251,   252,  1000,  1001,  1002,  1003,  1004,  1005,  1006,   253,
     254,   255,   256,   257,   258,  1007,  1008,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,  1009,   274,   275,     0,   276,   277,
     278,     0,   279,     0,     0,   281,   282,   283,   284,  1010,
     286,   287,   288,  1011,  1012,   290,     0,   291,  1013,   293,
       0,   294,     0,   295,   720,     0,   721,   296,   297,   298,
       0,   299,  1014,     0,   301,     0,   302,   303,   304,   305,
     306,     0,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,   723,   317,   318,   319,   320,   321,
    1015,  1016,     0,  1017,     0,   325,   724,   725,   326,   726,
     327,   328,   329,   330,   331,   332,   333,     0,   334,  1018,
     727,   336,     0,     0,   337,   338,   339,  1019,  1020,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,  1021,   729,  1022,   354,   355,   356,     0,   357,   358,
     730,   359,  1024,  1025,   361,  1026,   363,   364,   365,     0,
     366,     0,     0,  1027,   368,   369,     0,     0,   370,   731,
     732,   733,  1028,   372,   373,   374,   375,   376,   377,   378,
       0,   379,  1029,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,  1030,   394,   395,   396,
     397,     0,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,   734,   410,   411,  1031,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,  1032,   426,   427,   428,   429,     0,   430,
    1033,   432,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,  1034,     0,   444,   445,     0,   446,   447,
     448,   449,   450,   451,     0,  1035,  1036,     0,     0,   454,
    1037,   456,  1038,  1039,   458,   459,   460,   461,   462,   463,
     464,     0,  1040,   465,   466,   467,   468,   469,  1041,     0,
     470,   471,   472,   473,   474,   475,  1042,     0,   477,   736,
     478,   479,   480,     0,     0,   481,     0,     0,   482,   483,
     484,   485,   486,   487,  1043,  1044,  1045,  1046,  1047,  1048,
    1049,  1050,   496,   497,   498,     0,     0,     0,     0,     0,
       0,     0,  1051,  1052,     0,     0,     0,     0,     0,     0,
       0,  1054,   713,   985,   551,   986,   987,   988,   598,   989,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,   212,
     990,     0,     0,   213,   214,     0,   215,   216,   714,   217,
     218,   219,     0,   991,   715,   992,   993,     0,   224,   225,
     226,   227,   228,   994,   995,   229,   230,   996,   997,   233,
       0,   234,   235,   236,   237,   998,     0,   999,     0,   239,
     240,   241,   242,   717,   243,   244,     0,   245,   246,   247,
     248,   249,   250,     0,   718,   251,   252,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,   253,   254,   255,   256,   257,   258,
    1007,  1008,   261,     0,   262,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,     0,   271,   272,  1009,
     274,   275,     0,   276,   277,   278,     0,   279,     0,     0,
     281,   282,   283,   284,  1010,   286,   287,   288,  1011,  1012,
     290,     0,   291,  1013,   293,     0,   294,     0,   295,   720,
       0,   721,   296,   297,   298,     0,   299,  1014,     0,   301,
       0,   302,   303,   304,   305,   306,     0,   307,   308,   309,
       0,   310,   311,   312,   313,   314,   315,     0,   316,   723,
     317,   318,   319,   320,   321,  1015,  1016,     0,  1017,     0,
     325,   724,   725,   326,   726,   327,   328,   329,   330,   331,
     332,   333,     0,   334,  1018,   727,   336,     0,     0,   337,
     338,   339,  1019,  1020,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,  1021,   729,  1022,   354,
     355,   356,     0,   357,   358,   730,   359,  1024,  1025,   361,
    1026,   363,   364,   365,     0,   366,     0,     0,  1027,   368,
     369,     0,     0,   370,   731,   732,   733,  1028,   372,   373,
     374,   375,   376,   377,   378,     0,   379,  1029,   381,   382,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,  1030,   394,   395,   396,   397,     0,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     734,   410,   411,  1031,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,  1032,   426,
     427,   428,   429,     0,   430,  1033,   432,     0,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,  1034,     0,
     444,   445,     0,   446,   447,   448,   449,   450,   451,     0,
    1035,  1036,     0,     0,   454,  1037,   456,  1038,  1039,   458,
     459,   460,   461,   462,   463,   464,     0,     0,   465,   466,
     467,   468,   469,  1041,     0,   470,   471,   472,   473,   474,
     475,  1042,     0,   477,   736,   478,   479,   480,     0,     0,
     481,     0,     0,   482,   483,   484,   485,   486,   487,  1043,
    1044,  1045,  1046,  1047,  1048,  1049,  1050,   496,   497,   498,
       0,     0,     0,     0,     0,     0,   713,  2262,  2263,     0,
       0,     0,     0,     0,     0,     0,  1054,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,   212,     0,     0,     0,   213,   214,     0,
     215,   216,   714,   217,   218,   219,   220,   221,   715,   222,
     223,     0,   224,   225,   226,   227,   228,     0,   995,   229,
     230,   231,   232,   233,     0,   234,   235,   236,   237,   998,
       0,   999,     0,   239,   240,   241,   242,   717,   243,   244,
       0,   245,   246,   247,   248,   249,   250,     0,   718,   251,
     252,  1000,  1001,  1002,  1003,  1004,  1005,  1006,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   262,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
       0,   279,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,  1011,     0,   290,     0,   291,   292,   293,     0,
     294,     0,   295,   720,     0,   721,   296,   297,   298,     0,
     299,  1014,     0,   301,     0,   302,   303,   304,   305,   306,
     722,   307,   308,   309,     0,   310,   311,   312,   313,   314,
     315,     0,   316,   723,   317,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   724,   725,   326,   726,   327,
     328,   329,   330,   331,   332,   333,     0,   334,  1018,   727,
     336,   728,     0,   337,   338,   339,  1019,  1020,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   729,   353,   354,   355,   356,     0,   357,   358,   730,
     359,     0,  1025,   361,   362,   363,   364,   365,     0,   366,
       0,   678,   367,   368,   369,     0,     0,   370,   731,   732,
     733,  1028,   372,   373,   374,   375,   376,   377,   378,     0,
     379,  1029,   381,   382,   383,   384,   385,     0,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
       0,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   734,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,    37,   421,   422,   423,
     424,   425,  1032,   426,   427,   428,   429,   735,   430,   431,
     432,     0,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,  1034,     0,   444,   445,    41,   446,   447,   448,
     449,   450,   451,     0,   452,   453,     0,     0,   454,  1037,
     456,  1038,     0,   458,   459,   460,   461,   462,   463,   464,
       0,     0,   465,   466,   467,   468,   469,  1041,     0,   470,
     471,   472,   473,   474,   925,   476,     0,   477,   736,   478,
     479,   480,     0,     0,   481,     0,    46,   482,   483,   484,
     485,   486,   487,  1043,  1044,  1045,  1046,  1047,  1048,  1049,
    1050,   496,   497,   498,     0,     0,     0,     0,     0,     0,
     713,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2939,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,   212,     0,     0,
       0,   213,   214,     0,   215,   216,   714,   217,   218,   219,
     220,   221,   715,   222,   223,     0,   224,   225,   226,   227,
     228,     0,   995,   229,   230,   231,   232,   233,     0,   234,
     235,   236,   237,   998,     0,   999,     0,   239,   240,   241,
     242,   717,   243,   244,     0,   245,   246,   247,   248,   249,
     250,     0,   718,   251,   252,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,   253,   254,   255,   256,   257,   258,   259,   260,
     261,     0,   262,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,     0,   279,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,  1011,     0,   290,     0,
     291,   292,   293,     0,   294,     0,   295,   720,     0,   721,
     296,   297,   298,     0,   299,  1014,     0,   301,     0,   302,
     303,   304,   305,   306,   722,   307,   308,   309,     0,   310,
     311,   312,   313,   314,   315,     0,   316,   723,   317,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,   724,
     725,   326,   726,   327,   328,   329,   330,   331,   332,   333,
       0,   334,  1018,   727,   336,   728,     0,   337,   338,   339,
    1019,  1020,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   729,   353,   354,   355,   356,
       0,   357,   358,   730,   359,     0,  1025,   361,   362,   363,
     364,   365,     0,   366,     0,   678,   367,   368,   369,     0,
       0,   370,   731,   732,   733,  1028,   372,   373,   374,   375,
     376,   377,   378,     0,   379,  1029,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,     0,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,   734,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,  1032,   426,   427,   428,
     429,   735,   430,   431,   432,     0,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,  1034,     0,   444,   445,
       0,   446,   447,   448,   449,   450,   451,     0,   452,   453,
       0,     0,   454,  1037,   456,  1038,     0,   458,   459,   460,
     461,   462,   463,   464,     0,     0,   465,   466,   467,   468,
     469,  1041,     0,   470,   471,   472,   473,   474,   475,   476,
       0,   477,   736,   478,   479,   480,     0,     0,   481,     0,
       0,   482,   483,   484,   485,   486,   487,  1043,  1044,  1045,
    1046,  1047,  1048,  1049,  1050,   496,   497,   498,     0,     0,
       0,     0,     0,     0,   713,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2939,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,   212,     0,     0,     0,   213,   214,     0,   215,   216,
     714,   217,   218,   219,   220,   221,   715,   222,   223,     0,
     224,   225,   226,   227,   228,     0,   995,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   998,     0,   999,
       0,   239,   240,   241,   242,   717,   243,   244,     0,   245,
     246,   247,   248,   249,   250,     0,   718,   251,   252,  1000,
    1001,  1002,  1003,  1004,  1005,  1006,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   262,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,     0,   279,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
    1011,     0,   290,     0,   291,   292,   293,     0,   294,     0,
     295,   720,     0,   721,   296,   297,   298,     0,   299,  1014,
       0,   301,     0,   302,   303,   304,   305,   306,   722,   307,
     308,   309,     0,   310,   311,   312,   313,   314,   315,     0,
     316,   723,   317,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,   724,   725,   326,   726,   327,   328,   329,
     330,   331,   332,   333,     0,   334,  1018,   727,   336,   728,
       0,   337,   338,   339,  1019,  1020,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   729,
     353,   354,   355,   356,     0,   357,   358,   730,   359,     0,
    1025,   361,   362,   363,   364,   365,     0,   366,     0,     0,
     367,   368,   369,     0,     0,   370,   731,   732,   733,  1028,
     372,   373,   374,   375,   376,   377,   378,     0,   379,  1029,
     381,   382,   383,   384,   385,     0,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,     0,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   734,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
    1032,   426,   427,   428,   429,   735,   430,   431,   432,     0,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
    1034,     0,   444,   445,     0,   446,   447,   448,   449,   450,
     451,     0,   452,   453,     0,     0,   454,  1037,   456,  1038,
       0,   458,   459,   460,   461,   462,   463,   464,     0,     0,
     465,   466,   467,   468,   469,  1041,     0,   470,   471,   472,
     473,   474,   475,   476,     0,   477,   736,   478,   479,   480,
       0,     0,   481,     0,     0,   482,   483,   484,   485,   486,
     487,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,   496,
     497,   498,     0,     0,     0,     0,     0,     0,   756,  1235,
     551,     0,     0,     0,   598,     0,     0,     0,  3472,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,   212,     0,     0,     0,   213,
     214,     0,   215,   216,   714,   217,   218,   219,   220,   221,
     715,   222,   223,     0,   224,   225,   226,   227,   228,     0,
       0,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,     0,   716,     0,   239,   240,   241,   242,   717,
     243,   244,     0,   245,   246,   247,   248,   249,   250,     0,
     718,   251,   252,     0,     0,     0,   719,     0,     0,     0,
     253,   254,   255,   256,   257,   258,   259,   260,   261,     0,
     262,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,     0,   279,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,  1468,   290,     0,   291,   292,
     293,     0,   294,     0,   295,   720,     0,   721,   296,   297,
     298,     0,   299,   300,     0,   301,     0,   302,   303,   304,
     305,   306,   722,   307,   308,   309,     0,   310,   311,   312,
     313,   314,   315,     0,   316,   723,   317,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,   724,   725,   326,
     726,   327,   328,   329,   330,   331,   332,   333,     0,   334,
     335,   727,   336,   728,     0,   337,   338,   339,     0,     0,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   729,   353,   354,   355,   356,     0,   357,
     358,   730,   359,     0,   360,   361,   362,   363,   364,   365,
       0,   366,  1469,     0,   367,   368,   369,     0,     0,   370,
     731,   732,   733,   371,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,     0,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   734,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,     0,   426,   427,   428,   429,   735,
     430,   431,   432,     0,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,     0,   444,   445,     0,   446,
     447,   448,   449,   450,   451,     0,   452,   453,     0,     0,
     454,   455,   456,   457,  1470,   458,   459,   460,   461,   462,
     463,   464,     0,     0,   465,   466,   467,   468,   469,     0,
       0,   470,   471,   472,   473,   474,   475,   476,     0,   477,
     736,   478,   479,   480,     0,     0,   481,     0,     0,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,     0,     0,     0,     0,
       0,     0,   756,   610,  1236,  3595,     0,     0,     0,     0,
       0,     0,  3596,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     3,     4,     0,     0,   212,
       0,     0,     0,   213,   214,     0,   215,   216,   714,   217,
     218,   219,   220,   221,   715,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,     0,   716,     0,   239,
     240,   241,   242,   717,   243,   244,     0,   245,   246,   247,
     248,   249,   250,     0,   718,   251,   252,     0,     0,     0,
     719,     0,     0,     0,   253,   254,   255,   256,   257,   258,
     259,   260,   261,     0,   262,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,     0,   279,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,     0,   291,   292,   293,     0,   294,     0,   295,   720,
       0,   721,   296,   297,   298,     0,   299,   300,     0,   301,
       0,   302,   303,   304,   305,   306,   722,   307,   308,   309,
       0,   310,   311,   312,   313,   314,   315,     0,   316,   723,
     317,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,   724,   725,   326,   726,   327,   328,   329,   330,   331,
     332,   333,     0,   334,   335,   727,   336,   728,     0,   337,
     338,   339,     0,     0,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   729,   353,   354,
     355,   356,     0,   357,   358,   730,   359,     0,   360,   361,
     362,   363,   364,   365,     0,   366,     0,     0,   367,   368,
     369,     0,     0,   370,   731,   732,   733,   371,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,     0,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     734,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,    37,   421,   422,   423,   424,   425,     0,   426,
     427,   428,   429,   735,   430,   431,   432,     0,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,     0,
     444,   445,    41,   446,   447,   448,   449,   450,   451,     0,
     452,   453,     0,     0,   454,   455,   456,   457,     0,   458,
     459,   460,   461,   462,   463,   464,     0,     0,   465,   466,
     467,   468,   469,     0,     0,   470,   471,   472,   473,   474,
     925,   476,     0,   477,   736,   478,   479,   480,     0,     0,
     481,     0,    46,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
       0,     0,     0,     0,     0,     0,   713,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    47,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,   212,     0,     0,     0,   213,   214,     0,
     215,   216,   714,   217,   218,   219,   220,   221,   715,   222,
     223,     0,   224,   225,   226,   227,   228,     0,     0,   229,
     230,   231,   232,   233,     0,   234,   235,   236,   237,   238,
       0,   716,     0,   239,   240,   241,   242,   717,   243,   244,
       0,   245,   246,   247,   248,   249,   250,     0,   718,   251,
     252,     0,     0,     0,   719,     0,     0,     0,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   262,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
       0,   279,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,   290,     0,   291,   292,   293,     0,
     294,     0,   295,   720,     0,   721,   296,   297,   298,     0,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     722,   307,   308,   309,     0,   310,   311,   312,   313,   314,
     315,     0,   316,   723,   317,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   724,   725,   326,   726,   327,
     328,   329,   330,   331,   332,   333,     0,   334,   335,   727,
     336,   728,     0,   337,   338,   339,     0,     0,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   729,   353,   354,   355,   356,     0,   357,   358,   730,
     359,     0,   360,   361,   362,   363,   364,   365,     0,   366,
       0,     0,   367,   368,   369,     0,     0,   370,   731,   732,
     733,   371,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,   383,   384,   385,     0,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
       0,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,   734,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,     0,   426,   427,   428,   429,   735,   430,   431,
     432,     0,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,     0,   444,   445,     0,   446,   447,   448,
     449,   450,   451,     0,   452,   453,     0,     0,   454,   455,
     456,   457,     0,   458,   459,   460,   461,   462,   463,   464,
       0,     0,   465,   466,   467,   468,   469,     0,     0,   470,
     471,   472,   473,   474,   475,   476,     0,   477,   736,   478,
     479,   480,     0,     0,   481,     0,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,     0,     0,     0,     0,     0,     0,
     199,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3998,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,   212,     0,     0,
       0,   213,   214,     0,   215,   216,     0,   217,   218,   219,
     220,   221,     0,   222,   223,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,   231,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,     0,   239,   240,   241,
     242,     0,   243,   244,     0,   245,   246,   247,   248,   249,
     250,     0,     0,   251,   252,     0,     0,     0,     0,     0,
       0,     0,   253,   254,   255,   256,   257,   258,   259,   260,
     261,     0,   262,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,     0,   279,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,     0,   290,     0,
     291,   292,   293,     0,   294,     0,   295,     0,     0,     0,
     296,   297,   298,     0,   299,   300,     0,   301,     0,   302,
     303,   304,   305,   306,     0,   307,   308,   309,     0,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,     0,
       0,   326,     0,   327,   328,   329,   330,   331,   332,   333,
       0,   334,   335,     0,   336,     0,     0,   337,   338,   339,
       0,     0,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,     0,   359,     0,   360,   361,   362,   363,
     364,   365,     0,   366,     0,     0,   367,   368,   369,     0,
       0,   370,     0,     0,     0,   371,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,     0,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,     0,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
      37,   421,   422,   423,   424,   425,     0,   426,   427,   428,
     429,     0,   430,   431,   432,     0,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,     0,   444,   445,
      41,   446,   447,   448,   449,   450,   451,     0,   452,   453,
       0,     0,   454,   455,   456,   457,     0,   458,   459,   460,
     461,   462,   463,   464,     0,     0,   465,   466,   467,   468,
     469,     0,     0,   470,   471,   472,   473,   474,   925,   476,
       0,   477,     0,   478,   479,   480,     0,     0,   481,     0,
      46,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,     0,     0,
       0,     0,     0,     0,   199,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    47,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,   212,     0,     0,     0,   213,   214,     0,   215,   216,
       0,   217,   218,   219,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,     0,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
       0,   239,   240,   241,   242,     0,   243,   244,     0,   245,
     246,   247,   248,   249,   250,     0,     0,   251,   252,     0,
       0,     0,     0,     0,     0,     0,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   262,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,     0,   279,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,     0,   290,     0,   291,   292,   293,     0,   294,     0,
     295,     0,     0,     0,   296,   297,   298,     0,   299,   300,
       0,   301,     0,   302,   303,   304,   305,   306,     0,   307,
     308,   309,     0,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,     0,     0,   326,     0,   327,   328,   329,
     330,   331,   332,   333,     0,   334,   335,     0,   336,     0,
       0,   337,   338,   339,     0,     0,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,     0,   359,     0,
     360,   361,   362,   363,   364,   365,     0,   366,     0,     0,
     367,   368,   369,     0,     0,   370,     0,     0,     0,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,   383,   384,   385,     0,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,     0,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,     0,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
       0,   426,   427,   428,   429,     0,   430,   431,   432,     0,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,     0,   444,   445,     0,   446,   447,   448,   449,   450,
     451,     0,   452,   453,     0,     0,   454,   455,   456,   457,
       0,   458,   459,   460,   461,   462,   463,   464,     0,     0,
     465,   466,   467,   468,   469,     0,     0,   470,   471,   472,
     473,   474,   475,   476,     0,   477,     0,   478,   479,   480,
       0,     0,   481,     0,     0,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,     0,     0,     0,     0,     0,     0,   199,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1107,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,   212,     0,     0,     0,   213,
     214,     0,   215,   216,     0,   217,   218,   219,   220,   221,
       0,   222,   223,     0,   224,   225,   226,   227,   228,     0,
       0,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,     0,     0,     0,   239,   240,   241,   242,     0,
     243,   244,     0,   245,   246,   247,   248,   249,   250,     0,
       0,   251,   252,     0,     0,     0,     0,     0,     0,     0,
     253,   254,   255,   256,   257,   258,   259,   260,   261,     0,
     262,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,     0,   279,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,   290,     0,   291,   292,
     293,     0,   294,     0,   295,     0,     0,     0,   296,   297,
     298,     0,   299,   300,     0,   301,     0,   302,   303,   304,
     305,   306,     0,   307,   308,   309,     0,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,     0,     0,   326,
       0,   327,   328,   329,   330,   331,   332,   333,     0,   334,
     335,     0,   336,     0,     0,   337,   338,   339,     0,     0,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,     0,   360,   361,   362,   363,   364,   365,
       0,   366,     0,     0,   367,   368,   369,     0,     0,   370,
       0,     0,     0,   371,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,     0,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,     0,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,     0,   426,   427,   428,   429,     0,
     430,   431,   432,     0,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,     0,   444,   445,     0,   446,
     447,   448,   449,   450,   451,     0,   452,   453,     0,     0,
     454,   455,   456,   457,     0,   458,   459,   460,   461,   462,
     463,   464,     0,     0,   465,   466,   467,   468,   469,     0,
       0,   470,   471,   472,   473,   474,   475,   476,     0,   477,
       0,   478,   479,   480,     0,     0,   481,     0,     0,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,     0,     0,     0,     0,
       0,     0,   199,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2413,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,   212,
       0,     0,     0,   213,   214,     0,   215,   216,     0,   217,
     218,   219,   220,   221,     0,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,     0,   239,
     240,   241,   242,     0,   243,   244,     0,   245,   246,   247,
     248,   249,   250,     0,     0,   251,   252,     0,     0,     0,
       0,     0,     0,     0,   253,   254,   255,   256,   257,   258,
     259,   260,   261,     0,   262,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,     0,   279,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,     0,   291,   292,   293,     0,   294,     0,   295,     0,
       0,     0,   296,   297,   298,     0,   299,   300,     0,   301,
       0,   302,   303,   304,   305,   306,     0,   307,   308,   309,
       0,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,     0,     0,   326,     0,   327,   328,   329,   330,   331,
     332,   333,     0,   334,   335,     0,   336,     0,     0,   337,
     338,   339,     0,     0,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,     0,   360,   361,
     362,   363,   364,   365,     0,   366,     0,     0,   367,   368,
     369,     0,     0,   370,     0,     0,     0,   371,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,     0,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
       0,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,     0,   426,
     427,   428,   429,     0,   430,   431,   432,     0,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,     0,
     444,   445,     0,   446,   447,   448,   449,   450,   451,     0,
     452,   453,     0,     0,   454,   455,   456,   457,     0,   458,
     459,   460,   461,   462,   463,   464,     0,     0,   465,   466,
     467,   468,   469,     0,     0,   470,   471,   472,   473,   474,
     475,   476,     0,   477,     0,   478,   479,   480,     0,     0,
     481,     0,     0,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
       0,     0,     0,     0,     0,     0,   199,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3435,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,   212,     0,     0,     0,   213,   214,     0,
     215,   216,     0,   217,   218,   219,   220,   221,     0,   222,
     223,     0,   224,   225,   226,   227,   228,     0,     0,   229,
     230,   231,   232,   233,     0,   234,   235,   236,   237,   238,
       0,     0,     0,   239,   240,   241,   242,     0,   243,   244,
       0,   245,   246,   247,   248,   249,   250,     0,     0,   251,
     252,     0,     0,     0,     0,     0,     0,     0,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   262,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
       0,   279,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,   290,     0,   291,   292,   293,     0,
     294,     0,   295,     0,     0,     0,   296,   297,   298,     0,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,     0,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,     0,     0,   326,     0,   327,
     328,   329,   330,   331,   332,   333,     0,   334,   335,     0,
     336,     0,     0,   337,   338,   339,     0,     0,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,     0,   353,   354,   355,   356,     0,   357,   358,     0,
     359,     0,   360,   361,   362,   363,   364,   365,     0,   366,
       0,     0,   367,   368,   369,     0,     0,   370,     0,     0,
       0,   371,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,   383,   384,   385,     0,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
       0,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,     0,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,     0,   426,   427,   428,   429,     0,   430,   431,
     432,     0,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,     0,   444,   445,     0,   446,   447,   448,
     449,   450,   451,     0,   452,   453,     0,     0,   454,   455,
     456,   457,     0,   458,   459,   460,   461,   462,   463,   464,
       0,     0,   465,   466,   467,   468,   469,     0,     0,   470,
     471,   472,   473,   474,   475,   476,     0,   477,     0,   478,
     479,   480,     0,     0,   481,     0,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,     0,     0,     0,     0,     0,     0,
    1334,  1235,   551,     0,     0,   765,   598,     0,     0,     0,
    3765,   200,   201,   202,   203,   204,   205,   206,   207,  1670,
     209,   210,   211,  1671,  1672,  1673,  1674,   212,  1675,  1676,
    1677,   213,   214,  1678,   215,   216,   714,   217,   218,   219,
       0,  1335,   715,  1336,  1337,  1679,   224,   225,   226,   227,
     228,  1680,  1681,   229,   230,  1338,  1339,   233,  1682,   234,
     235,   236,   237,     0,  1683,   716,  1684,   239,   240,   241,
     242,   717,   243,   244,  1685,   245,   246,   247,   248,   249,
     250,  1686,   718,   251,   252,  1687,  1688,  1689,   719,  1690,
    1691,  1692,   253,   254,   255,   256,   257,   258,  1340,  1341,
     261,  1693,   262,  1694,   263,   264,   265,   266,   267,  1695,
     268,   269,   270,  1696,  1697,   271,   272,  1009,   274,   275,
    1698,   276,   277,   278,  1699,   279,   280,  1700,   281,   282,
     283,   284,     0,   286,   287,   288,     0,  1701,   290,  1702,
     291,  1342,   293,  1703,   294,  1704,   295,   720,  1705,   721,
     296,   297,   298,  1706,   299,     0,  1707,   301,  1708,   302,
     303,   304,   305,   306,   722,   307,   308,   309,  1709,   310,
     311,   312,   313,   314,   315,  1710,   316,   723,     0,   318,
     319,   320,   321,  1343,  1344,  1711,  1345,  1712,   325,   724,
     725,   326,   726,   327,   328,   329,   330,   331,   332,   333,
    1713,   334,     0,   727,   336,   728,  1714,   337,   338,   339,
    1715,  1716,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,  1346,   729,  1347,   354,   355,     0,
    1717,   357,   358,   730,   359,  1718,     0,   361,  1348,   363,
     364,   365,  1719,   366,  1720,  1721,  3169,   368,   369,  1722,
    1723,     0,   731,   732,   733,     0,   372,   373,   374,   375,
     376,   377,   378,  1724,   379,     0,   381,     0,   383,   384,
     385,  1725,   386,   387,   388,   389,   390,   391,   392,  1349,
     394,   395,   396,   397,  1726,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,  1727,   408,   409,   734,   410,
     411,     0,   413,   414,   415,   416,   417,   418,   419,   420,
    1728,   421,   422,   423,   424,   425,  1729,   426,  1887,   428,
     429,   735,   430,  1351,   432,  1730,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,     0,  1731,   444,   445,
    1732,   446,   447,   448,   449,   450,   451,  1733,  1352,  1353,
    1734,  1735,   454,     0,   456,     0,  1736,   458,   459,   460,
     461,   462,   463,   464,  1737,  1738,   465,   466,   467,   468,
     469,  1739,  1740,   470,   471,   472,   473,   474,     0,  1354,
    1741,   477,   736,   478,   479,   480,  1742,  1743,   481,  1744,
    1745,   482,   483,   484,   485,   486,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   496,   497,   498,     0,     0,
       0,   768,   769,   770,     0,  3170,  3171,   773,   774,   775,
     776,   199,     0,     0,     0,     0,   765,     0,     0,     0,
       0,     0,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,   212,     0,
       0,     0,   213,   214,     0,   215,   216,     0,   217,   218,
     219,   220,   221,     0,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,   233,     0,
     234,   766,   236,   237,   238,     0,     0,     0,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,     0,   251,   252,     0,     0,     0,     0,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   767,
       0,   291,   292,   293,     0,   294,     0,   295,     0,     0,
       0,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,     0,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
       0,     0,   326,     0,   327,   328,   329,   330,   331,   332,
     333,     0,   334,   335,     0,   336,     0,     0,   337,   338,
     339,     0,     0,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,     0,   353,   354,   355,
     356,     0,   357,   358,     0,   359,     0,   360,   361,   362,
     363,   364,   365,     0,   366,     0,     0,   367,   368,   369,
       0,     0,   370,     0,     0,     0,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,     0,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,     0,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,     0,   426,   427,
     428,   429,     0,   430,   431,   432,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,     0,   444,
     445,     0,   446,   447,   448,   449,   450,   451,     0,   452,
     453,     0,     0,   454,   455,   456,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,     0,   465,   466,   467,
     468,   469,     0,     0,   470,   471,   472,   473,   474,   475,
     476,     0,   477,     0,   478,   479,   480,     0,     0,   481,
       0,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,     0,
       0,     0,   768,   769,   770,     0,   771,   772,   773,   774,
     775,   776,   199,     0,     0,     0,     0,   765,     0,     0,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,   212,
       0,     0,     0,   213,   214,     0,   215,   216,     0,   217,
     218,   219,   220,   221,     0,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,   233,
       0,   234,   853,   236,   237,   238,     0,     0,     0,   239,
     240,   241,   242,     0,   243,   244,     0,   245,   246,   247,
     248,   249,   250,     0,     0,   251,   252,     0,     0,     0,
       0,     0,     0,     0,   253,   254,   255,   256,   257,   258,
     259,   260,   261,     0,   262,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,     0,   279,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     854,     0,   291,   292,   293,     0,   294,     0,   295,     0,
       0,     0,   296,   297,   298,     0,   299,   300,     0,   301,
       0,   302,   303,   304,   305,   306,     0,   307,   308,   309,
       0,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,     0,     0,   326,     0,   327,   328,   329,   330,   331,
     332,   333,     0,   334,   335,     0,   336,     0,     0,   337,
     338,   339,     0,     0,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,     0,   360,   361,
     362,   363,   364,   365,     0,   366,     0,     0,   367,   368,
     369,     0,     0,   370,     0,     0,     0,   371,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,     0,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
       0,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,     0,   426,
     427,   428,   429,     0,   430,   431,   432,     0,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,     0,
     444,   445,     0,   446,   447,   448,   449,   450,   451,     0,
     452,   453,     0,     0,   454,   455,   456,   457,     0,   458,
     459,   460,   461,   462,   463,   464,     0,     0,   465,   466,
     467,   468,   469,     0,     0,   470,   471,   472,   473,   474,
     475,   476,     0,   477,     0,   478,   479,   480,     0,     0,
     481,     0,     0,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
       0,     0,     0,   768,   769,   770,     0,   771,   772,   773,
     774,   775,   776,   199,     0,     0,     0,     0,   765,     0,
       0,     0,     0,     0,   200,   201,   202,   203,   204,   205,
     206,   207,     0,   209,   210,   211,     0,     0,     0,     0,
     212,     0,     0,     0,   213,   214,     0,   215,   216,     0,
     217,   218,   219,   220,   221,     0,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
     233,     0,   234,   898,   236,   237,   238,     0,     0,     0,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,     0,   251,   252,     0,     0,
       0,     0,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   899,     0,   291,   292,   293,     0,   294,     0,   295,
       0,     0,     0,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   900,     0,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,     0,     0,   326,     0,   327,   328,   329,   330,
     331,   332,   333,     0,   334,   335,     0,   336,     0,     0,
     337,   338,   339,     0,     0,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,     0,   360,
     361,   362,   363,   364,   365,     0,   366,     0,     0,   367,
     368,   369,     0,     0,   370,     0,     0,     0,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,     0,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,     0,
     426,   427,   428,   429,     0,   430,   431,   432,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   444,   445,     0,   446,   447,   448,   449,   450,   451,
       0,   452,   453,     0,     0,   454,   455,   456,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,     0,   465,
     466,   467,   468,   469,     0,     0,   470,   471,   472,   473,
     474,   475,   476,     0,   477,     0,   478,   479,   480,     0,
       0,   481,     0,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,     0,     0,     0,   768,   769,   770,     0,   771,   772,
     773,   774,   775,   776,   199,     0,     0,     0,     0,   765,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,   212,     0,     0,     0,   213,   214,     0,   215,   216,
       0,   217,   218,   219,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,     0,   229,   230,   231,
     232,   233,     0,   234,  1317,   236,   237,   238,     0,     0,
       0,   239,   240,   241,   242,     0,   243,   244,     0,   245,
     246,   247,   248,   249,   250,     0,     0,   251,   252,     0,
       0,     0,     0,     0,     0,     0,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   262,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,     0,   279,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,     0,  1318,     0,   291,   292,   293,     0,   294,     0,
     295,     0,     0,     0,   296,   297,   298,     0,   299,   300,
       0,   301,     0,   302,   303,   304,   305,   306,     0,   307,
     308,   309,     0,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,     0,     0,   326,     0,   327,   328,   329,
     330,   331,   332,   333,     0,   334,   335,     0,   336,     0,
       0,   337,   338,   339,     0,     0,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,     0,   359,     0,
     360,   361,   362,   363,   364,   365,     0,   366,     0,     0,
     367,   368,   369,     0,     0,   370,     0,     0,     0,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,   383,   384,   385,     0,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,     0,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,     0,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
       0,   426,   427,   428,   429,     0,   430,   431,   432,     0,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,     0,   444,   445,     0,   446,   447,   448,   449,   450,
     451,     0,   452,   453,     0,     0,   454,   455,   456,   457,
       0,   458,   459,   460,   461,   462,   463,   464,     0,     0,
     465,   466,   467,   468,   469,     0,     0,   470,   471,   472,
     473,   474,   475,   476,     0,   477,     0,   478,   479,   480,
       0,     0,   481,     0,     0,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,     0,     0,     0,   768,   769,   770,     0,   771,
     772,   773,   774,   775,   776,   199,     0,     0,     0,     0,
     765,     0,     0,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,   212,     0,     0,     0,   213,   214,     0,   215,
     216,     0,   217,   218,   219,   220,   221,     0,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,     0,
       0,     0,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,     0,   251,   252,
       0,     0,     0,     0,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,     0,     0,     0,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,     0,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,     0,     0,   326,     0,   327,   328,
     329,   330,   331,   332,   333,     0,   334,   335,     0,   336,
       0,     0,   337,   338,   339,     0,     0,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
       0,   353,   354,   355,   356,     0,   357,   358,     0,   359,
       0,   360,   361,   362,   363,   364,   365,     0,   366,     0,
       0,   367,   368,   369,     0,     0,   370,     0,     0,     0,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,     0,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,     0,   426,   427,   428,   429,     0,   430,   431,   432,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   449,
     450,   451,     0,   452,   453,     0,     0,   454,   455,   456,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
       0,   465,   466,   467,   468,   469,     0,     0,   470,   471,
     472,   473,   474,   475,   476,     0,   477,     0,   478,   479,
     480,     0,     0,   481,     0,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,     0,     0,     0,   768,   769,   770,     0,
     771,   772,   773,   774,   775,   776,   199,     0,     0,     0,
       0,   765,     0,     0,     0,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,   212,     0,     0,     0,   213,   214,     0,
     215,   216,     0,   217,   218,   219,   220,   221,     0,   222,
     223,     0,   224,   225,   226,   227,   228,     0,     0,   229,
     230,   231,   232,   233,     0,   234,  2473,   236,   237,   238,
       0,     0,     0,   239,   240,   241,   242,     0,   243,   244,
       0,   245,   246,   247,   248,   249,   250,     0,     0,   251,
     252,     0,     0,     0,     0,     0,     0,     0,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   262,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
       0,   279,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,  2474,     0,   291,   292,   293,     0,
     294,     0,   295,     0,     0,     0,   296,   297,   298,     0,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,     0,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,     0,     0,   326,     0,   327,
     328,   329,   330,   331,   332,   333,     0,   334,   335,     0,
     336,     0,     0,   337,   338,   339,     0,     0,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,     0,   353,   354,   355,   356,     0,   357,   358,     0,
     359,     0,   360,   361,   362,   363,   364,   365,     0,   366,
       0,     0,   367,   368,   369,     0,     0,   370,     0,     0,
       0,   371,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,   383,   384,   385,     0,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
       0,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,     0,   408,   409,     0,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,     0,   421,   422,   423,
     424,   425,     0,   426,   427,   428,   429,     0,   430,   431,
     432,     0,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,     0,   444,   445,     0,   446,   447,   448,
     449,   450,   451,     0,   452,   453,     0,     0,   454,   455,
     456,   457,     0,   458,   459,   460,   461,   462,   463,   464,
       0,     0,   465,   466,   467,   468,   469,     0,     0,   470,
     471,   472,   473,   474,   475,   476,     0,   477,     0,   478,
     479,   480,     0,     0,   481,     0,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,     0,     0,     0,   768,   769,   770,
       0,   771,   772,   773,   774,   775,   776,   199,     0,     0,
       0,     0,   765,     0,     0,     0,     0,     0,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,   212,     0,     0,     0,   213,   214,
       0,   215,   216,     0,   217,   218,   219,   220,   221,     0,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,   233,     0,   234,   235,   236,   237,
     238,     0,     0,     0,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,     0,
     251,   252,     0,     0,     0,     0,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,     0,     0,     0,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,     0,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,     0,     0,   326,     0,
     327,   328,   329,   330,   331,   332,   333,     0,   334,   335,
       0,   336,     0,     0,   337,   338,   339,     0,     0,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,     0,   360,   361,   362,   363,   364,   365,     0,
     366,     0,     0,  3982,   368,   369,     0,     0,   370,     0,
       0,     0,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,     0,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,     0,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,     0,   426,   427,   428,   429,     0,   430,
     431,   432,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,     0,   444,   445,     0,   446,   447,
     448,   449,   450,   451,     0,   452,   453,     0,     0,   454,
     455,   456,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,     0,   465,   466,   467,   468,   469,     0,     0,
     470,   471,   472,   473,   474,   475,   476,     0,   477,     0,
     478,   479,   480,     0,     0,   481,     0,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,     0,     0,  1669,   768,   769,
     770,     0,   771,   772,   773,   774,   775,   776,   200,   201,
     202,   203,   204,   205,   206,   207,  1670,   209,   210,   211,
    1671,  1672,  1673,  1674,   212,  1675,  1676,  1677,   213,   214,
    1678,   215,   216,   714,   217,   218,   219,   220,   221,   715,
     222,   223,  1679,   224,   225,   226,   227,   228,  1680,  1681,
     229,   230,   231,   232,   233,  1682,   234,   235,   236,   237,
     238,  1683,   716,  1684,   239,   240,   241,   242,   717,   243,
     244,  1685,   245,   246,   247,   248,   249,   250,  1686,   718,
     251,   252,  1687,  1688,  1689,   719,  1690,  1691,  1692,   253,
     254,   255,   256,   257,   258,   259,   260,   261,  1693,   262,
    1694,   263,   264,   265,   266,   267,  1695,   268,   269,   270,
    1696,  1697,   271,   272,   273,   274,   275,  1698,   276,   277,
     278,  1699,   279,   280,  1700,   281,   282,   283,   284,   285,
     286,   287,   288,   289,  1701,   290,  1702,   291,   292,   293,
    1703,   294,  1704,   295,   720,  1705,   721,   296,   297,   298,
    1706,   299,   300,  1707,   301,  1708,   302,   303,   304,   305,
     306,   722,   307,   308,   309,  1709,   310,   311,   312,   313,
     314,   315,  1710,   316,   723,   317,   318,   319,   320,   321,
     322,   323,  1711,   324,  1712,   325,   724,   725,   326,   726,
     327,   328,   329,   330,   331,   332,   333,  1713,   334,   335,
     727,   336,   728,  1714,   337,   338,   339,  1715,  1716,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   729,   353,   354,   355,   356,  1717,   357,   358,
     730,   359,  1718,   360,   361,   362,   363,   364,   365,  1719,
     366,  1720,  1721,   367,   368,   369,  1722,  1723,   370,   731,
     732,   733,   371,   372,   373,   374,   375,   376,   377,   378,
    1724,   379,   380,   381,   382,   383,   384,   385,  1725,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,  1726,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,  1727,   408,   409,   734,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,  1728,   421,   422,
     423,   424,   425,  1729,   426,   427,   428,   429,   735,   430,
     431,   432,  1730,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,  1731,   444,   445,  1732,   446,   447,
     448,   449,   450,   451,  1733,   452,   453,  1734,  1735,   454,
     455,   456,   457,  1736,   458,   459,   460,   461,   462,   463,
     464,  1737,  1738,   465,   466,   467,   468,   469,  1739,  1740,
     470,   471,   472,   473,   474,   475,   476,  1741,   477,   736,
     478,   479,   480,  1742,  1743,   481,  1744,  1745,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   199,     0,     0,     0,     0,
       0,     0,     0,     0,  1746,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,   212,     0,     0,     0,   213,   214,     0,   215,
     216,     0,   217,   218,   219,   220,   221,     0,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,     0,
       0,     0,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,     0,   251,   252,
       0,     0,     0,     0,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,     0,     0,     0,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,     0,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,     0,     0,   326,     0,   327,   328,
     329,   330,   331,   332,   333,     0,   334,   335,     0,   336,
       0,     0,   337,   338,   339,     0,     0,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
       0,   353,   354,   355,   356,     0,   357,   358,     0,   359,
       0,   360,   361,   362,   363,   364,   365,     0,   366,     0,
       0,   367,   368,   369,     0,     0,   370,     0,     0,     0,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,     0,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,     0,   426,   427,   428,   429,     0,   430,   431,   432,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   449,
     450,   451,     0,   452,   453,     0,     0,   454,   455,   456,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
       0,   465,   466,   467,   468,   469,     0,     0,   470,   471,
     472,   473,   474,   475,   476,     0,   477,     0,   478,   479,
     480,     0,     0,   481,     0,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   199,     0,     0,     0,     0,     0,     0,
       0,     0,   683,     0,   200,   201,   202,   203,   204,   205,
     206,   207,     0,   209,   210,   211,     0,     0,     0,     0,
     212,     0,     0,     0,   213,   214,     0,   215,   216,     0,
     217,   218,   219,   220,   221,     0,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
     233,     0,   234,   235,   236,   237,   238,     0,     0,     0,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,     0,   251,   252,     0,     0,
       0,     0,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,     0,   295,
       0,     0,     0,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,     0,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,     0,     0,   326,     0,   327,   328,   329,   330,
     331,   332,   333,     0,   334,   335,     0,   336,     0,     0,
     337,   338,   339,     0,     0,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,     0,   360,
     361,   362,   363,   364,   365,     0,   366,     0,     0,   367,
     368,   369,     0,     0,   370,     0,     0,     0,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,     0,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,     0,
     426,   427,   428,   429,     0,   430,   431,   432,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   444,   445,     0,   446,   447,   448,   449,   450,   451,
       0,   452,   453,     0,     0,   454,   455,   456,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,     0,   465,
     466,   467,   468,   469,     0,     0,   470,   471,   472,   473,
     474,   475,   476,     0,   477,     0,   478,   479,   480,     0,
       0,   481,     0,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,  1334,     0,     0,     0,     0,     0,     0,     0,     0,
    3861,     0,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,   212,     0,
       0,     0,   213,   214,     0,   215,   216,   714,   217,   218,
     219,     0,  1335,   715,  1336,  1337,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,  1338,  1339,   233,     0,
     234,   235,   236,   237,     0,     0,   716,     0,   239,   240,
     241,   242,   717,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,   718,   251,   252,     0,     0,     0,   719,
       0,     0,     0,   253,   254,   255,   256,   257,   258,  1340,
    1341,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,  1009,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,     0,   286,   287,   288,     0,     0,   290,
       0,   291,  1342,   293,     0,   294,     0,   295,   720,     0,
     721,   296,   297,   298,     0,   299,     0,     0,   301,     0,
     302,   303,   304,   305,   306,   722,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,   723,     0,
     318,   319,   320,   321,  1343,  1344,     0,  1345,     0,   325,
     724,   725,   326,   726,   327,   328,   329,   330,   331,   332,
     333,     0,   334,     0,   727,   336,   728,     0,   337,   338,
     339,     0,     0,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,  1346,   729,  1347,   354,   355,
       0,     0,   357,   358,   730,   359,     0,     0,   361,  1348,
     363,   364,   365,     0,   366,     0,     0,   367,   368,   369,
       0,     0,     0,   731,   732,   733,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,     0,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
    1349,   394,   395,   396,   397,     0,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,   734,
     410,   411,     0,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,     0,   426,  1350,
     428,   429,   735,   430,  1351,   432,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,     0,     0,   444,
     445,     0,   446,   447,   448,   449,   450,   451,     0,  1352,
    1353,     0,     0,   454,     0,   456,     0,     0,   458,   459,
     460,   461,   462,   463,   464,     0,     0,   465,   466,   467,
     468,   469,     0,     0,   470,   471,   472,   473,   474,     0,
    1354,     0,   477,   736,   478,   479,   480,     0,     0,   481,
       0,     0,   482,   483,   484,   485,   486,     0,     0,  2030,
       0,     0,     0,     0,     0,     0,   496,   497,   498,     0,
     200,   201,   202,   203,   204,   205,   206,   207,  1801,   209,
     210,   211,     0,     0,     0,     0,   212,     0,     0,     0,
     213,   214,     0,   215,   216,   714,   217,   218,   219,     0,
    1335,   715,  1336,  1337,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,  1338,  1339,   233,     0,   234,   235,
     236,   237,     0,     0,   716,     0,   239,   240,   241,   242,
     717,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,   718,   251,   252,     0,     0,     0,   719,     0,     0,
       0,   253,   254,   255,   256,   257,   258,  1340,  1341,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,  1009,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,     0,   286,   287,   288,     0,     0,   290,     0,   291,
    1342,   293,     0,   294,     0,   295,   720,     0,   721,   296,
     297,   298,     0,   299,     0,     0,   301,     0,   302,   303,
     304,   305,   306,   722,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,   723,     0,   318,   319,
     320,   321,  1343,  1344,     0,  1345,     0,   325,   724,   725,
     326,   726,   327,   328,   329,   330,   331,   332,   333,     0,
     334,     0,   727,   336,   728,     0,   337,   338,   339,     0,
       0,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,  1346,   729,  1347,   354,   355,     0,     0,
     357,   358,   730,   359,     0,     0,   361,  1348,   363,   364,
     365,     0,   366,     0,     0,   367,   368,   369,     0,     0,
       0,   731,   732,   733,     0,   372,   373,   374,   375,   376,
     377,   378,     0,   379,     0,   381,     0,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,  1349,   394,
     395,   396,   397,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,   734,   410,   411,
       0,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,     0,   426,  1350,   428,   429,
     735,   430,  1351,   432,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,     0,     0,   444,   445,     0,
     446,   447,   448,   449,   450,   451,     0,  1352,  1353,     0,
       0,   454,     0,   456,     0,     0,   458,   459,   460,   461,
     462,   463,   464,     0,     0,   465,   466,   467,   468,   469,
       0,     0,   470,   471,   472,   473,   474,     0,  1354,     0,
     477,   736,   478,   479,   480,     0,     0,   481,     0,     0,
     482,   483,   484,   485,   486,     0,     0,   756,  1235,   551,
       0,     0,     0,   598,   496,   497,   498,     0,   200,   201,
     202,   203,   204,   205,   206,   207,  1801,   209,   210,   211,
       0,     0,     0,     0,   212,     0,     0,     0,   213,   214,
       0,   215,   216,   714,   217,   218,   219,   220,   221,   715,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,   233,     0,   234,   235,   236,   237,
     238,     0,   716,     0,   239,   240,   241,   242,   717,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,   718,
     251,   252,     0,     0,     0,   719,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,  1659,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,  1468,   290,     0,   291,   292,   293,
       0,   294,     0,   295,   720,     0,   721,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   722,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,   723,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,   724,   725,   326,   726,
     327,   328,   329,   330,   331,   332,   333,     0,   334,   335,
     727,   336,   728,     0,   337,   338,   339,     0,     0,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   729,   353,   354,   355,   356,     0,   357,   358,
     730,   359,     0,   360,   361,   362,   363,   364,   365,     0,
     366,  1469,     0,   367,   368,   369,     0,     0,   370,   731,
     732,   733,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,     0,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,   734,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,     0,   426,   427,   428,   429,   735,   430,
     431,   432,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,     0,   444,   445,     0,   446,   447,
     448,   449,   450,   451,     0,   452,   453,     0,     0,   454,
     455,   456,   457,  1470,   458,   459,   460,   461,   462,   463,
     464,     0,     0,   465,   466,   467,   468,   469,     0,     0,
     470,   471,   472,   473,   474,   475,   476,     0,   477,   736,
     478,   479,   480,     0,     0,   481,     0,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   756,  1235,   551,     0,     0,
       0,   598,   610,  1236,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,   212,     0,     0,     0,   213,   214,     0,   215,
     216,   714,   217,   218,   219,   220,   221,   715,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,     0,
     716,     0,   239,   240,   241,   242,   717,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,   718,   251,   252,
       0,     0,     0,   719,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,  1664,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,  1468,   290,     0,   291,   292,   293,     0,   294,
       0,   295,   720,     0,   721,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   722,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,   723,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,   724,   725,   326,   726,   327,   328,
     329,   330,   331,   332,   333,     0,   334,   335,   727,   336,
     728,     0,   337,   338,   339,     0,     0,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     729,   353,   354,   355,   356,     0,   357,   358,   730,   359,
       0,   360,   361,   362,   363,   364,   365,     0,   366,  1469,
       0,   367,   368,   369,     0,     0,   370,   731,   732,   733,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   734,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,     0,   426,   427,   428,   429,   735,   430,   431,   432,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   449,
     450,   451,     0,   452,   453,     0,     0,   454,   455,   456,
     457,  1470,   458,   459,   460,   461,   462,   463,   464,     0,
       0,   465,   466,   467,   468,   469,     0,     0,   470,   471,
     472,   473,   474,   475,   476,     0,   477,   736,   478,   479,
     480,     0,     0,   481,     0,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   756,  1235,   551,     0,     0,     0,   598,
     610,  1236,     0,     0,   200,   201,   202,   203,   204,   205,
     206,   207,     0,   209,   210,   211,     0,     0,     0,     0,
     212,     0,     0,     0,   213,   214,     0,   215,   216,   714,
     217,   218,   219,   220,   221,   715,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
     233,     0,   234,   235,   236,   237,   238,     0,   716,     0,
     239,   240,   241,   242,   717,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,   718,   251,   252,     0,     0,
       0,   719,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
    1468,   290,     0,   291,   292,   293,     0,   294,     0,   295,
     720,     0,   721,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   722,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
     723,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,   724,   725,   326,   726,   327,   328,   329,   330,
     331,   332,   333,     0,   334,   335,   727,   336,   728,     0,
     337,   338,   339,     0,     0,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   729,   353,
     354,   355,   356,     0,   357,   358,   730,   359,     0,   360,
     361,   362,   363,   364,   365,     0,   366,  1469,     0,   367,
     368,   369,     0,     0,   370,   731,   732,   733,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,   734,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,     0,
     426,   427,   428,   429,   735,   430,   431,   432,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   444,   445,     0,   446,   447,   448,   449,   450,   451,
       0,   452,   453,     0,     0,   454,   455,   456,   457,  1470,
     458,   459,   460,   461,   462,   463,   464,     0,     0,   465,
     466,   467,   468,   469,     0,     0,   470,   471,   472,   473,
     474,   475,   476,     0,   477,   736,   478,   479,   480,     0,
       0,   481,     0,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   199,     0,     0,     0,     0,     0,   598,   610,  1236,
       0,     0,   200,   599,   202,   203,   204,   205,   206,   207,
     600,   209,   210,   211,     0,     0,     0,     0,   212,     0,
       0,     0,   213,   214,     0,   215,   216,     0,   601,   218,
     219,   220,   221,     0,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,   233,     0,
     234,   235,   236,   237,   238,     0,     0,     0,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,     0,   251,   252,     0,     0,     0,     0,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   602,   292,   293,     0,   294,     0,   603,     0,   604,
       0,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,     0,   307,   308,   309,   605,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
       0,     0,   326,     0,   327,   328,   329,   330,   606,   332,
     333,     0,   334,   335,     0,   336,     0,     0,   337,   338,
     339,     0,     0,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,     0,   353,   607,   355,
     356,     0,   357,   358,     0,   359,     0,   360,   361,   362,
     363,   364,   365,     0,   366,     0,     0,   367,   368,   369,
       0,     0,   370,     0,     0,     0,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,     0,   608,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,     0,   398,   609,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,     0,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,     0,   426,   427,
     428,   429,     0,   430,   431,   432,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,     0,   444,
     445,     0,   446,   447,   448,   449,   450,   451,     0,   452,
     453,     0,     0,   454,   455,   456,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,     0,   465,   466,   467,
     468,   469,     0,     0,   470,   471,   472,   473,   474,   475,
     476,     0,   477,     0,   478,   479,   480,     0,     0,   481,
       0,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,  1669,
    4273,   551,     0,     0,     0,   598,   610,   611,     0,     0,
     200,   201,   202,   203,   204,   205,   206,   207,  1670,   209,
     210,   211,  1671,  1672,  1673,  1674,   212,  1675,  1676,  1677,
     213,   214,  1678,   215,   216,   714,   217,   218,   219,   220,
     221,   715,   222,   223,  1679,   224,   225,   226,   227,   228,
    1680,  1681,   229,   230,   231,   232,   233,  1682,   234,   235,
     236,   237,   238,  1683,   716,  1684,   239,   240,   241,   242,
     717,   243,   244,  1685,   245,   246,   247,   248,   249,   250,
    1686,   718,   251,   252,  1687,  1688,  1689,   719,  1690,  1691,
    1692,   253,   254,   255,   256,   257,   258,   259,   260,   261,
    1693,   262,  1694,   263,   264,   265,   266,   267,  1695,   268,
     269,   270,  1696,  1697,   271,   272,   273,   274,   275,  1698,
     276,   277,   278,  1699,   279,   280,  1700,   281,   282,   283,
     284,   285,   286,   287,   288,   289,  1701,   290,  1702,   291,
     292,   293,  1703,   294,  1704,   295,   720,  1705,   721,   296,
     297,   298,  1706,   299,   300,  1707,   301,  1708,   302,   303,
     304,   305,   306,   722,   307,   308,   309,  1709,   310,   311,
     312,   313,   314,   315,  1710,   316,   723,   317,   318,   319,
     320,   321,   322,   323,  1711,   324,  1712,   325,   724,   725,
     326,   726,   327,   328,   329,   330,   331,   332,   333,  1713,
     334,   335,   727,   336,   728,  1714,   337,   338,   339,  1715,
    1716,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   729,   353,   354,   355,   356,  1717,
     357,   358,   730,   359,  1718,   360,   361,   362,   363,   364,
     365,  1719,   366,  1720,  1721,   367,   368,   369,  1722,  1723,
     370,   731,   732,   733,   371,   372,   373,   374,   375,   376,
     377,   378,  1724,   379,   380,   381,   382,   383,   384,   385,
    1725,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,  1726,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,  1727,   408,   409,   734,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,  1728,
     421,   422,   423,   424,   425,  1729,   426,   427,   428,   429,
     735,   430,   431,   432,  1730,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,  1731,   444,   445,  1732,
     446,   447,   448,   449,   450,   451,  1733,   452,   453,  1734,
    1735,   454,   455,   456,   457,  1736,   458,   459,   460,   461,
     462,   463,   464,  1737,  1738,   465,   466,   467,   468,   469,
    1739,  1740,   470,   471,   472,   473,   474,   475,   476,  1741,
     477,   736,   478,   479,   480,  1742,  1743,   481,  1744,  1745,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,  1669,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,   201,
     202,   203,   204,   205,   206,   207,  1670,   209,   210,   211,
    1671,  1672,  1673,  1674,   212,  1675,  1676,  1677,   213,   214,
    1678,   215,   216,   714,   217,   218,   219,   220,   221,   715,
     222,   223,  1679,   224,   225,   226,   227,   228,  1680,  1681,
     229,   230,   231,   232,   233,  1682,   234,   235,   236,   237,
     238,  1683,   716,  1684,   239,   240,   241,   242,   717,   243,
     244,  1685,   245,   246,   247,   248,   249,   250,  1686,   718,
     251,   252,  1687,  1688,  1689,   719,  1690,  1691,  1692,   253,
     254,   255,   256,   257,   258,   259,   260,   261,  1693,   262,
    1694,   263,   264,   265,   266,   267,  1695,   268,   269,   270,
    1696,  1697,   271,   272,   273,   274,   275,  1698,   276,   277,
     278,  1699,   279,   280,  1700,   281,   282,   283,   284,   285,
     286,   287,   288,   289,  1701,   290,  1702,   291,   292,   293,
    1703,   294,  1704,   295,   720,  1705,   721,   296,   297,   298,
    1706,   299,   300,  1707,   301,  1708,   302,   303,   304,   305,
     306,   722,   307,   308,   309,  1709,   310,   311,   312,   313,
     314,   315,  1710,   316,   723,   317,   318,   319,   320,   321,
     322,   323,  1711,   324,  1712,   325,   724,   725,   326,   726,
     327,   328,   329,   330,   331,   332,   333,  1713,   334,   335,
     727,   336,   728,  1714,   337,   338,   339,  1715,  1716,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   729,   353,   354,   355,   356,  1717,   357,   358,
     730,   359,  1718,   360,   361,   362,   363,   364,   365,  1719,
     366,  1720,  1721,   367,   368,   369,  1722,  1723,   370,   731,
     732,   733,   371,   372,   373,   374,   375,   376,   377,   378,
    1724,   379,   380,   381,   382,   383,   384,   385,  1725,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,  1726,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,  1727,   408,   409,   734,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,  1728,   421,   422,
     423,   424,   425,  1729,   426,   427,   428,   429,   735,   430,
     431,   432,  1730,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,  1731,   444,   445,  1732,   446,   447,
     448,   449,   450,   451,  1733,   452,   453,  1734,  1735,   454,
     455,   456,   457,  1736,   458,   459,   460,   461,   462,   463,
     464,  1737,  1738,   465,   466,   467,   468,   469,  1739,  1740,
     470,   471,   472,   473,   474,   475,   476,  1741,   477,   736,
     478,   479,   480,  1742,  1743,   481,  1744,  1745,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,  1669,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   200,   201,   202,   203,
    2538,   205,   206,   207,  1670,   209,   210,   211,  1671,  1672,
    1673,  1674,   212,  1675,  1676,  1677,   213,   214,  1678,   215,
     216,   714,   217,   218,   219,   220,   221,   715,   222,   223,
    1679,   224,   225,   226,   227,   228,  1680,  1681,   229,   230,
     231,   232,   233,  1682,   234,   235,   236,   237,   238,  1683,
     716,  1684,   239,   240,   241,   242,   717,   243,   244,  1685,
     245,   246,   247,   248,   249,   250,  1686,   718,   251,   252,
    1687,  1688,  1689,   719,  1690,  1691,  1692,   253,   254,   255,
     256,   257,   258,   259,   260,   261,  1693,   262,  1694,   263,
     264,   265,   266,   267,  1695,   268,   269,   270,  1696,  1697,
     271,   272,   273,  2539,   275,  1698,   276,   277,   278,  1699,
     279,   280,  1700,   281,   282,   283,   284,   285,   286,   287,
     288,   289,  1701,   290,  1702,   291,   292,   293,  1703,   294,
    1704,   295,   720,  1705,   721,   296,   297,   298,  1706,   299,
     300,  1707,   301,  1708,   302,   303,   304,   305,   306,   722,
     307,   308,   309,  1709,   310,   311,   312,   313,   314,   315,
    1710,   316,   723,   317,   318,   319,   320,   321,   322,   323,
    1711,   324,  1712,   325,   724,   725,   326,   726,   327,   328,
     329,   330,   331,   332,   333,  1713,   334,   335,   727,   336,
     728,  1714,   337,   338,   339,  1715,  1716,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     729,   353,   354,   355,   356,  1717,   357,   358,   730,   359,
    1718,   360,   361,   362,   363,   364,   365,  1719,   366,  1720,
    1721,   367,   368,   369,  1722,  1723,   370,   731,   732,   733,
     371,   372,   373,   374,   375,   376,   377,   378,  1724,   379,
     380,   381,   382,   383,   384,   385,  1725,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,  1726,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
    1727,   408,   409,   734,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,  1728,   421,   422,   423,   424,
     425,  1729,  2540,   427,   428,   429,   735,   430,   431,   432,
    1730,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,  1731,   444,   445,  1732,   446,   447,   448,   449,
     450,   451,  1733,   452,   453,  1734,  1735,   454,   455,   456,
     457,  1736,   458,   459,   460,   461,   462,   463,   464,  1737,
    1738,   465,   466,   467,   468,   469,  1739,  1740,   470,   471,
     472,   473,   474,   475,   476,  1741,   477,   736,   478,   479,
     480,  1742,  1743,   481,  1744,  1745,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   756,     0,   551,     0,     0,     0,     0,
       0,     0,     0,     0,   200,   201,   202,   203,   204,   205,
     206,   207,     0,   209,   210,   211,     0,     0,     0,     0,
     212,     0,     0,     0,   213,   214,     0,   215,   216,   714,
     217,   218,   219,   220,   221,   715,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
     233,     0,   234,   235,   236,   237,   238,     0,   716,     0,
     239,   240,   241,   242,   717,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,   718,   251,   252,     0,     0,
       0,   719,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
    1468,   290,     0,   291,   292,   293,     0,   294,     0,   295,
     720,     0,   721,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   722,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
     723,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,   724,   725,   326,   726,   327,   328,   329,   330,
     331,   332,   333,     0,   334,   335,   727,   336,   728,     0,
     337,   338,   339,     0,     0,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   729,   353,
     354,   355,   356,     0,   357,   358,   730,   359,     0,   360,
     361,   362,   363,   364,   365,     0,   366,  1469,     0,   367,
     368,   369,     0,     0,   370,   731,   732,   733,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,   734,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,     0,
     426,   427,   428,   429,   735,   430,   431,   432,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   444,   445,     0,   446,   447,   448,   449,   450,   451,
       0,   452,   453,     0,     0,   454,   455,   456,   457,  1470,
     458,   459,   460,   461,   462,   463,   464,     0,     0,   465,
     466,   467,   468,   469,     0,     0,   470,   471,   472,   473,
     474,   475,   476,     0,   477,   736,   478,   479,   480,     0,
       0,   481,     0,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   756,     0,   551,     0,     0,     0,     0,     0,     0,
       0,     0,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,   212,     0,
       0,     0,   213,   214,     0,   215,   216,   714,   217,   218,
     219,   220,   221,   715,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,   233,     0,
     234,   235,   236,   237,   238,     0,   716,     0,   239,   240,
     241,   242,   717,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,   718,   251,   252,     0,     0,     0,   719,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,  1644,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,     0,   295,   720,     0,
     721,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   722,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,   723,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
     724,   725,   326,   726,   327,   328,   329,   330,   331,   332,
     333,     0,   334,   335,   727,   336,   728,     0,   337,   338,
     339,     0,     0,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   729,   353,   354,   355,
     356,     0,   357,   358,   730,   359,     0,   360,   361,   362,
     363,   364,   365,     0,   366,     0,     0,   367,   368,   369,
       0,     0,   370,   731,   732,   733,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,     0,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,   734,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,     0,   426,   427,
     428,   429,   735,   430,   431,   432,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,     0,   444,
     445,     0,   446,   447,   448,   449,   450,   451,     0,   452,
     453,     0,     0,   454,   455,   456,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,     0,   465,   466,   467,
     468,   469,     0,     0,   470,   471,   472,   473,   474,   475,
     476,     0,   477,   736,   478,   479,   480,     0,     0,   481,
       0,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   756,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     200,   201,   202,   203,   204,   205,   206,   207,     0,   209,
     210,   211,     0,     0,     0,     0,   212,     0,     0,     0,
     213,   214,     0,   215,   216,   714,   217,   218,   219,   220,
     221,   715,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,   233,     0,   234,   235,
     236,   237,   238,     0,   716,     0,   239,   240,   241,   242,
     717,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,   718,   251,   252,     0,     0,     0,   719,     0,     0,
    1990,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,     0,   295,   720,     0,   721,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   722,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,   723,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,   724,   725,
     326,   726,   327,   328,   329,   330,   331,   332,   333,     0,
     334,   335,   727,   336,   728,     0,   337,   338,   339,     0,
       0,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   729,   353,   354,   355,   356,     0,
     357,   358,   730,   359,     0,   360,   361,   362,   363,   364,
     365,     0,   366,     0,     0,   367,   368,   369,     0,     0,
     370,   731,   732,   733,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,   734,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,     0,   426,   427,   428,   429,
     735,   430,   431,   432,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,     0,   444,   445,     0,
     446,   447,   448,   449,   450,   451,     0,   452,   453,     0,
       0,   454,   455,   456,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,     0,   465,   466,   467,   468,   469,
    1991,     0,   470,   471,   472,   473,   474,   475,   476,     0,
     477,   736,   478,   479,   480,     0,     0,   481,     0,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   756,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       3,     4,     0,     0,   212,     0,     0,     0,   213,   214,
       0,   215,   216,   714,   217,   218,   219,   220,   221,   715,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,   233,     0,   234,   235,   236,   237,
     238,     0,   716,     0,   239,   240,   241,   242,   717,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,   718,
     251,   252,     0,     0,     0,   719,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,   720,     0,   721,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   722,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,   723,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,   724,   725,   326,   726,
     327,   328,   329,   330,   331,   332,   333,     0,   334,   335,
     727,   336,   728,     0,   337,   338,   339,     0,     0,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   729,   353,   354,   355,   356,     0,   357,   358,
     730,   359,     0,   360,   361,   362,   363,   364,   365,     0,
     366,     0,     0,   367,   368,   369,     0,     0,   370,   731,
     732,   733,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,     0,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,   734,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,     0,   426,   427,   428,   429,   735,   430,
     431,   432,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,     0,   444,   445,     0,   446,   447,
     448,   449,   450,   451,     0,   452,   453,     0,     0,   454,
     455,   456,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,     0,   465,   466,   467,   468,   469,     0,     0,
     470,   471,   472,   473,   474,   475,   476,     0,   477,   736,
     478,   479,   480,     0,     0,   481,     0,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   756,     0,   551,     0,     0,
       0,     0,     0,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,   212,     0,     0,     0,   213,   214,     0,   215,
     216,   714,   217,   218,   219,   220,   221,   715,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,     0,
     716,     0,   239,   240,   241,   242,   717,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,   718,   251,   252,
       0,     0,     0,   719,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,   720,     0,   721,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   722,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,   723,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,   724,   725,   326,   726,   327,   328,
     329,   330,   331,   332,   333,     0,   334,   335,   727,   336,
     728,     0,   337,   338,   339,     0,     0,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     729,   353,   354,   355,   356,     0,   357,   358,   730,   359,
       0,   360,   361,   362,   363,   364,   365,     0,   366,     0,
       0,   367,   368,   369,     0,     0,   370,   731,   732,   733,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   734,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,     0,   426,   427,   428,   429,   735,   430,   431,   432,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   449,
     450,   451,     0,   452,   453,     0,     0,   454,   455,   456,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
       0,   465,   466,   467,   468,   469,     0,     0,   470,   471,
     472,   473,   474,   475,   476,     0,   477,   736,   478,   479,
     480,     0,     0,   481,     0,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   756,     0,   551,     0,     0,     0,     0,
       0,     0,     0,     0,   200,   201,   202,   203,   204,   205,
     206,   207,     0,   209,   210,   211,     0,     0,     0,     0,
     212,     0,     0,     0,   213,   214,     0,   215,   216,   714,
     217,   218,   219,   220,   221,   715,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
     233,     0,   234,   235,   236,   237,   238,     0,   716,     0,
     239,   240,   241,   242,   717,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,   718,   251,   252,     0,     0,
       0,   719,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,     0,   295,
     720,     0,   721,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,  1458,   722,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
     723,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,   724,   725,   326,   726,   327,   328,   329,   330,
     331,   332,   333,     0,   334,   335,   727,   336,   728,     0,
     337,   338,   339,     0,     0,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   729,   353,
     354,   355,   356,     0,   357,   358,   730,   359,     0,   360,
     361,   362,   363,   364,   365,     0,   366,     0,     0,   367,
     368,   369,     0,     0,   370,   731,   732,   733,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,   734,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,     0,
     426,   427,   428,   429,   735,   430,   431,   432,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   444,   445,     0,   446,   447,   448,   449,   450,   451,
       0,   452,   453,     0,     0,   454,   455,   456,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,     0,   465,
     466,   467,   468,   469,     0,     0,   470,   471,   472,   473,
     474,   475,   476,     0,   477,   736,   478,   479,   480,     0,
       0,   481,     0,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   756,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,   212,     0,
       0,     0,   213,   214,     0,   215,   216,   714,   217,   218,
     219,   220,   221,   715,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,   233,     0,
     234,   235,   236,   237,   238,     0,   716,     0,   239,   240,
     241,   242,   717,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,   718,   251,   252,     0,     0,     0,   719,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,     0,   295,   720,     0,
     721,   296,   297,   298,     0,   299,   300,  2801,   301,     0,
     302,   303,   304,   305,   306,   722,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,   723,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
     724,   725,   326,   726,   327,   328,   329,   330,   331,   332,
     333,     0,   334,   335,   727,   336,   728,     0,   337,   338,
     339,     0,     0,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   729,   353,   354,   355,
     356,     0,   357,   358,   730,   359,     0,   360,   361,   362,
     363,   364,   365,     0,   366,     0,     0,   367,   368,   369,
       0,     0,   370,   731,   732,   733,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,     0,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,   734,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,     0,   426,   427,
     428,   429,   735,   430,   431,   432,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,     0,   444,
     445,     0,   446,   447,   448,   449,   450,   451,     0,   452,
     453,     0,     0,   454,   455,   456,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,     0,   465,   466,   467,
     468,   469,     0,     0,   470,   471,   472,   473,   474,   475,
     476,     0,   477,   736,   478,   479,   480,     0,     0,   481,
       0,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   713,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     200,   201,   202,   203,   204,   205,   206,   207,     0,   209,
     210,   211,     0,     0,     0,     0,   212,     0,     0,     0,
     213,   214,     0,   215,   216,   714,   217,   218,   219,   220,
     221,   715,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,   233,     0,   234,   235,
     236,   237,   238,     0,   716,     0,   239,   240,   241,   242,
     717,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,   718,   251,   252,     0,     0,     0,   719,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,     0,   295,   720,     0,   721,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   722,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,   723,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,   724,   725,
     326,   726,   327,   328,   329,   330,   331,   332,   333,     0,
     334,   335,   727,   336,   728,     0,   337,   338,   339,     0,
       0,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   729,   353,   354,   355,   356,     0,
     357,   358,   730,   359,     0,   360,   361,   362,   363,   364,
     365,     0,   366,     0,     0,   367,   368,   369,     0,     0,
     370,   731,   732,   733,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,   734,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,     0,   426,   427,   428,   429,
     735,   430,   431,   432,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,     0,   444,   445,     0,
     446,   447,   448,   449,   450,   451,     0,   452,   453,     0,
       0,   454,   455,   456,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,     0,   465,   466,   467,   468,   469,
       0,     0,   470,   471,   472,   473,   474,   475,   476,     0,
     477,   736,   478,   479,   480,     0,     0,   481,     0,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   756,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,   212,     0,     0,     0,   213,   214,
       0,   215,   216,   714,   217,   218,   219,   220,   221,   715,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,   233,     0,   234,   235,   236,   237,
     238,     0,   716,     0,   239,   240,   241,   242,   717,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,   718,
     251,   252,     0,     0,     0,   719,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,   720,     0,   721,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   722,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,   723,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,   724,   725,   326,   726,
     327,   328,   329,   330,   331,   332,   333,     0,   334,   335,
     727,   336,   728,     0,   337,   338,   339,     0,     0,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   729,   353,   354,   355,   356,     0,   357,   358,
     730,   359,     0,   360,   361,   362,   363,   364,   365,     0,
     366,     0,     0,   367,   368,   369,     0,     0,   370,   731,
     732,   733,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,     0,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,   734,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,     0,   426,   427,   428,   429,   735,   430,
     431,   432,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,     0,   444,   445,     0,   446,   447,
     448,   449,   450,   451,     0,   452,   453,     0,     0,   454,
     455,   456,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,     0,   465,   466,   467,   468,   469,     0,     0,
     470,   471,   472,   473,   474,   475,   476,     0,   477,   736,
     478,   479,   480,     0,     0,   481,     0,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   756,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,   212,     0,     0,     0,   213,   214,     0,   215,
     216,   714,   217,   218,   219,   220,   221,   715,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,     0,
     716,     0,   239,   240,   241,   242,   717,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,   718,   251,   252,
       0,     0,     0,   719,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,   720,     0,   721,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   722,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,   723,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,   724,   725,   326,   726,   327,   328,
     329,   330,   331,   332,   333,     0,   334,   335,   727,   336,
     728,     0,   337,   338,   339,     0,     0,   340,   341,   792,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     729,   353,   354,   355,   356,     0,   357,   358,   730,   359,
       0,   360,   361,   362,   363,   364,   365,     0,   366,     0,
       0,   367,   368,   369,     0,     0,   370,   731,   732,   733,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   734,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,     0,   426,   427,   428,   429,   735,   430,   431,   432,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   449,
     450,   451,     0,   452,   453,     0,     0,   454,   455,   456,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
       0,   465,   466,   467,   468,   469,     0,     0,   470,   471,
     472,   473,   474,   475,   476,     0,   477,   736,   478,   479,
     480,     0,     0,   481,     0,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   756,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   200,   201,   202,   203,   204,   205,
     206,   207,     0,   209,   210,   211,     0,     0,     0,     0,
     212,     0,     0,     0,   213,   214,     0,   215,   216,   714,
     217,   218,   219,   220,   221,   715,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
     233,     0,   234,   235,   236,   237,   238,     0,   716,     0,
     239,   240,   241,   242,   717,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,   718,   251,   252,     0,     0,
       0,   719,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,     0,   295,
     720,     0,   721,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   722,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
     723,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,   724,   725,   326,   726,   327,   328,   329,   330,
     331,   332,   333,     0,   334,   335,   727,   336,   728,     0,
     337,   338,   339,     0,     0,   340,   341,   865,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   729,   353,
     354,   355,   356,     0,   357,   358,   730,   359,     0,   360,
     361,   362,   363,   364,   365,     0,   366,     0,     0,   367,
     368,   369,     0,     0,   370,   731,   732,   733,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,   734,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,     0,
     426,   427,   428,   429,   735,   430,   431,   432,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   444,   445,     0,   446,   447,   448,   449,   450,   451,
       0,   452,   453,     0,     0,   454,   455,   456,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,     0,   465,
     466,   467,   468,   469,     0,     0,   470,   471,   472,   473,
     474,   475,   476,     0,   477,   736,   478,   479,   480,     0,
       0,   481,     0,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   713,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,   212,     0,
       0,     0,   213,   214,     0,   215,   216,   714,   217,   218,
     219,   220,   221,   715,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,   233,     0,
     234,   235,   236,   237,   238,     0,   716,     0,   239,   240,
     241,   242,   717,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,   718,   251,   252,     0,     0,     0,   719,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,     0,   295,   720,     0,
     721,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   883,   722,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,   723,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
     724,   725,   326,   726,   327,   328,   329,   330,   331,   332,
     333,     0,   334,   335,   727,   336,   728,     0,   337,   338,
     339,     0,     0,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   729,   353,   354,   355,
     356,     0,   357,   358,   730,   359,     0,   360,   361,   362,
     363,   364,   365,     0,   366,     0,     0,   367,   368,   369,
       0,     0,   370,   731,   732,   733,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,     0,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,   734,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,     0,   426,   427,
     428,   429,   735,   430,   431,   432,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,     0,   444,
     445,     0,   446,   447,   448,   449,   450,   451,     0,   452,
     453,     0,     0,   454,   455,   456,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,     0,   465,   466,   467,
     468,   469,     0,     0,   470,   471,   472,   473,   474,   475,
     476,     0,   477,   736,   478,   479,   480,     0,     0,   481,
       0,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   713,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     200,   201,   202,   203,   204,   205,   206,   207,     0,   209,
     210,   211,     0,     0,     0,     0,   212,     0,     0,     0,
     213,   214,     0,   215,   216,   714,   217,   218,   219,   220,
     221,   715,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,   233,     0,   234,   235,
     236,   237,   238,     0,   716,     0,   239,   240,   241,   242,
     717,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,   718,   251,   252,     0,     0,     0,   719,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,     0,   295,   720,     0,   721,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   892,   722,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,   723,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,   724,   725,
     326,   726,   327,   328,   329,   330,   331,   332,   333,     0,
     334,   335,   727,   336,   728,     0,   337,   338,   339,     0,
       0,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   729,   353,   354,   355,   356,     0,
     357,   358,   730,   359,     0,   360,   361,   362,   363,   364,
     365,     0,   366,     0,     0,   367,   368,   369,     0,     0,
     370,   731,   732,   733,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,   734,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,     0,   426,   427,   428,   429,
     735,   430,   431,   432,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,     0,   444,   445,     0,
     446,   447,   448,   449,   450,   451,     0,   452,   453,     0,
       0,   454,   455,   456,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,     0,   465,   466,   467,   468,   469,
       0,     0,   470,   471,   472,   473,   474,   475,   476,     0,
     477,   736,   478,   479,   480,     0,     0,   481,     0,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   756,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,   212,     0,     0,     0,   213,   214,
       0,   215,   216,   714,   217,   218,   219,   220,   221,   715,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,   233,     0,   234,   235,   236,   237,
     238,     0,   716,     0,   239,   240,   241,   242,   717,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,   718,
     251,   252,     0,     0,     0,   719,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,   720,     0,   721,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     894,   722,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,   723,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,   724,   725,   326,   726,
     327,   328,   329,   330,   331,   332,   333,     0,   334,   335,
     727,   336,   728,     0,   337,   338,   339,     0,     0,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   729,   353,   354,   355,   356,     0,   357,   358,
     730,   359,     0,   360,   361,   362,   363,   364,   365,     0,
     366,     0,     0,   367,   368,   369,     0,     0,   370,   731,
     732,   733,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,     0,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,   734,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,     0,   426,   427,   428,   429,   735,   430,
     431,   432,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,     0,   444,   445,     0,   446,   447,
     448,   449,   450,   451,     0,   452,   453,     0,     0,   454,
     455,   456,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,     0,   465,   466,   467,   468,   469,     0,     0,
     470,   471,   472,   473,   474,   475,   476,     0,   477,   736,
     478,   479,   480,     0,     0,   481,     0,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   756,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,   212,     0,     0,     0,   213,   214,     0,   215,
     216,   714,   217,   218,   219,   220,   221,   715,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,     0,
     716,     0,   239,   240,   241,   242,   717,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,   718,   251,   252,
       0,     0,     0,   719,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,   720,     0,   721,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   903,   722,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,   723,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,   724,   725,   326,   726,   327,   328,
     329,   330,   331,   332,   333,     0,   334,   335,   727,   336,
     728,     0,   337,   338,   339,     0,     0,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     729,   353,   354,   355,   356,     0,   357,   358,   730,   359,
       0,   360,   361,   362,   363,   364,   365,     0,   366,     0,
       0,   367,   368,   369,     0,     0,   370,   731,   732,   733,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   734,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,     0,   426,   427,   428,   429,   735,   430,   431,   432,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   449,
     450,   451,     0,   452,   453,     0,     0,   454,   455,   456,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
       0,   465,   466,   467,   468,   469,     0,     0,   470,   471,
     472,   473,   474,   475,   476,     0,   477,   736,   478,   479,
     480,     0,     0,   481,     0,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   756,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   200,   201,   202,   203,   204,   205,
     206,   207,     0,   209,   210,   211,     0,     0,     0,     0,
     212,     0,     0,     0,   213,   214,     0,   215,   216,   714,
     217,   218,   219,   220,   221,   715,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
     233,     0,   234,   235,   236,   237,   238,     0,   716,     0,
     239,   240,   241,   242,   717,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,   718,   251,   252,     0,     0,
       0,   719,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,     0,   295,
     720,     0,   721,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   914,   722,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
     723,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,   724,   725,   326,   726,   327,   328,   329,   330,
     331,   332,   333,     0,   334,   335,   727,   336,   728,     0,
     337,   338,   339,     0,     0,   340,   341,   915,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   729,   353,
     354,   355,   356,     0,   357,   358,   730,   359,     0,   360,
     361,   362,   363,   364,   365,     0,   366,     0,     0,   367,
     368,   369,     0,     0,   370,   731,   732,   733,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,   734,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,     0,
     426,   427,   428,   429,   735,   430,   431,   432,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   444,   445,     0,   446,   447,   448,   449,   450,   451,
       0,   452,   453,     0,     0,   454,   455,   456,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,     0,   465,
     466,   467,   468,   469,     0,     0,   470,   471,   472,   473,
     474,   475,   476,     0,   477,   736,   478,   479,   480,     0,
       0,   481,     0,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,   212,     0,
       0,     0,   213,   214,     0,   215,   216,     0,   217,   218,
     219,   220,   221,     0,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,   233,  1825,
     234,   235,   236,   237,   238,     0,     0,  1900,   239,   240,
     241,   242,     0,   243,   244,  1826,   245,   246,   247,   248,
     249,   250,     0,     0,   251,   252,     0,     0,     0,     0,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,  1901,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,  1828,   295,     0,     0,
       0,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,     0,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
       0,     0,   326,     0,   327,   328,   329,   330,   331,   332,
     333,     0,   334,   335,     0,   336,     0,     0,   337,   338,
     339,     0,     0,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,     0,   353,   354,   355,
     356,     0,   357,   358,     0,   359,     0,   360,   361,   362,
     363,   364,   365,     0,   366,     0,     0,   367,   368,   369,
       0,     0,   370,     0,     0,     0,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,  1829,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,     0,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,     0,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,     0,   426,   427,
     428,   429,     0,   430,   431,   432,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,     0,   444,
     445,     0,   446,   447,   448,   449,   450,   451,     0,   452,
     453,     0,     0,   454,   455,   456,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,  1830,   465,   466,   467,
     468,   469,     0,     0,   470,   471,   472,   473,   474,   475,
     476,     0,   477,     0,   478,   479,   480,     0,     0,   481,
       0,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   199,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     200,   201,   202,   203,   204,   205,   206,   207,     0,   209,
     210,   211,     0,     0,     0,     0,   212,     0,     0,     0,
     213,   214,     0,   215,   216,     0,   217,   218,   219,   220,
     221,     0,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,   233,  1825,   234,   235,
     236,   237,   238,     0,     0,     0,   239,   240,   241,   242,
       0,   243,   244,  1826,   245,   246,   247,   248,   249,   250,
       0,     0,   251,   252,     0,     0,     0,     0,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,  1901,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,  1828,   295,     0,     0,     0,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,     0,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,     0,     0,
     326,     0,   327,   328,   329,   330,   331,   332,   333,     0,
     334,   335,     0,   336,  2739,     0,   337,   338,   339,     0,
       0,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,     0,   359,     0,   360,   361,   362,   363,   364,
     365,     0,   366,     0,     0,   367,   368,   369,     0,     0,
     370,     0,     0,     0,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,   383,   384,   385,
    1829,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,     0,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,     0,   426,   427,   428,   429,
       0,   430,   431,   432,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,     0,   444,   445,     0,
     446,   447,   448,   449,   450,   451,     0,   452,   453,     0,
       0,   454,   455,   456,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,  1830,   465,   466,   467,   468,   469,
       0,     0,   470,   471,   472,   473,   474,   475,   476,     0,
     477,     0,   478,   479,   480,     0,     0,   481,     0,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,   201,
     202,   203,   204,   648,   206,   207,   617,   209,   210,   211,
       0,     0,     0,     0,   212,     0,     0,     0,   213,   214,
       0,   215,   216,     0,   217,   218,   219,   220,   221,     0,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,   233,     0,   234,   235,   236,   237,
     238,     0,     0,     0,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,   250,   618,     0,
     251,   252,     0,     0,     0,     0,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,     0,     0,     0,   296,   297,   298,
     649,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,     0,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,     0,     0,   326,     0,
     327,   328,   329,   330,   331,   332,   333,     0,   334,   335,
       0,   336,     0,     0,   337,   338,   339,     0,     0,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,     0,   360,   361,   362,   363,   364,   365,     0,
     366,     0,     0,   367,   368,   369,     0,     0,   370,     0,
       0,     0,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   619,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,     0,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   620,   421,   422,
     423,   424,   425,     0,   426,   427,   428,   429,     0,   430,
     431,   432,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,     0,   444,   445,     0,   446,   447,
     448,   449,   450,   451,     0,   452,   453,     0,     0,   454,
     455,   456,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,     0,   465,   466,   467,   468,   469,     0,     0,
     470,   471,   472,   473,   474,   475,   476,     0,   477,     0,
     478,   479,   480,     0,     0,   481,     0,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   199,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,   617,   209,   210,   211,     0,     0,
       0,     0,   212,     0,     0,     0,   213,   214,     0,   215,
     216,     0,   217,   218,   219,   220,   221,     0,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,     0,
       0,     0,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,   250,   618,     0,   251,   252,
       0,     0,     0,     0,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,     0,     0,     0,   296,   297,   298,  2441,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,     0,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,     0,     0,   326,     0,   327,   328,
     329,   330,   331,   332,   333,     0,   334,   335,     0,   336,
       0,     0,   337,   338,   339,     0,     0,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
       0,   353,   354,   355,   356,     0,   357,   358,     0,   359,
       0,   360,   361,   362,   363,   364,   365,     0,   366,     0,
       0,   367,   368,   369,     0,     0,   370,     0,     0,     0,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   619,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,     0,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   620,   421,   422,   423,   424,
     425,     0,   426,   427,   428,   429,     0,   430,   431,   432,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   449,
     450,   451,     0,   452,   453,     0,     0,   454,   455,   456,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
       0,   465,   466,   467,   468,   469,     0,     0,   470,   471,
     472,   473,   474,   475,   476,     0,   477,     0,   478,   479,
     480,     0,     0,   481,     0,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   199,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   200,   201,   202,   203,   204,   205,
     206,   207,     0,   209,   210,   211,     0,     0,     0,     0,
     212,     0,     0,     0,   213,   214,     0,   215,   216,     0,
     217,   218,   219,   220,   221,     0,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
     233,  1825,   234,   235,   236,   237,   238,     0,     0,     0,
     239,   240,   241,   242,     0,   243,   244,  1826,   245,   246,
     247,   248,   249,   250,     0,     0,   251,   252,     0,     0,
       0,     0,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,  1901,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,  1828,   295,
       0,     0,     0,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,     0,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,     0,     0,   326,     0,   327,   328,   329,   330,
     331,   332,   333,     0,   334,   335,     0,   336,     0,     0,
     337,   338,   339,     0,     0,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,     0,   360,
     361,   362,   363,   364,   365,     0,   366,     0,     0,   367,
     368,   369,     0,     0,   370,     0,     0,     0,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,   383,   384,   385,  1829,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,     0,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,     0,
     426,   427,   428,   429,     0,   430,   431,   432,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   444,   445,     0,   446,   447,   448,   449,   450,   451,
       0,   452,   453,     0,     0,   454,   455,   456,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,  1830,   465,
     466,   467,   468,   469,     0,     0,   470,   471,   472,   473,
     474,   475,   476,     0,   477,     0,   478,   479,   480,     0,
       0,   481,     0,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   200,   201,   202,   203,   204,   205,   206,   207,
     617,   209,   210,   211,     0,     0,     0,     0,   212,     0,
       0,     0,   213,   214,     0,   215,   216,     0,   217,   218,
     219,   220,   221,     0,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,   233,     0,
     234,   235,   236,   237,   238,     0,     0,     0,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,   250,   618,     0,   251,   252,     0,     0,     0,     0,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,     0,   295,     0,     0,
       0,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,     0,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
       0,     0,   326,     0,   327,   328,   329,   330,   331,   332,
     333,     0,   334,   335,     0,   336,     0,     0,   337,   338,
     339,     0,     0,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,     0,   353,   354,   355,
     356,     0,   357,   358,     0,   359,     0,   360,   361,   362,
     363,   364,   365,     0,   366,     0,     0,   367,   368,   369,
       0,     0,   370,     0,     0,     0,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   619,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,     0,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   620,   421,   422,   423,   424,   425,     0,   426,   427,
     428,   429,     0,   430,   431,   432,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,     0,   444,
     445,     0,   446,   447,   448,   449,   450,   451,     0,   452,
     453,     0,     0,   454,   455,   456,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,     0,   465,   466,   467,
     468,   469,     0,     0,   470,   471,   472,   473,   474,   475,
     476,     0,   477,     0,   478,   479,   480,     0,     0,   481,
       0,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   199,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     200,   201,   202,   203,   204,   205,   206,   207,  1495,   209,
     210,   211,     0,     0,     0,     0,   212,     0,     0,     0,
     213,   214,     0,   215,   216,     0,   217,   218,   219,   220,
     221,     0,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,   233,     0,   234,   235,
     236,   237,   238,     0,     0,     0,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,     0,   251,   252,     0,     0,     0,     0,     0,     0,
       0,   253,   254,   255,  1496,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,  1497,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,  1498,   295,     0,     0,     0,  1499,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,     0,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,     0,     0,
     326,     0,   327,   328,  1500,  1501,   331,   332,   333,     0,
     334,   335,     0,   336,     0,     0,   337,   338,   339,     0,
       0,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,     0,   359,     0,   360,   361,   362,   363,   364,
     365,     0,   366,     0,     0,   367,   368,   369,     0,     0,
     370,     0,     0,     0,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,     0,   410,   411,
     412,   413,   414,   415,  1502,   417,   418,   419,   420,     0,
    1503,   422,   423,   424,   425,     0,   426,   427,   428,   429,
       0,   430,   431,   432,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,     0,   444,   445,  1504,
     446,  1505,   448,   449,   450,   451,     0,   452,   453,     0,
       0,   454,   455,   456,   457,     0,   458,   459,  1506,   461,
     462,   463,   464,     0,     0,   465,   466,   467,   468,   469,
       0,     0,   470,   471,   472,   473,   474,   475,   476,     0,
     477,     0,   478,   479,   480,     0,     0,   481,     0,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,   212,     0,     0,     0,   213,   214,
       0,   215,   216,     0,   217,   218,   219,   220,   221,     0,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,   233,     0,   234,   235,   236,   237,
     238,     0,     0,     0,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,   250,   618,     0,
     251,   252,     0,     0,     0,     0,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,     0,     0,     0,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,     0,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,     0,     0,   326,     0,
     327,   328,   329,   330,   331,   332,   333,     0,   334,   335,
       0,   336,     0,     0,   337,   338,   339,     0,     0,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,     0,   360,   361,   362,   363,   364,   365,     0,
     366,     0,     0,   367,   368,   369,     0,     0,   370,     0,
       0,     0,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   619,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,     0,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   620,   421,   422,
     423,   424,   425,     0,   426,   427,   428,   429,     0,   430,
     431,   432,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,     0,   444,   445,     0,   446,   447,
     448,   449,   450,   451,     0,   452,   453,     0,     0,   454,
     455,   456,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,     0,   465,   466,   467,   468,   469,     0,     0,
     470,   471,   472,   473,   474,   475,   476,     0,   477,     0,
     478,   479,   480,     0,     0,   481,     0,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   199,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     3,     4,
       0,     0,   212,     0,     0,     0,   213,   214,     0,   215,
     216,     0,   217,   218,   219,   220,   221,     0,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,     0,
       0,     0,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,     0,   251,   252,
       0,     0,     0,     0,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,     0,     0,     0,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,     0,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,     0,     0,   326,     0,   327,   328,
     329,   330,   331,   332,   333,     0,   334,   335,     0,   336,
       0,     0,   337,   338,   339,     0,     0,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
       0,   353,   354,   355,   356,     0,   357,   358,     0,   359,
       0,   360,   361,   362,   363,   364,   365,     0,   366,     0,
       0,   367,   368,   369,     0,     0,   370,     0,     0,     0,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,     0,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,     0,   426,   427,   428,   429,     0,   430,   431,   432,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   449,
     450,   451,     0,   452,   453,     0,     0,   454,   455,   456,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
       0,   465,   466,   467,   468,   469,     0,     0,   470,   471,
     472,   473,   474,   475,   476,     0,   477,     0,   478,   479,
     480,     0,     0,   481,     0,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   199,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   200,   201,   202,   203,   204,   205,
     206,   207,  2522,   209,   210,   211,     0,     0,     0,     0,
     212,     0,     0,     0,   213,   214,     0,   215,   216,     0,
     217,   218,   219,   220,   221,     0,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
     233,     0,   234,   235,   236,   237,   238,     0,     0,     0,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,     0,   251,   252,     0,     0,
       0,     0,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,     0,   295,
       0,     0,     0,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,     0,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,     0,     0,   326,     0,   327,   328,   329,   330,
     331,   332,   333,     0,   334,   335,     0,   336,     0,     0,
     337,   338,   339,     0,     0,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,     0,   360,
     361,   362,   363,   364,   365,     0,   366,     0,     0,   367,
     368,   369,     0,     0,   370,     0,     0,     0,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,     0,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,     0,
     426,   427,   428,   429,     0,   430,   431,   432,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   444,   445,     0,   446,   447,   448,   449,   450,   451,
       0,   452,   453,     0,     0,   454,   455,   456,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,     0,   465,
     466,   467,   468,   469,  2523,     0,   470,   471,   472,   473,
     474,   475,   476,     0,   477,     0,   478,   479,   480,     0,
       0,   481,     0,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   200,   201,   202,   203,   204,   205,   206,   207,
    2534,   209,   210,   211,     0,     0,     0,     0,   212,     0,
       0,     0,   213,   214,     0,   215,   216,     0,   217,   218,
     219,   220,   221,     0,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,   233,     0,
     234,   235,   236,   237,   238,     0,     0,     0,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,     0,   251,   252,     0,     0,     0,     0,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,     0,   295,     0,     0,
       0,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,     0,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
       0,     0,   326,     0,   327,   328,   329,   330,   331,   332,
     333,     0,   334,   335,     0,   336,     0,     0,   337,   338,
     339,     0,     0,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,     0,   353,   354,   355,
     356,     0,   357,   358,     0,   359,     0,   360,   361,   362,
     363,   364,   365,     0,   366,     0,     0,   367,   368,   369,
       0,     0,   370,     0,     0,     0,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,     0,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,     0,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,     0,   426,   427,
     428,   429,     0,   430,   431,   432,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,     0,   444,
     445,     0,   446,   447,   448,   449,   450,   451,     0,   452,
     453,     0,     0,   454,   455,   456,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,     0,   465,   466,   467,
     468,   469,  2535,     0,   470,   471,   472,   473,   474,   475,
     476,     0,   477,     0,   478,   479,   480,     0,     0,   481,
       0,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   199,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,     0,     0,     0,     0,   212,     0,     0,     0,
     213,   214,     0,   215,   216,     0,   217,   218,   219,   220,
     221,     0,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,   233,     0,   234,   235,
     236,   237,   238,     0,     0,     0,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,     0,   251,   252,     0,     0,     0,     0,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,     0,   295,     0,     0,     0,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,     0,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,     0,     0,
     326,     0,   327,   328,   329,   330,   331,   332,   333,     0,
     334,   335,     0,   336,     0,     0,   337,   338,   339,     0,
       0,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,     0,   359,     0,   360,   361,   362,   363,   364,
     365,     0,   366,     0,     0,   367,   368,   369,     0,     0,
     370,     0,     0,     0,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,     0,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,     0,   426,   427,   428,   429,
       0,   430,   431,   432,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,     0,   444,   445,     0,
     446,   447,   448,   449,   450,   451,     0,   452,   453,     0,
       0,   454,   455,   456,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,     0,   465,   466,   467,   468,   469,
       0,     0,   470,   471,   472,   473,   474,   475,   476,     0,
     477,     0,   478,   479,   480,     0,     0,   481,     0,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,   201,
     202,   203,   204,   205,   206,   207,   543,   209,   210,   211,
       0,     0,     0,     0,   212,     0,     0,     0,   213,   214,
       0,   215,   216,     0,   217,   218,   219,   220,   221,     0,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,   233,     0,   234,   235,   236,   237,
     238,     0,     0,     0,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,     0,
     251,   252,     0,     0,     0,     0,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,     0,     0,     0,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,     0,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,     0,     0,   326,     0,
     327,   328,   329,   330,   331,   332,   333,     0,   334,   335,
       0,   336,     0,     0,   337,   338,   339,     0,     0,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,     0,   360,   361,   362,   363,   364,   365,     0,
     366,     0,     0,   367,   368,   369,     0,     0,   370,     0,
       0,     0,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,   383,   544,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,     0,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,     0,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,     0,   426,   427,   428,   429,     0,   430,
     431,   432,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,     0,   444,   445,     0,   446,   447,
     448,   449,   450,   451,     0,   452,   453,     0,     0,   454,
     455,   456,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,     0,   465,   466,   467,   468,   469,     0,     0,
     470,   471,   472,   473,   474,   475,   476,     0,   477,     0,
     478,   479,   480,     0,     0,   481,     0,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   199,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,   642,   209,   210,   211,     0,     0,
       0,     0,   212,     0,     0,     0,   213,   214,     0,   215,
     216,     0,   217,   218,   219,   220,   221,     0,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,     0,
       0,     0,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,     0,   251,   252,
       0,     0,     0,     0,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,     0,     0,     0,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,     0,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,     0,     0,   326,     0,   327,   328,
     329,   330,   331,   332,   333,     0,   334,   335,     0,   336,
       0,     0,   337,   338,   339,     0,     0,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
       0,   353,   354,   355,   356,     0,   357,   358,     0,   359,
       0,   360,   361,   362,   363,   364,   365,     0,   366,     0,
       0,   367,   368,   369,     0,     0,   370,     0,     0,     0,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,     0,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     643,     0,   426,   427,   428,   429,     0,   430,   431,   432,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   449,
     450,   451,     0,   644,   453,     0,     0,   645,   455,   456,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
       0,   465,   466,   467,   468,   469,     0,     0,   470,   471,
     472,   473,   474,   475,   476,     0,   477,     0,   478,   479,
     480,     0,     0,   481,     0,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   199,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   200,   201,   202,   203,   204,   205,
     206,   207,   672,   209,   210,   211,     0,     0,     0,     0,
     212,     0,     0,     0,   213,   214,     0,   215,   216,     0,
     217,   218,   219,   220,   221,     0,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
     233,     0,   234,   235,   236,   237,   238,     0,     0,     0,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,     0,   251,   252,     0,     0,
       0,     0,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,     0,   295,
       0,     0,     0,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,     0,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,     0,     0,   326,     0,   327,   328,   329,   330,
     331,   332,   333,     0,   334,   335,     0,   336,     0,     0,
     337,   338,   339,     0,     0,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,     0,   360,
     361,   362,   363,   364,   365,     0,   366,     0,     0,   367,
     368,   369,     0,     0,   370,     0,     0,     0,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,     0,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   673,     0,
     426,   427,   428,   429,     0,   430,   431,   432,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   444,   445,     0,   446,   447,   448,   449,   450,   451,
       0,   674,   453,     0,     0,   675,   455,   456,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,     0,   465,
     466,   467,   468,   469,     0,     0,   470,   471,   472,   473,
     474,   475,   476,     0,   477,     0,   478,   479,   480,     0,
       0,   481,     0,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,   212,     0,
       0,     0,   213,   214,     0,   215,   216,     0,   217,   218,
     219,   220,   221,     0,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,   233,     0,
     234,   235,   236,   237,   238,     0,     0,     0,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,     0,   251,   252,     0,     0,     0,     0,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,     0,   295,     0,     0,
       0,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,     0,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
       0,     0,   326,     0,   327,   328,   329,   330,   331,   332,
     333,     0,   334,   335,     0,   336,     0,     0,   337,   338,
     339,     0,     0,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,     0,   353,   354,   355,
     356,     0,   357,   358,     0,   359,     0,   360,   361,   362,
     363,   364,   365,     0,   366,     0,   678,   367,   368,   369,
       0,     0,   370,     0,     0,     0,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,     0,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,     0,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,     0,   426,   427,
     428,   429,     0,   430,   431,   432,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,     0,   444,
     445,     0,   446,   447,   448,   449,   450,   451,     0,   452,
     453,     0,     0,   454,   455,   456,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,     0,   465,   466,   467,
     468,   469,     0,     0,   470,   471,   472,   473,   474,   475,
     476,     0,   477,     0,   478,   479,   480,     0,     0,   481,
       0,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   199,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     200,   201,   202,   203,   204,   205,   206,   207,     0,   209,
     210,   211,     0,     0,     0,     0,   212,     0,     0,     0,
     213,   214,     0,   215,   216,     0,   217,   218,   219,   220,
     221,     0,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,   233,     0,   234,   235,
     236,   237,   238,     0,     0,     0,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,     0,   251,   252,     0,     0,     0,     0,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,     0,   295,     0,     0,     0,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   786,     0,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,     0,     0,
     326,     0,   327,   328,   329,   330,   331,   332,   333,     0,
     334,   335,     0,   336,     0,     0,   337,   338,   339,     0,
       0,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,     0,   359,     0,   360,   361,   362,   363,   364,
     365,     0,   366,     0,   678,   367,   368,   369,     0,     0,
     370,     0,     0,     0,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,     0,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,     0,   426,   427,   428,   429,
       0,   430,   431,   432,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,     0,   444,   445,     0,
     446,   447,   448,   449,   450,   451,     0,   452,   453,     0,
       0,   454,   455,   456,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,     0,   465,   466,   467,   468,   469,
       0,     0,   470,   471,   472,   473,   474,   475,   476,     0,
     477,     0,   478,   479,   480,     0,     0,   481,     0,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,   201,
     202,   203,   204,   205,   206,   207,   876,   209,   210,   211,
       0,     0,     0,     0,   212,     0,     0,     0,   213,   214,
       0,   215,   216,     0,   217,   218,   219,   220,   221,     0,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,   233,     0,   234,   235,   236,   237,
     238,     0,     0,     0,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,     0,
     251,   252,     0,     0,     0,     0,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,     0,     0,     0,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,     0,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,     0,     0,   326,     0,
     327,   328,   329,   330,   331,   332,   333,     0,   334,   335,
       0,   336,     0,     0,   337,   338,   339,     0,     0,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,     0,   360,   361,   362,   363,   364,   365,     0,
     366,     0,     0,   367,   368,   369,     0,     0,   370,     0,
       0,     0,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,     0,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,     0,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,     0,   426,   427,   428,   429,     0,   430,
     431,   432,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,     0,   444,   445,     0,   446,   447,
     448,   449,   450,   451,     0,   452,   453,     0,     0,   454,
     455,   456,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,     0,   465,   466,   467,   468,   469,     0,     0,
     470,   471,   472,   473,   474,   475,   476,     0,   477,     0,
     478,   479,   480,     0,     0,   481,     0,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   199,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,  1082,   209,   210,   211,     0,     0,
       0,     0,   212,     0,     0,     0,   213,   214,     0,   215,
     216,     0,   217,   218,   219,   220,   221,     0,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,     0,
       0,     0,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,     0,   251,   252,
       0,     0,     0,     0,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,     0,     0,     0,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,     0,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,     0,     0,   326,     0,   327,   328,
     329,   330,   331,   332,   333,     0,   334,   335,     0,   336,
       0,     0,   337,   338,   339,     0,     0,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
       0,   353,   354,   355,   356,     0,   357,   358,     0,   359,
       0,   360,   361,   362,   363,   364,   365,     0,   366,     0,
       0,   367,   368,   369,     0,     0,   370,     0,     0,     0,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,     0,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,     0,   426,   427,   428,   429,     0,   430,   431,   432,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   449,
     450,   451,     0,   452,   453,     0,     0,   454,   455,   456,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
       0,   465,   466,   467,   468,   469,     0,     0,   470,   471,
     472,   473,   474,   475,   476,     0,   477,     0,   478,   479,
     480,     0,     0,   481,     0,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   199,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   200,   201,   202,   203,   204,   205,
     206,   207,     0,   209,   210,   211,     0,     0,     0,     0,
     212,     0,     0,     0,   213,   214,     0,   215,   216,  1093,
     217,   218,   219,   220,   221,     0,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   659,   230,   231,   232,
    1094,     0,   234,   235,   236,   237,   238,     0,     0,     0,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,     0,   251,   252,     0,     0,
       0,     0,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,     0,   295,
       0,     0,     0,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,     0,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,     0,     0,   326,     0,   327,   328,   329,   330,
     331,   332,   333,     0,   334,   335,     0,   336,     0,     0,
     337,   338,   339,     0,     0,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   662,   352,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,     0,   360,
     361,   362,   363,   364,   365,     0,   366,     0,     0,   367,
     368,   369,     0,     0,   370,     0,     0,     0,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,     0,   663,   411,   412,   413,   414,   415,   664,   417,
     418,   419,   420,     0,   421,   422,   423,   424,  1086,     0,
     426,   427,   428,   429,     0,   430,   431,   432,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   444,   445,     0,   446,   447,   448,   449,   450,   451,
       0,   666,   453,     0,     0,   667,   455,   456,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,     0,   465,
     466,   467,   468,   469,     0,     0,   470,   471,   472,   473,
     474,   475,   476,     0,   477,     0,   478,   479,   480,     0,
       0,   481,     0,     0,   482,   483,   484,   485,   668,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,   212,     0,
       0,     0,   213,   214,     0,   215,   216,     0,   217,   218,
     219,   220,   221,     0,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,   233,     0,
     234,   235,   236,   237,   238,     0,     0,     0,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,     0,   251,   252,     0,     0,     0,     0,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,     0,   295,     0,     0,
       0,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,  1190,     0,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
       0,     0,   326,     0,   327,   328,   329,   330,   331,   332,
     333,     0,   334,   335,     0,   336,     0,     0,   337,   338,
     339,     0,     0,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,     0,   353,   354,   355,
     356,     0,   357,   358,     0,   359,     0,   360,   361,   362,
     363,   364,   365,     0,   366,     0,   678,   367,   368,   369,
       0,     0,   370,     0,     0,     0,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,     0,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,     0,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,     0,   426,   427,
     428,   429,     0,   430,   431,   432,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,     0,   444,
     445,     0,   446,   447,   448,   449,   450,   451,     0,   452,
     453,     0,     0,   454,   455,   456,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,     0,   465,   466,   467,
     468,   469,     0,     0,   470,   471,   472,   473,   474,   475,
     476,     0,   477,     0,   478,   479,   480,     0,     0,   481,
       0,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   199,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     200,   201,   202,   203,   204,   205,   206,   207,     0,   209,
     210,   211,     0,     0,     0,     0,   212,     0,     0,     0,
     213,   214,     0,   215,   216,     0,   217,   218,   219,   220,
     221,     0,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,   233,     0,   234,   235,
     236,   237,   238,     0,     0,     0,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,     0,   251,   252,     0,     0,     0,     0,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,     0,   295,     0,     0,     0,   296,
     297,  2348,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,     0,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,     0,     0,
     326,     0,   327,   328,   329,   330,   331,   332,   333,     0,
     334,   335,     0,   336,     0,     0,   337,   338,  2349,     0,
       0,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,     0,   359,     0,   360,   361,   362,   363,   364,
     365,     0,   366,     0,     0,   367,   368,   369,     0,     0,
     370,     0,     0,     0,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,     0,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,     0,   426,   427,   428,   429,
       0,   430,   431,   432,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,     0,   444,   445,  2350,
     446,   447,  2351,   449,  2352,   451,     0,   452,   453,     0,
       0,   454,   455,   456,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,     0,   465,   466,  2353,   468,   469,
       0,     0,   470,   471,   472,   473,   474,   475,   476,     0,
     477,     0,   478,   479,   480,     0,     0,   481,     0,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   199,     0,   551,
       0,     0,     0,     0,     0,     0,     0,     0,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,   212,     0,     0,     0,   213,   214,
       0,   215,   216,     0,   217,   218,   219,   220,   221,     0,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,   233,     0,   234,   235,   236,   237,
     238,     0,     0,     0,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,     0,
     251,   252,     0,     0,     0,     0,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,     0,     0,     0,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,     0,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,     0,     0,   326,     0,
     327,   328,   329,   330,   331,   332,   333,     0,   334,   335,
       0,   336,     0,     0,   337,   338,   339,     0,     0,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,     0,   360,   361,   362,   363,   364,   365,     0,
     366,     0,     0,   367,   368,   369,     0,     0,   370,     0,
       0,     0,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,     0,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,     0,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,     0,   426,   427,   428,   429,     0,   430,
     431,   432,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,     0,   444,   445,     0,   446,   447,
     448,   449,   450,   451,     0,   452,   453,     0,     0,   454,
     455,   456,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,     0,   465,   466,   467,   468,   469,     0,     0,
     470,   471,   472,   473,   474,   475,   476,     0,   477,     0,
     478,   479,   480,     0,     0,   481,     0,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   199,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,   212,     0,  3408,     0,   213,   214,     0,   215,
     216,     0,   217,   218,   219,   220,   221,     0,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,     0,
       0,     0,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,     0,   251,   252,
       0,     0,     0,     0,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,     0,     0,     0,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,     0,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,     0,     0,   326,     0,   327,   328,
     329,   330,   331,   332,   333,     0,   334,   335,     0,   336,
       0,     0,   337,   338,   339,     0,     0,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
       0,   353,   354,   355,   356,     0,   357,   358,     0,   359,
       0,   360,   361,   362,   363,   364,   365,     0,   366,     0,
       0,   367,   368,   369,     0,     0,   370,     0,     0,     0,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,     0,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,     0,   426,   427,   428,   429,     0,   430,   431,   432,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   449,
     450,   451,     0,   452,   453,     0,     0,   454,   455,   456,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
       0,   465,   466,   467,   468,   469,     0,     0,   470,   471,
     472,   473,   474,   475,   476,     0,   477,     0,   478,   479,
     480,     0,     0,   481,     0,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   199,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   200,   201,   202,   203,   204,   205,
     206,   207,     0,   209,   210,   211,     0,     0,     0,     0,
     212,     0,  3421,     0,   213,   214,     0,   215,   216,     0,
     217,   218,   219,   220,   221,     0,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
     233,     0,   234,   235,   236,   237,   238,     0,     0,     0,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,     0,   251,   252,     0,     0,
       0,     0,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,     0,   295,
       0,     0,     0,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,     0,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,     0,     0,   326,     0,   327,   328,   329,   330,
     331,   332,   333,     0,   334,   335,     0,   336,     0,     0,
     337,   338,   339,     0,     0,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,     0,   360,
     361,   362,   363,   364,   365,     0,   366,     0,     0,   367,
     368,   369,     0,     0,   370,     0,     0,     0,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,     0,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,     0,
     426,   427,   428,   429,     0,   430,   431,   432,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   444,   445,     0,   446,   447,   448,   449,   450,   451,
       0,   452,   453,     0,     0,   454,   455,   456,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,     0,   465,
     466,   467,   468,   469,     0,     0,   470,   471,   472,   473,
     474,   475,   476,     0,   477,     0,   478,   479,   480,     0,
       0,   481,     0,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,   212,     0,
       0,     0,   213,   214,     0,   215,   216,     0,   217,   218,
     219,   220,   221,     0,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,   233,     0,
     234,   235,   236,   237,   238,     0,     0,     0,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,     0,   251,   252,     0,     0,     0,     0,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,  3626,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,     0,   295,     0,     0,
       0,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,     0,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
       0,     0,   326,     0,   327,   328,   329,   330,   331,   332,
     333,     0,   334,   335,     0,   336,     0,     0,   337,   338,
     339,     0,     0,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,     0,   353,   354,   355,
     356,     0,   357,   358,     0,   359,     0,   360,   361,   362,
     363,   364,   365,     0,   366,     0,     0,   367,   368,   369,
       0,     0,   370,     0,     0,     0,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,     0,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,     0,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,     0,   426,   427,
     428,   429,     0,   430,   431,   432,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,     0,   444,
     445,     0,   446,   447,   448,   449,   450,   451,     0,   452,
     453,     0,     0,   454,   455,   456,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,     0,   465,   466,   467,
     468,   469,     0,     0,   470,   471,   472,   473,   474,   475,
     476,     0,   477,     0,   478,   479,   480,     0,     0,   481,
       0,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   199,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     200,   201,   202,   203,   204,   205,   206,   207,     0,   209,
     210,   211,     0,     0,     0,     0,   212,     0,     0,     0,
     213,   214,     0,   215,   216,     0,   217,   218,   219,   220,
     221,     0,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,   233,     0,   234,   235,
     236,   237,   238,     0,     0,     0,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,     0,   251,   252,     0,     0,     0,     0,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
    3628,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,     0,   295,     0,     0,     0,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,     0,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,     0,     0,
     326,     0,   327,   328,   329,   330,   331,   332,   333,     0,
     334,   335,     0,   336,     0,     0,   337,   338,   339,     0,
       0,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,     0,   359,     0,   360,   361,   362,   363,   364,
     365,     0,   366,     0,     0,   367,   368,   369,     0,     0,
     370,     0,     0,     0,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,     0,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,     0,   426,   427,   428,   429,
       0,   430,   431,   432,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,     0,   444,   445,     0,
     446,   447,   448,   449,   450,   451,     0,   452,   453,     0,
       0,   454,   455,   456,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,     0,   465,   466,   467,   468,   469,
       0,     0,   470,   471,   472,   473,   474,   475,   476,     0,
     477,     0,   478,   479,   480,     0,     0,   481,     0,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,   212,     0,     0,     0,   213,   214,
       0,   215,   216,     0,   217,   218,   219,   220,   221,     0,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,   233,     0,   234,   235,   236,   237,
     238,     0,     0,     0,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,     0,
     251,   252,     0,     0,     0,     0,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,  3630,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,     0,     0,     0,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,     0,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,     0,     0,   326,     0,
     327,   328,   329,   330,   331,   332,   333,     0,   334,   335,
       0,   336,     0,     0,   337,   338,   339,     0,     0,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,     0,   360,   361,   362,   363,   364,   365,     0,
     366,     0,     0,   367,   368,   369,     0,     0,   370,     0,
       0,     0,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,     0,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,     0,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,     0,   426,   427,   428,   429,     0,   430,
     431,   432,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,     0,   444,   445,     0,   446,   447,
     448,   449,   450,   451,     0,   452,   453,     0,     0,   454,
     455,   456,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,     0,   465,   466,   467,   468,   469,     0,     0,
     470,   471,   472,   473,   474,   475,   476,     0,   477,     0,
     478,   479,   480,     0,     0,   481,     0,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   199,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,   212,     0,     0,     0,   213,   214,     0,   215,
     216,     0,   217,   218,   219,   220,   221,     0,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,     0,
       0,     0,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,     0,   251,   252,
       0,     0,     0,     0,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,     0,     0,     0,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,     0,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,     0,     0,   326,     0,   327,   328,
     329,   330,   331,   332,   333,     0,   334,   335,     0,   336,
       0,     0,   337,   338,   339,     0,     0,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
       0,   353,   354,   355,   356,     0,   357,   358,     0,   359,
       0,   360,   361,   362,   363,   364,   365,     0,   366,     0,
       0,   367,   368,   369,     0,     0,   370,     0,     0,     0,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,     0,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,     0,   426,   427,   428,   429,     0,   430,   431,   432,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   449,
     450,   451,     0,   452,   453,     0,     0,   454,   455,   456,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
       0,   465,   466,   467,   468,   469,     0,  3985,   470,   471,
     472,   473,   474,   475,   476,     0,   477,     0,   478,   479,
     480,     0,     0,   481,     0,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   199,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   200,   201,   202,   203,   204,   205,
     206,   207,     0,   209,   210,   211,     0,     0,     0,     0,
     212,     0,     0,     0,   213,   214,     0,   215,   216,     0,
     217,   218,   219,   220,   221,     0,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
     233,     0,   234,   235,   236,   237,   238,     0,     0,     0,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,     0,   251,   252,     0,     0,
       0,     0,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,     0,   295,
       0,     0,     0,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,     0,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,     0,     0,   326,     0,   327,   328,   329,   330,
     331,   332,   333,     0,   334,   335,     0,   336,     0,     0,
     337,   338,   339,     0,     0,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,     0,   360,
     361,   362,   363,   364,   365,     0,   366,     0,     0,   367,
     368,   369,     0,     0,   370,     0,     0,     0,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,     0,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,     0,
     426,   427,   428,   429,     0,   430,   431,   432,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   444,   445,     0,   446,   447,   448,   449,   450,   451,
       0,   452,   453,     0,     0,   454,   455,   456,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,     0,   465,
     466,   467,   468,   469,     0,     0,   470,   471,   472,   473,
     474,   475,   476,     0,   477,     0,   478,   479,   480,     0,
       0,   481,     0,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,   212,     0,
       0,     0,   213,   214,     0,   215,   216,     0,   217,   218,
     219,   220,   221,     0,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,   233,     0,
     234,   235,   236,   237,   238,     0,     0,     0,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,     0,   251,   252,     0,     0,     0,     0,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,     0,   295,     0,     0,
       0,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,     0,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
       0,     0,   326,     0,   327,   328,   329,   330,   331,   332,
     333,     0,   334,   335,     0,   336,     0,     0,   337,   338,
     339,     0,     0,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,     0,   353,   354,   355,
     356,     0,   357,   358,     0,   359,     0,   360,   361,   362,
     363,   364,   365,     0,   366,     0,     0,   367,   368,   369,
       0,     0,   370,     0,     0,     0,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,     0,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,     0,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,     0,   426,   427,
     428,   429,     0,   430,   431,   432,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,     0,   444,
     445,     0,   446,   447,   448,   449,   450,   451,     0,   452,
     453,     0,     0,   632,   455,   456,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,     0,   465,   466,   467,
     468,   469,     0,     0,   470,   471,   472,   473,   474,   475,
     476,     0,   477,     0,   478,   479,   480,     0,     0,   481,
       0,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   199,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     200,   201,   202,   203,   204,   205,   206,   207,     0,   209,
     210,   211,     0,     0,     0,     0,   212,     0,     0,     0,
     213,   214,     0,   215,   216,     0,   217,   218,   219,   220,
     221,     0,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,   233,     0,   234,   235,
     236,   237,   238,     0,     0,     0,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,     0,   251,   252,     0,     0,     0,     0,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,     0,   295,     0,     0,     0,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,     0,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,     0,     0,
     326,     0,   327,   328,   329,   330,   331,   332,   333,     0,
     334,   335,     0,   336,     0,     0,   337,   338,   339,     0,
       0,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,     0,   359,     0,   360,   361,   362,   363,   364,
     365,     0,   366,     0,     0,   367,   368,   369,     0,     0,
     370,     0,     0,     0,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,     0,   410,   411,
     412,   413,   414,   640,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,     0,   426,   427,   428,   429,
       0,   430,   431,   432,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,     0,   444,   445,     0,
     446,   447,   448,   449,   450,   451,     0,   452,   453,     0,
       0,   454,   455,   456,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,     0,   465,   466,   467,   468,   469,
       0,     0,   470,   471,   472,   473,   474,   475,   476,     0,
     477,     0,   478,   479,   480,     0,     0,   481,     0,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,   212,     0,     0,     0,   213,   214,
       0,   215,   216,     0,   217,   218,   219,   220,   221,     0,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     659,   230,   231,   232,   233,     0,   234,   235,   236,   237,
     238,     0,     0,     0,   239,   240,   241,   242,     0,   243,
     244,     0,   660,   246,   247,   248,   249,   250,     0,     0,
     251,   252,     0,     0,     0,     0,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,     0,     0,     0,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,     0,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,     0,     0,   326,     0,
     327,   328,   329,   330,   331,   332,   333,     0,   334,   335,
       0,   336,     0,     0,   337,   338,   661,     0,     0,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     662,   352,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,     0,   360,   361,   362,   363,   364,   365,     0,
     366,     0,     0,   367,   368,   369,     0,     0,   370,     0,
       0,     0,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,     0,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,     0,   663,   411,   412,   413,
     414,   415,   664,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   665,     0,   426,   427,   428,   429,     0,   430,
     431,   432,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,     0,   444,   445,     0,   446,   447,
     448,   449,   450,   451,     0,   666,   453,     0,     0,   667,
     455,   456,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,     0,   465,   466,   467,   468,   469,     0,     0,
     470,   471,   472,   473,   474,   475,   476,     0,   477,     0,
     478,   479,   480,     0,     0,   481,     0,     0,   482,   483,
     484,   485,   668,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   199,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,   212,     0,     0,     0,   213,   214,     0,   215,
     216,     0,   217,   218,   219,   220,   221,     0,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,     0,
       0,     0,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,     0,   251,   252,
       0,     0,     0,     0,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,     0,     0,     0,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,     0,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,     0,     0,   326,     0,   327,   328,
     329,   330,   331,   332,   333,     0,   334,   335,     0,   336,
       0,     0,   337,   338,   339,     0,     0,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
       0,   353,   354,   355,   356,     0,   357,   358,     0,   359,
       0,   360,   361,   362,   363,   364,   365,     0,   366,     0,
       0,   367,   368,   369,     0,     0,   370,     0,     0,     0,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   690,   397,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,     0,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,     0,   426,   427,   428,   429,     0,   430,   431,   432,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   449,
     450,   451,     0,   452,   453,     0,     0,   454,   455,   456,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
       0,   465,   466,   467,   468,   469,     0,     0,   470,   471,
     472,   473,   474,   475,   476,     0,   477,     0,   478,   479,
     480,     0,     0,   481,     0,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   199,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   200,   201,   202,   203,   204,   205,
     206,   207,     0,   209,   210,   211,     0,     0,     0,     0,
     212,     0,     0,     0,   213,   214,     0,   215,   216,     0,
     217,   218,   219,   220,   221,     0,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
     233,     0,   234,   235,   236,   237,   238,     0,     0,     0,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,     0,   251,   252,     0,     0,
       0,     0,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,     0,   295,
       0,     0,     0,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   762,     0,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,     0,     0,   326,     0,   327,   328,   329,   330,
     331,   332,   333,     0,   334,   335,     0,   336,     0,     0,
     337,   338,   339,     0,     0,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,     0,   360,
     361,   362,   363,   364,   365,     0,   366,     0,     0,   367,
     368,   369,     0,     0,   370,     0,     0,     0,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,     0,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,     0,
     426,   427,   428,   429,     0,   430,   431,   432,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   444,   445,     0,   446,   447,   448,   449,   450,   451,
       0,   452,   453,     0,     0,   454,   455,   456,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,     0,   465,
     466,   467,   468,   469,     0,     0,   470,   471,   472,   473,
     474,   475,   476,     0,   477,     0,   478,   479,   480,     0,
       0,   481,     0,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,   212,     0,
       0,     0,   213,   214,     0,   215,   216,     0,   217,   218,
     219,   220,   221,     0,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,   233,     0,
     234,   235,   236,   237,   238,     0,     0,     0,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,     0,   251,   252,     0,     0,     0,     0,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,     0,   295,     0,     0,
       0,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   783,     0,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
       0,     0,   326,     0,   327,   328,   329,   330,   331,   332,
     333,     0,   334,   335,     0,   336,     0,     0,   337,   338,
     339,     0,     0,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,     0,   353,   354,   355,
     356,     0,   357,   358,     0,   359,     0,   360,   361,   362,
     363,   364,   365,     0,   366,     0,     0,   367,   368,   369,
       0,     0,   370,     0,     0,     0,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,     0,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,     0,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,     0,   426,   427,
     428,   429,     0,   430,   431,   432,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,     0,   444,
     445,     0,   446,   447,   448,   449,   450,   451,     0,   452,
     453,     0,     0,   454,   455,   456,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,     0,   465,   466,   467,
     468,   469,     0,     0,   470,   471,   472,   473,   474,   475,
     476,     0,   477,     0,   478,   479,   480,     0,     0,   481,
       0,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   199,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     200,   201,   202,   203,   204,   205,   206,   207,     0,   209,
     210,   211,     0,     0,     0,     0,   212,     0,     0,     0,
     213,   214,     0,   215,   216,     0,   217,   218,   219,   220,
     221,     0,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,   233,     0,   234,   235,
     236,   237,   238,     0,     0,     0,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,     0,   251,   252,     0,     0,     0,     0,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,     0,   295,     0,     0,     0,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   794,     0,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,     0,     0,
     326,     0,   327,   328,   329,   330,   331,   332,   333,     0,
     334,   335,     0,   336,     0,     0,   337,   338,   339,     0,
       0,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,     0,   359,     0,   360,   361,   362,   363,   364,
     365,     0,   366,     0,     0,   367,   368,   369,     0,     0,
     370,     0,     0,     0,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,     0,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,     0,   426,   427,   428,   429,
       0,   430,   431,   432,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,     0,   444,   445,     0,
     446,   447,   448,   449,   450,   451,     0,   452,   453,     0,
       0,   454,   455,   456,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,     0,   465,   466,   467,   468,   469,
       0,     0,   470,   471,   472,   473,   474,   475,   476,     0,
     477,     0,   478,   479,   480,     0,     0,   481,     0,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,   212,     0,     0,     0,   213,   214,
       0,   215,   216,     0,   217,   218,   219,   220,   221,     0,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,   233,     0,   234,   235,   236,   237,
     238,     0,     0,     0,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,     0,
     251,   252,     0,     0,     0,     0,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,     0,     0,     0,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     844,     0,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,     0,     0,   326,     0,
     327,   328,   329,   330,   331,   332,   333,     0,   334,   335,
       0,   336,     0,     0,   337,   338,   339,     0,     0,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,     0,   360,   361,   362,   363,   364,   365,     0,
     366,     0,     0,   367,   368,   369,     0,     0,   370,     0,
       0,     0,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,     0,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,     0,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,     0,   426,   427,   428,   429,     0,   430,
     431,   432,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,     0,   444,   445,     0,   446,   447,
     448,   449,   450,   451,     0,   452,   453,     0,     0,   454,
     455,   456,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,     0,   465,   466,   467,   468,   469,     0,     0,
     470,   471,   472,   473,   474,   475,   476,     0,   477,     0,
     478,   479,   480,     0,     0,   481,     0,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   199,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,   212,     0,     0,     0,   213,   214,     0,   215,
     216,     0,   217,   218,   219,   220,   221,     0,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,     0,
       0,     0,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,     0,   251,   252,
       0,     0,     0,     0,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,     0,     0,     0,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   888,     0,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,     0,     0,   326,     0,   327,   328,
     329,   330,   331,   332,   333,     0,   334,   335,     0,   336,
       0,     0,   337,   338,   339,     0,     0,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
       0,   353,   354,   355,   356,     0,   357,   358,     0,   359,
       0,   360,   361,   362,   363,   364,   365,     0,   366,     0,
       0,   367,   368,   369,     0,     0,   370,     0,     0,     0,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,     0,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,     0,   426,   427,   428,   429,     0,   430,   431,   432,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   449,
     450,   451,     0,   452,   453,     0,     0,   454,   455,   456,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
       0,   465,   466,   467,   468,   469,     0,     0,   470,   471,
     472,   473,   474,   475,   476,     0,   477,     0,   478,   479,
     480,     0,     0,   481,     0,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   199,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   200,   201,   202,   203,   204,   205,
     206,   207,     0,   209,   210,   211,     0,     0,     0,     0,
     212,     0,     0,     0,   213,   214,     0,   215,   216,     0,
     217,   218,   219,   220,   221,     0,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
     233,     0,   234,   235,   236,   237,   238,     0,     0,     0,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,     0,   251,   252,     0,     0,
       0,     0,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,     0,   295,
       0,     0,     0,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   905,     0,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,     0,     0,   326,     0,   327,   328,   329,   330,
     331,   332,   333,     0,   334,   335,     0,   336,     0,     0,
     337,   338,   339,     0,     0,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,     0,   360,
     361,   362,   363,   364,   365,     0,   366,     0,     0,   367,
     368,   369,     0,     0,   370,     0,     0,     0,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,     0,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,     0,
     426,   427,   428,   429,     0,   430,   431,   432,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   444,   445,     0,   446,   447,   448,   449,   450,   451,
       0,   452,   453,     0,     0,   454,   455,   456,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,     0,   465,
     466,   467,   468,   469,     0,     0,   470,   471,   472,   473,
     474,   475,   476,     0,   477,     0,   478,   479,   480,     0,
       0,   481,     0,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,   212,     0,
       0,     0,   213,   214,     0,   215,   216,     0,   217,   218,
     219,   220,   221,     0,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,   233,     0,
     234,   235,   236,   237,   238,     0,     0,     0,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,     0,   251,   252,     0,     0,     0,     0,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,     0,   295,     0,     0,
       0,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   907,     0,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
       0,     0,   326,     0,   327,   328,   329,   330,   331,   332,
     333,     0,   334,   335,     0,   336,     0,     0,   337,   338,
     339,     0,     0,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,     0,   353,   354,   355,
     356,     0,   357,   358,     0,   359,     0,   360,   361,   362,
     363,   364,   365,     0,   366,     0,     0,   367,   368,   369,
       0,     0,   370,     0,     0,     0,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,     0,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,     0,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,     0,   426,   427,
     428,   429,     0,   430,   431,   432,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,     0,   444,
     445,     0,   446,   447,   448,   449,   450,   451,     0,   452,
     453,     0,     0,   454,   455,   456,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,     0,   465,   466,   467,
     468,   469,     0,     0,   470,   471,   472,   473,   474,   475,
     476,     0,   477,     0,   478,   479,   480,     0,     0,   481,
       0,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   199,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     200,   201,   202,   203,   204,   205,   206,   207,     0,   209,
     210,   211,     0,     0,     0,     0,   212,     0,     0,     0,
     213,   214,     0,   215,   216,     0,   217,   218,   219,   220,
     221,     0,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,   233,     0,   234,   235,
     236,   237,   238,     0,     0,     0,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,     0,   251,   252,     0,     0,     0,     0,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,     0,   295,     0,     0,     0,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   909,     0,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,     0,     0,
     326,     0,   327,   328,   329,   330,   331,   332,   333,     0,
     334,   335,     0,   336,     0,     0,   337,   338,   339,     0,
       0,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,     0,   359,     0,   360,   361,   362,   363,   364,
     365,     0,   366,     0,     0,   367,   368,   369,     0,     0,
     370,     0,     0,     0,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,     0,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,     0,   426,   427,   428,   429,
       0,   430,   431,   432,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,     0,   444,   445,     0,
     446,   447,   448,   449,   450,   451,     0,   452,   453,     0,
       0,   454,   455,   456,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,     0,   465,   466,   467,   468,   469,
       0,     0,   470,   471,   472,   473,   474,   475,   476,     0,
     477,     0,   478,   479,   480,     0,     0,   481,     0,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,   212,     0,     0,     0,   213,   214,
       0,   215,   216,     0,   217,   218,   219,   220,   221,     0,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,   233,     0,   234,   235,   236,   237,
     238,     0,     0,     0,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,     0,
     251,   252,     0,     0,     0,     0,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,     0,     0,     0,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     912,     0,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,     0,     0,   326,     0,
     327,   328,   329,   330,   331,   332,   333,     0,   334,   335,
       0,   336,     0,     0,   337,   338,   339,     0,     0,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,     0,   360,   361,   362,   363,   364,   365,     0,
     366,     0,     0,   367,   368,   369,     0,     0,   370,     0,
       0,     0,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,     0,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,     0,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,     0,   426,   427,   428,   429,     0,   430,
     431,   432,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,     0,   444,   445,     0,   446,   447,
     448,   449,   450,   451,     0,   452,   453,     0,     0,   454,
     455,   456,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,     0,   465,   466,   467,   468,   469,     0,     0,
     470,   471,   472,   473,   474,   475,   476,     0,   477,     0,
     478,   479,   480,     0,     0,   481,     0,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   199,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,   212,     0,     0,     0,   213,   214,     0,   215,
     216,     0,   217,   218,   219,   220,   221,     0,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,     0,
       0,     0,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,     0,   251,   252,
       0,     0,     0,     0,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,     0,     0,     0,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   918,     0,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,     0,     0,   326,     0,   327,   328,
     329,   330,   331,   332,   333,     0,   334,   335,     0,   336,
       0,     0,   337,   338,   339,     0,     0,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
       0,   353,   354,   355,   356,     0,   357,   358,     0,   359,
       0,   360,   361,   362,   363,   364,   365,     0,   366,     0,
       0,   367,   368,   369,     0,     0,   370,     0,     0,     0,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,     0,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,     0,   426,   427,   428,   429,     0,   430,   431,   432,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   449,
     450,   451,     0,   452,   453,     0,     0,   454,   455,   456,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
       0,   465,   466,   467,   468,   469,     0,     0,   470,   471,
     472,   473,   474,   475,   476,     0,   477,     0,   478,   479,
     480,     0,     0,   481,     0,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   199,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   200,   201,   202,   203,   204,   205,
     206,   207,     0,   209,   210,   211,     0,     0,     0,     0,
     212,     0,     0,     0,   213,   214,     0,   215,   216,     0,
     217,   218,   219,   220,   221,     0,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   659,   230,   231,   232,
     233,     0,   234,   235,   236,   237,   238,     0,     0,     0,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,     0,   251,   252,     0,     0,
       0,     0,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,     0,   295,
       0,     0,     0,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,     0,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,     0,     0,   326,     0,   327,   328,   329,   330,
     331,   332,   333,     0,   334,   335,     0,   336,     0,     0,
     337,   338,   339,     0,     0,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   662,   352,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,     0,   360,
     361,   362,   363,   364,   365,     0,   366,     0,     0,   367,
     368,   369,     0,     0,   370,     0,     0,     0,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,     0,   663,   411,   412,   413,   414,   415,   664,   417,
     418,   419,   420,     0,   421,   422,   423,   424,  1086,     0,
     426,   427,   428,   429,     0,   430,   431,   432,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   444,   445,     0,   446,   447,   448,   449,   450,   451,
       0,   666,   453,     0,     0,   667,   455,   456,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,     0,   465,
     466,   467,   468,   469,     0,     0,   470,   471,   472,   473,
     474,   475,   476,     0,   477,     0,   478,   479,   480,     0,
       0,   481,     0,     0,   482,   483,   484,   485,   668,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,   212,     0,
       0,     0,   213,   214,     0,   215,   216,     0,   217,   218,
     219,   220,   221,     0,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,   233,     0,
     234,   235,   236,   237,   238,     0,     0,     0,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,     0,   251,   252,     0,     0,     0,     0,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,     0,   295,     0,     0,
       0,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,  1379,     0,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
       0,     0,   326,     0,   327,   328,   329,   330,   331,   332,
     333,     0,   334,   335,     0,   336,     0,     0,   337,   338,
     339,     0,     0,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,     0,   353,   354,   355,
     356,     0,   357,   358,     0,   359,     0,   360,   361,   362,
     363,   364,   365,     0,   366,     0,     0,   367,   368,   369,
       0,     0,   370,     0,     0,     0,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,     0,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,     0,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,     0,   426,   427,
     428,   429,     0,   430,   431,   432,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,     0,   444,
     445,     0,   446,   447,   448,   449,   450,   451,     0,   452,
     453,     0,     0,   454,   455,   456,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,     0,   465,   466,   467,
     468,   469,     0,     0,   470,   471,   472,   473,   474,   475,
     476,     0,   477,     0,   478,   479,   480,     0,     0,   481,
       0,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   199,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     200,   201,   202,   203,   204,   205,   206,   207,     0,   209,
     210,   211,     0,     0,     0,     0,   212,     0,     0,     0,
     213,   214,     0,   215,   216,     0,   217,   218,   219,   220,
     221,     0,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,   233,     0,   234,   235,
     236,   237,   238,     0,     0,     0,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,     0,   251,   252,     0,     0,     0,     0,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,     0,   295,     0,     0,     0,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,  1406,     0,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,     0,     0,
     326,     0,   327,   328,   329,   330,   331,   332,   333,     0,
     334,   335,     0,   336,     0,     0,   337,   338,   339,     0,
       0,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,     0,   359,     0,   360,   361,   362,   363,   364,
     365,     0,   366,     0,     0,   367,   368,   369,     0,     0,
     370,     0,     0,     0,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,     0,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,     0,   426,   427,   428,   429,
       0,   430,   431,   432,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,     0,   444,   445,     0,
     446,   447,   448,   449,   450,   451,     0,   452,   453,     0,
       0,   454,   455,   456,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,     0,   465,   466,   467,   468,   469,
       0,     0,   470,   471,   472,   473,   474,   475,   476,     0,
     477,     0,   478,   479,   480,     0,     0,   481,     0,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,   212,     0,     0,     0,   213,   214,
       0,   215,   216,     0,   217,   218,   219,   220,   221,     0,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,   231,   232,   233,     0,   234,   235,   236,   237,
     238,     0,     0,     0,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,     0,
     251,   252,     0,     0,     0,     0,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,     0,     0,     0,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
    1434,     0,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,     0,     0,   326,     0,
     327,   328,   329,   330,   331,   332,   333,     0,   334,   335,
       0,   336,     0,     0,   337,   338,   339,     0,     0,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,     0,   360,   361,   362,   363,   364,   365,     0,
     366,     0,     0,   367,   368,   369,     0,     0,   370,     0,
       0,     0,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,     0,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,     0,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,     0,   426,   427,   428,   429,     0,   430,
     431,   432,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,     0,   444,   445,     0,   446,   447,
     448,   449,   450,   451,     0,   452,   453,     0,     0,   454,
     455,   456,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,     0,   465,   466,   467,   468,   469,     0,     0,
     470,   471,   472,   473,   474,   475,   476,     0,   477,     0,
     478,   479,   480,     0,     0,   481,     0,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   199,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,   212,     0,     0,     0,   213,   214,     0,   215,
     216,     0,   217,   218,   219,   220,   221,     0,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,     0,
       0,     0,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,     0,   251,   252,
       0,     0,     0,     0,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,     0,     0,     0,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,  1436,     0,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,     0,     0,   326,     0,   327,   328,
     329,   330,   331,   332,   333,     0,   334,   335,     0,   336,
       0,     0,   337,   338,   339,     0,     0,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
       0,   353,   354,   355,   356,     0,   357,   358,     0,   359,
       0,   360,   361,   362,   363,   364,   365,     0,   366,     0,
       0,   367,   368,   369,     0,     0,   370,     0,     0,     0,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,     0,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,     0,   426,   427,   428,   429,     0,   430,   431,   432,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   449,
     450,   451,     0,   452,   453,     0,     0,   454,   455,   456,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
       0,   465,   466,   467,   468,   469,     0,     0,   470,   471,
     472,   473,   474,   475,   476,     0,   477,     0,   478,   479,
     480,     0,     0,   481,     0,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   199,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   200,   201,   202,   203,   204,   205,
     206,   207,     0,   209,   210,   211,     0,     0,     0,     0,
     212,     0,     0,     0,   213,   214,     0,   215,   216,     0,
     217,   218,   219,   220,   221,     0,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
     233,     0,   234,   235,   236,   237,   238,     0,     0,     0,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,     0,   251,   252,     0,     0,
       0,     0,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,     0,   295,
       0,     0,     0,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,  1438,     0,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,     0,     0,   326,     0,   327,   328,   329,   330,
     331,   332,   333,     0,   334,   335,     0,   336,     0,     0,
     337,   338,   339,     0,     0,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,     0,   360,
     361,   362,   363,   364,   365,     0,   366,     0,     0,   367,
     368,   369,     0,     0,   370,     0,     0,     0,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,     0,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,     0,
     426,   427,   428,   429,     0,   430,   431,   432,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   444,   445,     0,   446,   447,   448,   449,   450,   451,
       0,   452,   453,     0,     0,   454,   455,   456,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,     0,   465,
     466,   467,   468,   469,     0,     0,   470,   471,   472,   473,
     474,   475,   476,     0,   477,     0,   478,   479,   480,     0,
       0,   481,     0,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,   212,     0,
       0,     0,   213,   214,     0,   215,   216,     0,   217,   218,
     219,   220,   221,     0,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,   233,     0,
     234,   235,   236,   237,   238,     0,     0,     0,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,     0,   251,   252,     0,     0,     0,     0,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,     0,   295,     0,     0,
       0,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,     0,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
       0,     0,   326,     0,   327,   328,   329,   330,   331,   332,
     333,     0,   334,   335,     0,   336,     0,     0,   337,   338,
     339,     0,     0,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,     0,   353,   354,   355,
     356,     0,   357,   358,     0,   359,     0,   360,   361,   362,
     363,   364,   365,     0,   366,     0,     0,   367,   368,   369,
       0,     0,   370,     0,     0,     0,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,     0,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,     0,
     410,   411,   412,   413,   414,  1529,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,     0,   426,   427,
     428,   429,     0,   430,   431,   432,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,     0,   444,
     445,     0,   446,   447,   448,   449,   450,   451,     0,   452,
     453,     0,     0,   454,   455,   456,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,     0,   465,   466,   467,
     468,   469,     0,     0,   470,   471,   472,   473,   474,   475,
     476,     0,   477,     0,   478,   479,   480,     0,     0,   481,
       0,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   199,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     200,   201,   202,   203,   204,   205,   206,   207,     0,   209,
     210,   211,     0,     0,     0,     0,   212,     0,  1798,     0,
     213,   214,     0,   215,   216,     0,   217,   218,   219,   220,
     221,     0,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,   233,     0,   234,   235,
     236,   237,   238,     0,     0,     0,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,     0,   251,   252,     0,     0,     0,     0,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,     0,   295,     0,     0,     0,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,     0,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,     0,     0,
     326,     0,   327,   328,   329,   330,   331,   332,   333,     0,
     334,   335,     0,   336,     0,     0,   337,   338,   339,     0,
       0,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,     0,   359,     0,   360,   361,   362,   363,   364,
     365,     0,   366,     0,     0,   367,   368,   369,     0,     0,
     370,     0,     0,     0,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,     0,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,     0,     0,   427,   428,   429,
       0,   430,   431,   432,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,     0,   444,   445,     0,
     446,   447,   448,   449,   450,   451,     0,   452,   453,     0,
       0,   454,   455,   456,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,     0,   465,   466,   467,   468,   469,
       0,     0,   470,   471,   472,   473,   474,   475,   476,     0,
     477,     0,   478,   479,   480,     0,     0,   481,     0,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,   212,     0,     0,     0,   213,   214,
       0,   215,   216,     0,   217,   218,   219,   220,   221,     0,
     222,   223,     0,   224,   225,   226,   227,   228,     0,     0,
     659,   230,   231,   232,   233,     0,   234,   235,   236,   237,
     238,     0,     0,     0,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,     0,
     251,   252,     0,     0,     0,     0,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,     0,     0,     0,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,     0,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,     0,     0,   326,     0,
     327,   328,   329,   330,   331,   332,   333,     0,   334,   335,
       0,   336,     0,     0,   337,   338,   339,     0,     0,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     662,   352,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,     0,   360,   361,   362,   363,   364,   365,     0,
     366,     0,     0,   367,   368,   369,     0,     0,   370,     0,
       0,     0,   371,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,     0,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,     0,   663,   411,   412,   413,
     414,   415,   664,   417,   418,   419,   420,     0,   421,   422,
     423,   424,  1086,     0,   426,   427,   428,   429,     0,   430,
     431,   432,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,     0,   444,   445,     0,   446,  1816,
     448,   449,   450,   451,     0,   666,   453,     0,     0,   667,
     455,   456,   457,     0,   458,   459,   460,   461,   462,   463,
     464,     0,     0,   465,   466,   467,   468,   469,     0,     0,
     470,   471,   472,   473,   474,   475,   476,     0,   477,     0,
     478,   479,   480,     0,     0,   481,     0,     0,   482,   483,
     484,   485,   668,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   199,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,   212,     0,     0,     0,   213,   214,     0,   215,
     216,     0,   217,   218,   219,   220,   221,     0,   222,   223,
       0,   224,   225,   226,   227,   228,     0,     0,   659,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,     0,
       0,     0,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,     0,   251,   252,
       0,     0,     0,     0,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,     0,     0,     0,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,     0,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,     0,     0,   326,     0,   327,   328,
     329,   330,   331,   332,   333,     0,   334,   335,     0,   336,
       0,     0,   337,   338,   339,     0,     0,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   662,   352,
       0,   353,   354,   355,   356,     0,   357,   358,     0,   359,
       0,   360,   361,   362,   363,   364,   365,     0,   366,     0,
       0,   367,   368,   369,     0,     0,   370,     0,     0,     0,
     371,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,     0,   663,   411,   412,   413,   414,   415,
    1876,   417,   418,   419,   420,     0,   421,   422,   423,   424,
    1877,     0,   426,   427,   428,   429,     0,   430,   431,   432,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,     0,   444,   445,     0,   446,   447,   448,   449,
     450,   451,     0,   666,   453,     0,     0,  1878,   455,   456,
     457,     0,   458,   459,   460,   461,   462,   463,   464,     0,
       0,   465,   466,   467,   468,   469,     0,     0,   470,   471,
     472,   473,   474,   475,   476,     0,   477,     0,   478,   479,
     480,     0,     0,   481,     0,     0,   482,   483,   484,   485,
     668,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   199,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   200,   201,   202,   203,   204,   205,
     206,   207,     0,   209,   210,   211,     0,     0,     0,     0,
     212,     0,     0,     0,   213,   214,     0,   215,   216,     0,
     217,   218,   219,   220,   221,     0,   222,   223,     0,   224,
     225,   226,   227,   228,     0,     0,   229,   230,   231,   232,
     233,     0,   234,   235,   236,   237,   238,     0,     0,     0,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,     0,   251,   252,     0,     0,
       0,     0,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,     0,   295,
       0,     0,     0,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,  2122,     0,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,     0,     0,   326,     0,   327,   328,   329,   330,
     331,   332,   333,     0,   334,   335,     0,   336,     0,     0,
     337,   338,   339,     0,     0,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,     0,   360,
     361,   362,   363,   364,   365,     0,   366,     0,     0,   367,
     368,   369,     0,     0,   370,     0,     0,     0,   371,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,     0,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,     0,   408,
     409,     0,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,     0,   421,   422,   423,   424,   425,     0,
     426,   427,   428,   429,     0,   430,   431,   432,     0,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
       0,   444,   445,     0,   446,   447,   448,   449,   450,   451,
       0,   452,   453,     0,     0,   454,   455,   456,   457,     0,
     458,   459,   460,   461,   462,   463,   464,     0,     0,   465,
     466,   467,   468,   469,     0,     0,   470,   471,   472,   473,
     474,   475,   476,     0,   477,     0,   478,   479,   480,     0,
       0,   481,     0,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,   212,     0,
       0,     0,   213,   214,     0,   215,   216,     0,   217,   218,
     219,   220,   221,     0,   222,   223,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,   231,   232,   233,     0,
     234,   235,   236,   237,   238,     0,     0,     0,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,     0,   251,   252,     0,     0,     0,     0,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,     0,   295,     0,     0,
       0,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,  2452,     0,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
       0,     0,   326,     0,   327,   328,   329,   330,   331,   332,
     333,     0,   334,   335,     0,   336,     0,     0,   337,   338,
     339,     0,     0,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,     0,   353,   354,   355,
     356,     0,   357,   358,     0,   359,     0,   360,   361,   362,
     363,   364,   365,     0,   366,     0,     0,   367,   368,   369,
       0,     0,   370,     0,     0,     0,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,     0,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,     0,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,     0,   426,   427,
     428,   429,     0,   430,   431,   432,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,     0,   444,
     445,     0,   446,   447,   448,   449,   450,   451,     0,   452,
     453,     0,     0,   454,   455,   456,   457,     0,   458,   459,
     460,   461,   462,   463,   464,     0,     0,   465,   466,   467,
     468,   469,     0,     0,   470,   471,   472,   473,   474,   475,
     476,     0,   477,     0,   478,   479,   480,     0,     0,   481,
       0,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   199,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     200,   201,   202,   203,   204,   205,   206,   207,     0,   209,
     210,   211,     0,     0,     0,     0,   212,     0,     0,     0,
     213,   214,     0,   215,   216,     0,   217,   218,   219,   220,
     221,     0,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   659,   230,   231,   232,   233,     0,   234,   235,
     236,   237,   238,     0,     0,     0,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,     0,   251,   252,     0,     0,     0,     0,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,     0,   295,     0,     0,     0,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,     0,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,     0,     0,
     326,     0,   327,   328,   329,   330,   331,   332,   333,     0,
     334,   335,     0,   336,     0,     0,   337,   338,   339,     0,
       0,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   662,   352,     0,   353,   354,   355,   356,     0,
     357,   358,     0,   359,     0,   360,   361,   362,   363,   364,
     365,     0,   366,     0,     0,   367,   368,   369,     0,     0,
     370,     0,     0,     0,   371,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,     0,   663,   411,
     412,   413,   414,   415,   664,   417,   418,   419,   420,     0,
     421,   422,   423,   424,  1877,     0,   426,   427,   428,   429,
       0,   430,   431,   432,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,     0,   444,   445,     0,
     446,   447,   448,   449,   450,   451,     0,   666,   453,     0,
       0,  1878,   455,   456,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,     0,   465,   466,   467,   468,   469,
       0,     0,   470,   471,   472,   473,   474,   475,   476,     0,
     477,     0,   478,   479,   480,     0,     0,   481,     0,     0,
     482,   483,   484,   485,   668,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,  1334,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,   212,     0,     0,     0,   213,   214,
       0,   215,   216,   714,   217,   218,   219,     0,  1335,   715,
    1336,  1337,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,  1338,  1339,   233,     0,   234,   235,   236,   237,
       0,     0,   716,     0,   239,   240,   241,   242,   717,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,   718,
     251,   252,     0,     0,     0,   719,     0,     0,     0,   253,
     254,   255,   256,   257,   258,  1340,  1341,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,  1009,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,     0,
     286,   287,   288,     0,     0,   290,     0,   291,  1342,   293,
       0,   294,     0,   295,   720,     0,   721,   296,   297,   298,
       0,   299,     0,     0,   301,     0,   302,   303,   304,   305,
     306,   722,   307,   308,   309,  1884,   310,   311,   312,   313,
     314,   315,     0,   316,   723,  1885,   318,   319,   320,   321,
    1343,  1344,     0,  1345,     0,   325,   724,   725,   326,   726,
     327,   328,   329,   330,   331,   332,   333,     0,   334,     0,
     727,   336,   728,     0,   337,   338,   339,     0,     0,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,  1346,   729,  1347,   354,   355,     0,     0,   357,   358,
     730,   359,     0,     0,   361,  1348,   363,   364,   365,     0,
     366,     0,     0,   367,   368,   369,     0,     0,  1886,   731,
     732,   733,     0,   372,   373,   374,   375,   376,   377,   378,
       0,   379,     0,   381,     0,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,  1349,   394,   395,   396,
     397,     0,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,   734,   410,   411,     0,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,     0,   426,  1887,   428,   429,   735,   430,
    1351,   432,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,     0,     0,   444,   445,     0,   446,   447,
     448,   449,   450,   451,     0,  1352,  1353,     0,     0,   454,
       0,   456,     0,     0,   458,   459,   460,   461,   462,   463,
     464,     0,     0,   465,   466,   467,   468,   469,     0,     0,
     470,   471,   472,   473,   474,     0,  1354,  1888,   477,   736,
     478,   479,   480,     0,     0,   481,     0,     0,   482,   483,
     484,   485,   486,     0,   199,     0,     0,     0,     0,     0,
       0,     0,   496,   497,   498,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,   212,     0,     0,     0,   213,   214,     0,   215,   216,
       0,   217,   218,   219,   220,   221,     0,   222,   223,     0,
     224,   225,   226,   227,   228,     0,     0,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,     0,     0,
       0,   239,   240,   241,   242,     0,   243,   244,     0,   245,
     246,   247,   248,   249,   250,     0,     0,   251,   252,     0,
       0,     0,     0,     0,     0,     0,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   262,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,     0,   279,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,     0,   290,     0,   291,   292,   293,     0,   294,     0,
     295,     0,     0,     0,   296,   297,   298,     0,   299,   300,
       0,   301,     0,   302,   303,   304,   305,  2525,     0,   307,
     308,   309,     0,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,     0,     0,   326,     0,   327,   328,   329,
     330,   331,   332,   333,     0,   334,   335,     0,   336,     0,
       0,   337,   338,   339,     0,     0,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,     0,
     353,   354,   355,   356,     0,   357,   358,     0,   359,     0,
     360,   361,   362,   363,   364,   365,     0,   366,     0,     0,
     367,   368,   369,     0,     0,   370,     0,     0,     0,   371,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,   383,   384,   385,     0,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,     0,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,     0,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
       0,   426,   427,   428,   429,     0,   430,   431,   432,     0,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,     0,   444,   445,     0,   446,   447,   448,   449,   450,
     451,     0,   452,   453,     0,     0,   454,   455,   456,   457,
       0,   458,   459,   460,   461,   462,   463,   464,     0,     0,
     465,   466,   467,   468,   469,     0,     0,   470,   471,   472,
     473,   474,   475,   476,     0,   477,     0,   478,   479,   480,
       0,     0,   481,     0,     0,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   199,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,   212,
       0,     0,     0,   213,   214,     0,   215,   216,     0,   217,
     218,   219,   220,   221,     0,   222,   223,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,     0,     0,     0,   239,
     240,   241,   242,     0,   243,   244,     0,   245,   246,   247,
     248,   249,   250,     0,     0,   251,   252,     0,     0,     0,
       0,     0,     0,     0,   253,   254,   255,   256,   257,   258,
     259,   260,   261,     0,   262,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,     0,   279,   280,     0,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,     0,   291,   292,   293,     0,   294,     0,   295,     0,
       0,     0,   296,   297,   298,     0,   299,   300,     0,   301,
       0,   302,   303,   304,   305,  2527,     0,   307,   308,   309,
       0,   310,   311,   312,   313,   314,   315,     0,   316,     0,
     317,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,     0,     0,   326,     0,   327,   328,   329,   330,   331,
     332,   333,     0,   334,   335,     0,   336,     0,     0,   337,
     338,   339,     0,     0,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,     0,   360,   361,
     362,   363,   364,   365,     0,   366,     0,     0,   367,   368,
     369,     0,     0,   370,     0,     0,     0,   371,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,     0,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
       0,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,     0,   426,
     427,   428,   429,     0,   430,   431,   432,     0,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,     0,
     444,   445,     0,   446,   447,   448,   449,   450,   451,     0,
     452,   453,     0,     0,   454,   455,   456,   457,     0,   458,
     459,   460,   461,   462,   463,   464,     0,     0,   465,   466,
     467,   468,   469,     0,     0,   470,   471,   472,   473,   474,
     475,   476,     0,   477,     0,   478,   479,   480,     0,     0,
     481,     0,     0,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     199,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,   212,     0,     0,
       0,   213,   214,     0,   215,   216,     0,   217,   218,   219,
     220,   221,     0,   222,   223,     0,   224,   225,   226,   227,
     228,     0,     0,   229,   230,   231,   232,   233,     0,   234,
     235,   236,   237,   238,     0,     0,     0,   239,   240,   241,
     242,     0,   243,   244,     0,   245,   246,   247,   248,   249,
     250,     0,     0,   251,   252,     0,     0,     0,     0,     0,
       0,     0,   253,   254,   255,   256,   257,   258,   259,   260,
     261,     0,   262,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,     0,   279,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,     0,   290,     0,
     291,   292,   293,     0,   294,     0,   295,     0,     0,     0,
     296,   297,   298,     0,   299,   300,     0,   301,     0,   302,
     303,   304,   305,  2619,     0,   307,   308,   309,     0,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,     0,
       0,   326,     0,   327,   328,   329,   330,   331,   332,   333,
       0,   334,   335,     0,   336,     0,     0,   337,   338,   339,
       0,     0,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,   355,   356,
       0,   357,   358,     0,   359,     0,   360,   361,   362,   363,
     364,   365,     0,   366,     0,     0,   367,   368,   369,     0,
       0,   370,     0,     0,     0,   371,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,     0,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,     0,   408,   409,     0,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
       0,   421,   422,   423,   424,   425,     0,   426,   427,   428,
     429,     0,   430,   431,   432,     0,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,     0,   444,   445,
       0,   446,   447,   448,   449,   450,   451,     0,   452,   453,
       0,     0,   454,   455,   456,   457,     0,   458,   459,   460,
     461,   462,   463,   464,     0,     0,   465,   466,   467,   468,
     469,     0,     0,   470,   471,   472,   473,   474,   475,   476,
       0,   477,     0,   478,   479,   480,     0,     0,   481,     0,
       0,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,  1334,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,   212,     0,     0,     0,   213,
     214,     0,   215,   216,   714,   217,   218,   219,     0,  1335,
     715,  1336,  1337,     0,   224,   225,   226,   227,   228,     0,
       0,   229,   230,  1338,  1339,   233,     0,   234,   235,   236,
     237,     0,     0,   716,     0,   239,   240,   241,   242,   717,
     243,   244,     0,   245,   246,   247,   248,   249,   250,     0,
     718,   251,   252,     0,     0,     0,   719,     0,     0,     0,
     253,   254,   255,   256,   257,   258,  1340,  1341,   261,     0,
     262,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,     0,   271,   272,  1009,   274,   275,     0,   276,
     277,   278,     0,   279,   280,     0,   281,   282,   283,   284,
       0,   286,   287,   288,     0,     0,   290,     0,   291,  1342,
     293,     0,   294,     0,   295,   720,     0,   721,   296,   297,
     298,     0,   299,     0,     0,   301,     0,   302,   303,   304,
     305,   306,   722,   307,   308,   309,     0,   310,   311,   312,
     313,   314,   315,     0,   316,   723,     0,   318,   319,   320,
     321,  1343,  1344,     0,  1345,     0,   325,   724,   725,   326,
     726,   327,   328,   329,   330,   331,   332,   333,     0,   334,
       0,   727,   336,   728,     0,   337,   338,   339,     0,     0,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,  1346,   729,  1347,   354,   355,     0,     0,   357,
     358,   730,   359,  1872,     0,   361,  1348,   363,   364,   365,
       0,   366,     0,     0,   367,   368,   369,     0,     0,     0,
     731,   732,   733,     0,   372,   373,   374,   375,   376,   377,
     378,     0,   379,     0,   381,     0,   383,   384,   385,     0,
     386,   387,   388,   389,   390,   391,   392,  1349,   394,   395,
     396,   397,     0,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   734,   410,   411,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,     0,   426,  1887,   428,   429,   735,
     430,  1351,   432,     0,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,     0,     0,   444,   445,  3274,   446,
     447,   448,   449,   450,   451,     0,  1352,  1353,     0,     0,
     454,     0,   456,     0,     0,   458,   459,   460,   461,   462,
     463,   464,     0,     0,   465,   466,   467,   468,   469,     0,
       0,   470,   471,   472,   473,   474,     0,  1354,     0,   477,
     736,   478,   479,   480,     0,     0,   481,     0,     0,   482,
     483,   484,   485,   486,     0,  1334,     0,     0,     0,     0,
       0,     0,     0,   496,   497,   498,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,   212,     0,     0,     0,   213,   214,     0,   215,
     216,   714,   217,   218,   219,     0,  1335,   715,  1336,  1337,
       0,   224,   225,   226,   227,   228,     0,     0,   229,   230,
    1338,  1339,   233,     0,   234,   235,   236,   237,     0,     0,
     716,     0,   239,   240,   241,   242,   717,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,   718,   251,   252,
       0,     0,     0,   719,     0,     0,     0,   253,   254,   255,
     256,   257,   258,  1340,  1341,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,  1009,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,     0,   286,   287,
     288,     0,     0,   290,     0,   291,  1342,   293,     0,   294,
       0,   295,   720,     0,   721,   296,   297,   298,     0,   299,
       0,     0,   301,     0,   302,   303,   304,   305,   306,   722,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,   723,     0,   318,   319,   320,   321,  1343,  1344,
       0,  1345,     0,   325,   724,   725,   326,   726,   327,   328,
     329,   330,   331,   332,   333,     0,   334,     0,   727,   336,
     728,     0,   337,   338,   339,     0,     0,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,  1346,
     729,  1347,   354,   355,  1935,     0,   357,   358,   730,   359,
       0,     0,   361,  1348,   363,   364,   365,     0,   366,     0,
       0,   367,   368,   369,     0,     0,     0,   731,   732,   733,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,     0,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,  1349,   394,   395,   396,   397,     0,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
       0,   408,   409,   734,   410,   411,     0,   413,   414,   415,
     416,   417,   418,   419,   420,     0,   421,   422,   423,   424,
     425,     0,   426,  1350,   428,   429,   735,   430,  1351,   432,
       0,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,     0,     0,   444,   445,     0,   446,   447,   448,   449,
     450,   451,     0,  1352,  1353,     0,     0,   454,     0,   456,
       0,     0,   458,   459,   460,   461,   462,   463,   464,     0,
       0,   465,   466,   467,   468,   469,     0,     0,   470,   471,
     472,   473,   474,     0,  1354,     0,   477,   736,   478,   479,
     480,     0,     0,   481,     0,     0,   482,   483,   484,   485,
     486,     0,  1334,     0,     0,     0,     0,     0,     0,     0,
     496,   497,   498,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,   212,
       0,     0,     0,   213,   214,     0,   215,   216,   714,   217,
     218,   219,     0,  1335,   715,  1336,  1337,     0,   224,   225,
     226,   227,   228,     0,     0,   229,   230,  1338,  1339,   233,
       0,   234,   235,   236,   237,     0,     0,   716,     0,   239,
     240,   241,   242,   717,   243,   244,     0,   245,   246,   247,
     248,   249,   250,     0,   718,   251,   252,     0,     0,     0,
     719,     0,     0,     0,   253,   254,   255,   256,   257,   258,
    1340,  1341,   261,     0,   262,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,     0,   271,   272,  1009,
     274,   275,     0,   276,   277,   278,     0,   279,   280,     0,
     281,   282,   283,   284,     0,   286,   287,   288,     0,     0,
     290,     0,   291,  1342,   293,     0,   294,     0,   295,   720,
       0,   721,   296,   297,   298,     0,   299,     0,     0,   301,
       0,   302,   303,   304,   305,   306,   722,   307,   308,   309,
       0,   310,   311,   312,   313,   314,   315,     0,   316,   723,
       0,   318,   319,   320,   321,  1343,  1344,     0,  1345,     0,
     325,   724,   725,   326,   726,   327,   328,   329,   330,   331,
     332,   333,     0,   334,     0,   727,   336,   728,     0,   337,
     338,   339,     0,     0,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,  1346,   729,  1347,   354,
     355,  3093,     0,   357,   358,   730,   359,     0,     0,   361,
    1348,   363,   364,   365,     0,   366,     0,     0,   367,   368,
     369,     0,     0,     0,   731,   732,   733,     0,   372,   373,
     374,   375,   376,   377,   378,     0,   379,     0,   381,     0,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,  1349,   394,   395,   396,   397,     0,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,     0,   408,   409,
     734,   410,   411,     0,   413,   414,   415,   416,   417,   418,
     419,   420,     0,   421,   422,   423,   424,   425,     0,   426,
    1350,   428,   429,   735,   430,  1351,   432,     0,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,     0,     0,
     444,   445,     0,   446,   447,   448,   449,   450,   451,     0,
    1352,  1353,     0,     0,   454,     0,   456,     0,     0,   458,
     459,   460,   461,   462,   463,   464,     0,     0,   465,   466,
     467,   468,   469,     0,     0,   470,   471,   472,   473,   474,
       0,  1354,     0,   477,   736,   478,   479,   480,     0,     0,
     481,     0,     0,   482,   483,   484,   485,   486,     0,   199,
       0,     0,     0,     0,     0,     0,     0,   496,   497,   498,
     200,   201,   202,   203,   204,   205,   206,   207,     0,   209,
     210,   211,     0,     0,     0,     0,   212,     0,     0,     0,
     213,   214,     0,   215,   216,     0,   217,   218,   219,   220,
     221,     0,   222,   223,     0,   224,   225,   226,   227,   228,
       0,     0,   229,   230,   231,   232,   233,     0,   234,   235,
     236,   237,   238,     0,     0,     0,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,     0,   251,   252,     0,     0,     0,     0,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,     0,   295,     0,     0,     0,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,     0,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,     0,     0,
     326,     0,   327,   328,   329,   330,   331,   332,   333,     0,
     334,   335,     0,   336,     0,     0,   337,   338,   339,     0,
       0,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   355,   356,     0,
     357,   358,     0,   359,     0,   360,   361,   362,   363,   364,
     365,     0,   366,     0,     0,   367,   368,   369,     0,     0,
     370,     0,     0,     0,   371,   372,   373,   374,   375,     0,
     377,   378,     0,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,     0,   392,   393,   394,
     395,   396,   397,     0,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,     0,   408,   409,     0,   410,   411,
     412,     0,   414,   415,   416,   417,   418,   419,   420,     0,
     421,   422,   423,   424,   425,     0,   426,   427,   428,   429,
       0,   430,   431,   432,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,     0,   444,   445,     0,
     446,   447,   448,   449,   450,   451,     0,   452,   453,     0,
       0,   454,   455,   456,   457,     0,   458,   459,   460,   461,
     462,   463,   464,     0,     0,   465,   466,   467,   468,   469,
       0,     0,   470,   471,   472,   473,   474,   475,   476,     0,
     477,     0,   478,   479,   480,     0,     0,   481,     0,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,  1334,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,   212,     0,     0,     0,   213,   214,
       0,   215,   216,   714,   217,   218,   219,     0,  1335,   715,
    1336,  1337,     0,   224,   225,   226,   227,   228,     0,     0,
     229,   230,  1338,  1339,   233,     0,   234,   235,   236,   237,
       0,     0,   716,     0,   239,   240,   241,   242,   717,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,   718,
     251,   252,     0,     0,     0,   719,     0,     0,     0,   253,
     254,   255,   256,   257,   258,  1340,  1341,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,  1009,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,     0,
     286,   287,   288,     0,     0,   290,     0,   291,  1342,   293,
       0,   294,     0,   295,   720,     0,   721,   296,   297,   298,
       0,   299,     0,     0,   301,     0,   302,   303,   304,   305,
     306,   722,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,   723,     0,   318,   319,   320,   321,
    1343,  1344,     0,  1345,     0,   325,   724,   725,   326,   726,
     327,   328,   329,   330,   331,   332,   333,     0,   334,     0,
     727,   336,   728,     0,   337,   338,   339,     0,     0,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,  1346,   729,  1347,   354,   355,     0,     0,   357,   358,
     730,   359,     0,     0,   361,  1348,   363,   364,   365,     0,
     366,     0,     0,   367,   368,   369,     0,     0,     0,   731,
     732,   733,     0,   372,   373,   374,   375,   376,   377,   378,
       0,   379,     0,   381,     0,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,  1349,   394,   395,   396,
     397,     0,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,     0,   408,   409,   734,   410,   411,     0,   413,
     414,   415,   416,   417,   418,   419,   420,     0,   421,   422,
     423,   424,   425,     0,   426,  1350,   428,   429,   735,   430,
    1351,   432,     0,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,     0,     0,   444,   445,     0,   446,   447,
     448,   449,   450,   451,     0,  1352,  1353,     0,     0,   454,
       0,   456,     0,     0,   458,   459,   460,   461,   462,   463,
     464,     0,     0,   465,   466,   467,   468,   469,     0,     0,
     470,   471,   472,   473,   474,     0,  1354,     0,   477,   736,
     478,   479,   480,     0,     0,   481,     0,     0,   482,   483,
     484,   485,   486,     0,  1334,     0,     0,     0,     0,     0,
       0,     0,   496,   497,   498,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,   212,     0,     0,     0,   213,   214,     0,   215,   216,
     714,   217,   218,   219,     0,  1335,   715,  1336,  1337,     0,
     224,   225,   226,   227,   228,     0,     0,   229,   230,  1338,
    1339,   233,     0,   234,   235,   236,   237,     0,     0,   716,
       0,   239,   240,   241,   242,   717,   243,   244,     0,   245,
     246,   247,   248,   249,   250,     0,   718,   251,   252,     0,
       0,     0,   719,     0,     0,     0,   253,   254,   255,   256,
     257,   258,  1340,  1341,   261,     0,   262,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,     0,   271,
     272,  1009,   274,   275,     0,   276,   277,   278,     0,   279,
     280,     0,   281,   282,   283,   284,     0,   286,   287,   288,
       0,     0,   290,     0,   291,  1342,   293,     0,   294,     0,
     295,   720,     0,   721,   296,   297,   298,     0,   299,     0,
       0,   301,     0,   302,   303,   304,   305,   306,   722,   307,
     308,   309,     0,   310,   311,   312,   313,   314,   315,     0,
     316,   723,     0,   318,   319,   320,   321,  1343,  1344,     0,
    1345,     0,   325,   724,   725,   326,   726,   327,   328,   329,
     330,   331,   332,   333,     0,   334,     0,   727,   336,   728,
       0,   337,   338,   339,     0,     0,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,  1346,   729,
    1347,   354,   355,     0,     0,   357,   358,   730,   359,     0,
       0,   361,  1348,   363,   364,   365,     0,   366,     0,     0,
     367,   368,   369,     0,     0,     0,   731,   732,   733,     0,
     372,   373,   374,   375,   376,   377,   378,     0,   379,     0,
     381,     0,   383,   384,   385,     0,   386,   387,   388,   389,
     390,   391,   392,  1349,   394,   395,   396,   397,     0,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,     0,
     408,   409,   734,   410,   411,     0,   413,   414,   415,   416,
     417,   418,   419,   420,     0,   421,   422,   423,   424,   425,
       0,   426,  1887,   428,   429,   735,   430,  1351,   432,     0,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
       0,     0,   444,   445,     0,   446,   447,   448,   449,   450,
     451,     0,  1352,  1353,     0,     0,   454,     0,   456,     0,
       0,   458,   459,   460,   461,   462,   463,   464,     0,     0,
     465,   466,   467,   468,   469,     0,     0,   470,   471,   472,
     473,   474,     0,  1354,     0,   477,   736,   478,   479,   480,
       0,     0,   481,     0,     0,   482,   483,   484,   485,   486,
       0,  1334,     0,     0,     0,     0,     0,     0,     0,   496,
     497,   498,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,   212,     0,
       0,     0,   213,   214,     0,   215,   216,   714,   217,   218,
     219,     0,  1335,   715,  1336,  1337,     0,   224,   225,   226,
     227,   228,     0,     0,   229,   230,  1338,  1339,   233,     0,
     234,   235,   236,   237,     0,     0,   716,     0,   239,   240,
     241,   242,   717,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,   718,   251,   252,     0,     0,     0,   719,
       0,     0,     0,   253,   254,   255,   256,   257,   258,  1340,
    1341,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,  1009,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,     0,   286,   287,   288,     0,     0,   290,
       0,   291,  1342,   293,     0,   294,     0,   295,   720,     0,
     721,   296,   297,   298,     0,   299,     0,     0,   301,     0,
     302,   303,   304,   305,   306,   722,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,   723,     0,
     318,   319,   320,   321,  1343,  1344,     0,  1345,     0,   325,
     724,   725,   326,   726,   327,   328,   329,   330,   331,   332,
     333,     0,   334,     0,   727,   336,   728,     0,   337,   338,
     339,     0,     0,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,  1346,   729,  1347,   354,   355,
       0,     0,   357,   358,   730,   359,     0,     0,   361,  1348,
     363,   364,   365,     0,   366,     0,     0,   367,   368,   369,
       0,     0,     0,   731,   732,   733,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,     0,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
    1349,   394,   395,   396,   397,     0,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,     0,   408,   409,   734,
     410,   411,     0,   413,   414,   415,   416,   417,   418,   419,
     420,     0,   421,   422,   423,   424,   425,     0,   426,     0,
     428,   429,   735,   430,  1351,   432,     0,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,     0,     0,   444,
     445,     0,   446,   447,   448,   449,   450,   451,     0,  1352,
    1353,     0,     0,   454,     0,   456,     0,     0,   458,   459,
     460,   461,   462,   463,   464,     0,     0,   465,   466,   467,
     468,   469,     0,     0,   470,   471,   472,   473,   474,     0,
    1354,     0,   477,   736,   478,   479,   480,     0,     0,   481,
       0,     0,   482,   483,   484,   485,   486,     0,  1334,     0,
       0,     0,     0,     0,     0,     0,   496,   497,   498,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,   212,     0,     0,     0,   213,
     214,     0,   215,   216,   714,   217,   218,   219,     0,     0,
     715,     0,     0,     0,   224,   225,   226,   227,   228,     0,
       0,   229,   230,     0,     0,   233,     0,   234,   235,   236,
     237,     0,     0,   716,     0,   239,   240,   241,   242,   717,
     243,   244,     0,   245,   246,   247,   248,   249,   250,     0,
     718,   251,   252,     0,     0,     0,   719,     0,     0,     0,
     253,   254,   255,   256,   257,   258,     0,     0,   261,     0,
     262,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,     0,   279,   280,     0,   281,   282,   283,   284,
       0,   286,   287,   288,     0,     0,   290,     0,   291,     0,
     293,     0,   294,     0,   295,   720,     0,   721,   296,   297,
     298,     0,   299,     0,     0,   301,     0,   302,   303,   304,
     305,   306,   722,   307,   308,   309,     0,   310,   311,   312,
     313,   314,   315,     0,   316,   723,     0,   318,   319,   320,
     321,     0,     0,     0,     0,     0,   325,   724,   725,   326,
     726,   327,   328,   329,   330,   331,   332,   333,     0,   334,
       0,   727,   336,   728,     0,   337,   338,   339,     0,     0,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,     0,   729,     0,   354,   355,     0,     0,   357,
     358,   730,   359,     0,     0,   361,     0,   363,   364,   365,
       0,   366,     0,     0,   367,   368,   369,     0,     0,     0,
     731,   732,   733,     0,   372,   373,   374,   375,   376,   377,
     378,     0,   379,     0,   381,     0,   383,   384,   385,     0,
     386,   387,   388,   389,   390,   391,   392,     0,   394,   395,
     396,   397,     0,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,     0,   408,   409,   734,   410,   411,     0,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   421,
     422,   423,   424,   425,     0,   426,     0,   428,   429,   735,
     430,     0,   432,     0,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,     0,     0,   444,   445,     0,   446,
     447,   448,   449,   450,   451,     0,     0,     0,     0,     0,
     454,     0,   456,     0,     0,   458,   459,   460,   461,   462,
     463,   464,     0,     0,   465,   466,   467,   468,   469,     0,
       0,   470,   471,   472,   473,   474,     0,     0,     0,   477,
     736,   478,   479,   480,     0,     0,   481,     0,     0,   482,
     483,   484,   485,   486,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   496,   497,   498
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-3845)))

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-2171)))

static const yytype_int16 yycheck[] =
{
       0,     0,     0,     0,     0,     0,    47,    16,   164,   893,
     660,    11,    33,   929,    21,    24,   707,   951,   901,    26,
      20,   525,    20,  1111,   172,   618,   619,   620,   921,   712,
      42,   624,   180,     7,  1177,  1211,   781,   184,   738,   802,
      14,  1499,   965,  1129,  1216,   785,    21,    47,   793,   764,
    2205,    26,  1600,  1350,  1036,  2357,   181,    12,   855,  1934,
    1307,   186,  1007,  1008,   568,  2488,   897,   864,   667,  1220,
     195,  2762,   837,  1216,  1569,   978,  1164,  1892,  1893,  1388,
      22,  1026,    17,  1113,  1229,  1367,   570,  1403,  1583,    20,
    2363,    33,   552,  2538,  1535,  2540,   580,   842,  1211,  1388,
     845,   182,  2701,  1388,  2406,   850,   517,   188,  1388,  1388,
    1388,  1981,   857,  1134,  1263,   196,  2184,  2665,  1761,   884,
    1271,   866,   552,  2683,  2359,  2360,  2972,  2413,  2361,  3006,
    1160,  1276,  1277,  3057,   151,  2683,  1631,    41,  3275,  3236,
    1456,   587,     0,  3254,   166,     0,     0,  3013,     0,     0,
     561,  1203,  1164,   784,    38,  2984,   787,   754,   588,  3477,
    2296,  1054,  2877,   793,   795,  1412,   166,     5,  2944,  2945,
    3217,    18,  1405,  3669,   166,   704,   996,   997,  2687,  2688,
    2689,  2690,  2691,  2692,     5,     5,  1144,     9,    11,    32,
    2065,     0,    13,    13,   704,    45,    38,     0,  2026,    59,
       9,    67,  1022,   663,    16,  3915,     9,  2939,    38,    36,
      26,    27,  3798,    22,   929,   104,    52,    73,    30,    22,
      52,    80,     5,     5,     5,    25,   151,   157,     0,    22,
      13,   104,   106,   663,    52,  3908,    29,    36,     0,     5,
       5,   111,   835,    22,    22,   160,    99,   146,    22,     5,
      29,    29,     5,   134,     0,     0,  2131,   152,  2133,   130,
     121,  2490,     5,   243,    11,   151,   104,     0,    23,     5,
     160,     5,   243,    97,   121,   253,   243,     0,    59,  2262,
    2263,   109,  1370,  2419,  2267,    65,   190,   128,   151,     5,
      37,   231,     5,   121,    59,     5,     5,    71,     5,   248,
     106,     5,  3868,    52,    78,   173,   174,     5,   133,   177,
     178,   164,    18,   151,  3180,   231,   820,   188,   151,    20,
      67,   133,     9,     4,  2307,  2308,   194,   314,     9,   146,
     107,   105,   151,    35,   150,  1098,   152,     8,   304,     5,
      41,   231,   151,    97,     3,     4,     5,     4,   151,    33,
       9,    84,     9,   220,     9,  1055,   343,    22,    79,  1942,
     171,    84,   171,   291,   512,   253,  1386,   220,   171,    69,
     223,  1353,   428,    11,  4218,   431,    32,    77,   525,   151,
    1080,  1096,   253,    39,  1404,    11,  1101,  1102,   194,   151,
     251,   168,   320,  1851,    11,  1340,  1341,   118,   523,   171,
     387,   175,   527,  1348,  3900,   151,   151,   373,   556,   171,
    1496,    37,  1995,   538,  1500,   121,  1502,   565,   902,  1505,
      37,   568,   310,   156,   505,   171,   171,   233,   112,   510,
     185,  1315,   313,   156,   295,  3482,  1319,   296,   104,   280,
     313,    67,  4286,   271,   311,   104,    69,   427,   397,    69,
      67,   116,  4018,   431,    77,   198,   427,   917,   311,   320,
     427,   297,   343,   379,   379,   297,   246,   353,   170,   409,
     343,  2700,    69,   957,    69,   281,   293,   231,  1193,   297,
    4153,    77,   238,   967,   185,   931,  1201,   917,   123,   379,
     256,  3000,   304,   317,   294,   979,   367,   322,   507,   929,
     381,   431,   427,   377,  1534,   375,   306,    31,   381,   365,
     322,  4097,   393,   340,  1259,   353,  1261,  1605,  1338,  1339,
     393,  3081,   982,   353,  3896,   414,   373,  1347,   427,  1269,
     189,    22,   427,  3081,  1331,   328,  1251,  4247,   380,  1254,
    1255,   340,  1305,   552,   553,  1310,   427,   588,   297,   328,
     328,   707,   982,   212,   427,   408,  1490,   357,   639,   425,
    1191,  3672,   336,   429,  1594,   298,   192,   427,   431,   385,
    2445,   506,   431,   590,   427,   298,   414,   427,   249,   660,
     104,   334,   335,  1328,   427,   291,   427,   587,   588,   587,
    1887,   429,   599,  3640,   601,   431,   603,   678,   431,   431,
     423,  1316,   609,   384,   426,  3471,   427,   427,  1638,   418,
     419,  1569,   431,  1210,  1896,   418,   419,  1247,   699,  3334,
     431,   430,  1151,   632,   599,  1583,   601,   430,   603,  1460,
    3229,   586,  3461,  1093,   609,   610,   611,  2939,  3685,   613,
    1533,  1151,  1535,   652,   427,   427,   427,   515,  4144,  3248,
     659,   519,  1545,   662,   663,   664,  1549,   588,   430,   807,
     393,  3979,   427,  1093,  1557,  1558,  1497,   535,   430,   817,
     393,  1101,  1102,   820,   696,  1506,   423,  1570,  1571,  3411,
    4052,  2954,   431,  3415,   430,   430,   384,   394,  1581,  3198,
     394,   427,  2507,   427,  2509,   428,   696,   430,   698,   698,
     698,   698,   698,   698,   696,   428,   413,   430,  3010,   413,
    4206,   427,  1863,  1946,   427,   425,  1892,   427,   427,   429,
     427,    11,  1810,   427,   872,   629,  2959,    52,  1900,   427,
     353,   418,   419,   353,   106,    99,   393,   418,   419,  1243,
     427,  1561,  1562,   414,   415,   416,  3793,   418,   419,   420,
     421,   422,   423,  3800,   389,   686,   353,   353,   353,   418,
     419,   418,   419,   418,   419,   190,   847,  2262,  2263,  2644,
    2645,     8,  2267,    97,    11,    97,   267,   661,   682,   109,
      84,   665,   420,   421,   422,   423,   867,   868,   869,   764,
       3,    28,   418,   419,   420,   421,   422,   423,  1810,   103,
     164,   104,    11,   420,   421,   422,   423,   711,    18,     5,
     247,  2639,  2307,  2308,  2642,  2643,  1409,   246,  2646,   133,
      97,   109,   194,    97,  2372,    97,   133,   836,  2656,  1881,
     134,  3987,  3988,  4205,    98,  1923,     3,  4209,     5,    75,
     698,    18,    45,   698,   698,   276,   698,   698,   109,   753,
    2665,   160,  2988,  1503,  1504,   346,   220,   348,     5,   223,
     159,   233,  3285,    76,     5,    97,   104,   108,  2683,    61,
     304,   192,   104,   151,  4246,   956,  2859,   113,   104,  2862,
    2863,  2864,  2865,  2866,  2867,  2868,  2869,  2870,  2871,  2061,
     414,  1591,    95,   745,   247,   153,   184,   978,   766,   767,
     154,   425,   192,   427,   428,   429,   231,   431,   917,   281,
     174,   121,   104,   126,  3765,   142,  3767,   151,   107,   106,
     929,   164,   231,   184,     5,  4062,   247,  4038,     9,   260,
     233,   931,    99,   931,  2110,   116,  1440,   118,  2921,  2922,
     875,   793,   251,   260,   121,  2760,   153,   311,  1432,    75,
     191,  2100,   109,   962,   929,   192,   908,    58,    59,  1443,
     934,    75,   936,   176,   938,   833,   940,   919,   942,   943,
     944,  1455,   297,   982,   291,   949,  3752,   220,    61,   168,
     183,   154,   209,   192,   153,   853,   854,   113,   425,   320,
     990,   249,   429,   427,  3685,   320,   427,   164,   427,   113,
     238,   233,   870,   302,  3870,   308,   431,   233,   322,   313,
    1010,    75,   249,  1054,   152,   322,    18,  1428,  4174,   343,
    1466,   343,    24,   104,  3756,   261,  1107,   184,   231,  3761,
     898,   899,  3764,     8,  4145,    43,    11,  1467,   145,   343,
    1040,   233,   238,   373,   408,   253,   238,  1056,   131,   113,
     260,   238,   265,   220,  1054,  4152,   223,  1066,     5,   431,
      75,   315,   243,  1567,  3509,   148,   343,  1076,   311,   343,
     379,   343,   360,  1154,   308,   353,     5,   381,   342,   343,
     249,   291,   274,   260,  1093,   373,  2172,  1096,  1097,   393,
     344,   238,  1101,  1102,   253,   287,  1243,   238,   113,   306,
    3977,   333,    84,  2048,   336,  1122,   309,  4154,  3959,  3411,
     320,   347,   373,  3415,   291,  1137,  1138,  4041,  1140,   121,
     108,  1096,   320,   427,   262,  3991,  1101,  1102,   418,   419,
     420,   421,   422,   423,  1215,   261,   414,  1137,  1138,   385,
    1140,  1222,   315,   320,   311,  1137,  1138,   261,  1140,    61,
     143,   429,   386,   366,   361,     5,   313,   104,  3801,   167,
    3433,   374,   269,   171,   377,    77,  1291,   336,   378,  1250,
    3443,   344,    39,  3459,   156,   104,   368,   414,   415,   416,
    1977,   418,   419,   420,   421,   422,   423,   325,   343,  3424,
     363,   274,    18,    60,   260,   427,  3429,   261,    24,  2287,
     208,  1282,    96,   191,    11,  2293,   293,   281,  3441,   418,
     419,   420,   421,   422,   423,  1296,   373,   192,  1193,   131,
     428,   347,  2504,   431,  3956,   291,  1201,  3210,  1309,  2511,
      37,   429,  3875,   347,  1949,   302,   148,   230,  4104,    18,
    2124,   408,  1957,   306,  1959,    24,   261,  3315,   322,  1153,
     375,  2134,    22,  1188,   320,  4101,  4102,   273,  1267,   260,
      67,  1236,  1387,   106,   259,  3825,  3081,   106,  1899,   428,
      11,   146,   431,  1421,   249,   152,  1251,  3825,  1403,  1254,
    1255,   156,  1430,   347,  3883,   368,  2083,  2084,  2085,  2086,
     291,    20,    53,  1440,   357,   121,   171,  2128,  2095,   373,
      61,    77,   427,   180,  2262,  2263,   393,   374,  1433,  2267,
    4176,   353,    41,  3141,     8,  1946,   324,    11,   195,  3147,
    3148,  3149,  3150,  3151,  3152,   219,    67,   221,   104,   206,
    2506,  1456,   347,   197,   345,   178,  1967,  3980,  2231,   355,
    2798,  1316,   121,   353,   431,   107,   116,  3990,  1852,  2307,
    2308,  1499,  2995,  2118,  2440,   194,   322,  1225,   306,  2380,
     171,   427,   274,   314,  2859,  1996,  1270,  2862,  2863,  2864,
    2865,  2866,  2867,  2868,  2869,  2870,  2871,  3247,   295,   395,
    1389,  4227,   393,   394,  1465,   192,   193,  2280,   231,   431,
     233,  2832,   343,  2506,   233,  1247,   355,  2892,  3381,  3382,
    4266,   306,   428,   320,  1815,   431,   168,   373,  2717,   357,
    1278,  1279,  1280,  1281,  1898,   375,   427,  3292,  2311,  3294,
    1567,   431,  1503,  1504,   301,   300,  2921,  2922,  2717,   236,
    4029,   839,  2717,  2582,   260,   393,   387,  2717,  2717,  2717,
    2591,   273,   281,   418,   419,   420,   421,   422,   423,  1317,
    1318,   212,   357,  2346,  3756,  1323,   368,   233,   393,  3761,
     280,  2176,  3764,  4154,   427,   291,  1466,   427,  1466,   160,
    1422,  2787,   375,   431,   155,   142,     0,   171,   394,  1431,
     291,   260,   431,  1435,   295,   305,    85,   142,   327,  1441,
    1442,   146,  3794,  3916,   320,    76,   431,   413,   192,  3772,
    3773,  1369,  1476,    50,  1478,  1526,  1480,  1459,  1482,   320,
    1484,   116,   291,   118,  1488,   430,  2450,  1517,  1517,  1517,
    1517,  1517,  1517,   355,   427,  1393,  1394,  1395,  1396,  1940,
     355,   212,   601,   602,   603,   132,  1467,   606,   607,   608,
     231,   320,   209,    96,   125,  1554,   130,   616,  3703,    96,
    3995,     4,  1633,   152,   209,   249,     9,   965,   142,   153,
     291,  1642,   146,   395,   295,   428,   308,  2512,   431,   260,
     395,   393,  1547,  1548,  2662,   172,    32,  1445,   245,   251,
    1555,   180,   393,  1525,  1559,  1560,  1454,   181,   260,   320,
     245,   106,  2475,  1461,  2682,    51,   195,  1532,   155,  1574,
     291,  1576,  2747,   345,   188,  2750,  3908,   206,  1512,   431,
    1610,   418,   419,   420,   421,   422,   423,  3492,  3493,   291,
     201,   202,  1597,   176,  1599,   209,   173,    83,   233,   228,
     151,   146,  3822,  3788,   215,  3790,  2854,   146,   243,     8,
     393,   394,    11,  1652,  4067,   233,  3194,   304,   247,   260,
     171,   393,   394,  2113,  3956,   212,  3846,   166,  2373,   281,
    2878,   245,   393,   178,   291,   346,   219,   348,   221,   253,
     292,   308,   219,   276,   221,   332,  1757,   414,  1759,   260,
     291,  1806,   138,  2113,   231,   427,  1811,  2147,   379,  1814,
     371,   279,   429,   320,   316,   310,   308,  1845,  3971,   116,
    2465,   118,   301,  1851,   242,  1852,   387,    85,   345,   320,
    2796,  1836,   259,   169,   386,  3210,   231,  2147,   233,   198,
     414,   415,   416,   140,   418,   419,   420,   421,   422,   423,
     247,   426,  3715,   345,     8,   252,   431,    11,   426,    11,
    1608,   146,   198,   431,   346,  1870,   348,  2397,   204,   296,
    1158,  2491,  3034,   353,  3582,  3583,   393,   394,  3741,  3742,
     346,   166,   348,    37,   345,    37,   347,  3014,  1775,    43,
     247,  2370,  1897,   308,   152,   252,   375,   233,   427,  2519,
     422,   393,   394,   367,   331,   427,   425,   429,   427,   346,
     427,   348,  2726,    67,   260,    67,  1921,  1797,  1797,  1820,
    1775,  1822,   180,    21,  1756,   425,  2894,   427,    26,   429,
     345,  2674,  2675,  2676,   371,   427,  1941,   195,   142,  1944,
     357,   238,   146,   192,  2328,   291,   243,  1758,   206,   295,
     293,  3379,   428,  1241,   260,   431,  1917,  1962,   116,   295,
     118,   425,   425,   299,   428,   429,   429,  1972,    77,   305,
     228,  4153,   428,   308,   320,   431,   312,   260,   393,   394,
    1985,  2492,   140,   932,   320,   291,   935,  1876,   937,  1994,
     939,  2901,   941,   329,   428,     8,   945,   431,    11,   428,
     249,   337,   431,   310,     0,   209,  3381,  3382,   291,   260,
     345,  3042,   427,  1585,   320,    28,  1588,   171,    81,  2881,
    2882,  2859,   166,  1311,  2862,  2863,  2864,  2865,  2866,  2867,
    2868,  2869,  2870,  2871,  3059,  3060,  2819,   320,   192,   193,
     291,   245,  1330,   301,   295,   174,   155,   234,   235,   428,
     428,   430,   388,   431,  2892,    74,   392,   393,   393,   394,
     260,  2825,   359,  2373,   427,   174,   429,  3930,   313,   320,
    2695,    49,   369,  2437,  2438,   233,   428,   310,  1862,   431,
     238,   198,   236,  2921,  2922,   243,  2996,  1375,    84,   304,
     305,   291,   427,  1982,  1949,   249,   304,   305,   343,  1847,
    1848,  1849,  1957,   212,  1959,  2066,  1854,   427,  1856,   429,
    1858,  1859,  3080,   427,  3082,  2888,  2919,   393,   394,   313,
     320,   394,     5,  2463,     9,  3880,   313,    10,   428,  2018,
    3825,   431,   411,   412,   130,    18,   381,  2026,  4173,  1427,
     413,  3849,   393,   252,   428,   427,   142,   431,   393,   343,
     146,    34,   247,  2463,   427,   151,   343,    21,     8,   428,
     156,    11,   431,   159,   431,   161,   415,   416,   308,   418,
     419,   420,   421,   422,   423,   427,  3228,  2182,  2823,   192,
      49,  2209,   427,   394,    39,   428,  2214,   381,   431,   410,
    2045,    55,   188,  2082,   381,   393,   394,  3011,  3012,  3376,
    2205,   359,   413,   194,    68,   345,   393,  1955,   969,   970,
    2574,   369,  3268,   209,   308,  3910,   427,    81,  2107,  2398,
    2399,   422,  2102,  2102,  2113,  3050,   427,   429,   429,   428,
    3253,  2826,   431,   427,  2069,   428,   249,   346,   431,   348,
     427,   250,  2279,  2716,  2281,  2282,    26,    27,   357,   245,
     346,   345,   348,   393,   394,   119,   250,   253,  2147,   368,
     247,   353,   371,  2011,   418,   419,   420,   421,   422,   423,
     146,  2019,  2020,  2021,  2022,  2023,  2024,   428,     8,   235,
     431,    11,   410,  3160,   148,  3162,   250,   427,  3165,   153,
    3167,  2123,   428,   428,     8,   431,   431,    11,    28,   393,
     394,  2328,   298,   346,    84,   348,     8,  2139,  2140,    11,
     428,  2143,   130,   431,    28,  1603,   428,  2149,  2961,   431,
      39,  2176,   428,   103,   142,   431,   247,   194,   146,  2357,
    2366,   428,   420,   427,   431,    37,  3302,  3303,  3304,   410,
    3715,    43,   192,   150,  2708,   428,  2710,   343,   431,  3724,
     428,  3779,   431,   431,   134,  2103,  2696,   313,  2698,   428,
     428,  3157,   431,   431,  2391,    67,  3741,  3742,  2948,   427,
     188,   367,  3210,   428,   428,  2207,   431,   431,  2406,   428,
    2951,  2952,  2130,   428,  2132,   249,  2696,   343,  2698,  2350,
    2311,   209,   428,    49,   390,   431,   392,   393,   428,   249,
     430,   414,   415,   416,   151,   418,   419,   420,   421,   422,
     423,   308,   428,   277,   701,   431,   703,  2422,   428,  2759,
    3416,   431,  3418,     8,   190,   381,    11,   245,   427,   425,
     396,  2311,   428,   429,   430,   253,  2397,   393,   428,   428,
      45,   431,   431,    28,   308,  2325,   429,   320,   345,  2759,
     314,   427,    37,   317,  2818,   135,   427,   429,    43,  2351,
    2352,  2353,   192,   428,  2344,   167,   431,   428,   135,   171,
     431,   427,   428,   135,   430,   247,  2224,  2357,   192,   343,
     428,    86,    67,   431,  2373,   349,   428,   146,  2409,   431,
     192,   193,  3704,  3705,  3706,  3707,   393,   394,   362,   428,
     428,   428,   431,   431,   431,   110,   208,  2387,  2387,  2387,
    2387,  2387,  2387,   135,  3134,  3425,  2371,   207,  2373,   249,
     125,   375,   428,   387,   129,   431,  2406,   106,  3866,  2409,
     427,   247,   427,   313,   236,   249,   428,   428,   428,   431,
     431,   431,   147,  3381,  3382,   242,  3456,   249,   428,   367,
     428,   431,  2557,   431,   310,  3930,   198,   162,   428,  2564,
      61,   431,  3157,   343,   414,   415,   416,   427,   418,   419,
     420,   421,   422,   423,  2463,   428,   428,   428,   431,   431,
     431,   393,   167,    32,  3387,   233,   171,   396,  3554,  3555,
    3363,  3557,   428,   428,   428,   431,   431,   431,    39,   428,
    3277,   381,   431,   428,   427,   385,   431,   192,   193,   428,
      39,   362,   431,   393,     8,   428,  1904,    11,   431,   260,
     146,  2453,   324,   208,   428,   277,  3594,   431,  3684,  2634,
      74,   135,   428,   238,    28,   431,   428,   428,  2665,   431,
     431,   246,   428,    37,   135,   431,   427,   427,   233,    43,
     135,   236,   396,   135,   135,  2544,  2683,   431,   135,   135,
     135,   247,   135,   135,   249,   135,   247,   252,   135,   135,
     343,    32,   427,    67,   279,   207,   147,   146,   146,   247,
       5,   427,     5,  2572,   414,   415,   416,   427,   418,   419,
     420,   421,   422,   423,  2526,   427,  2528,   270,   146,   427,
     414,   415,   416,   427,   418,   419,   420,   421,   422,   423,
     427,     5,  3307,   415,   416,   427,   418,   419,   420,   421,
     422,   423,   427,  2471,     5,  2473,  2474,   427,   427,   427,
       5,   427,   427,   427,   427,   427,     5,   257,   427,   324,
     427,  2702,   427,   427,   427,   427,   427,    32,  2036,   427,
    2639,   427,     3,  2642,  2643,   427,   427,  2646,    87,    32,
     207,   431,   146,   146,   320,   245,  2727,  2656,    19,   353,
    2798,   353,  2661,   167,  2735,   308,  2665,   171,  2739,   429,
     308,   353,  2787,  2615,   353,    77,   353,   353,  2620,   353,
    3604,   308,  2753,   135,  2683,   247,  2801,   312,   192,   193,
    3596,   204,   353,   353,   238,   353,    69,  2696,   247,  2698,
    2665,   374,   176,   243,   208,   427,  2821,  2672,  2673,   353,
     427,    77,  2677,   353,   260,    76,   375,   431,  2683,   414,
     415,   416,   375,   418,   419,   420,   421,   422,   423,   233,
    2729,    98,   236,   353,   353,   353,   431,  3157,    49,    51,
      49,   353,    21,   353,   353,   249,  2711,   353,  2819,   251,
     353,    38,    38,   353,   353,   308,   431,  3231,  3232,  2758,
    2759,  3894,   247,   396,    21,   126,   247,  3715,    61,   353,
     192,    83,   393,   427,    67,   427,  3724,   384,   427,  2769,
    2769,    32,    31,    20,    77,   135,   233,  3477,   427,    68,
     104,   387,   386,  3741,  3742,   215,   233,  2195,   243,    32,
     375,  2939,    81,   146,   427,    32,  3719,   135,   198,   309,
     171,   104,    69,   106,   135,   176,   135,   135,   135,    98,
     324,   242,   353,   375,   237,   104,   138,   375,  2770,   151,
     427,   351,  2774,  2775,   389,  2777,   410,  2779,  2780,   427,
     119,    98,    11,   225,   225,   320,  2788,   353,   351,   151,
     355,   188,   165,   375,    18,   428,  3591,   169,   137,   431,
      24,  2826,   119,   427,   427,  2936,  2937,  2938,   165,   148,
     431,   427,  3010,  3949,   153,   243,   248,   353,  2820,   308,
     159,   431,    76,  3959,   431,   178,  3769,   428,   353,   308,
     427,   148,   204,   375,   238,   174,   153,  4063,  2929,   238,
     196,    65,   196,   353,   265,   310,  2905,   198,  2939,   427,
     414,   415,   416,   238,   418,   419,   420,   421,   422,   423,
     199,   233,  3037,  2781,   247,    39,  2784,   327,   254,  2931,
    2932,  2933,  2934,   431,  4010,   353,  3860,   353,   246,  2929,
     233,   302,   199,   308,  3081,   238,   291,   317,   260,  2939,
     114,   281,   353,  3447,   353,    32,   192,   121,   192,  2958,
     124,   192,   192,   375,   375,   246,   192,   427,   414,  2827,
     249,    31,   425,   353,   425,   353,   353,   353,   427,   291,
     341,   274,  3930,   295,   414,   135,   317,   299,   146,   148,
     243,   427,   135,   305,   287,   393,   163,   317,   277,  3114,
     312,   247,  3117,   247,   146,   366,  4082,   163,   320,    32,
     135,   317,   176,   374,   146,   247,   377,   329,  3931,   247,
     277,   431,   171,   302,   171,   337,   171,   396,   431,   308,
      19,   157,   222,   247,   431,   314,    49,   431,   317,   343,
     242,   198,   428,   151,   428,   302,   410,   264,   410,   151,
     353,   308,  3935,   428,   428,   256,    13,   314,  3641,    13,
     431,   414,   247,   390,   343,   428,   345,   231,  2466,   233,
     349,   428,   428,   428,   428,   368,   388,   428,   357,   243,
     428,   428,  3081,   362,   250,  3998,   343,   251,   345,  4002,
    4003,   390,   428,   428,   428,   374,   260,   381,   427,  3098,
    3097,   298,  3101,   427,  3103,   362,   209,   247,   387,   174,
    4016,  3784,   428,   135,   353,   353,  3081,   427,   396,   182,
     427,   238,   251,   135,   353,  3999,  3197,  4000,  3127,  3128,
     387,   295,  3097,   353,   135,   209,   217,   265,   265,   217,
     353,   353,  3141,   353,   217,  3216,   353,   372,  3147,  3148,
    3149,  3150,  3151,  3152,   353,   308,   320,   353,  3157,   320,
     353,     0,  3161,  2561,   308,  2563,  4244,  3238,   135,   353,
    3028,  3029,  3030,  3031,    32,   308,  3596,   353,   308,   353,
     353,    38,   353,   192,   192,  4006,   192,  4008,   192,   192,
     192,     3,  3157,    51,   192,  3310,   311,   223,   209,   414,
     362,  3200,  3201,  3202,  3203,  3170,  3171,   425,  4091,   428,
     293,    97,   428,  4291,   378,   393,  3181,   428,  2616,   427,
     247,  4299,   431,   428,    32,    83,   246,   431,   160,   353,
     133,   431,   308,   308,   375,  3200,   375,   308,   133,    22,
      23,   192,  2640,   250,    27,    84,   425,   127,    31,    32,
      33,   151,    35,    11,   146,    38,    39,    59,    41,  3899,
      43,   151,   159,   428,   386,   428,  3265,   248,   428,   146,
      32,   375,   427,  3411,  3264,  3264,   428,  3415,   375,   308,
     138,   353,   428,   431,   182,   353,   146,   308,    67,  3970,
     427,   130,   428,   428,   428,   362,   362,   428,   353,   353,
     353,  3795,    97,   142,   427,   362,   427,   146,   428,   428,
    3447,   169,   151,   192,   192,   428,   428,   156,   428,   426,
     159,   426,   161,   196,  3323,   431,   427,  3398,  3399,  3400,
    3401,   393,   396,   146,   428,   431,  3830,   177,    72,   431,
     198,   427,  3307,   353,   428,   345,   204,  3289,  2746,   188,
    3208,   317,   156,   151,   192,  3297,  3298,    32,  4232,   192,
     192,   192,   151,   286,    49,   195,   391,   428,   427,   427,
     209,   255,   428,  2771,   391,   233,    51,   428,   428,   431,
     195,   427,    49,   161,   428,   428,   431,   243,   353,   172,
     173,   174,   175,    67,   177,   178,   414,   180,   151,   182,
     393,   184,   176,   362,   238,   188,   245,   190,    83,   238,
    3525,   194,   431,   196,   253,   414,   431,   353,   135,   192,
     111,  3411,  3537,   153,   238,  3415,   151,   375,   317,   426,
     375,    32,   122,   389,    97,   393,   427,   295,   393,   151,
    2838,   299,   427,   179,   250,  3444,   151,   305,   427,   427,
     286,   380,   428,   428,   312,   330,   427,   195,  3469,   298,
    2858,   392,   320,   138,  3454,  3454,  3463,   427,   287,   263,
     247,   329,   353,   393,   146,   428,   428,    32,   428,   337,
     427,   427,   238,   218,   427,  2883,   174,   134,   428,   305,
     251,    49,   427,    49,   169,   305,     8,   427,  3463,    11,
     231,   253,   247,   375,   343,   141,   278,    61,   345,   250,
      61,   117,   379,   431,   380,   286,    28,    32,  3515,   151,
    4103,  2919,   390,   198,   284,    37,   146,   122,   367,   204,
     388,    43,   393,   176,   392,    32,   247,   247,    49,   427,
     427,   250,   250,   428,   109,   428,  3488,   304,   373,   304,
    3515,   390,    17,   392,   393,    67,   427,    28,   233,   134,
     278,    51,   427,  3528,  3529,  1294,   757,  2068,  3533,  3534,
    1102,  2373,  1930,  2519,  3080,  1989,  2661,  3519,  3520,  3852,
     698,  3594,  4016,  3582,  3583,  3660,   425,  3889,  3703,   428,
     429,   430,  3257,    83,  3894,  3634,  4016,  3596,  2444,  3898,
    2164,  3600,  4180,  3602,  3794,  4099,  3605,  3606,  4231,  4136,
    4135,  4195,  4039,  2448,  3661,  3221,  3687,  2059,  3756,  3616,
     295,  2059,  3768,  3761,   299,  3076,  3764,  2539,  3226,  1390,
     305,  3228,  2054,  3575,  3576,  2728,  4236,   312,  4299,  4291,
    2682,  2667,  4202,  3832,  1382,   320,  4114,  4188,   138,  3835,
      26,  3616,  3310,   958,   329,   167,  3794,  3656,  3795,   171,
    3976,  3266,   337,  1893,  3268,  4063,  2618,  4214,  4293,  4031,
    1759,   553,   677,  3788,  1758,  3790,  2387,  3250,  1467,   169,
     192,   193,  2388,  2993,  3683,  1128,  1147,  1795,  3825,  3455,
    1146,  3829,  2400,  3830,   690,  2394,   208,  2414,  3556,  1794,
    1778,  1149,  2406,  3417,  2939,  3704,  3705,  3706,  3707,  3957,
     682,  1153,  3570,   388,   204,  2994,  2035,   392,  3933,  2904,
    2896,   233,   505,  4167,   236,  4168,  4171,   510,  3866,   512,
    2391,  2325,   515,  2233,   517,  2323,   519,   249,    -1,  2989,
     252,  1634,   525,   233,    -1,   528,    -1,  3689,    -1,  3691,
    3692,    -1,   535,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3702,    -1,    -1,    -1,    -1,    -1,  3756,    -1,    -1,    -1,
    3908,  3761,    -1,   556,  3764,    -1,    -1,    -1,   561,    -1,
      -1,    -1,   565,    -1,    -1,   568,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    11,  3869,    -1,
     583,  3659,    -1,    -1,    -1,   295,    -1,   297,    -1,   299,
      -1,    -1,   324,    -1,    28,   305,    -1,  3781,  3956,    -1,
      -1,    -1,   312,    37,    -1,    -1,  3825,    -1,  3899,    43,
     320,    -1,    -1,    -1,    -1,    -1,    -1,  3235,    -1,   329,
      -1,    -1,    -1,    -1,    -1,     0,   629,   337,    -1,    -1,
    3849,    -1,    -1,    67,  3853,    -1,   639,   640,    -1,    -1,
    3825,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   658,    -1,   660,   661,    -1,
      -1,    -1,   665,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3881,  3881,    -1,    -1,   678,    -1,    -1,   388,   682,
      -1,    -1,   414,   415,   416,   688,   418,   419,   420,   421,
     422,   423,    -1,    -1,   426,    -1,   699,    -1,  3989,    -1,
     432,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   711,    84,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3796,  3797,
    3798,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   167,    -1,    -1,    -1,   171,    -1,    -1,
      -1,    -1,  4099,    -1,    -1,    -1,  3956,    -1,    -1,    -1,
     753,    -1,    -1,    -1,    -1,   130,    -1,    -1,   192,   193,
      -1,    -1,  3924,   766,   767,    -1,    -1,   142,    -1,  3387,
      -1,   146,    -1,    -1,   208,    -1,   151,    -1,    -1,    -1,
      -1,   156,    -1,    -1,   159,  4143,   161,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4153,    -1,  4016,    -1,   233,
      -1,    -1,   236,    -1,   807,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   188,   817,   249,  3978,   820,   252,    -1,
      -1,    -1,    -1,    -1,    -1,  4183,    -1,    -1,    -1,  3907,
     833,    -1,    -1,    -1,   209,    -1,    -1,    -1,  4173,    -1,
      -1,    -1,    -1,    -1,   847,    -1,    -1,    -1,    -1,  4011,
     853,   854,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   867,   868,   869,   870,    -1,   872,
     245,    -1,  3490,    -1,    -1,    -1,    -1,    -1,   253,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     324,    -1,    -1,    -1,   897,   898,   899,    -1,    -1,    -1,
    3518,    -1,    -1,    -1,    -1,    -1,    -1,  3985,    -1,    -1,
      -1,    -1,  3530,    -1,    -1,    -1,    -1,    -1,   921,    -1,
      -1,    -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,  4007,
      -1,  4009,    18,    -1,    -1,    -1,    -1,  4295,    24,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   951,   952,
      -1,    -1,    -1,   956,    -1,   958,  3574,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   343,    -1,
      -1,    -1,   975,    -1,    -1,   978,    -1,    -1,   981,    65,
     414,   415,   416,    -1,   418,   419,   420,   421,   422,   423,
      -1,   994,   367,    -1,    -1,    -1,    -1,   431,  4249,    -1,
      -1,    -1,    -1,    -1,  4214,  4214,  4214,  4214,  4214,  4214,
      -1,    -1,    -1,    -1,    -1,   390,    -1,   392,   393,  4097,
    1023,    -1,    -1,    -1,    -1,  4244,    -1,    -1,   114,    -1,
      -1,    -1,    -1,    -1,    -1,   121,    -1,    -1,   124,  4249,
    4249,  4249,  4249,  4249,  4249,    -1,    -1,    -1,  1051,  1052,
     425,  1054,    -1,   428,   429,   430,    -1,    -1,    -1,  4244,
      -1,  4139,    -1,    -1,  4226,    -1,    -1,    -1,  1071,    -1,
      -1,    -1,  4291,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4299,    -1,    -1,  4293,  4293,  4293,  4293,  4293,  4293,    -1,
     176,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
       8,  3719,    -1,    11,  1107,    -1,  4291,  1110,    -1,    -1,
      -1,    -1,    -1,  4191,  4299,    -1,    -1,    -1,    -1,    -1,
      28,    -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    -1,    -1,    -1,    43,  1139,    -1,    -1,    -1,
    1143,  1144,    -1,    -1,    -1,   231,    -1,   233,    -1,    -1,
    1153,  1154,  1155,    -1,    -1,  4233,    -1,   243,    -1,    67,
      -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,  1171,    -1,
      -1,    -1,    -1,    -1,   260,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
    1203,    -1,    -1,    -1,    -1,   291,    -1,    -1,    37,   295,
      -1,    -1,  1215,  1216,    43,    -1,    -1,    -1,    -1,  1222,
      -1,    -1,  1225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   320,    -1,    -1,    -1,    67,    -1,
    1243,    -1,    -1,    -1,    -1,    -1,    -1,  1250,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   167,
      -1,    -1,    -1,   171,    -1,    -1,    -1,  1270,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1278,  1279,  1280,  1281,  1282,
      -1,    -1,    -1,    -1,   192,   193,    -1,    -1,    -1,    -1,
    1293,    -1,   378,  1296,    -1,    -1,    -1,    -1,    -1,    -1,
     208,    -1,    -1,    -1,  1307,    -1,  1309,    -1,    -1,    -1,
      -1,    -1,    -1,  3931,  1317,  1318,    -1,    -1,    -1,    -1,
    1323,    -1,    -1,    -1,    -1,   233,    -1,    -1,   236,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   167,    -1,
      -1,   249,   171,  3961,   252,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   192,   193,    -1,  1369,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   208,
    3998,    -1,    -1,    -1,  4002,  4003,    -1,    -1,    -1,    -1,
    1393,  1394,  1395,  1396,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   233,    -1,    -1,   236,    -1,  1412,
      -1,    -1,    -1,    -1,    -1,    -1,   324,    -1,  1421,    -1,
     249,    -1,    -1,   252,    -1,  1428,    -1,  1430,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1440,    -1,    -1,
      -1,    -1,  1445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1454,    -1,    -1,    -1,    -1,    -1,  1460,  1461,    -1,
      -1,    -1,  1465,    -1,    -1,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1490,    -1,    28,
      -1,    -1,    -1,    -1,  1497,   324,  1499,    -1,    37,    -1,
    1503,  1504,    -1,  1506,    43,    -1,   414,   415,   416,  1512,
     418,   419,   420,   421,   422,   423,    -1,    -1,    -1,    -1,
      -1,    -1,  1525,  1526,    -1,    -1,  1529,    -1,    67,    -1,
    1533,    -1,  1535,    -1,    -1,    -1,    -1,    -1,    -1,  1542,
      -1,    -1,  1545,    -1,    -1,    -1,  1549,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1557,  1558,    -1,    -1,    -1,    -1,
      -1,    -1,  1565,    -1,  1567,  1568,  1569,  1570,  1571,    -1,
      -1,    -1,    -1,    -1,    -1,  1578,  1579,    -1,  1581,    -1,
    1583,  1584,    -1,    -1,  1587,   414,   415,   416,    -1,   418,
     419,   420,   421,   422,   423,    -1,    -1,    -1,    -1,   428,
      -1,  1604,    -1,    -1,    -1,  1608,  1609,    -1,    -1,    -1,
    1613,    -1,    -1,    -1,  1617,    -1,  1619,  1620,  1621,  1622,
    1623,  1624,  1625,  1626,  1627,    -1,  1629,    -1,   167,    -1,
    1633,  1634,   171,  1636,    -1,    -1,    -1,    -1,    -1,  1642,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   208,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   233,    -1,    -1,   236,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,
     249,    -1,    -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     8,    -1,    37,    11,    -1,    -1,    -1,
      -1,    43,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    -1,    28,  1757,    -1,  1759,    24,  1761,    -1,
      -1,    -1,    37,    -1,    -1,    67,    -1,    -1,    43,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   324,    -1,    -1,    -1,    -1,
      -1,    -1,    67,    -1,    -1,  1798,    -1,  1800,    65,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1815,    -1,    -1,    -1,    -1,  1820,    -1,  1822,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1839,    -1,    -1,    -1,
      -1,    -1,  1845,    -1,  1847,  1848,  1849,   114,  1851,  1852,
      -1,  1854,    -1,  1856,   121,  1858,  1859,   124,    -1,  1862,
      -1,    -1,    -1,    -1,    -1,   167,    -1,    -1,    -1,   171,
      -1,    -1,    -1,    -1,    -1,   414,   415,   416,  1881,   418,
     419,   420,   421,   422,   423,    -1,    -1,    -1,    -1,   428,
     192,   193,   167,    -1,    -1,    -1,   171,  1900,    -1,    -1,
      -1,    -1,    -1,  1906,    -1,    -1,   208,    -1,  1911,   176,
      -1,    -1,    -1,    -1,  1917,    -1,    -1,   192,   193,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1933,  1934,    -1,   208,   236,    -1,    -1,  1940,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   249,    -1,    -1,
      -1,    -1,  1955,    -1,    -1,    -1,    -1,    -1,   233,    -1,
      -1,   236,    -1,    -1,   231,    -1,   233,    -1,     0,    -1,
      -1,    -1,    -1,    -1,   249,    -1,   243,   252,  1981,    -1,
    1983,  1984,    14,    -1,   251,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    24,   260,    26,    27,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2011,    -1,
      42,    -1,   839,    -1,    -1,    -1,  2019,  2020,  2021,  2022,
    2023,  2024,   324,    -1,   291,    -1,    -1,    -1,   295,    -1,
      62,  2034,    64,    65,    -1,    -1,    -1,    -1,    70,    -1,
      72,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   324,
      82,    -1,    84,   320,    -1,    -1,    -1,    -1,  2061,    -1,
      -1,    -1,  2065,  2066,    -1,    -1,    -1,  2070,   100,    -1,
      -1,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   115,    -1,   117,    -1,    -1,    -1,   121,
      -1,    -1,    -1,  2096,    -1,   127,    -1,    -1,    -1,    -1,
    2103,  2104,   134,    -1,   136,    -1,    -1,    -1,    -1,    -1,
     142,   378,   414,   415,   416,    -1,   418,   419,   420,   421,
     422,   423,    -1,    -1,   156,  2128,    -1,  2130,  2131,  2132,
    2133,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   965,   414,
     415,   416,    -1,   418,   419,   420,   421,   422,   423,  2152,
      -1,    -1,    -1,   428,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2164,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   210,   211,
      -1,    -1,    -1,    -1,   216,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   224,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   235,    -1,    -1,  2209,    -1,    -1,    -1,
      -1,  2214,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2224,    -1,    -1,    -1,    -1,    -1,    -1,  2231,  2232,
      -1,    -1,    -1,    -1,  2237,    -1,    -1,    -1,    -1,    -1,
     272,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   283,    -1,    -1,    -1,    -1,   288,    -1,   290,  2262,
    2263,    -1,    -1,   295,  2267,    -1,    -1,     8,   300,  1096,
      11,   303,    -1,    -1,    -1,   307,  2279,  2280,  2281,  2282,
     312,   313,    -1,    -1,    -1,    21,    -1,    28,   320,  2292,
      -1,   323,  2295,    -1,  2297,  2298,    37,    -1,    -1,   331,
      -1,    -1,    43,    -1,  2307,  2308,    -1,    -1,  2311,    -1,
      -1,   343,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    55,
      -1,  2324,    -1,  2326,    -1,  2328,    67,  2330,   360,    -1,
      -1,  1158,    68,    69,     8,    -1,    -1,    11,   370,    -1,
      -1,    77,    -1,  2346,   376,    81,    -1,  2350,    -1,   381,
      -1,    -1,    -1,    -1,  2357,    -1,  2359,  2360,  2361,    -1,
      -1,   393,    98,    37,    -1,    -1,    -1,    -1,    -1,    43,
      -1,    -1,    -1,  2376,    -1,    -1,     8,    -1,    -1,    11,
      -1,    -1,    -1,   119,  1211,  2388,    -1,    -1,    -1,    -1,
    2393,    -1,    -1,    67,  2397,   427,    28,  2400,   430,    -1,
      -1,   137,    -1,  2406,    -1,    37,  2409,    -1,    -1,    -1,
    2413,    43,   148,    -1,  1241,    -1,    -1,   153,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   167,    -1,    -1,    -1,
     171,    -1,    -1,    -1,    -1,    67,    -1,    -1,   174,    -1,
    2443,    -1,  2445,    -1,    -1,    -1,    -1,  2450,    -1,    -1,
      -1,   192,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   199,    -1,    -1,    -1,   208,  2471,     8,
    2473,  2474,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1311,    -1,    -1,    -1,    -1,    28,
      -1,    -1,   233,   167,    -1,   236,    -1,   171,    37,    -1,
      -1,    -1,    -1,  1330,    43,    -1,    -1,    -1,   249,    -1,
      -1,   252,    -1,   249,    -1,    -1,    -1,    -1,   192,   193,
      -1,    -1,    -1,  1350,    -1,    -1,    -1,    -1,    67,    -1,
      -1,    -1,    -1,    -1,   208,   167,    -1,    -1,    -1,   171,
      -1,   277,    -1,    -1,    -1,    -1,    -1,    -1,  1375,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   233,
     192,   193,   236,    -1,    -1,    -1,   302,    -1,    -1,    -1,
     306,    -1,   308,    -1,    -1,   249,   208,    -1,   314,    -1,
      -1,   317,    -1,   324,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    -1,    -1,
    1427,   233,    -1,    24,   236,    -1,    -1,   343,     8,   345,
      -1,    11,    -1,   349,    -1,    -1,    -1,   249,    -1,    -1,
     252,   357,    -1,    -1,    -1,    -1,   362,    -1,   167,    -1,
      -1,    -1,   171,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      -1,  2644,  2645,    43,    65,    -1,    -1,    -1,    -1,    -1,
     324,   387,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    -1,   208,
      -1,    -1,    -1,   414,   415,   416,    -1,   418,   419,   420,
     421,   422,   423,    -1,    -1,    -1,    -1,   428,    -1,    -1,
      -1,    -1,   324,   114,   233,    -1,    -1,   236,    -1,  2702,
     121,    -1,    -1,   124,    -1,    -1,    -1,    -1,    -1,    -1,
     249,    -1,    -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2726,  2727,    -1,    -1,    -1,    -1,   129,
      -1,    -1,  2735,    -1,    -1,    -1,  2739,    -1,    -1,    -1,
     414,   415,   416,    -1,   418,   419,   420,   421,   422,   423,
    2753,    -1,    -1,    -1,    -1,   176,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   167,    -1,    -1,
      -1,   171,    -1,    -1,    -1,    -1,  1603,    -1,  2781,    -1,
      -1,  2784,   414,   415,   416,   324,   418,   419,   420,   421,
     422,   423,   192,   193,    -1,  2798,   428,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   208,    -1,
     231,    -1,   233,    -1,    -1,    -1,  2819,    -1,    -1,    -1,
      -1,    -1,   243,    -1,  2827,    -1,    -1,    -1,    -1,    -1,
     251,    -1,  2835,    -1,    -1,    -1,   236,    -1,    -1,   260,
      -1,    -1,  2845,    -1,    -1,    -1,    -1,    -1,  2851,   249,
    2853,    -1,    -1,    -1,    -1,    -1,  2859,    -1,    -1,  2862,
    2863,  2864,  2865,  2866,  2867,  2868,  2869,  2870,  2871,    -1,
     291,    -1,  2875,  2876,   295,   414,   415,   416,    -1,   418,
     419,   420,   421,   422,   423,  2888,    -1,   426,    -1,  2892,
      -1,    -1,    -1,  2896,    -1,    -1,    -1,    -1,    -1,   320,
      -1,    -1,    -1,  2906,    -1,    -1,  2909,    -1,  2911,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2920,  2921,  2922,
      -1,    -1,    -1,  2926,   324,    -1,  2929,    -1,    -1,    -1,
      -1,    -1,    -1,  2936,  2937,  2938,  2939,  2940,    -1,    -1,
      -1,  2944,  2945,    -1,    -1,    -1,  2949,    -1,    -1,    -1,
      -1,    -1,  2955,    -1,  2957,    -1,  2959,   378,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2983,    -1,    -1,    -1,    -1,    -1,  2989,    -1,    -1,    -1,
    2993,    -1,  2995,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3010,  3011,  3012,
      -1,  3014,    -1,    -1,    -1,    -1,    -1,    -1,   418,   419,
     420,   421,   422,   423,    -1,  3028,  3029,  3030,  3031,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,    -1,    -1,    -1,    -1,    -1,    24,    -1,    -1,     8,
      -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1887,    -1,    -1,  3066,    -1,  1892,  1893,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1904,    37,    -1,
      -1,    -1,    -1,    -1,    43,    -1,    -1,    65,   172,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   180,   181,    -1,    -1,
      -1,    -1,   186,    -1,    -1,    -1,    -1,    -1,    67,     8,
      -1,   195,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    11,    -1,    -1,    -1,  3131,    28,
      -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,    37,    -1,
      -1,    -1,    -1,   121,    43,    -1,   124,    -1,    -1,    -1,
      37,    -1,    -1,    -1,    -1,    -1,    43,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    -1,
     129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      67,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3197,    -1,    -1,    -1,   176,    -1,
      -1,    -1,    -1,    -1,    -1,  3208,    -1,  3210,   167,  2036,
      -1,    37,   171,  3216,    -1,    -1,    -1,    43,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3228,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   192,   193,  3238,    -1,    -1,    -1,    -1,
      -1,    67,   129,    -1,  3247,    -1,    -1,    -1,    -1,   208,
    3253,    -1,    -1,   231,  3257,   233,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   243,  3269,  3270,   167,    -1,
      -1,    -1,   171,   251,    -1,    -1,    -1,   236,    -1,    -1,
     167,    -1,   260,  2110,   171,    -1,    -1,    -1,    -1,  3292,
     249,  3294,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   129,    -1,   192,   193,    -1,    -1,   208,
      -1,    -1,    -1,   291,    -1,    -1,    -1,   295,    -1,    -1,
      -1,   208,    -1,  3326,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   233,    -1,    -1,   236,    -1,    -1,
      -1,   167,   320,    -1,    -1,   171,    -1,    -1,    -1,   236,
     249,    -1,    -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,
    3363,    -1,   249,    -1,    -1,   324,   192,   193,  2195,    -1,
    3373,  3374,    -1,    -1,    -1,    -1,    -1,    -1,  3381,  3382,
      -1,    -1,   208,  3386,    -1,    -1,    -1,    -1,    -1,  3392,
    3393,    -1,    -1,  3396,    -1,  3398,  3399,  3400,  3401,    -1,
     378,    -1,  3405,    -1,    -1,  3408,    -1,    -1,  3411,    -1,
     236,    -1,  3415,    -1,    -1,    -1,    -1,    -1,  3421,    -1,
      -1,  3424,    -1,   249,    -1,   324,  3429,    -1,   512,    -1,
      -1,    -1,  3435,    -1,    -1,    -1,    -1,   324,  3441,   523,
      -1,    -1,    -1,   527,  3447,    18,    -1,    -1,    -1,    -1,
      -1,    24,  3455,    -1,   538,    -1,  3459,    -1,    -1,   418,
     419,   420,   421,   422,   423,    -1,  3469,    -1,   552,  3472,
      -1,    -1,   556,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   565,   566,    -1,    -1,    -1,   570,    -1,    -1,  3492,
    3493,    -1,    65,    -1,    -1,    -1,   580,    -1,   324,    -1,
      -1,    -1,    -1,    -1,   588,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3516,    -1,   414,   415,   416,    -1,   418,
     419,   420,   421,   422,   423,    -1,    -1,    -1,    -1,   428,
      -1,   418,   419,   420,   421,   422,   423,    -1,    -1,    -1,
      -1,   114,    -1,    -1,    -1,    -1,    -1,    -1,   121,    -1,
      -1,   124,    -1,  3556,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3570,    -1,    -1,
      -1,    -1,    -1,    -1,   658,    -1,    -1,    -1,    -1,   663,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      11,    -1,   418,   419,   420,   421,   422,   423,    -1,    -1,
      -1,  3604,    -1,   176,   688,    -1,    -1,    28,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    -1,    -1,    -1,
      -1,    -1,    43,    -1,    -1,    -1,    -1,    -1,    -1,  3632,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2466,
      -1,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3659,  3660,   231,    -1,
     233,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,  2506,
    2507,    -1,  2509,    -1,  3687,    -1,    -1,   260,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3715,    -1,    -1,    -1,    -1,    -1,   291,    -1,
      -1,  3724,   295,   807,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   817,  2561,    -1,  2563,    -1,  3741,  3742,
      -1,    -1,  3745,    -1,    -1,    -1,   167,   320,    -1,  3752,
     171,    -1,    -1,  3756,    -1,   839,    -1,    -1,  3761,    -1,
      -1,  3764,  3765,    -1,  3767,    -1,  3769,  3770,    -1,    -1,
      -1,   192,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   208,   872,  2616,
      -1,  3794,  3795,  3796,  3797,  3798,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   378,    -1,    -1,    -1,    -1,
      -1,    -1,   233,  2640,    -1,   236,    -1,    -1,   902,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3829,  3830,   249,     8,
      -1,   252,    11,   917,    -1,    -1,    -1,   921,  2665,    -1,
      -1,    -1,    -1,    -1,    -1,   929,    -1,    -1,    -1,    28,
      -1,    -1,    -1,    -1,    -1,    -1,  2683,  3860,    37,    -1,
      -1,    -1,    -1,  3866,    43,     8,  3869,    -1,    11,    -1,
      -1,    -1,    -1,   957,    -1,    -1,    -1,  3880,    -1,  3882,
      -1,   965,    -1,   967,    -1,    28,    -1,    -1,    67,    -1,
      -1,  3894,    -1,    -1,    37,   979,  3899,    -1,   982,    -1,
      43,    -1,    -1,   324,  3907,  3908,    -1,    -1,    -1,    -1,
     994,    -1,    -1,     8,    -1,    -1,    11,    -1,    -1,  2746,
      -1,    -1,    -1,    -1,    67,    -1,    -1,  3930,    -1,    -1,
    3933,    -1,  3935,  2760,    -1,    -1,    -1,    -1,    -1,  1023,
      -1,    -1,    37,    -1,  2771,    -1,    -1,    -1,    43,  3952,
      -1,    -1,    -1,  3956,    -1,    -1,  3959,    -1,    -1,    -1,
      -1,    -1,  3965,    -1,    -1,    -1,    -1,  1051,  1052,    -1,
    1054,    -1,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3985,    -1,    -1,    -1,  3989,  1071,   167,    -1,
      -1,    -1,   171,   414,   415,   416,    -1,   418,   419,   420,
     421,   422,   423,  4006,  4007,  4008,  4009,   428,    -1,  1093,
      -1,  2838,    -1,   192,   193,    -1,    -1,  1101,  1102,    -1,
      -1,    -1,    -1,    -1,   167,    -1,  1110,  1111,   171,   208,
      -1,  2858,    18,  4036,   129,    -1,    -1,    -1,    24,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   192,
     193,    -1,    -1,    -1,   233,  1139,  2883,   236,    -1,  1143,
    1144,    -1,    -1,    -1,    -1,   208,    -1,    -1,    -1,    -1,
     249,    -1,   167,   252,  1158,    -1,   171,    -1,    -1,    65,
    1164,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4091,    -1,
     233,    -1,  2919,   236,  4097,    -1,  4099,   192,   193,    -1,
      -1,    -1,    -1,    -1,    -1,  4108,   249,    -1,    -1,   252,
      -1,    -1,    -1,   208,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1211,   114,    -1,
      -1,    -1,    -1,    -1,    -1,   121,  4139,    -1,   124,    -1,
    4143,   236,    -1,    -1,    -1,   324,    -1,    -1,    -1,    -1,
    4153,    -1,    18,    -1,   249,    -1,    -1,  1241,    24,    -1,
      -1,    -1,    -1,    -1,  4167,    -1,    -1,  4170,  4171,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,
    4183,   324,    -1,    -1,    -1,    -1,    -1,    -1,  4191,    -1,
     176,     8,    -1,    28,    11,    -1,    -1,    -1,    -1,    65,
      -1,    -1,    37,    -1,    -1,    -1,    -1,  1291,    43,    -1,
      -1,    28,    -1,    -1,    -1,  4218,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    -1,    -1,  4228,    43,  1311,    -1,   324,
    4233,    -1,    67,    -1,    -1,   414,   415,   416,    -1,   418,
     419,   420,   421,   422,   423,   231,  1330,   233,   114,   428,
      67,    -1,    -1,    -1,  3081,   121,    -1,   243,   124,    -1,
      -1,    -1,    -1,    -1,    -1,   251,  1350,    -1,    -1,    -1,
      -1,   414,   415,   416,   260,   418,   419,   420,   421,   422,
     423,    -1,    -1,  4286,    -1,   428,  1370,    -1,    -1,    -1,
      -1,  1375,  4295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1387,    -1,   291,    -1,    -1,    -1,   295,
     176,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1403,
      -1,    -1,    -1,   418,   419,   420,   421,   422,   423,    -1,
      -1,    -1,   167,    -1,   320,    -1,   171,  1421,    -1,    -1,
      -1,    -1,    -1,  1427,    -1,    -1,  1430,    -1,  1432,  1433,
     167,    -1,    -1,    -1,   171,    -1,    -1,   192,   193,  1443,
      -1,    -1,    -1,    -1,    -1,   231,    -1,   233,    -1,    -1,
      -1,  1455,  1456,   208,    -1,   192,   193,   243,    -1,    -1,
      -1,    -1,    -1,  1467,    -1,   251,    -1,    -1,    -1,    -1,
      -1,   208,   378,    -1,   260,    -1,    -1,    -1,   233,    -1,
      -1,   236,    -1,    -1,    -1,    -1,    -1,    -1,  3235,    -1,
      -1,    -1,    -1,    -1,   249,  1499,   233,   252,    -1,   236,
      -1,    -1,    -1,    -1,    -1,   291,    -1,    -1,    -1,   295,
      -1,    -1,   249,    -1,    -1,   252,    -1,    -1,    -1,    -1,
      -1,  3268,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1533,
      -1,  1535,    -1,    -1,   320,    -1,    -1,    -1,  1542,    -1,
      -1,  1545,    -1,    -1,    -1,  1549,    -1,    -1,    -1,    -1,
      -1,    18,    -1,  1557,  1558,    -1,    -1,    24,    -1,    -1,
      -1,  1565,    -1,    -1,  1568,  1569,  1570,  1571,    -1,   324,
      -1,    -1,    -1,    -1,  1578,  1579,    -1,  1581,    -1,  1583,
    1584,    -1,    -1,  1587,    -1,    -1,    -1,   324,    -1,    -1,
      -1,    -1,   378,    -1,    -1,    -1,    -1,    -1,    65,  1603,
    1604,  1605,    -1,    -1,    -1,  1609,    -1,    -1,    -1,  1613,
      -1,    -1,    -1,  1617,    -1,  1619,  1620,  1621,  1622,  1623,
    1624,  1625,  1626,  1627,    -1,  1629,    -1,    -1,    -1,  3376,
    1634,    -1,  1636,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3387,    -1,    21,    -1,    -1,    -1,    -1,   114,    -1,    -1,
      -1,    -1,    -1,    -1,   121,    34,    -1,   124,    -1,   414,
     415,   416,    -1,   418,   419,   420,   421,   422,   423,    -1,
      -1,    -1,    -1,   428,    -1,    -1,    55,   414,   415,   416,
      -1,   418,   419,   420,   421,   422,   423,     8,    -1,    68,
      11,   428,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    81,    -1,    -1,    -1,    -1,    28,    -1,   176,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    -1,     8,    98,
      -1,    11,    43,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,
     119,    -1,    -1,  3490,    -1,    -1,    67,    37,    -1,    -1,
      -1,    -1,    -1,    43,    -1,    -1,    -1,  1761,   137,    -1,
      -1,    -1,    -1,    -1,   231,    -1,   233,    -1,    -1,   148,
      -1,  3518,    -1,    -1,   153,    -1,   243,    67,    -1,    -1,
     159,    -1,    -1,  3530,   251,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   260,    -1,   174,    -1,    -1,    -1,    -1,
      -1,    -1,  1806,    -1,    -1,    -1,  1810,  1811,    -1,    -1,
    1814,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   291,    -1,    -1,  3574,   295,    -1,
      -1,    -1,  1836,     8,    -1,  1839,    11,    -1,    -1,    -1,
      -1,  1845,    -1,    -1,    -1,    -1,   167,  1851,    -1,    -1,
     171,    -1,    -1,   320,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    -1,    -1,    -1,  1870,    -1,    43,    -1,
     249,   192,   193,    -1,    -1,    -1,    -1,   167,    -1,    -1,
     259,   171,    -1,  1887,    -1,    -1,    -1,   208,  1892,  1893,
      -1,    -1,    67,  1897,  1898,    -1,    -1,    -1,   277,    -1,
    1904,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   378,   233,    -1,    -1,   236,  1920,  1921,   208,  1923,
      -1,    -1,    -1,   302,    -1,    -1,    -1,   306,   249,   308,
      -1,   252,    -1,    -1,    -1,   314,    -1,  1941,   317,    -1,
    1944,    -1,    -1,   233,    -1,    -1,   236,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   129,    -1,    -1,    -1,  1962,   249,
      -1,    -1,   252,    -1,   343,    -1,   345,    -1,  1972,    -1,
     349,    -1,  3719,    -1,    -1,    -1,    -1,    -1,   357,    -1,
      -1,  1985,    -1,   362,    -1,    -1,   839,    -1,    -1,    -1,
    1994,    -1,   167,    -1,    -1,   374,   171,    -1,    -1,    -1,
      -1,    -1,    -1,   324,    -1,    -1,    -1,    -1,   387,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   192,   193,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2034,    -1,  2036,   208,   324,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      11,   236,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   249,    -1,    -1,    28,  3825,    -1,
      -1,    -1,    33,    -1,    -1,    -1,    37,    -1,    -1,    -1,
      -1,    -1,    43,   414,   415,   416,    -1,   418,   419,   420,
     421,   422,   423,    -1,    -1,    -1,  2110,   428,    -1,  2113,
      -1,    -1,   965,    -1,    -1,    -1,    67,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   414,   415,   416,    -1,   418,   419,
     420,   421,   422,   423,    -1,    -1,    -1,    -1,   428,    -1,
      -1,    -1,    -1,  2147,    -1,    -1,    -1,    -1,  2152,   324,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   112,    -1,  3910,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2182,    -1,
      -1,    -1,    -1,    -1,  3931,    -1,    -1,    -1,    -1,    -1,
      -1,  2195,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2205,    -1,    -1,    -1,  2209,    -1,    -1,    -1,    -1,
    2214,    -1,    -1,    -1,  3961,    -1,   167,    -1,    -1,    -1,
     171,    -1,    -1,    -1,    -1,    -1,    -1,  2231,  2232,    -1,
      -1,    -1,    -1,  2237,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   192,   193,   418,   419,   420,   421,   422,   423,    -1,
      -1,  3998,    -1,    -1,    -1,  4002,  4003,   208,  2262,  2263,
      -1,    -1,    -1,  2267,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2279,  2280,  2281,  2282,    -1,
      -1,    -1,   233,  2287,    -1,   236,    -1,    -1,  2292,  2293,
      -1,  2295,    -1,  2297,    -1,    -1,    -1,    -1,   249,    -1,
      -1,   252,    -1,  2307,  2308,  1158,    -1,  2311,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2324,    -1,  2326,    -1,    -1,    -1,  2330,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2346,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2357,    -1,  2359,  2360,  2361,  1211,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2373,
      -1,    -1,  2376,   324,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2388,    -1,    -1,    -1,  1241,  2393,
      -1,    -1,    -1,    -1,    -1,    -1,  2400,    -1,    -1,    -1,
      -1,    -1,  2406,    -1,    -1,    -1,    -1,    -1,    18,    -1,
      -1,    -1,    -1,    13,    24,    -1,    -1,    -1,  2422,    19,
      -1,    -1,    -1,    -1,   375,    -1,    -1,    -1,    28,    -1,
      -1,    -1,    -1,  2437,  2438,    -1,    -1,    -1,    -1,  2443,
      50,    18,    -1,    -1,    -1,    -1,    46,    24,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    -1,  1311,  2463,
      -1,    -1,  2466,   414,   415,   416,    -1,   418,   419,   420,
     421,   422,   423,    50,    -1,    -1,    -1,  1330,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,    65,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1350,    -1,    -1,
      -1,    -1,  2506,  2507,   114,  2509,    -1,    -1,    -1,    -1,
      -1,   121,    -1,    -1,   124,    -1,    -1,    -1,    -1,    96,
      -1,    -1,  1375,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2538,  2539,  2540,   114,    -1,    -1,
      -1,    -1,    -1,    -1,   121,    -1,    -1,   124,    -1,    -1,
      -1,    -1,    -1,  2557,    -1,    -1,    -1,  2561,    -1,  2563,
    2564,    -1,    -1,   173,    -1,    -1,   176,    -1,    -1,    -1,
    2574,    -1,    -1,    -1,  1427,    -1,    -1,    -1,   178,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   187,    -1,   189,
      -1,   191,    -1,   193,    -1,    -1,   173,    -1,    -1,   176,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   219,
      -1,   221,  2616,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   231,    -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,
    2634,    -1,    -1,   243,    -1,    -1,  2640,    -1,    -1,    -1,
      -1,   251,   219,    -1,   221,    -1,    -1,    -1,    -1,   259,
     260,    -1,    -1,    -1,   231,    -1,   233,    -1,  2662,    -1,
      -1,  2665,    -1,    -1,    -1,    -1,   243,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,  2682,  2683,
      -1,   291,   259,   260,    -1,   295,   296,    -1,    -1,    -1,
      -1,    -1,  2696,    -1,  2698,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2708,    -1,  2710,    -1,    -1,    -1,
     320,    -1,    -1,    -1,   291,    -1,    -1,    -1,   295,   296,
      -1,   331,   181,    -1,    -1,    -1,    -1,   186,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   195,    -1,    -1,    -1,
      -1,    -1,  2746,   320,    -1,    -1,    -1,    -1,    -1,    -1,
    1603,    -1,    -1,    -1,   331,  2759,  2760,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2771,   378,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2787,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2798,    -1,    -1,  2801,    -1,    -1,
      -1,   378,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2818,    -1,    -1,  2821,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2835,    -1,    -1,  2838,    -1,    -1,    -1,    -1,    -1,
      -1,  2845,    -1,    -1,    -1,    -1,    -1,  2851,    -1,  2853,
      -1,    -1,    -1,    -1,  2858,  2859,    -1,    -1,  2862,  2863,
    2864,  2865,  2866,  2867,  2868,  2869,  2870,  2871,    -1,    -1,
      -1,  2875,  2876,    -1,    -1,    -1,    -1,    -1,    -1,  2883,
      -1,    -1,    -1,    -1,  2888,    -1,    -1,    -1,  2892,    -1,
    2894,    -1,  2896,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2906,     8,    -1,  2909,    11,  2911,    -1,    -1,
      -1,    -1,    -1,   513,    -1,  2919,  2920,  2921,  2922,    -1,
     520,    -1,  2926,    28,    -1,  2929,    -1,    -1,    -1,   529,
     530,    -1,    37,    -1,   534,  2939,    -1,    -1,    43,    -1,
      -1,    -1,    -1,    -1,   544,  2949,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2957,    -1,  2959,    -1,   557,    -1,    -1,
      -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   571,    -1,    -1,   574,    -1,   576,    -1,   578,  2983,
      -1,    -1,    -1,    -1,    -1,  2989,    -1,    -1,    -1,     8,
      -1,  2995,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3010,    -1,    -1,    28,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    -1,    -1,    -1,    43,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3037,  1887,   635,    -1,   637,    -1,  1892,
    1893,   146,    -1,    -1,    -1,    -1,   151,    -1,    67,    -1,
      -1,  1904,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   167,    -1,   523,    -1,   171,    -1,   527,    -1,
      -1,    -1,  3076,    -1,    -1,    -1,  3080,  3081,  3082,   538,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   192,   193,    -1,
     690,    -1,    -1,   552,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   208,    -1,    -1,    -1,   566,    -1,    -1,
    3114,   570,    -1,  3117,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   580,    -1,    -1,    -1,    -1,    -1,    -1,   233,   588,
      -1,   236,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   249,    -1,    -1,   252,   167,    -1,
      -1,    -1,   171,  3157,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,
      -1,    -1,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2036,    -1,    28,    -1,    -1,    -1,   208,
      -1,    -1,    -1,    -1,    37,    -1,   796,    -1,    -1,    -1,
      43,    -1,    -1,    -1,   663,    -1,  3210,    -1,    -1,    -1,
      -1,   811,    -1,    -1,   233,    -1,    -1,   236,    -1,   324,
      -1,    -1,   822,    -1,    67,    -1,    -1,  3231,  3232,   829,
     249,  3235,    -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   841,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   271,    -1,    -1,    -1,    -1,  2110,    -1,    -1,
      -1,    -1,    -1,    -1,  3268,  3269,  3270,    -1,    -1,    -1,
      -1,    -1,    -1,   873,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   145,    -1,    -1,   324,  3310,    -1,    -1,   414,
     415,   416,    -1,   418,   419,   420,   421,   422,   423,   338,
      -1,    -1,  3326,    -1,   167,    -1,    -1,    -1,   171,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2195,    -1,    -1,    -1,    -1,    -1,    -1,   192,
     193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3363,
      -1,    -1,    -1,    -1,    -1,   208,    -1,    -1,    -1,  3373,
    3374,    -1,  3376,    -1,    -1,    -1,    -1,  3381,  3382,    -1,
      -1,    -1,  3386,  3387,    -1,    -1,    -1,    -1,  3392,  3393,
     233,    -1,  3396,   236,    -1,   414,   415,   416,    -1,   418,
     419,   420,   421,   422,   423,    -1,   249,  3411,    -1,   252,
      -1,  3415,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3424,    -1,    -1,    -1,    -1,  3429,   269,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3441,    -1,    -1,
      -1,    -1,    -1,   902,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   917,    -1,
       8,    -1,    -1,    11,    -1,    -1,    -1,    -1,  3472,    -1,
     929,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      28,   324,    -1,    -1,    32,    -1,  3490,    -1,    -1,    37,
      -1,    -1,    -1,    -1,    -1,    43,    -1,    -1,   957,    -1,
      -1,    -1,    -1,    -1,    -1,  3509,    -1,    -1,   967,    -1,
      -1,    -1,    -1,    -1,  3518,    -1,    -1,    -1,    -1,    67,
     979,  3525,    -1,   982,    -1,    -1,  3530,    -1,  1128,  1129,
      -1,    -1,    -1,  3537,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3574,   414,   415,   416,    -1,   418,   419,   420,   421,   422,
     423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1189,
    3594,    -1,  3596,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2466,    -1,    -1,    -1,    -1,    -1,   167,
      -1,    -1,    -1,   171,    -1,    -1,    -1,    -1,  3632,    -1,
      -1,    -1,    -1,    -1,  1093,     8,    -1,    -1,    11,    -1,
      -1,    -1,  1101,  1102,   192,   193,    -1,    -1,    -1,    -1,
      -1,    -1,  1111,  2506,  2507,    28,  2509,    -1,    -1,    32,
     208,    -1,    -1,    -1,    37,    -1,    -1,    -1,    -1,    -1,
      43,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3684,    -1,    -1,    -1,    -1,   233,    -1,    -1,   236,    -1,
      -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,  3703,
      -1,   249,    -1,    -1,   252,  1164,    -1,    -1,  2561,    -1,
    2563,  3715,    -1,    -1,    -1,  3719,    -1,    -1,    -1,    -1,
    3724,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3741,  3742,    -1,
      -1,  3745,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3756,    -1,    -1,    -1,    -1,  3761,    -1,    -1,
    3764,    -1,    -1,  2616,    -1,  3769,  3770,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   324,    -1,  1378,     8,
      -1,    -1,    11,    -1,  3788,    -1,  3790,  2640,    -1,    -1,
    3794,  1391,    -1,    -1,   167,    -1,    -1,    -1,   171,    28,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    -1,  2665,    -1,    43,    -1,    -1,    -1,    -1,   192,
     193,  3825,    -1,    -1,    -1,  3829,    -1,    -1,    -1,  1429,
    2683,    -1,  1291,    -1,    -1,   208,    -1,    -1,    67,    -1,
      -1,    -1,    -1,    -1,  1444,    -1,  1446,    -1,  1448,    -1,
      -1,    -1,    -1,  1453,    -1,    -1,    -1,    -1,    -1,    -1,
     233,    -1,  3866,   236,    -1,    -1,   414,   415,   416,    -1,
     418,   419,   420,   421,   422,   423,   249,    -1,    -1,   252,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2746,    -1,    -1,  1496,    -1,    -1,    -1,
    1500,    -1,  1502,    -1,  3908,  1505,  3910,  2760,    -1,    -1,
      -1,  1370,    -1,    -1,    -1,    -1,    -1,    -1,  2771,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3930,  3931,  1387,  3933,
      -1,  3935,    -1,    -1,    -1,    -1,    -1,    -1,   167,    -1,
      -1,    -1,   171,    -1,  1403,    -1,    -1,    -1,  3952,    -1,
      -1,   324,  3956,    -1,    -1,    -1,    -1,  3961,    -1,    -1,
      -1,    -1,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1432,  1433,    -1,    -1,    -1,    -1,   208,
      -1,    -1,    -1,    -1,  1443,  2838,    -1,    -1,    -1,    -1,
      -1,  3995,    -1,    -1,  3998,    -1,  1455,  1456,  4002,  4003,
      -1,    -1,    -1,    -1,   233,  2858,    -1,   236,  1467,    -1,
      -1,    -1,  4016,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     249,    -1,    -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,
    2883,    -1,  4036,    -1,    -1,    -1,    -1,   266,    -1,    -1,
      -1,   414,   415,   416,    -1,   418,   419,   420,   421,   422,
     423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4063,
      -1,    -1,    -1,    -1,    -1,    -1,  2919,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4091,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   324,    -1,    -1,    -1,    -1,
      -1,   181,    -1,    -1,  4108,    -1,   186,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   195,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4143,
      -1,    -1,    -1,    -1,    -1,    -1,  1605,    -1,    -1,  4153,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4170,  4171,    -1,  4173,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4183,
       8,    -1,    -1,    11,    -1,   414,   415,   416,    -1,   418,
     419,   420,   421,   422,   423,    -1,    -1,    -1,    -1,    -1,
      28,    -1,    -1,    -1,    -1,    -1,    -1,  1807,  1808,    37,
      -1,    -1,  1812,  1813,  4218,    43,  1816,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4228,    -1,  1826,    -1,  3081,    -1,
      -1,    -1,    -1,  1833,    -1,    -1,    -1,  1837,  1838,    67,
    4244,  1841,  1842,  1843,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1853,    -1,  1855,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1871,    -1,    -1,    -1,    -1,  1876,    -1,    -1,    -1,
      -1,    -1,  4286,    -1,    -1,    -1,    -1,  4291,    -1,    -1,
      -1,  4295,    -1,    -1,    -1,  4299,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1907,  1908,  1909,
    1910,    -1,    -1,    -1,  1914,  1915,    -1,    -1,    -1,    -1,
      -1,    -1,  1922,   151,    -1,  1925,    -1,    -1,    -1,  1929,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   167,
      -1,    -1,    -1,   171,    -1,  1945,    -1,  1806,    -1,    -1,
      -1,  1810,  1811,    -1,    -1,  1814,  1956,    -1,  1958,    -1,
      -1,    -1,    -1,  1963,   192,   193,    -1,    -1,  1968,  1969,
    1970,  1971,    -1,  1973,    -1,    -1,    -1,  1836,    -1,    -1,
     208,    -1,  3235,    -1,    -1,    -1,  1986,  1987,  1988,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1997,  1998,    -1,
       8,    -1,    -1,    11,    -1,   233,    -1,    -1,   236,    -1,
      -1,  1870,    -1,    -1,    -1,  3268,    -1,    -1,    -1,    -1,
      28,   249,    -1,    -1,   252,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    -1,    -1,    -1,    43,    -1,    -1,  1897,  1898,
      -1,    -1,    -1,   523,    -1,     8,    -1,   527,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2057,   538,    67,
      -1,  1920,  1921,    -1,  1923,    28,    -1,    -1,    -1,    32,
      -1,    -1,   552,    -1,    37,    -1,    -1,    -1,    -1,    -1,
      43,    -1,  1941,    -1,    -1,  1944,   566,    -1,    -1,    -1,
     570,    -1,    -1,    -1,    -1,    -1,   324,    -1,    -1,    -1,
     580,    -1,    -1,  1962,    67,    -1,    -1,    -1,   588,     8,
      -1,    -1,    11,  1972,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3376,    -1,    -1,  1985,    -1,    -1,    28,
      -1,    -1,    -1,    32,  3387,  1994,    -1,    -1,    37,    -1,
      -1,    -1,    -1,    -1,    43,    -1,    -1,     8,    -1,    -1,
      11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   167,
      -1,    -1,    -1,   171,    -1,    -1,    -1,    28,    67,    -1,
      -1,    -1,  2172,    -1,    -1,    -1,    37,    -1,    -1,    -1,
      -1,    -1,    43,   663,   192,   193,   414,   415,   416,    -1,
     418,   419,   420,   421,   422,   423,    -1,    -1,    -1,    -1,
     208,  2201,    -1,    -1,   167,    -1,    67,    -1,   171,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,   236,   192,
     193,    -1,    -1,    -1,    -1,    -1,    -1,  3490,    -1,    -1,
      -1,   249,    -1,    -1,   252,   208,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2113,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3518,    -1,    -1,   167,    -1,
     233,    -1,   171,   236,    -1,    -1,    -1,  3530,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   249,    -1,  2147,   252,
      -1,    -1,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   167,    -1,    -1,   208,
     171,    -1,    -1,    -1,    -1,    -1,   324,    -1,    -1,    -1,
      -1,  3574,    -1,  2182,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   192,   193,    -1,   233,    -1,    -1,   236,    -1,    -1,
      -1,    -1,   350,    -1,    -1,    -1,  2205,   208,    -1,    -1,
     249,    -1,    -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   324,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   233,    -1,    -1,   236,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2386,    -1,   249,    -1,
      -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   414,   415,   416,    -1,
     418,   419,   420,   421,   422,   423,    -1,    -1,    -1,   839,
      -1,    -1,   902,  2423,  2424,   324,    -1,    -1,  2287,    -1,
      -1,    -1,   658,    -1,  2293,    -1,    -1,   917,    -1,    -1,
    2440,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   929,
      -1,   414,   415,   416,    -1,   418,   419,   420,   421,   422,
     423,    -1,   688,   324,    -1,    -1,  3719,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   957,    -1,    -1,
      -1,    -1,    -1,  2483,  2484,    -1,    -1,   967,  2488,    -1,
      -1,    -1,    -1,  2493,  2494,  2495,    -1,    -1,    -1,   979,
      -1,    -1,   982,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2373,   414,   415,   416,    -1,   418,
     419,   420,   421,   422,   423,    -1,    -1,    -1,    -1,  2529,
    2530,  2531,  2532,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   965,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   414,   415,   416,    -1,   418,   419,   420,
     421,   422,   423,  2422,    -1,  2565,    -1,    -1,    -1,    -1,
      -1,    -1,  3825,    -1,    -1,    -1,    -1,    -1,  2437,  2438,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2463,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1093,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1101,  1102,    -1,    -1,    -1,    -1,  2627,    -1,    -1,
      -1,  1111,    -1,    -1,    -1,  2635,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3910,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3931,  2538,
    2539,  2540,    -1,    -1,  1164,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2697,  2557,    -1,
      -1,    -1,    -1,    -1,    -1,  2564,    -1,  2707,  3961,    -1,
      -1,    -1,    -1,    -1,    -1,  2574,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2734,    -1,  2736,    -1,  1158,    -1,
      -1,    -1,    -1,    -1,    -1,  3998,    -1,    -1,    -1,  4002,
    4003,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   994,    -1,
      -1,    -1,  2772,    -1,    -1,  2634,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2786,    -1,    -1,    -1,
      -1,  1211,    -1,    -1,    -1,    -1,  2796,  1023,    -1,    -1,
      -1,    -1,    -1,  2662,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1291,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1241,    -1,  2682,    -1,  1051,  1052,    -1,  1054,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2696,    -1,  2698,
      -1,    -1,    -1,    -1,    -1,  1071,    -1,    -1,    -1,  2708,
      -1,  2710,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1110,    -1,    -1,    -1,    -1,    -1,
    1370,  1311,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2759,    -1,    -1,    -1,    -1,    -1,    -1,  1387,    -1,    -1,
    1330,    -1,    -1,  1139,    -1,    -1,    -1,  1143,  1144,    -1,
      -1,    -1,    -1,  1403,    -1,    -1,    -1,    -1,  2787,    -1,
    1350,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2801,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1432,  1433,    -1,  1375,    -1,    -1,    -1,  2818,
      -1,    -1,  2821,  1443,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1455,  1456,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1467,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1427,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3017,    -1,  3019,
      -1,    -1,    -1,  3023,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2894,    -1,    -1,  3038,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3055,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3064,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3104,  3105,  3106,  3107,  3108,  3109,
    3110,    -1,    -1,    -1,    -1,  3115,  3116,    -1,  3118,  3119,
    3120,  3121,  3122,  3123,  3124,  1605,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3133,    -1,  3135,  3136,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   839,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3037,    -1,
      -1,    -1,    -1,  1603,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3204,  3205,  3206,    -1,    -1,  3209,
      -1,    -1,    -1,    -1,    -1,    -1,  1636,  3076,    -1,    -1,
      -1,  3080,    -1,  3082,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3114,    -1,    -1,  3117,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   965,  3285,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3157,    -1,
      -1,    -1,  3302,  3303,  3304,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1542,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1806,    -1,    -1,    -1,
    1810,  1811,    -1,    -1,  1814,    -1,    -1,    -1,    -1,  1565,
      -1,    -1,  1568,    -1,    -1,  1571,    -1,    -1,    -1,    -1,
      -1,    -1,  1578,  1579,    -1,    -1,  1836,    -1,  1584,    -1,
      -1,  1587,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3231,  3232,    -1,    -1,    -1,    -1,  1604,    -1,
      -1,    -1,    -1,  1609,    -1,    -1,    -1,  1613,    -1,    -1,
    1870,  1617,    -1,  1619,  1620,  1621,  1622,  1623,  1624,  1625,
    1626,  1627,    -1,  1629,    -1,    -1,    -1,    -1,  1634,    -1,
    1636,    -1,    -1,    -1,    -1,    -1,    -1,  1897,  1898,   839,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1920,  1921,    -1,  1923,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3310,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1941,    -1,    -1,  1944,    -1,    -1,  1887,    -1,    -1,
      -1,    -1,  1892,  1893,    -1,    -1,    -1,  1158,    -1,    -1,
      -1,    -1,  1962,    -1,  1904,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1972,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3501,  3502,  3503,  3504,  1985,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1994,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    21,    -1,  3526,  3527,    -1,    -1,
    1211,    -1,    -1,    -1,    -1,  1761,    -1,    34,  3538,  3539,
      -1,    -1,    -1,    -1,    -1,   965,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3554,  3555,    -1,  3557,    55,    -1,
    1241,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      77,    -1,    -1,    -1,    81,    -1,    -1,    -1,    -1,    -1,
      -1,  1067,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    98,    -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,
      -1,    -1,    -1,  1839,    -1,    -1,  2036,    -1,    -1,    -1,
      -1,    -1,   119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1311,    -1,    -1,  2113,    -1,    -1,    -1,    -1,    -1,    -1,
     137,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1124,  1330,
    3509,   148,  3652,    -1,    -1,    -1,    -1,    -1,   155,    -1,
      -1,    -1,   159,    -1,    -1,    -1,  3525,  2147,    -1,  1350,
      -1,    -1,    -1,    -1,    -1,  3675,    -1,   174,  3537,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2110,    -1,    -1,    -1,  1375,  3695,    -1,    -1,    -1,    -1,
      -1,    -1,  2182,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   212,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2205,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3594,    -1,  3596,  1158,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1427,    -1,    -1,    -1,
      -1,    -1,   249,    -1,  3754,   252,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3767,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2195,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   302,    -1,  2287,  2034,    -1,
      -1,   308,    -1,  2293,    -1,    -1,    -1,   314,    -1,    -1,
     317,  1241,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3839,
      -1,    -1,    -1,    -1,  3703,    -1,   343,    -1,   345,   346,
      -1,   348,   349,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     357,    -1,    -1,    -1,    -1,   362,    -1,    -1,    -1,    -1,
      -1,   368,    -1,    -1,   371,    -1,    -1,   374,    -1,  3879,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     387,  1311,    -1,  2373,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1330,    -1,    -1,    -1,    -1,    -1,  3916,    -1,    -1,    -1,
      -1,    -1,  1603,    -1,    -1,    -1,  2152,    -1,    -1,  3788,
    1350,  3790,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2359,
    2360,  2361,  2422,    -1,    -1,    -1,    -1,    -1,    -1,  3949,
      -1,    -1,    -1,    -1,    -1,  1375,    -1,  2437,  2438,  3959,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2463,    -1,    -1,    -1,  1463,    -1,    -1,
      -1,    -1,    -1,  3993,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2232,  1427,    -1,    -1,
    4010,  2237,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2466,    -1,    -1,    -1,
      -1,    -1,    -1,  2279,    -1,  2281,  2282,    -1,  2538,  2539,
    2540,    -1,    -1,    -1,  1540,    -1,  2292,  4067,    -1,  2295,
      -1,  2297,    -1,    -1,    -1,    -1,    -1,  2557,    -1,    -1,
      -1,    -1,  4082,    -1,  2564,    -1,  2506,  2507,  1564,  2509,
      -1,    -1,    -1,  1569,  2574,    -1,    -1,    -1,  2324,    -1,
    2326,    -1,    -1,    -1,  2330,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1589,  1590,    -1,  1592,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2359,  2360,  2361,  3995,  4137,    -1,    -1,
      -1,  2561,    -1,  2563,    -1,    -1,    -1,    -1,    -1,    -1,
    2376,    -1,    -1,    -1,  2634,    -1,  1632,  4016,    -1,    -1,
      -1,    -1,  2388,    -1,    -1,    -1,    -1,  2393,    -1,    -1,
      -1,    -1,    -1,    -1,  2400,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2662,  1603,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1668,    -1,    -1,    -1,  2616,    -1,    -1,    -1,
      -1,    -1,  2682,    -1,    -1,    -1,  1887,    -1,    -1,    -1,
      -1,  1892,  1893,    -1,    -1,    -1,  2696,  2443,  2698,    -1,
    2640,    -1,    -1,  1904,    -1,    -1,    -1,    -1,  2708,    -1,
    2710,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2665,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2683,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2759,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1771,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1781,    -1,  2787,  1784,    -1,
      -1,    -1,    -1,    -1,  4173,    -1,    -1,    -1,    -1,    -1,
      -1,  2801,    -1,    -1,    -1,    -1,  2746,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2818,    -1,
    2760,  2821,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2771,    -1,    -1,    -1,  2036,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4244,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   839,    -1,    -1,
      -1,    -1,    -1,    -1,  2894,    -1,    -1,    -1,  2838,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2110,
      -1,    -1,  4291,    -1,    -1,    -1,    -1,    -1,  2858,    -1,
    4299,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2883,    -1,    -1,    -1,  1887,    -1,    -1,
      -1,    -1,  1892,  1893,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1904,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2919,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2195,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   965,    -1,    -1,    -1,    -1,    -1,  2959,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3037,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3076,    -1,    -1,    -1,
    3080,    -1,  3082,    -1,    -1,    -1,    -1,    -1,    -1,  2835,
      -1,    -1,    -1,    -1,    -1,    -1,  2036,    -1,    -1,  2845,
      -1,    -1,    -1,    -1,    -1,  2851,    -1,  2853,    -1,    -1,
      -1,    -1,    -1,    -1,  3114,    -1,    -1,  3117,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2875,
    2876,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3081,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2896,    -1,    -1,    -1,    -1,    -1,    -1,  3157,    -1,    -1,
    2906,    -1,    -1,  2909,    -1,  2911,    -1,    -1,    -1,    -1,
    2110,    -1,    -1,    -1,  2920,    -1,    -1,    -1,    -1,    -1,
    2926,    -1,    -1,  2929,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2949,    -1,    -1,  1158,    -1,    -1,    -1,
      -1,  2957,    -1,  2959,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3231,  3232,    -1,    -1,    -1,    -1,  2983,    -1,  2235,
      -1,    -1,    -1,  2989,    -1,    -1,    -1,    -1,    -1,  2995,
      -1,    -1,    -1,    -1,    -1,  2195,    -1,    -1,    -1,  1211,
      -1,    -1,  2258,    -1,  2260,  2466,  2262,  2263,  2264,    -1,
      -1,  2267,    -1,    -1,    -1,  2271,    -1,    -1,    -1,    -1,
      -1,    -1,  2278,    -1,    -1,    -1,    -1,  2283,    -1,  1241,
      -1,    -1,    -1,  2289,    -1,  3235,    -1,    -1,  2294,    -1,
      -1,    -1,    -1,    -1,    -1,  2506,  2507,  2303,  2509,    -1,
    3310,  2307,  2308,    -1,  2310,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2322,    -1,  3268,    -1,
      -1,    -1,    -1,  2329,    -1,  2331,  2332,  2333,  2334,  2335,
    2336,  2337,  2338,  2339,  2340,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1311,
    2561,    -1,  2563,    -1,    -1,    -1,    -1,    -1,    -1,  2365,
      -1,    -1,    -1,   839,    -1,    -1,    -1,    -1,  1330,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1350,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2616,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1375,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3376,    -1,    -1,  2640,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3387,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2458,    -1,  2665,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1427,    -1,    -1,    -1,    -1,
      -1,    -1,  2683,    -1,  3424,    -1,    -1,    -1,    -1,  3429,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   965,
      -1,  3441,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3509,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3269,  3270,  3525,  2466,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3537,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2746,    -1,    -1,    -1,    -1,
    3490,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2760,
      -1,    -1,    -1,    -1,    -1,    -1,  2506,  2507,    -1,  2509,
    2771,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3518,    -1,
    3326,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3530,    -1,    -1,    -1,  3594,    -1,  3596,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2561,    -1,  2563,    -1,    -1,    -1,  3373,  3374,    -1,
      -1,    -1,    -1,    -1,  3574,    -1,   839,  2838,    -1,    -1,
    3386,    -1,    -1,    -1,    -1,    -1,  3392,  3393,    -1,    -1,
    3396,  1603,    -1,    -1,    -1,    -1,    -1,  2858,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2668,    -1,    -1,    -1,  2616,    -1,  3424,    -1,
      -1,    -1,  2883,  3429,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1158,    -1,    -1,  3441,    -1,    -1,    -1,    -1,
    2640,    -1,    -1,  3703,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2919,    -1,
      -1,    -1,    -1,    -1,    -1,  2665,  3472,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2683,  3684,  1211,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   965,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1241,    -1,    -1,    -1,  3719,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3788,    -1,
    3790,    -1,    -1,    -1,  2790,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2746,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2760,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2771,    -1,    -1,    -1,    -1,    -1,    -1,  2834,    -1,
      -1,    -1,    -1,    -1,  2840,  1311,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2856,  2857,    -1,  2859,  1330,    -1,  2862,  2863,  2864,  2865,
    2866,  2867,  2868,  2869,  2870,  2871,  2872,    -1,    -1,    -1,
    3081,    -1,    -1,    -1,  1350,  3825,  3632,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2838,    -1,
      -1,  2897,    -1,    -1,  2900,    -1,  2902,    -1,    -1,  1375,
      -1,  2907,  2908,    -1,    -1,    -1,    -1,    -1,  2858,    -1,
      -1,    -1,    -1,    -1,    -1,  2921,  2922,  2923,    -1,  2925,
      -1,    -1,  2928,    -1,    -1,  1887,    -1,    -1,    -1,    -1,
    1892,  1893,    -1,  2883,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1904,    -1,    -1,  1158,    -1,    -1,    -1,    -1,
      -1,  1427,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2965,
    3910,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2919,
    2976,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3931,    -1,    -1,    -1,  3995,    -1,    -1,    -1,  3745,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1211,    -1,
      -1,  3007,    -1,    -1,    -1,    -1,  4016,    -1,    -1,    -1,
      -1,  3961,    -1,    -1,  3770,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3235,    -1,    -1,    -1,  1241,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3998,    -1,
      -1,    -1,  4002,  4003,    -1,    -1,    -1,  3268,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2036,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1311,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4063,    -1,    -1,    -1,  1330,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1603,    -1,    -1,
      -1,  3081,    -1,    -1,    -1,    -1,    -1,  1350,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2110,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1375,  4173,    -1,  3376,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3387,  3933,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3952,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3210,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1427,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2195,  4244,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3490,
    4036,  4291,    -1,    -1,    -1,  3235,    -1,    -1,    -1,  4299,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3518,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3268,  3530,
      -1,  3327,    -1,    -1,    -1,  3331,  3332,  3333,    -1,    -1,
    3336,    -1,    -1,    -1,    -1,  3341,  3342,  3343,  3344,  3345,
    3346,  3347,  3348,  3349,  3350,  3351,  3352,    -1,    -1,    -1,
      -1,    -1,  4108,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3574,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3380,  3381,  3382,  3383,    -1,  3385,
      -1,    -1,    -1,  3389,  3390,  3391,    -1,    -1,  3394,    -1,
    1603,  3397,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1887,    -1,    -1,  4170,  4171,  1892,  1893,    -1,    -1,
    3426,    -1,    -1,    -1,    -1,    -1,  3376,    -1,  1904,    -1,
      -1,    -1,  3438,    -1,    -1,    -1,    -1,  3387,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3452,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4218,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2466,    -1,    -1,    -1,  3719,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4286,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3490,    -1,    -1,    -1,  2506,  2507,    -1,  2509,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2036,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3518,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3530,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2561,
      -1,  2563,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3825,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3574,    -1,    -1,    -1,    -1,  3635,
      -1,    -1,    -1,    -1,  2110,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2616,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1887,  3681,  3682,    -1,  2640,  1892,
    1893,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1904,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3910,
      -1,    -1,    -1,  2665,    -1,  3711,    -1,    -1,    -1,  3715,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2195,
    3931,  2683,    -1,  3729,    -1,  3731,    -1,    -1,    -1,    -1,
    3736,  3737,  3738,    -1,    -1,  3741,  3742,  3743,  3744,    -1,
    3746,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3961,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3719,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2746,    -1,  3792,  3998,    -1,    -1,
      -1,  4002,  4003,    -1,    -1,    -1,    -1,    -1,  2760,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2771,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2036,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3872,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3825,  2838,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2858,  2110,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2883,    -1,  3929,  3930,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3945,
    3946,  3947,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2919,  3964,    -1,
    3910,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3931,  2195,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2466,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3961,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2506,  2507,    -1,  2509,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3998,    -1,
      -1,    -1,  4002,  4003,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4071,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4081,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2561,    -1,  2563,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3081,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4142,    -1,    -1,    -1,
    2616,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2640,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4182,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2665,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2683,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4221,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2466,    -1,    -1,    -1,    -1,    -1,  4265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2746,    -1,    -1,  3235,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2760,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2506,  2507,  2771,  2509,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3268,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2561,    -1,
    2563,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2838,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2858,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2616,    -1,    -1,    -1,  2883,    -1,    -1,
      -1,    -1,    -1,    -1,  3376,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3387,    -1,  2640,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2919,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2665,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2683,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3490,    -1,
      -1,    -1,    -1,  2746,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2760,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3518,    -1,  2771,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3530,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3081,    -1,    -1,    -1,    -1,
      -1,    -1,  3574,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2838,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2858,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2883,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2919,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3719,    -1,  3235,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3268,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3825,    -1,    -1,    -1,    -1,  3081,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3376,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3387,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3910,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3931,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3961,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3490,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3998,    -1,    -1,    -1,
    4002,  4003,  3518,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3530,  3268,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3574,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3376,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3387,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3719,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3490,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3518,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3530,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3825,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3574,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3910,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3931,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3961,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3719,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3998,    -1,    -1,    -1,  4002,  4003,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3825,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3910,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3931,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3961,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    -1,  3998,    -1,    30,    31,  4002,
    4003,    34,    35,    -1,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    68,    -1,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,   116,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,   150,    -1,   152,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,   167,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,   205,   206,   207,   208,    -1,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,
      -1,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,    -1,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,    -1,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,    -1,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
      -1,    -1,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,    -1,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   418,   419,   420,    -1,    -1,
      -1,    -1,    -1,    -1,   427,   428,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    31,    -1,    -1,    34,    35,    -1,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    -1,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
     167,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,   180,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,   206,
     207,   208,    -1,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,    -1,   246,
      -1,    -1,   249,   250,   251,    -1,    -1,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,    -1,
     267,   268,   269,   270,   271,   272,   273,    -1,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
      -1,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,    -1,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,    -1,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,    -1,   344,   345,   346,
     347,   348,   349,    -1,   351,   352,    -1,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
      -1,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,
     427,   428,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    32,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
      -1,    -1,   152,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
     180,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,   206,   207,    -1,    -1,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,    -1,   234,   235,    -1,   237,    -1,   239,
     240,   241,   242,   243,   244,    -1,   246,    -1,    -1,   249,
     250,   251,    -1,    -1,   254,    -1,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,    -1,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,    -1,    -1,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   428,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    39,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    -1,    -1,    68,    -1,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,   150,    -1,   152,   153,   154,
     155,    -1,   157,    -1,    -1,   160,    -1,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,    -1,   179,   180,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
      -1,   206,   207,   208,    -1,   210,   211,   212,    -1,    -1,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
      -1,   246,    -1,    -1,   249,   250,   251,    -1,    -1,   254,
     255,   256,   257,    -1,   259,   260,   261,   262,   263,   264,
     265,    -1,   267,    -1,   269,    -1,   271,   272,   273,    -1,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,    -1,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,    -1,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
     325,   326,   327,    -1,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,    -1,   341,   342,    -1,   344,
     345,   346,   347,   348,   349,    -1,   351,   352,    -1,    -1,
     355,    -1,   357,    -1,    -1,   360,   361,   362,   363,   364,
     365,   366,    -1,    -1,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,    -1,   382,   383,   384,
     385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   408,   409,   410,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,   428,    -1,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
      -1,    -1,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
      -1,   229,   230,   231,   232,    -1,   234,   235,    -1,   237,
      -1,   239,   240,   241,   242,   243,   244,    -1,   246,    -1,
      -1,   249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
      -1,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,    -1,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,    -1,
      -1,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     428,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    39,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    -1,    -1,    68,    -1,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    85,    86,    87,    -1,    -1,    -1,    91,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,   150,    -1,   152,
     153,   154,   155,    -1,   157,    -1,    -1,   160,    -1,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,    -1,   206,   207,   208,    -1,   210,   211,   212,
      -1,    -1,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,    -1,
      -1,   234,   235,   236,   237,    -1,    -1,   240,   241,   242,
     243,   244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,
      -1,   254,   255,   256,   257,    -1,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,    -1,   269,    -1,   271,   272,
     273,    -1,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,    -1,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,   325,   326,   327,    -1,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
      -1,    -1,   355,    -1,   357,    -1,    -1,   360,   361,   362,
     363,   364,   365,   366,    -1,    -1,   369,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,   380,    -1,   382,
     383,   384,   385,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   408,   409,   410,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,   428,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    31,    -1,    -1,    34,    35,    -1,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      68,    -1,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,   167,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,   246,    -1,
      -1,   249,   250,   251,    -1,    -1,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,    -1,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     418,   419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   427,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    31,    -1,
      -1,    34,    35,    -1,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    68,    -1,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,   150,    -1,   152,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,   167,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,   205,   206,   207,   208,    -1,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,
      -1,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,    -1,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,    -1,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,    -1,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
      -1,    -1,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,    -1,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,    -1,    -1,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   418,   419,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   427,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    31,    -1,    -1,    34,    35,    -1,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      68,    -1,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,   167,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,   206,   207,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,   246,    -1,
      -1,   249,   250,   251,    -1,    -1,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,    -1,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     418,   419,    -1,    -1,    -1,    -1,    -1,   425,   426,   427,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    31,    -1,
      -1,    34,    35,    -1,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    68,    -1,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,   150,    -1,   152,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,   167,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,   205,   206,   207,   208,    -1,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,
      -1,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,    -1,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,    -1,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,    -1,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
      -1,    -1,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,    -1,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   418,   419,   420,    -1,    -1,
      -1,    -1,    -1,    -1,   427,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    31,    -1,    -1,    34,    35,    -1,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      68,    -1,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,   167,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,   206,   207,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,   246,    -1,
      -1,   249,   250,   251,    -1,    -1,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,    -1,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     418,   419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   427,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    31,    -1,
      -1,    34,    35,    -1,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    68,    -1,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,   150,    -1,   152,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,   167,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,   205,   206,   207,   208,    -1,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,
      -1,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,    -1,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,    -1,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,    -1,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
      -1,    -1,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,    -1,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   418,   419,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   427,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    31,    -1,    -1,    34,    35,    -1,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      68,    -1,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,   167,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,   206,   207,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,   246,    -1,
      -1,   249,   250,   251,    -1,    -1,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,    -1,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     418,   419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   427,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    31,    -1,
      -1,    34,    35,    -1,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    68,    -1,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,   150,    -1,   152,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,   167,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,   205,   206,   207,   208,    -1,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,
      -1,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,    -1,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,    -1,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,    -1,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
      -1,    -1,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,    -1,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   418,   419,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   427,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    31,    -1,    -1,    34,    35,    -1,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      68,    -1,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,   167,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,   206,   207,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,   246,    -1,
      -1,   249,   250,   251,    -1,    -1,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,    -1,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     418,   419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   427,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    31,    -1,
      -1,    34,    35,    -1,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    68,    -1,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,   150,    -1,   152,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,   167,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,   205,   206,   207,   208,    -1,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,
      -1,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,    -1,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,    -1,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,    -1,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
      -1,    -1,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,    -1,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   418,   419,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   427,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    31,    -1,    -1,    34,    35,    -1,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      68,    -1,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,   167,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,   206,   207,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,   246,    -1,
      -1,   249,   250,   251,    -1,    -1,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,    -1,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     418,   419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   427,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    31,    -1,
      -1,    34,    35,    -1,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    68,    -1,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,   150,    -1,   152,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,   167,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,   205,   206,   207,   208,    -1,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,
      -1,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,    -1,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,    -1,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,    -1,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
      -1,    -1,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,    -1,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   418,   419,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   427,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    31,    -1,    -1,    34,    35,    -1,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      68,    -1,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,   167,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,   206,   207,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,   246,    -1,
      -1,   249,   250,   251,    -1,    -1,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,    -1,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     418,   419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   427,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    31,    -1,
      -1,    34,    35,    -1,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    68,    -1,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,   150,    -1,   152,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,   167,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,   205,   206,   207,   208,    -1,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,
      -1,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,    -1,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,    -1,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,    -1,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
      -1,    -1,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,    -1,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   418,   419,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   427,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    31,    -1,    -1,    34,    35,    -1,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      68,    -1,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,   167,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,   206,   207,
     208,    -1,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,    -1,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,    -1,   246,    -1,
      -1,   249,   250,   251,    -1,    -1,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,    -1,
      -1,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     418,   419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   427,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    31,    -1,
      -1,    34,    35,    -1,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    68,    -1,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,   150,    -1,   152,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,   205,   206,   207,    -1,    -1,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
      -1,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,
      -1,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,    -1,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,    -1,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,    -1,   325,   326,   327,    -1,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
      -1,    -1,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,    -1,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   418,   419,    -1,    -1,     3,
       4,     5,     6,     7,   427,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    31,    -1,    -1,
      34,    35,    -1,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    68,    -1,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,    -1,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,    -1,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,   167,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,   177,    -1,   179,   180,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,   206,   207,   208,    -1,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,    -1,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,    -1,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
      -1,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,    -1,    -1,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,     6,     7,    -1,     9,
      10,    -1,    -1,   427,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    31,    -1,    -1,    34,    35,    -1,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    68,    -1,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
     150,    -1,   152,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,   167,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
     180,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,   206,   207,   208,    -1,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,    -1,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,    -1,   246,    -1,    -1,   249,
     250,   251,    -1,    -1,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,    -1,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,    -1,    -1,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,   427,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    31,    -1,    -1,    34,    35,
      -1,    37,    38,    39,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    68,    -1,    70,    71,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,    -1,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,   150,    -1,   152,   153,   154,   155,
      -1,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,   177,    -1,   179,   180,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
     206,   207,    -1,    -1,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,    -1,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,    -1,
     246,    -1,    -1,   249,   250,   251,    -1,    -1,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,    -1,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,    -1,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,    -1,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   418,   419,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   427,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      31,    -1,    -1,    34,    35,    -1,    37,    38,    39,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    68,    -1,    70,
      71,    72,    73,    74,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,    -1,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,   150,
      -1,   152,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,   180,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,    -1,   204,   205,   206,   207,    -1,    -1,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,    -1,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,    -1,   246,    -1,    -1,   249,   250,
     251,    -1,    -1,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,    -1,   267,   268,   269,   270,
     271,   272,   273,    -1,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,    -1,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,    -1,   325,   326,   327,    -1,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,    -1,   344,   345,   346,   347,   348,   349,    -1,
     351,   352,    -1,    -1,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,    -1,    -1,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
      -1,    -1,    -1,    -1,    -1,    -1,     3,   418,   419,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   427,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    -1,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
     167,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,   180,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,   206,
     207,   208,    -1,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,    -1,   234,   235,   236,
     237,    -1,   239,   240,   241,   242,   243,   244,    -1,   246,
      -1,   248,   249,   250,   251,    -1,    -1,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,    -1,
     267,   268,   269,   270,   271,   272,   273,    -1,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
      -1,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,    -1,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,    -1,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,    -1,   351,   352,    -1,    -1,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
      -1,    -1,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,    -1,    -1,   391,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     427,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    68,    -1,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,   150,    -1,   152,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,   167,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,   180,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,   205,   206,   207,   208,    -1,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
      -1,   234,   235,   236,   237,    -1,   239,   240,   241,   242,
     243,   244,    -1,   246,    -1,   248,   249,   250,   251,    -1,
      -1,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,    -1,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,    -1,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,    -1,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
      -1,    -1,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,    -1,    -1,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   427,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    68,
      -1,    70,    71,    72,    73,    74,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,   150,    -1,   152,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,   167,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,   205,   206,   207,   208,
      -1,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,    -1,   234,   235,   236,   237,    -1,
     239,   240,   241,   242,   243,   244,    -1,   246,    -1,    -1,
     249,   250,   251,    -1,    -1,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,    -1,   267,   268,
     269,   270,   271,   272,   273,    -1,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,    -1,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,    -1,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,    -1,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,    -1,   344,   345,   346,   347,   348,
     349,    -1,   351,   352,    -1,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,    -1,    -1,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,
       5,    -1,    -1,    -1,     9,    -1,    -1,    -1,   427,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    -1,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,   150,    -1,   152,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,   167,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,   180,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
     205,   206,   207,   208,    -1,   210,   211,   212,    -1,    -1,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,    -1,   234,
     235,   236,   237,    -1,   239,   240,   241,   242,   243,   244,
      -1,   246,   247,    -1,   249,   250,   251,    -1,    -1,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,    -1,   267,   268,   269,   270,   271,   272,   273,    -1,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,    -1,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,    -1,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
     325,   326,   327,    -1,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,    -1,   344,
     345,   346,   347,   348,   349,    -1,   351,   352,    -1,    -1,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,    -1,    -1,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,    -1,    -1,    -1,    -1,
      -1,    -1,     3,   418,   419,   420,    -1,    -1,    -1,    -1,
      -1,    -1,   427,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    26,    27,    -1,    -1,    30,
      -1,    -1,    -1,    34,    35,    -1,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    68,    -1,    70,
      71,    72,    73,    74,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,
      91,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,   150,
      -1,   152,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,   167,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,   180,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,    -1,   204,   205,   206,   207,   208,    -1,   210,
     211,   212,    -1,    -1,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,    -1,   234,   235,   236,   237,    -1,   239,   240,
     241,   242,   243,   244,    -1,   246,    -1,    -1,   249,   250,
     251,    -1,    -1,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,    -1,   267,   268,   269,   270,
     271,   272,   273,    -1,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,    -1,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,   325,   326,   327,    -1,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,    -1,
     351,   352,    -1,    -1,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,    -1,    -1,   369,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,    -1,    -1,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   427,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    -1,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
     167,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,   180,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,   206,
     207,   208,    -1,   210,   211,   212,    -1,    -1,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,    -1,   234,   235,   236,
     237,    -1,   239,   240,   241,   242,   243,   244,    -1,   246,
      -1,    -1,   249,   250,   251,    -1,    -1,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,    -1,
     267,   268,   269,   270,   271,   272,   273,    -1,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
      -1,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,    -1,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,   325,   326,
     327,    -1,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,    -1,   344,   345,   346,
     347,   348,   349,    -1,   351,   352,    -1,    -1,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
      -1,    -1,   369,   370,   371,   372,   373,    -1,    -1,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     427,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    -1,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    -1,    -1,    70,    71,    72,
      73,    -1,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,    -1,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,    -1,    -1,   210,   211,   212,
      -1,    -1,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,    -1,   229,   230,   231,   232,
      -1,   234,   235,    -1,   237,    -1,   239,   240,   241,   242,
     243,   244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,
      -1,   254,    -1,    -1,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,    -1,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,    -1,   299,   300,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,    -1,   325,   326,   327,    -1,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
      -1,    -1,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,    -1,    -1,   369,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   427,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    -1,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    -1,
      -1,    70,    71,    72,    73,    -1,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,    -1,
      -1,   210,   211,   212,    -1,    -1,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,    -1,
     229,   230,   231,   232,    -1,   234,   235,    -1,   237,    -1,
     239,   240,   241,   242,   243,   244,    -1,   246,    -1,    -1,
     249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,   258,
     259,   260,   261,   262,   263,   264,   265,    -1,   267,   268,
     269,   270,   271,   272,   273,    -1,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,    -1,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,    -1,
     299,   300,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,    -1,   325,   326,   327,    -1,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,    -1,   344,   345,   346,   347,   348,
     349,    -1,   351,   352,    -1,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,    -1,    -1,
     369,   370,   371,   372,   373,    -1,    -1,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,    -1,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   427,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      -1,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,
     155,    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,
      -1,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,    -1,    -1,   210,   211,   212,    -1,    -1,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,    -1,   229,   230,   231,   232,    -1,   234,
     235,    -1,   237,    -1,   239,   240,   241,   242,   243,   244,
      -1,   246,    -1,    -1,   249,   250,   251,    -1,    -1,   254,
      -1,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,    -1,   267,   268,   269,   270,   271,   272,   273,    -1,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,    -1,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,    -1,   299,   300,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,    -1,
     325,   326,   327,    -1,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,    -1,   344,
     345,   346,   347,   348,   349,    -1,   351,   352,    -1,    -1,
     355,   356,   357,   358,    -1,   360,   361,   362,   363,   364,
     365,   366,    -1,    -1,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
      -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,    -1,    -1,    -1,    -1,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   427,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    -1,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,    70,
      71,    72,    73,    -1,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,
      -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,    -1,   196,   197,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,    -1,    -1,   210,
     211,   212,    -1,    -1,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,    -1,   229,   230,
     231,   232,    -1,   234,   235,    -1,   237,    -1,   239,   240,
     241,   242,   243,   244,    -1,   246,    -1,    -1,   249,   250,
     251,    -1,    -1,   254,    -1,    -1,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,    -1,   267,   268,   269,   270,
     271,   272,   273,    -1,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,    -1,   299,   300,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,    -1,   325,   326,   327,    -1,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,    -1,   344,   345,   346,   347,   348,   349,    -1,
     351,   352,    -1,    -1,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,    -1,    -1,   369,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   427,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    -1,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,    -1,    -1,   210,   211,   212,    -1,    -1,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,    -1,   229,   230,   231,   232,    -1,   234,   235,    -1,
     237,    -1,   239,   240,   241,   242,   243,   244,    -1,   246,
      -1,    -1,   249,   250,   251,    -1,    -1,   254,    -1,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,    -1,
     267,   268,   269,   270,   271,   272,   273,    -1,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
      -1,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,    -1,   299,   300,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,    -1,   325,   326,
     327,    -1,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,    -1,   344,   345,   346,
     347,   348,   349,    -1,   351,   352,    -1,    -1,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
      -1,    -1,   369,   370,   371,   372,   373,    -1,    -1,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,    -1,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,    -1,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,    -1,    -1,     8,     9,    -1,    -1,    -1,
     427,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    -1,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,    -1,   136,   137,   138,    -1,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,    -1,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,    -1,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,    -1,
     233,   234,   235,   236,   237,   238,    -1,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,    -1,   255,   256,   257,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,    -1,   269,    -1,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,    -1,   357,    -1,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,    -1,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   408,   409,   410,    -1,    -1,
      -1,   414,   415,   416,    -1,   418,   419,   420,   421,   422,
     423,     3,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,    -1,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,
      -1,   153,   154,   155,    -1,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
      -1,    -1,   194,    -1,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,    -1,    -1,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,    -1,   229,   230,   231,
     232,    -1,   234,   235,    -1,   237,    -1,   239,   240,   241,
     242,   243,   244,    -1,   246,    -1,    -1,   249,   250,   251,
      -1,    -1,   254,    -1,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,    -1,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,    -1,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,    -1,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,    -1,    -1,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,    -1,
      -1,    -1,   414,   415,   416,    -1,   418,   419,   420,   421,
     422,   423,     3,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    -1,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,    70,
      71,    72,    73,    -1,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,
      -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,    -1,   196,   197,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,    -1,    -1,   210,
     211,   212,    -1,    -1,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,    -1,   229,   230,
     231,   232,    -1,   234,   235,    -1,   237,    -1,   239,   240,
     241,   242,   243,   244,    -1,   246,    -1,    -1,   249,   250,
     251,    -1,    -1,   254,    -1,    -1,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,    -1,   267,   268,   269,   270,
     271,   272,   273,    -1,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,    -1,   299,   300,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,    -1,   325,   326,   327,    -1,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,    -1,   344,   345,   346,   347,   348,   349,    -1,
     351,   352,    -1,    -1,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,    -1,    -1,   369,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
      -1,    -1,    -1,   414,   415,   416,    -1,   418,   419,   420,
     421,   422,   423,     3,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
      -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,    -1,    -1,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,    -1,   229,
     230,   231,   232,    -1,   234,   235,    -1,   237,    -1,   239,
     240,   241,   242,   243,   244,    -1,   246,    -1,    -1,   249,
     250,   251,    -1,    -1,   254,    -1,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,    -1,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,    -1,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,    -1,    -1,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,    -1,    -1,    -1,   414,   415,   416,    -1,   418,   419,
     420,   421,   422,   423,     3,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    -1,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    -1,
      -1,    70,    71,    72,    73,    -1,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,    -1,
      -1,   210,   211,   212,    -1,    -1,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,    -1,
     229,   230,   231,   232,    -1,   234,   235,    -1,   237,    -1,
     239,   240,   241,   242,   243,   244,    -1,   246,    -1,    -1,
     249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,   258,
     259,   260,   261,   262,   263,   264,   265,    -1,   267,   268,
     269,   270,   271,   272,   273,    -1,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,    -1,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,    -1,
     299,   300,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,    -1,   325,   326,   327,    -1,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,    -1,   344,   345,   346,   347,   348,
     349,    -1,   351,   352,    -1,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,    -1,    -1,
     369,   370,   371,   372,   373,    -1,    -1,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,    -1,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,    -1,    -1,    -1,   414,   415,   416,    -1,   418,
     419,   420,   421,   422,   423,     3,    -1,    -1,    -1,    -1,
       8,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
      -1,    -1,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
      -1,   229,   230,   231,   232,    -1,   234,   235,    -1,   237,
      -1,   239,   240,   241,   242,   243,   244,    -1,   246,    -1,
      -1,   249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
      -1,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,    -1,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,    -1,
      -1,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,    -1,    -1,    -1,   414,   415,   416,    -1,
     418,   419,   420,   421,   422,   423,     3,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    -1,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,   141,    -1,   143,   144,   145,    -1,
     147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,   169,   170,    -1,   172,   173,   174,   175,   176,
     177,    -1,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,    -1,    -1,   210,   211,   212,    -1,    -1,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,    -1,   229,   230,   231,   232,    -1,   234,   235,    -1,
     237,    -1,   239,   240,   241,   242,   243,   244,    -1,   246,
      -1,    -1,   249,   250,   251,    -1,    -1,   254,    -1,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,    -1,
     267,   268,   269,   270,   271,   272,   273,    -1,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
      -1,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,    -1,   299,   300,    -1,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,    -1,   314,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,    -1,   325,   326,
     327,    -1,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,    -1,   344,   345,   346,
     347,   348,   349,    -1,   351,   352,    -1,    -1,   355,   356,
     357,   358,    -1,   360,   361,   362,   363,   364,   365,   366,
      -1,    -1,   369,   370,   371,   372,   373,    -1,    -1,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,    -1,   386,
     387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,    -1,    -1,    -1,   414,   415,   416,
      -1,   418,   419,   420,   421,   422,   423,     3,    -1,    -1,
      -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,
      -1,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,   177,    -1,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,    -1,    -1,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,    -1,   234,   235,
      -1,   237,    -1,   239,   240,   241,   242,   243,   244,    -1,
     246,    -1,    -1,   249,   250,   251,    -1,    -1,   254,    -1,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,    -1,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,    -1,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,    -1,    -1,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,    -1,    -1,     3,   414,   415,
     416,    -1,   418,   419,   420,   421,   422,   423,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   420,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
      -1,    -1,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
      -1,   229,   230,   231,   232,    -1,   234,   235,    -1,   237,
      -1,   239,   240,   241,   242,   243,   244,    -1,   246,    -1,
      -1,   249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
      -1,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,    -1,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,    -1,
      -1,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   420,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
      -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,    -1,    -1,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,    -1,   229,
     230,   231,   232,    -1,   234,   235,    -1,   237,    -1,   239,
     240,   241,   242,   243,   244,    -1,   246,    -1,    -1,   249,
     250,   251,    -1,    -1,   254,    -1,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,    -1,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,    -1,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,    -1,    -1,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     420,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    39,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    -1,    -1,    68,    -1,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,    91,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,    -1,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,   150,    -1,
     152,   153,   154,   155,    -1,   157,    -1,    -1,   160,    -1,
     162,   163,   164,   165,   166,   167,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,    -1,   246,    -1,    -1,   249,   250,   251,
      -1,    -1,    -1,   255,   256,   257,    -1,   259,   260,   261,
     262,   263,   264,   265,    -1,   267,    -1,   269,    -1,   271,
     272,   273,    -1,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,    -1,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,    -1,   355,    -1,   357,    -1,    -1,   360,   361,
     362,   363,   364,   365,   366,    -1,    -1,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,    -1,
     382,    -1,   384,   385,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,   408,   409,   410,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,   420,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    39,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    -1,    -1,    68,    -1,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,    -1,   136,   137,   138,    -1,    -1,   141,    -1,   143,
     144,   145,    -1,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,    -1,   157,    -1,    -1,   160,    -1,   162,   163,
     164,   165,   166,   167,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,    -1,   206,   207,   208,    -1,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,    -1,    -1,
     234,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,    -1,
      -1,   255,   256,   257,    -1,   259,   260,   261,   262,   263,
     264,   265,    -1,   267,    -1,   269,    -1,   271,   272,   273,
      -1,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,    -1,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
      -1,   355,    -1,   357,    -1,    -1,   360,   361,   362,   363,
     364,   365,   366,    -1,    -1,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,    -1,   382,    -1,
     384,   385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,    -1,    -1,     3,     4,     5,
      -1,    -1,    -1,     9,   408,   409,   410,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,   420,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    68,    -1,    70,    71,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    85,
      86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,   150,    -1,   152,   153,   154,   155,
      -1,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,   167,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,   177,    -1,   179,   180,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
     206,   207,   208,    -1,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,    -1,   234,   235,
     236,   237,    -1,   239,   240,   241,   242,   243,   244,    -1,
     246,   247,    -1,   249,   250,   251,    -1,    -1,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,    -1,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,    -1,    -1,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,     3,     4,     5,    -1,    -1,
      -1,     9,   418,   419,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      68,    -1,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,   167,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,   206,   207,
     208,    -1,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,    -1,   234,   235,   236,   237,
      -1,   239,   240,   241,   242,   243,   244,    -1,   246,   247,
      -1,   249,   250,   251,    -1,    -1,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,    -1,
      -1,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,     3,     4,     5,    -1,    -1,    -1,     9,
     418,   419,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    68,    -1,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
     150,    -1,   152,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,   167,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
     180,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,   206,   207,   208,    -1,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,    -1,   234,   235,   236,   237,    -1,   239,
     240,   241,   242,   243,   244,    -1,   246,   247,    -1,   249,
     250,   251,    -1,    -1,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,    -1,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,    -1,    -1,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,     3,    -1,    -1,    -1,    -1,    -1,     9,   418,   419,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,    -1,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,   151,
      -1,   153,   154,   155,    -1,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,    -1,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
      -1,    -1,   194,    -1,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,    -1,    -1,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,    -1,   229,   230,   231,
     232,    -1,   234,   235,    -1,   237,    -1,   239,   240,   241,
     242,   243,   244,    -1,   246,    -1,    -1,   249,   250,   251,
      -1,    -1,   254,    -1,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,    -1,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,    -1,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,    -1,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,    -1,    -1,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,     3,
       4,     5,    -1,    -1,    -1,     9,   418,   419,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,     3,    -1,     5,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    68,    -1,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
     150,    -1,   152,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,   167,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
     180,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,   206,   207,   208,    -1,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,    -1,   234,   235,   236,   237,    -1,   239,
     240,   241,   242,   243,   244,    -1,   246,   247,    -1,   249,
     250,   251,    -1,    -1,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,    -1,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,    -1,    -1,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,     3,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    68,    -1,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,    91,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,    -1,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,   150,    -1,
     152,   153,   154,   155,    -1,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,   167,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,   180,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,   206,   207,   208,    -1,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,    -1,   234,   235,   236,   237,    -1,   239,   240,   241,
     242,   243,   244,    -1,   246,    -1,    -1,   249,   250,   251,
      -1,    -1,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,    -1,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,    -1,    -1,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    68,    -1,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,    -1,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,    -1,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,   167,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,   177,    -1,   179,   180,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,   206,   207,   208,    -1,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,    -1,
     234,   235,   236,   237,    -1,   239,   240,   241,   242,   243,
     244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,    -1,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
      -1,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,    -1,    -1,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      26,    27,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    68,    -1,    70,    71,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    85,
      86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,   150,    -1,   152,   153,   154,   155,
      -1,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,   167,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,   177,    -1,   179,   180,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
     206,   207,   208,    -1,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,    -1,   234,   235,
     236,   237,    -1,   239,   240,   241,   242,   243,   244,    -1,
     246,    -1,    -1,   249,   250,   251,    -1,    -1,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,    -1,    -1,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,     3,    -1,     5,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      68,    -1,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,   167,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,   206,   207,
     208,    -1,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,    -1,   234,   235,   236,   237,
      -1,   239,   240,   241,   242,   243,   244,    -1,   246,    -1,
      -1,   249,   250,   251,    -1,    -1,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,    -1,
      -1,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,     3,    -1,     5,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    68,    -1,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
     150,    -1,   152,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,   167,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
     180,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,   206,   207,   208,    -1,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,    -1,   234,   235,   236,   237,    -1,   239,
     240,   241,   242,   243,   244,    -1,   246,    -1,    -1,   249,
     250,   251,    -1,    -1,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,    -1,    -1,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    68,    -1,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,    91,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,    -1,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,   150,    -1,
     152,   153,   154,   155,    -1,   157,   158,   159,   160,    -1,
     162,   163,   164,   165,   166,   167,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,   180,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,   206,   207,   208,    -1,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,    -1,   234,   235,   236,   237,    -1,   239,   240,   241,
     242,   243,   244,    -1,   246,    -1,    -1,   249,   250,   251,
      -1,    -1,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,    -1,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,    -1,    -1,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    68,    -1,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,    -1,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,    -1,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,   167,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,   177,    -1,   179,   180,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,   206,   207,   208,    -1,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,    -1,
     234,   235,   236,   237,    -1,   239,   240,   241,   242,   243,
     244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,    -1,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
      -1,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,    -1,    -1,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    68,    -1,    70,    71,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    85,
      86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,   150,    -1,   152,   153,   154,   155,
      -1,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,   167,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,   177,    -1,   179,   180,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
     206,   207,   208,    -1,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,    -1,   234,   235,
     236,   237,    -1,   239,   240,   241,   242,   243,   244,    -1,
     246,    -1,    -1,   249,   250,   251,    -1,    -1,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,    -1,    -1,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      68,    -1,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,   167,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,   206,   207,
     208,    -1,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,    -1,   234,   235,   236,   237,
      -1,   239,   240,   241,   242,   243,   244,    -1,   246,    -1,
      -1,   249,   250,   251,    -1,    -1,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,    -1,
      -1,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    68,    -1,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
     150,    -1,   152,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,   167,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
     180,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,   206,   207,   208,    -1,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,    -1,   234,   235,   236,   237,    -1,   239,
     240,   241,   242,   243,   244,    -1,   246,    -1,    -1,   249,
     250,   251,    -1,    -1,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,    -1,    -1,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    68,    -1,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,    91,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,    -1,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,   150,    -1,
     152,   153,   154,   155,    -1,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,   167,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,   180,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,   206,   207,   208,    -1,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,    -1,   234,   235,   236,   237,    -1,   239,   240,   241,
     242,   243,   244,    -1,   246,    -1,    -1,   249,   250,   251,
      -1,    -1,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,    -1,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,    -1,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,    -1,    -1,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    68,    -1,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,    -1,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,    -1,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,   167,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,   177,    -1,   179,   180,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,   206,   207,   208,    -1,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,    -1,
     234,   235,   236,   237,    -1,   239,   240,   241,   242,   243,
     244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,    -1,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
      -1,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,    -1,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
     324,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,    -1,    -1,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    68,    -1,    70,    71,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    85,
      86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,   150,    -1,   152,   153,   154,   155,
      -1,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,   167,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,   177,    -1,   179,   180,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
     206,   207,   208,    -1,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,    -1,   234,   235,
     236,   237,    -1,   239,   240,   241,   242,   243,   244,    -1,
     246,    -1,    -1,   249,   250,   251,    -1,    -1,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,    -1,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,    -1,    -1,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      68,    -1,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,   167,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,   206,   207,
     208,    -1,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,    -1,   234,   235,   236,   237,
      -1,   239,   240,   241,   242,   243,   244,    -1,   246,    -1,
      -1,   249,   250,   251,    -1,    -1,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
      -1,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,    -1,
      -1,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    68,    -1,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
     150,    -1,   152,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,   167,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
     180,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,   206,   207,   208,    -1,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,    -1,   234,   235,   236,   237,    -1,   239,
     240,   241,   242,   243,   244,    -1,   246,    -1,    -1,   249,
     250,   251,    -1,    -1,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,    -1,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,   324,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,    -1,    -1,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    -1,    -1,    69,    70,    71,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,    -1,   141,
      -1,   143,   144,   145,    -1,   147,   148,   149,    -1,    -1,
      -1,   153,   154,   155,    -1,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
      -1,    -1,   194,    -1,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,    -1,    -1,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,    -1,   229,   230,   231,
     232,    -1,   234,   235,    -1,   237,    -1,   239,   240,   241,
     242,   243,   244,    -1,   246,    -1,    -1,   249,   250,   251,
      -1,    -1,   254,    -1,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,    -1,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,    -1,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,    -1,   368,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,    -1,   147,   148,   149,    -1,    -1,    -1,   153,
     154,   155,    -1,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,   177,    -1,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,
     194,    -1,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,    -1,   229,   230,   231,   232,    -1,
     234,   235,    -1,   237,    -1,   239,   240,   241,   242,   243,
     244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,    -1,
     254,    -1,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,    -1,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
      -1,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,    -1,   368,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,   177,    -1,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,    -1,    -1,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,    -1,   234,   235,
      -1,   237,    -1,   239,   240,   241,   242,   243,   244,    -1,
     246,    -1,    -1,   249,   250,   251,    -1,    -1,   254,    -1,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,    -1,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,    -1,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,    -1,    -1,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,    -1,    -1,    -1,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
      -1,    -1,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
      -1,   229,   230,   231,   232,    -1,   234,   235,    -1,   237,
      -1,   239,   240,   241,   242,   243,   244,    -1,   246,    -1,
      -1,   249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
      -1,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,    -1,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,    -1,
      -1,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,   148,   149,
      -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,    -1,    -1,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,    -1,   229,
     230,   231,   232,    -1,   234,   235,    -1,   237,    -1,   239,
     240,   241,   242,   243,   244,    -1,   246,    -1,    -1,   249,
     250,   251,    -1,    -1,   254,    -1,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,    -1,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,    -1,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,    -1,   368,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,    -1,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,
      -1,   153,   154,   155,    -1,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
      -1,    -1,   194,    -1,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,    -1,    -1,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,    -1,   229,   230,   231,
     232,    -1,   234,   235,    -1,   237,    -1,   239,   240,   241,
     242,   243,   244,    -1,   246,    -1,    -1,   249,   250,   251,
      -1,    -1,   254,    -1,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,    -1,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,    -1,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,    -1,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,    -1,    -1,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,    -1,   147,   148,   149,    -1,    -1,    -1,   153,
     154,   155,    -1,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,   177,    -1,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,
     194,    -1,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,    -1,    -1,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,    -1,   229,   230,   231,   232,    -1,
     234,   235,    -1,   237,    -1,   239,   240,   241,   242,   243,
     244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,    -1,
     254,    -1,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
      -1,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,    -1,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
      -1,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,    -1,    -1,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,
      -1,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,   177,    -1,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,    -1,    -1,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,    -1,   234,   235,
      -1,   237,    -1,   239,   240,   241,   242,   243,   244,    -1,
     246,    -1,    -1,   249,   250,   251,    -1,    -1,   254,    -1,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,    -1,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,    -1,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,    -1,    -1,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    26,    27,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
      -1,    -1,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
      -1,   229,   230,   231,   232,    -1,   234,   235,    -1,   237,
      -1,   239,   240,   241,   242,   243,   244,    -1,   246,    -1,
      -1,   249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
      -1,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,    -1,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,    -1,
      -1,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
      -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,    -1,    -1,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,    -1,   229,
     230,   231,   232,    -1,   234,   235,    -1,   237,    -1,   239,
     240,   241,   242,   243,   244,    -1,   246,    -1,    -1,   249,
     250,   251,    -1,    -1,   254,    -1,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,    -1,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,    -1,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,    -1,    -1,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,    -1,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,
      -1,   153,   154,   155,    -1,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
      -1,    -1,   194,    -1,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,    -1,    -1,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,    -1,   229,   230,   231,
     232,    -1,   234,   235,    -1,   237,    -1,   239,   240,   241,
     242,   243,   244,    -1,   246,    -1,    -1,   249,   250,   251,
      -1,    -1,   254,    -1,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,    -1,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,    -1,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,    -1,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,    -1,    -1,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,
     154,   155,    -1,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,   177,    -1,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,
     194,    -1,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,    -1,    -1,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,    -1,   229,   230,   231,   232,    -1,
     234,   235,    -1,   237,    -1,   239,   240,   241,   242,   243,
     244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,    -1,
     254,    -1,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
      -1,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,    -1,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
      -1,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,    -1,    -1,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,
      -1,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,   177,    -1,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,    -1,    -1,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,    -1,   234,   235,
      -1,   237,    -1,   239,   240,   241,   242,   243,   244,    -1,
     246,    -1,    -1,   249,   250,   251,    -1,    -1,   254,    -1,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,    -1,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,    -1,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,    -1,    -1,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
      -1,    -1,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
      -1,   229,   230,   231,   232,    -1,   234,   235,    -1,   237,
      -1,   239,   240,   241,   242,   243,   244,    -1,   246,    -1,
      -1,   249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
      -1,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,    -1,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,    -1,
      -1,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
      -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,    -1,    -1,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,    -1,   229,
     230,   231,   232,    -1,   234,   235,    -1,   237,    -1,   239,
     240,   241,   242,   243,   244,    -1,   246,    -1,    -1,   249,
     250,   251,    -1,    -1,   254,    -1,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,    -1,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,    -1,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,    -1,    -1,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,    -1,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,
      -1,   153,   154,   155,    -1,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
      -1,    -1,   194,    -1,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,    -1,    -1,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,    -1,   229,   230,   231,
     232,    -1,   234,   235,    -1,   237,    -1,   239,   240,   241,
     242,   243,   244,    -1,   246,    -1,   248,   249,   250,   251,
      -1,    -1,   254,    -1,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,    -1,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,    -1,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,    -1,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,    -1,    -1,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,
     154,   155,    -1,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,   177,    -1,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,
     194,    -1,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,    -1,    -1,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,    -1,   229,   230,   231,   232,    -1,
     234,   235,    -1,   237,    -1,   239,   240,   241,   242,   243,
     244,    -1,   246,    -1,   248,   249,   250,   251,    -1,    -1,
     254,    -1,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
      -1,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,    -1,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
      -1,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,    -1,    -1,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,
      -1,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,   177,    -1,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,    -1,    -1,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,    -1,   234,   235,
      -1,   237,    -1,   239,   240,   241,   242,   243,   244,    -1,
     246,    -1,    -1,   249,   250,   251,    -1,    -1,   254,    -1,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,    -1,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,    -1,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,    -1,    -1,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
      -1,    -1,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
      -1,   229,   230,   231,   232,    -1,   234,   235,    -1,   237,
      -1,   239,   240,   241,   242,   243,   244,    -1,   246,    -1,
      -1,   249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
      -1,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,    -1,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,    -1,
      -1,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    39,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
      -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,    -1,    -1,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,    -1,   229,
     230,   231,   232,    -1,   234,   235,    -1,   237,    -1,   239,
     240,   241,   242,   243,   244,    -1,   246,    -1,    -1,   249,
     250,   251,    -1,    -1,   254,    -1,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,    -1,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,    -1,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,    -1,    -1,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,    -1,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,
      -1,   153,   154,   155,    -1,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
      -1,    -1,   194,    -1,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,    -1,    -1,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,    -1,   229,   230,   231,
     232,    -1,   234,   235,    -1,   237,    -1,   239,   240,   241,
     242,   243,   244,    -1,   246,    -1,   248,   249,   250,   251,
      -1,    -1,   254,    -1,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,    -1,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,    -1,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,    -1,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,    -1,    -1,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,
     154,   155,    -1,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,   177,    -1,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,
     194,    -1,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,    -1,    -1,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,    -1,   229,   230,   231,   232,    -1,
     234,   235,    -1,   237,    -1,   239,   240,   241,   242,   243,
     244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,    -1,
     254,    -1,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
      -1,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,    -1,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
      -1,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,    -1,    -1,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,     3,    -1,     5,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,
      -1,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,   177,    -1,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,    -1,    -1,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,    -1,   234,   235,
      -1,   237,    -1,   239,   240,   241,   242,   243,   244,    -1,
     246,    -1,    -1,   249,   250,   251,    -1,    -1,   254,    -1,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,    -1,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,    -1,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,    -1,    -1,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    32,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
      -1,    -1,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
      -1,   229,   230,   231,   232,    -1,   234,   235,    -1,   237,
      -1,   239,   240,   241,   242,   243,   244,    -1,   246,    -1,
      -1,   249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
      -1,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,    -1,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,    -1,
      -1,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    32,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
      -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,    -1,    -1,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,    -1,   229,
     230,   231,   232,    -1,   234,   235,    -1,   237,    -1,   239,
     240,   241,   242,   243,   244,    -1,   246,    -1,    -1,   249,
     250,   251,    -1,    -1,   254,    -1,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,    -1,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,    -1,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,    -1,    -1,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,    -1,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,
      -1,   153,   154,   155,    -1,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
      -1,    -1,   194,    -1,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,    -1,    -1,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,    -1,   229,   230,   231,
     232,    -1,   234,   235,    -1,   237,    -1,   239,   240,   241,
     242,   243,   244,    -1,   246,    -1,    -1,   249,   250,   251,
      -1,    -1,   254,    -1,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,    -1,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,    -1,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,    -1,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,    -1,    -1,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,
     154,   155,    -1,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,   177,    -1,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,
     194,    -1,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,    -1,    -1,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,    -1,   229,   230,   231,   232,    -1,
     234,   235,    -1,   237,    -1,   239,   240,   241,   242,   243,
     244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,    -1,
     254,    -1,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
      -1,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,    -1,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
      -1,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,    -1,    -1,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,
      -1,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,   177,    -1,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,    -1,    -1,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,    -1,   234,   235,
      -1,   237,    -1,   239,   240,   241,   242,   243,   244,    -1,
     246,    -1,    -1,   249,   250,   251,    -1,    -1,   254,    -1,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,    -1,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,    -1,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,    -1,    -1,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
      -1,    -1,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
      -1,   229,   230,   231,   232,    -1,   234,   235,    -1,   237,
      -1,   239,   240,   241,   242,   243,   244,    -1,   246,    -1,
      -1,   249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
      -1,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,    -1,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,    -1,
      -1,   369,   370,   371,   372,   373,    -1,   375,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
      -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,    -1,    -1,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,    -1,   229,
     230,   231,   232,    -1,   234,   235,    -1,   237,    -1,   239,
     240,   241,   242,   243,   244,    -1,   246,    -1,    -1,   249,
     250,   251,    -1,    -1,   254,    -1,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,    -1,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,    -1,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,    -1,    -1,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,    -1,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,
      -1,   153,   154,   155,    -1,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
      -1,    -1,   194,    -1,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,    -1,    -1,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,    -1,   229,   230,   231,
     232,    -1,   234,   235,    -1,   237,    -1,   239,   240,   241,
     242,   243,   244,    -1,   246,    -1,    -1,   249,   250,   251,
      -1,    -1,   254,    -1,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,    -1,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,    -1,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,    -1,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,    -1,    -1,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,
     154,   155,    -1,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,   177,    -1,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,
     194,    -1,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,    -1,    -1,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,    -1,   229,   230,   231,   232,    -1,
     234,   235,    -1,   237,    -1,   239,   240,   241,   242,   243,
     244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,    -1,
     254,    -1,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
      -1,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,    -1,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
      -1,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,    -1,    -1,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,
      -1,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,   177,    -1,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,    -1,    -1,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,    -1,   234,   235,
      -1,   237,    -1,   239,   240,   241,   242,   243,   244,    -1,
     246,    -1,    -1,   249,   250,   251,    -1,    -1,   254,    -1,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,    -1,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,    -1,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,    -1,    -1,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
      -1,    -1,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
      -1,   229,   230,   231,   232,    -1,   234,   235,    -1,   237,
      -1,   239,   240,   241,   242,   243,   244,    -1,   246,    -1,
      -1,   249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
      -1,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,    -1,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,    -1,
      -1,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
      -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,    -1,    -1,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,    -1,   229,
     230,   231,   232,    -1,   234,   235,    -1,   237,    -1,   239,
     240,   241,   242,   243,   244,    -1,   246,    -1,    -1,   249,
     250,   251,    -1,    -1,   254,    -1,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,    -1,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,    -1,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,    -1,    -1,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,    -1,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,
      -1,   153,   154,   155,    -1,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
      -1,    -1,   194,    -1,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,    -1,    -1,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,    -1,   229,   230,   231,
     232,    -1,   234,   235,    -1,   237,    -1,   239,   240,   241,
     242,   243,   244,    -1,   246,    -1,    -1,   249,   250,   251,
      -1,    -1,   254,    -1,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,    -1,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,    -1,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,    -1,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,    -1,    -1,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,
     154,   155,    -1,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,   177,    -1,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,
     194,    -1,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,    -1,    -1,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,    -1,   229,   230,   231,   232,    -1,
     234,   235,    -1,   237,    -1,   239,   240,   241,   242,   243,
     244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,    -1,
     254,    -1,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
      -1,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,    -1,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
      -1,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,    -1,    -1,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,
      -1,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,   177,    -1,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,    -1,    -1,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,    -1,   234,   235,
      -1,   237,    -1,   239,   240,   241,   242,   243,   244,    -1,
     246,    -1,    -1,   249,   250,   251,    -1,    -1,   254,    -1,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,    -1,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,    -1,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,    -1,    -1,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
      -1,    -1,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
      -1,   229,   230,   231,   232,    -1,   234,   235,    -1,   237,
      -1,   239,   240,   241,   242,   243,   244,    -1,   246,    -1,
      -1,   249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
      -1,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,    -1,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,    -1,
      -1,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
      -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,    -1,    -1,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,    -1,   229,
     230,   231,   232,    -1,   234,   235,    -1,   237,    -1,   239,
     240,   241,   242,   243,   244,    -1,   246,    -1,    -1,   249,
     250,   251,    -1,    -1,   254,    -1,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,    -1,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,    -1,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,    -1,    -1,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,    -1,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,
      -1,   153,   154,   155,    -1,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
      -1,    -1,   194,    -1,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,    -1,    -1,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,    -1,   229,   230,   231,
     232,    -1,   234,   235,    -1,   237,    -1,   239,   240,   241,
     242,   243,   244,    -1,   246,    -1,    -1,   249,   250,   251,
      -1,    -1,   254,    -1,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,    -1,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,    -1,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,    -1,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,    -1,    -1,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,
     154,   155,    -1,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,   177,    -1,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,
     194,    -1,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,    -1,    -1,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,    -1,   229,   230,   231,   232,    -1,
     234,   235,    -1,   237,    -1,   239,   240,   241,   242,   243,
     244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,    -1,
     254,    -1,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
      -1,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,    -1,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
      -1,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,    -1,    -1,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,
      -1,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,   177,    -1,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,    -1,    -1,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,    -1,   234,   235,
      -1,   237,    -1,   239,   240,   241,   242,   243,   244,    -1,
     246,    -1,    -1,   249,   250,   251,    -1,    -1,   254,    -1,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,    -1,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,    -1,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,    -1,    -1,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
      -1,    -1,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
      -1,   229,   230,   231,   232,    -1,   234,   235,    -1,   237,
      -1,   239,   240,   241,   242,   243,   244,    -1,   246,    -1,
      -1,   249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
      -1,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,    -1,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,    -1,
      -1,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
      -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,    -1,    -1,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,    -1,   229,
     230,   231,   232,    -1,   234,   235,    -1,   237,    -1,   239,
     240,   241,   242,   243,   244,    -1,   246,    -1,    -1,   249,
     250,   251,    -1,    -1,   254,    -1,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,    -1,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,    -1,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,    -1,    -1,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,    -1,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,
      -1,   153,   154,   155,    -1,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
      -1,    -1,   194,    -1,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,    -1,    -1,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,    -1,   229,   230,   231,
     232,    -1,   234,   235,    -1,   237,    -1,   239,   240,   241,
     242,   243,   244,    -1,   246,    -1,    -1,   249,   250,   251,
      -1,    -1,   254,    -1,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,    -1,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,    -1,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,    -1,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,    -1,    -1,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,
     154,   155,    -1,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,   177,    -1,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,
     194,    -1,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,    -1,    -1,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,    -1,   229,   230,   231,   232,    -1,
     234,   235,    -1,   237,    -1,   239,   240,   241,   242,   243,
     244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,    -1,
     254,    -1,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
      -1,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,    -1,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
      -1,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,    -1,    -1,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,
      -1,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,   177,    -1,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,    -1,    -1,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,    -1,   234,   235,
      -1,   237,    -1,   239,   240,   241,   242,   243,   244,    -1,
     246,    -1,    -1,   249,   250,   251,    -1,    -1,   254,    -1,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,    -1,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,    -1,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,    -1,    -1,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
      -1,    -1,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
      -1,   229,   230,   231,   232,    -1,   234,   235,    -1,   237,
      -1,   239,   240,   241,   242,   243,   244,    -1,   246,    -1,
      -1,   249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
      -1,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,    -1,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,    -1,
      -1,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
      -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,    -1,    -1,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,    -1,   229,
     230,   231,   232,    -1,   234,   235,    -1,   237,    -1,   239,
     240,   241,   242,   243,   244,    -1,   246,    -1,    -1,   249,
     250,   251,    -1,    -1,   254,    -1,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,    -1,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,    -1,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,    -1,    -1,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,    -1,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,
      -1,   153,   154,   155,    -1,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
      -1,    -1,   194,    -1,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,    -1,    -1,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,    -1,   229,   230,   231,
     232,    -1,   234,   235,    -1,   237,    -1,   239,   240,   241,
     242,   243,   244,    -1,   246,    -1,    -1,   249,   250,   251,
      -1,    -1,   254,    -1,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,    -1,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,    -1,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,    -1,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,    -1,    -1,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    32,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,
     154,   155,    -1,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,   177,    -1,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,
     194,    -1,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,    -1,    -1,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,    -1,   229,   230,   231,   232,    -1,
     234,   235,    -1,   237,    -1,   239,   240,   241,   242,   243,
     244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,    -1,
     254,    -1,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
      -1,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,    -1,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,   316,   317,   318,    -1,    -1,   321,   322,   323,
      -1,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,    -1,    -1,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,    -1,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,    -1,    -1,    -1,   153,   154,   155,
      -1,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,   177,    -1,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,    -1,    -1,   194,    -1,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,    -1,    -1,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,    -1,   229,   230,   231,   232,    -1,   234,   235,
      -1,   237,    -1,   239,   240,   241,   242,   243,   244,    -1,
     246,    -1,    -1,   249,   250,   251,    -1,    -1,   254,    -1,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,    -1,   299,   300,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,    -1,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,    -1,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,   365,
     366,    -1,    -1,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,    -1,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
      -1,    -1,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
      -1,   229,   230,   231,   232,    -1,   234,   235,    -1,   237,
      -1,   239,   240,   241,   242,   243,   244,    -1,   246,    -1,
      -1,   249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
      -1,   299,   300,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,    -1,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,    -1,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,   365,   366,    -1,
      -1,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,    -1,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
      -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,   149,
      -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,   169,
     170,    -1,   172,   173,   174,   175,   176,   177,    -1,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,    -1,   189,
      -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,    -1,    -1,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,    -1,   229,
     230,   231,   232,    -1,   234,   235,    -1,   237,    -1,   239,
     240,   241,   242,   243,   244,    -1,   246,    -1,    -1,   249,
     250,   251,    -1,    -1,   254,    -1,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,    -1,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,    -1,   299,
     300,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,    -1,
     320,   321,   322,   323,    -1,   325,   326,   327,    -1,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,    -1,   344,   345,   346,   347,   348,   349,
      -1,   351,   352,    -1,    -1,   355,   356,   357,   358,    -1,
     360,   361,   362,   363,   364,   365,   366,    -1,    -1,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,    -1,   386,   387,   388,    -1,
      -1,   391,    -1,    -1,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,    -1,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,
      -1,   153,   154,   155,    -1,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
      -1,    -1,   194,    -1,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,    -1,    -1,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,    -1,   229,   230,   231,
     232,    -1,   234,   235,    -1,   237,    -1,   239,   240,   241,
     242,   243,   244,    -1,   246,    -1,    -1,   249,   250,   251,
      -1,    -1,   254,    -1,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,    -1,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,    -1,   299,   300,    -1,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,    -1,   320,   321,
     322,   323,    -1,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,    -1,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,   365,   366,    -1,    -1,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,
     154,   155,    -1,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,   177,    -1,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,
     194,    -1,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,    -1,    -1,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,    -1,   229,   230,   231,   232,    -1,
     234,   235,    -1,   237,    -1,   239,   240,   241,   242,   243,
     244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,    -1,
     254,    -1,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
      -1,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,    -1,   299,   300,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
      -1,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,    -1,    -1,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    39,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      -1,    -1,    68,    -1,    70,    71,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    85,
      86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,    -1,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,   150,    -1,   152,   153,   154,   155,
      -1,   157,    -1,    -1,   160,    -1,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,    -1,   179,   180,   181,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,    -1,
     246,    -1,    -1,   249,   250,   251,    -1,    -1,   254,   255,
     256,   257,    -1,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,    -1,   269,    -1,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,    -1,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,    -1,   355,
      -1,   357,    -1,    -1,   360,   361,   362,   363,   364,   365,
     366,    -1,    -1,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,    -1,   382,   383,   384,   385,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   408,   409,   410,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    -1,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    -1,
      -1,    70,    71,    72,    73,    -1,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,    -1,    -1,    -1,   153,   154,   155,    -1,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,    -1,    -1,   194,    -1,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,    -1,
      -1,   210,   211,   212,    -1,    -1,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,    -1,
     229,   230,   231,   232,    -1,   234,   235,    -1,   237,    -1,
     239,   240,   241,   242,   243,   244,    -1,   246,    -1,    -1,
     249,   250,   251,    -1,    -1,   254,    -1,    -1,    -1,   258,
     259,   260,   261,   262,   263,   264,   265,    -1,   267,   268,
     269,   270,   271,   272,   273,    -1,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,    -1,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,    -1,
     299,   300,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,    -1,   325,   326,   327,    -1,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,    -1,   344,   345,   346,   347,   348,
     349,    -1,   351,   352,    -1,    -1,   355,   356,   357,   358,
      -1,   360,   361,   362,   363,   364,   365,   366,    -1,    -1,
     369,   370,   371,   372,   373,    -1,    -1,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,    -1,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    -1,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,    70,
      71,    72,    73,    -1,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,    -1,
      -1,    -1,   153,   154,   155,    -1,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,    -1,    -1,   194,    -1,   196,   197,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,    -1,    -1,   210,
     211,   212,    -1,    -1,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,    -1,   229,   230,
     231,   232,    -1,   234,   235,    -1,   237,    -1,   239,   240,
     241,   242,   243,   244,    -1,   246,    -1,    -1,   249,   250,
     251,    -1,    -1,   254,    -1,    -1,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,    -1,   267,   268,   269,   270,
     271,   272,   273,    -1,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,    -1,   299,   300,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,    -1,   325,   326,   327,    -1,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,    -1,
     341,   342,    -1,   344,   345,   346,   347,   348,   349,    -1,
     351,   352,    -1,    -1,   355,   356,   357,   358,    -1,   360,
     361,   362,   363,   364,   365,   366,    -1,    -1,   369,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,    -1,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    -1,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    -1,    -1,    70,    71,    72,
      73,    -1,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,    -1,   141,    -1,
     143,   144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,
     153,   154,   155,    -1,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,   169,   170,    -1,   172,
     173,   174,   175,   176,   177,    -1,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,    -1,   189,    -1,   191,    -1,
      -1,   194,    -1,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,    -1,    -1,   210,   211,   212,
      -1,    -1,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,    -1,   229,   230,   231,   232,
      -1,   234,   235,    -1,   237,    -1,   239,   240,   241,   242,
     243,   244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,
      -1,   254,    -1,    -1,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,    -1,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    -1,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,    -1,   299,   300,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      -1,   314,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,    -1,   325,   326,   327,    -1,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
      -1,   344,   345,   346,   347,   348,   349,    -1,   351,   352,
      -1,    -1,   355,   356,   357,   358,    -1,   360,   361,   362,
     363,   364,   365,   366,    -1,    -1,   369,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,
      -1,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    39,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    -1,    -1,    68,    -1,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,    -1,   141,    -1,   143,   144,
     145,    -1,   147,    -1,   149,   150,    -1,   152,   153,   154,
     155,    -1,   157,    -1,    -1,   160,    -1,   162,   163,   164,
     165,   166,   167,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
     185,   186,   187,    -1,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
      -1,   206,   207,   208,    -1,   210,   211,   212,    -1,    -1,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,   238,    -1,   240,   241,   242,   243,   244,
      -1,   246,    -1,    -1,   249,   250,   251,    -1,    -1,    -1,
     255,   256,   257,    -1,   259,   260,   261,   262,   263,   264,
     265,    -1,   267,    -1,   269,    -1,   271,   272,   273,    -1,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,    -1,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,    -1,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
     325,   326,   327,    -1,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,    -1,   351,   352,    -1,    -1,
     355,    -1,   357,    -1,    -1,   360,   361,   362,   363,   364,
     365,   366,    -1,    -1,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,    -1,   382,    -1,   384,
     385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   408,   409,   410,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    39,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    -1,    -1,
      68,    -1,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,    -1,   136,   137,
     138,    -1,    -1,   141,    -1,   143,   144,   145,    -1,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,    -1,   157,
      -1,    -1,   160,    -1,   162,   163,   164,   165,   166,   167,
     168,   169,   170,    -1,   172,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,   185,   186,   187,
      -1,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,    -1,   206,   207,
     208,    -1,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,    -1,   234,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,    -1,   246,    -1,
      -1,   249,   250,   251,    -1,    -1,    -1,   255,   256,   257,
      -1,   259,   260,   261,   262,   263,   264,   265,    -1,   267,
      -1,   269,    -1,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,    -1,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
      -1,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,   309,   310,   311,   312,    -1,   314,   315,   316,   317,
     318,    -1,   320,   321,   322,   323,   324,   325,   326,   327,
      -1,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,    -1,   341,   342,    -1,   344,   345,   346,   347,
     348,   349,    -1,   351,   352,    -1,    -1,   355,    -1,   357,
      -1,    -1,   360,   361,   362,   363,   364,   365,   366,    -1,
      -1,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,    -1,   382,    -1,   384,   385,   386,   387,
     388,    -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,
     398,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     408,   409,   410,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    34,    35,    -1,    37,    38,    39,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    -1,    -1,    68,    -1,    70,
      71,    72,    73,    74,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,
      91,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,    -1,   136,   137,   138,    -1,    -1,
     141,    -1,   143,   144,   145,    -1,   147,    -1,   149,   150,
      -1,   152,   153,   154,   155,    -1,   157,    -1,    -1,   160,
      -1,   162,   163,   164,   165,   166,   167,   168,   169,   170,
      -1,   172,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,   185,   186,   187,    -1,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,    -1,   204,    -1,   206,   207,   208,    -1,   210,
     211,   212,    -1,    -1,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,    -1,   234,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,    -1,   246,    -1,    -1,   249,   250,
     251,    -1,    -1,    -1,   255,   256,   257,    -1,   259,   260,
     261,   262,   263,   264,   265,    -1,   267,    -1,   269,    -1,
     271,   272,   273,    -1,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,    -1,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,    -1,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,   314,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,   324,   325,   326,   327,    -1,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,    -1,
     341,   342,    -1,   344,   345,   346,   347,   348,   349,    -1,
     351,   352,    -1,    -1,   355,    -1,   357,    -1,    -1,   360,
     361,   362,   363,   364,   365,   366,    -1,    -1,   369,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
      -1,   382,    -1,   384,   385,   386,   387,   388,    -1,    -1,
     391,    -1,    -1,   394,   395,   396,   397,   398,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   408,   409,   410,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    -1,   141,    -1,   143,
     144,   145,    -1,   147,    -1,   149,    -1,    -1,    -1,   153,
     154,   155,    -1,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,   169,   170,    -1,   172,   173,
     174,   175,   176,   177,    -1,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,    -1,   189,    -1,   191,    -1,    -1,
     194,    -1,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,    -1,    -1,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,    -1,   229,   230,   231,   232,    -1,
     234,   235,    -1,   237,    -1,   239,   240,   241,   242,   243,
     244,    -1,   246,    -1,    -1,   249,   250,   251,    -1,    -1,
     254,    -1,    -1,    -1,   258,   259,   260,   261,   262,    -1,
     264,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
      -1,   275,   276,   277,   278,   279,    -1,   281,   282,   283,
     284,   285,   286,    -1,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,    -1,   299,   300,    -1,   302,   303,
     304,    -1,   306,   307,   308,   309,   310,   311,   312,    -1,
     314,   315,   316,   317,   318,    -1,   320,   321,   322,   323,
      -1,   325,   326,   327,    -1,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,    -1,
     344,   345,   346,   347,   348,   349,    -1,   351,   352,    -1,
      -1,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,   365,   366,    -1,    -1,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,    -1,   386,   387,   388,    -1,    -1,   391,    -1,    -1,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    39,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      -1,    -1,    68,    -1,    70,    71,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    85,
      86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,    -1,
     136,   137,   138,    -1,    -1,   141,    -1,   143,   144,   145,
      -1,   147,    -1,   149,   150,    -1,   152,   153,   154,   155,
      -1,   157,    -1,    -1,   160,    -1,   162,   163,   164,   165,
     166,   167,   168,   169,   170,    -1,   172,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,   185,
     186,   187,    -1,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,    -1,
     206,   207,   208,    -1,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,    -1,   234,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,    -1,
     246,    -1,    -1,   249,   250,   251,    -1,    -1,    -1,   255,
     256,   257,    -1,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,    -1,   269,    -1,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,    -1,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,    -1,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,   309,   310,   311,   312,    -1,   314,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,    -1,   341,   342,    -1,   344,   345,
     346,   347,   348,   349,    -1,   351,   352,    -1,    -1,   355,
      -1,   357,    -1,    -1,   360,   361,   362,   363,   364,   365,
     366,    -1,    -1,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,    -1,   382,    -1,   384,   385,
     386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,   395,
     396,   397,   398,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   408,   409,   410,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,
      39,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    -1,    -1,    68,
      -1,    70,    71,    72,    73,    74,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    85,    86,    87,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,    -1,   136,   137,   138,
      -1,    -1,   141,    -1,   143,   144,   145,    -1,   147,    -1,
     149,   150,    -1,   152,   153,   154,   155,    -1,   157,    -1,
      -1,   160,    -1,   162,   163,   164,   165,   166,   167,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,    -1,   182,   183,   184,   185,   186,   187,    -1,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,    -1,   206,   207,   208,
      -1,   210,   211,   212,    -1,    -1,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,    -1,
      -1,   240,   241,   242,   243,   244,    -1,   246,    -1,    -1,
     249,   250,   251,    -1,    -1,    -1,   255,   256,   257,    -1,
     259,   260,   261,   262,   263,   264,   265,    -1,   267,    -1,
     269,    -1,   271,   272,   273,    -1,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,    -1,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,    -1,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,   308,
     309,   310,   311,   312,    -1,   314,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,   325,   326,   327,    -1,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,    -1,   341,   342,    -1,   344,   345,   346,   347,   348,
     349,    -1,   351,   352,    -1,    -1,   355,    -1,   357,    -1,
      -1,   360,   361,   362,   363,   364,   365,   366,    -1,    -1,
     369,   370,   371,   372,   373,    -1,    -1,   376,   377,   378,
     379,   380,    -1,   382,    -1,   384,   385,   386,   387,   388,
      -1,    -1,   391,    -1,    -1,   394,   395,   396,   397,   398,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   408,
     409,   410,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    39,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    -1,    -1,    68,    -1,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,    91,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,    -1,   136,   137,   138,    -1,    -1,   141,
      -1,   143,   144,   145,    -1,   147,    -1,   149,   150,    -1,
     152,   153,   154,   155,    -1,   157,    -1,    -1,   160,    -1,
     162,   163,   164,   165,   166,   167,   168,   169,   170,    -1,
     172,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,   185,   186,   187,    -1,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,    -1,   206,   207,   208,    -1,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,    -1,   246,    -1,    -1,   249,   250,   251,
      -1,    -1,    -1,   255,   256,   257,    -1,   259,   260,   261,
     262,   263,   264,   265,    -1,   267,    -1,   269,    -1,   271,
     272,   273,    -1,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,    -1,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,    -1,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,   308,   309,   310,   311,
     312,    -1,   314,   315,   316,   317,   318,    -1,   320,    -1,
     322,   323,   324,   325,   326,   327,    -1,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,    -1,   341,
     342,    -1,   344,   345,   346,   347,   348,   349,    -1,   351,
     352,    -1,    -1,   355,    -1,   357,    -1,    -1,   360,   361,
     362,   363,   364,   365,   366,    -1,    -1,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,    -1,
     382,    -1,   384,   385,   386,   387,   388,    -1,    -1,   391,
      -1,    -1,   394,   395,   396,   397,   398,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   408,   409,   410,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    39,    40,    41,    42,    -1,    -1,
      45,    -1,    -1,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    -1,    -1,    60,    -1,    62,    63,    64,
      65,    -1,    -1,    68,    -1,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,    -1,    -1,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
      -1,   136,   137,   138,    -1,    -1,   141,    -1,   143,    -1,
     145,    -1,   147,    -1,   149,   150,    -1,   152,   153,   154,
     155,    -1,   157,    -1,    -1,   160,    -1,   162,   163,   164,
     165,   166,   167,   168,   169,   170,    -1,   172,   173,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
     185,    -1,    -1,    -1,    -1,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
      -1,   206,   207,   208,    -1,   210,   211,   212,    -1,    -1,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,   228,    -1,   230,   231,    -1,    -1,   234,
     235,   236,   237,    -1,    -1,   240,    -1,   242,   243,   244,
      -1,   246,    -1,    -1,   249,   250,   251,    -1,    -1,    -1,
     255,   256,   257,    -1,   259,   260,   261,   262,   263,   264,
     265,    -1,   267,    -1,   269,    -1,   271,   272,   273,    -1,
     275,   276,   277,   278,   279,   280,   281,    -1,   283,   284,
     285,   286,    -1,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,    -1,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,   309,   310,   311,   312,    -1,   314,
     315,   316,   317,   318,    -1,   320,    -1,   322,   323,   324,
     325,    -1,   327,    -1,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,    -1,   341,   342,    -1,   344,
     345,   346,   347,   348,   349,    -1,    -1,    -1,    -1,    -1,
     355,    -1,   357,    -1,    -1,   360,   361,   362,   363,   364,
     365,   366,    -1,    -1,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,    -1,    -1,    -1,   384,
     385,   386,   387,   388,    -1,    -1,   391,    -1,    -1,   394,
     395,   396,   397,   398,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   408,   409,   410
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    14,    24,    26,    27,    42,    62,    64,    65,    70,
      72,    82,    84,   100,   103,   115,   117,   121,   127,   134,
     136,   142,   156,   210,   211,   216,   224,   235,   272,   283,
     288,   290,   295,   300,   303,   307,   312,   313,   320,   323,
     331,   343,   360,   370,   376,   381,   393,   427,   434,   435,
     436,   437,   443,   444,   446,   447,   448,   449,   450,   451,
     452,   454,   455,   459,   470,   473,   474,   477,   478,   479,
     490,   493,   494,   509,   546,   549,   550,   557,   563,   565,
     567,   568,   571,   574,   575,   579,   580,   589,   593,   594,
     595,   599,   600,   602,   603,   604,   617,   618,   619,   620,
     631,   632,   639,   640,   643,   644,   645,   646,   647,   652,
     654,   657,   661,   665,   666,   676,   677,   680,   685,   696,
     715,   718,   719,   720,   723,   726,   728,   730,   733,   736,
     737,   738,   745,   746,   748,   749,   750,   755,   757,   758,
     762,   763,   766,   767,   768,   770,   771,   772,   773,   775,
     778,   779,   784,   790,   793,   795,   796,   801,   803,   807,
     814,   818,   819,   820,   821,   822,   823,   826,   853,   355,
     395,   751,    21,    68,    81,    98,   104,   119,   137,   148,
     153,   159,   174,   199,   249,   277,   302,   308,   314,   317,
     343,   345,   349,   357,   362,   374,   387,   564,   751,     3,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    30,    34,    35,    37,    38,    40,    41,    42,
      43,    44,    46,    47,    49,    50,    51,    52,    53,    56,
      57,    58,    59,    60,    62,    63,    64,    65,    66,    70,
      71,    72,    73,    75,    76,    78,    79,    80,    81,    82,
      83,    86,    87,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   105,   107,   108,   109,   110,   111,   113,   114,
     115,   118,   119,   120,   121,   122,   124,   125,   126,   128,
     129,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     141,   143,   144,   145,   147,   149,   153,   154,   155,   157,
     158,   160,   162,   163,   164,   165,   166,   168,   169,   170,
     172,   173,   174,   175,   176,   177,   179,   181,   182,   183,
     184,   185,   186,   187,   189,   191,   194,   196,   197,   198,
     199,   200,   201,   202,   204,   205,   207,   210,   211,   212,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   229,   230,   231,   232,   234,   235,   237,
     239,   240,   241,   242,   243,   244,   246,   249,   250,   251,
     254,   258,   259,   260,   261,   262,   263,   264,   265,   267,
     268,   269,   270,   271,   272,   273,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   299,   300,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   314,   315,   316,   317,   318,   320,   321,   322,   323,
     325,   326,   327,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   341,   342,   344,   345,   346,   347,
     348,   349,   351,   352,   355,   356,   357,   358,   360,   361,
     362,   363,   364,   365,   366,   369,   370,   371,   372,   373,
     376,   377,   378,   379,   380,   381,   382,   384,   386,   387,
     388,   391,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   815,
     958,   971,   975,   976,   385,   780,   247,   273,   751,    45,
     500,   819,    21,    34,    55,    68,    77,    98,   104,   119,
     137,   148,   155,   159,   212,   249,   252,   302,   308,   317,
     345,   346,   348,   349,   357,   362,   368,   371,   374,   510,
     635,   686,   697,    22,   272,   958,   815,    22,   267,   346,
     348,     5,   198,   724,   725,   967,    21,    34,    55,    68,
      81,    98,   119,   137,   148,   153,   159,   174,   249,   259,
     302,   306,   308,   314,   317,   343,   345,   349,   357,   362,
     374,   387,   564,   648,   751,   958,    84,   385,   427,   546,
     779,   785,   793,   796,   801,   807,   814,   818,     9,    15,
      22,    40,   143,   149,   151,   171,   200,   230,   275,   289,
     418,   419,   662,   663,   815,   966,   970,    22,    84,   287,
     313,   667,   668,   669,   971,   971,   963,   967,   343,   829,
     662,   971,   355,   958,   259,    98,   174,   342,   343,   731,
     307,   971,    22,   318,   351,   355,   462,   971,    19,   156,
     667,   668,   273,   751,   971,   197,    22,   116,   831,    56,
      78,   212,   226,   302,   308,   318,   351,   355,   398,   460,
     461,   462,    22,   318,   351,   355,   462,   355,   248,   862,
     956,   971,   829,   420,   971,   152,   427,   781,   427,   952,
     285,   824,   825,   958,   819,   820,   823,     0,   430,   780,
     130,   188,   253,   367,   832,   833,   819,   821,   822,   109,
     184,   373,   431,     3,    39,    45,    68,    74,    85,    91,
     150,   152,   167,   180,   192,   193,   195,   206,   208,   228,
     236,   255,   256,   257,   301,   324,   385,   964,   971,   972,
     975,   977,   650,   971,   650,   959,   971,   276,   650,   650,
     958,   971,    97,   343,   675,   964,     3,   968,   973,   975,
     976,   977,   166,   956,   242,     8,    63,   141,   414,   415,
     416,   418,   419,   420,   421,   422,   423,   722,   919,   920,
     971,   968,   958,   166,   956,   958,   166,   862,   958,   310,
     958,   650,   217,   968,   166,   956,   198,   106,   194,   233,
     281,   752,   753,   754,   956,   962,   971,    21,    55,    68,
      69,    77,    81,    98,   119,   137,   148,   153,   174,   199,
     249,   302,   306,   308,   314,   317,   343,   345,   349,   357,
     362,   387,   564,   655,   967,   956,   353,   964,   958,   427,
     650,   357,   959,   650,   166,   958,    97,   343,   346,   348,
     968,   346,   348,    63,   141,   722,   293,   968,   456,   971,
     958,   958,   310,   958,   650,   217,   968,   314,   343,   387,
      81,   174,   153,   306,   361,   558,    22,   958,   816,   469,
     967,   973,   725,   166,   964,   958,   166,   729,   166,   959,
      97,   343,   166,   964,   166,   968,   969,    74,    63,   141,
     166,   722,    49,   166,   969,   166,   958,   166,   958,   166,
     958,   310,   166,   958,   166,   217,   969,   198,   166,   649,
     650,   427,   794,   510,   785,   381,   779,   786,   787,   788,
     973,   780,   970,   663,   664,    22,   664,   970,   664,    22,
     664,   970,   664,   664,   664,   970,   966,   966,   815,   664,
     276,   427,   427,   529,   529,   529,   247,   353,   431,   529,
     862,   863,   431,   747,   967,   427,   791,    49,   958,   958,
     956,   971,    39,   410,   194,   429,   250,   250,   247,   151,
     967,   353,   146,   658,   247,     4,     6,     7,     8,    10,
      31,    44,    46,    47,    54,    55,    58,    59,    66,    68,
      88,    89,    90,    91,    92,    93,    94,   101,   102,   120,
     135,   139,   140,   144,   158,   186,   187,   189,   205,   213,
     214,   227,   229,   233,   238,   239,   241,   249,   258,   268,
     282,   304,   319,   326,   339,   351,   352,   356,   358,   359,
     368,   374,   382,   400,   401,   402,   403,   404,   405,   406,
     407,   418,   419,   420,   427,   819,   874,   877,   880,   881,
     882,   884,   885,   886,   887,   890,   891,   895,   897,   898,
     917,   921,   940,   945,   953,   954,   964,   965,   966,   967,
     971,   967,    22,   475,   955,   956,   318,   460,   104,   468,
     967,   469,   967,    39,    60,   460,   410,   327,   753,   250,
     151,   353,   414,    39,   410,   194,   754,   427,   956,   420,
     425,   429,   946,   947,   863,   150,   152,   385,   776,   777,
     779,   150,   782,   104,   895,   950,   951,   824,   431,   427,
     783,   428,   428,   436,   956,    22,   116,   830,   830,    49,
     830,   142,   146,   209,   245,   836,   838,   839,   848,   850,
     851,   832,   833,   151,   190,   862,   864,   952,   427,   625,
     947,   260,   291,   320,   429,   651,   260,   291,   320,   260,
     291,   320,   393,   438,   470,   471,   681,    18,   121,   260,
     291,   320,   378,   482,   320,    18,   121,   373,   453,   396,
     166,   862,    51,    83,   138,   169,   204,   233,   260,   291,
     299,   305,   312,   320,   329,   337,   388,   470,   472,   709,
     716,   427,   698,   291,   453,   135,    18,    24,    65,   114,
     121,   124,   176,   231,   233,   243,   251,   260,   291,   295,
     320,   378,   480,   481,   583,     4,   419,   555,   970,   650,
     650,   427,   721,   429,   171,   291,   438,   445,   260,   291,
     135,    50,    96,   173,   219,   221,   231,   259,   291,   296,
     320,   331,   480,   552,   553,   260,   291,   386,   583,   591,
     135,   291,   320,   480,   260,   291,   295,   320,    75,   113,
     261,   347,   247,    18,    24,   121,   260,   291,   320,   491,
     492,   146,   291,   320,   438,   471,   135,   291,   320,   480,
     958,   207,   106,   248,   397,   431,   752,   375,   774,   247,
     964,   427,   958,    97,   343,   964,   242,    63,   141,   722,
     958,   310,   958,   198,   650,   529,   334,   335,   496,   967,
     427,   625,   626,    61,     3,    44,    46,    47,    58,    59,
     101,   102,   144,   186,   187,   189,   227,   229,   241,   282,
     321,   326,   351,   352,   382,   871,   873,   875,   877,   879,
     881,   882,   883,   885,   886,   890,   891,   972,   975,   151,
     427,   621,   958,   438,    32,   769,   233,   438,   396,   166,
     956,   438,   650,   650,   621,   510,   438,    39,   457,   362,
     590,   260,   566,    75,   113,   261,   347,    20,    41,   185,
     605,    32,   621,   146,   438,   956,   166,   547,   956,   956,
     650,    74,   687,   964,   958,   564,    45,    95,   183,   231,
     309,   135,   625,    52,   297,   483,   135,   427,   135,   396,
     135,   698,   135,   431,   166,   649,   166,   650,   166,   650,
     135,   721,   969,   135,   135,   247,   135,   483,   135,    75,
     113,   261,   347,   135,   247,   135,   146,   166,   166,   469,
     135,   431,   483,   895,   924,   343,   428,   431,   140,   247,
     359,   466,   469,   555,   789,   785,   664,   815,   664,   815,
     664,   815,   664,   815,   664,   815,   815,   815,   664,   815,
     427,   530,   531,   971,   530,    22,    98,   119,   148,   153,
     198,   199,   308,   314,   343,   345,   362,   670,   955,   969,
     669,   171,   431,   804,   967,   871,   927,    32,   969,   147,
     732,   732,   732,   207,   971,   146,   146,   670,   969,   307,
     971,   469,   247,   427,   948,   425,   819,   928,   384,   888,
     895,   944,   427,   888,   888,   427,   146,   427,   427,   427,
     876,   876,   270,   819,   427,   427,   878,   427,   427,   427,
     427,    58,    59,   888,   895,   427,   876,   427,   427,   427,
     427,   427,   394,   413,   427,   892,   427,   892,   427,   427,
     819,   427,   427,   427,   427,   427,   427,   427,   427,   895,
     895,   819,   895,   924,   947,   967,    59,   427,   889,   427,
     967,     3,     8,    11,    28,    32,    37,    43,    67,   167,
     171,   192,   193,   208,   233,   236,   249,   252,   324,   414,
     415,   416,   418,   419,   420,   421,   422,   423,   919,   921,
     923,   257,   895,   190,   431,   827,   427,   967,   947,   107,
     168,   476,   431,    60,   104,   469,    32,     3,   104,   212,
     467,   555,   891,   967,   967,    79,   118,   904,    87,   104,
     463,   464,   466,   555,   104,   463,   207,   956,   895,     3,
      22,    26,    27,    28,    29,    31,    32,    33,    36,    48,
      54,    55,    61,    67,    69,    77,    84,    88,    89,    90,
      92,    93,    94,   104,   106,   112,   116,   117,   123,   127,
     130,   140,   142,   146,   148,   151,   156,   159,   161,   171,
     178,   188,   190,   203,   209,   213,   214,   233,   238,   245,
     247,   248,   252,   253,   266,   274,   287,   298,   313,   319,
     328,   340,   343,   350,   353,   354,   359,   367,   368,   374,
     375,   383,   389,   390,   392,   393,   420,   961,   974,   975,
     976,   977,   978,   946,    80,   296,   653,   428,   431,   780,
     428,   431,   825,   957,   958,    32,   783,   821,   821,   834,
     835,   895,   821,   143,   230,   845,   281,   322,   373,    22,
     840,   895,   841,   843,   895,   897,   848,   849,   839,   838,
     836,   837,   146,   851,   836,   848,   864,   956,    32,   971,
     320,   420,   927,   260,   291,   320,   353,   353,   308,   961,
     429,   353,   353,   308,   353,   353,   345,   460,   764,   146,
     156,   171,   300,   682,   683,    61,    77,   131,   148,   274,
     368,   526,   527,    77,   104,   233,   353,    77,   353,   104,
     233,   308,    77,   308,   572,    21,    55,    68,    81,   119,
     148,   153,   249,   308,   314,   317,   343,   349,   362,   387,
     564,   958,   135,   291,   320,   480,   247,   555,   312,   204,
     353,   353,   238,   555,   108,   191,   308,   318,   355,   461,
     297,   320,   709,   717,   171,   181,   254,   321,   383,   428,
     699,   702,   703,   704,   706,   871,   972,   353,   374,   956,
      69,   131,   517,   526,   971,    69,   734,   247,   306,   357,
      77,   734,    25,   294,   306,   357,   956,   176,   243,   650,
     427,   353,   353,   427,   486,   345,   393,   394,   486,    77,
     431,     4,   260,   375,   375,   232,   871,   260,   320,   722,
      98,   353,   440,   471,   353,   353,   956,   555,    49,   554,
     555,   555,    96,   219,   221,    49,   353,   438,   308,   438,
     231,   553,   353,   353,   238,   967,   583,   862,    77,   353,
     734,   308,   353,   353,   486,   486,   650,   650,   650,   650,
     956,    38,   380,    38,    38,   353,    38,   353,   308,   431,
      94,   374,   601,   968,   353,   440,   956,   353,   308,   260,
     291,   281,   292,   316,   465,   752,   962,   971,   956,   625,
     871,   247,   396,   698,   555,   650,   650,   721,   192,   247,
      75,   113,   261,   347,   247,   650,   192,   393,   501,   438,
       3,   627,   628,   621,   427,   873,    32,    31,   872,    99,
     164,   220,   223,   311,   408,   427,   893,   894,   651,   876,
     650,   622,   623,   974,    20,   759,   871,   135,   569,   958,
     233,   427,   596,   439,   635,   375,   387,   439,   968,    84,
     156,   458,   509,   549,   604,   665,   685,   755,   967,   591,
     592,   958,   215,   650,   650,   650,   650,   243,   109,   184,
     360,   373,   606,   607,   128,   280,   427,   601,   439,   551,
     552,   233,    32,   243,   427,   529,   529,   146,   688,   962,
     427,   700,    32,   198,   393,   394,   817,   309,   964,   483,
     871,   959,   166,   958,   964,   483,   969,   968,   135,   483,
     135,   375,   135,   375,   722,   483,   483,   969,   958,   650,
     958,   958,   958,   650,   969,   601,   135,   135,   483,   649,
     650,   428,   431,   956,   785,   787,   815,   815,   815,   815,
     815,   815,   530,   428,   431,   428,   154,   315,   344,   957,
     649,    97,   317,   674,   675,   957,   242,   957,   955,   955,
     957,   649,   353,   393,   678,    16,    30,   133,   304,   322,
     805,   862,   237,   806,   428,   431,   792,   796,   801,   807,
     818,   353,   668,   667,   668,   151,   157,   679,   971,    21,
      69,    98,   119,   148,   153,   199,   302,   308,   314,   343,
     345,   362,   387,   564,   659,   924,   946,   426,   924,   928,
     929,   427,   389,   941,   942,   895,   924,   427,   966,   966,
     924,     3,    99,   164,   220,   223,   311,   408,   930,   931,
     967,   966,   924,   924,   966,   966,   888,   888,   895,   722,
     895,   932,   418,   419,   896,   897,   917,   921,   934,   428,
     924,   895,   924,   935,   351,   410,   966,   966,   895,    48,
     151,   203,   354,   895,   924,   938,   924,   225,   897,   895,
     902,   903,   904,   225,   895,   904,   428,   431,   320,   966,
     966,   893,   871,   895,   974,   351,    36,   340,   949,   650,
     895,   427,   819,   939,   116,   118,   140,   233,   238,   243,
     359,   369,   895,    43,   167,   171,   208,   324,   427,   895,
     353,   895,   895,   895,   895,   895,   895,   895,   895,   895,
     895,    22,    29,   328,   918,   304,   427,   917,   155,   212,
     343,   346,   348,   371,   828,   956,   954,   151,   854,    22,
     116,   383,   420,   428,   704,   895,   925,   926,   972,   956,
     355,   427,   967,   431,   428,   426,   432,   165,   165,   483,
     956,   777,   778,   956,   950,   428,   431,   427,   431,    33,
     112,   375,   694,   427,   842,   970,   248,   243,   852,   852,
     431,   304,   305,   844,   849,   837,   375,   802,   104,   427,
     797,   818,   971,   427,   808,   809,   810,   811,   812,   971,
     428,   428,   353,   353,   308,   968,   958,   958,   961,   968,
     958,   958,   968,   959,   958,    76,   765,   302,   374,   667,
     308,   156,   667,   427,   958,   375,   689,   196,   196,   375,
     427,   545,   166,   958,   238,   968,   958,   958,   895,   238,
     958,   958,   958,   353,   573,   964,   427,   650,   650,   650,
      97,   343,   675,    63,   141,   722,   958,   650,   958,   650,
     310,   650,   650,   198,   160,   231,   260,   291,   379,   576,
     577,   578,   862,   353,   734,   308,   238,   108,   191,   968,
     958,   247,   958,   254,   972,   428,   431,   704,   706,   703,
     706,   972,   651,   968,   969,   291,   480,   517,   871,   971,
     958,   958,    22,   374,   958,   166,   958,   166,   971,   306,
     357,   306,   357,   958,    22,   374,   958,   956,    18,   121,
     320,   584,   585,   586,   587,   974,   968,   958,   488,   489,
     974,   958,   246,    65,   246,   958,   481,   353,   960,   971,
     960,   431,   428,   431,   353,   308,   959,   968,     3,    76,
     126,   176,   265,   366,   374,   377,   441,   968,   958,   291,
     320,   480,   552,   555,   650,   958,   555,   958,   555,   968,
     958,   291,   320,   480,   958,   958,   958,   958,   968,   958,
      18,    24,   121,   260,   291,   320,   260,   291,   320,   621,
     291,   320,   291,   320,   291,   870,   971,   967,   971,   166,
     971,   968,   958,   958,   958,    18,   492,   317,   968,   291,
     320,   480,   958,   958,   353,   353,    73,   365,   281,   192,
      32,   650,   192,   192,   375,   375,   192,   238,   656,   967,
     650,   650,   650,   650,   650,   650,   192,   656,   246,   151,
     353,   495,   427,   497,   498,   414,   428,   431,   895,    31,
     872,   871,   425,   425,   353,   353,   353,   427,   353,   966,
     876,   428,   431,   414,   606,    76,   125,   201,   202,   215,
     260,   345,   347,   760,   519,   958,   151,   308,   386,   570,
     577,   578,   135,   428,   517,   597,   598,   317,    19,   171,
     302,   341,   441,   442,   146,   960,   956,   457,   252,   510,
     148,   967,   621,   621,   621,   621,   243,   247,   252,   427,
     621,   868,   869,   870,   317,   135,   134,   818,   650,   208,
     511,   513,   515,   517,   523,   526,   971,   393,   394,   541,
     393,   487,   967,   247,   428,   701,   702,   707,    32,   198,
     299,   392,   708,   709,   710,   247,   469,   163,   163,   146,
     625,    32,   135,   483,   698,   649,   650,   960,   650,   960,
     721,   247,   483,   483,   247,   483,   317,   146,   469,   483,
     895,   428,   531,   171,   171,   171,   396,   957,   431,   555,
     556,   159,   671,   672,   968,    19,   679,   133,   322,   133,
     322,   133,   322,   304,   373,   222,   871,   958,   151,   247,
     671,    49,   483,   964,   343,   964,   242,   198,   650,   428,
     426,   426,   431,   924,   895,   123,   942,   943,    32,   428,
     895,   428,   428,   428,   428,   151,   428,   428,   428,   428,
     428,   431,   428,   266,   933,   428,   896,   896,    11,   171,
     192,   249,   414,   415,   416,   418,   419,   420,   421,   422,
     423,   921,   896,   428,   428,   146,   151,   936,   937,   428,
     410,   428,   428,    32,   938,   924,   938,   938,   151,   428,
     428,   974,   264,   906,    32,   428,   431,   895,   974,   431,
     895,   948,   895,   971,   428,   428,   410,   896,   896,   129,
     924,   151,   116,   118,   140,   238,   243,   359,   369,   427,
     129,   340,   949,   895,   939,   895,   353,   722,   895,   427,
     819,   346,   348,   346,   348,   956,   829,   829,   829,   427,
     819,   855,   856,   857,   862,   865,   898,   964,   971,   390,
     866,   925,   925,   926,   428,   256,   910,    13,   428,   431,
     833,   753,   966,   893,   464,   895,   783,   958,   792,   835,
     249,   919,   922,   411,   412,   695,   895,   844,   955,   806,
     806,   841,   855,   390,   867,   381,   798,   799,   971,   298,
     800,   812,   813,   431,   854,   414,   948,   968,   958,   958,
     209,   969,   969,   247,   957,   250,   247,   895,   527,   960,
     427,   427,   427,   545,   174,   530,   615,   135,   483,   353,
     469,   625,   871,   396,   650,   650,   650,   721,    75,   113,
     261,   347,   958,   559,   958,   160,   379,   353,   353,   559,
     576,   583,   291,   320,   480,   958,   958,   958,   182,   238,
     651,   702,   706,   706,   422,   353,   251,   581,   121,   295,
     320,   482,   583,   735,   135,   483,   135,   483,   958,   958,
     958,   958,   586,   587,   586,   428,   431,   588,   967,   428,
     431,   414,   429,   968,   260,   291,   320,    18,   121,   260,
     291,   320,   871,   232,   871,   968,   958,   209,   265,   238,
     967,   265,   969,   372,   353,   308,   353,   734,   308,   353,
     353,   217,   217,   217,   353,   353,   308,   353,   353,   308,
     353,   308,   353,   308,   353,   483,   871,    20,    41,   320,
     735,   135,   483,   353,   958,   353,   308,   968,   958,   656,
     871,   192,   656,   656,   960,   960,   656,   192,   192,   192,
     192,   192,   192,   656,   496,   504,   505,   974,    45,    86,
     110,   125,   129,   147,   162,   238,   246,   279,   499,   249,
     418,   419,   555,   624,   706,   922,   967,   978,     3,   628,
     428,   425,   428,   966,   426,   966,   164,   220,   894,   220,
     894,   894,   966,   223,   428,   623,   624,   247,   209,   414,
     761,   761,   761,   761,   761,   761,   761,    61,    67,    77,
     104,   106,   178,   233,   238,   274,   287,   368,   520,   521,
     522,   438,   469,   958,   469,   581,   956,   428,   431,   958,
     969,   159,   302,   969,   966,   362,   529,   293,   343,    97,
     530,   956,   607,   629,   630,   967,   428,   431,   958,   956,
     958,   393,   548,   427,   512,   956,   428,   431,   246,   486,
     246,   247,   542,   486,    32,   353,   956,   428,   431,   104,
     414,   711,   967,   469,   343,   705,   706,   393,   710,   712,
     109,   184,   313,   373,   743,   160,   818,   483,   871,   958,
     483,   483,   375,   483,   375,   483,   483,   650,   650,   958,
     601,   483,   308,   308,   308,   957,   675,   431,   968,   393,
     431,   673,   250,   133,   133,   969,   670,   483,   968,   625,
     698,   555,   650,   192,   928,   428,   350,   895,   127,   871,
     428,   895,   895,   895,   936,   871,   896,   116,   118,   233,
     243,   896,   896,   896,   896,   896,   896,   896,   896,   896,
     896,   895,   895,   937,   936,   892,   892,   871,   428,   428,
     428,   924,   428,   431,    49,   897,   428,   974,   903,   271,
     338,   905,   428,   431,   386,   899,    32,   428,   889,   967,
     895,    28,    28,   895,   428,   895,   151,   427,   927,   895,
     896,   896,   129,   129,   895,   428,   129,   895,   829,   829,
     829,   829,   956,   956,   956,   819,   856,   857,    32,   858,
     971,   431,    85,   152,   180,   195,   206,   228,   301,   859,
     858,    32,   858,   971,   427,   947,   895,   159,   846,   431,
     832,   833,   832,   428,   910,   427,   911,   971,   895,   910,
     967,   383,   926,   428,   428,   426,   428,   427,   695,   428,
     248,    87,   895,   800,   428,   431,   948,   953,   428,   431,
     809,   867,   950,   761,   154,   315,   344,   363,   684,   146,
     684,   428,   427,   533,   534,   691,   898,   971,   530,   530,
     615,   962,   428,   106,   178,   231,   233,   616,   958,   958,
      32,   958,   375,   375,   650,   650,   650,   650,   651,   968,
     958,   353,   734,   308,   353,   182,   422,   362,   958,   427,
     519,   233,   486,    97,   233,   333,   336,   486,   362,   958,
     971,   585,   489,   624,   974,   353,   353,   308,   153,   249,
     336,   633,   634,   153,   249,   641,   642,   353,   353,   308,
     428,   428,   428,   970,   967,   967,   967,   958,   958,   958,
     958,   958,   958,   958,   146,   146,   293,   146,   166,   968,
     958,   958,   968,   958,   958,   958,   958,   958,   958,   958,
      67,   484,   967,   967,   362,   971,   958,   583,   958,   958,
     428,   656,   192,   192,   656,   656,   656,   656,   656,   656,
     375,   502,   503,   428,   431,   420,   427,   466,   506,   555,
     769,   967,   769,   233,   279,   769,   769,   615,   966,   393,
     394,   426,   426,   428,   893,   956,   761,   104,   966,   967,
     104,   967,   104,   967,   104,   967,   104,   958,   104,   958,
     104,   958,   427,   650,   958,   896,   107,   168,   106,   238,
     196,   956,   712,   569,   596,   598,   581,   969,   969,   871,
     487,   956,   396,   146,   608,   428,   431,   870,   581,   243,
     427,   794,    97,   231,   514,   516,   518,   526,   971,   541,
     524,   177,   540,   515,    72,   345,   543,   818,   967,   689,
     707,   895,   895,   431,   427,   708,   621,   353,   559,   428,
     483,   960,   960,   483,   483,   317,   957,   957,   957,   555,
     156,   672,   679,   151,   192,   192,   192,   192,   238,   660,
     967,   895,   428,   428,   937,   151,   116,   118,   243,   427,
     428,   399,   901,   924,   286,    49,   391,   391,   428,   895,
     231,   895,   431,   900,   873,   893,   896,   896,   895,   927,
     428,    28,    28,   895,   895,   129,   895,   428,   956,   956,
     956,   956,   428,   971,   427,   856,   195,   255,   860,   856,
     860,   195,   859,   860,   195,   427,   971,   427,   925,    49,
     161,   847,   428,   428,   910,   912,   971,   926,   910,   967,
     722,   243,   818,   799,   414,   812,   800,   970,   353,   667,
     151,   615,   895,   428,   431,   393,    67,   692,   692,   428,
     428,   712,   107,   168,   176,   106,   377,   483,   871,   960,
     960,   958,   958,   958,   958,   362,   582,   586,   238,   238,
     970,   971,   871,   483,   483,   414,   968,   958,   958,   966,
     966,   871,   431,   966,   966,   431,   968,   958,   958,   353,
     957,   957,   650,   957,   135,   650,   871,   483,   483,   192,
     656,   656,   438,   111,   505,   466,   507,   508,   967,   967,
     238,   420,   530,   967,   967,   426,   153,   181,   153,   151,
     614,   970,   895,   233,   521,   712,   529,   375,   544,   317,
     375,    32,   427,   958,   122,   609,   389,   611,   967,   650,
     511,   548,    97,   428,   431,   393,   542,   132,   172,   427,
     541,   109,   121,   271,   958,   393,   756,   151,   427,   967,
     704,   713,   714,   972,   712,   956,   179,   560,   483,   483,
     483,   958,   250,   483,   671,   660,   660,   660,   660,   896,
     151,   427,   927,   427,   428,   431,   428,   897,   286,   428,
     380,   330,   428,   428,   428,   896,   896,   895,   858,   427,
     957,   856,   247,   375,   861,   856,   195,   856,   869,   427,
     869,   971,   428,   924,   895,   392,   907,   910,   910,   263,
     913,   428,   893,   428,   815,   952,   671,   247,   671,   428,
     712,   534,   249,   722,   650,   375,   650,   693,   693,   287,
     712,   544,   428,   353,   428,   431,   484,   624,   427,   964,
     722,   634,   427,   427,   642,   958,   393,   293,   393,   393,
     146,   484,   656,   497,   967,   428,   431,   530,   675,    32,
     727,   727,   956,   615,   428,   544,   218,   532,   174,   958,
     960,   818,   581,   304,   332,   610,   427,   134,   512,   428,
     516,   251,   543,    22,    71,    78,   105,   175,   336,   525,
     525,   955,   542,   305,   305,    53,    61,   212,   650,   690,
     691,   706,   428,   431,   866,   559,   231,   379,   561,   562,
     483,   896,   927,   428,   902,   924,    49,   231,   409,   957,
     428,   895,   427,   856,   861,   428,   869,   428,   908,   909,
     971,    49,   832,   910,   673,   684,   483,   692,   544,   427,
     650,   694,   694,   956,   544,   615,   958,   586,   375,   485,
     927,   698,   146,   637,   721,   927,   927,   649,   650,   649,
     650,   957,   483,   508,   727,    35,   170,   146,   231,   528,
     152,   262,   325,   247,   536,   537,   538,   345,   581,   141,
     636,   756,   895,   278,   541,   540,   519,   428,   543,    61,
     250,    61,   428,   431,   708,   713,   117,   379,   559,   428,
     428,   428,   286,   380,   428,   957,   428,   431,    32,   924,
     280,   305,   914,   151,   693,   390,   535,   722,   695,   695,
     529,   615,   895,   428,   253,   310,   284,   638,   637,   428,
     428,   393,   122,   176,   109,   373,   247,   538,   247,   537,
     958,   650,    32,   428,   964,   542,   541,   250,   250,   487,
     691,   712,    23,   185,   744,   428,   909,   911,    43,    87,
     364,   895,   915,   916,   915,   428,   671,   694,   427,   615,
     428,   532,   964,    49,   638,   650,   304,    52,   231,   297,
     320,   539,   539,   633,   427,   543,   542,   543,   234,   427,
     739,   741,   746,   796,   801,   807,   818,   916,   304,   145,
     269,   145,   269,   483,   695,   895,   536,   698,   650,   611,
      17,   104,   238,     4,   612,   613,   966,   967,   974,   543,
     866,   740,   741,   742,   819,   820,    28,   428,   615,   134,
     428,   431,   428,   430,   916,   278,   613,   742,   964,   427,
     612,   428
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (YYID (N))                                                     \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (YYID (0))
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

__attribute__((__unused__))
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
#else
static unsigned
yy_location_print_ (yyo, yylocp)
    FILE *yyo;
    YYLTYPE const * const yylocp;
#endif
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += fprintf (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += fprintf (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += fprintf (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += fprintf (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += fprintf (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, &yylloc, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, &yylloc, yyscanner)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
  YYUSE (yyscanner);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule, yyscanner)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
    core_yyscan_t yyscanner;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule, yyscanner); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp, yyscanner)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YYUSE (yytype);
}




/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (core_yyscan_t yyscanner)
#else
int
yyparse (yyscanner)
    core_yyscan_t yyscanner;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;


#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
static YYSTYPE yyval_default;
# define YY_INITIAL_VALUE(Value) = Value
#endif
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc = yyloc_default;


    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1787 of yacc.c  */
#line 654 "gram.y"
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[(1) - (1)].list);
			}
    break;

  case 3:
/* Line 1787 of yacc.c  */
#line 661 "gram.y"
    {
					if ((yyvsp[(3) - (3)].node) != NULL)
						(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
					else
						(yyval.list) = (yyvsp[(1) - (3)].list);
				}
    break;

  case 4:
/* Line 1787 of yacc.c  */
#line 668 "gram.y"
    {
					if ((yyvsp[(1) - (1)].node) != NULL)
						(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
					else
						(yyval.list) = NIL;
				}
    break;

  case 115:
/* Line 1787 of yacc.c  */
#line 788 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 116:
/* Line 1787 of yacc.c  */
#line 799 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 117:
/* Line 1787 of yacc.c  */
#line 809 "gram.y"
    {}
    break;

  case 118:
/* Line 1787 of yacc.c  */
#line 810 "gram.y"
    {}
    break;

  case 119:
/* Line 1787 of yacc.c  */
#line 819 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 120:
/* Line 1787 of yacc.c  */
#line 820 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 121:
/* Line 1787 of yacc.c  */
#line 824 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 122:
/* Line 1787 of yacc.c  */
#line 825 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 123:
/* Line 1787 of yacc.c  */
#line 830 "gram.y"
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 124:
/* Line 1787 of yacc.c  */
#line 835 "gram.y"
    {
					(yyval.defelt) = makeDefElem("password", NULL);
				}
    break;

  case 125:
/* Line 1787 of yacc.c  */
#line 839 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encryptedPassword",
									 (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 126:
/* Line 1787 of yacc.c  */
#line 844 "gram.y"
    {
					(yyval.defelt) = makeDefElem("unencryptedPassword",
									 (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 127:
/* Line 1787 of yacc.c  */
#line 849 "gram.y"
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(TRUE));
				}
    break;

  case 128:
/* Line 1787 of yacc.c  */
#line 853 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(3) - (3)].ival)));
				}
    break;

  case 129:
/* Line 1787 of yacc.c  */
#line 857 "gram.y"
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 130:
/* Line 1787 of yacc.c  */
#line 862 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 131:
/* Line 1787 of yacc.c  */
#line 866 "gram.y"
    {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[(1) - (1)].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "createuser") == 0)
					{
						/* For backwards compatibility, synonym for SUPERUSER */
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
					}
					else if (strcmp((yyvsp[(1) - (1)].str), "nocreateuser") == 0)
					{
						/* For backwards compatibility, synonym for SUPERUSER */
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
					}
					else if (strcmp((yyvsp[(1) - (1)].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(FALSE));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[(1) - (1)].str)),
									 parser_errposition((yylsp[(1) - (1)]))));
				}
    break;

  case 132:
/* Line 1787 of yacc.c  */
#line 919 "gram.y"
    { (yyval.defelt) = (yyvsp[(1) - (1)].defelt); }
    break;

  case 133:
/* Line 1787 of yacc.c  */
#line 922 "gram.y"
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *)makeInteger((yyvsp[(2) - (2)].ival)));
				}
    break;

  case 134:
/* Line 1787 of yacc.c  */
#line 926 "gram.y"
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 135:
/* Line 1787 of yacc.c  */
#line 930 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 136:
/* Line 1787 of yacc.c  */
#line 934 "gram.y"
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 137:
/* Line 1787 of yacc.c  */
#line 938 "gram.y"
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 138:
/* Line 1787 of yacc.c  */
#line 952 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 139:
/* Line 1787 of yacc.c  */
#line 970 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 }
    break;

  case 140:
/* Line 1787 of yacc.c  */
#line 980 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 141:
/* Line 1787 of yacc.c  */
#line 981 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); }
    break;

  case 142:
/* Line 1787 of yacc.c  */
#line 986 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->database = (yyvsp[(4) - (5)].str);
					n->setstmt = (yyvsp[(5) - (5)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 143:
/* Line 1787 of yacc.c  */
#line 1004 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 }
    break;

  case 144:
/* Line 1787 of yacc.c  */
#line 1016 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (4)].str);
					n->database = NULL;
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 145:
/* Line 1787 of yacc.c  */
#line 1037 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 146:
/* Line 1787 of yacc.c  */
#line 1044 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 147:
/* Line 1787 of yacc.c  */
#line 1063 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 148:
/* Line 1787 of yacc.c  */
#line 1070 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->roles = (yyvsp[(5) - (5)].list);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 149:
/* Line 1787 of yacc.c  */
#line 1087 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 150:
/* Line 1787 of yacc.c  */
#line 1105 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *)(yyvsp[(6) - (6)].list)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 151:
/* Line 1787 of yacc.c  */
#line 1115 "gram.y"
    { (yyval.ival) = +1; }
    break;

  case 152:
/* Line 1787 of yacc.c  */
#line 1116 "gram.y"
    { (yyval.ival) = -1; }
    break;

  case 153:
/* Line 1787 of yacc.c  */
#line 1129 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 154:
/* Line 1787 of yacc.c  */
#line 1136 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 155:
/* Line 1787 of yacc.c  */
#line 1153 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					if ((yyvsp[(3) - (6)].str) != NULL)
						n->schemaname = (yyvsp[(3) - (6)].str);
					else
						n->schemaname = (yyvsp[(5) - (6)].str);
					n->authid = (yyvsp[(5) - (6)].str);
					n->schemaElts = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 156:
/* Line 1787 of yacc.c  */
#line 1165 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[(3) - (4)].str);
					n->authid = NULL;
					n->schemaElts = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 157:
/* Line 1787 of yacc.c  */
#line 1176 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 158:
/* Line 1787 of yacc.c  */
#line 1177 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 159:
/* Line 1787 of yacc.c  */
#line 1181 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 160:
/* Line 1787 of yacc.c  */
#line 1182 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 167:
/* Line 1787 of yacc.c  */
#line 1210 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(2) - (2)].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 168:
/* Line 1787 of yacc.c  */
#line 1216 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 169:
/* Line 1787 of yacc.c  */
#line 1222 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 170:
/* Line 1787 of yacc.c  */
#line 1231 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[(2) - (2)].list);
					(yyval.vsetstmt) = n;
				}
    break;

  case 171:
/* Line 1787 of yacc.c  */
#line 1239 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[(5) - (5)].list);
					(yyval.vsetstmt) = n;
				}
    break;

  case 173:
/* Line 1787 of yacc.c  */
#line 1251 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[(1) - (3)].str);
					n->args = (yyvsp[(3) - (3)].list);
					(yyval.vsetstmt) = n;
				}
    break;

  case 174:
/* Line 1787 of yacc.c  */
#line 1259 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[(1) - (3)].str);
					n->args = (yyvsp[(3) - (3)].list);
					(yyval.vsetstmt) = n;
				}
    break;

  case 175:
/* Line 1787 of yacc.c  */
#line 1267 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				}
    break;

  case 176:
/* Line 1787 of yacc.c  */
#line 1274 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				}
    break;

  case 177:
/* Line 1787 of yacc.c  */
#line 1281 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				}
    break;

  case 178:
/* Line 1787 of yacc.c  */
#line 1289 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[(3) - (3)].node) != NULL)
						n->args = list_make1((yyvsp[(3) - (3)].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
    break;

  case 179:
/* Line 1787 of yacc.c  */
#line 1300 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[(2) - (2)]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
    break;

  case 180:
/* Line 1787 of yacc.c  */
#line 1308 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 181:
/* Line 1787 of yacc.c  */
#line 1316 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[(2) - (2)].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
    break;

  case 182:
/* Line 1787 of yacc.c  */
#line 1327 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 183:
/* Line 1787 of yacc.c  */
#line 1335 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 184:
/* Line 1787 of yacc.c  */
#line 1343 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
    break;

  case 185:
/* Line 1787 of yacc.c  */
#line 1350 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 186:
/* Line 1787 of yacc.c  */
#line 1359 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 187:
/* Line 1787 of yacc.c  */
#line 1368 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 188:
/* Line 1787 of yacc.c  */
#line 1370 "gram.y"
    {
					(yyval.str) = palloc(strlen((yyvsp[(1) - (3)].str)) + strlen((yyvsp[(3) - (3)].str)) + 2);
					sprintf((yyval.str), "%s.%s", (yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].str));
				}
    break;

  case 189:
/* Line 1787 of yacc.c  */
#line 1376 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 190:
/* Line 1787 of yacc.c  */
#line 1377 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 191:
/* Line 1787 of yacc.c  */
#line 1381 "gram.y"
    { (yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)])); }
    break;

  case 192:
/* Line 1787 of yacc.c  */
#line 1383 "gram.y"
    { (yyval.node) = makeAConst((yyvsp[(1) - (1)].value), (yylsp[(1) - (1)])); }
    break;

  case 193:
/* Line 1787 of yacc.c  */
#line 1386 "gram.y"
    { (yyval.str) = "read uncommitted"; }
    break;

  case 194:
/* Line 1787 of yacc.c  */
#line 1387 "gram.y"
    { (yyval.str) = "read committed"; }
    break;

  case 195:
/* Line 1787 of yacc.c  */
#line 1388 "gram.y"
    { (yyval.str) = "repeatable read"; }
    break;

  case 196:
/* Line 1787 of yacc.c  */
#line 1389 "gram.y"
    { (yyval.str) = "serializable"; }
    break;

  case 197:
/* Line 1787 of yacc.c  */
#line 1393 "gram.y"
    { (yyval.str) = "true"; }
    break;

  case 198:
/* Line 1787 of yacc.c  */
#line 1394 "gram.y"
    { (yyval.str) = "false"; }
    break;

  case 199:
/* Line 1787 of yacc.c  */
#line 1395 "gram.y"
    { (yyval.str) = "on"; }
    break;

  case 200:
/* Line 1787 of yacc.c  */
#line 1401 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 201:
/* Line 1787 of yacc.c  */
#line 1414 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 202:
/* Line 1787 of yacc.c  */
#line 1418 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 203:
/* Line 1787 of yacc.c  */
#line 1422 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (3)].typnam);
					if ((yyvsp[(3) - (3)].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[(3) - (3)].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[(3) - (3)]))));
					}
					t->typmods = (yyvsp[(3) - (3)].list);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (3)].str), (yylsp[(2) - (3)]), t);
				}
    break;

  case 204:
/* Line 1787 of yacc.c  */
#line 1437 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (6)].typnam);
					if ((yyvsp[(6) - (6)].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[(6) - (6)].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[(6) - (6)]))));
						if (list_length((yyvsp[(6) - (6)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[(1) - (6)]))));
						t->typmods = lappend((yyvsp[(6) - (6)].list), makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (6)].str), (yylsp[(5) - (6)]), t);
				}
    break;

  case 205:
/* Line 1787 of yacc.c  */
#line 1459 "gram.y"
    { (yyval.node) = makeAConst((yyvsp[(1) - (1)].value), (yylsp[(1) - (1)])); }
    break;

  case 206:
/* Line 1787 of yacc.c  */
#line 1460 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 207:
/* Line 1787 of yacc.c  */
#line 1461 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 208:
/* Line 1787 of yacc.c  */
#line 1465 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 209:
/* Line 1787 of yacc.c  */
#line 1466 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 210:
/* Line 1787 of yacc.c  */
#line 1467 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 211:
/* Line 1787 of yacc.c  */
#line 1471 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 212:
/* Line 1787 of yacc.c  */
#line 1472 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 213:
/* Line 1787 of yacc.c  */
#line 1477 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 214:
/* Line 1787 of yacc.c  */
#line 1484 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
    break;

  case 215:
/* Line 1787 of yacc.c  */
#line 1491 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
    break;

  case 216:
/* Line 1787 of yacc.c  */
#line 1498 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
    break;

  case 217:
/* Line 1787 of yacc.c  */
#line 1505 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET_ALL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 218:
/* Line 1787 of yacc.c  */
#line 1514 "gram.y"
    { (yyval.vsetstmt) = (yyvsp[(2) - (2)].vsetstmt); }
    break;

  case 219:
/* Line 1787 of yacc.c  */
#line 1515 "gram.y"
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[(1) - (1)].node); }
    break;

  case 220:
/* Line 1787 of yacc.c  */
#line 1520 "gram.y"
    { (yyval.vsetstmt) = (yyvsp[(2) - (2)].vsetstmt); }
    break;

  case 221:
/* Line 1787 of yacc.c  */
#line 1521 "gram.y"
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[(1) - (1)].node); }
    break;

  case 222:
/* Line 1787 of yacc.c  */
#line 1527 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 223:
/* Line 1787 of yacc.c  */
#line 1533 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
    break;

  case 224:
/* Line 1787 of yacc.c  */
#line 1539 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
    break;

  case 225:
/* Line 1787 of yacc.c  */
#line 1545 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
    break;

  case 226:
/* Line 1787 of yacc.c  */
#line 1551 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				}
    break;

  case 227:
/* Line 1787 of yacc.c  */
#line 1561 "gram.y"
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);
					n->constraints = (yyvsp[(3) - (4)].list);
					n->deferred = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				}
    break;

  case 228:
/* Line 1787 of yacc.c  */
#line 1570 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 229:
/* Line 1787 of yacc.c  */
#line 1571 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 230:
/* Line 1787 of yacc.c  */
#line 1575 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 231:
/* Line 1787 of yacc.c  */
#line 1576 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 232:
/* Line 1787 of yacc.c  */
#line 1585 "gram.y"
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 233:
/* Line 1787 of yacc.c  */
#line 1600 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 234:
/* Line 1787 of yacc.c  */
#line 1606 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
    break;

  case 235:
/* Line 1787 of yacc.c  */
#line 1612 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
    break;

  case 236:
/* Line 1787 of yacc.c  */
#line 1618 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
    break;

  case 237:
/* Line 1787 of yacc.c  */
#line 1636 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 238:
/* Line 1787 of yacc.c  */
#line 1645 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->cmds = (yyvsp[(6) - (6)].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 239:
/* Line 1787 of yacc.c  */
#line 1654 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 240:
/* Line 1787 of yacc.c  */
#line 1663 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->cmds = (yyvsp[(6) - (6)].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 241:
/* Line 1787 of yacc.c  */
#line 1672 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 242:
/* Line 1787 of yacc.c  */
#line 1681 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->cmds = (yyvsp[(6) - (6)].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 243:
/* Line 1787 of yacc.c  */
#line 1690 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 244:
/* Line 1787 of yacc.c  */
#line 1699 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->cmds = (yyvsp[(6) - (6)].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 245:
/* Line 1787 of yacc.c  */
#line 1710 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 246:
/* Line 1787 of yacc.c  */
#line 1711 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 247:
/* Line 1787 of yacc.c  */
#line 1717 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(2) - (2)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 248:
/* Line 1787 of yacc.c  */
#line 1725 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(3) - (3)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 249:
/* Line 1787 of yacc.c  */
#line 1733 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[(3) - (4)].str);
					n->def = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 250:
/* Line 1787 of yacc.c  */
#line 1742 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[(3) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 251:
/* Line 1787 of yacc.c  */
#line 1750 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[(3) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 252:
/* Line 1787 of yacc.c  */
#line 1758 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) makeInteger((yyvsp[(6) - (6)].ival));
					(yyval.node) = (Node *)n;
				}
    break;

  case 253:
/* Line 1787 of yacc.c  */
#line 1767 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetOptions;
					n->name = (yyvsp[(3) - (5)].str);
					n->def = (Node *) (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 254:
/* Line 1787 of yacc.c  */
#line 1776 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[(3) - (5)].str);
					n->def = (Node *) (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 255:
/* Line 1787 of yacc.c  */
#line 1785 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStorage;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) makeString((yyvsp[(6) - (6)].str));
					(yyval.node) = (Node *)n;
				}
    break;

  case 256:
/* Line 1787 of yacc.c  */
#line 1794 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(5) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 257:
/* Line 1787 of yacc.c  */
#line 1804 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 258:
/* Line 1787 of yacc.c  */
#line 1817 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[(3) - (8)].str);
					n->def = (Node *) def;
					/* We only use these three fields of the ColumnDef node */
					def->typeName = (yyvsp[(6) - (8)].typnam);
					def->collClause = (CollateClause *) (yyvsp[(7) - (8)].node);
					def->raw_default = (yyvsp[(8) - (8)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 259:
/* Line 1787 of yacc.c  */
#line 1831 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[(3) - (4)].str);
					n->def = (Node *) (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 260:
/* Line 1787 of yacc.c  */
#line 1840 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[(2) - (2)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 261:
/* Line 1787 of yacc.c  */
#line 1848 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 262:
/* Line 1787 of yacc.c  */
#line 1856 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[(5) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 263:
/* Line 1787 of yacc.c  */
#line 1866 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 264:
/* Line 1787 of yacc.c  */
#line 1876 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddOids;
					(yyval.node) = (Node *)n;
				}
    break;

  case 265:
/* Line 1787 of yacc.c  */
#line 1883 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOids;
					(yyval.node) = (Node *)n;
				}
    break;

  case 266:
/* Line 1787 of yacc.c  */
#line 1890 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 267:
/* Line 1787 of yacc.c  */
#line 1898 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 268:
/* Line 1787 of yacc.c  */
#line 1906 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 269:
/* Line 1787 of yacc.c  */
#line 1914 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 270:
/* Line 1787 of yacc.c  */
#line 1922 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 271:
/* Line 1787 of yacc.c  */
#line 1930 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *)n;
				}
    break;

  case 272:
/* Line 1787 of yacc.c  */
#line 1937 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *)n;
				}
    break;

  case 273:
/* Line 1787 of yacc.c  */
#line 1944 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 274:
/* Line 1787 of yacc.c  */
#line 1952 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *)n;
				}
    break;

  case 275:
/* Line 1787 of yacc.c  */
#line 1959 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *)n;
				}
    break;

  case 276:
/* Line 1787 of yacc.c  */
#line 1966 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRule;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 277:
/* Line 1787 of yacc.c  */
#line 1974 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 278:
/* Line 1787 of yacc.c  */
#line 1982 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 279:
/* Line 1787 of yacc.c  */
#line 1990 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRule;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 280:
/* Line 1787 of yacc.c  */
#line 1998 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[(2) - (2)].range);
					(yyval.node) = (Node *)n;
				}
    break;

  case 281:
/* Line 1787 of yacc.c  */
#line 2006 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[(3) - (3)].range);
					(yyval.node) = (Node *)n;
				}
    break;

  case 282:
/* Line 1787 of yacc.c  */
#line 2014 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName *def = makeTypeNameFromNameList((yyvsp[(2) - (2)].list));
					def->location = (yylsp[(2) - (2)]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *)n;
				}
    break;

  case 283:
/* Line 1787 of yacc.c  */
#line 2024 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOf;
					(yyval.node) = (Node *)n;
				}
    break;

  case 284:
/* Line 1787 of yacc.c  */
#line 2031 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ChangeOwner;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 285:
/* Line 1787 of yacc.c  */
#line 2039 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 286:
/* Line 1787 of yacc.c  */
#line 2047 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetRelOptions;
					n->def = (Node *)(yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 287:
/* Line 1787 of yacc.c  */
#line 2055 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetRelOptions;
					n->def = (Node *)(yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 288:
/* Line 1787 of yacc.c  */
#line 2062 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_GenericOptions;
					n->def = (Node *)(yyvsp[(1) - (1)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 289:
/* Line 1787 of yacc.c  */
#line 2071 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (3)].node); }
    break;

  case 290:
/* Line 1787 of yacc.c  */
#line 2072 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 291:
/* Line 1787 of yacc.c  */
#line 2076 "gram.y"
    { (yyval.dbehavior) = DROP_CASCADE; }
    break;

  case 292:
/* Line 1787 of yacc.c  */
#line 2077 "gram.y"
    { (yyval.dbehavior) = DROP_RESTRICT; }
    break;

  case 293:
/* Line 1787 of yacc.c  */
#line 2078 "gram.y"
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
    break;

  case 294:
/* Line 1787 of yacc.c  */
#line 2083 "gram.y"
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[(2) - (2)].list);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 295:
/* Line 1787 of yacc.c  */
#line 2090 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 296:
/* Line 1787 of yacc.c  */
#line 2094 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 297:
/* Line 1787 of yacc.c  */
#line 2095 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 298:
/* Line 1787 of yacc.c  */
#line 2099 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 299:
/* Line 1787 of yacc.c  */
#line 2102 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 300:
/* Line 1787 of yacc.c  */
#line 2103 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 301:
/* Line 1787 of yacc.c  */
#line 2107 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 302:
/* Line 1787 of yacc.c  */
#line 2108 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 303:
/* Line 1787 of yacc.c  */
#line 2114 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *) (yyvsp[(3) - (3)].node));
				}
    break;

  case 304:
/* Line 1787 of yacc.c  */
#line 2118 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (1)].str), NULL);
				}
    break;

  case 305:
/* Line 1787 of yacc.c  */
#line 2122 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[(1) - (5)].str), (yyvsp[(3) - (5)].str), (Node *) (yyvsp[(5) - (5)].node),
											 DEFELEM_UNSPEC);
				}
    break;

  case 306:
/* Line 1787 of yacc.c  */
#line 2127 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].str), NULL, DEFELEM_UNSPEC);
				}
    break;

  case 307:
/* Line 1787 of yacc.c  */
#line 2142 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[(3) - (4)].list), (yylsp[(3) - (4)]), yyscanner);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_TYPE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 308:
/* Line 1787 of yacc.c  */
#line 2154 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 309:
/* Line 1787 of yacc.c  */
#line 2155 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 310:
/* Line 1787 of yacc.c  */
#line 2161 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(3) - (4)].node);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 311:
/* Line 1787 of yacc.c  */
#line 2170 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(5) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 312:
/* Line 1787 of yacc.c  */
#line 2180 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 313:
/* Line 1787 of yacc.c  */
#line 2190 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[(3) - (8)].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					/* We only use these three fields of the ColumnDef node */
					def->typeName = (yyvsp[(6) - (8)].typnam);
					def->collClause = (CollateClause *) (yyvsp[(7) - (8)].node);
					def->raw_default = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 314:
/* Line 1787 of yacc.c  */
#line 2215 "gram.y"
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 315:
/* Line 1787 of yacc.c  */
#line 2221 "gram.y"
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 316:
/* Line 1787 of yacc.c  */
#line 2249 "gram.y"
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = (yyvsp[(3) - (10)].range);
					n->query = NULL;
					n->attlist = (yyvsp[(4) - (10)].list);
					n->is_from = (yyvsp[(6) - (10)].boolean);
					n->filename = (yyvsp[(7) - (10)].str);

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[(2) - (10)].defelt))
						n->options = lappend(n->options, (yyvsp[(2) - (10)].defelt));
					if ((yyvsp[(5) - (10)].defelt))
						n->options = lappend(n->options, (yyvsp[(5) - (10)].defelt));
					if ((yyvsp[(8) - (10)].defelt))
						n->options = lappend(n->options, (yyvsp[(8) - (10)].defelt));
					if ((yyvsp[(10) - (10)].list))
						n->options = list_concat(n->options, (yyvsp[(10) - (10)].list));
					(yyval.node) = (Node *)n;
				}
    break;

  case 317:
/* Line 1787 of yacc.c  */
#line 2270 "gram.y"
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = NULL;
					n->query = (yyvsp[(2) - (6)].node);
					n->attlist = NIL;
					n->is_from = false;
					n->filename = (yyvsp[(4) - (6)].str);
					n->options = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 318:
/* Line 1787 of yacc.c  */
#line 2283 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 319:
/* Line 1787 of yacc.c  */
#line 2284 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 320:
/* Line 1787 of yacc.c  */
#line 2293 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 321:
/* Line 1787 of yacc.c  */
#line 2294 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 322:
/* Line 1787 of yacc.c  */
#line 2295 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 323:
/* Line 1787 of yacc.c  */
#line 2298 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 324:
/* Line 1787 of yacc.c  */
#line 2299 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 325:
/* Line 1787 of yacc.c  */
#line 2304 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 326:
/* Line 1787 of yacc.c  */
#line 2305 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 327:
/* Line 1787 of yacc.c  */
#line 2310 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				}
    break;

  case 328:
/* Line 1787 of yacc.c  */
#line 2314 "gram.y"
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
    break;

  case 329:
/* Line 1787 of yacc.c  */
#line 2318 "gram.y"
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 330:
/* Line 1787 of yacc.c  */
#line 2322 "gram.y"
    {
					(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 331:
/* Line 1787 of yacc.c  */
#line 2326 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("csv"));
				}
    break;

  case 332:
/* Line 1787 of yacc.c  */
#line 2330 "gram.y"
    {
					(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(TRUE));
				}
    break;

  case 333:
/* Line 1787 of yacc.c  */
#line 2334 "gram.y"
    {
					(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 334:
/* Line 1787 of yacc.c  */
#line 2338 "gram.y"
    {
					(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 335:
/* Line 1787 of yacc.c  */
#line 2342 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 336:
/* Line 1787 of yacc.c  */
#line 2346 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)makeNode(A_Star));
				}
    break;

  case 337:
/* Line 1787 of yacc.c  */
#line 2350 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *)(yyvsp[(4) - (4)].list));
				}
    break;

  case 338:
/* Line 1787 of yacc.c  */
#line 2354 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 339:
/* Line 1787 of yacc.c  */
#line 2363 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				}
    break;

  case 340:
/* Line 1787 of yacc.c  */
#line 2366 "gram.y"
    { (yyval.defelt) = NULL; }
    break;

  case 341:
/* Line 1787 of yacc.c  */
#line 2371 "gram.y"
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
    break;

  case 342:
/* Line 1787 of yacc.c  */
#line 2374 "gram.y"
    { (yyval.defelt) = NULL; }
    break;

  case 343:
/* Line 1787 of yacc.c  */
#line 2379 "gram.y"
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 344:
/* Line 1787 of yacc.c  */
#line 2382 "gram.y"
    { (yyval.defelt) = NULL; }
    break;

  case 345:
/* Line 1787 of yacc.c  */
#line 2386 "gram.y"
    {}
    break;

  case 346:
/* Line 1787 of yacc.c  */
#line 2387 "gram.y"
    {}
    break;

  case 347:
/* Line 1787 of yacc.c  */
#line 2393 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				}
    break;

  case 348:
/* Line 1787 of yacc.c  */
#line 2397 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				}
    break;

  case 349:
/* Line 1787 of yacc.c  */
#line 2404 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				}
    break;

  case 350:
/* Line 1787 of yacc.c  */
#line 2410 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 351:
/* Line 1787 of yacc.c  */
#line 2411 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].value); }
    break;

  case 352:
/* Line 1787 of yacc.c  */
#line 2412 "gram.y"
    { (yyval.node) = (Node *) makeNode(A_Star); }
    break;

  case 353:
/* Line 1787 of yacc.c  */
#line 2413 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(2) - (3)].list); }
    break;

  case 354:
/* Line 1787 of yacc.c  */
#line 2414 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 355:
/* Line 1787 of yacc.c  */
#line 2419 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 356:
/* Line 1787 of yacc.c  */
#line 2423 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 357:
/* Line 1787 of yacc.c  */
#line 2430 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 358:
/* Line 1787 of yacc.c  */
#line 2443 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(4) - (11)].range)->relpersistence = (yyvsp[(2) - (11)].ival);
					n->relation = (yyvsp[(4) - (11)].range);
					n->tableElts = (yyvsp[(6) - (11)].list);
					n->inhRelations = (yyvsp[(8) - (11)].list);
					n->constraints = NIL;
					n->options = (yyvsp[(9) - (11)].list);
					n->oncommit = (yyvsp[(10) - (11)].oncommit);
					n->tablespacename = (yyvsp[(11) - (11)].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 359:
/* Line 1787 of yacc.c  */
#line 2459 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(7) - (14)].range)->relpersistence = (yyvsp[(2) - (14)].ival);
					n->relation = (yyvsp[(7) - (14)].range);
					n->tableElts = (yyvsp[(9) - (14)].list);
					n->inhRelations = (yyvsp[(11) - (14)].list);
					n->constraints = NIL;
					n->options = (yyvsp[(12) - (14)].list);
					n->oncommit = (yyvsp[(13) - (14)].oncommit);
					n->tablespacename = (yyvsp[(14) - (14)].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 360:
/* Line 1787 of yacc.c  */
#line 2474 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(4) - (10)].range)->relpersistence = (yyvsp[(2) - (10)].ival);
					n->relation = (yyvsp[(4) - (10)].range);
					n->tableElts = (yyvsp[(7) - (10)].list);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[(6) - (10)].list));
					n->ofTypename->location = (yylsp[(6) - (10)]);
					n->constraints = NIL;
					n->options = (yyvsp[(8) - (10)].list);
					n->oncommit = (yyvsp[(9) - (10)].oncommit);
					n->tablespacename = (yyvsp[(10) - (10)].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 361:
/* Line 1787 of yacc.c  */
#line 2490 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(7) - (13)].range)->relpersistence = (yyvsp[(2) - (13)].ival);
					n->relation = (yyvsp[(7) - (13)].range);
					n->tableElts = (yyvsp[(10) - (13)].list);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[(9) - (13)].list));
					n->ofTypename->location = (yylsp[(9) - (13)]);
					n->constraints = NIL;
					n->options = (yyvsp[(11) - (13)].list);
					n->oncommit = (yyvsp[(12) - (13)].oncommit);
					n->tablespacename = (yyvsp[(13) - (13)].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 362:
/* Line 1787 of yacc.c  */
#line 2517 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
    break;

  case 363:
/* Line 1787 of yacc.c  */
#line 2518 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
    break;

  case 364:
/* Line 1787 of yacc.c  */
#line 2519 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
    break;

  case 365:
/* Line 1787 of yacc.c  */
#line 2520 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
    break;

  case 366:
/* Line 1787 of yacc.c  */
#line 2522 "gram.y"
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
    break;

  case 367:
/* Line 1787 of yacc.c  */
#line 2529 "gram.y"
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
    break;

  case 368:
/* Line 1787 of yacc.c  */
#line 2535 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
    break;

  case 369:
/* Line 1787 of yacc.c  */
#line 2536 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
    break;

  case 370:
/* Line 1787 of yacc.c  */
#line 2540 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 371:
/* Line 1787 of yacc.c  */
#line 2541 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 372:
/* Line 1787 of yacc.c  */
#line 2545 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 373:
/* Line 1787 of yacc.c  */
#line 2546 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 374:
/* Line 1787 of yacc.c  */
#line 2551 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 375:
/* Line 1787 of yacc.c  */
#line 2555 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 376:
/* Line 1787 of yacc.c  */
#line 2562 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 377:
/* Line 1787 of yacc.c  */
#line 2566 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 378:
/* Line 1787 of yacc.c  */
#line 2572 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 379:
/* Line 1787 of yacc.c  */
#line 2573 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 380:
/* Line 1787 of yacc.c  */
#line 2574 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 381:
/* Line 1787 of yacc.c  */
#line 2578 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 382:
/* Line 1787 of yacc.c  */
#line 2579 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 383:
/* Line 1787 of yacc.c  */
#line 2583 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (4)].str);
					n->typeName = (yyvsp[(2) - (4)].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[(3) - (4)].list);
					SplitColQualList((yyvsp[(4) - (4)].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 384:
/* Line 1787 of yacc.c  */
#line 2603 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (4)].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[(4) - (4)].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 385:
/* Line 1787 of yacc.c  */
#line 2622 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 386:
/* Line 1787 of yacc.c  */
#line 2623 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 387:
/* Line 1787 of yacc.c  */
#line 2628 "gram.y"
    {
					Constraint *n = (Constraint *) (yyvsp[(3) - (3)].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[(2) - (3)].str);
					n->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 388:
/* Line 1787 of yacc.c  */
#line 2635 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 389:
/* Line 1787 of yacc.c  */
#line 2636 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 390:
/* Line 1787 of yacc.c  */
#line 2638 "gram.y"
    {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[(2) - (2)].list);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 391:
/* Line 1787 of yacc.c  */
#line 2669 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 392:
/* Line 1787 of yacc.c  */
#line 2676 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 393:
/* Line 1787 of yacc.c  */
#line 2683 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[(1) - (3)]);
					n->keys = NULL;
					n->options = (yyvsp[(2) - (3)].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 394:
/* Line 1787 of yacc.c  */
#line 2694 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[(1) - (4)]);
					n->keys = NULL;
					n->options = (yyvsp[(3) - (4)].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 395:
/* Line 1787 of yacc.c  */
#line 2705 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[(1) - (5)]);
					n->is_no_inherit = (yyvsp[(5) - (5)].boolean);
					n->raw_expr = (yyvsp[(3) - (5)].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 396:
/* Line 1787 of yacc.c  */
#line 2715 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[(1) - (2)]);
					n->raw_expr = (yyvsp[(2) - (2)].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 397:
/* Line 1787 of yacc.c  */
#line 2724 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[(1) - (5)]);
					n->pktable			= (yyvsp[(2) - (5)].range);
					n->fk_attrs			= NIL;
					n->pk_attrs			= (yyvsp[(3) - (5)].list);
					n->fk_matchtype		= (yyvsp[(4) - (5)].ival);
					n->fk_upd_action	= (char) ((yyvsp[(5) - (5)].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[(5) - (5)].ival) & 0xFF);
					n->skip_validation  = false;
					n->initially_valid  = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 398:
/* Line 1787 of yacc.c  */
#line 2757 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 399:
/* Line 1787 of yacc.c  */
#line 2764 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 400:
/* Line 1787 of yacc.c  */
#line 2771 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 401:
/* Line 1787 of yacc.c  */
#line 2778 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 402:
/* Line 1787 of yacc.c  */
#line 2789 "gram.y"
    {
					TableLikeClause *n = makeNode(TableLikeClause);
					n->relation = (yyvsp[(2) - (3)].range);
					n->options = (yyvsp[(3) - (3)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 403:
/* Line 1787 of yacc.c  */
#line 2798 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | (yyvsp[(3) - (3)].ival); }
    break;

  case 404:
/* Line 1787 of yacc.c  */
#line 2799 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) & ~(yyvsp[(3) - (3)].ival); }
    break;

  case 405:
/* Line 1787 of yacc.c  */
#line 2800 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 406:
/* Line 1787 of yacc.c  */
#line 2804 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
    break;

  case 407:
/* Line 1787 of yacc.c  */
#line 2805 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
    break;

  case 408:
/* Line 1787 of yacc.c  */
#line 2806 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
    break;

  case 409:
/* Line 1787 of yacc.c  */
#line 2807 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
    break;

  case 410:
/* Line 1787 of yacc.c  */
#line 2808 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
    break;

  case 411:
/* Line 1787 of yacc.c  */
#line 2809 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
    break;

  case 412:
/* Line 1787 of yacc.c  */
#line 2819 "gram.y"
    {
					Constraint *n = (Constraint *) (yyvsp[(3) - (3)].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[(2) - (3)].str);
					n->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 413:
/* Line 1787 of yacc.c  */
#line 2826 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 414:
/* Line 1787 of yacc.c  */
#line 2831 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[(1) - (5)]);
					n->raw_expr = (yyvsp[(3) - (5)].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[(5) - (5)].ival), (yylsp[(5) - (5)]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
    break;

  case 415:
/* Line 1787 of yacc.c  */
#line 2845 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[(1) - (7)]);
					n->keys = (yyvsp[(3) - (7)].list);
					n->options = (yyvsp[(5) - (7)].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[(6) - (7)].str);
					processCASbits((yyvsp[(7) - (7)].ival), (yylsp[(7) - (7)]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 416:
/* Line 1787 of yacc.c  */
#line 2859 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[(1) - (3)]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[(2) - (3)].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[(3) - (3)].ival), (yylsp[(3) - (3)]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 417:
/* Line 1787 of yacc.c  */
#line 2874 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[(1) - (8)]);
					n->keys = (yyvsp[(4) - (8)].list);
					n->options = (yyvsp[(6) - (8)].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[(7) - (8)].str);
					processCASbits((yyvsp[(8) - (8)].ival), (yylsp[(8) - (8)]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 418:
/* Line 1787 of yacc.c  */
#line 2888 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[(1) - (4)]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[(3) - (4)].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[(4) - (4)].ival), (yylsp[(4) - (4)]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 419:
/* Line 1787 of yacc.c  */
#line 2904 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[(1) - (9)]);
					n->access_method	= (yyvsp[(2) - (9)].str);
					n->exclusions		= (yyvsp[(4) - (9)].list);
					n->options			= (yyvsp[(6) - (9)].list);
					n->indexname		= NULL;
					n->indexspace		= (yyvsp[(7) - (9)].str);
					n->where_clause		= (yyvsp[(8) - (9)].node);
					processCASbits((yyvsp[(9) - (9)].ival), (yylsp[(9) - (9)]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 420:
/* Line 1787 of yacc.c  */
#line 2921 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[(1) - (11)]);
					n->pktable			= (yyvsp[(7) - (11)].range);
					n->fk_attrs			= (yyvsp[(4) - (11)].list);
					n->pk_attrs			= (yyvsp[(8) - (11)].list);
					n->fk_matchtype		= (yyvsp[(9) - (11)].ival);
					n->fk_upd_action	= (char) ((yyvsp[(10) - (11)].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[(10) - (11)].ival) & 0xFF);
					processCASbits((yyvsp[(11) - (11)].ival), (yylsp[(11) - (11)]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
    break;

  case 421:
/* Line 1787 of yacc.c  */
#line 2940 "gram.y"
    {  (yyval.boolean) = TRUE; }
    break;

  case 422:
/* Line 1787 of yacc.c  */
#line 2941 "gram.y"
    {  (yyval.boolean) = FALSE; }
    break;

  case 423:
/* Line 1787 of yacc.c  */
#line 2945 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 424:
/* Line 1787 of yacc.c  */
#line 2946 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 425:
/* Line 1787 of yacc.c  */
#line 2950 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 426:
/* Line 1787 of yacc.c  */
#line 2951 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 427:
/* Line 1787 of yacc.c  */
#line 2955 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str));
				}
    break;

  case 428:
/* Line 1787 of yacc.c  */
#line 2961 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
    break;

  case 429:
/* Line 1787 of yacc.c  */
#line 2965 "gram.y"
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[(1) - (2)]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
    break;

  case 430:
/* Line 1787 of yacc.c  */
#line 2973 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_UNSPECIFIED;
			}
    break;

  case 431:
/* Line 1787 of yacc.c  */
#line 2977 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_UNSPECIFIED;
			}
    break;

  case 432:
/* Line 1787 of yacc.c  */
#line 2983 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].list)); }
    break;

  case 433:
/* Line 1787 of yacc.c  */
#line 2985 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)); }
    break;

  case 434:
/* Line 1787 of yacc.c  */
#line 2989 "gram.y"
    {
				(yyval.list) = list_make2((yyvsp[(1) - (3)].ielem), (yyvsp[(3) - (3)].list));
			}
    break;

  case 435:
/* Line 1787 of yacc.c  */
#line 2994 "gram.y"
    {
				(yyval.list) = list_make2((yyvsp[(1) - (6)].ielem), (yyvsp[(5) - (6)].list));
			}
    break;

  case 436:
/* Line 1787 of yacc.c  */
#line 3000 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (4)].node); }
    break;

  case 437:
/* Line 1787 of yacc.c  */
#line 3001 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 438:
/* Line 1787 of yacc.c  */
#line 3012 "gram.y"
    { (yyval.ival) = ((yyvsp[(1) - (1)].ival) << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
    break;

  case 439:
/* Line 1787 of yacc.c  */
#line 3014 "gram.y"
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | ((yyvsp[(1) - (1)].ival) & 0xFF); }
    break;

  case 440:
/* Line 1787 of yacc.c  */
#line 3016 "gram.y"
    { (yyval.ival) = ((yyvsp[(1) - (2)].ival) << 8) | ((yyvsp[(2) - (2)].ival) & 0xFF); }
    break;

  case 441:
/* Line 1787 of yacc.c  */
#line 3018 "gram.y"
    { (yyval.ival) = ((yyvsp[(2) - (2)].ival) << 8) | ((yyvsp[(1) - (2)].ival) & 0xFF); }
    break;

  case 442:
/* Line 1787 of yacc.c  */
#line 3020 "gram.y"
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
    break;

  case 443:
/* Line 1787 of yacc.c  */
#line 3023 "gram.y"
    { (yyval.ival) = (yyvsp[(3) - (3)].ival); }
    break;

  case 444:
/* Line 1787 of yacc.c  */
#line 3026 "gram.y"
    { (yyval.ival) = (yyvsp[(3) - (3)].ival); }
    break;

  case 445:
/* Line 1787 of yacc.c  */
#line 3030 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_NOACTION; }
    break;

  case 446:
/* Line 1787 of yacc.c  */
#line 3031 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_RESTRICT; }
    break;

  case 447:
/* Line 1787 of yacc.c  */
#line 3032 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_CASCADE; }
    break;

  case 448:
/* Line 1787 of yacc.c  */
#line 3033 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_SETNULL; }
    break;

  case 449:
/* Line 1787 of yacc.c  */
#line 3034 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_SETDEFAULT; }
    break;

  case 450:
/* Line 1787 of yacc.c  */
#line 3037 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 451:
/* Line 1787 of yacc.c  */
#line 3038 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 452:
/* Line 1787 of yacc.c  */
#line 3043 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 453:
/* Line 1787 of yacc.c  */
#line 3044 "gram.y"
    { (yyval.list) = list_make1(defWithOids(true)); }
    break;

  case 454:
/* Line 1787 of yacc.c  */
#line 3045 "gram.y"
    { (yyval.list) = list_make1(defWithOids(false)); }
    break;

  case 455:
/* Line 1787 of yacc.c  */
#line 3046 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 456:
/* Line 1787 of yacc.c  */
#line 3049 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_DROP; }
    break;

  case 457:
/* Line 1787 of yacc.c  */
#line 3050 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
    break;

  case 458:
/* Line 1787 of yacc.c  */
#line 3051 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
    break;

  case 459:
/* Line 1787 of yacc.c  */
#line 3052 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_NOOP; }
    break;

  case 460:
/* Line 1787 of yacc.c  */
#line 3055 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 461:
/* Line 1787 of yacc.c  */
#line 3056 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 462:
/* Line 1787 of yacc.c  */
#line 3059 "gram.y"
    { (yyval.str) = (yyvsp[(4) - (4)].str); }
    break;

  case 463:
/* Line 1787 of yacc.c  */
#line 3060 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 464:
/* Line 1787 of yacc.c  */
#line 3063 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); }
    break;

  case 465:
/* Line 1787 of yacc.c  */
#line 3079 "gram.y"
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[(6) - (7)].node);
					ctas->into = (yyvsp[(4) - (7)].into);
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[(4) - (7)].into)->rel->relpersistence = (yyvsp[(2) - (7)].ival);
					(yyvsp[(4) - (7)].into)->skipData = !((yyvsp[(7) - (7)].boolean));
					(yyval.node) = (Node *) ctas;
				}
    break;

  case 466:
/* Line 1787 of yacc.c  */
#line 3093 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(1) - (5)].range);
					(yyval.into)->colNames = (yyvsp[(2) - (5)].list);
					(yyval.into)->options = (yyvsp[(3) - (5)].list);
					(yyval.into)->onCommit = (yyvsp[(4) - (5)].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[(5) - (5)].str);
					(yyval.into)->skipData = false;		/* might get changed later */
				}
    break;

  case 467:
/* Line 1787 of yacc.c  */
#line 3105 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 468:
/* Line 1787 of yacc.c  */
#line 3106 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 469:
/* Line 1787 of yacc.c  */
#line 3107 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 470:
/* Line 1787 of yacc.c  */
#line 3121 "gram.y"
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[(4) - (5)].range)->relpersistence = (yyvsp[(2) - (5)].ival);
					n->sequence = (yyvsp[(4) - (5)].range);
					n->options = (yyvsp[(5) - (5)].list);
					n->ownerId = InvalidOid;
					(yyval.node) = (Node *)n;
				}
    break;

  case 471:
/* Line 1787 of yacc.c  */
#line 3133 "gram.y"
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[(3) - (4)].range);
					n->options = (yyvsp[(4) - (4)].list);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 472:
/* Line 1787 of yacc.c  */
#line 3141 "gram.y"
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[(5) - (6)].range);
					n->options = (yyvsp[(6) - (6)].list);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 473:
/* Line 1787 of yacc.c  */
#line 3151 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 474:
/* Line 1787 of yacc.c  */
#line 3152 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 475:
/* Line 1787 of yacc.c  */
#line 3155 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 476:
/* Line 1787 of yacc.c  */
#line 3156 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 477:
/* Line 1787 of yacc.c  */
#line 3160 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cache", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 478:
/* Line 1787 of yacc.c  */
#line 3164 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(TRUE));
				}
    break;

  case 479:
/* Line 1787 of yacc.c  */
#line 3168 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(FALSE));
				}
    break;

  case 480:
/* Line 1787 of yacc.c  */
#line 3172 "gram.y"
    {
					(yyval.defelt) = makeDefElem("increment", (Node *)(yyvsp[(3) - (3)].value));
				}
    break;

  case 481:
/* Line 1787 of yacc.c  */
#line 3176 "gram.y"
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 482:
/* Line 1787 of yacc.c  */
#line 3180 "gram.y"
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 483:
/* Line 1787 of yacc.c  */
#line 3184 "gram.y"
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL);
				}
    break;

  case 484:
/* Line 1787 of yacc.c  */
#line 3188 "gram.y"
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL);
				}
    break;

  case 485:
/* Line 1787 of yacc.c  */
#line 3192 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 486:
/* Line 1787 of yacc.c  */
#line 3196 "gram.y"
    {
					(yyval.defelt) = makeDefElem("start", (Node *)(yyvsp[(3) - (3)].value));
				}
    break;

  case 487:
/* Line 1787 of yacc.c  */
#line 3200 "gram.y"
    {
					(yyval.defelt) = makeDefElem("restart", NULL);
				}
    break;

  case 488:
/* Line 1787 of yacc.c  */
#line 3204 "gram.y"
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[(3) - (3)].value));
				}
    break;

  case 489:
/* Line 1787 of yacc.c  */
#line 3209 "gram.y"
    {}
    break;

  case 490:
/* Line 1787 of yacc.c  */
#line 3210 "gram.y"
    {}
    break;

  case 491:
/* Line 1787 of yacc.c  */
#line 3214 "gram.y"
    { (yyval.value) = makeFloat((yyvsp[(1) - (1)].str)); }
    break;

  case 492:
/* Line 1787 of yacc.c  */
#line 3216 "gram.y"
    {
					(yyval.value) = makeFloat((yyvsp[(2) - (2)].str));
					doNegateFloat((yyval.value));
				}
    break;

  case 493:
/* Line 1787 of yacc.c  */
#line 3220 "gram.y"
    { (yyval.value) = makeInteger((yyvsp[(1) - (1)].ival)); }
    break;

  case 494:
/* Line 1787 of yacc.c  */
#line 3223 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].value)); }
    break;

  case 495:
/* Line 1787 of yacc.c  */
#line 3224 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].value)); }
    break;

  case 496:
/* Line 1787 of yacc.c  */
#line 3237 "gram.y"
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[(2) - (6)].boolean);
				n->plname = (yyvsp[(6) - (6)].str);
				/* parameters are all to be supplied by system */
				n->plhandler = NIL;
				n->plinline = NIL;
				n->plvalidator = NIL;
				n->pltrusted = false;
				(yyval.node) = (Node *)n;
			}
    break;

  case 497:
/* Line 1787 of yacc.c  */
#line 3250 "gram.y"
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[(2) - (10)].boolean);
				n->plname = (yyvsp[(6) - (10)].str);
				n->plhandler = (yyvsp[(8) - (10)].list);
				n->plinline = (yyvsp[(9) - (10)].list);
				n->plvalidator = (yyvsp[(10) - (10)].list);
				n->pltrusted = (yyvsp[(3) - (10)].boolean);
				(yyval.node) = (Node *)n;
			}
    break;

  case 498:
/* Line 1787 of yacc.c  */
#line 3263 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 499:
/* Line 1787 of yacc.c  */
#line 3264 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 500:
/* Line 1787 of yacc.c  */
#line 3272 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 501:
/* Line 1787 of yacc.c  */
#line 3273 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)); }
    break;

  case 502:
/* Line 1787 of yacc.c  */
#line 3277 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 503:
/* Line 1787 of yacc.c  */
#line 3278 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 504:
/* Line 1787 of yacc.c  */
#line 3282 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 505:
/* Line 1787 of yacc.c  */
#line 3283 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 506:
/* Line 1787 of yacc.c  */
#line 3287 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 507:
/* Line 1787 of yacc.c  */
#line 3288 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 508:
/* Line 1787 of yacc.c  */
#line 3293 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(list_make1(makeString((yyvsp[(4) - (5)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 509:
/* Line 1787 of yacc.c  */
#line 3304 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(list_make1(makeString((yyvsp[(6) - (7)].str))));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 510:
/* Line 1787 of yacc.c  */
#line 3316 "gram.y"
    {}
    break;

  case 511:
/* Line 1787 of yacc.c  */
#line 3317 "gram.y"
    {}
    break;

  case 512:
/* Line 1787 of yacc.c  */
#line 3328 "gram.y"
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);
					n->tablespacename = (yyvsp[(3) - (6)].str);
					n->owner = (yyvsp[(4) - (6)].str);
					n->location = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 513:
/* Line 1787 of yacc.c  */
#line 3337 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 514:
/* Line 1787 of yacc.c  */
#line 3338 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 515:
/* Line 1787 of yacc.c  */
#line 3352 "gram.y"
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[(3) - (3)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 516:
/* Line 1787 of yacc.c  */
#line 3359 "gram.y"
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[(5) - (5)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 517:
/* Line 1787 of yacc.c  */
#line 3376 "gram.y"
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[(3) - (5)].str);
					n->if_not_exists = false;
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 518:
/* Line 1787 of yacc.c  */
#line 3384 "gram.y"
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[(6) - (8)].str);
					n->if_not_exists = true;
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 519:
/* Line 1787 of yacc.c  */
#line 3395 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 520:
/* Line 1787 of yacc.c  */
#line 3397 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 521:
/* Line 1787 of yacc.c  */
#line 3402 "gram.y"
    {
					(yyval.defelt) = makeDefElem("schema", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 522:
/* Line 1787 of yacc.c  */
#line 3406 "gram.y"
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 523:
/* Line 1787 of yacc.c  */
#line 3410 "gram.y"
    {
					(yyval.defelt) = makeDefElem("old_version", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 524:
/* Line 1787 of yacc.c  */
#line 3422 "gram.y"
    {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);
					n->extname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 525:
/* Line 1787 of yacc.c  */
#line 3432 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 526:
/* Line 1787 of yacc.c  */
#line 3434 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 527:
/* Line 1787 of yacc.c  */
#line 3439 "gram.y"
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 528:
/* Line 1787 of yacc.c  */
#line 3452 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[(6) - (7)].list);
					n->objargs = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 529:
/* Line 1787 of yacc.c  */
#line 3462 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (10)].str);
					n->action = (yyvsp[(4) - (10)].ival);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[(7) - (10)].typnam));
					n->objargs = list_make1((yyvsp[(9) - (10)].typnam));
					(yyval.node) = (Node *) n;
				}
    break;

  case 530:
/* Line 1787 of yacc.c  */
#line 3472 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_COLLATION;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 531:
/* Line 1787 of yacc.c  */
#line 3481 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_CONVERSION;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 532:
/* Line 1787 of yacc.c  */
#line 3490 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_DOMAIN;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 533:
/* Line 1787 of yacc.c  */
#line 3499 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[(6) - (6)].funwithargs)->funcname;
					n->objargs = (yyvsp[(6) - (6)].funwithargs)->funcargs;
					(yyval.node) = (Node *)n;
				}
    break;

  case 534:
/* Line 1787 of yacc.c  */
#line 3509 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = list_make1(makeString((yyvsp[(7) - (7)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 535:
/* Line 1787 of yacc.c  */
#line 3518 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[(6) - (7)].list);
					n->objargs = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 536:
/* Line 1787 of yacc.c  */
#line 3528 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (9)].str);
					n->action = (yyvsp[(4) - (9)].ival);
					n->objtype = OBJECT_OPCLASS;
					n->objname = (yyvsp[(7) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(9) - (9)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 537:
/* Line 1787 of yacc.c  */
#line 3538 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (9)].str);
					n->action = (yyvsp[(4) - (9)].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = (yyvsp[(7) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(9) - (9)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 538:
/* Line 1787 of yacc.c  */
#line 3548 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_SCHEMA;
					n->objname = list_make1(makeString((yyvsp[(6) - (6)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 539:
/* Line 1787 of yacc.c  */
#line 3557 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_TABLE;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 540:
/* Line 1787 of yacc.c  */
#line 3566 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_TSPARSER;
					n->objname = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 541:
/* Line 1787 of yacc.c  */
#line 3575 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_TSDICTIONARY;
					n->objname = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 542:
/* Line 1787 of yacc.c  */
#line 3584 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_TSTEMPLATE;
					n->objname = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 543:
/* Line 1787 of yacc.c  */
#line 3593 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_TSCONFIGURATION;
					n->objname = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 544:
/* Line 1787 of yacc.c  */
#line 3602 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_SEQUENCE;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 545:
/* Line 1787 of yacc.c  */
#line 3611 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_VIEW;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 546:
/* Line 1787 of yacc.c  */
#line 3620 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->objname = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 547:
/* Line 1787 of yacc.c  */
#line 3629 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_FDW;
					n->objname = list_make1(makeString((yyvsp[(8) - (8)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 548:
/* Line 1787 of yacc.c  */
#line 3638 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->objname = list_make1(makeString((yyvsp[(6) - (6)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 549:
/* Line 1787 of yacc.c  */
#line 3647 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_TYPE;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 550:
/* Line 1787 of yacc.c  */
#line 3665 "gram.y"
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);
					n->fdwname = (yyvsp[(5) - (7)].str);
					n->func_options = (yyvsp[(6) - (7)].list);
					n->options = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 551:
/* Line 1787 of yacc.c  */
#line 3675 "gram.y"
    { (yyval.defelt) = makeDefElem("handler", (Node *)(yyvsp[(2) - (2)].list)); }
    break;

  case 552:
/* Line 1787 of yacc.c  */
#line 3676 "gram.y"
    { (yyval.defelt) = makeDefElem("handler", NULL); }
    break;

  case 553:
/* Line 1787 of yacc.c  */
#line 3677 "gram.y"
    { (yyval.defelt) = makeDefElem("validator", (Node *)(yyvsp[(2) - (2)].list)); }
    break;

  case 554:
/* Line 1787 of yacc.c  */
#line 3678 "gram.y"
    { (yyval.defelt) = makeDefElem("validator", NULL); }
    break;

  case 555:
/* Line 1787 of yacc.c  */
#line 3682 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 556:
/* Line 1787 of yacc.c  */
#line 3683 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 557:
/* Line 1787 of yacc.c  */
#line 3687 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 558:
/* Line 1787 of yacc.c  */
#line 3688 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 559:
/* Line 1787 of yacc.c  */
#line 3699 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FDW;
					n->objects = list_make1(list_make1(makeString((yyvsp[(5) - (6)].str))));
					n->arguments = NIL;
					n->missing_ok = false;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 560:
/* Line 1787 of yacc.c  */
#line 3710 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FDW;
					n->objects = list_make1(list_make1(makeString((yyvsp[(7) - (8)].str))));
					n->arguments = NIL;
					n->missing_ok = true;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 561:
/* Line 1787 of yacc.c  */
#line 3730 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (7)].str);
					n->func_options = (yyvsp[(6) - (7)].list);
					n->options = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 562:
/* Line 1787 of yacc.c  */
#line 3738 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (6)].str);
					n->func_options = (yyvsp[(6) - (6)].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 563:
/* Line 1787 of yacc.c  */
#line 3749 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 564:
/* Line 1787 of yacc.c  */
#line 3750 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 565:
/* Line 1787 of yacc.c  */
#line 3755 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				}
    break;

  case 566:
/* Line 1787 of yacc.c  */
#line 3759 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				}
    break;

  case 567:
/* Line 1787 of yacc.c  */
#line 3766 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 568:
/* Line 1787 of yacc.c  */
#line 3771 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				}
    break;

  case 569:
/* Line 1787 of yacc.c  */
#line 3775 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				}
    break;

  case 570:
/* Line 1787 of yacc.c  */
#line 3782 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(1) - (1)].defelt);
				}
    break;

  case 571:
/* Line 1787 of yacc.c  */
#line 3786 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(2) - (2)].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
    break;

  case 572:
/* Line 1787 of yacc.c  */
#line 3791 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(2) - (2)].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
    break;

  case 573:
/* Line 1787 of yacc.c  */
#line 3796 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[(2) - (2)].str), NULL, DEFELEM_DROP);
				}
    break;

  case 574:
/* Line 1787 of yacc.c  */
#line 3803 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				}
    break;

  case 575:
/* Line 1787 of yacc.c  */
#line 3809 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 576:
/* Line 1787 of yacc.c  */
#line 3814 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 577:
/* Line 1787 of yacc.c  */
#line 3826 "gram.y"
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[(3) - (10)].str);
					n->servertype = (yyvsp[(4) - (10)].str);
					n->version = (yyvsp[(5) - (10)].str);
					n->fdwname = (yyvsp[(9) - (10)].str);
					n->options = (yyvsp[(10) - (10)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 578:
/* Line 1787 of yacc.c  */
#line 3838 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 579:
/* Line 1787 of yacc.c  */
#line 3839 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 580:
/* Line 1787 of yacc.c  */
#line 3844 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 581:
/* Line 1787 of yacc.c  */
#line 3845 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 582:
/* Line 1787 of yacc.c  */
#line 3849 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 583:
/* Line 1787 of yacc.c  */
#line 3850 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 584:
/* Line 1787 of yacc.c  */
#line 3861 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FOREIGN_SERVER;
					n->objects = list_make1(list_make1(makeString((yyvsp[(3) - (4)].str))));
					n->arguments = NIL;
					n->missing_ok = false;
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 585:
/* Line 1787 of yacc.c  */
#line 3872 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FOREIGN_SERVER;
					n->objects = list_make1(list_make1(makeString((yyvsp[(5) - (6)].str))));
					n->arguments = NIL;
					n->missing_ok = true;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 586:
/* Line 1787 of yacc.c  */
#line 3892 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (5)].str);
					n->version = (yyvsp[(4) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 587:
/* Line 1787 of yacc.c  */
#line 3901 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->version = (yyvsp[(4) - (4)].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 588:
/* Line 1787 of yacc.c  */
#line 3909 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->options = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 589:
/* Line 1787 of yacc.c  */
#line 3928 "gram.y"
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[(4) - (8)].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[(4) - (8)].range);
					n->base.tableElts = (yyvsp[(5) - (8)].list);
					n->base.inhRelations = NIL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[(7) - (8)].str);
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 590:
/* Line 1787 of yacc.c  */
#line 3943 "gram.y"
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[(7) - (11)].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[(7) - (11)].range);
					n->base.tableElts = (yyvsp[(8) - (11)].list);
					n->base.inhRelations = NIL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[(10) - (11)].str);
					n->options = (yyvsp[(11) - (11)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 591:
/* Line 1787 of yacc.c  */
#line 3958 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 592:
/* Line 1787 of yacc.c  */
#line 3959 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 593:
/* Line 1787 of yacc.c  */
#line 3964 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 594:
/* Line 1787 of yacc.c  */
#line 3968 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 595:
/* Line 1787 of yacc.c  */
#line 3974 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 596:
/* Line 1787 of yacc.c  */
#line 3986 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(4) - (5)].range);
					n->cmds = (yyvsp[(5) - (5)].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 597:
/* Line 1787 of yacc.c  */
#line 3995 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(6) - (7)].range);
					n->cmds = (yyvsp[(7) - (7)].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 598:
/* Line 1787 of yacc.c  */
#line 4013 "gram.y"
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->username = (yyvsp[(5) - (8)].str);
					n->servername = (yyvsp[(7) - (8)].str);
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 599:
/* Line 1787 of yacc.c  */
#line 4024 "gram.y"
    { (yyval.str) = "current_user"; }
    break;

  case 600:
/* Line 1787 of yacc.c  */
#line 4025 "gram.y"
    { (yyval.str) = "current_user"; }
    break;

  case 601:
/* Line 1787 of yacc.c  */
#line 4026 "gram.y"
    { (yyval.str) = (strcmp((yyvsp[(1) - (1)].str), "public") == 0) ? NULL : (yyvsp[(1) - (1)].str); }
    break;

  case 602:
/* Line 1787 of yacc.c  */
#line 4037 "gram.y"
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[(5) - (7)].str);
					n->servername = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 603:
/* Line 1787 of yacc.c  */
#line 4045 "gram.y"
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[(7) - (9)].str);
					n->servername = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 604:
/* Line 1787 of yacc.c  */
#line 4062 "gram.y"
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);
					n->username = (yyvsp[(5) - (8)].str);
					n->servername = (yyvsp[(7) - (8)].str);
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 605:
/* Line 1787 of yacc.c  */
#line 4083 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(3) - (15)].str);
					n->relation = (yyvsp[(7) - (15)].range);
					n->funcname = (yyvsp[(12) - (15)].list);
					n->args = (yyvsp[(14) - (15)].list);
					n->row = (yyvsp[(8) - (15)].boolean);
					n->timing = (yyvsp[(4) - (15)].ival);
					n->events = intVal(linitial((yyvsp[(5) - (15)].list)));
					n->columns = (List *) lsecond((yyvsp[(5) - (15)].list));
					n->whenClause = (yyvsp[(9) - (15)].node);
					n->isconstraint  = FALSE;
					n->deferrable	 = FALSE;
					n->initdeferred  = FALSE;
					n->constrrel = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 606:
/* Line 1787 of yacc.c  */
#line 4104 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(4) - (20)].str);
					n->relation = (yyvsp[(8) - (20)].range);
					n->funcname = (yyvsp[(17) - (20)].list);
					n->args = (yyvsp[(19) - (20)].list);
					n->row = TRUE;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[(6) - (20)].list)));
					n->columns = (List *) lsecond((yyvsp[(6) - (20)].list));
					n->whenClause = (yyvsp[(14) - (20)].node);
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[(10) - (20)].ival), (yylsp[(10) - (20)]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					n->constrrel = (yyvsp[(9) - (20)].range);
					(yyval.node) = (Node *)n;
				}
    break;

  case 607:
/* Line 1787 of yacc.c  */
#line 4125 "gram.y"
    { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
    break;

  case 608:
/* Line 1787 of yacc.c  */
#line 4126 "gram.y"
    { (yyval.ival) = TRIGGER_TYPE_AFTER; }
    break;

  case 609:
/* Line 1787 of yacc.c  */
#line 4127 "gram.y"
    { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
    break;

  case 610:
/* Line 1787 of yacc.c  */
#line 4132 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 611:
/* Line 1787 of yacc.c  */
#line 4134 "gram.y"
    {
					int		events1 = intVal(linitial((yyvsp[(1) - (3)].list)));
					int		events2 = intVal(linitial((yyvsp[(3) - (3)].list)));
					List   *columns1 = (List *) lsecond((yyvsp[(1) - (3)].list));
					List   *columns2 = (List *) lsecond((yyvsp[(3) - (3)].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
    break;

  case 612:
/* Line 1787 of yacc.c  */
#line 4156 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
    break;

  case 613:
/* Line 1787 of yacc.c  */
#line 4158 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
    break;

  case 614:
/* Line 1787 of yacc.c  */
#line 4160 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
    break;

  case 615:
/* Line 1787 of yacc.c  */
#line 4162 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[(3) - (3)].list)); }
    break;

  case 616:
/* Line 1787 of yacc.c  */
#line 4164 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
    break;

  case 617:
/* Line 1787 of yacc.c  */
#line 4169 "gram.y"
    {
					(yyval.boolean) = (yyvsp[(3) - (3)].boolean);
				}
    break;

  case 618:
/* Line 1787 of yacc.c  */
#line 4173 "gram.y"
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = FALSE;
				}
    break;

  case 619:
/* Line 1787 of yacc.c  */
#line 4183 "gram.y"
    {}
    break;

  case 620:
/* Line 1787 of yacc.c  */
#line 4184 "gram.y"
    {}
    break;

  case 621:
/* Line 1787 of yacc.c  */
#line 4188 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 622:
/* Line 1787 of yacc.c  */
#line 4189 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 623:
/* Line 1787 of yacc.c  */
#line 4193 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (4)].node); }
    break;

  case 624:
/* Line 1787 of yacc.c  */
#line 4194 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 625:
/* Line 1787 of yacc.c  */
#line 4198 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].value)); }
    break;

  case 626:
/* Line 1787 of yacc.c  */
#line 4199 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].value)); }
    break;

  case 627:
/* Line 1787 of yacc.c  */
#line 4200 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 628:
/* Line 1787 of yacc.c  */
#line 4205 "gram.y"
    {
					char buf[64];
					snprintf(buf, sizeof(buf), "%d", (yyvsp[(1) - (1)].ival));
					(yyval.value) = makeString(pstrdup(buf));
				}
    break;

  case 629:
/* Line 1787 of yacc.c  */
#line 4210 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 630:
/* Line 1787 of yacc.c  */
#line 4211 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 631:
/* Line 1787 of yacc.c  */
#line 4212 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 632:
/* Line 1787 of yacc.c  */
#line 4216 "gram.y"
    { (yyval.range) = (yyvsp[(2) - (2)].range); }
    break;

  case 633:
/* Line 1787 of yacc.c  */
#line 4217 "gram.y"
    { (yyval.range) = NULL; }
    break;

  case 634:
/* Line 1787 of yacc.c  */
#line 4222 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 635:
/* Line 1787 of yacc.c  */
#line 4224 "gram.y"
    {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[(1) - (2)].ival) | (yyvsp[(2) - (2)].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[(2) - (2)]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[(2) - (2)]))));
					(yyval.ival) = newspec;
				}
    break;

  case 636:
/* Line 1787 of yacc.c  */
#line 4250 "gram.y"
    { (yyval.ival) = CAS_NOT_DEFERRABLE; }
    break;

  case 637:
/* Line 1787 of yacc.c  */
#line 4251 "gram.y"
    { (yyval.ival) = CAS_DEFERRABLE; }
    break;

  case 638:
/* Line 1787 of yacc.c  */
#line 4252 "gram.y"
    { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
    break;

  case 639:
/* Line 1787 of yacc.c  */
#line 4253 "gram.y"
    { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
    break;

  case 640:
/* Line 1787 of yacc.c  */
#line 4254 "gram.y"
    { (yyval.ival) = CAS_NOT_VALID; }
    break;

  case 641:
/* Line 1787 of yacc.c  */
#line 4255 "gram.y"
    { (yyval.ival) = CAS_NO_INHERIT; }
    break;

  case 642:
/* Line 1787 of yacc.c  */
#line 4261 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRIGGER;
					n->objects = list_make1(lappend((yyvsp[(5) - (6)].list), makeString((yyvsp[(3) - (6)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 643:
/* Line 1787 of yacc.c  */
#line 4272 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRIGGER;
					n->objects = list_make1(lappend((yyvsp[(7) - (8)].list), makeString((yyvsp[(5) - (8)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 644:
/* Line 1787 of yacc.c  */
#line 4296 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(3) - (8)].str);
					n->args = list_make1((yyvsp[(6) - (8)].node));
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[(8) - (8)].ival), (yylsp[(8) - (8)]), "ASSERTION",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);

					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = (Node *)n;
				}
    break;

  case 645:
/* Line 1787 of yacc.c  */
#line 4315 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = NIL;
					n->arguments = NIL;
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->removeType = OBJECT_TRIGGER; /* XXX */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("DROP ASSERTION is not yet implemented")));
					(yyval.node) = (Node *) n;
				}
    break;

  case 646:
/* Line 1787 of yacc.c  */
#line 4338 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->definition = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 647:
/* Line 1787 of yacc.c  */
#line 4348 "gram.y"
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 648:
/* Line 1787 of yacc.c  */
#line 4359 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 649:
/* Line 1787 of yacc.c  */
#line 4369 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 650:
/* Line 1787 of yacc.c  */
#line 4379 "gram.y"
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (3)].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 651:
/* Line 1787 of yacc.c  */
#line 4390 "gram.y"
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[(3) - (7)].list), (yylsp[(3) - (7)]), yyscanner);
					n->coldeflist = (yyvsp[(6) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 652:
/* Line 1787 of yacc.c  */
#line 4399 "gram.y"
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);
					n->typeName = (yyvsp[(3) - (8)].list);
					n->vals = (yyvsp[(7) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 653:
/* Line 1787 of yacc.c  */
#line 4406 "gram.y"
    {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);
					n->typeName = (yyvsp[(3) - (6)].list);
					n->params	= (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 654:
/* Line 1787 of yacc.c  */
#line 4413 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 655:
/* Line 1787 of yacc.c  */
#line 4422 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 656:
/* Line 1787 of yacc.c  */
#line 4431 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 657:
/* Line 1787 of yacc.c  */
#line 4440 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 658:
/* Line 1787 of yacc.c  */
#line 4449 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 659:
/* Line 1787 of yacc.c  */
#line 4458 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[(3) - (5)].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[(5) - (5)].list)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 660:
/* Line 1787 of yacc.c  */
#line 4468 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 661:
/* Line 1787 of yacc.c  */
#line 4471 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 662:
/* Line 1787 of yacc.c  */
#line 4472 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 663:
/* Line 1787 of yacc.c  */
#line 4476 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *) (yyvsp[(3) - (3)].node));
				}
    break;

  case 664:
/* Line 1787 of yacc.c  */
#line 4480 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (1)].str), NULL);
				}
    break;

  case 665:
/* Line 1787 of yacc.c  */
#line 4486 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].typnam); }
    break;

  case 666:
/* Line 1787 of yacc.c  */
#line 4487 "gram.y"
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[(1) - (1)].keyword))); }
    break;

  case 667:
/* Line 1787 of yacc.c  */
#line 4488 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].list); }
    break;

  case 668:
/* Line 1787 of yacc.c  */
#line 4489 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].value); }
    break;

  case 669:
/* Line 1787 of yacc.c  */
#line 4490 "gram.y"
    { (yyval.node) = (Node *)makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 670:
/* Line 1787 of yacc.c  */
#line 4493 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 671:
/* Line 1787 of yacc.c  */
#line 4494 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 672:
/* Line 1787 of yacc.c  */
#line 4497 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 673:
/* Line 1787 of yacc.c  */
#line 4500 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 674:
/* Line 1787 of yacc.c  */
#line 4501 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 675:
/* Line 1787 of yacc.c  */
#line 4510 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *)(yyvsp[(3) - (3)].node));
				}
    break;

  case 676:
/* Line 1787 of yacc.c  */
#line 4516 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 677:
/* Line 1787 of yacc.c  */
#line 4517 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 678:
/* Line 1787 of yacc.c  */
#line 4521 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 679:
/* Line 1787 of yacc.c  */
#line 4523 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 680:
/* Line 1787 of yacc.c  */
#line 4534 "gram.y"
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[(3) - (6)].list);
				n->newVal = (yyvsp[(6) - (6)].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				(yyval.node) = (Node *) n;
			}
    break;

  case 681:
/* Line 1787 of yacc.c  */
#line 4543 "gram.y"
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[(3) - (8)].list);
				n->newVal = (yyvsp[(6) - (8)].str);
				n->newValNeighbor = (yyvsp[(8) - (8)].str);
				n->newValIsAfter = false;
				(yyval.node) = (Node *) n;
			}
    break;

  case 682:
/* Line 1787 of yacc.c  */
#line 4552 "gram.y"
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[(3) - (8)].list);
				n->newVal = (yyvsp[(6) - (8)].str);
				n->newValNeighbor = (yyvsp[(8) - (8)].str);
				n->newValIsAfter = true;
				(yyval.node) = (Node *) n;
			}
    break;

  case 683:
/* Line 1787 of yacc.c  */
#line 4577 "gram.y"
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);
					n->opclassname = (yyvsp[(4) - (13)].list);
					n->isDefault = (yyvsp[(5) - (13)].boolean);
					n->datatype = (yyvsp[(8) - (13)].typnam);
					n->amname = (yyvsp[(10) - (13)].str);
					n->opfamilyname = (yyvsp[(11) - (13)].list);
					n->items = (yyvsp[(13) - (13)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 684:
/* Line 1787 of yacc.c  */
#line 4590 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 685:
/* Line 1787 of yacc.c  */
#line 4591 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 686:
/* Line 1787 of yacc.c  */
#line 4596 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = NIL;
					n->number = (yyvsp[(2) - (5)].ival);
					n->order_family = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 687:
/* Line 1787 of yacc.c  */
#line 4607 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[(3) - (6)].list);
					n->args = (yyvsp[(4) - (6)].list);
					n->number = (yyvsp[(2) - (6)].ival);
					n->order_family = (yyvsp[(5) - (6)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 688:
/* Line 1787 of yacc.c  */
#line 4617 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[(3) - (4)].list);
					n->args = extractArgTypes((yyvsp[(4) - (4)].list));
					n->number = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *) n;
				}
    break;

  case 689:
/* Line 1787 of yacc.c  */
#line 4626 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[(6) - (7)].list);
					n->args = extractArgTypes((yyvsp[(7) - (7)].list));
					n->number = (yyvsp[(2) - (7)].ival);
					n->class_args = (yyvsp[(4) - (7)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 690:
/* Line 1787 of yacc.c  */
#line 4636 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[(2) - (2)].typnam);
					(yyval.node) = (Node *) n;
				}
    break;

  case 691:
/* Line 1787 of yacc.c  */
#line 4644 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 692:
/* Line 1787 of yacc.c  */
#line 4645 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 693:
/* Line 1787 of yacc.c  */
#line 4648 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 694:
/* Line 1787 of yacc.c  */
#line 4649 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 695:
/* Line 1787 of yacc.c  */
#line 4652 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 696:
/* Line 1787 of yacc.c  */
#line 4653 "gram.y"
    { (yyval.list) = (yyvsp[(4) - (4)].list); }
    break;

  case 697:
/* Line 1787 of yacc.c  */
#line 4654 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 698:
/* Line 1787 of yacc.c  */
#line 4658 "gram.y"
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[(1) - (1)]))));
					(yyval.boolean) = TRUE;
				}
    break;

  case 699:
/* Line 1787 of yacc.c  */
#line 4671 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 700:
/* Line 1787 of yacc.c  */
#line 4677 "gram.y"
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (6)].list);
					n->amname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 701:
/* Line 1787 of yacc.c  */
#line 4687 "gram.y"
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (8)].list);
					n->amname = (yyvsp[(6) - (8)].str);
					n->isDrop = false;
					n->items = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 702:
/* Line 1787 of yacc.c  */
#line 4696 "gram.y"
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (8)].list);
					n->amname = (yyvsp[(6) - (8)].str);
					n->isDrop = true;
					n->items = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 703:
/* Line 1787 of yacc.c  */
#line 4707 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 704:
/* Line 1787 of yacc.c  */
#line 4708 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 705:
/* Line 1787 of yacc.c  */
#line 4713 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[(2) - (5)].ival);
					n->args = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 706:
/* Line 1787 of yacc.c  */
#line 4721 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[(2) - (5)].ival);
					n->args = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 707:
/* Line 1787 of yacc.c  */
#line 4733 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[(4) - (7)].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[(6) - (7)].str))));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 708:
/* Line 1787 of yacc.c  */
#line 4744 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[(6) - (9)].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[(8) - (9)].str))));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 709:
/* Line 1787 of yacc.c  */
#line 4758 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[(4) - (7)].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[(6) - (7)].str))));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 710:
/* Line 1787 of yacc.c  */
#line 4769 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[(6) - (9)].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[(8) - (9)].str))));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 711:
/* Line 1787 of yacc.c  */
#line 4792 "gram.y"
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);
					n->roles = (yyvsp[(4) - (5)].list);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 712:
/* Line 1787 of yacc.c  */
#line 4802 "gram.y"
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);
					n->roles = (yyvsp[(4) - (6)].list);
					n->newrole = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 713:
/* Line 1787 of yacc.c  */
#line 4820 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[(2) - (6)].objtype);
					n->missing_ok = TRUE;
					n->objects = (yyvsp[(5) - (6)].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 714:
/* Line 1787 of yacc.c  */
#line 4831 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[(2) - (4)].objtype);
					n->missing_ok = FALSE;
					n->objects = (yyvsp[(3) - (4)].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 715:
/* Line 1787 of yacc.c  */
#line 4842 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = FALSE;
					n->objects = (yyvsp[(4) - (5)].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 716:
/* Line 1787 of yacc.c  */
#line 4853 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = TRUE;
					n->objects = (yyvsp[(6) - (7)].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 717:
/* Line 1787 of yacc.c  */
#line 4866 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; }
    break;

  case 718:
/* Line 1787 of yacc.c  */
#line 4867 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; }
    break;

  case 719:
/* Line 1787 of yacc.c  */
#line 4868 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; }
    break;

  case 720:
/* Line 1787 of yacc.c  */
#line 4869 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; }
    break;

  case 721:
/* Line 1787 of yacc.c  */
#line 4870 "gram.y"
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
    break;

  case 722:
/* Line 1787 of yacc.c  */
#line 4871 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; }
    break;

  case 723:
/* Line 1787 of yacc.c  */
#line 4872 "gram.y"
    { (yyval.objtype) = OBJECT_DOMAIN; }
    break;

  case 724:
/* Line 1787 of yacc.c  */
#line 4873 "gram.y"
    { (yyval.objtype) = OBJECT_COLLATION; }
    break;

  case 725:
/* Line 1787 of yacc.c  */
#line 4874 "gram.y"
    { (yyval.objtype) = OBJECT_CONVERSION; }
    break;

  case 726:
/* Line 1787 of yacc.c  */
#line 4875 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; }
    break;

  case 727:
/* Line 1787 of yacc.c  */
#line 4876 "gram.y"
    { (yyval.objtype) = OBJECT_EXTENSION; }
    break;

  case 728:
/* Line 1787 of yacc.c  */
#line 4877 "gram.y"
    { (yyval.objtype) = OBJECT_TSPARSER; }
    break;

  case 729:
/* Line 1787 of yacc.c  */
#line 4878 "gram.y"
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
    break;

  case 730:
/* Line 1787 of yacc.c  */
#line 4879 "gram.y"
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
    break;

  case 731:
/* Line 1787 of yacc.c  */
#line 4880 "gram.y"
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
    break;

  case 732:
/* Line 1787 of yacc.c  */
#line 4884 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].list)); }
    break;

  case 733:
/* Line 1787 of yacc.c  */
#line 4885 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)); }
    break;

  case 734:
/* Line 1787 of yacc.c  */
#line 4888 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 735:
/* Line 1787 of yacc.c  */
#line 4889 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)); }
    break;

  case 736:
/* Line 1787 of yacc.c  */
#line 4893 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(2) - (2)].str))); }
    break;

  case 737:
/* Line 1787 of yacc.c  */
#line 4895 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 738:
/* Line 1787 of yacc.c  */
#line 4908 "gram.y"
    {
					TruncateStmt *n = makeNode(TruncateStmt);
					n->relations = (yyvsp[(3) - (5)].list);
					n->restart_seqs = (yyvsp[(4) - (5)].boolean);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 739:
/* Line 1787 of yacc.c  */
#line 4918 "gram.y"
    { (yyval.boolean) = false; }
    break;

  case 740:
/* Line 1787 of yacc.c  */
#line 4919 "gram.y"
    { (yyval.boolean) = true; }
    break;

  case 741:
/* Line 1787 of yacc.c  */
#line 4920 "gram.y"
    { (yyval.boolean) = false; }
    break;

  case 742:
/* Line 1787 of yacc.c  */
#line 4947 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[(3) - (6)].objtype);
					n->objname = (yyvsp[(4) - (6)].list);
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 743:
/* Line 1787 of yacc.c  */
#line 4956 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = (yyvsp[(5) - (7)].list);
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 744:
/* Line 1787 of yacc.c  */
#line 4965 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = extractArgTypes((yyvsp[(5) - (7)].list));
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 745:
/* Line 1787 of yacc.c  */
#line 4974 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = (yyvsp[(5) - (7)].list);
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 746:
/* Line 1787 of yacc.c  */
#line 4983 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CONSTRAINT;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 747:
/* Line 1787 of yacc.c  */
#line 4992 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 748:
/* Line 1787 of yacc.c  */
#line 5001 "gram.y"
    {
					/* Obsolete syntax supported for awhile for compatibility */
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = list_make1(makeString((yyvsp[(4) - (6)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 749:
/* Line 1787 of yacc.c  */
#line 5011 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRIGGER;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 750:
/* Line 1787 of yacc.c  */
#line 5020 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPCLASS;
					n->objname = (yyvsp[(5) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(7) - (9)].str)));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 751:
/* Line 1787 of yacc.c  */
#line 5029 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = (yyvsp[(5) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(7) - (9)].str)));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 752:
/* Line 1787 of yacc.c  */
#line 5038 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[(5) - (7)].value));
					n->objargs = NIL;
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 753:
/* Line 1787 of yacc.c  */
#line 5047 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[(5) - (10)].typnam));
					n->objargs = list_make1((yyvsp[(7) - (10)].typnam));
					n->comment = (yyvsp[(10) - (10)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 754:
/* Line 1787 of yacc.c  */
#line 5056 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[(5) - (7)].list);
					n->objargs = NIL;
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 755:
/* Line 1787 of yacc.c  */
#line 5065 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSPARSER;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 756:
/* Line 1787 of yacc.c  */
#line 5073 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSDICTIONARY;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 757:
/* Line 1787 of yacc.c  */
#line 5081 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSTEMPLATE;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 758:
/* Line 1787 of yacc.c  */
#line 5089 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSCONFIGURATION;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 759:
/* Line 1787 of yacc.c  */
#line 5099 "gram.y"
    { (yyval.objtype) = OBJECT_COLUMN; }
    break;

  case 760:
/* Line 1787 of yacc.c  */
#line 5100 "gram.y"
    { (yyval.objtype) = OBJECT_DATABASE; }
    break;

  case 761:
/* Line 1787 of yacc.c  */
#line 5101 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; }
    break;

  case 762:
/* Line 1787 of yacc.c  */
#line 5102 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; }
    break;

  case 763:
/* Line 1787 of yacc.c  */
#line 5103 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; }
    break;

  case 764:
/* Line 1787 of yacc.c  */
#line 5104 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; }
    break;

  case 765:
/* Line 1787 of yacc.c  */
#line 5105 "gram.y"
    { (yyval.objtype) = OBJECT_DOMAIN; }
    break;

  case 766:
/* Line 1787 of yacc.c  */
#line 5106 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; }
    break;

  case 767:
/* Line 1787 of yacc.c  */
#line 5107 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; }
    break;

  case 768:
/* Line 1787 of yacc.c  */
#line 5108 "gram.y"
    { (yyval.objtype) = OBJECT_COLLATION; }
    break;

  case 769:
/* Line 1787 of yacc.c  */
#line 5109 "gram.y"
    { (yyval.objtype) = OBJECT_CONVERSION; }
    break;

  case 770:
/* Line 1787 of yacc.c  */
#line 5110 "gram.y"
    { (yyval.objtype) = OBJECT_TABLESPACE; }
    break;

  case 771:
/* Line 1787 of yacc.c  */
#line 5111 "gram.y"
    { (yyval.objtype) = OBJECT_EXTENSION; }
    break;

  case 772:
/* Line 1787 of yacc.c  */
#line 5112 "gram.y"
    { (yyval.objtype) = OBJECT_ROLE; }
    break;

  case 773:
/* Line 1787 of yacc.c  */
#line 5113 "gram.y"
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
    break;

  case 774:
/* Line 1787 of yacc.c  */
#line 5114 "gram.y"
    { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
    break;

  case 775:
/* Line 1787 of yacc.c  */
#line 5115 "gram.y"
    { (yyval.objtype) = OBJECT_FDW; }
    break;

  case 776:
/* Line 1787 of yacc.c  */
#line 5119 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 777:
/* Line 1787 of yacc.c  */
#line 5120 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 778:
/* Line 1787 of yacc.c  */
#line 5136 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (8)].str);
					n->objtype = (yyvsp[(5) - (8)].objtype);
					n->objname = (yyvsp[(6) - (8)].list);
					n->objargs = NIL;
					n->label = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 779:
/* Line 1787 of yacc.c  */
#line 5147 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (9)].str);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[(6) - (9)].list);
					n->objargs = (yyvsp[(7) - (9)].list);
					n->label = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 780:
/* Line 1787 of yacc.c  */
#line 5158 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (9)].str);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[(6) - (9)].list);
					n->objargs = extractArgTypes((yyvsp[(7) - (9)].list));
					n->label = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 781:
/* Line 1787 of yacc.c  */
#line 5169 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (9)].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[(7) - (9)].value));
					n->objargs = NIL;
					n->label = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 782:
/* Line 1787 of yacc.c  */
#line 5180 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (9)].str);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[(7) - (9)].list);
					n->objargs = NIL;
					n->label = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 783:
/* Line 1787 of yacc.c  */
#line 5191 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 784:
/* Line 1787 of yacc.c  */
#line 5192 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 785:
/* Line 1787 of yacc.c  */
#line 5196 "gram.y"
    { (yyval.objtype) = OBJECT_COLUMN; }
    break;

  case 786:
/* Line 1787 of yacc.c  */
#line 5197 "gram.y"
    { (yyval.objtype) = OBJECT_DATABASE; }
    break;

  case 787:
/* Line 1787 of yacc.c  */
#line 5198 "gram.y"
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
    break;

  case 788:
/* Line 1787 of yacc.c  */
#line 5199 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; }
    break;

  case 789:
/* Line 1787 of yacc.c  */
#line 5200 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; }
    break;

  case 790:
/* Line 1787 of yacc.c  */
#line 5201 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; }
    break;

  case 791:
/* Line 1787 of yacc.c  */
#line 5202 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; }
    break;

  case 792:
/* Line 1787 of yacc.c  */
#line 5203 "gram.y"
    { (yyval.objtype) = OBJECT_ROLE; }
    break;

  case 793:
/* Line 1787 of yacc.c  */
#line 5204 "gram.y"
    { (yyval.objtype) = OBJECT_TABLESPACE; }
    break;

  case 794:
/* Line 1787 of yacc.c  */
#line 5205 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; }
    break;

  case 795:
/* Line 1787 of yacc.c  */
#line 5206 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; }
    break;

  case 796:
/* Line 1787 of yacc.c  */
#line 5209 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 797:
/* Line 1787 of yacc.c  */
#line 5210 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 798:
/* Line 1787 of yacc.c  */
#line 5221 "gram.y"
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[(2) - (2)].node);
					n->ismove = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 799:
/* Line 1787 of yacc.c  */
#line 5227 "gram.y"
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[(2) - (2)].node);
					n->ismove = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 800:
/* Line 1787 of yacc.c  */
#line 5235 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(1) - (1)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 801:
/* Line 1787 of yacc.c  */
#line 5243 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(2) - (2)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 802:
/* Line 1787 of yacc.c  */
#line 5251 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 803:
/* Line 1787 of yacc.c  */
#line 5259 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 804:
/* Line 1787 of yacc.c  */
#line 5267 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 805:
/* Line 1787 of yacc.c  */
#line 5275 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 806:
/* Line 1787 of yacc.c  */
#line 5283 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 807:
/* Line 1787 of yacc.c  */
#line 5291 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 808:
/* Line 1787 of yacc.c  */
#line 5299 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[(1) - (3)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 809:
/* Line 1787 of yacc.c  */
#line 5307 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 810:
/* Line 1787 of yacc.c  */
#line 5315 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 811:
/* Line 1787 of yacc.c  */
#line 5323 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 812:
/* Line 1787 of yacc.c  */
#line 5331 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 813:
/* Line 1787 of yacc.c  */
#line 5339 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 814:
/* Line 1787 of yacc.c  */
#line 5347 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 815:
/* Line 1787 of yacc.c  */
#line 5355 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 816:
/* Line 1787 of yacc.c  */
#line 5364 "gram.y"
    {}
    break;

  case 817:
/* Line 1787 of yacc.c  */
#line 5365 "gram.y"
    {}
    break;

  case 818:
/* Line 1787 of yacc.c  */
#line 5368 "gram.y"
    {}
    break;

  case 819:
/* Line 1787 of yacc.c  */
#line 5369 "gram.y"
    {}
    break;

  case 820:
/* Line 1787 of yacc.c  */
#line 5381 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ((yyvsp[(4) - (7)].privtarget))->targtype;
					n->objtype = ((yyvsp[(4) - (7)].privtarget))->objtype;
					n->objects = ((yyvsp[(4) - (7)].privtarget))->objs;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->grant_option = (yyvsp[(7) - (7)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 821:
/* Line 1787 of yacc.c  */
#line 5397 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ((yyvsp[(4) - (7)].privtarget))->targtype;
					n->objtype = ((yyvsp[(4) - (7)].privtarget))->objtype;
					n->objects = ((yyvsp[(4) - (7)].privtarget))->objs;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 822:
/* Line 1787 of yacc.c  */
#line 5411 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[(5) - (10)].list);
					n->targtype = ((yyvsp[(7) - (10)].privtarget))->targtype;
					n->objtype = ((yyvsp[(7) - (10)].privtarget))->objtype;
					n->objects = ((yyvsp[(7) - (10)].privtarget))->objs;
					n->grantees = (yyvsp[(9) - (10)].list);
					n->behavior = (yyvsp[(10) - (10)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 823:
/* Line 1787 of yacc.c  */
#line 5436 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 824:
/* Line 1787 of yacc.c  */
#line 5438 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 825:
/* Line 1787 of yacc.c  */
#line 5440 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 826:
/* Line 1787 of yacc.c  */
#line 5442 "gram.y"
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[(3) - (4)].list);
					(yyval.list) = list_make1(n);
				}
    break;

  case 827:
/* Line 1787 of yacc.c  */
#line 5449 "gram.y"
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[(4) - (5)].list);
					(yyval.list) = list_make1(n);
				}
    break;

  case 828:
/* Line 1787 of yacc.c  */
#line 5457 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].accesspriv)); }
    break;

  case 829:
/* Line 1787 of yacc.c  */
#line 5458 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].accesspriv)); }
    break;

  case 830:
/* Line 1787 of yacc.c  */
#line 5462 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			}
    break;

  case 831:
/* Line 1787 of yacc.c  */
#line 5469 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			}
    break;

  case 832:
/* Line 1787 of yacc.c  */
#line 5476 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			}
    break;

  case 833:
/* Line 1787 of yacc.c  */
#line 5483 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = (yyvsp[(1) - (2)].str);
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			}
    break;

  case 834:
/* Line 1787 of yacc.c  */
#line 5497 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(1) - (1)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 835:
/* Line 1787 of yacc.c  */
#line 5505 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 836:
/* Line 1787 of yacc.c  */
#line 5513 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 837:
/* Line 1787 of yacc.c  */
#line 5521 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FDW;
					n->objs = (yyvsp[(4) - (4)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 838:
/* Line 1787 of yacc.c  */
#line 5529 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[(3) - (3)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 839:
/* Line 1787 of yacc.c  */
#line 5537 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 840:
/* Line 1787 of yacc.c  */
#line 5545 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DATABASE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 841:
/* Line 1787 of yacc.c  */
#line 5553 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DOMAIN;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 842:
/* Line 1787 of yacc.c  */
#line 5561 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LANGUAGE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 843:
/* Line 1787 of yacc.c  */
#line 5569 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[(3) - (3)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 844:
/* Line 1787 of yacc.c  */
#line 5577 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_NAMESPACE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 845:
/* Line 1787 of yacc.c  */
#line 5585 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TABLESPACE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 846:
/* Line 1787 of yacc.c  */
#line 5593 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TYPE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 847:
/* Line 1787 of yacc.c  */
#line 5601 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 848:
/* Line 1787 of yacc.c  */
#line 5609 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 849:
/* Line 1787 of yacc.c  */
#line 5617 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 850:
/* Line 1787 of yacc.c  */
#line 5628 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 851:
/* Line 1787 of yacc.c  */
#line 5629 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 852:
/* Line 1787 of yacc.c  */
#line 5633 "gram.y"
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* This hack lets us avoid reserving PUBLIC as a keyword*/
					if (strcmp((yyvsp[(1) - (1)].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[(1) - (1)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 853:
/* Line 1787 of yacc.c  */
#line 5643 "gram.y"
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* Treat GROUP PUBLIC as a synonym for PUBLIC */
					if (strcmp((yyvsp[(2) - (2)].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 854:
/* Line 1787 of yacc.c  */
#line 5656 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 855:
/* Line 1787 of yacc.c  */
#line 5657 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 856:
/* Line 1787 of yacc.c  */
#line 5661 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].funwithargs)); }
    break;

  case 857:
/* Line 1787 of yacc.c  */
#line 5663 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].funwithargs)); }
    break;

  case 858:
/* Line 1787 of yacc.c  */
#line 5668 "gram.y"
    {
					FuncWithArgs *n = makeNode(FuncWithArgs);
					n->funcname = (yyvsp[(1) - (2)].list);
					n->funcargs = extractArgTypes((yyvsp[(2) - (2)].list));
					(yyval.funwithargs) = n;
				}
    break;

  case 859:
/* Line 1787 of yacc.c  */
#line 5684 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = true;
					n->granted_roles = (yyvsp[(2) - (6)].list);
					n->grantee_roles = (yyvsp[(4) - (6)].list);
					n->admin_opt = (yyvsp[(5) - (6)].boolean);
					n->grantor = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node*)n;
				}
    break;

  case 860:
/* Line 1787 of yacc.c  */
#line 5697 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[(2) - (6)].list);
					n->grantee_roles = (yyvsp[(4) - (6)].list);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node*)n;
				}
    break;

  case 861:
/* Line 1787 of yacc.c  */
#line 5707 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[(5) - (9)].list);
					n->grantee_roles = (yyvsp[(7) - (9)].list);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					(yyval.node) = (Node*)n;
				}
    break;

  case 862:
/* Line 1787 of yacc.c  */
#line 5718 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 863:
/* Line 1787 of yacc.c  */
#line 5719 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 864:
/* Line 1787 of yacc.c  */
#line 5722 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); }
    break;

  case 865:
/* Line 1787 of yacc.c  */
#line 5723 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 866:
/* Line 1787 of yacc.c  */
#line 5734 "gram.y"
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);
					n->options = (yyvsp[(4) - (5)].list);
					n->action = (GrantStmt *) (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node*)n;
				}
    break;

  case 867:
/* Line 1787 of yacc.c  */
#line 5743 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 868:
/* Line 1787 of yacc.c  */
#line 5744 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 869:
/* Line 1787 of yacc.c  */
#line 5749 "gram.y"
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 870:
/* Line 1787 of yacc.c  */
#line 5753 "gram.y"
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 871:
/* Line 1787 of yacc.c  */
#line 5757 "gram.y"
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 872:
/* Line 1787 of yacc.c  */
#line 5769 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(4) - (7)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->grant_option = (yyvsp[(7) - (7)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 873:
/* Line 1787 of yacc.c  */
#line 5782 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(4) - (7)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 874:
/* Line 1787 of yacc.c  */
#line 5796 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[(5) - (10)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(7) - (10)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(9) - (10)].list);
					n->behavior = (yyvsp[(10) - (10)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 875:
/* Line 1787 of yacc.c  */
#line 5811 "gram.y"
    { (yyval.ival) = ACL_OBJECT_RELATION; }
    break;

  case 876:
/* Line 1787 of yacc.c  */
#line 5812 "gram.y"
    { (yyval.ival) = ACL_OBJECT_FUNCTION; }
    break;

  case 877:
/* Line 1787 of yacc.c  */
#line 5813 "gram.y"
    { (yyval.ival) = ACL_OBJECT_SEQUENCE; }
    break;

  case 878:
/* Line 1787 of yacc.c  */
#line 5814 "gram.y"
    { (yyval.ival) = ACL_OBJECT_TYPE; }
    break;

  case 879:
/* Line 1787 of yacc.c  */
#line 5829 "gram.y"
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[(2) - (14)].boolean);
					n->concurrent = (yyvsp[(4) - (14)].boolean);
					n->idxname = (yyvsp[(5) - (14)].str);
					n->relation = (yyvsp[(7) - (14)].range);
					n->accessMethod = (yyvsp[(8) - (14)].str);
					n->indexParams = (yyvsp[(10) - (14)].list);
					n->options = (yyvsp[(12) - (14)].list);
					n->tableSpace = (yyvsp[(13) - (14)].str);
					n->whereClause = (yyvsp[(14) - (14)].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 880:
/* Line 1787 of yacc.c  */
#line 5853 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 881:
/* Line 1787 of yacc.c  */
#line 5854 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 882:
/* Line 1787 of yacc.c  */
#line 5858 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 883:
/* Line 1787 of yacc.c  */
#line 5859 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 884:
/* Line 1787 of yacc.c  */
#line 5863 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 885:
/* Line 1787 of yacc.c  */
#line 5864 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 886:
/* Line 1787 of yacc.c  */
#line 5868 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 887:
/* Line 1787 of yacc.c  */
#line 5869 "gram.y"
    { (yyval.str) = DEFAULT_INDEX_TYPE; }
    break;

  case 888:
/* Line 1787 of yacc.c  */
#line 5872 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].ielem)); }
    break;

  case 889:
/* Line 1787 of yacc.c  */
#line 5873 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].ielem)); }
    break;

  case 890:
/* Line 1787 of yacc.c  */
#line 5882 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = (yyvsp[(1) - (5)].str);
					(yyval.ielem)->expr = NULL;
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[(2) - (5)].list);
					(yyval.ielem)->opclass = (yyvsp[(3) - (5)].list);
					(yyval.ielem)->ordering = (yyvsp[(4) - (5)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(5) - (5)].ival);
				}
    break;

  case 891:
/* Line 1787 of yacc.c  */
#line 5893 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[(1) - (5)].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[(2) - (5)].list);
					(yyval.ielem)->opclass = (yyvsp[(3) - (5)].list);
					(yyval.ielem)->ordering = (yyvsp[(4) - (5)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(5) - (5)].ival);
				}
    break;

  case 892:
/* Line 1787 of yacc.c  */
#line 5904 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[(2) - (7)].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[(4) - (7)].list);
					(yyval.ielem)->opclass = (yyvsp[(5) - (7)].list);
					(yyval.ielem)->ordering = (yyvsp[(6) - (7)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(7) - (7)].ival);
				}
    break;

  case 893:
/* Line 1787 of yacc.c  */
#line 5916 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 894:
/* Line 1787 of yacc.c  */
#line 5917 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 895:
/* Line 1787 of yacc.c  */
#line 5920 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 896:
/* Line 1787 of yacc.c  */
#line 5921 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 897:
/* Line 1787 of yacc.c  */
#line 5922 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 898:
/* Line 1787 of yacc.c  */
#line 5925 "gram.y"
    { (yyval.ival) = SORTBY_ASC; }
    break;

  case 899:
/* Line 1787 of yacc.c  */
#line 5926 "gram.y"
    { (yyval.ival) = SORTBY_DESC; }
    break;

  case 900:
/* Line 1787 of yacc.c  */
#line 5927 "gram.y"
    { (yyval.ival) = SORTBY_DEFAULT; }
    break;

  case 901:
/* Line 1787 of yacc.c  */
#line 5930 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_FIRST; }
    break;

  case 902:
/* Line 1787 of yacc.c  */
#line 5931 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_LAST; }
    break;

  case 903:
/* Line 1787 of yacc.c  */
#line 5932 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
    break;

  case 904:
/* Line 1787 of yacc.c  */
#line 5950 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (9)].boolean);
					n->funcname = (yyvsp[(4) - (9)].list);
					n->parameters = (yyvsp[(5) - (9)].list);
					n->returnType = (yyvsp[(7) - (9)].typnam);
					n->options = (yyvsp[(8) - (9)].list);
					n->withClause = (yyvsp[(9) - (9)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 905:
/* Line 1787 of yacc.c  */
#line 5962 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (12)].boolean);
					n->funcname = (yyvsp[(4) - (12)].list);
					n->parameters = mergeTableFuncParameters((yyvsp[(5) - (12)].list), (yyvsp[(9) - (12)].list));
					n->returnType = TableFuncTypeName((yyvsp[(9) - (12)].list));
					n->returnType->location = (yylsp[(7) - (12)]);
					n->options = (yyvsp[(11) - (12)].list);
					n->withClause = (yyvsp[(12) - (12)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 906:
/* Line 1787 of yacc.c  */
#line 5975 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (7)].boolean);
					n->funcname = (yyvsp[(4) - (7)].list);
					n->parameters = (yyvsp[(5) - (7)].list);
					n->returnType = NULL;
					n->options = (yyvsp[(6) - (7)].list);
					n->withClause = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 907:
/* Line 1787 of yacc.c  */
#line 5988 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 908:
/* Line 1787 of yacc.c  */
#line 5989 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 909:
/* Line 1787 of yacc.c  */
#line 5992 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 910:
/* Line 1787 of yacc.c  */
#line 5993 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 911:
/* Line 1787 of yacc.c  */
#line 5997 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); }
    break;

  case 912:
/* Line 1787 of yacc.c  */
#line 5998 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); }
    break;

  case 913:
/* Line 1787 of yacc.c  */
#line 6006 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 914:
/* Line 1787 of yacc.c  */
#line 6007 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 915:
/* Line 1787 of yacc.c  */
#line 6011 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); }
    break;

  case 916:
/* Line 1787 of yacc.c  */
#line 6013 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); }
    break;

  case 917:
/* Line 1787 of yacc.c  */
#line 6028 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(2) - (3)].str);
					n->argType = (yyvsp[(3) - (3)].typnam);
					n->mode = (yyvsp[(1) - (3)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 918:
/* Line 1787 of yacc.c  */
#line 6037 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (3)].str);
					n->argType = (yyvsp[(3) - (3)].typnam);
					n->mode = (yyvsp[(2) - (3)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 919:
/* Line 1787 of yacc.c  */
#line 6046 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (2)].str);
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 920:
/* Line 1787 of yacc.c  */
#line 6055 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = (yyvsp[(1) - (2)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 921:
/* Line 1787 of yacc.c  */
#line 6064 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[(1) - (1)].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 922:
/* Line 1787 of yacc.c  */
#line 6075 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
    break;

  case 923:
/* Line 1787 of yacc.c  */
#line 6076 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
    break;

  case 924:
/* Line 1787 of yacc.c  */
#line 6077 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
    break;

  case 925:
/* Line 1787 of yacc.c  */
#line 6078 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
    break;

  case 926:
/* Line 1787 of yacc.c  */
#line 6079 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
    break;

  case 928:
/* Line 1787 of yacc.c  */
#line 6090 "gram.y"
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 929:
/* Line 1787 of yacc.c  */
#line 6104 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 930:
/* Line 1787 of yacc.c  */
#line 6106 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(1) - (4)].str)), (yyvsp[(2) - (4)].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[(1) - (4)]);
				}
    break;

  case 931:
/* Line 1787 of yacc.c  */
#line 6112 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(2) - (5)].str)), (yyvsp[(3) - (5)].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = TRUE;
					(yyval.typnam)->location = (yylsp[(2) - (5)]);
				}
    break;

  case 932:
/* Line 1787 of yacc.c  */
#line 6122 "gram.y"
    {
					(yyval.fun_param) = (yyvsp[(1) - (1)].fun_param);
				}
    break;

  case 933:
/* Line 1787 of yacc.c  */
#line 6126 "gram.y"
    {
					(yyval.fun_param) = (yyvsp[(1) - (3)].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[(3) - (3)].node);
				}
    break;

  case 934:
/* Line 1787 of yacc.c  */
#line 6131 "gram.y"
    {
					(yyval.fun_param) = (yyvsp[(1) - (3)].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[(3) - (3)].node);
				}
    break;

  case 935:
/* Line 1787 of yacc.c  */
#line 6140 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 936:
/* Line 1787 of yacc.c  */
#line 6141 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 937:
/* Line 1787 of yacc.c  */
#line 6149 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(FALSE));
				}
    break;

  case 938:
/* Line 1787 of yacc.c  */
#line 6153 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
    break;

  case 939:
/* Line 1787 of yacc.c  */
#line 6157 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
    break;

  case 940:
/* Line 1787 of yacc.c  */
#line 6161 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("immutable"));
				}
    break;

  case 941:
/* Line 1787 of yacc.c  */
#line 6165 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("stable"));
				}
    break;

  case 942:
/* Line 1787 of yacc.c  */
#line 6169 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("volatile"));
				}
    break;

  case 943:
/* Line 1787 of yacc.c  */
#line 6173 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
    break;

  case 944:
/* Line 1787 of yacc.c  */
#line 6177 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
    break;

  case 945:
/* Line 1787 of yacc.c  */
#line 6181 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
    break;

  case 946:
/* Line 1787 of yacc.c  */
#line 6185 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
    break;

  case 947:
/* Line 1787 of yacc.c  */
#line 6189 "gram.y"
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(TRUE));
				}
    break;

  case 948:
/* Line 1787 of yacc.c  */
#line 6193 "gram.y"
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(FALSE));
				}
    break;

  case 949:
/* Line 1787 of yacc.c  */
#line 6197 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cost", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 950:
/* Line 1787 of yacc.c  */
#line 6201 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rows", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 951:
/* Line 1787 of yacc.c  */
#line 6205 "gram.y"
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *)(yyvsp[(1) - (1)].vsetstmt));
				}
    break;

  case 952:
/* Line 1787 of yacc.c  */
#line 6213 "gram.y"
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 953:
/* Line 1787 of yacc.c  */
#line 6217 "gram.y"
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 954:
/* Line 1787 of yacc.c  */
#line 6221 "gram.y"
    {
					(yyval.defelt) = makeDefElem("window", (Node *)makeInteger(TRUE));
				}
    break;

  case 955:
/* Line 1787 of yacc.c  */
#line 6225 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(1) - (1)].defelt);
				}
    break;

  case 956:
/* Line 1787 of yacc.c  */
#line 6230 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 957:
/* Line 1787 of yacc.c  */
#line 6232 "gram.y"
    {
					(yyval.list) = list_make2(makeString((yyvsp[(1) - (3)].str)), makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 958:
/* Line 1787 of yacc.c  */
#line 6238 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 959:
/* Line 1787 of yacc.c  */
#line 6239 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 960:
/* Line 1787 of yacc.c  */
#line 6243 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (2)].str);
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 961:
/* Line 1787 of yacc.c  */
#line 6255 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param));
				}
    break;

  case 962:
/* Line 1787 of yacc.c  */
#line 6259 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param));
				}
    break;

  case 963:
/* Line 1787 of yacc.c  */
#line 6274 "gram.y"
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->func = (yyvsp[(3) - (5)].funwithargs);
					n->actions = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 964:
/* Line 1787 of yacc.c  */
#line 6284 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 965:
/* Line 1787 of yacc.c  */
#line 6285 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 968:
/* Line 1787 of yacc.c  */
#line 6307 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = list_make1((yyvsp[(3) - (5)].list));
					n->arguments = list_make1(extractArgTypes((yyvsp[(4) - (5)].list)));
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 969:
/* Line 1787 of yacc.c  */
#line 6318 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = list_make1((yyvsp[(5) - (7)].list));
					n->arguments = list_make1(extractArgTypes((yyvsp[(6) - (7)].list)));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 970:
/* Line 1787 of yacc.c  */
#line 6332 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = list_make1((yyvsp[(3) - (5)].list));
					n->arguments = list_make1((yyvsp[(4) - (5)].list));
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 971:
/* Line 1787 of yacc.c  */
#line 6343 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = list_make1((yyvsp[(5) - (7)].list));
					n->arguments = list_make1((yyvsp[(6) - (7)].list));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 972:
/* Line 1787 of yacc.c  */
#line 6357 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = list_make1((yyvsp[(3) - (5)].list));
					n->arguments = list_make1((yyvsp[(4) - (5)].list));
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 973:
/* Line 1787 of yacc.c  */
#line 6368 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = list_make1((yyvsp[(5) - (7)].list));
					n->arguments = list_make1((yyvsp[(6) - (7)].list));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 974:
/* Line 1787 of yacc.c  */
#line 6382 "gram.y"
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[(3) - (3)]))));
				}
    break;

  case 975:
/* Line 1787 of yacc.c  */
#line 6390 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (5)].typnam), (yyvsp[(4) - (5)].typnam)); }
    break;

  case 976:
/* Line 1787 of yacc.c  */
#line 6392 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(4) - (5)].typnam)); }
    break;

  case 977:
/* Line 1787 of yacc.c  */
#line 6394 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (5)].typnam), NULL); }
    break;

  case 978:
/* Line 1787 of yacc.c  */
#line 6399 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 979:
/* Line 1787 of yacc.c  */
#line 6401 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (3)].str)), (yyvsp[(3) - (3)].list)); }
    break;

  case 980:
/* Line 1787 of yacc.c  */
#line 6414 "gram.y"
    {
					DoStmt *n = makeNode(DoStmt);
					n->args = (yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 981:
/* Line 1787 of yacc.c  */
#line 6422 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 982:
/* Line 1787 of yacc.c  */
#line 6423 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 983:
/* Line 1787 of yacc.c  */
#line 6428 "gram.y"
    {
					(yyval.defelt) = makeDefElem("as", (Node *)makeString((yyvsp[(1) - (1)].str)));
				}
    break;

  case 984:
/* Line 1787 of yacc.c  */
#line 6432 "gram.y"
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 985:
/* Line 1787 of yacc.c  */
#line 6445 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (11)].typnam);
					n->targettype = (yyvsp[(6) - (11)].typnam);
					n->func = (yyvsp[(10) - (11)].funwithargs);
					n->context = (CoercionContext) (yyvsp[(11) - (11)].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 986:
/* Line 1787 of yacc.c  */
#line 6456 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (10)].typnam);
					n->targettype = (yyvsp[(6) - (10)].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[(10) - (10)].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 987:
/* Line 1787 of yacc.c  */
#line 6467 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (10)].typnam);
					n->targettype = (yyvsp[(6) - (10)].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[(10) - (10)].ival);
					n->inout = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 988:
/* Line 1787 of yacc.c  */
#line 6478 "gram.y"
    { (yyval.ival) = COERCION_IMPLICIT; }
    break;

  case 989:
/* Line 1787 of yacc.c  */
#line 6479 "gram.y"
    { (yyval.ival) = COERCION_ASSIGNMENT; }
    break;

  case 990:
/* Line 1787 of yacc.c  */
#line 6480 "gram.y"
    { (yyval.ival) = COERCION_EXPLICIT; }
    break;

  case 991:
/* Line 1787 of yacc.c  */
#line 6485 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make1((yyvsp[(5) - (9)].typnam)));
					n->arguments = list_make1(list_make1((yyvsp[(7) - (9)].typnam)));
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = (yyvsp[(3) - (9)].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 992:
/* Line 1787 of yacc.c  */
#line 6497 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 993:
/* Line 1787 of yacc.c  */
#line 6498 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 994:
/* Line 1787 of yacc.c  */
#line 6513 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[(2) - (4)].objtype);
					n->relation = (yyvsp[(3) - (4)].range);
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 995:
/* Line 1787 of yacc.c  */
#line 6521 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[(3) - (4)].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 996:
/* Line 1787 of yacc.c  */
#line 6531 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[(3) - (4)].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 997:
/* Line 1787 of yacc.c  */
#line 6543 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; }
    break;

  case 998:
/* Line 1787 of yacc.c  */
#line 6544 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; }
    break;

  case 999:
/* Line 1787 of yacc.c  */
#line 6547 "gram.y"
    {  (yyval.boolean) = TRUE; }
    break;

  case 1000:
/* Line 1787 of yacc.c  */
#line 6548 "gram.y"
    {  (yyval.boolean) = FALSE; }
    break;

  case 1001:
/* Line 1787 of yacc.c  */
#line 6559 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newname = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1002:
/* Line 1787 of yacc.c  */
#line 6569 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLLATION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1003:
/* Line 1787 of yacc.c  */
#line 6578 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1004:
/* Line 1787 of yacc.c  */
#line 6587 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1005:
/* Line 1787 of yacc.c  */
#line 6596 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1006:
/* Line 1787 of yacc.c  */
#line 6605 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONSTRAINT;
					n->relationType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (8)].list);
					n->subname = (yyvsp[(6) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1007:
/* Line 1787 of yacc.c  */
#line 6615 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FDW;
					n->subname = (yyvsp[(5) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1008:
/* Line 1787 of yacc.c  */
#line 6624 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1009:
/* Line 1787 of yacc.c  */
#line 6634 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1010:
/* Line 1787 of yacc.c  */
#line 6643 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_LANGUAGE;
					n->subname = (yyvsp[(4) - (7)].str);
					n->newname = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1011:
/* Line 1787 of yacc.c  */
#line 6652 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPCLASS;
					n->object = (yyvsp[(4) - (9)].list);
					n->subname = (yyvsp[(6) - (9)].str);
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1012:
/* Line 1787 of yacc.c  */
#line 6662 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPFAMILY;
					n->object = (yyvsp[(4) - (9)].list);
					n->subname = (yyvsp[(6) - (9)].str);
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1013:
/* Line 1787 of yacc.c  */
#line 6672 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1014:
/* Line 1787 of yacc.c  */
#line 6681 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_SERVER;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1015:
/* Line 1787 of yacc.c  */
#line 6690 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1016:
/* Line 1787 of yacc.c  */
#line 6700 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1017:
/* Line 1787 of yacc.c  */
#line 6710 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1018:
/* Line 1787 of yacc.c  */
#line 6720 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1019:
/* Line 1787 of yacc.c  */
#line 6730 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1020:
/* Line 1787 of yacc.c  */
#line 6740 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1021:
/* Line 1787 of yacc.c  */
#line 6750 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1022:
/* Line 1787 of yacc.c  */
#line 6760 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1023:
/* Line 1787 of yacc.c  */
#line 6770 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(4) - (7)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1024:
/* Line 1787 of yacc.c  */
#line 6780 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(6) - (9)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1025:
/* Line 1787 of yacc.c  */
#line 6790 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (8)].range);
					n->subname = (yyvsp[(6) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1026:
/* Line 1787 of yacc.c  */
#line 6801 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[(5) - (10)].range);
					n->subname = (yyvsp[(8) - (10)].str);
					n->newname = (yyvsp[(10) - (10)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1027:
/* Line 1787 of yacc.c  */
#line 6812 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONSTRAINT;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (8)].range);
					n->subname = (yyvsp[(6) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1028:
/* Line 1787 of yacc.c  */
#line 6822 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(4) - (9)].range);
					n->subname = (yyvsp[(7) - (9)].str);
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1029:
/* Line 1787 of yacc.c  */
#line 6833 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(6) - (11)].range);
					n->subname = (yyvsp[(9) - (11)].str);
					n->newname = (yyvsp[(11) - (11)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1030:
/* Line 1787 of yacc.c  */
#line 6844 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = (yyvsp[(3) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1031:
/* Line 1787 of yacc.c  */
#line 6854 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1032:
/* Line 1787 of yacc.c  */
#line 6863 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1033:
/* Line 1787 of yacc.c  */
#line 6872 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1034:
/* Line 1787 of yacc.c  */
#line 6881 "gram.y"
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->isReset = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1035:
/* Line 1787 of yacc.c  */
#line 6890 "gram.y"
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->isReset = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1036:
/* Line 1787 of yacc.c  */
#line 6899 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSPARSER;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1037:
/* Line 1787 of yacc.c  */
#line 6908 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1038:
/* Line 1787 of yacc.c  */
#line 6917 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1039:
/* Line 1787 of yacc.c  */
#line 6926 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1040:
/* Line 1787 of yacc.c  */
#line 6935 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1041:
/* Line 1787 of yacc.c  */
#line 6944 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[(3) - (9)].list), (yylsp[(3) - (9)]), yyscanner);
					n->subname = (yyvsp[(6) - (9)].str);
					n->newname = (yyvsp[(8) - (9)].str);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1042:
/* Line 1787 of yacc.c  */
#line 6957 "gram.y"
    { (yyval.ival) = COLUMN; }
    break;

  case 1043:
/* Line 1787 of yacc.c  */
#line 6958 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1044:
/* Line 1787 of yacc.c  */
#line 6961 "gram.y"
    { (yyval.ival) = 1; }
    break;

  case 1045:
/* Line 1787 of yacc.c  */
#line 6962 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1046:
/* Line 1787 of yacc.c  */
#line 6973 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newschema = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1047:
/* Line 1787 of yacc.c  */
#line 6983 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1048:
/* Line 1787 of yacc.c  */
#line 6992 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1049:
/* Line 1787 of yacc.c  */
#line 7001 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1050:
/* Line 1787 of yacc.c  */
#line 7010 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_EXTENSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1051:
/* Line 1787 of yacc.c  */
#line 7019 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1052:
/* Line 1787 of yacc.c  */
#line 7029 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newschema = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1053:
/* Line 1787 of yacc.c  */
#line 7039 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (yyvsp[(4) - (9)].list);
					n->addname = (yyvsp[(6) - (9)].str);
					n->newschema = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1054:
/* Line 1787 of yacc.c  */
#line 7049 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (yyvsp[(4) - (9)].list);
					n->addname = (yyvsp[(6) - (9)].str);
					n->newschema = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1055:
/* Line 1787 of yacc.c  */
#line 7059 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1056:
/* Line 1787 of yacc.c  */
#line 7068 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1057:
/* Line 1787 of yacc.c  */
#line 7077 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSPARSER;
					n->object = (yyvsp[(5) - (8)].list);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1058:
/* Line 1787 of yacc.c  */
#line 7086 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1059:
/* Line 1787 of yacc.c  */
#line 7095 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[(5) - (8)].list);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1060:
/* Line 1787 of yacc.c  */
#line 7104 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1061:
/* Line 1787 of yacc.c  */
#line 7113 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1062:
/* Line 1787 of yacc.c  */
#line 7122 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1063:
/* Line 1787 of yacc.c  */
#line 7131 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1064:
/* Line 1787 of yacc.c  */
#line 7140 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[(5) - (8)].range);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1065:
/* Line 1787 of yacc.c  */
#line 7149 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(4) - (7)].range);
					n->newschema = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1066:
/* Line 1787 of yacc.c  */
#line 7158 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(6) - (9)].range);
					n->newschema = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1067:
/* Line 1787 of yacc.c  */
#line 7167 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1068:
/* Line 1787 of yacc.c  */
#line 7184 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1069:
/* Line 1787 of yacc.c  */
#line 7193 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1070:
/* Line 1787 of yacc.c  */
#line 7201 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1071:
/* Line 1787 of yacc.c  */
#line 7209 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1072:
/* Line 1787 of yacc.c  */
#line 7217 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1073:
/* Line 1787 of yacc.c  */
#line 7225 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1074:
/* Line 1787 of yacc.c  */
#line 7234 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[(4) - (7)].str)));
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1075:
/* Line 1787 of yacc.c  */
#line 7242 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = list_make1((yyvsp[(4) - (7)].value));
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1076:
/* Line 1787 of yacc.c  */
#line 7250 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1077:
/* Line 1787 of yacc.c  */
#line 7259 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (yyvsp[(4) - (9)].list);
					n->addname = (yyvsp[(6) - (9)].str);
					n->newowner = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1078:
/* Line 1787 of yacc.c  */
#line 7268 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (yyvsp[(4) - (9)].list);
					n->addname = (yyvsp[(6) - (9)].str);
					n->newowner = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1079:
/* Line 1787 of yacc.c  */
#line 7277 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1080:
/* Line 1787 of yacc.c  */
#line 7285 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1081:
/* Line 1787 of yacc.c  */
#line 7293 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TABLESPACE;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1082:
/* Line 1787 of yacc.c  */
#line 7301 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1083:
/* Line 1787 of yacc.c  */
#line 7309 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1084:
/* Line 1787 of yacc.c  */
#line 7317 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[(5) - (8)].str)));
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1085:
/* Line 1787 of yacc.c  */
#line 7325 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1086:
/* Line 1787 of yacc.c  */
#line 7344 "gram.y"
    {
					RuleStmt *n = makeNode(RuleStmt);
					n->replace = (yyvsp[(2) - (13)].boolean);
					n->relation = (yyvsp[(9) - (13)].range);
					n->rulename = (yyvsp[(4) - (13)].str);
					n->whereClause = (yyvsp[(10) - (13)].node);
					n->event = (yyvsp[(7) - (13)].ival);
					n->instead = (yyvsp[(12) - (13)].boolean);
					n->actions = (yyvsp[(13) - (13)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1087:
/* Line 1787 of yacc.c  */
#line 7358 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1088:
/* Line 1787 of yacc.c  */
#line 7359 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1089:
/* Line 1787 of yacc.c  */
#line 7360 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1090:
/* Line 1787 of yacc.c  */
#line 7366 "gram.y"
    { if ((yyvsp[(3) - (3)].node) != NULL)
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				  else
					(yyval.list) = (yyvsp[(1) - (3)].list);
				}
    break;

  case 1091:
/* Line 1787 of yacc.c  */
#line 7372 "gram.y"
    { if ((yyvsp[(1) - (1)].node) != NULL)
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				  else
					(yyval.list) = NIL;
				}
    break;

  case 1097:
/* Line 1787 of yacc.c  */
#line 7388 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1098:
/* Line 1787 of yacc.c  */
#line 7389 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1099:
/* Line 1787 of yacc.c  */
#line 7392 "gram.y"
    { (yyval.ival) = CMD_SELECT; }
    break;

  case 1100:
/* Line 1787 of yacc.c  */
#line 7393 "gram.y"
    { (yyval.ival) = CMD_UPDATE; }
    break;

  case 1101:
/* Line 1787 of yacc.c  */
#line 7394 "gram.y"
    { (yyval.ival) = CMD_DELETE; }
    break;

  case 1102:
/* Line 1787 of yacc.c  */
#line 7395 "gram.y"
    { (yyval.ival) = CMD_INSERT; }
    break;

  case 1103:
/* Line 1787 of yacc.c  */
#line 7399 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1104:
/* Line 1787 of yacc.c  */
#line 7400 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1105:
/* Line 1787 of yacc.c  */
#line 7401 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1106:
/* Line 1787 of yacc.c  */
#line 7407 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_RULE;
					n->objects = list_make1(lappend((yyvsp[(5) - (6)].list), makeString((yyvsp[(3) - (6)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1107:
/* Line 1787 of yacc.c  */
#line 7418 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_RULE;
					n->objects = list_make1(lappend((yyvsp[(7) - (8)].list), makeString((yyvsp[(5) - (8)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1108:
/* Line 1787 of yacc.c  */
#line 7440 "gram.y"
    {
					NotifyStmt *n = makeNode(NotifyStmt);
					n->conditionname = (yyvsp[(2) - (3)].str);
					n->payload = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1109:
/* Line 1787 of yacc.c  */
#line 7449 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 1110:
/* Line 1787 of yacc.c  */
#line 7450 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 1111:
/* Line 1787 of yacc.c  */
#line 7454 "gram.y"
    {
					ListenStmt *n = makeNode(ListenStmt);
					n->conditionname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1112:
/* Line 1787 of yacc.c  */
#line 7463 "gram.y"
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1113:
/* Line 1787 of yacc.c  */
#line 7469 "gram.y"
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1114:
/* Line 1787 of yacc.c  */
#line 7488 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1115:
/* Line 1787 of yacc.c  */
#line 7495 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1116:
/* Line 1787 of yacc.c  */
#line 7502 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1117:
/* Line 1787 of yacc.c  */
#line 7509 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1118:
/* Line 1787 of yacc.c  */
#line 7516 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1119:
/* Line 1787 of yacc.c  */
#line 7523 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1120:
/* Line 1787 of yacc.c  */
#line 7530 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_SAVEPOINT;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(2) - (2)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1121:
/* Line 1787 of yacc.c  */
#line 7538 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(3) - (3)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1122:
/* Line 1787 of yacc.c  */
#line 7546 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(2) - (2)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1123:
/* Line 1787 of yacc.c  */
#line 7554 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(5) - (5)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1124:
/* Line 1787 of yacc.c  */
#line 7562 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(4) - (4)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1125:
/* Line 1787 of yacc.c  */
#line 7570 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1126:
/* Line 1787 of yacc.c  */
#line 7577 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1127:
/* Line 1787 of yacc.c  */
#line 7584 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1128:
/* Line 1787 of yacc.c  */
#line 7592 "gram.y"
    {}
    break;

  case 1129:
/* Line 1787 of yacc.c  */
#line 7593 "gram.y"
    {}
    break;

  case 1130:
/* Line 1787 of yacc.c  */
#line 7594 "gram.y"
    {}
    break;

  case 1131:
/* Line 1787 of yacc.c  */
#line 7599 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)]))); }
    break;

  case 1132:
/* Line 1787 of yacc.c  */
#line 7602 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(TRUE, (yylsp[(1) - (2)]))); }
    break;

  case 1133:
/* Line 1787 of yacc.c  */
#line 7605 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(FALSE, (yylsp[(1) - (2)]))); }
    break;

  case 1134:
/* Line 1787 of yacc.c  */
#line 7608 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(TRUE, (yylsp[(1) - (1)]))); }
    break;

  case 1135:
/* Line 1787 of yacc.c  */
#line 7611 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(FALSE, (yylsp[(1) - (2)]))); }
    break;

  case 1136:
/* Line 1787 of yacc.c  */
#line 7618 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 1137:
/* Line 1787 of yacc.c  */
#line 7620 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 1138:
/* Line 1787 of yacc.c  */
#line 7622 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 1140:
/* Line 1787 of yacc.c  */
#line 7628 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1141:
/* Line 1787 of yacc.c  */
#line 7642 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(4) - (9)].range);
					n->view->relpersistence = (yyvsp[(2) - (9)].ival);
					n->aliases = (yyvsp[(5) - (9)].list);
					n->query = (yyvsp[(8) - (9)].node);
					n->replace = false;
					n->options = (yyvsp[(6) - (9)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1142:
/* Line 1787 of yacc.c  */
#line 7654 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(6) - (11)].range);
					n->view->relpersistence = (yyvsp[(4) - (11)].ival);
					n->aliases = (yyvsp[(7) - (11)].list);
					n->query = (yyvsp[(10) - (11)].node);
					n->replace = true;
					n->options = (yyvsp[(8) - (11)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1143:
/* Line 1787 of yacc.c  */
#line 7668 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				}
    break;

  case 1144:
/* Line 1787 of yacc.c  */
#line 7674 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				}
    break;

  case 1145:
/* Line 1787 of yacc.c  */
#line 7680 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				}
    break;

  case 1146:
/* Line 1787 of yacc.c  */
#line 7685 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1147:
/* Line 1787 of yacc.c  */
#line 7696 "gram.y"
    {
					LoadStmt *n = makeNode(LoadStmt);
					n->filename = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1148:
/* Line 1787 of yacc.c  */
#line 7712 "gram.y"
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1149:
/* Line 1787 of yacc.c  */
#line 7721 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 1150:
/* Line 1787 of yacc.c  */
#line 7722 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1151:
/* Line 1787 of yacc.c  */
#line 7727 "gram.y"
    {
					(yyval.defelt) = makeDefElem("tablespace", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1152:
/* Line 1787 of yacc.c  */
#line 7731 "gram.y"
    {
					(yyval.defelt) = makeDefElem("tablespace", NULL);
				}
    break;

  case 1153:
/* Line 1787 of yacc.c  */
#line 7735 "gram.y"
    {
					(yyval.defelt) = makeDefElem("location", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1154:
/* Line 1787 of yacc.c  */
#line 7739 "gram.y"
    {
					(yyval.defelt) = makeDefElem("location", NULL);
				}
    break;

  case 1155:
/* Line 1787 of yacc.c  */
#line 7743 "gram.y"
    {
					(yyval.defelt) = makeDefElem("template", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1156:
/* Line 1787 of yacc.c  */
#line 7747 "gram.y"
    {
					(yyval.defelt) = makeDefElem("template", NULL);
				}
    break;

  case 1157:
/* Line 1787 of yacc.c  */
#line 7751 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1158:
/* Line 1787 of yacc.c  */
#line 7755 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeInteger((yyvsp[(3) - (3)].ival)));
				}
    break;

  case 1159:
/* Line 1787 of yacc.c  */
#line 7759 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", NULL);
				}
    break;

  case 1160:
/* Line 1787 of yacc.c  */
#line 7763 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_collate", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1161:
/* Line 1787 of yacc.c  */
#line 7767 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_collate", NULL);
				}
    break;

  case 1162:
/* Line 1787 of yacc.c  */
#line 7771 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_ctype", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1163:
/* Line 1787 of yacc.c  */
#line 7775 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_ctype", NULL);
				}
    break;

  case 1164:
/* Line 1787 of yacc.c  */
#line 7779 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(4) - (4)].ival)));
				}
    break;

  case 1165:
/* Line 1787 of yacc.c  */
#line 7783 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owner", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1166:
/* Line 1787 of yacc.c  */
#line 7787 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owner", NULL);
				}
    break;

  case 1167:
/* Line 1787 of yacc.c  */
#line 7796 "gram.y"
    {}
    break;

  case 1168:
/* Line 1787 of yacc.c  */
#line 7797 "gram.y"
    {}
    break;

  case 1169:
/* Line 1787 of yacc.c  */
#line 7809 "gram.y"
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 }
    break;

  case 1170:
/* Line 1787 of yacc.c  */
#line 7816 "gram.y"
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[(3) - (6)].str);
					n->options = list_make1(makeDefElem("tablespace",
													(Node *)makeString((yyvsp[(6) - (6)].str))));
					(yyval.node) = (Node *)n;
				 }
    break;

  case 1171:
/* Line 1787 of yacc.c  */
#line 7827 "gram.y"
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[(3) - (4)].str);
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1172:
/* Line 1787 of yacc.c  */
#line 7837 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 1173:
/* Line 1787 of yacc.c  */
#line 7838 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1174:
/* Line 1787 of yacc.c  */
#line 7843 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(4) - (4)].ival)));
				}
    break;

  case 1175:
/* Line 1787 of yacc.c  */
#line 7857 "gram.y"
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[(3) - (3)].str);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1176:
/* Line 1787 of yacc.c  */
#line 7864 "gram.y"
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[(5) - (5)].str);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1177:
/* Line 1787 of yacc.c  */
#line 7881 "gram.y"
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);
					n->domainname = (yyvsp[(3) - (6)].list);
					n->typeName = (yyvsp[(5) - (6)].typnam);
					SplitColQualList((yyvsp[(6) - (6)].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1178:
/* Line 1787 of yacc.c  */
#line 7894 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'T';
					n->typeName = (yyvsp[(3) - (4)].list);
					n->def = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1179:
/* Line 1787 of yacc.c  */
#line 7903 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'N';
					n->typeName = (yyvsp[(3) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1180:
/* Line 1787 of yacc.c  */
#line 7911 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'O';
					n->typeName = (yyvsp[(3) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1181:
/* Line 1787 of yacc.c  */
#line 7919 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'C';
					n->typeName = (yyvsp[(3) - (5)].list);
					n->def = (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1182:
/* Line 1787 of yacc.c  */
#line 7928 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[(3) - (7)].list);
					n->name = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1183:
/* Line 1787 of yacc.c  */
#line 7939 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[(3) - (9)].list);
					n->name = (yyvsp[(8) - (9)].str);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1184:
/* Line 1787 of yacc.c  */
#line 7950 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'V';
					n->typeName = (yyvsp[(3) - (6)].list);
					n->name = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1185:
/* Line 1787 of yacc.c  */
#line 7959 "gram.y"
    {}
    break;

  case 1186:
/* Line 1787 of yacc.c  */
#line 7960 "gram.y"
    {}
    break;

  case 1187:
/* Line 1787 of yacc.c  */
#line 7972 "gram.y"
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);
					n->dictname = (yyvsp[(5) - (6)].list);
					n->options = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1188:
/* Line 1787 of yacc.c  */
#line 7982 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(9) - (11)].list);
					n->dicts = (yyvsp[(11) - (11)].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1189:
/* Line 1787 of yacc.c  */
#line 7992 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(9) - (11)].list);
					n->dicts = (yyvsp[(11) - (11)].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1190:
/* Line 1787 of yacc.c  */
#line 8002 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[(9) - (11)].list),(yyvsp[(11) - (11)].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1191:
/* Line 1787 of yacc.c  */
#line 8012 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (13)].list);
					n->tokentype = (yyvsp[(9) - (13)].list);
					n->dicts = list_make2((yyvsp[(11) - (13)].list),(yyvsp[(13) - (13)].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1192:
/* Line 1787 of yacc.c  */
#line 8022 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (9)].list);
					n->tokentype = (yyvsp[(9) - (9)].list);
					n->missing_ok = false;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1193:
/* Line 1787 of yacc.c  */
#line 8030 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(11) - (11)].list);
					n->missing_ok = true;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1194:
/* Line 1787 of yacc.c  */
#line 8052 "gram.y"
    {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);
				n->conversion_name = (yyvsp[(4) - (10)].list);
				n->for_encoding_name = (yyvsp[(6) - (10)].str);
				n->to_encoding_name = (yyvsp[(8) - (10)].str);
				n->func_name = (yyvsp[(10) - (10)].list);
				n->def = (yyvsp[(2) - (10)].boolean);
				(yyval.node) = (Node *)n;
			}
    break;

  case 1195:
/* Line 1787 of yacc.c  */
#line 8074 "gram.y"
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->indexname = (yyvsp[(4) - (4)].str);
					n->verbose = (yyvsp[(2) - (4)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 1196:
/* Line 1787 of yacc.c  */
#line 8082 "gram.y"
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = NULL;
					n->indexname = NULL;
					n->verbose = (yyvsp[(2) - (2)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 1197:
/* Line 1787 of yacc.c  */
#line 8091 "gram.y"
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[(5) - (5)].range);
					n->indexname = (yyvsp[(3) - (5)].str);
					n->verbose = (yyvsp[(2) - (5)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 1198:
/* Line 1787 of yacc.c  */
#line 8101 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 1199:
/* Line 1787 of yacc.c  */
#line 8102 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 1200:
/* Line 1787 of yacc.c  */
#line 8115 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[(2) - (4)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(4) - (4)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[(3) - (4)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (4)].boolean) ? 0 : -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1201:
/* Line 1787 of yacc.c  */
#line 8129 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[(2) - (5)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(4) - (5)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->relation = (yyvsp[(5) - (5)].range);
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1202:
/* Line 1787 of yacc.c  */
#line 8143 "gram.y"
    {
					VacuumStmt *n = (VacuumStmt *) (yyvsp[(5) - (5)].node);
					n->options |= VACOPT_VACUUM;
					if ((yyvsp[(2) - (5)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(4) - (5)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1203:
/* Line 1787 of yacc.c  */
#line 8155 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[(3) - (4)].ival);
					if (n->options & VACOPT_FREEZE)
						n->freeze_min_age = n->freeze_table_age = 0;
					else
						n->freeze_min_age = n->freeze_table_age = -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1204:
/* Line 1787 of yacc.c  */
#line 8167 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[(3) - (6)].ival);
					if (n->options & VACOPT_FREEZE)
						n->freeze_min_age = n->freeze_table_age = 0;
					else
						n->freeze_min_age = n->freeze_table_age = -1;
					n->relation = (yyvsp[(5) - (6)].range);
					n->va_cols = (yyvsp[(6) - (6)].list);
					if (n->va_cols != NIL)	/* implies analyze */
						n->options |= VACOPT_ANALYZE;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1205:
/* Line 1787 of yacc.c  */
#line 8183 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); }
    break;

  case 1206:
/* Line 1787 of yacc.c  */
#line 8184 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | (yyvsp[(3) - (3)].ival); }
    break;

  case 1207:
/* Line 1787 of yacc.c  */
#line 8188 "gram.y"
    { (yyval.ival) = VACOPT_ANALYZE; }
    break;

  case 1208:
/* Line 1787 of yacc.c  */
#line 8189 "gram.y"
    { (yyval.ival) = VACOPT_VERBOSE; }
    break;

  case 1209:
/* Line 1787 of yacc.c  */
#line 8190 "gram.y"
    { (yyval.ival) = VACOPT_FREEZE; }
    break;

  case 1210:
/* Line 1787 of yacc.c  */
#line 8191 "gram.y"
    { (yyval.ival) = VACOPT_FULL; }
    break;

  case 1211:
/* Line 1787 of yacc.c  */
#line 8196 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[(2) - (2)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1212:
/* Line 1787 of yacc.c  */
#line 8208 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[(2) - (4)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->relation = (yyvsp[(3) - (4)].range);
					n->va_cols = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1213:
/* Line 1787 of yacc.c  */
#line 8222 "gram.y"
    {}
    break;

  case 1214:
/* Line 1787 of yacc.c  */
#line 8223 "gram.y"
    {}
    break;

  case 1215:
/* Line 1787 of yacc.c  */
#line 8227 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1216:
/* Line 1787 of yacc.c  */
#line 8228 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1217:
/* Line 1787 of yacc.c  */
#line 8231 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1218:
/* Line 1787 of yacc.c  */
#line 8232 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1219:
/* Line 1787 of yacc.c  */
#line 8235 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1220:
/* Line 1787 of yacc.c  */
#line 8236 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1221:
/* Line 1787 of yacc.c  */
#line 8240 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1222:
/* Line 1787 of yacc.c  */
#line 8241 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1223:
/* Line 1787 of yacc.c  */
#line 8255 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(2) - (2)].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1224:
/* Line 1787 of yacc.c  */
#line 8262 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(4) - (4)].node);
					n->options = list_make1(makeDefElem("analyze", NULL));
					if ((yyvsp[(3) - (4)].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1225:
/* Line 1787 of yacc.c  */
#line 8272 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(3) - (3)].node);
					n->options = list_make1(makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1226:
/* Line 1787 of yacc.c  */
#line 8279 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(5) - (5)].node);
					n->options = (yyvsp[(3) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1234:
/* Line 1787 of yacc.c  */
#line 8299 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				}
    break;

  case 1235:
/* Line 1787 of yacc.c  */
#line 8303 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				}
    break;

  case 1236:
/* Line 1787 of yacc.c  */
#line 8310 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				}
    break;

  case 1237:
/* Line 1787 of yacc.c  */
#line 8316 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1238:
/* Line 1787 of yacc.c  */
#line 8317 "gram.y"
    { (yyval.str) = "analyze"; }
    break;

  case 1239:
/* Line 1787 of yacc.c  */
#line 8321 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 1240:
/* Line 1787 of yacc.c  */
#line 8322 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].value); }
    break;

  case 1241:
/* Line 1787 of yacc.c  */
#line 8323 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1242:
/* Line 1787 of yacc.c  */
#line 8334 "gram.y"
    {
					PrepareStmt *n = makeNode(PrepareStmt);
					n->name = (yyvsp[(2) - (5)].str);
					n->argtypes = (yyvsp[(3) - (5)].list);
					n->query = (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1243:
/* Line 1787 of yacc.c  */
#line 8343 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1244:
/* Line 1787 of yacc.c  */
#line 8344 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1249:
/* Line 1787 of yacc.c  */
#line 8362 "gram.y"
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[(2) - (3)].str);
					n->params = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1250:
/* Line 1787 of yacc.c  */
#line 8370 "gram.y"
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[(7) - (9)].str);
					n->params = (yyvsp[(8) - (9)].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[(4) - (9)].into);
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[(4) - (9)].into)->rel->relpersistence = (yyvsp[(2) - (9)].ival);
					(yyvsp[(4) - (9)].into)->skipData = !((yyvsp[(9) - (9)].boolean));
					(yyval.node) = (Node *) ctas;
				}
    break;

  case 1251:
/* Line 1787 of yacc.c  */
#line 8385 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1252:
/* Line 1787 of yacc.c  */
#line 8386 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1253:
/* Line 1787 of yacc.c  */
#line 8397 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[(2) - (2)].str);
						(yyval.node) = (Node *) n;
					}
    break;

  case 1254:
/* Line 1787 of yacc.c  */
#line 8403 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[(3) - (3)].str);
						(yyval.node) = (Node *) n;
					}
    break;

  case 1255:
/* Line 1787 of yacc.c  */
#line 8409 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
    break;

  case 1256:
/* Line 1787 of yacc.c  */
#line 8415 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
    break;

  case 1257:
/* Line 1787 of yacc.c  */
#line 8431 "gram.y"
    {
					(yyvsp[(5) - (6)].istmt)->relation = (yyvsp[(4) - (6)].range);
					(yyvsp[(5) - (6)].istmt)->returningList = (yyvsp[(6) - (6)].list);
					(yyvsp[(5) - (6)].istmt)->withClause = (yyvsp[(1) - (6)].with);
					(yyval.node) = (Node *) (yyvsp[(5) - (6)].istmt);
				}
    break;

  case 1258:
/* Line 1787 of yacc.c  */
#line 8441 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[(1) - (1)].node);
				}
    break;

  case 1259:
/* Line 1787 of yacc.c  */
#line 8447 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[(2) - (4)].list);
					(yyval.istmt)->selectStmt = (yyvsp[(4) - (4)].node);
				}
    break;

  case 1260:
/* Line 1787 of yacc.c  */
#line 8453 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
    break;

  case 1261:
/* Line 1787 of yacc.c  */
#line 8462 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1262:
/* Line 1787 of yacc.c  */
#line 8464 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); }
    break;

  case 1263:
/* Line 1787 of yacc.c  */
#line 8469 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(1) - (2)].str);
					(yyval.target)->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1264:
/* Line 1787 of yacc.c  */
#line 8479 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1265:
/* Line 1787 of yacc.c  */
#line 8480 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1266:
/* Line 1787 of yacc.c  */
#line 8493 "gram.y"
    {
					DeleteStmt *n = makeNode(DeleteStmt);
					n->relation = (yyvsp[(4) - (7)].range);
					n->usingClause = (yyvsp[(5) - (7)].list);
					n->whereClause = (yyvsp[(6) - (7)].node);
					n->returningList = (yyvsp[(7) - (7)].list);
					n->withClause = (yyvsp[(1) - (7)].with);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1267:
/* Line 1787 of yacc.c  */
#line 8505 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1268:
/* Line 1787 of yacc.c  */
#line 8506 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1269:
/* Line 1787 of yacc.c  */
#line 8518 "gram.y"
    {
					LockStmt *n = makeNode(LockStmt);

					n->relations = (yyvsp[(3) - (5)].list);
					n->mode = (yyvsp[(4) - (5)].ival);
					n->nowait = (yyvsp[(5) - (5)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1270:
/* Line 1787 of yacc.c  */
#line 8528 "gram.y"
    { (yyval.ival) = (yyvsp[(2) - (3)].ival); }
    break;

  case 1271:
/* Line 1787 of yacc.c  */
#line 8529 "gram.y"
    { (yyval.ival) = AccessExclusiveLock; }
    break;

  case 1272:
/* Line 1787 of yacc.c  */
#line 8532 "gram.y"
    { (yyval.ival) = AccessShareLock; }
    break;

  case 1273:
/* Line 1787 of yacc.c  */
#line 8533 "gram.y"
    { (yyval.ival) = RowShareLock; }
    break;

  case 1274:
/* Line 1787 of yacc.c  */
#line 8534 "gram.y"
    { (yyval.ival) = RowExclusiveLock; }
    break;

  case 1275:
/* Line 1787 of yacc.c  */
#line 8535 "gram.y"
    { (yyval.ival) = ApplicationShareLock; }
    break;

  case 1276:
/* Line 1787 of yacc.c  */
#line 8536 "gram.y"
    { (yyval.ival) = ApplicationExclusiveLock; }
    break;

  case 1277:
/* Line 1787 of yacc.c  */
#line 8537 "gram.y"
    { (yyval.ival) = ShareUpdateExclusiveLock; }
    break;

  case 1278:
/* Line 1787 of yacc.c  */
#line 8538 "gram.y"
    { (yyval.ival) = ShareLock; }
    break;

  case 1279:
/* Line 1787 of yacc.c  */
#line 8539 "gram.y"
    { (yyval.ival) = ShareRowExclusiveLock; }
    break;

  case 1280:
/* Line 1787 of yacc.c  */
#line 8540 "gram.y"
    { (yyval.ival) = ExclusiveLock; }
    break;

  case 1281:
/* Line 1787 of yacc.c  */
#line 8541 "gram.y"
    { (yyval.ival) = AccessExclusiveLock; }
    break;

  case 1282:
/* Line 1787 of yacc.c  */
#line 8544 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1283:
/* Line 1787 of yacc.c  */
#line 8545 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1284:
/* Line 1787 of yacc.c  */
#line 8561 "gram.y"
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[(3) - (8)].range);
					n->targetList = (yyvsp[(5) - (8)].list);
					n->fromClause = (yyvsp[(6) - (8)].list);
					n->whereClause = (yyvsp[(7) - (8)].node);
					n->returningList = (yyvsp[(8) - (8)].list);
					n->withClause = (yyvsp[(1) - (8)].with);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1285:
/* Line 1787 of yacc.c  */
#line 8574 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1286:
/* Line 1787 of yacc.c  */
#line 8575 "gram.y"
    { (yyval.list) = list_concat((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].list)); }
    break;

  case 1287:
/* Line 1787 of yacc.c  */
#line 8579 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1288:
/* Line 1787 of yacc.c  */
#line 8580 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1289:
/* Line 1787 of yacc.c  */
#line 8585 "gram.y"
    {
					(yyval.target) = (yyvsp[(1) - (3)].target);
					(yyval.target)->val = (Node *) (yyvsp[(3) - (3)].node);
				}
    break;

  case 1290:
/* Line 1787 of yacc.c  */
#line 8593 "gram.y"
    {
					ListCell *col_cell;
					ListCell *val_cell;

					/*
					 * Break the ctext_row apart, merge individual expressions
					 * into the destination ResTargets.  XXX this approach
					 * cannot work for general row expressions as sources.
					 */
					if (list_length((yyvsp[(2) - (5)].list)) != list_length((yyvsp[(5) - (5)].list)))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("number of columns does not match number of values"),
								 parser_errposition((yylsp[(1) - (5)]))));
					forboth(col_cell, (yyvsp[(2) - (5)].list), val_cell, (yyvsp[(5) - (5)].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						Node *res_val = (Node *) lfirst(val_cell);

						res_col->val = res_val;
					}

					(yyval.list) = (yyvsp[(2) - (5)].list);
				}
    break;

  case 1291:
/* Line 1787 of yacc.c  */
#line 8621 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(1) - (2)].str);
					(yyval.target)->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1292:
/* Line 1787 of yacc.c  */
#line 8631 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1293:
/* Line 1787 of yacc.c  */
#line 8632 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].target)); }
    break;

  case 1294:
/* Line 1787 of yacc.c  */
#line 8643 "gram.y"
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);
					n->portalname = (yyvsp[(2) - (7)].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[(3) - (7)].ival) | (yyvsp[(5) - (7)].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1295:
/* Line 1787 of yacc.c  */
#line 8653 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1296:
/* Line 1787 of yacc.c  */
#line 8656 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1297:
/* Line 1787 of yacc.c  */
#line 8657 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | CURSOR_OPT_NO_SCROLL; }
    break;

  case 1298:
/* Line 1787 of yacc.c  */
#line 8658 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_SCROLL; }
    break;

  case 1299:
/* Line 1787 of yacc.c  */
#line 8659 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_BINARY; }
    break;

  case 1300:
/* Line 1787 of yacc.c  */
#line 8660 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_INSENSITIVE; }
    break;

  case 1301:
/* Line 1787 of yacc.c  */
#line 8663 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1302:
/* Line 1787 of yacc.c  */
#line 8664 "gram.y"
    { (yyval.ival) = CURSOR_OPT_HOLD; }
    break;

  case 1303:
/* Line 1787 of yacc.c  */
#line 8665 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1306:
/* Line 1787 of yacc.c  */
#line 8718 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); }
    break;

  case 1307:
/* Line 1787 of yacc.c  */
#line 8719 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); }
    break;

  case 1308:
/* Line 1787 of yacc.c  */
#line 8733 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1309:
/* Line 1787 of yacc.c  */
#line 8735 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].list), NIL,
										NULL, NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (2)].node);
				}
    break;

  case 1310:
/* Line 1787 of yacc.c  */
#line 8742 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].list), (yyvsp[(3) - (4)].list),
										list_nth((yyvsp[(4) - (4)].list), 0), list_nth((yyvsp[(4) - (4)].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (4)].node);
				}
    break;

  case 1311:
/* Line 1787 of yacc.c  */
#line 8750 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].list), (yyvsp[(4) - (4)].list),
										list_nth((yyvsp[(3) - (4)].list), 0), list_nth((yyvsp[(3) - (4)].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (4)].node);
				}
    break;

  case 1312:
/* Line 1787 of yacc.c  */
#line 8758 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (2)].node), NULL, NIL,
										NULL, NULL,
										(yyvsp[(1) - (2)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (2)].node);
				}
    break;

  case 1313:
/* Line 1787 of yacc.c  */
#line 8766 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].list), NIL,
										NULL, NULL,
										(yyvsp[(1) - (3)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (3)].node);
				}
    break;

  case 1314:
/* Line 1787 of yacc.c  */
#line 8774 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (5)].node), (yyvsp[(3) - (5)].list), (yyvsp[(4) - (5)].list),
										list_nth((yyvsp[(5) - (5)].list), 0), list_nth((yyvsp[(5) - (5)].list), 1),
										(yyvsp[(1) - (5)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (5)].node);
				}
    break;

  case 1315:
/* Line 1787 of yacc.c  */
#line 8782 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (5)].node), (yyvsp[(3) - (5)].list), (yyvsp[(5) - (5)].list),
										list_nth((yyvsp[(4) - (5)].list), 0), list_nth((yyvsp[(4) - (5)].list), 1),
										(yyvsp[(1) - (5)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (5)].node);
				}
    break;

  case 1316:
/* Line 1787 of yacc.c  */
#line 8792 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1317:
/* Line 1787 of yacc.c  */
#line 8793 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1318:
/* Line 1787 of yacc.c  */
#line 8823 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->distinctClause = (yyvsp[(2) - (9)].list);
					n->targetList = (yyvsp[(3) - (9)].list);
					n->intoClause = (yyvsp[(4) - (9)].into);
					n->fromClause = (yyvsp[(5) - (9)].list);
					n->whereClause = (yyvsp[(6) - (9)].node);
					n->groupClause = (yyvsp[(7) - (9)].list);
					n->havingClause = (yyvsp[(8) - (9)].node);
					n->windowClause = (yyvsp[(9) - (9)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1319:
/* Line 1787 of yacc.c  */
#line 8835 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1320:
/* Line 1787 of yacc.c  */
#line 8837 "gram.y"
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef *cr = makeNode(ColumnRef);
					ResTarget *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *)cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[(2) - (2)].range));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1321:
/* Line 1787 of yacc.c  */
#line 8856 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				}
    break;

  case 1322:
/* Line 1787 of yacc.c  */
#line 8860 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				}
    break;

  case 1323:
/* Line 1787 of yacc.c  */
#line 8864 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				}
    break;

  case 1324:
/* Line 1787 of yacc.c  */
#line 8879 "gram.y"
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[(2) - (2)].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[(1) - (2)]);
			}
    break;

  case 1325:
/* Line 1787 of yacc.c  */
#line 8886 "gram.y"
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[(3) - (3)].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[(1) - (3)]);
			}
    break;

  case 1326:
/* Line 1787 of yacc.c  */
#line 8895 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1327:
/* Line 1787 of yacc.c  */
#line 8896 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 1328:
/* Line 1787 of yacc.c  */
#line 8900 "gram.y"
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);
				n->ctename = (yyvsp[(1) - (6)].str);
				n->aliascolnames = (yyvsp[(2) - (6)].list);
				n->ctequery = (yyvsp[(5) - (6)].node);
				n->location = (yylsp[(1) - (6)]);
				(yyval.node) = (Node *) n;
			}
    break;

  case 1329:
/* Line 1787 of yacc.c  */
#line 8911 "gram.y"
    { (yyval.with) = (yyvsp[(1) - (1)].with); }
    break;

  case 1330:
/* Line 1787 of yacc.c  */
#line 8912 "gram.y"
    { (yyval.with) = NULL; }
    break;

  case 1331:
/* Line 1787 of yacc.c  */
#line 8917 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(2) - (2)].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->skipData = false;
				}
    break;

  case 1332:
/* Line 1787 of yacc.c  */
#line 8927 "gram.y"
    { (yyval.into) = NULL; }
    break;

  case 1333:
/* Line 1787 of yacc.c  */
#line 8936 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1334:
/* Line 1787 of yacc.c  */
#line 8941 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1335:
/* Line 1787 of yacc.c  */
#line 8946 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1336:
/* Line 1787 of yacc.c  */
#line 8951 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1337:
/* Line 1787 of yacc.c  */
#line 8956 "gram.y"
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[(1) - (4)]))));
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1338:
/* Line 1787 of yacc.c  */
#line 8964 "gram.y"
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[(1) - (4)]))));
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1339:
/* Line 1787 of yacc.c  */
#line 8972 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
    break;

  case 1340:
/* Line 1787 of yacc.c  */
#line 8977 "gram.y"
    {
					(yyval.range) = (yyvsp[(2) - (2)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
    break;

  case 1341:
/* Line 1787 of yacc.c  */
#line 8982 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
    break;

  case 1342:
/* Line 1787 of yacc.c  */
#line 8988 "gram.y"
    {}
    break;

  case 1343:
/* Line 1787 of yacc.c  */
#line 8989 "gram.y"
    {}
    break;

  case 1344:
/* Line 1787 of yacc.c  */
#line 8992 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1345:
/* Line 1787 of yacc.c  */
#line 8993 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1346:
/* Line 1787 of yacc.c  */
#line 8994 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1347:
/* Line 1787 of yacc.c  */
#line 9001 "gram.y"
    { (yyval.list) = list_make1(NIL); }
    break;

  case 1348:
/* Line 1787 of yacc.c  */
#line 9002 "gram.y"
    { (yyval.list) = (yyvsp[(4) - (5)].list); }
    break;

  case 1349:
/* Line 1787 of yacc.c  */
#line 9003 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1350:
/* Line 1787 of yacc.c  */
#line 9004 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1351:
/* Line 1787 of yacc.c  */
#line 9008 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list);}
    break;

  case 1352:
/* Line 1787 of yacc.c  */
#line 9009 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1353:
/* Line 1787 of yacc.c  */
#line 9013 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); }
    break;

  case 1354:
/* Line 1787 of yacc.c  */
#line 9017 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].sortby)); }
    break;

  case 1355:
/* Line 1787 of yacc.c  */
#line 9018 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].sortby)); }
    break;

  case 1356:
/* Line 1787 of yacc.c  */
#line 9022 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (4)].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[(4) - (4)].ival);
					(yyval.sortby)->useOp = (yyvsp[(3) - (4)].list);
					(yyval.sortby)->location = (yylsp[(3) - (4)]);
				}
    break;

  case 1357:
/* Line 1787 of yacc.c  */
#line 9031 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (3)].node);
					(yyval.sortby)->sortby_dir = (yyvsp[(2) - (3)].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[(3) - (3)].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
    break;

  case 1358:
/* Line 1787 of yacc.c  */
#line 9043 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (2)].node), (yyvsp[(1) - (2)].node)); }
    break;

  case 1359:
/* Line 1787 of yacc.c  */
#line 9044 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node)); }
    break;

  case 1360:
/* Line 1787 of yacc.c  */
#line 9045 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(1) - (1)].node)); }
    break;

  case 1361:
/* Line 1787 of yacc.c  */
#line 9046 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(1) - (1)].node), NULL); }
    break;

  case 1362:
/* Line 1787 of yacc.c  */
#line 9050 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1363:
/* Line 1787 of yacc.c  */
#line 9051 "gram.y"
    { (yyval.list) = list_make2(NULL,NULL); }
    break;

  case 1364:
/* Line 1787 of yacc.c  */
#line 9056 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1365:
/* Line 1787 of yacc.c  */
#line 9058 "gram.y"
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[(1) - (4)]))));
				}
    break;

  case 1366:
/* Line 1787 of yacc.c  */
#line 9068 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (5)].node); }
    break;

  case 1367:
/* Line 1787 of yacc.c  */
#line 9073 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1368:
/* Line 1787 of yacc.c  */
#line 9076 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); }
    break;

  case 1369:
/* Line 1787 of yacc.c  */
#line 9080 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1370:
/* Line 1787 of yacc.c  */
#line 9082 "gram.y"
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[(1) - (1)]));
				}
    break;

  case 1371:
/* Line 1787 of yacc.c  */
#line 9089 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1372:
/* Line 1787 of yacc.c  */
#line 9099 "gram.y"
    { (yyval.node) = makeIntConst((yyvsp[(1) - (1)].ival), (yylsp[(1) - (1)])); }
    break;

  case 1373:
/* Line 1787 of yacc.c  */
#line 9100 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); }
    break;

  case 1374:
/* Line 1787 of yacc.c  */
#line 9101 "gram.y"
    { (yyval.node) = makeIntConst(1, -1); }
    break;

  case 1375:
/* Line 1787 of yacc.c  */
#line 9109 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1376:
/* Line 1787 of yacc.c  */
#line 9113 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1377:
/* Line 1787 of yacc.c  */
#line 9114 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1378:
/* Line 1787 of yacc.c  */
#line 9117 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1379:
/* Line 1787 of yacc.c  */
#line 9118 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1380:
/* Line 1787 of yacc.c  */
#line 9123 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); }
    break;

  case 1381:
/* Line 1787 of yacc.c  */
#line 9124 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1382:
/* Line 1787 of yacc.c  */
#line 9128 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1383:
/* Line 1787 of yacc.c  */
#line 9129 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1384:
/* Line 1787 of yacc.c  */
#line 9133 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1385:
/* Line 1787 of yacc.c  */
#line 9134 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1386:
/* Line 1787 of yacc.c  */
#line 9138 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1387:
/* Line 1787 of yacc.c  */
#line 9139 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1388:
/* Line 1787 of yacc.c  */
#line 9143 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1389:
/* Line 1787 of yacc.c  */
#line 9144 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 1390:
/* Line 1787 of yacc.c  */
#line 9149 "gram.y"
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[(3) - (4)].list);
					n->forUpdate = TRUE;
					n->noWait = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1391:
/* Line 1787 of yacc.c  */
#line 9157 "gram.y"
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[(3) - (4)].list);
					n->forUpdate = FALSE;
					n->noWait = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1392:
/* Line 1787 of yacc.c  */
#line 9167 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1393:
/* Line 1787 of yacc.c  */
#line 9168 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1394:
/* Line 1787 of yacc.c  */
#line 9174 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->valuesLists = list_make1((yyvsp[(2) - (2)].list));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1395:
/* Line 1787 of yacc.c  */
#line 9180 "gram.y"
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[(1) - (3)].node);
					n->valuesLists = lappend(n->valuesLists, (yyvsp[(3) - (3)].list));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1396:
/* Line 1787 of yacc.c  */
#line 9197 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1397:
/* Line 1787 of yacc.c  */
#line 9198 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1398:
/* Line 1787 of yacc.c  */
#line 9202 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1399:
/* Line 1787 of yacc.c  */
#line 9203 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 1400:
/* Line 1787 of yacc.c  */
#line 9214 "gram.y"
    {
					(yyval.node) = (Node *) (yyvsp[(1) - (1)].range);
				}
    break;

  case 1401:
/* Line 1787 of yacc.c  */
#line 9218 "gram.y"
    {
					(yyvsp[(1) - (2)].range)->alias = (yyvsp[(2) - (2)].alias);
					(yyval.node) = (Node *) (yyvsp[(1) - (2)].range);
				}
    break;

  case 1402:
/* Line 1787 of yacc.c  */
#line 9223 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[(1) - (1)].node);
					n->coldeflist = NIL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1403:
/* Line 1787 of yacc.c  */
#line 9230 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[(1) - (2)].node);
					n->alias = (yyvsp[(2) - (2)].alias);
					n->coldeflist = NIL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1404:
/* Line 1787 of yacc.c  */
#line 9238 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[(1) - (5)].node);
					n->coldeflist = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1405:
/* Line 1787 of yacc.c  */
#line 9245 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					Alias *a = makeNode(Alias);
					n->funccallnode = (yyvsp[(1) - (6)].node);
					a->aliasname = (yyvsp[(3) - (6)].str);
					n->alias = a;
					n->coldeflist = (yyvsp[(5) - (6)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1406:
/* Line 1787 of yacc.c  */
#line 9255 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					Alias *a = makeNode(Alias);
					n->funccallnode = (yyvsp[(1) - (5)].node);
					a->aliasname = (yyvsp[(2) - (5)].str);
					n->alias = a;
					n->coldeflist = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1407:
/* Line 1787 of yacc.c  */
#line 9265 "gram.y"
    {
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if (IsA((yyvsp[(1) - (1)].node), SelectStmt) &&
						((SelectStmt *) (yyvsp[(1) - (1)].node))->valuesLists)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("VALUES in FROM must have an alias"),
								 errhint("For example, FROM (VALUES ...) [AS] foo."),
								 parser_errposition((yylsp[(1) - (1)]))));
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("subquery in FROM must have an alias"),
								 errhint("For example, FROM (SELECT ...) [AS] foo."),
								 parser_errposition((yylsp[(1) - (1)]))));
					(yyval.node) = NULL;
				}
    break;

  case 1408:
/* Line 1787 of yacc.c  */
#line 9293 "gram.y"
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->subquery = (yyvsp[(1) - (2)].node);
					n->alias = (yyvsp[(2) - (2)].alias);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1409:
/* Line 1787 of yacc.c  */
#line 9300 "gram.y"
    {
					(yyval.node) = (Node *) (yyvsp[(1) - (1)].jexpr);
				}
    break;

  case 1410:
/* Line 1787 of yacc.c  */
#line 9304 "gram.y"
    {
					(yyvsp[(2) - (4)].jexpr)->alias = (yyvsp[(4) - (4)].alias);
					(yyval.node) = (Node *) (yyvsp[(2) - (4)].jexpr);
				}
    break;

  case 1411:
/* Line 1787 of yacc.c  */
#line 9330 "gram.y"
    {
					(yyval.jexpr) = (yyvsp[(2) - (3)].jexpr);
				}
    break;

  case 1412:
/* Line 1787 of yacc.c  */
#line 9334 "gram.y"
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(4) - (4)].node);
					n->usingClause = NIL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
    break;

  case 1413:
/* Line 1787 of yacc.c  */
#line 9346 "gram.y"
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[(2) - (5)].jtype);
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (5)].node);
					n->rarg = (yyvsp[(4) - (5)].node);
					if ((yyvsp[(5) - (5)].node) != NULL && IsA((yyvsp[(5) - (5)].node), List))
						n->usingClause = (List *) (yyvsp[(5) - (5)].node); /* USING clause */
					else
						n->quals = (yyvsp[(5) - (5)].node); /* ON clause */
					(yyval.jexpr) = n;
				}
    break;

  case 1414:
/* Line 1787 of yacc.c  */
#line 9359 "gram.y"
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(3) - (4)].node);
					if ((yyvsp[(4) - (4)].node) != NULL && IsA((yyvsp[(4) - (4)].node), List))
						n->usingClause = (List *) (yyvsp[(4) - (4)].node); /* USING clause */
					else
						n->quals = (yyvsp[(4) - (4)].node); /* ON clause */
					(yyval.jexpr) = n;
				}
    break;

  case 1415:
/* Line 1787 of yacc.c  */
#line 9373 "gram.y"
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[(3) - (5)].jtype);
					n->isNatural = TRUE;
					n->larg = (yyvsp[(1) - (5)].node);
					n->rarg = (yyvsp[(5) - (5)].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
    break;

  case 1416:
/* Line 1787 of yacc.c  */
#line 9384 "gram.y"
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = TRUE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(4) - (4)].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
    break;

  case 1417:
/* Line 1787 of yacc.c  */
#line 9399 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(2) - (5)].str);
					(yyval.alias)->colnames = (yyvsp[(4) - (5)].list);
				}
    break;

  case 1418:
/* Line 1787 of yacc.c  */
#line 9405 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(2) - (2)].str);
				}
    break;

  case 1419:
/* Line 1787 of yacc.c  */
#line 9410 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(1) - (4)].str);
					(yyval.alias)->colnames = (yyvsp[(3) - (4)].list);
				}
    break;

  case 1420:
/* Line 1787 of yacc.c  */
#line 9416 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(1) - (1)].str);
				}
    break;

  case 1421:
/* Line 1787 of yacc.c  */
#line 9422 "gram.y"
    { (yyval.jtype) = JOIN_FULL; }
    break;

  case 1422:
/* Line 1787 of yacc.c  */
#line 9423 "gram.y"
    { (yyval.jtype) = JOIN_LEFT; }
    break;

  case 1423:
/* Line 1787 of yacc.c  */
#line 9424 "gram.y"
    { (yyval.jtype) = JOIN_RIGHT; }
    break;

  case 1424:
/* Line 1787 of yacc.c  */
#line 9425 "gram.y"
    { (yyval.jtype) = JOIN_INNER; }
    break;

  case 1425:
/* Line 1787 of yacc.c  */
#line 9429 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1426:
/* Line 1787 of yacc.c  */
#line 9430 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1427:
/* Line 1787 of yacc.c  */
#line 9442 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(3) - (4)].list); }
    break;

  case 1428:
/* Line 1787 of yacc.c  */
#line 9443 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1429:
/* Line 1787 of yacc.c  */
#line 9449 "gram.y"
    {
					/* default inheritance */
					(yyval.range) = (yyvsp[(1) - (1)].range);
					(yyval.range)->inhOpt = INH_DEFAULT;
					(yyval.range)->alias = NULL;
				}
    break;

  case 1430:
/* Line 1787 of yacc.c  */
#line 9456 "gram.y"
    {
					/* inheritance query */
					(yyval.range) = (yyvsp[(1) - (2)].range);
					(yyval.range)->inhOpt = INH_YES;
					(yyval.range)->alias = NULL;
				}
    break;

  case 1431:
/* Line 1787 of yacc.c  */
#line 9463 "gram.y"
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[(2) - (2)].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
    break;

  case 1432:
/* Line 1787 of yacc.c  */
#line 9470 "gram.y"
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[(3) - (4)].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
    break;

  case 1433:
/* Line 1787 of yacc.c  */
#line 9480 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].range)); }
    break;

  case 1434:
/* Line 1787 of yacc.c  */
#line 9481 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].range)); }
    break;

  case 1435:
/* Line 1787 of yacc.c  */
#line 9495 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
				}
    break;

  case 1436:
/* Line 1787 of yacc.c  */
#line 9499 "gram.y"
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[(2) - (2)].str);
					(yyvsp[(1) - (2)].range)->alias = alias;
					(yyval.range) = (yyvsp[(1) - (2)].range);
				}
    break;

  case 1437:
/* Line 1787 of yacc.c  */
#line 9506 "gram.y"
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[(3) - (3)].str);
					(yyvsp[(1) - (3)].range)->alias = alias;
					(yyval.range) = (yyvsp[(1) - (3)].range);
				}
    break;

  case 1438:
/* Line 1787 of yacc.c  */
#line 9515 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1439:
/* Line 1787 of yacc.c  */
#line 9520 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1440:
/* Line 1787 of yacc.c  */
#line 9521 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1441:
/* Line 1787 of yacc.c  */
#line 9526 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1442:
/* Line 1787 of yacc.c  */
#line 9528 "gram.y"
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[(4) - (4)].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1443:
/* Line 1787 of yacc.c  */
#line 9535 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1444:
/* Line 1787 of yacc.c  */
#line 9540 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1445:
/* Line 1787 of yacc.c  */
#line 9541 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1446:
/* Line 1787 of yacc.c  */
#line 9546 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 1447:
/* Line 1787 of yacc.c  */
#line 9550 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1448:
/* Line 1787 of yacc.c  */
#line 9556 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (3)].str);
					n->typeName = (yyvsp[(2) - (3)].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[(3) - (3)].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1449:
/* Line 1787 of yacc.c  */
#line 9585 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[(2) - (2)].list);
				}
    break;

  case 1450:
/* Line 1787 of yacc.c  */
#line 9590 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (3)].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[(3) - (3)].list);
					(yyval.typnam)->setof = TRUE;
				}
    break;

  case 1451:
/* Line 1787 of yacc.c  */
#line 9597 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (5)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[(4) - (5)].ival)));
				}
    break;

  case 1452:
/* Line 1787 of yacc.c  */
#line 9602 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (6)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[(5) - (6)].ival)));
					(yyval.typnam)->setof = TRUE;
				}
    break;

  case 1453:
/* Line 1787 of yacc.c  */
#line 9608 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
    break;

  case 1454:
/* Line 1787 of yacc.c  */
#line 9613 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (3)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = TRUE;
				}
    break;

  case 1455:
/* Line 1787 of yacc.c  */
#line 9622 "gram.y"
    {  (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeInteger(-1)); }
    break;

  case 1456:
/* Line 1787 of yacc.c  */
#line 9624 "gram.y"
    {  (yyval.list) = lappend((yyvsp[(1) - (4)].list), makeInteger((yyvsp[(3) - (4)].ival))); }
    break;

  case 1457:
/* Line 1787 of yacc.c  */
#line 9626 "gram.y"
    {  (yyval.list) = NIL; }
    break;

  case 1458:
/* Line 1787 of yacc.c  */
#line 9630 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1459:
/* Line 1787 of yacc.c  */
#line 9631 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1460:
/* Line 1787 of yacc.c  */
#line 9632 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1461:
/* Line 1787 of yacc.c  */
#line 9633 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1462:
/* Line 1787 of yacc.c  */
#line 9634 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1463:
/* Line 1787 of yacc.c  */
#line 9636 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
				}
    break;

  case 1464:
/* Line 1787 of yacc.c  */
#line 9641 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (5)].typnam);
					if ((yyvsp[(5) - (5)].list) != NIL)
					{
						if (list_length((yyvsp[(5) - (5)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[(1) - (5)]))));
						(yyval.typnam)->typmods = lappend((yyvsp[(5) - (5)].list), makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					}
					else
						(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												 makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
				}
    break;

  case 1465:
/* Line 1787 of yacc.c  */
#line 9670 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1466:
/* Line 1787 of yacc.c  */
#line 9671 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1467:
/* Line 1787 of yacc.c  */
#line 9672 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1468:
/* Line 1787 of yacc.c  */
#line 9673 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1469:
/* Line 1787 of yacc.c  */
#line 9685 "gram.y"
    {
					(yyval.typnam) = makeTypeName((yyvsp[(1) - (2)].str));
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1470:
/* Line 1787 of yacc.c  */
#line 9691 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(1) - (3)].str)), (yyvsp[(2) - (3)].list)));
					(yyval.typnam)->typmods = (yyvsp[(3) - (3)].list);
					(yyval.typnam)->location = (yylsp[(1) - (3)]);
				}
    break;

  case 1471:
/* Line 1787 of yacc.c  */
#line 9698 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1472:
/* Line 1787 of yacc.c  */
#line 9699 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1473:
/* Line 1787 of yacc.c  */
#line 9706 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1474:
/* Line 1787 of yacc.c  */
#line 9711 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1475:
/* Line 1787 of yacc.c  */
#line 9716 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1476:
/* Line 1787 of yacc.c  */
#line 9721 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1477:
/* Line 1787 of yacc.c  */
#line 9726 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1478:
/* Line 1787 of yacc.c  */
#line 9731 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (2)].typnam);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1479:
/* Line 1787 of yacc.c  */
#line 9736 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1480:
/* Line 1787 of yacc.c  */
#line 9741 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1481:
/* Line 1787 of yacc.c  */
#line 9747 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1482:
/* Line 1787 of yacc.c  */
#line 9753 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1483:
/* Line 1787 of yacc.c  */
#line 9759 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1484:
/* Line 1787 of yacc.c  */
#line 9766 "gram.y"
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[(2) - (3)].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[(2) - (3)]))));
					else if ((yyvsp[(2) - (3)].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[(2) - (3)].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[(2) - (3)]))));
				}
    break;

  case 1485:
/* Line 1787 of yacc.c  */
#line 9787 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float8");
				}
    break;

  case 1486:
/* Line 1787 of yacc.c  */
#line 9797 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1487:
/* Line 1787 of yacc.c  */
#line 9801 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1488:
/* Line 1787 of yacc.c  */
#line 9809 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1489:
/* Line 1787 of yacc.c  */
#line 9813 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
					(yyval.typnam)->typmods = NIL;
				}
    break;

  case 1490:
/* Line 1787 of yacc.c  */
#line 9821 "gram.y"
    {
					char *typname;

					typname = (yyvsp[(2) - (5)].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[(4) - (5)].list);
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1491:
/* Line 1787 of yacc.c  */
#line 9833 "gram.y"
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[(2) - (2)].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1492:
/* Line 1787 of yacc.c  */
#line 9854 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1493:
/* Line 1787 of yacc.c  */
#line 9858 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1494:
/* Line 1787 of yacc.c  */
#line 9864 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1495:
/* Line 1787 of yacc.c  */
#line 9868 "gram.y"
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
					(yyval.typnam)->typmods = NIL;
				}
    break;

  case 1496:
/* Line 1787 of yacc.c  */
#line 9881 "gram.y"
    {
					if (((yyvsp[(5) - (5)].str) != NULL) && (strcmp((yyvsp[(5) - (5)].str), "sql_text") != 0))
					{
						char *type;

						type = palloc(strlen((yyvsp[(1) - (5)].str)) + 1 + strlen((yyvsp[(5) - (5)].str)) + 1);
						strcpy(type, (yyvsp[(1) - (5)].str));
						strcat(type, "_");
						strcat(type, (yyvsp[(5) - (5)].str));
						(yyvsp[(1) - (5)].str) = type;
					}

					(yyval.typnam) = SystemTypeName((yyvsp[(1) - (5)].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1497:
/* Line 1787 of yacc.c  */
#line 9900 "gram.y"
    {
					if (((yyvsp[(2) - (2)].str) != NULL) && (strcmp((yyvsp[(2) - (2)].str), "sql_text") != 0))
					{
						char *type;

						type = palloc(strlen((yyvsp[(1) - (2)].str)) + 1 + strlen((yyvsp[(2) - (2)].str)) + 1);
						strcpy(type, (yyvsp[(1) - (2)].str));
						strcat(type, "_");
						strcat(type, (yyvsp[(2) - (2)].str));
						(yyvsp[(1) - (2)].str) = type;
					}

					(yyval.typnam) = SystemTypeName((yyvsp[(1) - (2)].str));

					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[(1) - (2)].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));

					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1498:
/* Line 1787 of yacc.c  */
#line 9923 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1499:
/* Line 1787 of yacc.c  */
#line 9925 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1500:
/* Line 1787 of yacc.c  */
#line 9927 "gram.y"
    { (yyval.str) = "varchar"; }
    break;

  case 1501:
/* Line 1787 of yacc.c  */
#line 9929 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1502:
/* Line 1787 of yacc.c  */
#line 9931 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1503:
/* Line 1787 of yacc.c  */
#line 9933 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1504:
/* Line 1787 of yacc.c  */
#line 9937 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1505:
/* Line 1787 of yacc.c  */
#line 9938 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1506:
/* Line 1787 of yacc.c  */
#line 9942 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); }
    break;

  case 1507:
/* Line 1787 of yacc.c  */
#line 9943 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 1508:
/* Line 1787 of yacc.c  */
#line 9951 "gram.y"
    {
					if ((yyvsp[(5) - (5)].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1509:
/* Line 1787 of yacc.c  */
#line 9960 "gram.y"
    {
					if ((yyvsp[(2) - (2)].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1510:
/* Line 1787 of yacc.c  */
#line 9968 "gram.y"
    {
					if ((yyvsp[(5) - (5)].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1511:
/* Line 1787 of yacc.c  */
#line 9977 "gram.y"
    {
					if ((yyvsp[(2) - (2)].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1512:
/* Line 1787 of yacc.c  */
#line 9988 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1513:
/* Line 1787 of yacc.c  */
#line 9995 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1514:
/* Line 1787 of yacc.c  */
#line 9996 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1515:
/* Line 1787 of yacc.c  */
#line 9997 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1516:
/* Line 1787 of yacc.c  */
#line 10002 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[(1) - (1)]))); }
    break;

  case 1517:
/* Line 1787 of yacc.c  */
#line 10004 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[(1) - (1)]))); }
    break;

  case 1518:
/* Line 1787 of yacc.c  */
#line 10006 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[(1) - (1)]))); }
    break;

  case 1519:
/* Line 1787 of yacc.c  */
#line 10008 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[(1) - (1)]))); }
    break;

  case 1520:
/* Line 1787 of yacc.c  */
#line 10010 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[(1) - (1)]))); }
    break;

  case 1521:
/* Line 1787 of yacc.c  */
#line 10012 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1522:
/* Line 1787 of yacc.c  */
#line 10014 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[(1) - (3)])));
				}
    break;

  case 1523:
/* Line 1787 of yacc.c  */
#line 10019 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[(1) - (3)])));
				}
    break;

  case 1524:
/* Line 1787 of yacc.c  */
#line 10024 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[(1) - (3)])));
				}
    break;

  case 1525:
/* Line 1787 of yacc.c  */
#line 10030 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				}
    break;

  case 1526:
/* Line 1787 of yacc.c  */
#line 10038 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[(1) - (3)])));
				}
    break;

  case 1527:
/* Line 1787 of yacc.c  */
#line 10043 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				}
    break;

  case 1528:
/* Line 1787 of yacc.c  */
#line 10050 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				}
    break;

  case 1529:
/* Line 1787 of yacc.c  */
#line 10056 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1530:
/* Line 1787 of yacc.c  */
#line 10061 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[(1) - (1)])));
				}
    break;

  case 1531:
/* Line 1787 of yacc.c  */
#line 10065 "gram.y"
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[(1) - (4)])),
									makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
				}
    break;

  case 1532:
/* Line 1787 of yacc.c  */
#line 10094 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1533:
/* Line 1787 of yacc.c  */
#line 10096 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].typnam), (yylsp[(2) - (3)])); }
    break;

  case 1534:
/* Line 1787 of yacc.c  */
#line 10098 "gram.y"
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = (yyvsp[(1) - (3)].node);
					n->collname = (yyvsp[(3) - (3)].list);
					n->location = (yylsp[(2) - (3)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1535:
/* Line 1787 of yacc.c  */
#line 10106 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("timezone");
					n->args = list_make2((yyvsp[(5) - (5)].node), (yyvsp[(1) - (5)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (5)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1536:
/* Line 1787 of yacc.c  */
#line 10128 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1537:
/* Line 1787 of yacc.c  */
#line 10130 "gram.y"
    { (yyval.node) = doNegate((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1538:
/* Line 1787 of yacc.c  */
#line 10132 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1539:
/* Line 1787 of yacc.c  */
#line 10134 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1540:
/* Line 1787 of yacc.c  */
#line 10136 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1541:
/* Line 1787 of yacc.c  */
#line 10138 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1542:
/* Line 1787 of yacc.c  */
#line 10140 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1543:
/* Line 1787 of yacc.c  */
#line 10142 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1544:
/* Line 1787 of yacc.c  */
#line 10144 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1545:
/* Line 1787 of yacc.c  */
#line 10146 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1546:
/* Line 1787 of yacc.c  */
#line 10148 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1547:
/* Line 1787 of yacc.c  */
#line 10151 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (3)].list), (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1548:
/* Line 1787 of yacc.c  */
#line 10153 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(1) - (2)].list), NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1549:
/* Line 1787 of yacc.c  */
#line 10155 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (2)].list), (yyvsp[(1) - (2)].node), NULL, (yylsp[(2) - (2)])); }
    break;

  case 1550:
/* Line 1787 of yacc.c  */
#line 10158 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1551:
/* Line 1787 of yacc.c  */
#line 10160 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1552:
/* Line 1787 of yacc.c  */
#line 10162 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1553:
/* Line 1787 of yacc.c  */
#line 10165 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1554:
/* Line 1787 of yacc.c  */
#line 10167 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = list_make1(makeString("like_escape"));
					n->args = list_make2((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				}
    break;

  case 1555:
/* Line 1787 of yacc.c  */
#line 10180 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)])); }
    break;

  case 1556:
/* Line 1787 of yacc.c  */
#line 10182 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = list_make1(makeString("like_escape"));
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				}
    break;

  case 1557:
/* Line 1787 of yacc.c  */
#line 10195 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1558:
/* Line 1787 of yacc.c  */
#line 10197 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = list_make1(makeString("like_escape"));
					n->args = list_make2((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				}
    break;

  case 1559:
/* Line 1787 of yacc.c  */
#line 10210 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)])); }
    break;

  case 1560:
/* Line 1787 of yacc.c  */
#line 10212 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = list_make1(makeString("like_escape"));
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				}
    break;

  case 1561:
/* Line 1787 of yacc.c  */
#line 10226 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = list_make1(makeString("similar_escape"));
					n->args = list_make2((yyvsp[(4) - (4)].node), makeNullAConst(-1));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[(1) - (4)].node), (Node *) n, (yylsp[(2) - (4)]));
				}
    break;

  case 1562:
/* Line 1787 of yacc.c  */
#line 10239 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = list_make1(makeString("similar_escape"));
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				}
    break;

  case 1563:
/* Line 1787 of yacc.c  */
#line 10252 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = list_make1(makeString("similar_escape"));
					n->args = list_make2((yyvsp[(5) - (5)].node), makeNullAConst(-1));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				}
    break;

  case 1564:
/* Line 1787 of yacc.c  */
#line 10265 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = list_make1(makeString("similar_escape"));
					n->args = list_make2((yyvsp[(5) - (7)].node), (yyvsp[(7) - (7)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (7)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[(1) - (7)].node), (Node *) n, (yylsp[(2) - (7)]));
				}
    break;

  case 1565:
/* Line 1787 of yacc.c  */
#line 10288 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (3)].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1566:
/* Line 1787 of yacc.c  */
#line 10295 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (2)].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1567:
/* Line 1787 of yacc.c  */
#line 10302 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (4)].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1568:
/* Line 1787 of yacc.c  */
#line 10309 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (2)].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1569:
/* Line 1787 of yacc.c  */
#line 10316 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("overlaps");
					if (list_length((yyvsp[(1) - (3)].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[(1) - (3)]))));
					if (list_length((yyvsp[(3) - (3)].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[(3) - (3)]))));
					n->args = list_concat((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (3)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1570:
/* Line 1787 of yacc.c  */
#line 10339 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_TRUE;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1571:
/* Line 1787 of yacc.c  */
#line 10346 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_TRUE;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1572:
/* Line 1787 of yacc.c  */
#line 10353 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_FALSE;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1573:
/* Line 1787 of yacc.c  */
#line 10360 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_FALSE;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1574:
/* Line 1787 of yacc.c  */
#line 10367 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_UNKNOWN;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1575:
/* Line 1787 of yacc.c  */
#line 10374 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1576:
/* Line 1787 of yacc.c  */
#line 10381 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yylsp[(2) - (5)]));
				}
    break;

  case 1577:
/* Line 1787 of yacc.c  */
#line 10385 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
									(Node *) makeSimpleA_Expr(AEXPR_DISTINCT,
															  "=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));

				}
    break;

  case 1578:
/* Line 1787 of yacc.c  */
#line 10393 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[(1) - (6)].node), (Node *) (yyvsp[(5) - (6)].list), (yylsp[(2) - (6)]));
				}
    break;

  case 1579:
/* Line 1787 of yacc.c  */
#line 10397 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[(1) - (7)].node), (Node *) (yyvsp[(6) - (7)].list), (yylsp[(2) - (7)]));
				}
    break;

  case 1580:
/* Line 1787 of yacc.c  */
#line 10407 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));
				}
    break;

  case 1581:
/* Line 1787 of yacc.c  */
#line 10414 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
											 (yylsp[(2) - (7)]));
				}
    break;

  case 1582:
/* Line 1787 of yacc.c  */
#line 10421 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeA_Expr(AEXPR_AND, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											(yylsp[(2) - (6)])),
						(Node *) makeA_Expr(AEXPR_AND, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
											(yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));
				}
    break;

  case 1583:
/* Line 1787 of yacc.c  */
#line 10434 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeA_Expr(AEXPR_OR, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
											(yylsp[(2) - (7)])),
						(Node *) makeA_Expr(AEXPR_OR, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
											(yylsp[(2) - (7)])),
											 (yylsp[(2) - (7)]));
				}
    break;

  case 1584:
/* Line 1787 of yacc.c  */
#line 10447 "gram.y"
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[(3) - (3)].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink *n = (SubLink *) (yyvsp[(3) - (3)].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[(1) - (3)].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[(2) - (3)]);
						(yyval.node) = (Node *)n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)]));
					}
				}
    break;

  case 1585:
/* Line 1787 of yacc.c  */
#line 10466 "gram.y"
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[(4) - (4)].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink *n = (SubLink *) (yyvsp[(4) - (4)].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[(1) - (4)].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[(3) - (4)]);
						/* Stick a NOT on top */
						(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (Node *) n, (yylsp[(2) - (4)]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)]));
					}
				}
    break;

  case 1586:
/* Line 1787 of yacc.c  */
#line 10487 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = (yyvsp[(3) - (4)].ival);
					n->testexpr = (yyvsp[(1) - (4)].node);
					n->operName = (yyvsp[(2) - (4)].list);
					n->subselect = (yyvsp[(4) - (4)].node);
					n->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1587:
/* Line 1787 of yacc.c  */
#line 10497 "gram.y"
    {
					if ((yyvsp[(3) - (6)].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[(2) - (6)].list), (yyvsp[(1) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(2) - (6)]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[(2) - (6)].list), (yyvsp[(1) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(2) - (6)]));
				}
    break;

  case 1588:
/* Line 1787 of yacc.c  */
#line 10504 "gram.y"
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[(1) - (2)]))));
				}
    break;

  case 1589:
/* Line 1787 of yacc.c  */
#line 10520 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[(1) - (3)].node)), (yylsp[(2) - (3)]));
				}
    break;

  case 1590:
/* Line 1787 of yacc.c  */
#line 10525 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[(1) - (4)].node)), (yylsp[(2) - (4)])),
											 (yylsp[(2) - (4)]));
				}
    break;

  case 1591:
/* Line 1787 of yacc.c  */
#line 10543 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1592:
/* Line 1787 of yacc.c  */
#line 10545 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].typnam), (yylsp[(2) - (3)])); }
    break;

  case 1593:
/* Line 1787 of yacc.c  */
#line 10547 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1594:
/* Line 1787 of yacc.c  */
#line 10549 "gram.y"
    { (yyval.node) = doNegate((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1595:
/* Line 1787 of yacc.c  */
#line 10551 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1596:
/* Line 1787 of yacc.c  */
#line 10553 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1597:
/* Line 1787 of yacc.c  */
#line 10555 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1598:
/* Line 1787 of yacc.c  */
#line 10557 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1599:
/* Line 1787 of yacc.c  */
#line 10559 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1600:
/* Line 1787 of yacc.c  */
#line 10561 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1601:
/* Line 1787 of yacc.c  */
#line 10563 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1602:
/* Line 1787 of yacc.c  */
#line 10565 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1603:
/* Line 1787 of yacc.c  */
#line 10567 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1604:
/* Line 1787 of yacc.c  */
#line 10569 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (3)].list), (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1605:
/* Line 1787 of yacc.c  */
#line 10571 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(1) - (2)].list), NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1606:
/* Line 1787 of yacc.c  */
#line 10573 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (2)].list), (yyvsp[(1) - (2)].node), NULL, (yylsp[(2) - (2)])); }
    break;

  case 1607:
/* Line 1787 of yacc.c  */
#line 10575 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yylsp[(2) - (5)]));
				}
    break;

  case 1608:
/* Line 1787 of yacc.c  */
#line 10579 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL,
						NULL, (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])), (yylsp[(2) - (6)]));
				}
    break;

  case 1609:
/* Line 1787 of yacc.c  */
#line 10584 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[(1) - (6)].node), (Node *) (yyvsp[(5) - (6)].list), (yylsp[(2) - (6)]));
				}
    break;

  case 1610:
/* Line 1787 of yacc.c  */
#line 10588 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[(1) - (7)].node), (Node *) (yyvsp[(6) - (7)].list), (yylsp[(2) - (7)]));
				}
    break;

  case 1611:
/* Line 1787 of yacc.c  */
#line 10592 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[(1) - (3)].node)), (yylsp[(2) - (3)]));
				}
    break;

  case 1612:
/* Line 1787 of yacc.c  */
#line 10597 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[(1) - (4)].node)), (yylsp[(2) - (4)])),
											 (yylsp[(2) - (4)]));
				}
    break;

  case 1613:
/* Line 1787 of yacc.c  */
#line 10613 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1614:
/* Line 1787 of yacc.c  */
#line 10614 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1615:
/* Line 1787 of yacc.c  */
#line 10616 "gram.y"
    {
					ParamRef *p = makeNode(ParamRef);
					p->number = (yyvsp[(1) - (2)].ival);
					p->location = (yylsp[(1) - (2)]);
					if ((yyvsp[(2) - (2)].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
    break;

  case 1616:
/* Line 1787 of yacc.c  */
#line 10631 "gram.y"
    {
					if ((yyvsp[(4) - (4)].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (yyvsp[(2) - (4)].node);
						n->indirection = check_indirection((yyvsp[(4) - (4)].list), yyscanner);
						(yyval.node) = (Node *)n;
					}
					else
						(yyval.node) = (yyvsp[(2) - (4)].node);
				}
    break;

  case 1617:
/* Line 1787 of yacc.c  */
#line 10643 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1618:
/* Line 1787 of yacc.c  */
#line 10645 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1619:
/* Line 1787 of yacc.c  */
#line 10647 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(1) - (1)].node);
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1620:
/* Line 1787 of yacc.c  */
#line 10657 "gram.y"
    {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(1) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					a->arg = (Node *)n;
					a->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.node) = (Node *)a;
				}
    break;

  case 1621:
/* Line 1787 of yacc.c  */
#line 10680 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXISTS_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(2) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1622:
/* Line 1787 of yacc.c  */
#line 10690 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = ARRAY_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(2) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1623:
/* Line 1787 of yacc.c  */
#line 10700 "gram.y"
    {
					A_ArrayExpr *n = (A_ArrayExpr *) (yyvsp[(2) - (2)].node);
					Assert(IsA(n, A_ArrayExpr));
					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1624:
/* Line 1787 of yacc.c  */
#line 10708 "gram.y"
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[(1) - (1)].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)r;
				}
    break;

  case 1625:
/* Line 1787 of yacc.c  */
#line 10727 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (4)].list);
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(4) - (4)].windef);
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1626:
/* Line 1787 of yacc.c  */
#line 10740 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (5)].list);
					n->args = (yyvsp[(3) - (5)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(5) - (5)].windef);
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1627:
/* Line 1787 of yacc.c  */
#line 10753 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (6)].list);
					n->args = list_make1((yyvsp[(4) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = TRUE;
					n->over = (yyvsp[(6) - (6)].windef);
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1628:
/* Line 1787 of yacc.c  */
#line 10766 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (8)].list);
					n->args = lappend((yyvsp[(3) - (8)].list), (yyvsp[(6) - (8)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = TRUE;
					n->over = (yyvsp[(8) - (8)].windef);
					n->location = (yylsp[(1) - (8)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1629:
/* Line 1787 of yacc.c  */
#line 10779 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (6)].list);
					n->args = (yyvsp[(3) - (6)].list);
					n->agg_order = (yyvsp[(4) - (6)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(6) - (6)].windef);
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1630:
/* Line 1787 of yacc.c  */
#line 10792 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (7)].list);
					n->args = (yyvsp[(4) - (7)].list);
					n->agg_order = (yyvsp[(5) - (7)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					n->func_variadic = FALSE;
					n->over = (yyvsp[(7) - (7)].windef);
					n->location = (yylsp[(1) - (7)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1631:
/* Line 1787 of yacc.c  */
#line 10809 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (7)].list);
					n->args = (yyvsp[(4) - (7)].list);
					n->agg_order = (yyvsp[(5) - (7)].list);
					n->agg_star = FALSE;
					n->agg_distinct = TRUE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(7) - (7)].windef);
					n->location = (yylsp[(1) - (7)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1632:
/* Line 1787 of yacc.c  */
#line 10822 "gram.y"
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL92 that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (5)].list);
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = TRUE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(5) - (5)].windef);
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1633:
/* Line 1787 of yacc.c  */
#line 10845 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("pg_collation_for");
					n->args = list_make1((yyvsp[(4) - (5)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1634:
/* Line 1787 of yacc.c  */
#line 10858 "gram.y"
    {
					/*
					 * Translate as "'now'::text::date".
					 *
					 * We cannot use "'now'::date" because coerce_type() will
					 * immediately reduce that to a constant representing
					 * today's date.  We need to delay the conversion until
					 * runtime, else the wrong things will happen when
					 * CURRENT_DATE is used in a column default value or rule.
					 *
					 * This could be simplified if we had a way to generate
					 * an expression tree representing runtime application
					 * of type-input conversion functions.  (As of PG 7.3
					 * that is actually possible, but not clear that we want
					 * to rely on it.)
					 *
					 * The token location is attached to the run-time
					 * typecast, not to the Const, for the convenience of
					 * pg_stat_statements (which doesn't want these constructs
					 * to appear to be replaceable constants).
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("date"), (yylsp[(1) - (1)]));
				}
    break;

  case 1635:
/* Line 1787 of yacc.c  */
#line 10884 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timetz".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timetz"), (yylsp[(1) - (1)]));
				}
    break;

  case 1636:
/* Line 1787 of yacc.c  */
#line 10894 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timetz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timetz");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[(1) - (4)]));
				}
    break;

  case 1637:
/* Line 1787 of yacc.c  */
#line 10907 "gram.y"
    {
					/*
					 * Translate as "now()", since we have a function that
					 * does exactly what is needed.
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("now");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1638:
/* Line 1787 of yacc.c  */
#line 10924 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamptz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timestamptz");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[(1) - (4)]));
				}
    break;

  case 1639:
/* Line 1787 of yacc.c  */
#line 10937 "gram.y"
    {
					/*
					 * Translate as "'now'::text::time".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast((Node *)n, SystemTypeName("time"), (yylsp[(1) - (1)]));
				}
    break;

  case 1640:
/* Line 1787 of yacc.c  */
#line 10947 "gram.y"
    {
					/*
					 * Translate as "'now'::text::time(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("time");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast((Node *)n, d, (yylsp[(1) - (4)]));
				}
    break;

  case 1641:
/* Line 1787 of yacc.c  */
#line 10960 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamp".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timestamp"), (yylsp[(1) - (1)]));
				}
    break;

  case 1642:
/* Line 1787 of yacc.c  */
#line 10970 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamp(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timestamp");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[(1) - (4)]));
				}
    break;

  case 1643:
/* Line 1787 of yacc.c  */
#line 10983 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1644:
/* Line 1787 of yacc.c  */
#line 10996 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1645:
/* Line 1787 of yacc.c  */
#line 11009 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("session_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1646:
/* Line 1787 of yacc.c  */
#line 11022 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1647:
/* Line 1787 of yacc.c  */
#line 11035 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_database");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1648:
/* Line 1787 of yacc.c  */
#line 11048 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_schema");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1649:
/* Line 1787 of yacc.c  */
#line 11061 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].typnam), (yylsp[(1) - (6)])); }
    break;

  case 1650:
/* Line 1787 of yacc.c  */
#line 11063 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("date_part");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1651:
/* Line 1787 of yacc.c  */
#line 11076 "gram.y"
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to
					 * overlay(A, B, C, D)
					 * overlay(A PLACING B FROM C) is converted to
					 * overlay(A, B, C)
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("overlay");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1652:
/* Line 1787 of yacc.c  */
#line 11094 "gram.y"
    {
					/* position(A in B) is converted to position(B, A) */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("position");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1653:
/* Line 1787 of yacc.c  */
#line 11108 "gram.y"
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("substring");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1654:
/* Line 1787 of yacc.c  */
#line 11124 "gram.y"
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 */
					FuncCall *n = makeNode(FuncCall);
					/* Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					n->funcname = SystemFuncName(((Value *)llast((yyvsp[(5) - (6)].typnam)->names))->val.str);
					n->args = list_make1((yyvsp[(3) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1655:
/* Line 1787 of yacc.c  */
#line 11146 "gram.y"
    {
					/* various trim expressions are defined in SQL92
					 * - thomas 1997-07-19
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("btrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1656:
/* Line 1787 of yacc.c  */
#line 11162 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("ltrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1657:
/* Line 1787 of yacc.c  */
#line 11175 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("rtrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1658:
/* Line 1787 of yacc.c  */
#line 11188 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("btrim");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1659:
/* Line 1787 of yacc.c  */
#line 11201 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(1) - (6)]));
				}
    break;

  case 1660:
/* Line 1787 of yacc.c  */
#line 11205 "gram.y"
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);
					c->args = (yyvsp[(3) - (4)].list);
					c->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)c;
				}
    break;

  case 1661:
/* Line 1787 of yacc.c  */
#line 11212 "gram.y"
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[(3) - (4)].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)v;
				}
    break;

  case 1662:
/* Line 1787 of yacc.c  */
#line 11220 "gram.y"
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[(3) - (4)].list);
					v->op = IS_LEAST;
					v->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)v;
				}
    break;

  case 1663:
/* Line 1787 of yacc.c  */
#line 11228 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1664:
/* Line 1787 of yacc.c  */
#line 11232 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (5)].str), NIL, NIL, (yylsp[(1) - (5)]));
				}
    break;

  case 1665:
/* Line 1787 of yacc.c  */
#line 11236 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (7)].str), (yyvsp[(6) - (7)].list), NIL, (yylsp[(1) - (7)]));
				}
    break;

  case 1666:
/* Line 1787 of yacc.c  */
#line 11240 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (7)].str), NIL, (yyvsp[(6) - (7)].list), (yylsp[(1) - (7)]));
				}
    break;

  case 1667:
/* Line 1787 of yacc.c  */
#line 11244 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (9)].str), (yyvsp[(6) - (9)].list), (yyvsp[(8) - (9)].list), (yylsp[(1) - (9)]));
				}
    break;

  case 1668:
/* Line 1787 of yacc.c  */
#line 11248 "gram.y"
    {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("xmlexists");
					n->args = list_make2((yyvsp[(3) - (5)].node), (yyvsp[(4) - (5)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1669:
/* Line 1787 of yacc.c  */
#line 11263 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[(3) - (4)].list), NIL, (yylsp[(1) - (4)]));
				}
    break;

  case 1670:
/* Line 1787 of yacc.c  */
#line 11267 "gram.y"
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[(4) - (6)].node), makeBoolAConst((yyvsp[(5) - (6)].boolean), -1)),
									(yylsp[(1) - (6)]));
					x->xmloption = (yyvsp[(3) - (6)].ival);
					(yyval.node) = (Node *)x;
				}
    break;

  case 1671:
/* Line 1787 of yacc.c  */
#line 11276 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[(4) - (5)].str), NULL, NIL, (yylsp[(1) - (5)]));
				}
    break;

  case 1672:
/* Line 1787 of yacc.c  */
#line 11280 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[(4) - (7)].str), NULL, list_make1((yyvsp[(6) - (7)].node)), (yylsp[(1) - (7)]));
				}
    break;

  case 1673:
/* Line 1787 of yacc.c  */
#line 11284 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[(3) - (7)].node), (yyvsp[(5) - (7)].node), (yyvsp[(6) - (7)].node)), (yylsp[(1) - (7)]));
				}
    break;

  case 1674:
/* Line 1787 of yacc.c  */
#line 11289 "gram.y"
    {
					XmlSerialize *n = makeNode(XmlSerialize);
					n->xmloption = (yyvsp[(3) - (7)].ival);
					n->expr = (yyvsp[(4) - (7)].node);
					n->typeName = (yyvsp[(6) - (7)].typnam);
					n->location = (yylsp[(1) - (7)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1675:
/* Line 1787 of yacc.c  */
#line 11303 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1676:
/* Line 1787 of yacc.c  */
#line 11305 "gram.y"
    { (yyval.node) = makeNullAConst(-1); }
    break;

  case 1677:
/* Line 1787 of yacc.c  */
#line 11309 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
    break;

  case 1678:
/* Line 1787 of yacc.c  */
#line 11311 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
    break;

  case 1679:
/* Line 1787 of yacc.c  */
#line 11313 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
    break;

  case 1680:
/* Line 1787 of yacc.c  */
#line 11315 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
    break;

  case 1681:
/* Line 1787 of yacc.c  */
#line 11318 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1682:
/* Line 1787 of yacc.c  */
#line 11321 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1683:
/* Line 1787 of yacc.c  */
#line 11322 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); }
    break;

  case 1684:
/* Line 1787 of yacc.c  */
#line 11326 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(3) - (3)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[(1) - (3)].node);
					(yyval.target)->location = (yylsp[(1) - (3)]);
				}
    break;

  case 1685:
/* Line 1787 of yacc.c  */
#line 11334 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[(1) - (1)].node);
					(yyval.target)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1686:
/* Line 1787 of yacc.c  */
#line 11343 "gram.y"
    { (yyval.ival) = XMLOPTION_DOCUMENT; }
    break;

  case 1687:
/* Line 1787 of yacc.c  */
#line 11344 "gram.y"
    { (yyval.ival) = XMLOPTION_CONTENT; }
    break;

  case 1688:
/* Line 1787 of yacc.c  */
#line 11347 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1689:
/* Line 1787 of yacc.c  */
#line 11348 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1690:
/* Line 1787 of yacc.c  */
#line 11349 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1691:
/* Line 1787 of yacc.c  */
#line 11355 "gram.y"
    {
					(yyval.node) = (yyvsp[(2) - (2)].node);
				}
    break;

  case 1692:
/* Line 1787 of yacc.c  */
#line 11359 "gram.y"
    {
					(yyval.node) = (yyvsp[(2) - (4)].node);
				}
    break;

  case 1693:
/* Line 1787 of yacc.c  */
#line 11363 "gram.y"
    {
					(yyval.node) = (yyvsp[(4) - (4)].node);
				}
    break;

  case 1694:
/* Line 1787 of yacc.c  */
#line 11367 "gram.y"
    {
					(yyval.node) = (yyvsp[(4) - (6)].node);
				}
    break;

  case 1695:
/* Line 1787 of yacc.c  */
#line 11377 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1696:
/* Line 1787 of yacc.c  */
#line 11378 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1697:
/* Line 1787 of yacc.c  */
#line 11382 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].windef)); }
    break;

  case 1698:
/* Line 1787 of yacc.c  */
#line 11384 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].windef)); }
    break;

  case 1699:
/* Line 1787 of yacc.c  */
#line 11389 "gram.y"
    {
					WindowDef *n = (yyvsp[(3) - (3)].windef);
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.windef) = n;
				}
    break;

  case 1700:
/* Line 1787 of yacc.c  */
#line 11397 "gram.y"
    { (yyval.windef) = (yyvsp[(2) - (2)].windef); }
    break;

  case 1701:
/* Line 1787 of yacc.c  */
#line 11399 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = (yyvsp[(2) - (2)].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[(2) - (2)]);
					(yyval.windef) = n;
				}
    break;

  case 1702:
/* Line 1787 of yacc.c  */
#line 11412 "gram.y"
    { (yyval.windef) = NULL; }
    break;

  case 1703:
/* Line 1787 of yacc.c  */
#line 11417 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = NULL;
					n->refname = (yyvsp[(2) - (6)].str);
					n->partitionClause = (yyvsp[(3) - (6)].list);
					n->orderClause = (yyvsp[(4) - (6)].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[(5) - (6)].windef)->frameOptions;
					n->startOffset = (yyvsp[(5) - (6)].windef)->startOffset;
					n->endOffset = (yyvsp[(5) - (6)].windef)->endOffset;
					n->location = (yylsp[(1) - (6)]);
					(yyval.windef) = n;
				}
    break;

  case 1704:
/* Line 1787 of yacc.c  */
#line 11442 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1705:
/* Line 1787 of yacc.c  */
#line 11443 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 1706:
/* Line 1787 of yacc.c  */
#line 11446 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); }
    break;

  case 1707:
/* Line 1787 of yacc.c  */
#line 11447 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1708:
/* Line 1787 of yacc.c  */
#line 11459 "gram.y"
    {
					WindowDef *n = (yyvsp[(2) - (2)].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_PRECEDING |
										   FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE PRECEDING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[(1) - (2)]))));
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_FOLLOWING |
										   FRAMEOPTION_END_VALUE_FOLLOWING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE FOLLOWING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.windef) = n;
				}
    break;

  case 1709:
/* Line 1787 of yacc.c  */
#line 11477 "gram.y"
    {
					WindowDef *n = (yyvsp[(2) - (2)].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					(yyval.windef) = n;
				}
    break;

  case 1710:
/* Line 1787 of yacc.c  */
#line 11483 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1711:
/* Line 1787 of yacc.c  */
#line 11493 "gram.y"
    {
					WindowDef *n = (yyvsp[(1) - (1)].windef);
					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[(1) - (1)]))));
					if (n->frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[(1) - (1)]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
    break;

  case 1712:
/* Line 1787 of yacc.c  */
#line 11510 "gram.y"
    {
					WindowDef *n1 = (yyvsp[(2) - (4)].windef);
					WindowDef *n2 = (yyvsp[(4) - (4)].windef);
					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[(2) - (4)]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[(4) - (4)]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[(4) - (4)]))));
					if ((frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_VALUE_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[(4) - (4)]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
    break;

  case 1713:
/* Line 1787 of yacc.c  */
#line 11555 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1714:
/* Line 1787 of yacc.c  */
#line 11563 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1715:
/* Line 1787 of yacc.c  */
#line 11571 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1716:
/* Line 1787 of yacc.c  */
#line 11579 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_PRECEDING;
					n->startOffset = (yyvsp[(1) - (2)].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1717:
/* Line 1787 of yacc.c  */
#line 11587 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_FOLLOWING;
					n->startOffset = (yyvsp[(1) - (2)].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1718:
/* Line 1787 of yacc.c  */
#line 11607 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1719:
/* Line 1787 of yacc.c  */
#line 11608 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1720:
/* Line 1787 of yacc.c  */
#line 11609 "gram.y"
    { (yyval.list) = lappend((yyvsp[(2) - (5)].list), (yyvsp[(4) - (5)].node)); }
    break;

  case 1721:
/* Line 1787 of yacc.c  */
#line 11612 "gram.y"
    { (yyval.ival) = ANY_SUBLINK; }
    break;

  case 1722:
/* Line 1787 of yacc.c  */
#line 11613 "gram.y"
    { (yyval.ival) = ANY_SUBLINK; }
    break;

  case 1723:
/* Line 1787 of yacc.c  */
#line 11614 "gram.y"
    { (yyval.ival) = ALL_SUBLINK; }
    break;

  case 1724:
/* Line 1787 of yacc.c  */
#line 11617 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1725:
/* Line 1787 of yacc.c  */
#line 11618 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1726:
/* Line 1787 of yacc.c  */
#line 11621 "gram.y"
    { (yyval.str) = "+"; }
    break;

  case 1727:
/* Line 1787 of yacc.c  */
#line 11622 "gram.y"
    { (yyval.str) = "-"; }
    break;

  case 1728:
/* Line 1787 of yacc.c  */
#line 11623 "gram.y"
    { (yyval.str) = "*"; }
    break;

  case 1729:
/* Line 1787 of yacc.c  */
#line 11624 "gram.y"
    { (yyval.str) = "/"; }
    break;

  case 1730:
/* Line 1787 of yacc.c  */
#line 11625 "gram.y"
    { (yyval.str) = "%"; }
    break;

  case 1731:
/* Line 1787 of yacc.c  */
#line 11626 "gram.y"
    { (yyval.str) = "^"; }
    break;

  case 1732:
/* Line 1787 of yacc.c  */
#line 11627 "gram.y"
    { (yyval.str) = "<"; }
    break;

  case 1733:
/* Line 1787 of yacc.c  */
#line 11628 "gram.y"
    { (yyval.str) = ">"; }
    break;

  case 1734:
/* Line 1787 of yacc.c  */
#line 11629 "gram.y"
    { (yyval.str) = "="; }
    break;

  case 1735:
/* Line 1787 of yacc.c  */
#line 11633 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1736:
/* Line 1787 of yacc.c  */
#line 11635 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1737:
/* Line 1787 of yacc.c  */
#line 11640 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1738:
/* Line 1787 of yacc.c  */
#line 11642 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1739:
/* Line 1787 of yacc.c  */
#line 11647 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1740:
/* Line 1787 of yacc.c  */
#line 11649 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1741:
/* Line 1787 of yacc.c  */
#line 11651 "gram.y"
    { (yyval.list) = list_make1(makeString("~~")); }
    break;

  case 1742:
/* Line 1787 of yacc.c  */
#line 11653 "gram.y"
    { (yyval.list) = list_make1(makeString("!~~")); }
    break;

  case 1743:
/* Line 1787 of yacc.c  */
#line 11655 "gram.y"
    { (yyval.list) = list_make1(makeString("~~*")); }
    break;

  case 1744:
/* Line 1787 of yacc.c  */
#line 11657 "gram.y"
    { (yyval.list) = list_make1(makeString("!~~*")); }
    break;

  case 1745:
/* Line 1787 of yacc.c  */
#line 11669 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 1746:
/* Line 1787 of yacc.c  */
#line 11673 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1747:
/* Line 1787 of yacc.c  */
#line 11680 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 1748:
/* Line 1787 of yacc.c  */
#line 11684 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1749:
/* Line 1787 of yacc.c  */
#line 11690 "gram.y"
    {
					(yyval.node) = (yyvsp[(1) - (1)].node);
				}
    break;

  case 1750:
/* Line 1787 of yacc.c  */
#line 11694 "gram.y"
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[(1) - (3)].str);
					na->arg = (Expr *) (yyvsp[(3) - (3)].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) na;
				}
    break;

  case 1751:
/* Line 1787 of yacc.c  */
#line 11704 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].typnam)); }
    break;

  case 1752:
/* Line 1787 of yacc.c  */
#line 11705 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].typnam)); }
    break;

  case 1753:
/* Line 1787 of yacc.c  */
#line 11709 "gram.y"
    {
					(yyval.node) = makeAArrayExpr((yyvsp[(2) - (3)].list), (yylsp[(1) - (3)]));
				}
    break;

  case 1754:
/* Line 1787 of yacc.c  */
#line 11713 "gram.y"
    {
					(yyval.node) = makeAArrayExpr((yyvsp[(2) - (3)].list), (yylsp[(1) - (3)]));
				}
    break;

  case 1755:
/* Line 1787 of yacc.c  */
#line 11717 "gram.y"
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[(1) - (2)]));
				}
    break;

  case 1756:
/* Line 1787 of yacc.c  */
#line 11722 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1757:
/* Line 1787 of yacc.c  */
#line 11723 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 1758:
/* Line 1787 of yacc.c  */
#line 11729 "gram.y"
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[(1) - (3)].str), (yylsp[(1) - (3)])), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1759:
/* Line 1787 of yacc.c  */
#line 11732 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1760:
/* Line 1787 of yacc.c  */
#line 11739 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1761:
/* Line 1787 of yacc.c  */
#line 11740 "gram.y"
    { (yyval.str) = "year"; }
    break;

  case 1762:
/* Line 1787 of yacc.c  */
#line 11741 "gram.y"
    { (yyval.str) = "month"; }
    break;

  case 1763:
/* Line 1787 of yacc.c  */
#line 11742 "gram.y"
    { (yyval.str) = "day"; }
    break;

  case 1764:
/* Line 1787 of yacc.c  */
#line 11743 "gram.y"
    { (yyval.str) = "hour"; }
    break;

  case 1765:
/* Line 1787 of yacc.c  */
#line 11744 "gram.y"
    { (yyval.str) = "minute"; }
    break;

  case 1766:
/* Line 1787 of yacc.c  */
#line 11745 "gram.y"
    { (yyval.str) = "second"; }
    break;

  case 1767:
/* Line 1787 of yacc.c  */
#line 11746 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1768:
/* Line 1787 of yacc.c  */
#line 11757 "gram.y"
    {
					(yyval.list) = list_make4((yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].node), (yyvsp[(3) - (4)].node), (yyvsp[(4) - (4)].node));
				}
    break;

  case 1769:
/* Line 1787 of yacc.c  */
#line 11761 "gram.y"
    {
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1770:
/* Line 1787 of yacc.c  */
#line 11768 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1771:
/* Line 1787 of yacc.c  */
#line 11774 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(3) - (3)].node), (yyvsp[(1) - (3)].node)); }
    break;

  case 1772:
/* Line 1787 of yacc.c  */
#line 11775 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1773:
/* Line 1787 of yacc.c  */
#line 11792 "gram.y"
    {
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1774:
/* Line 1787 of yacc.c  */
#line 11796 "gram.y"
    {
					/* not legal per SQL99, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yyvsp[(2) - (3)].node));
				}
    break;

  case 1775:
/* Line 1787 of yacc.c  */
#line 11801 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node));
				}
    break;

  case 1776:
/* Line 1787 of yacc.c  */
#line 11805 "gram.y"
    {
					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[(1) - (2)].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[(2) - (2)].node),
												 SystemTypeName("int4"), -1));
				}
    break;

  case 1777:
/* Line 1787 of yacc.c  */
#line 11820 "gram.y"
    {
					(yyval.list) = (yyvsp[(1) - (1)].list);
				}
    break;

  case 1778:
/* Line 1787 of yacc.c  */
#line 11824 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1779:
/* Line 1787 of yacc.c  */
#line 11828 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1780:
/* Line 1787 of yacc.c  */
#line 11831 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1781:
/* Line 1787 of yacc.c  */
#line 11834 "gram.y"
    { (yyval.list) = lappend((yyvsp[(3) - (3)].list), (yyvsp[(1) - (3)].node)); }
    break;

  case 1782:
/* Line 1787 of yacc.c  */
#line 11835 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1783:
/* Line 1787 of yacc.c  */
#line 11836 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1784:
/* Line 1787 of yacc.c  */
#line 11840 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subselect = (yyvsp[(1) - (1)].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *)n;
				}
    break;

  case 1785:
/* Line 1787 of yacc.c  */
#line 11846 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(2) - (3)].list); }
    break;

  case 1786:
/* Line 1787 of yacc.c  */
#line 11857 "gram.y"
    {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[(2) - (5)].node);
					c->args = (yyvsp[(3) - (5)].list);
					c->defresult = (Expr *) (yyvsp[(4) - (5)].node);
					c->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)c;
				}
    break;

  case 1787:
/* Line 1787 of yacc.c  */
#line 11870 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1788:
/* Line 1787 of yacc.c  */
#line 11871 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 1789:
/* Line 1787 of yacc.c  */
#line 11876 "gram.y"
    {
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) (yyvsp[(2) - (4)].node);
					w->result = (Expr *) (yyvsp[(4) - (4)].node);
					w->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)w;
				}
    break;

  case 1790:
/* Line 1787 of yacc.c  */
#line 11886 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1791:
/* Line 1787 of yacc.c  */
#line 11887 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1792:
/* Line 1787 of yacc.c  */
#line 11890 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1793:
/* Line 1787 of yacc.c  */
#line 11891 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1794:
/* Line 1787 of yacc.c  */
#line 11895 "gram.y"
    {
					(yyval.node) = makeColumnRef((yyvsp[(1) - (1)].str), NIL, (yylsp[(1) - (1)]), yyscanner);
				}
    break;

  case 1795:
/* Line 1787 of yacc.c  */
#line 11899 "gram.y"
    {
					(yyval.node) = makeColumnRef((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].list), (yylsp[(1) - (2)]), yyscanner);
				}
    break;

  case 1796:
/* Line 1787 of yacc.c  */
#line 11906 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(2) - (2)].str));
				}
    break;

  case 1797:
/* Line 1787 of yacc.c  */
#line 11910 "gram.y"
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
    break;

  case 1798:
/* Line 1787 of yacc.c  */
#line 11914 "gram.y"
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = NULL;
					ai->uidx = (yyvsp[(2) - (3)].node);
					(yyval.node) = (Node *) ai;
				}
    break;

  case 1799:
/* Line 1787 of yacc.c  */
#line 11921 "gram.y"
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = (yyvsp[(2) - (5)].node);
					ai->uidx = (yyvsp[(4) - (5)].node);
					(yyval.node) = (Node *) ai;
				}
    break;

  case 1800:
/* Line 1787 of yacc.c  */
#line 11930 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1801:
/* Line 1787 of yacc.c  */
#line 11931 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 1802:
/* Line 1787 of yacc.c  */
#line 11935 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1803:
/* Line 1787 of yacc.c  */
#line 11936 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 1806:
/* Line 1787 of yacc.c  */
#line 11951 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].node); }
    break;

  case 1807:
/* Line 1787 of yacc.c  */
#line 11953 "gram.y"
    {
					SetToDefault *n = makeNode(SetToDefault);
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1808:
/* Line 1787 of yacc.c  */
#line 11961 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1809:
/* Line 1787 of yacc.c  */
#line 11962 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 1810:
/* Line 1787 of yacc.c  */
#line 11970 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1811:
/* Line 1787 of yacc.c  */
#line 11981 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1812:
/* Line 1787 of yacc.c  */
#line 11982 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); }
    break;

  case 1813:
/* Line 1787 of yacc.c  */
#line 11986 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(3) - (3)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (3)].node);
					(yyval.target)->location = (yylsp[(1) - (3)]);
				}
    break;

  case 1814:
/* Line 1787 of yacc.c  */
#line 12002 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(2) - (2)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (2)].node);
					(yyval.target)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1815:
/* Line 1787 of yacc.c  */
#line 12010 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (1)].node);
					(yyval.target)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1816:
/* Line 1787 of yacc.c  */
#line 12018 "gram.y"
    {
					ColumnRef *n = makeNode(ColumnRef);
					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[(1) - (1)]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)n;
					(yyval.target)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1817:
/* Line 1787 of yacc.c  */
#line 12039 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].range)); }
    break;

  case 1818:
/* Line 1787 of yacc.c  */
#line 12040 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].range)); }
    break;

  case 1819:
/* Line 1787 of yacc.c  */
#line 12052 "gram.y"
    {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 1820:
/* Line 1787 of yacc.c  */
#line 12056 "gram.y"
    {
					check_qualified_name((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.range) = makeRangeVar(NULL, NULL, (yylsp[(1) - (2)]));
					switch (list_length((yyvsp[(2) - (2)].list)))
					{
						case 1:
							(yyval.range)->catalogname = NULL;
							(yyval.range)->schemaname = (yyvsp[(1) - (2)].str);
							(yyval.range)->relname = strVal(linitial((yyvsp[(2) - (2)].list)));
							break;
						case 2:
							(yyval.range)->catalogname = (yyvsp[(1) - (2)].str);
							(yyval.range)->schemaname = strVal(linitial((yyvsp[(2) - (2)].list)));
							(yyval.range)->relname = strVal(lsecond((yyvsp[(2) - (2)].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString(lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)))),
									 parser_errposition((yylsp[(1) - (2)]))));
							break;
					}
				}
    break;

  case 1821:
/* Line 1787 of yacc.c  */
#line 12083 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1822:
/* Line 1787 of yacc.c  */
#line 12085 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 1823:
/* Line 1787 of yacc.c  */
#line 12089 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1824:
/* Line 1787 of yacc.c  */
#line 12092 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1825:
/* Line 1787 of yacc.c  */
#line 12095 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1826:
/* Line 1787 of yacc.c  */
#line 12097 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1827:
/* Line 1787 of yacc.c  */
#line 12099 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1828:
/* Line 1787 of yacc.c  */
#line 12101 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1829:
/* Line 1787 of yacc.c  */
#line 12112 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1830:
/* Line 1787 of yacc.c  */
#line 12114 "gram.y"
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)),
											 yyscanner);
					}
    break;

  case 1831:
/* Line 1787 of yacc.c  */
#line 12125 "gram.y"
    {
					(yyval.node) = makeIntConst((yyvsp[(1) - (1)].ival), (yylsp[(1) - (1)]));
				}
    break;

  case 1832:
/* Line 1787 of yacc.c  */
#line 12129 "gram.y"
    {
					(yyval.node) = makeFloatConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 1833:
/* Line 1787 of yacc.c  */
#line 12133 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 1834:
/* Line 1787 of yacc.c  */
#line 12137 "gram.y"
    {
					(yyval.node) = makeBitStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 1835:
/* Line 1787 of yacc.c  */
#line 12141 "gram.y"
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 1836:
/* Line 1787 of yacc.c  */
#line 12150 "gram.y"
    {
					/* generic type 'literal' syntax */
					TypeName *t = makeTypeNameFromNameList((yyvsp[(1) - (2)].list));
					t->location = (yylsp[(1) - (2)]);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)]), t);
				}
    break;

  case 1837:
/* Line 1787 of yacc.c  */
#line 12157 "gram.y"
    {
					/* generic syntax with a type modifier */
					TypeName *t = makeTypeNameFromNameList((yyvsp[(1) - (5)].list));
					ListCell *lc;

					/*
					 * We must use func_arg_list in the production to avoid
					 * reduce/reduce conflicts, but we don't actually wish
					 * to allow NamedArgExpr in this context.
					 */
					foreach(lc, (yyvsp[(3) - (5)].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					t->typmods = (yyvsp[(3) - (5)].list);
					t->location = (yylsp[(1) - (5)]);
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (5)].str), (yylsp[(5) - (5)]), t);
				}
    break;

  case 1838:
/* Line 1787 of yacc.c  */
#line 12182 "gram.y"
    {
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)]), (yyvsp[(1) - (2)].typnam));
				}
    break;

  case 1839:
/* Line 1787 of yacc.c  */
#line 12186 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (3)].typnam);
					t->typmods = (yyvsp[(3) - (3)].list);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (3)].str), (yylsp[(2) - (3)]), t);
				}
    break;

  case 1840:
/* Line 1787 of yacc.c  */
#line 12192 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (6)].typnam);
					if ((yyvsp[(6) - (6)].list) != NIL)
					{
						if (list_length((yyvsp[(6) - (6)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[(1) - (6)]))));
						t->typmods = lappend((yyvsp[(6) - (6)].list), makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (6)].str), (yylsp[(5) - (6)]), t);
				}
    break;

  case 1841:
/* Line 1787 of yacc.c  */
#line 12209 "gram.y"
    {
					(yyval.node) = makeBoolAConst(TRUE, (yylsp[(1) - (1)]));
				}
    break;

  case 1842:
/* Line 1787 of yacc.c  */
#line 12213 "gram.y"
    {
					(yyval.node) = makeBoolAConst(FALSE, (yylsp[(1) - (1)]));
				}
    break;

  case 1843:
/* Line 1787 of yacc.c  */
#line 12217 "gram.y"
    {
					(yyval.node) = makeNullAConst((yylsp[(1) - (1)]));
				}
    break;

  case 1844:
/* Line 1787 of yacc.c  */
#line 12222 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); }
    break;

  case 1845:
/* Line 1787 of yacc.c  */
#line 12223 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1846:
/* Line 1787 of yacc.c  */
#line 12224 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1847:
/* Line 1787 of yacc.c  */
#line 12227 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1848:
/* Line 1787 of yacc.c  */
#line 12229 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 1849:
/* Line 1787 of yacc.c  */
#line 12232 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); }
    break;

  case 1850:
/* Line 1787 of yacc.c  */
#line 12233 "gram.y"
    { (yyval.ival) = + (yyvsp[(2) - (2)].ival); }
    break;

  case 1851:
/* Line 1787 of yacc.c  */
#line 12234 "gram.y"
    { (yyval.ival) = - (yyvsp[(2) - (2)].ival); }
    break;

  case 1852:
/* Line 1787 of yacc.c  */
#line 12250 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1853:
/* Line 1787 of yacc.c  */
#line 12251 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1854:
/* Line 1787 of yacc.c  */
#line 12252 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1855:
/* Line 1787 of yacc.c  */
#line 12257 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1856:
/* Line 1787 of yacc.c  */
#line 12258 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1857:
/* Line 1787 of yacc.c  */
#line 12259 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1858:
/* Line 1787 of yacc.c  */
#line 12264 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1859:
/* Line 1787 of yacc.c  */
#line 12265 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1860:
/* Line 1787 of yacc.c  */
#line 12266 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1861:
/* Line 1787 of yacc.c  */
#line 12267 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1862:
/* Line 1787 of yacc.c  */
#line 12273 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1863:
/* Line 1787 of yacc.c  */
#line 12274 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1864:
/* Line 1787 of yacc.c  */
#line 12275 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1865:
/* Line 1787 of yacc.c  */
#line 12276 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1866:
/* Line 1787 of yacc.c  */
#line 12277 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;


/* Line 1787 of yacc.c  */
#line 36697 "gram.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, yyscanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc, yyscanner);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2050 of yacc.c  */
#line 12731 "gram.y"


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int		nfields = 0;
	ListCell *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast *n = makeNode(TypeCast);
	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

static Node *
makeIntConst(int val, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Integer;
	n->val.val.ival = val;
	n->location = location;

	return (Node *)n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Float;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_BitString;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Null;
	n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Value *v, int location)
{
	Node *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(v->val.str, location);
			break;

		case T_Integer:
			n = makeIntConst(v->val.ival, location);
			break;

		case T_String:
		default:
			n = makeStringConst(v->val.str, location);
			break;
	}

	return n;
}

/* makeBoolAConst()
 * Create an A_Const string node and put it inside a boolean cast.
 */
static Node *
makeBoolAConst(bool state, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = (state ? "t" : "f");
	n->location = location;

	return makeTypeCast((Node *)n, SystemTypeName("bool"), -1);
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					Node *limitOffset, Node *limitCount,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitOffset))));
		stmt->limitOffset = limitOffset;
	}
	if (limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitCount))));
		stmt->limitCount = limitCount;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const *con = (A_Const *)n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (con->val.type == T_Integer)
		{
			con->val.val.ival = -con->val.val.ival;
			return n;
		}
		if (con->val.type == T_Float)
		{
			doNegateFloat(&con->val);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Value *v)
{
	char   *oldval = v->val.str;

	Assert(IsA(v, Float));
	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->val.str = oldval+1;	/* just strip the '-' */
	else
	{
		char   *newval = (char *) palloc(strlen(oldval) + 2);

		*newval = '-';
		strcpy(newval+1, oldval);
		v->val.str = newval;
	}
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr		*x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_IN && p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = (TypeName *) copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;
	ListCell   *prev;
	ListCell   *next;

	*collClause = NULL;
	prev = NULL;
	for (cell = list_head(qualList); cell; cell = next)
	{
		Node   *n = (Node *) lfirst(cell);

		next = lnext(cell);
		if (IsA(n, Constraint))
		{
			/* keep it in list */
			prev = cell;
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = list_delete_cell(qualList, cell, prev);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}

/*
 * Must undefine this stuff before including scan.c, since it has different
 * definitions for these macros.
 */
#undef yyerror
#undef yylval
#undef yylloc

#include "scan.c"
